<?php
/**
 * BlooKing - The King in Joomla Booking
 * @version 1.0
 * @author BlooKing.org. Based on BooKiTGold code by Costas Kakousis
 * @copyright (C) 2012-2013 by BlooKing.org (http://www.blooking.org)
 * @license GNU/GPL: http://www.gnu.org/copyleft/gpl.html
 *
 * If you fork this to create your own project, please make a reference to
 * BlooKing! someplace in your code and provide a link to
 * http://www.blooking.org
 *
 * This file is part of BlooKing! BlooKing is free software: you can
 * redistribute it and/or modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * BlooKing is distributed in the hope that it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details. You should have received a copy of the GNU General Public License
 * along with BlooKing.  If not, see <http://www.gnu.org/licenses/>.
 *   ______ __                __  __ __
 *	|   __ \  |.-----..-----.|  |/  |__|.-----..-----.
 *	|   __ <  ||  _  ||  _  ||     <|  ||     ||  _  |
 *	|______/__||_____||_____||__|\__|__||__|__||___  |
 *                                             |_____|
 **/
defined( '_JEXEC' ) or die( 'Restricted access' );
require_once( JPATH_COMPONENT.DS.'controller.php' );

$jlang =& JFactory::getLanguage();
$jlang->load('com_blooking', JPATH_ADMINISTRATOR, 'en-GB', true);
$jlang->load('com_blooking', JPATH_ADMINISTRATOR, null, true);

JLoader::register('BlookingHelper', JPATH_COMPONENT.'/helpers/BlookingHelper.php');
$params = BlookingHelper::getParams();

JSubMenuHelper::addEntry(JText::_('COM_BOOKIT_HOME'), 'index.php?option=com_blooking');

if ($params->multiroom != "2") {
	JSubMenuHelper::addEntry(JText::_('COM_BOOKIT_ROOM_CATEGORIES'), 'index.php?option=com_blooking&view=roomcategory');
	JSubMenuHelper::addEntry(JText::_('COM_BOOKIT_ROOMS'), 'index.php?option=com_blooking&view=room');
} else {
	JSubMenuHelper::addEntry(JText::_('COM_BOOKIT_PROPERTIES'), 'index.php?option=com_blooking&view=roomcategory');
}

JSubMenuHelper::addEntry(JText::_('COM_BOOKIT_EXTRA_SERVICES'), 'index.php?option=com_blooking&view=roomextra');
JSubMenuHelper::addEntry(JText::_('COM_BOOKIT_GUESTS'), 'index.php?option=com_blooking&view=guests');
JSubMenuHelper::addEntry(JText::_('COM_BOOKIT_BOOKINGS'), 'index.php?option=com_blooking&view=booking');
JSubMenuHelper::addEntry(JText::_('COM_BOOKIT_AVAILABILITY'), 'index.php?option=com_blooking&view=availability');
JSubMenuHelper::addEntry(JText::_('COM_BOOKIT_RULES'), 'index.php?option=com_blooking&view=rules');
JSubMenuHelper::addEntry(JText::_('COM_BOOKIT_STATISTICS'), 'index.php?option=com_blooking&view=statistics');
JSubMenuHelper::addEntry(JText::_('COM_BOOKIT_HOTEL_SETUP'), 'index.php?option=com_blooking&view=hotelsetup');

if($controller = JRequest::getWord('controller')) {
	$path = JPATH_COMPONENT.DS.'controllers'.DS.$controller.'.php';
	if (file_exists($path)) {
		require_once $path;
	} else {
		$controller = '';
	}
}

$classname    = 'BlookingController'.$controller;
$controller   = new $classname( );
$controller->execute( JRequest::getVar( 'task' ) );
$controller->redirect();