<?php
/**
 * BlooKing - The King in Joomla Booking
 * @version 1.0
 * @author BlooKing.org. Based on BooKiTGold code by Costas Kakousis
 * @copyright (C) 2012-2013 by BlooKing.org (http://www.blooking.org)
 * @license GNU/GPL: http://www.gnu.org/copyleft/gpl.html
 *
 * If you fork this to create your own project, please make a reference to
 * BlooKing! someplace in your code and provide a link to
 * http://www.blooking.org
 *
 * This file is part of BlooKing! BlooKing is free software: you can
 * redistribute it and/or modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * BlooKing is distributed in the hope that it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details. You should have received a copy of the GNU General Public License
 * along with BlooKing.  If not, see <http://www.gnu.org/licenses/>.
 *   ______ __                __  __ __
 *	|   __ \  |.-----..-----.|  |/  |__|.-----..-----.
 *	|   __ <  ||  _  ||  _  ||     <|  ||     ||  _  |
 *	|______/__||_____||_____||__|\__|__||__|__||___  |
 *                                             |_____|
 **/
defined( '_JEXEC' ) or die( 'Restricted access' );
jimport('joomla.application.component.controller');

class BlookingController extends JController {

	function __construct() {
		parent::__construct();
		$this->registerTask( 'update'  , 'update' );
		$this->registerTask( 'params'  , 'params' );
	}

	function params ()
	{
		$this->setRedirect('index.php?option=com_blooking&controller=params');
	}

	function update() {
		$this->setRedirect('index.php?option=com_blooking&controller=update');
	}


	function display() {
		//Expire bookings
		$model = $this->getModel();
		$expire_bookings = $model->getPendingBookingsData();

		if ($expire_bookings['0']=='1' && $expire_bookings['1'] > 0)
		{
			$db =& JFactory::getDBO();
				
			$time_measure = "";
			switch($expire_bookings['2']) {
				case '0':
					$time_measure = "month";
					break;
				case '1':
					$time_measure = "week";
					break;
				case '2':
					$time_measure = "day";
					break;
				case '3':
					$time_measure = "hour";
					break;
				case '4':
					$time_measure = "minute";
					break;
			}
				
			$killtime = "DATE_SUB(now(),INTERVAL ".$expire_bookings['1']." ".$time_measure.")";

			$bookingid = "SELECT ".$db->nameQuote('idbook')." FROM ".
					$db->nameQuote('#__bookitbooking').
					" WHERE (timestamp < ".$killtime.") AND ".
					$db->nameQuote('status')."=".$db->quote('2');
			$db->setQuery($bookingid);
			$row= $db->loadResultArray();

			if ($row) {
				foreach ($row as $id) {
					$update_query =  "UPDATE ".
							$db->nameQuote('#__bookitbooking')." SET ".$db->nameQuote('status').
							" = ".$db->quote('4').
							" WHERE ".$db->nameQuote('idbook')."=".
							$db->quote($id)." AND ".$db->nameQuote('idguests').">".
							$db->quote('0');
					$updateavail = $db->setQuery($update_query);
					$result = $db->query();
				}
			}
		}

		parent::display();
	}
}