<?php
/**
 * BlooKing - The King in Joomla Booking
 * @version 1.0
 * @author BlooKing.org. Based on BooKiTGold code by Costas Kakousis
 * @copyright (C) 2012-2013 by BlooKing.org (http://www.blooking.org)
 * @license GNU/GPL: http://www.gnu.org/copyleft/gpl.html
 *
 * If you fork this to create your own project, please make a reference to
 * BlooKing! someplace in your code and provide a link to
 * http://www.blooking.org
 *
 * This file is part of BlooKing! BlooKing is free software: you can
 * redistribute it and/or modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * BlooKing is distributed in the hope that it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details. You should have received a copy of the GNU General Public License
 * along with BlooKing.  If not, see <http://www.gnu.org/licenses/>.
 *   ______ __                __  __ __
 *	|   __ \  |.-----..-----.|  |/  |__|.-----..-----.
 *	|   __ <  ||  _  ||  _  ||     <|  ||     ||  _  |
 *	|______/__||_____||_____||__|\__|__||__|__||___  |
 *                                             |_____|
 **/
defined( '_JEXEC' ) or die( 'Restricted access' );
jimport('joomla.application.component.controller');

class BlookingControllerBooking extends BlookingController {
	function __construct() {
		parent::__construct();
		$this->registerTask( 'add'  , 	'edit' );
		$this->registerTask( 'adminConfirm', 'adminConfirm' );
		$this->registerTask( 'listing'  , 	'listing' );
		$this->registerTask( 'deleteExpired'  , 	'deleteExpired' );
		$this->registerTask( 'autocomplete'  , 	'autocomplete' );
	}

	function listing() {
		JRequest::setVar( 'view', 'booking' );
		JRequest::setVar( 'layout', 'default'  );
		parent::display();
	}

	function edit() {
		JRequest::setVar( 'view', 'bookingedit' );
		JRequest::setVar( 'layout', 'default'  );
		JRequest::setVar('hidemainmenu', 1);
		parent::display();
	}

	function adminConfirm() {
		$model = $this->getModel('bookingedit');

		if(!$model->adminConfirm()) {
			$msg = JText::_( 'COM_BOOKIT_ERROR_AVAILABILITY_NOT_CHANGED' );
		} else {
			$msg = JText::_( 'COM_BOOKIT_BOOKING_AVAILABILITY_CONFIRMED' );
		}

		$this->setRedirect( 'index.php?option=com_blooking&controller=booking&task=listing', $msg );
	}

	function deleteExpired() {
		$model = $this->getModel('booking');

		if(!$model->deleteExpired()) {
			$msg = JText::_( 'COM_BOOKIT_ERROR_ONE_OR_MORE_BOOKINGS_COULD_NOT_BE_DELETED' );
		} else {
			$msg = JText::_( 'COM_BOOKIT_BOOKINGS_DELETED' );
		}

		$this->setRedirect( 'index.php?option=com_blooking&controller=booking&task=listing', $msg );
	}
	function remove() {
		$model = $this->getModel('booking');
		if(!$model->delete()) {
			$msg = JText::_( 'COM_BOOKIT_ERROR_ONE_OR_MORE_BOOKINGS_COULD_NOT_BE_DELETED' );
		} else {
			$msg = JText::_( 'COM_BOOKIT_BOOKINGS_DELETED' );
		}

		$this->setRedirect( 'index.php?option=com_blooking&controller=booking&task=listing', $msg );
	}

	function autocomplete() {
		$view = JRequest::getVar( 'view', 'booking' );
		$format = JRequest::getVar( 'format', 'json' );
		$view =& $this->getView( $view, $format );
		$model =& $this->getModel( 'booking' );
		$view->setModel( $model, true );
		$view->display();
	}

	function cancel() {
		$link = 'index.php?option=com_blooking';
		$this->setRedirect($link);
	}
}