<?php
/**
 * BlooKing - The King in Joomla Booking
 * @version 1.0
 * @author BlooKing.org. Based on BooKiTGold code by Costas Kakousis
 * @copyright (C) 2012-2013 by BlooKing.org (http://www.blooking.org)
 * @license GNU/GPL: http://www.gnu.org/copyleft/gpl.html
 *
 * If you fork this to create your own project, please make a reference to
 * BlooKing! someplace in your code and provide a link to
 * http://www.blooking.org
 *
 * This file is part of BlooKing! BlooKing is free software: you can
 * redistribute it and/or modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * BlooKing is distributed in the hope that it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details. You should have received a copy of the GNU General Public License
 * along with BlooKing.  If not, see <http://www.gnu.org/licenses/>.
 *   ______ __                __  __ __
 *	|   __ \  |.-----..-----.|  |/  |__|.-----..-----.
 *	|   __ <  ||  _  ||  _  ||     <|  ||     ||  _  |
 *	|______/__||_____||_____||__|\__|__||__|__||___  |
 *                                             |_____|
 **/

defined( '_JEXEC' ) or die( 'Restricted access' );
jimport('joomla.application.component.controller');
class BlookingControllerBookingedit extends BlookingController {
	function __construct() {
		parent::__construct();
		$this->registerTask( 'add'  , 	'edit' );
		$this->registerTask( 'saveNew'  , 'save' );
		$this->registerTask( 'oncategorychange', 'oncategorychange' );
		$this->registerTask( 'updaterooms', 'updaterooms' );
		$this->registerTask( 'sendemail', 'save' );
	}

	function save() {
		$model = $this->getModel('bookingedit');
		$task = $this->getTask();
		$res = $model->store();


		if ($res["code"]>0) {
			$id = $res['id'];
			$remaining_rooms = $res["rooms"]-1;
			$msg = JText::_( 'COM_BOOKIT_BOOKING_SAVED' )."!";
			if ($remaining_rooms > 0)
				$msg.=" ".$remaining_rooms." ".
				JText::_("COM_BOOKIT_ROOMS_REMAINING");

			if ($task=='saveNew') {
				$link = 'index.php?option=com_blooking&controller=booking&task=edit';
			} else if ($task=='sendemail') {
				$link = 'index.php?option=com_blooking&controller=booking&task=edit&cid[]='.$id;
				$msg = $this->sendmail($res['lang']);
			} else {
				$link = 'index.php?option=com_blooking&controller=booking&task=listing';
			}
			$this->setRedirect($link, $msg);
		} else if ($res["code"]==-2) {
			$msg = JText::_( 'COM_BOOKIT_ERROR_SAVING_BOOKING' );
			$link = 'index.php?option=com_blooking&controller=booking&task=listing';
			$this->setRedirect($link, $msg, 'error');
		}
		else if ($res["code"]==0) {

			$msg = JText::_( 'COM_BOOKIT_ERROR_SAVING_BOOKING_UNAVAILABLE' );
			$link = 'index.php?option=com_blooking&controller=booking&task=edit&cid[]='.$res["id"];
			$this->setRedirect($link, $msg, 'notice');
		}
		else  {

			$msg = JText::_( 'COM_BOOKIT_PLEASE_ENTER_ALL_REQUIRED_FIELDS_VALID_DATES_GUEST'  );
			$link = 'index.php?option=com_blooking&controller=booking&task=edit&cid[]='.$res["id"];
			$this->setRedirect($link, $msg, 'notice');
		}
	}

	function cancel() {
		$link = 'index.php?option=com_blooking&controller=booking&task=listing';
		$this->setRedirect($link);
	}

	function edit() {
		JRequest::setVar( 'view', 'booking' );
		JRequest::setVar( 'layout', 'default'  );
		JRequest::setVar('hidemainmenu', 1);
		parent::display();
	}

	function pricecalc() {
		$model = $this->getModel('bookingedit');
		$data = JRequest::get( 'get' );
		$res = $model->priceCalculation( $data);

		//1.5.7
		$arr = explode(",",  $res->rule_ids);
		$arr = array_map("trim", $arr);
		$arr = array_unique($arr);
		foreach ($arr as $key => $link)
		{
			if ($arr[$key] == '')
			{
				unset($arr[$key]);
			}
		}
		$res->rule_ids = implode(",",$arr);

		echo $res->price."#".$res->msg."#".$res->rule_ids;
	}

	function oncategorychange(){
		// Set the view and the model
		$view = JRequest::getVar( 'view', 'bookingedit' );
		$format = JRequest::getVar( 'format', 'raw' );
		$view =& $this->getView( $view, $format );
		$model =& $this->getModel( 'bookingedit' );
		$view->setModel( $model, true );
		$view->display();
	}

	function updaterooms(){

		// Set the view and the model
		$view = JRequest::getVar( 'view', 'bookingedit' );
		$format = JRequest::getVar( 'format', 'raw' );
		$view =& $this->getView( $view, $format );
		$model =& $this->getModel( 'bookingedit' );
		$view->setModel( $model, true );
		$view->update_rooms();

	}

	function sendmail($lang) {
		if ($lang=='nb') $lang='en';


		// ** Send E-Mail to customer ONLY from Booking Edit Toolbar ** //
		$mailer =& JFactory::getMailer();
		$config =& JFactory::getConfig();
		$model = $this->getModel('bookingedit');
		$params = BlookingHelper::getParams();

		$emails = $model->getAdminEmails();
		$sender = array(
				$emails->admin1,
				$config->getValue( 'config.fromname' ) );
		$mailer->setSender($sender);

		$subject = $model->getSubject($lang);

		$idbook = JRequest::getVar('idbook');
		$res = $model->getBookingDetailsForEmail($idbook);
		$recipients = $res['email'];
		$mailer->addRecipient($recipients);
		//$mailer->addRecipient($emails->admin1); //To send to admin as well


		$utils = $model->getUtils();
		if ($lang=='en') $type='custemail'; else $type='custemail_'.$lang;
		$msg_tmpl = $utils->{$type};

		if ($params->deposit_percent > 0) {
			$deposit = number_format(($res['totalprice'] / 100)*$params->deposit_percent,2, '.','');
		} else {
			$deposit = number_format($params->deposit_fixed,2, '.','');
		}

		$pricelessdeposit = number_format($res['totalprice'] - $deposit,2, '.','');

		$arr_tpl_vars = array('{firstname}','{surname}', '{email}', '{phone}',
				'{address1}', '{address2}', '{address3}', '{postcode}', '{country}',
				'{bookingid}', '{checkin}', '{checkout}', '{nights}', '{roomtype}',
				'{totalprice}', '{deposit}', '{amountreceived}','{remainingprice}',
				'{pricelessdeposit}','{adults}', '{childs}', '{guests}', '{extras}',
				'{extraprices}', '{requests}', '{terms}', '{cancellation}', '{cancelbookinglink}',
				'{bookingstatus}', '{paymentmethod}');

		$arr_tpl_data = array($res['firstname'], $res['surname'], $res['email'],
				$res['phone'], $res['address1'], $res['address2'], $res['address3'],
				$res['postcode'], $res['country'], $res['bookingid'], $res['checkin'],
				$res['checkout'], $res['nights'], $res['roomtype'], $res['totalprice'],
				$deposit, $res['deposit'], $res['remainingprice'], $pricelessdeposit,
				$res['adults'], $res['childs'],	$res['guests'], $res['extras'],
				$res['extraprices'], $res['requests'], $res['terms'], $res['cancellation_policy'],
				$res['cancelbookinglink'], $res['bookingstatus'], $res['paymentmethod']);

		$msg = str_replace($arr_tpl_vars, $arr_tpl_data, $msg_tmpl);
		$subject = str_replace($arr_tpl_vars, $arr_tpl_data, $subject);

		$mailer->setSubject($subject);
		$mailer->isHTML(true);
		$mailer->setBody($msg);
			
		$send =& $mailer->Send();


		if ($send==true) {
			$msg=JText::_("COM_BOOKIT_EMAIL_SENT");
		}



		return $msg;
	}
}