<?php
/**
 * BlooKing - The King in Joomla Booking
 * @version 1.0
 * @author BlooKing.org. Based on BooKiTGold code by Costas Kakousis
 * @copyright (C) 2012-2013 by BlooKing.org (http://www.blooking.org)
 * @license GNU/GPL: http://www.gnu.org/copyleft/gpl.html
 *
 * If you fork this to create your own project, please make a reference to
 * BlooKing! someplace in your code and provide a link to
 * http://www.blooking.org
 *
 * This file is part of BlooKing! BlooKing is free software: you can
 * redistribute it and/or modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * BlooKing is distributed in the hope that it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details. You should have received a copy of the GNU General Public License
 * along with BlooKing.  If not, see <http://www.gnu.org/licenses/>.
 *   ______ __                __  __ __
 *	|   __ \  |.-----..-----.|  |/  |__|.-----..-----.
 *	|   __ <  ||  _  ||  _  ||     <|  ||     ||  _  |
 *	|______/__||_____||_____||__|\__|__||__|__||___  |
 *                                             |_____|
 **/

defined( '_JEXEC' ) or die( 'Restricted access' );
jimport('joomla.application.component.controller');
class BlookingControllerEditor extends BlookingController {
	function __construct() {
		parent::__construct();
		$this->registerTask( 'loadFromDB'  , 	'display' );
		$this->registerTask( 'preview'  , 	'preview' );
		$this->registerTask( 'apply'  , 'save' );
		JLoader::register('BlookingHelper',
		JPATH_COMPONENT.'/helpers/BlookingHelper.php');

	}

	function display() {
		JRequest::setVar( 'view', 'editor' );
		JRequest::setVar( 'layout', 'default'  );
		parent::display();
	}

	function cancel() {
		$link = 'index.php?option=com_blooking&controller=hotelsetup';
		$this->setRedirect($link);
	}

	function save() {

		$filecontent = JRequest::getVar('text', '', 'post', 'string', JREQUEST_ALLOWRAW);
		$filetype = JRequest::getVar('type');
		$model = $this->getModel('editor');
		$task = $this->getTask();
			
		/*if ($filetype == "custemail" || $filetype == "adminemail")
		 {
		$subject = JRequest::getVar('subject');
		$emailSubject = $model->storeEmailSubject($filetype, $subject);
		}*/
		$res = $model->store();
			
		if ($res['code']>0)
		{

			if($task=="apply"){
				$link = 'index.php?option=com_blooking&controller=editor&type='.$res['type'].'&lang='.$res['lang'];
			}
			else
				$link = 'index.php?option=com_blooking&controller=hotelsetup';
			$msg = JText::_( 'COM_BOOKIT_SAVED' );
			$this->setRedirect($link, $msg);
		}
		else
		{

			$msg = JText::_( 'COM_BOOKIT_ERROR_SAVING' );
			if($task=="apply"){
				$link = 'index.php?option=com_blooking&controller=editor&type='.$res['type'].'&lang='.$res['lang'];
			}
			$link = 'index.php?option=com_blooking&controller=hotelsetup';
			$this->setRedirect($link, $msg, 'error');
		}

	}

	function preview() {
		JRequest::setVar( 'view', 'editor' );
		JRequest::setVar( 'layout', 'preview'  );
		parent::display();
	}

	function languageChange ()
	{
		$language = JRequest::getVar('language');
		$type = JRequest::getVar('type');
		$translations =  BlookingHelper::getTranslations('#__bookitutils', $language, $type);

		$document =& JFactory::getDocument();
		$document->setMimeEncoding( 'application/json' );

		echo json_encode( $translations );
	}
}