<?php
/**
 * BlooKing - The King in Joomla Booking
 * @version 1.0
 * @author BlooKing.org. Based on BooKiTGold code by Costas Kakousis
 * @copyright (C) 2012-2013 by BlooKing.org (http://www.blooking.org)
 * @license GNU/GPL: http://www.gnu.org/copyleft/gpl.html
 *
 * If you fork this to create your own project, please make a reference to
 * BlooKing! someplace in your code and provide a link to
 * http://www.blooking.org
 *
 * This file is part of BlooKing! BlooKing is free software: you can
 * redistribute it and/or modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * BlooKing is distributed in the hope that it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details. You should have received a copy of the GNU General Public License
 * along with BlooKing.  If not, see <http://www.gnu.org/licenses/>.
 *   ______ __                __  __ __
 *	|   __ \  |.-----..-----.|  |/  |__|.-----..-----.
 *	|   __ <  ||  _  ||  _  ||     <|  ||     ||  _  |
 *	|______/__||_____||_____||__|\__|__||__|__||___  |
 *                                             |_____|
 **/
defined( '_JEXEC' ) or die( 'Restricted access' );
jimport('joomla.application.component.controller');

class BlookingControllerFinalform extends BlookingController {
	function __construct() {
		parent::__construct();
		$this->registerTask( 'apply'  , 	'save' );
		JLoader::register('BlookingHelper',
		JPATH_COMPONENT.'/helpers/BlookingHelper.php');
	}

	function cancel() {
		$link = 'index.php?option=com_blooking&controller=hotelsetup';
		$this->setRedirect($link);
	}

	function edit() {
		JRequest::setVar( 'view', 'finalform' );
		JRequest::setVar( 'layout', 'default'  );
		parent::display();
	}

	function save() {
		$data = JRequest::get( 'post' );
		$task = $this->getTask();
		$model = $this->getModel('finalform');
		$res = $model->store();


		if ($res['code']>0) {
			$msg = JText::_( 'COM_BOOKIT_FORM_CHANGES_SAVED' )."!";

			if ($task=='apply')
				$link = 'index.php?option=com_blooking&controller=finalform&task=edit&lang='.$res['lang'];
			else
				$link = 'index.php?option=com_blooking&controller=hotelsetup';
				
			$this->setRedirect($link, $msg);
		} else {
			$msg = JText::_( 'COM_BOOKIT_ERROR_SAVING_FORM_CHANGES' );
			$link = 'index.php?option=com_blooking&controller=finalform&task=edit';
			$this->setRedirect($link, $msg, 'error');
		}
	}
	function languageChange ()
	{
		$language = JRequest::getVar('language');
		$type = JRequest::getVar('type');
		$translations =  BlookingHelper::getTranslations('#__bookitutils', $language, $type);

		$document =& JFactory::getDocument();
		$document->setMimeEncoding( 'application/json' );

		echo json_encode( $translations );
	}
}
