<?php
/**
 * BlooKing - The King in Joomla Booking
 * @version 1.0
 * @author BlooKing.org. Based on BooKiTGold code by Costas Kakousis
 * @copyright (C) 2012-2013 by BlooKing.org (http://www.blooking.org)
 * @license GNU/GPL: http://www.gnu.org/copyleft/gpl.html
 *
 * If you fork this to create your own project, please make a reference to
 * BlooKing! someplace in your code and provide a link to
 * http://www.blooking.org
 *
 * This file is part of BlooKing! BlooKing is free software: you can
 * redistribute it and/or modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * BlooKing is distributed in the hope that it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details. You should have received a copy of the GNU General Public License
 * along with BlooKing.  If not, see <http://www.gnu.org/licenses/>.
 *   ______ __                __  __ __
 *	|   __ \  |.-----..-----.|  |/  |__|.-----..-----.
 *	|   __ <  ||  _  ||  _  ||     <|  ||     ||  _  |
 *	|______/__||_____||_____||__|\__|__||__|__||___  |
 *                                             |_____|
 **/
defined( '_JEXEC' ) or die( 'Restricted access' );
jimport('joomla.application.component.controller');

class BlookingControllerGateways extends BlookingController {
	function __construct() {
		parent::__construct();
		$this->registerTask( 'editplugin', 'editplugin' );
		$this->registerTask( 'unpublish', 'publish');
	}

	function display() {
		JRequest::setVar( 'view', 'gateways' );
		JRequest::setVar( 'layout', 'default'  );
		parent::display();
	}

	function editplugin ()
	{
		$id   = JRequest::getInt('cid');
		$context = 'com_plugins.edit.plugin';
		$app   = &JFactory::getApplication();
		$values  = (array) $app->getUserState($context.'.id');
		if (!in_array($id, $values))
		{
			$values[] = $id;
			$app->setUserState($context.'.id', $values);
		}

		$this->setRedirect('index.php?option=com_plugins&view=plugin&layout=edit&extension_id='.$id);

		return;

	}

	function publish () {
		$id   = JRequest::getInt('id');
		$model = $this->getModel('gateways');
		if(version_compare(JVERSION,'1.6.0','ge')) {
			$modelfunction = $model->publish17($id);
		} else {
			$modelfunction = $model->publish15($id);
		}

		$link = 'index.php?option=com_blooking&controller=gateways&task=listing';

		if(!$modelfunction) {
			$msg = JText::_('COM_BOOKIT_ERROR_ACTIVATING_PLUGIN');
			$this->setRedirect($link, $msg, 'error');
		} else {
			$this->setRedirect($link);
		}
	}

	function cancel() {
		$link = 'index.php?option=com_blooking&controller=hotelsetup';
		$this->setRedirect($link);
	}
}