<?php
/**
 * BlooKing - The King in Joomla Booking
 * @version 1.0
 * @author BlooKing.org. Based on BooKiTGold code by Costas Kakousis
 * @copyright (C) 2012-2013 by BlooKing.org (http://www.blooking.org)
 * @license GNU/GPL: http://www.gnu.org/copyleft/gpl.html
 *
 * If you fork this to create your own project, please make a reference to
 * BlooKing! someplace in your code and provide a link to
 * http://www.blooking.org
 *
 * This file is part of BlooKing! BlooKing is free software: you can
 * redistribute it and/or modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * BlooKing is distributed in the hope that it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details. You should have received a copy of the GNU General Public License
 * along with BlooKing.  If not, see <http://www.gnu.org/licenses/>.
 *   ______ __                __  __ __
 *	|   __ \  |.-----..-----.|  |/  |__|.-----..-----.
 *	|   __ <  ||  _  ||  _  ||     <|  ||     ||  _  |
 *	|______/__||_____||_____||__|\__|__||__|__||___  |
 *                                             |_____|
 **/
defined( '_JEXEC' ) or die( 'Restricted access' );
jimport('joomla.application.component.controller');

class BlookingControllerRoom extends BlookingController {
	function __construct() {
		parent::__construct();
		$this->registerTask( 'add'  , 	'edit' );
		$this->registerTask( 'list'  , 	'listing' );
	}

	function listing() {
		JRequest::setVar( 'view', 'room' );
		JRequest::setVar( 'layout', 'default'  );
		parent::display();
	}

	function edit() {
		JRequest::setVar( 'view', 'roomedit' );
		JRequest::setVar( 'layout', 'default'  );
		JRequest::setVar('hidemainmenu', 1);
		parent::display();
	}

	function remove() {
		$model = $this->getModel('room');
		$res = $model->delete();
		if ($res==0)
		{
			$msg = JText::_( 'COM_BOOKIT_ROOMS_DELETED' );
			$this->setRedirect( 'index.php?option=com_blooking&controller=room&task=listing', $msg );
			return;
		}
		else if ($res==-3){
			$msg = JText::_( 'COM_BOOKIT_ROOMS_CANNOT_BE_REMOVED_AS_THEY_ARE_ASSOCIATED_TO_BOOKINGS' );
			$this->setRedirect( 'index.php?option=com_blooking&controller=room&task=listing', $msg, 'notice' );
			return;
		}
		else
		{
			$msg = JText::_( 'COM_BOOKIT_ERROR_ONE_OR_MORE_ROOM_COULD_NOT_BE_DELETED' );
			$this->setRedirect( 'index.php?option=com_blooking&controller=room&task=listing', $msg, 'error' );
			return;
		}

	}

	function copy() {
		$model = $this->getModel('room');
		if(!$model->copy()) {
			$msg = JText::_( 'COM_BOOKIT_ERROR_ONE_OR_MORE_ROOMS_COULD_NOT_BE_COPIED' );
		} else {
			$msg = JText::_( 'COM_BOOKIT_ROOM_COPIED' );
		}

		$this->setRedirect( 'index.php?option=com_blooking&controller=room&task=listing', $msg );
	}

	function cancel() {
		$link = 'index.php?option=com_blooking';
		$this->setRedirect($link);
	}
}