<?php
/**
 * BlooKing - The King in Joomla Booking
 * @version 1.0
 * @author BlooKing.org. Based on BooKiTGold code by Costas Kakousis
 * @copyright (C) 2012-2013 by BlooKing.org (http://www.blooking.org)
 * @license GNU/GPL: http://www.gnu.org/copyleft/gpl.html
 *
 * If you fork this to create your own project, please make a reference to
 * BlooKing! someplace in your code and provide a link to
 * http://www.blooking.org
 *
 * This file is part of BlooKing! BlooKing is free software: you can
 * redistribute it and/or modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * BlooKing is distributed in the hope that it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details. You should have received a copy of the GNU General Public License
 * along with BlooKing.  If not, see <http://www.gnu.org/licenses/>.
 *   ______ __                __  __ __
 *	|   __ \  |.-----..-----.|  |/  |__|.-----..-----.
 *	|   __ <  ||  _  ||  _  ||     <|  ||     ||  _  |
 *	|______/__||_____||_____||__|\__|__||__|__||___  |
 *                                             |_____|
 **/

defined( '_JEXEC' ) or die( 'Restricted access' );
jimport('joomla.application.component.controller');

class BlookingControllerRoomcategoryedit extends BlookingController {
	function __construct() {
		parent::__construct();
		$this->registerTask( 'add'  , 	'edit' );
		$this->registerTask( 'saveNew'  , 'save' );
		$this->registerTask( 'apply'  , 'save' );
		JLoader::register('BlookingHelper',
		JPATH_COMPONENT.'/helpers/BlookingHelper.php');
	}



	function save() {
		$model = $this->getModel('roomcategoryedit');
		$task = $this->getTask();
		$res = $model->store();
		$previousView = JRequest::getVar('return');
		$params = BlookingHelper::getParams();

		if ($res["code"]==0) {
			if ($params->multiroom != "2") {
				$msg = JText::_( 'COM_BOOKIT_ROOM_CATEGORY_SAVED' );
			} else {
				$msg = JText::_('COM_BOOKIT_PROPERTY_SAVED');
			}
			if ($task=='saveNew') {
				if ($previousView != "") {
					$link = 'index.php?option=com_blooking&controller=roomcategory&task=edit&prev='.$previousView;
				} else {
					$link = 'index.php?option=com_blooking&controller=roomcategory&task=edit';
				}
			} else if($task=="apply"){
				$link = 'index.php?option=com_blooking&controller=roomcategory&task=edit&cid[]='.$res["id"]."&lang=".$res['lang'];
			} else {
				if ($previousView != "") {
					$link = 'index.php?option=com_blooking&view='.$previousView;
				} else {
					$link = 'index.php?option=com_blooking&controller=roomcategory&task=listing';
				}
			}
			$this->setRedirect($link, $msg);
		} else if ($res["code"]==-2) {
			if ($params->multiroom != "2") {
				$msg = JText::_( 'COM_BOOKIT_ERROR_SAVING_ROOM_CATEGORY' );
			} else {
				$msg = JText::_( 'COM_BOOKIT_ERROR_SAVING_PROPERTY' );
			}
			$link = 'index.php?option=com_blooking&controller=roomcategory&task=listing';
			$this->setRedirect($link, $msg, 'error');
		}
		else if ($res["code"]==-3) {
			if ($params->multiroom != "2") {
				$msg = JText::_( 'COM_BOOKIT_ERROR_SAVING_ROOM_CATEGORY_UNIQUE_NAME' );
			} else {
				$msg = JText::_( 'COM_BOOKIT_ERROR_SAVING_PROPERTY_UNIQUE_NAME' );
			}
			$link = 'index.php?option=com_blooking&controller=roomcategory&task=listing';
			$this->setRedirect($link, $msg, 'error');
		}
		else {
			$msg = JText::_( 'COM_BOOKIT_PLEASE_COMPLETE_ALL_BASIC_FIELDS_NUMBER_OF_GUEST_AND_COST_MUST_BE_POSITIVE_NUMBERS' );
			$link = 'index.php?option=com_blooking&controller=roomcategory&task=edit&cid[]='.$res["id"];
			$this->setRedirect($link, $msg, 'notice');
		}
	}

	function cancel() {
		$link = 'index.php?option=com_blooking&controller=roomcategory&task=listing';
		$this->setRedirect($link);
	}

	function edit() {
		JRequest::setVar( 'view', 'roomcategoryedit' );
		JRequest::setVar( 'layout', 'default'  );
		JRequest::setVar('hidemainmenu', 1);
		parent::display();
	}

	function languageChange ()
	{
		$language = JRequest::getVar('language');
		$id = JRequest::getVar('idcategory');
		$translations =  BlookingHelper::getTranslations('#__bookitcategory',
				$language, $id);

		$document =& JFactory::getDocument();
		$document->setMimeEncoding( 'application/json' );

		echo json_encode( $translations );
	}
}