<?php
/**
 * BlooKing - The King in Joomla Booking
 * @version 1.0
 * @author BlooKing.org. Based on BooKiTGold code by Costas Kakousis
 * @copyright (C) 2012-2013 by BlooKing.org (http://www.blooking.org)
 * @license GNU/GPL: http://www.gnu.org/copyleft/gpl.html
 *
 * If you fork this to create your own project, please make a reference to
 * BlooKing! someplace in your code and provide a link to
 * http://www.blooking.org
 *
 * This file is part of BlooKing! BlooKing is free software: you can
 * redistribute it and/or modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * BlooKing is distributed in the hope that it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details. You should have received a copy of the GNU General Public License
 * along with BlooKing.  If not, see <http://www.gnu.org/licenses/>.
 *   ______ __                __  __ __
 *	|   __ \  |.-----..-----.|  |/  |__|.-----..-----.
 *	|   __ <  ||  _  ||  _  ||     <|  ||     ||  _  |
 *	|______/__||_____||_____||__|\__|__||__|__||___  |
 *                                             |_____|
 **/
defined( '_JEXEC' ) or die( 'Restricted access' );
jimport('joomla.application.component.controller');

class BlookingControllerRoomextra extends BlookingController {
	function __construct() {
		parent::__construct();
		$this->registerTask( 'add'  , 	'edit' );
		$this->registerTask( 'list'  , 	'listing' );
		$this->registerTask('unpublish', 'publish');
		$this->registerTask('orderdown', 'reorder');
		$this->registerTask('orderup', 'reorder');
	}

	function listing() {
		JRequest::setVar( 'view', 'roomextra' );
		JRequest::setVar( 'layout', 'default'  );
		parent::display();
	}

	function edit() {
		JRequest::setVar( 'view', 'roomextraedit' );
		JRequest::setVar( 'layout', 'default'  );
		JRequest::setVar('hidemainmenu', 1);
		parent::display();
	}

	function remove() {
		$model = $this->getModel('roomextra');
		if(!$model->delete()) {
			$msg = JText::_( 'COM_BOOKIT_ERROR_ONE_OR_MORE_SERVICES_COULD_NOT_BE_DELETED' );
		} else {
			$msg = JText::_( 'COM_BOOKIT_SERVICE_DELETED' );
		}

		$this->setRedirect( 'index.php?option=com_blooking&controller=roomextra&task=listing', $msg );
	}

	function copy() {
		$model = $this->getModel('roomextra');
		if(!$model->copy()) {
			$msg = JText::_( 'COM_BOOKIT_ERROR_ONE_OR_MORE_SERVICES_COULD_NOT_BE_COPIED' );
		} else {
			$msg = JText::_( 'COM_BOOKIT_SERVICE_COPIED' );
		}

		$this->setRedirect( 'index.php?option=com_blooking&controller=roomextra&task=listing', $msg );
	}

	function publish() {
		$model = $this->getModel('roomextra');
		$link = 'index.php?option=com_blooking&controller=roomextra&task=listing';

		if(!$model->publish()) {
			$msg = JText::_('COM_BOOKIT_ERROR_ACTIVATING');
			$this->setRedirect($link, $msg, 'error');
		} else {
			$this->setRedirect($link);
		}
	}

	function cancel() {
		$link = 'index.php?option=com_blooking';
		$this->setRedirect($link);
	}

	function saveorder() {
		$model = $this->getModel('roomextra');
		$link = 'index.php?option=com_blooking&controller=roomextra&task=listing';

		if(!$model->saveorder()) {
			$msg = JText::_('COM_BOOKIT_ERROR_CHANGING_ORDER');
			$this->setRedirect($link, $msg, 'error');
		} else {
			$msg = JText::_('COM_BOOKIT_ORDERING_SAVED');
			$this->setRedirect($link, $msg);
		}
	}

	function reorder() {
		$model = $this->getModel('roomextra');
		$task = $this->getTask();
		$link = 'index.php?option=com_blooking&controller=roomextra&task=listing';

		if ($task=="orderup") {
			$inc = -1;
		} else {
			$inc = +1;
		}

		if(!$model->reorder($inc)) {
			$msg = JText::_('COM_BOOKIT_ERROR_CHANGING_ORDER');
			$this->setRedirect($link, $msg, 'error');
		} else {
			$msg = JText::_('COM_BOOKIT_ORDERING_SAVED');
			$this->setRedirect($link, $msg);
		}
	}
}
