<?php
/**
 * BlooKing - The King in Joomla Booking
 * @version 1.0
 * @author BlooKing.org. Based on BooKiTGold code by Costas Kakousis
 * @copyright (C) 2012-2013 by BlooKing.org (http://www.blooking.org)
 * @license GNU/GPL: http://www.gnu.org/copyleft/gpl.html
 *
 * If you fork this to create your own project, please make a reference to
 * BlooKing! someplace in your code and provide a link to
 * http://www.blooking.org
 *
 * This file is part of BlooKing! BlooKing is free software: you can
 * redistribute it and/or modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * BlooKing is distributed in the hope that it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details. You should have received a copy of the GNU General Public License
 * along with BlooKing.  If not, see <http://www.gnu.org/licenses/>.
 *   ______ __                __  __ __
 *	|   __ \  |.-----..-----.|  |/  |__|.-----..-----.
 *	|   __ <  ||  _  ||  _  ||     <|  ||     ||  _  |
 *	|______/__||_____||_____||__|\__|__||__|__||___  |
 *                                             |_____|
 **/


defined( '_JEXEC' ) or die( 'Restricted access' );

jimport('joomla.application.component.controller');

class BlookingControllerRoomextraedit extends BlookingController
{

	function __construct()
	{

		parent::__construct();
		$this->registerTask( 'add'  , 	'edit' );
		JLoader::register('BlookingHelper',
		JPATH_COMPONENT.'/helpers/BlookingHelper.php');

	}

	function apply ()
	{
		$model = $this->getModel('roomextraedit');
		$res = $model->store();

		$link = 'index.php?option=com_blooking&controller=roomextra&task=edit&cid[]='.$res["id"].'&lang='.$res["lang"];
		if ($res["code"]==0) {

			$msg = JText::_( 'COM_BOOKIT_SERVICE_SAVED' );
			// Check the table in so it can be edited.... we are done with it anyway


			$this->setRedirect($link, $msg);
		} else if ($res["code"]==-2) {
			$msg = JText::_( 'COM_BOOKIT_ERROR_SAVING_SERVICE' );
			// Check the table in so it can be edited.... we are done with it anyway

			$this->setRedirect($link, $msg, 'error');
		}else  {
			$msg = JText::_( 'COM_BOOKIT_PLEASE_COMPLETE_ALL_BASIC_FIELDS_VALUE_MUST_BE_A_VALID_NUMBER' );


			$this->setRedirect($link, $msg, 'notice');
		}
	}

	/**
	 * save a record (and redirect to main page)
	 * @return void
	 */
	function save()
	{
		$task = $this->getTask();
		$model = $this->getModel('roomextraedit');
		$res = $model->store();

		if ($res["code"]==0) {

			$msg = JText::_( 'COM_BOOKIT_SERVICE_SAVED' );
			// Check the table in so it can be edited.... we are done with it anyway
			$link = 'index.php?option=com_blooking&controller=roomextra&task=listing';
			$this->setRedirect($link, $msg);
		} else if ($res["code"]==-2) {
			$msg = JText::_( 'COM_BOOKIT_ERROR_SAVING_SERVICE' );
			// Check the table in so it can be edited.... we are done with it anyway
			$link = 'index.php?option=com_blooking&controller=roomextra&task=listing';
			$this->setRedirect($link, $msg, 'error');
		}else  {
			$msg = JText::_( 'COM_BOOKIT_PLEASE_COMPLETE_ALL_BASIC_FIELDS_VALUE_MUST_BE_A_VALID_NUMBER' );

			$link = 'index.php?option=com_blooking&controller=roomextra&task=edit&cid[]='.$res["id"];
			$this->setRedirect($link, $msg, 'notice');
		}
	}



	function cancel()
	{

		$link = 'index.php?option=com_blooking&controller=roomextra&task=listing';
		$this->setRedirect($link);
	}

	function edit()
	{
		JRequest::setVar( 'view', 'roomextra' );
		JRequest::setVar( 'layout', 'default'  );     // <-- The default form is named here, but in
		JRequest::setVar('hidemainmenu', 1);
		// some complex views, multiple layouts might
		// be needed.

		parent::display();
	}
	function languageChange ()
	{
		$language = JRequest::getVar('language');
		$id = JRequest::getVar('idextra');
		$translations =  BlookingHelper::getTranslations('#__bookitextra', $language, $id);

		$document =& JFactory::getDocument();
		$document->setMimeEncoding( 'application/json' );

		echo json_encode( $translations );
	}

}



