<?php
/**
 * BlooKing - The King in Joomla Booking
 * @version 1.0
 * @author BlooKing.org. Based on BooKiTGold code by Costas Kakousis
 * @copyright (C) 2012-2013 by BlooKing.org (http://www.blooking.org)
 * @license GNU/GPL: http://www.gnu.org/copyleft/gpl.html
 *
 * If you fork this to create your own project, please make a reference to
 * BlooKing! someplace in your code and provide a link to
 * http://www.blooking.org
 *
 * This file is part of BlooKing! BlooKing is free software: you can
 * redistribute it and/or modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * BlooKing is distributed in the hope that it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details. You should have received a copy of the GNU General Public License
 * along with BlooKing.  If not, see <http://www.gnu.org/licenses/>.
 *   ______ __                __  __ __
 *	|   __ \  |.-----..-----.|  |/  |__|.-----..-----.
 *	|   __ <  ||  _  ||  _  ||     <|  ||     ||  _  |
 *	|______/__||_____||_____||__|\__|__||__|__||___  |
 *                                             |_____|
 **/
defined( '_JEXEC' ) or die( 'Restricted access' );
jimport('joomla.application.component.controller');

class BlookingControllerRules extends BlookingController {
	function __construct() {
		parent::__construct();
		$this->registerTask('add', 'edit' );
		$this->registerTask('unpublish', 'publish');
	}

	function copy() {
		$model = $this->getModel('rules');
		$link = 'index.php?option=com_blooking&controller=rules&task=listing';
			
		if (!$model->copy()) {
			$msg = JText::_('COM_BOOKIT_ERROR_COPYING_RULE');
			$this->setRedirect($link, $msg, 'error');
		} else {
			$msg = JText::_('COM_BOOKIT_RULES_COPIED');
			$this->setRedirect($link, $msg);
		}
	}

	function cancel() {
		$link = 'index.php?option=com_blooking';
		$this->setRedirect($link);
	}

	function edit() {
		JRequest::setVar( 'view', 'rulesedit' );
		JRequest::setVar( 'layout', 'default'  );
		JRequest::setVar('hidemainmenu', 1);
		parent::display();
	}

	function listing() {
		JRequest::setVar( 'view', 'rules' );
		JRequest::setVar( 'layout', 'default'  );
		parent::display();
	}

	function remove() {
		$model = $this->getModel('rules');
		$link = 'index.php?option=com_blooking&controller=rules&task=listing';

		if(!$model->delete()) {
			$msg = JText::_( 'COM_BOOKIT_ERROR_DELETING_RULE' );
			$this->setRedirect($link, $msg, 'error');
		} else {
			$msg = JText::_( 'COM_BOOKIT_RULE_DELETED' );
			$this->setRedirect($link, $msg);
		}
	}

	function publish() {
		$model = $this->getModel('rules');
		$link = 'index.php?option=com_blooking&controller=rules&task=listing';

		if(!$model->publish()) {
			$msg = JText::_('COM_BOOKIT_ERROR_ACTIVATING');
			$this->setRedirect($link, $msg, 'error');
		} else {
			$this->setRedirect($link);
		}
	}
}