<?php
/**
 * BlooKing - The King in Joomla Booking
 * @version 1.0
 * @author BlooKing.org. Based on BooKiTGold code by Costas Kakousis
 * @copyright (C) 2012-2013 by BlooKing.org (http://www.blooking.org)
 * @license GNU/GPL: http://www.gnu.org/copyleft/gpl.html
 *
 * If you fork this to create your own project, please make a reference to
 * BlooKing! someplace in your code and provide a link to
 * http://www.blooking.org
 *
 * This file is part of BlooKing! BlooKing is free software: you can
 * redistribute it and/or modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * BlooKing is distributed in the hope that it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details. You should have received a copy of the GNU General Public License
 * along with BlooKing.  If not, see <http://www.gnu.org/licenses/>.
 *   ______ __                __  __ __
 *	|   __ \  |.-----..-----.|  |/  |__|.-----..-----.
 *	|   __ <  ||  _  ||  _  ||     <|  ||     ||  _  |
 *	|______/__||_____||_____||__|\__|__||__|__||___  |
 *                                             |_____|
 **/

defined( '_JEXEC' ) or die( 'Restricted access' );
jimport('joomla.application.component.controller');

class BlookingControllerRulesedit extends BlookingController
{
	function __construct() {
		parent::__construct();
		$this->registerTask('saveNew', 'save');
		$this->registerTask('apply', 'save');
		JLoader::register('BlookingHelper',
		JPATH_COMPONENT.'/helpers/BlookingHelper.php');
	}

	function save() {
		$model = $this->getModel('rulesedit');
		$task = $this->getTask();
		$res = $model->store();



		if ($res->code=='0') {
			$msg = JText::_( 'COM_BOOKIT_RULE_SAVED' );
			if ($task=="saveNew") {
				$link = 'index.php?option=com_blooking&controller=rulesedit&task=edit';
			}
			else if ($task=="apply") {

				$link = 'index.php?option=com_blooking&controller=rules&task=edit&cid[]='.$res->id."&lang=".$res->lang;
			}
			else {
				$link = 'index.php?option=com_blooking&controller=rules&task=listing';
			}
			$this->setRedirect($link, $msg);
				
		} else {
			$msg = $res->msg;
			$link = 'index.php?option=com_blooking&controller=rules&task=edit&cid[]='.$res->id;
			$this->setRedirect($link, $msg, 'error');
		}
	}

	function cancel() {
		$link = 'index.php?option=com_blooking&controller=rules&task=listing';
		$this->setRedirect($link);
	}

	function edit() {
		JRequest::setVar( 'view', 'rulesedit' );
		JRequest::setVar( 'layout', 'default'  );
		JRequest::setVar('hidemainmenu', 1);
		parent::display();
	}
	function languageChange ()
	{
		$language = JRequest::getVar('language');
		$id = JRequest::getVar('idrule');
		$translations =  BlookingHelper::getTranslations('#__bookitrules', $language, $id);

		$document =& JFactory::getDocument();
		$document->setMimeEncoding( 'application/json' );

		echo json_encode( $translations );
	}

}