<?php
/**
 * BlooKing - The King in Joomla Booking
 * @version 1.0
 * @author BlooKing.org. Based on BooKiTGold code by Costas Kakousis
 * @copyright (C) 2012-2013 by BlooKing.org (http://www.blooking.org)
 * @license GNU/GPL: http://www.gnu.org/copyleft/gpl.html
 *
 * If you fork this to create your own project, please make a reference to
 * BlooKing! someplace in your code and provide a link to
 * http://www.blooking.org
 *
 * This file is part of BlooKing! BlooKing is free software: you can
 * redistribute it and/or modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * BlooKing is distributed in the hope that it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details. You should have received a copy of the GNU General Public License
 * along with BlooKing.  If not, see <http://www.gnu.org/licenses/>.
 *   ______ __                __  __ __
 *	|   __ \  |.-----..-----.|  |/  |__|.-----..-----.
 *	|   __ <  ||  _  ||  _  ||     <|  ||     ||  _  |
 *	|______/__||_____||_____||__|\__|__||__|__||___  |
 *                                             |_____|
 **/

defined('_JEXEC') or die('Restricted access');
class BlookingHelper {

	var $_db;

	function getLanguages()
	{
		$options =  array();

		array_push($options, JHTML::_('select.option', 'af', 'Afrikans'));
		array_push($options, JHTML::_('select.option', 'ar', 'Arabic'));
		array_push($options, JHTML::_('select.option', 'eu', 'Basque'));
		array_push($options, JHTML::_('select.option', 'bg', 'Bulgarian'));
		array_push($options, JHTML::_('select.option', 'ca', 'Catalan'));
		array_push($options, JHTML::_('select.option', 'zh', 'Chinese'));
		array_push($options, JHTML::_('select.option', 'da', 'Danish'));
		array_push($options, JHTML::_('select.option', 'de', 'German'));
		array_push($options, JHTML::_('select.option', 'nl', 'Dutch'));
		array_push($options, JHTML::_('select.option', 'el', 'Greek'));
		array_push($options, JHTML::_('select.option', 'en', 'English'));
		array_push($options, JHTML::_('select.option', 'et', 'Estonian'));
		array_push($options, JHTML::_('select.option', 'fr', 'French'));
		array_push($options, JHTML::_('select.option', 'hr', 'Croatian'));
		array_push($options, JHTML::_('select.option', 'hu', 'Hungarian'));
		array_push($options, JHTML::_('select.option', 'is', 'Icelandic'));
		array_push($options, JHTML::_('select.option', 'it', 'Italian'));
		array_push($options, JHTML::_('select.option', 'ja', 'Japanese'));
		array_push($options, JHTML::_('select.option', 'no', 'Norwegian'));
		array_push($options, JHTML::_('select.option', 'pl', 'Polish'));
		array_push($options, JHTML::_('select.option', 'pt', 'Portuguese'));
		array_push($options, JHTML::_('select.option', 'ru', 'Russian'));
		array_push($options, JHTML::_('select.option', 'sk', 'Slovak'));
		array_push($options, JHTML::_('select.option', 'sl', 'Slovenian'));
		array_push($options, JHTML::_('select.option', 'es', 'Spanish'));
		array_push($options, JHTML::_('select.option', 'sr', 'Serbian'));
		array_push($options, JHTML::_('select.option', 'sv', 'Swedish'));
		array_push($options, JHTML::_('select.option', 'tr', 'Turkish'));
		array_push($options, JHTML::_('select.option', 'uk', 'Ukrainian'));

			
		return $options;

	}

	function getTranslations($table, $language, $id)
	{
		$db =& JFactory::getDBO();
		$translation =  array();
		$translation['subject']="";
		$translation['name']="";
		$description_column = "";
		$facilities_column = "";

		switch ($table) {
			case '#__bookitcategory':
				if ($language!='en')
				{
					$description_column = 'description_'.$language;
					$facilities_column = 'facilities_'.$language;
					$name_column = 'name_'.$language;
				}

				if ($language=='en'||
						!BlookingHelper::columnExists($table, $description_column))
				{
					$description_column = 'description';
				}

				if ($language=='en'||
						!BlookingHelper::columnExists($table, $name_column))
				{
					$name_column ='name';
				}

				$sql = "SELECT ".$db->nameQuote($description_column).
				" FROM ".$db->nameQuote($table).
				" WHERE ".$db->nameQuote('idcategory')."=".
				$db->quote($id);
				$db->setQuery($sql);
				$translation['description'] = $db->loadResult();
					
				$sql = "SELECT ".$db->nameQuote($name_column).
				" FROM ".$db->nameQuote($table).
				" WHERE ".$db->nameQuote('idcategory')."=".
				$db->quote($id);
				$db->setQuery($sql);
				$translation['name'] = $db->loadResult();
					
				break;
			case '#__bookitextra':
				if ($language!='en')
				{
					$description_column = 'description_'.$language;
					$name_column = 'name_'.$language;
				}

				if ($language=='en'||
						!BlookingHelper::columnExists($table, $description_column))
				{
					$description_column = 'description';
				}

				if ($language=='en'||
						!BlookingHelper::columnExists($table, $name_column))
				{
					$name_column ='name';
				}

				$sql = "SELECT ".$db->nameQuote($description_column).
				" FROM ".$db->nameQuote($table).
				" WHERE ".$db->nameQuote('idextra')."=".
				$db->quote($id);
				$db->setQuery($sql);
				$translation['description'] = $db->loadResult();

				$sql = "SELECT ".$db->nameQuote($name_column).
				" FROM ".$db->nameQuote($table).
				" WHERE ".$db->nameQuote('idextra')."=".
				$db->quote($id);
				$db->setQuery($sql);
				$translation['name'] = $db->loadResult();

					
				break;
			case '#__bookitutils':
				if ($language!='en')
				{
					$column = $id.'_'.$language;
					$subject_column = $id.'_'.'subject_'.$language;
				}
				else
				{
					$column = $id;
					$subject_column = $id.'_'.'subject';
				}

				if(BlookingHelper::columnExists($table, $column))
				{
					$sql = "SELECT ".$db->nameQuote($column).
					" FROM ".$db->nameQuote($table).
					" WHERE ".$db->nameQuote('id')."=".
					$db->quote('1');
					$db->setQuery($sql);
					$translation['description'] = $db->loadResult();
				}
				else
				{
					$translation['description']="";
				}
				if ($id=='custemail' || $id=='adminemail')
				{
					if(BlookingHelper::columnExists($table, $subject_column))
					{
						$sql = "SELECT ".$db->nameQuote($subject_column).
						" FROM ".$db->nameQuote($table).
						" WHERE ".$db->nameQuote('id')."=".
						$db->quote('1');
						$db->setQuery($sql);
						$translation['subject'] = $db->loadResult();
					}
				}
				else
				{
					$translation['subject']="";
				}
				break;
			case '#__bookitrules':
				if ($language!='en')
				{
					$name_column = 'name_'.$language;
				}

				if ($language=='en'||
						!BlookingHelper::columnExists($table, $name_column))
				{
					$name_column ='name';
				}

				$sql = "SELECT ".$db->nameQuote($name_column).
				" FROM ".$db->nameQuote($table).
				" WHERE ".$db->nameQuote('idrule')."=".
				$db->quote($id);
				$db->setQuery($sql);
				$translation['name'] = $db->loadResult();

				break;
					
			default:
				;
				break;
		}

		return $translation;
	}

	function columnExists ($table, $column)
	{

		$db =& JFactory::getDBO();
		$sql = "SHOW COLUMNS FROM ".$db->nameQuote($table);
		$db->setQuery($sql);
		$columns = 	$db->loadObjectList();

		foreach ($columns as $col)
		{
			if ($col->Field==$column)
				return true;
		}
		return false;
	}

	function getParams ()
	{
		$db =& JFactory::getDBO();
		$sql = "SELECT * FROM ".$db->nameQuote("#__bookitparams").
		" WHERE ".$db->nameQuote("id")."=".
		$db->quote("1");
		$db->setQuery($sql);
		return $db->loadObject();
	}
	function getUtils ()
	{
		$db =& JFactory::getDBO();
		$sql = "SELECT * FROM ".$db->nameQuote("#__bookitutils").
		" WHERE ".$db->nameQuote("id")."=".
		$db->quote("1");
		$db->setQuery($sql);
		return $db->loadObject();
	}

	function getCurrencyOptions ()
	{
		return array(
				JHTML::_('select.option', 'EUR', 'EUR'),
				JHTML::_('select.option', 'USD', 'USD'),
				JHTML::_('select.option', 'AUD', 'AUD'),
				JHTML::_('select.option', 'BRL', 'BRL'),
				JHTML::_('select.option', 'GBP', 'GBP'),
				JHTML::_('select.option', 'CAD', 'CAD'),
				JHTML::_('select.option', 'CZK', 'CZK'),
				JHTML::_('select.option', 'DKK', 'DKK'),
				JHTML::_('select.option', 'HKD', 'HKD'),
				JHTML::_('select.option', 'HUF', 'HUF'),
				JHTML::_('select.option', 'ILS', 'ILS'),
				JHTML::_('select.option', 'JPY', 'JPY'),
				JHTML::_('select.option', 'MXN', 'MXN'),
				JHTML::_('select.option', 'NZD', 'NZD'),
				JHTML::_('select.option', 'NOK', 'NOK'),
				JHTML::_('select.option', 'PHP', 'PHP'),
				JHTML::_('select.option', 'PLN', 'PLN'),
				JHTML::_('select.option', 'SGD', 'SGD'),
				JHTML::_('select.option', 'SEK', 'SEK'),
				JHTML::_('select.option', 'CHF', 'CHF'),
				JHTML::_('select.option', 'TWD', 'TWD'),
				JHTML::_('select.option', 'THB', 'THB'),
				JHTML::_('select.option', 'ZAR', 'ZAR'),
				JHTML::_('select.option', 'MYR', 'MYR')

		);
	}

	function getDateFormat () {
		$date_code = new stdClass;
		$params = BlookingHelper::getParams();
		$dateformatcode = $params->dateformat;
		if ($dateformatcode==""||$dateformatcode==3)
		{
			$d1='d-m-Y';
			$d2='%d-%m-%Y';
		}
		else if ($dateformatcode==1)
		{
			$d1='Y-m-d';
			$d2='%Y-%m-%d';
		}
		else if ($dateformatcode==2)
		{
			$d1='m/d/Y';
			$d2='%m/%d/%Y';
		}
		$date_code->d1 = $d1;
		$date_code->d2 = $d2;

		return $date_code;
	}

	function getSessionCnt ()
	{
		$db =& JFactory::getDBO();
		$sql = "UPDATE ".$db->nameQuote("#__bookitutils")." SET ".
				$db->nameQuote("session_cnt")."=".
				$db->nameQuote('session_cnt')." + 1".
				" WHERE ".$db->nameQuote("id")."=".
				$db->quote("1");
		$db->setQuery($sql);
		$db->query();
		$sql = "SELECT ".$db->nameQuote("session_cnt")." FROM ".
				$db->nameQuote("#__bookitutils").
				" WHERE ".$db->nameQuote("id")."=".
				$db->quote("1");
		$db->setQuery($sql);
		return $db->loadResult();

	}

	function getLocalizedDate($date = 'now', $format='')
	{
		jimport('joomla.utilities.date');
		$config =& JFactory::getConfig();
		$siteOffset = $config->getValue('config.offset');
			
		$jdate = new JDate($date, $siteOffset);
		// site offset
		if ($format=='toRFC822')
			return $jdate->toRFC822();
		else if ($format=='toISO8601')
			return $jdate->toISO8601();
		else
			return $jdate->toUnix();
	}

	function getCountries ()
	{
		$sql = "SELECT * FROM #__bookitcountry ORDER BY name";
		$this->_db->setQuery($sql);
		$countries =  $this->_db->loadObjectList();
		$result = array();
		$cnt=1;
		foreach ($countries as $c)
		{
			array_push($result, JHTML::_('select.option', $c->idcountry,
			JText::_("COM_BOOKIT_C_".$c->abbv), 'idcountry', 'name' ));
		}

		asort($result);
		return $result;
	}

}