<?php
/**
 * BlooKing - The King in Joomla Booking
 * @version 1.0
 * @author BlooKing.org. Based on BooKiTGold code by Costas Kakousis
 * @copyright (C) 2012-2013 by BlooKing.org (http://www.blooking.org)
 * @license GNU/GPL: http://www.gnu.org/copyleft/gpl.html
 *
 * If you fork this to create your own project, please make a reference to
 * BlooKing! someplace in your code and provide a link to
 * http://www.blooking.org
 *
 * This file is part of BlooKing! BlooKing is free software: you can
 * redistribute it and/or modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * BlooKing is distributed in the hope that it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details. You should have received a copy of the GNU General Public License
 * along with BlooKing.  If not, see <http://www.gnu.org/licenses/>.
 *   ______ __                __  __ __
 *	|   __ \  |.-----..-----.|  |/  |__|.-----..-----.
 *	|   __ <  ||  _  ||  _  ||     <|  ||     ||  _  |
 *	|______/__||_____||_____||__|\__|__||__|__||___  |
 *                                             |_____|
 **/
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport('joomla.application.component.model');

class BlookingModelAvailability extends JModel
{
	var $_data;
	var $_id;
	var $_db;
	function __construct()
	{
		parent::__construct();

		$array = JRequest::getVar('cid',  0, '', 'array');
		$this->setId((int)$array[0]);
		JLoader::register('BlookingHelper',
		JPATH_COMPONENT.'/helpers/BlookingHelper.php');
	}

	function setId($id)
	{
		// Set id and wipe data
		$this->_id		= 1;
		$this->_data	= null;
	}

	function getCategories() {
		$db =& JFactory::getDBO();
		$sql = "SELECT ".$db->nameQuote('idcategory').", ".
				$db->nameQuote('name')." FROM ".$db->nameQuote("#__bookitcategory");
		$db->setQuery($sql);
		return $db->loadObjectList();
	}

	//function getRooms() {
	function getRooms($idcategory=0) {
		$db =& JFactory::getDBO();
		if ($idcategory>0)
		{
			$sql = "SELECT ".$db->nameQuote('idroom').", ".
					$db->nameQuote('name')." FROM ".$db->nameQuote("#__bookitroom").
					" WHERE ".$db->nameQuote('idcategory')."=".$idcategory;
		}
		else
		{
			$sql = "SELECT ".$db->nameQuote('idroom').", ".
					$db->nameQuote('name')." FROM ".$db->nameQuote("#__bookitroom");
		}
		$db->setQuery($sql);
		return $db->loadObjectList();
	}
	function getAjaxRooms ($idcategory=0)
	{

		if ($idcategory>0)
		{
			$query = ' SELECT * '
					. ' FROM '.$this->_db->nameQuote('#__bookitroom').' WHERE '
							. $this->_db->nameQuote('idcategory'). ' = '
									. $this->_db->quote($idcategory).' ORDER BY '
											. $this->_db->nameQuote('name');
		}
		else
		{
			$query = ' SELECT * '
					. ' FROM '.$this->_db->nameQuote('#__bookitroom').' ORDER BY '
							. $this->_db->nameQuote('name');
		}

		$this->_db->setQuery($query);
		$rooms = $this->_db->loadObjectList();

		$res = array ();
		$res[0] = JText::_("COM_BOOKIT_ANY");
		foreach ($rooms as $room):
		$res[$room->idroom]=$room->name;
		endforeach;

		return $res;
	}


	function displayCalendar($month, $year, $idcategory, $idroom, $months_ahead,
			$cal_rows=2, $cal_cols=3)
	{
		if ($idroom==-999)
			require_once (JPATH_ADMINISTRATOR.DS."components".DS."com_blooking".DS."helpers".DS."BlookingHelper.php");

		$imagesRoot = JURI::root()."components/com_blooking/images/";
		$params = BlookingHelper::getParams();

		$available_color = '#'.$params->available_color;
		$booked_color = '#'.$params->booked_color;
		$pending_color = '#'.$params->pending_color;
		$other_color = '#'.$params->other_color;
		$extra_availability = JText::_("COM_BOOKIT_CLOSED");
		$none_color="#FFFFFF";
		$months_count = 0;
		$backcolor="";
		$backimage="";
		$state=0;
		$afternoon_booked=0;
		$morning_booked=0;
		$currentDay= date('Y-m-d');

		$calendar = "<div>";
		$calendar .= "<table>";
		for ($i=0; $i<$cal_rows; $i++)
		{
			$calendar .= "<tr>";
			for ($j=0; $j<$cal_cols; $j++)
			{

				if (++$months_count>$months_ahead)
					break;

				$calendar .="<td style='vertical-align:top;'>";
				$calendar .= '<table cellpadding="0" cellspacing="0"
						class="ycalendar">';
				$calendar.= '<tr class="ycalendar-row" align="right" >
						<td class="table-header" colspan="7">'.
						$month.' / '.$year.'</td></tr>';

				/* table headings */
				if ($params->start_monday==1)
				{
					$headings = array(
							JText::_("COM_BOOKIT_MO"),
							JText::_("COM_BOOKIT_TU"),
							JText::_("COM_BOOKIT_WE"),
							JText::_("COM_BOOKIT_TH"),
							JText::_("COM_BOOKIT_FR"),
							JText::_("COM_BOOKIT_SA"),
							JText::_("COM_BOOKIT_SU")
					);
				}
				else
				{
					//If start on monday
					$headings = array(JText::_("COM_BOOKIT_SU"),
							JText::_("COM_BOOKIT_MO"),
							JText::_("COM_BOOKIT_TU"),
							JText::_("COM_BOOKIT_WE"),
							JText::_("COM_BOOKIT_TH"),
							JText::_("COM_BOOKIT_FR"),
							JText::_("COM_BOOKIT_SA")
					);
				}

				$calendar.= '<tr class="ycalendar-row">
						<td class="ycalendar-day-head" >'.
						implode('</td><td class="ycalendar-day-head">',$headings).
						'</td></tr>';

				/* days and weeks vars now ... */
				if ($params->start_monday==0)
					$running_day = date('w',mktime(0,0,0,$month,1,$year));
				else
					$running_day = date('N',mktime(0,0,0,$month,1,$year))-1;
				$days_in_month = date('t',mktime(0,0,0,$month,1,$year));
				$days_in_this_week = 1;
				$day_counter = 0;
				$dates_array = array();

				/* row for week one */
				$calendar.= '<tr class="ycalendar-row">';

				/* print "blank" days until the first of the current week */
				for($x = 0; $x < $running_day; $x++):
				$calendar.= '<td class="ycalendar-day-np"> </td>';
				$days_in_this_week++;
				endfor;

				/* keep going with days.... */
				for($list_day = 1; $list_day <= $days_in_month; $list_day++):

				$currentDay =  date ("Y-m-d",strtotime($year."-".$month."-".$list_day));

				$check = $this->_availabilityCheck($currentDay,
						$currentDay, $idcategory, $idroom);
				$count_available = $check->remaining_rooms;
				$r = $this->_getAvailabilityState ($currentDay, $idcategory, $idroom);
				$state = $r->state;
				if ($count_available>0)
				{

					//Get the day state (availability)
					if ($state==0 || $state=="" || $state==6)
					{
						if ($params->show_available==1)
						{
							if ($morning_booked>0)
							{
								$backcolor = $available_color;
								$backimage = "" ;
							}
							else
							{
								$backcolor = $available_color;
								$backimage = "";
							}
						}
						else
						{
							$backcolor = $none_color;
							$backimage = "";
						}
					}
					else if ($state==2)
					{
						if ($params->show_pending==1)
						{
							$backcolor = $pending_color;
							$backimage = "";
						}
						else
						{
							$backcolor = $available_color;
							$backimage = "";
						}
					}
					else if ($state==3)
					{
						if ($params->show_extra==1)
						{
							$backcolor = $other_color;
							$backimage = "";
						}
						else
						{
							$backcolor = $available_color;
							$backimage = "";
						}
					}
				}
				else if ($count_available<=0)
				{

					if ($state==3)
					{
						if ($params->show_extra==1)
						{
							$backcolor = $other_color;
							$backimage = "";
						}
						else
						{
							$backcolor = $available_color;
							$backimage = "";
						}
					}
					else
					{
						if ($state==2)
						{
							//To draw a half day tomorrow must be available
							$yesterday = date('Y-m-d', strtotime($currentDay.' -1 day'));
							$check = $this->_availabilityCheck($yesterday, $currentDay,
									$idcategory, $idroom);
							$afternoon_booked = $check->remaining_rooms;

							if ($params->show_pending==1)
							{
								if ($afternoon_booked>0)
								{
									$backcolor = $available_color;
									$backimage = "url(".$imagesRoot."pending_eve_y.gif)" ;
								}
								else
								{
									$backcolor = $pending_color;
									$backimage = "";
								}
							}
							else
							{
								$backcolor = $available_color;
								$backimage = "";
							}
						}
						else
						{
							//To draw a half day tomorrow must be available
							$yesterday = date('Y-m-d', strtotime($currentDay.' -1 day'));
							$check = $this->_availabilityCheck($yesterday, $currentDay,
									$idcategory, $idroom);
							$afternoon_booked = $check->remaining_rooms;


							if ($params->show_booked==1)
							{
								if ($afternoon_booked>0)
								{
									$backcolor = $available_color;
									$backimage = "url(".$imagesRoot."booked_eve_y.gif)" ;
								}
								else
								{
									$backcolor = $booked_color;
									$backimage = "";
								}
							}
							else
							{
								$backcolor = $available_color;
								$backimage = "";
							}
						}
					}
				}
				else
				{
					if ($params->show_available==1)
					{
						$backcolor = $available_color;
						$backimage = "";
					}
					else
					{
						$backcolor = $none_color;
						$backimage = "";
					}
				}
				if ($idroom!=-999) {
					$calendar.= '<td onClick="showDayDetails(1,2,&quot;'.htmlspecialchars(
							$this->showdaydetails($currentDay, $idcategory, $idroom)).'&quot;);"
									class="ycalendar-day" style="background:'.
									$backcolor.' '.$backimage.' no-repeat" />';
				}
				else { //Front end
					$calendar.= '<td class="ycalendar-day" style="background:'.
							$backcolor.' '.$backimage.' no-repeat" />';
				}


				$calendar.= '<div class="day-number">'.$list_day.'</div>';
				$calendar.= str_repeat('<p> </p>',2);
				$calendar.= '</td>';

				if($running_day == 6):
				$calendar.= '</tr>';
				if(($day_counter+1) != $days_in_month):
				$calendar.= '<tr class="ycalendar-row">';
				endif;
				$running_day = -1;
				$days_in_this_week = 0;
				endif;
				$days_in_this_week++; $running_day++; $day_counter++;
				endfor;

				/* finish the rest of the days in the week */
				if($days_in_this_week < 8):
				for($x = 1; $x <= (8 - $days_in_this_week); $x++):
				$calendar.= '<td class="ycalendar-day-np"> </td>';
				endfor;
				endif;

				/* final row */
				$calendar.= '</tr>';

				/* end the table */
				$calendar.= '</table>';

				$calendar.='</td>';
				$month++;
				if ($month==13)
				{
					$month=1;
					$year++;
				}
			}

			$calendar.= '</tr>';
			if ($months_count==$months_ahead)
				break;
		}

		$calendar .="</table><table class='calendar-labels'>";
		if ($params->show_available==1)
		{
			$calendar .= "<td style='background-color:".$available_color."'
					class='ycalendar-label-day' >
					</td><td>".
					JText::_( 'COM_BOOKIT_AVAILABLE' )."</td>";
		}
		if ($params->show_booked==1)
		{
			$calendar .= "<td style='background-color:".$booked_color."'
					class='ycalendar-label-day'>
					</td><td>".
					JText::_( 'COM_BOOKIT_BOOKED' )."</td>";
		}
		if ($params->show_pending==1)
		{
			$calendar .= "<td style='background-color:".$pending_color."'
					class='ycalendar-label-day'>
					</td><td>".
					JText::_( 'COM_BOOKIT_PENDING' )."</td>";
		}
		if ($params->show_extra==1)
		{
			$calendar .= "<td style='background-color:".$other_color."'
					class='ycalendar-label-day'>
					</td><td>".
					$extra_availability."</td>";
		}
		$calendar .= "</tr></table>";
		$calendar .="</table>";
		$calendar .="</div>";
		return $calendar;
	}
	function _availabilityCheck ($valid_from, $valid_to, $idcategory=-1, $idroom=-1)
	{
		$res = new stdClass();
		$res->remaining_rooms = 0;
		$res->query="";
		//CHECK FOR AVAILABILITY
		$start= $this->_toMysqlDateFormat ($valid_from);
		$end = $this->_toMysqlDateFormat($valid_to);

		$whereStr="";

		if ($idcategory>0)
		{
			$whereStr.=$this->_db->nameQuote('idcategory')." = ".
					$this->_db->quote($idcategory);
		}
		if ($idroom>0)
		{
			if ($whereStr!="")
			{
				$whereStr.=" AND ".$this->_db->nameQuote('idroom')." = ".
						$this->_db->quote($idroom);
			}
			else
			{
				$whereStr.=$this->_db->nameQuote('idroom')." = ".
						$this->_db->quote($idroom);
			}
		}

		$case1 =  $this->_db->nameQuote('valid_from')." <= ".
				$this->_db->quote($start)." AND ".
				$this->_db->nameQuote('valid_to')." > ".$this->_db->quote($start);

		$case2 = $this->_db->nameQuote('valid_from')." >= ".
				$this->_db->quote($start)." AND ".$this->_db->nameQuote('valid_from').
				" < ".$this->_db->quote($end);


		//------Check if there is availability for the selected options---------
		//Get bookings already found for selected settings
		$query = "SELECT COUNT(*) FROM ".
				$this->_db->nameQuote('#__bookitbooking')." WHERE ".$whereStr;
		if ($whereStr!="")
			$query.=" AND ";
		$query.="(".$this->_db->nameQuote('status')." IN(1,2,3) ) AND ( (".
				$case1.") OR (".$case2.") );";
		$this->_db->setQuery($query);
		$rows = $this->_db->loadResult();
		$res->query = $query;
		$res->bookings = $rows;

		$query = "SELECT COUNT(*) FROM ".
				$this->_db->nameQuote('#__bookitroom');
		if ($whereStr!="")
			$query .= " WHERE ".$whereStr;
		$this->_db->setQuery($query);
		$rooms_in_selected_category = $this->_db->loadResult();

		if ($rows==0)
			$res->remaining_rooms= $rooms_in_selected_category;
		else
			$res->remaining_rooms = $rooms_in_selected_category - $rows;
		return $res;
	}
	function _getBookings ($valid_from, $valid_to, $idcategory=-1, $idroom=-1)
	{
		$res = new stdClass();

		$res->query="";

		$start= $this->_toMysqlDateFormat ($valid_from);
		$end = $this->_toMysqlDateFormat($valid_to);

		$whereStr="";

		if ($idcategory>0)
		{
			$whereStr.=$this->_db->nameQuote('idcategory')." = ".
					$this->_db->quote($idcategory);
		}
		if ($idroom>0)
		{
			if ($whereStr!="")
			{
				$whereStr.=" AND ".$this->_db->nameQuote('idroom')." = ".
						$this->_db->quote($idroom);
			}
			else
			{
				$whereStr.=$this->_db->nameQuote('idroom')." = ".
						$this->_db->quote($idroom);
			}
		}

		$case1 =  $this->_db->nameQuote('valid_from')." <= ".
				$this->_db->quote($start)." AND ".
				$this->_db->nameQuote('valid_to')." > ".$this->_db->quote($start);

		$case2 = $this->_db->nameQuote('valid_from')." >= ".
				$this->_db->quote($start)." AND ".$this->_db->nameQuote('valid_from').
				" <= ".$this->_db->quote($end);

		//Clear fake bookings for the same settings
		$query = "DELETE FROM ".
				$this->_db->nameQuote('#__bookitbooking')." WHERE ".$whereStr;
		if ($whereStr!="")
			$query.=" AND ";
		$query.="(".$this->_db->nameQuote('status').
		" IN (0, 2, 3) ) AND ( (".$case1.") OR (".$case2.") )";
		$query .= " AND ".$this->_db->nameQuote('idguests')."=".
				$this->_db->quote('0');
		$this->_db->setQuery($query);
		$this->_db->query();

		$case1 =  $this->_db->nameQuote('valid_from')." <= ".
				$this->_db->quote($start)." AND ".
				$this->_db->nameQuote('valid_to')." > ".$this->_db->quote($start);

		$case2 = $this->_db->nameQuote('valid_from')." >= ".
				$this->_db->quote($start)." AND ".$this->_db->nameQuote('valid_from').
				" < ".$this->_db->quote($end);

		//Get real bookings already found for selected settings
		$query = "SELECT ".$this->_db->nameQuote('idroom')." FROM ".
				$this->_db->nameQuote('#__bookitbooking')." WHERE ".$whereStr;
		if ($whereStr!="")
			$query.=" AND ";
		$query.="( (".$case1.") OR (".$case2.") )";
		$query .= " AND ".$this->_db->nameQuote('idguests').">".
				$this->_db->quote('0');
		$this->_db->setQuery($query);
		$rows = $this->_db->loadResultArray();
		$res->query = $query;
		$res->bookings = count($rows);
		$res->idrooms = $rows;

		return $rows;
	}
	function _toMysqlDateFormat ($dateString)
	{
		$date_format = $this->_getDateFormat ();
		$originalDate = strtotime($dateString);
		return date("Y-m-d", $originalDate);
	}
	function _getDateFormat ()
	{
		$params = BlookingHelper::getParams();
		$dateformatcode = $params->dateformat;
		if ($dateformatcode==""||$dateformatcode==3)
			$d1='d-m-Y';
		else if ($dateformatcode==1)
			$d1='Y-m-d';
		else if ($dateformatcode==2)
			$d1='m/d/Y';
		return $d1;
	}
	function _getAvailabilityState ($currentDay, $idcategory, $idroom)
	{
		$res = new stdClass();
		$whereStr = "";
		$state = 0;
		$pending_rooms = 0;
		$closed_rooms = 0;
		$booked_rooms = 0;
		$available_rooms = 0;
			
		if ($idcategory>0)
		{
			$whereStr .= $this->_db->nameQuote("idcategory")."=".
					$this->_db->quote($idcategory);
		}
		if ($idroom>0)
		{
			if ($whereStr!="")
				$whereStr .= " AND ";

			$whereStr .= $this->_db->nameQuote("idroom")."=".
					$this->_db->quote($idroom);
		}

		$rooms = $this->_gatTotalRooms ($idcategory, $idroom);
		$available_rooms=$rooms;

		$query = "SELECT ".$this->_db->nameQuote("status").
		" FROM ".$this->_db->nameQuote("#__bookitbooking").
		" WHERE ".$whereStr;
		if ($whereStr!="")
			$query .= " AND ";
		$query .= "(";
		$query .= $this->_db->nameQuote("valid_from")." <= ".
				$this->_db->quote($currentDay)." AND ".
				$this->_db->nameQuote("valid_to")." > ".
				$this->_db->quote($currentDay).") ";
		$this->_db->setQuery($query);
		$states = $this->_db->loadResultArray();


		if (!empty($states))
		{
			$pending_rooms = count(array_keys($states, '2'));
			$closed_rooms = count(array_keys($states, '3'));
			$booked_rooms = count(array_keys($states, '1'));
			$processing_rooms = count(array_keys($states, '6'));

			$available_rooms = $rooms -
			($pending_rooms+$closed_rooms+$booked_rooms+$processing_rooms);

				

			if ($booked_rooms==$rooms) //All rooms are booked
				$state = 1;
			else if ($pending_rooms==$rooms) //All rooms are pending
				$state = 2;
			else if ($closed_rooms==$rooms) //All rooms are closed
				$state = 3;
			else if ($available_rooms>0)
				$state = 0;
			else if ($pending_rooms>0)
				$state = 2;
			else if ($closed_rooms>0)
				$state = 3;
			else if ($processing_rooms>0)
				$state = 6;
			else
				$state=0;
				
				
		}

		$res->state = $state;
		$res->pending_rooms = $pending_rooms;
		$res->closed_rooms = $closed_rooms;
		$res->booked_rooms = $booked_rooms;
		$res->available_rooms = $available_rooms;

		return $res;

	}
	function _gatTotalRooms ($idcategory, $idroom)
	{
		$whereStr="";
		if ($idcategory>0)
		{
			$whereStr .= " WHERE ".$this->_db->nameQuote("idcategory")."=".
					$this->_db->quote($idcategory);
		}
		if($idroom>0)
		{
			if ($whereStr!="")
			{
				$whereStr .= " AND ".$this->_db->nameQuote("idroom")."=".
						$this->_db->quote($idroom);
			}
			else
			{
				$whereStr .= " WHERE ".$this->_db->nameQuote("idroom")."=".
						$this->_db->quote($idroom);
			}
		}

		$query = "SELECT COUNT(*) FROM ".
				$this->_db->nameQuote("#__bookitroom").$whereStr;
		$this->_db->setQuery($query);
		return $this->_db->loadResult();
	}

	function setstatus ($valid_from, $valid_to, $idcategory, $idroom, $status)
	{

		//status:  '0=available; 1=booked; 2=pending; 3=closed '
		$booked_rooms = $this->_getBookings($valid_from, $valid_to, $idcategory,
				$idroom);
		$found_booked_rooms = false;

		if ($status==0)
			$valid_to = date("Y-m-d", strtotime($valid_to));
		else
			$valid_to = date("Y-m-d", strtotime("+1 day", strtotime($valid_to)));

		//book the specific room
		if ($idcategory > 0 && $idroom > 0)
		{
			//The selected room is already booked
			if (in_array($idroom, $booked_rooms))
				return 0;
			$data = new stdClass();
			$data->idbook = null;
			$data->idcoupon = 0;
			$data->idguests = 0;
			$data->nguests = 0;
			$data->value_paid = 0.0;
			$data->value_pending = 0.0;
			$data->value_full = 0.0;
			$data->valid_from = date("Y-m-d", strtotime($valid_from));
			$data->valid_to = date("Y-m-d", strtotime($valid_to));
			$data->today =  date ("Y-m-d");
			$data->extra_ids = "";
			$data->nchilds = 0;
			$data->preferences = NULL;
			$data->status = $status;
			$data->lang = NULL;
			$data->rule_ids = NULL;
			$data->idroom = $idroom;
			$data->idcategory = $idcategory;
			$this->_db->insertObject( '#__bookitbooking', $data, 'idbook' );
		}
		//find room category and book the room
		else if ($idroom > 0 && $idcategory <= 0)
		{
			//The selected room is already booked
			if (in_array($idroom, $booked_rooms))
				return 0;
			$data = new stdClass();
			$data->idbook = null;
			$data->idcoupon = 0;
			$data->idguests = 0;
			$data->nguests = 0;
			$data->value_paid = 0.0;
			$data->value_pending = 0.0;
			$data->value_full = 0.0;
			$data->valid_from = date("Y-m-d", strtotime($valid_from));
			$data->valid_to = date("Y-m-d", strtotime($valid_to));
			$data->today =  date ("Y-m-d");
			$data->extra_ids = "";
			$data->nchilds = 0;
			$data->preferences = NULL;
			$data->status = $status;
			$data->lang = NULL;
			$data->rule_ids = NULL;
			$data->idroom = $idroom;
			$query = "SELECT ".$this->_db->nameQuote('idcategory')." FROM ".
					$this->_db->nameQuote('#__bookitroom')." WHERE ".
					$this->_db->nameQuote('idroom')." = ".$idroom;
			$this->_db->setQuery($query);
			$data->idcategory = $this->_db->loadResult();
			$this->_db->insertObject( '#__bookitbooking', $data, 'idbook' );
		}
		else if ($idroom <= 0 && $idcategory > 0) //book all rooms in category
		{

			$rooms = $this->getRooms($idcategory);
			foreach ($rooms as $room)
			{
				//This room is already booked
				if (in_array($room->idroom, $booked_rooms))
				{
					$found_booked_rooms = true;
					continue;
				}
					
				$data = new stdClass();
				$data->idbook = null;
				$data->idcoupon = 0;
				$data->idguests = 0;
				$data->nguests = 0;
				$data->value_paid = 0.0;
				$data->value_pending = 0.0;
				$data->value_full = 0.0;
				$data->valid_from = date("Y-m-d", strtotime($valid_from));
				$data->valid_to = date("Y-m-d", strtotime($valid_to));
				$data->today =  date ("Y-m-d");
				$data->extra_ids = "";
				$data->nchilds = 0;
				$data->preferences = NULL;
				$data->status = $status;
				$data->lang = NULL;
				$data->rule_ids = NULL;
				$data->idroom = $room->idroom;
				$data->idcategory = $idcategory;

				$this->_db->insertObject( '#__bookitbooking', $data, 'idbook' );
			}
		}
		else if ($idroom <= 0 && $idcategory <= 0) //book all hotel rooms
		{
			$categories = $this->getCategories();
			foreach ($categories as $category)
			{
				$rooms = $this->getRooms($category->idcategory);

				foreach ($rooms as $room)
				{
					//This room is already booked
					if (in_array($room->idroom, $booked_rooms))
					{
						$found_booked_rooms = true;
						continue;
					}
					$data = new stdClass();
					$data->idbook = null;
					$data->idcoupon = 0;
					$data->idguests = 0;
					$data->nguests = 0;
					$data->value_paid = 0.0;
					$data->value_pending = 0.0;
					$data->value_full = 0.0;
					$data->valid_from = date("Y-m-d", strtotime($valid_from));
					$data->valid_to = date("Y-m-d", strtotime($valid_to));
					$data->today =  date ("Y-m-d");
					$data->extra_ids = "";
					$data->nchilds = 0;
					$data->preferences = NULL;
					$data->status = $status;
					$data->lang = NULL;
					$data->rule_ids = NULL;
					$data->idroom = $room->idroom;
					$data->idcategory = $category->idcategory;
					$this->_db->insertObject( '#__bookitbooking', $data, 'idbook' );
				}
			}
		}
		if ($found_booked_rooms) return 0;
		else
			return 1;
	}

	function showdaydetails ($day, $idcategory, $idroom)
	{

		$date_in_selected_format =
		date($this->_getDateFormat(), strtotime($day));
		$details="";

		if ($idcategory > 0 || $idroom > 0)
		{
			if ($idcategory<=0)
				$idcategory = $this->_getCategoryIdFromRoom ($idroom);

			//Date
			$details .= "<span class='details_row'>";
			$details .= "<span class='details_key'>".
					JText::_("COM_BOOKIT_DATE").":</span>";
			$details .= "<span class='details_value'>".
					$date_in_selected_format."</span>";
			$details .= "</span>";

			//Category
			$url = JURI::root()."administrator/index.php?option=com_blooking&controller=roomcategory&task=edit&cid[]=".$idcategory;
			$details .= "<span class='details_row'>";
			$details .= "<span class='details_key'>".
					JText::_("COM_BOOKIT_ROOM_CATEGORY").":</span>";
			$details .= "<span class='details_value'>";
			$details.="<a href=".$url.">".$this->_getCategoryName($idcategory)
			."</a></span>";
			$details .= "</span>";

			//Room
			$details .= "<span class='details_row'>";
			$details .= "<span class='details_key'>".
					JText::_("COM_BOOKIT_ROOM").":</span>";
			$details .= "<span class='details_value'>".
					$this->_getRoomName($idroom)."</span>";
			$details .= "</span>";

			//State
			$r = $this->_getAvailabilityState($day, $idcategory, $idroom);
			$state=$r->state;
			$details .= "<span class='details_row'>";
			$details .= "<span class='details_key'>".
					JText::_("COM_BOOKIT_STATUS").":</span>";
			$details .= "<span class='details_value'>".
					$this->_statusToText($state)
					."</span>";
			$details .= "</span>";
				
			//booked rooms
			$details .= "<span class='details_row'>";
			$details .= "<span class='details_key'>".
					JText::_("COM_BOOKIT_BOOKED_ROOMS").":</span>";
			$details .= "<span class='details_value'>".
					$r->booked_rooms
					."</span>";
			$details .= "</span>";

			//Pending rooms
			$details .= "<span class='details_row'>";
			$details .= "<span class='details_key'>".
					JText::_("COM_BOOKIT_PENDING_ROOMS").":</span>";
			$details .= "<span class='details_value'>".
					$r->pending_rooms
					."</span>";
			$details .= "</span>";

			//Closed rooms
			$details .= "<span class='details_row'>";
			$details .= "<span class='details_key'>".
					JText::_("COM_BOOKIT_CLOSED_ROOMS").":</span>";
			$details .= "<span class='details_value'>".
					$r->closed_rooms
					."</span>";
			$details .= "</span>";
				
			//Available rooms
			$details .= "<span class='details_row'>";
			$details .= "<span class='details_key'>".
					JText::_("COM_BOOKIT_AVAILABLE_ROOMS").":</span>";
			$details .= "<span class='details_value'>".
					$r->available_rooms
					."</span>";
			$details .= "</span>";

				
			//Get the bookingedit model!
			$bookingeditmodel =&
			$this->getInstance('bookingedit', 'BlookingModel');
			$data = array();
			$data['idcoupon']=-1;
			$data['extra_ids']="";
			$data['nguests']=1;
			$data['nchilds']=0;
			$data['valid_from']=date ("Y-m-d", strtotime($day));
			$data['valid_to']=date("Y-m-d", strtotime("+1 day", strtotime($day)));
			$data['idcategory']=$idcategory;
			$res = $bookingeditmodel->priceCalculation ($data);
			$rates = $res->daily_rates;

			//RATE
			$details .= "<span class='details_row'>";
			$details .= "<span class='details_key'>".
					JText::_("COM_BOOKIT_RATE").":</span>";
			$details .= "<span class='details_value'>".
					$rates[strtotime($day)]
					."</span>";
			$details .= "</span>";

			//RULES
			$rules="";
			if (strpos($res->idrules,","))
			{
				$ruleids = explode(",",$res->idrules);
				foreach ($ruleids as $rule)
				{
					if ($rule=="")break;
					$url = JURI::root()."administrator/index.php?option=com_blooking&controller=rules&task=edit&cid[]=".$rule;
					$rules.="<a href=".$url.">".htmlspecialchars($this->_getRuleName($rule))."</a>";
					$rules .= ", ";
				}
			}
			else if ($res->idrules!="")
			{

				$url = JURI::root()."administrator/index.php?option=com_blooking&controller=rules&task=edit&cid[]=".$res->idrules;
				$rules.="<a href=".$url.">".htmlspecialchars($this->_getRuleName($res->idrules))."</a>";
			}
			else
				$rules=JText::_('JNONE');

			//Delete last comma
			if (substr($rules, -2, 1)==",")
				$rules = substr($rules,0,-2);

			$details .= "<span class='details_row'>";
			$details .= "<span class='details_key'>".
					JText::_("COM_BOOKIT_ACTIVE_RULES").":</span>";
			$details .= "<span class='details_value'>".
					$rules."</span>";
			$details .= "</span>";

			//Other rules that maybe applying
			if ($rules==JText::_("JNONE"))
				$rules="";
				
			$other_rules = $this->_getOtherRules($data['valid_from'],
					$data['valid_to'], $rules);
			$details .= "<span class='details_row'>";
			$details .= "<span class='details_key'>".
					JText::_("COM_BOOKIT_OTHER_RULES").":</span>";
			$details .= "<span class='details_value'>".
					$other_rules."</span>";
			$details .= "</span>";


			//BOOKING
			$bd = $this->_getBookingDetails($day, $idcategory,
					$idroom);

			if ($bd!="")
			{
				$details .= "<span class='details_row'>";
				$details .= "<span class='details_booking_heading'>".
						JText::_("COM_BOOKIT_BOOKING_DETAILS").":</span>";
				$details .= "<span class='details_value'>".
						$bd."</span>";
				$details .= "</span>";
			}

		}
		else if ($idroom <= 0 && $idcategory <= 0)//HOTEL LEVEL
		{
			//Date
			$details .= "<span class='details_row'>";
			$details .= "<span class='details_key'>".
					JText::_("COM_BOOKIT_DATE").":</span>";
			$details .= "<span class='details_value'>".
					$date_in_selected_format."</span>";
			$details .= "</span>";

			//Category
			$details .= "<span class='details_row'>";
			$details .= "<span class='details_key'>".
					JText::_("COM_BOOKIT_ROOM_CATEGORY").":</span>";
			$details .= "<span class='details_value'>";
			$details.=JText::_("COM_BOOKIT_ANY")."</span>";
			$details .= "</span>";

			//Room
			$details .= "<span class='details_row'>";
			$details .= "<span class='details_key'>".
					JText::_("COM_BOOKIT_ROOM").":</span>";
			$details .= "<span class='details_value'>";
			$details.=JText::_("COM_BOOKIT_ANY")."</span>";
			$details .= "</span>";

			//State
			$r = $this->_getAvailabilityState($day, $idcategory, $idroom);
			$state=$r->state;
			$details .= "<span class='details_row'>";
			$details .= "<span class='details_key'>".
					JText::_("COM_BOOKIT_STATUS").":</span>";
			$details .= "<span class='details_value'>".
					$this->_statusToText($state)
					."</span>";
			$details .= "</span>";

			//booked rooms
			$details .= "<span class='details_row'>";
			$details .= "<span class='details_key'>".
					JText::_("COM_BOOKIT_BOOKED_ROOMS").":</span>";
			$details .= "<span class='details_value'>".
					$r->booked_rooms
					."</span>";
			$details .= "</span>";
				
			//Pending rooms
			$details .= "<span class='details_row'>";
			$details .= "<span class='details_key'>".
					JText::_("COM_BOOKIT_PENDING_ROOMS").":</span>";
			$details .= "<span class='details_value'>".
					$r->pending_rooms
					."</span>";
			$details .= "</span>";
				
			//Closed rooms
			$details .= "<span class='details_row'>";
			$details .= "<span class='details_key'>".
					JText::_("COM_BOOKIT_CLOSED_ROOMS").":</span>";
			$details .= "<span class='details_value'>".
					$r->closed_rooms
					."</span>";
			$details .= "</span>";
				
			//Available rooms
			$details .= "<span class='details_row'>";
			$details .= "<span class='details_key'>".
					JText::_("COM_BOOKIT_AVAILABLE_ROOMS").":</span>";
			$details .= "<span class='details_value'>".
					$r->available_rooms
					."</span>";
			$details .= "</span>";
				
			//BOOKING
			$bd = $this->_getBookingDetails($day, $idcategory,
					$idroom);

			if ($bd!="")
			{
				$details .= "<span class='details_row'>";
				$details .= "<span class='details_booking_heading'>".
						JText::_("COM_BOOKIT_BOOKING_DETAILS").":</span>";
				$details .= "<span class='details_value'>".
						$bd."</span>";
				$details .= "</span>";
			}


		}

		return $details;
	}

	function _getCategoryName($idcategory)
	{
		$query = "SELECT ".$this->_db->nameQuote('name')." FROM ".
				$this->_db->nameQuote('#__bookitcategory')." WHERE ".
				$this->_db->nameQuote('idcategory')." = ".$idcategory;
		$this->_db->setQuery($query);
		return $this->_db->loadResult();
	}
	function _getRoomName($idroom)
	{
		if ($idroom<=0) return JText::_("COM_BOOKIT_ANY");
		$query = "SELECT ".$this->_db->nameQuote('name')." FROM ".
				$this->_db->nameQuote('#__bookitroom')." WHERE ".
				$this->_db->nameQuote('idroom')." = ".$idroom;
		$this->_db->setQuery($query);
		return $this->_db->loadResult();
	}
	function _statusToText($no)
	{
		$status ="";
		switch ($no) {
			case 0:
				$status = JText::_('COM_BOOKIT_AVAILABLE');
				break;
			case 1:
				$status = JText::_('COM_BOOKIT_BOOKED');
				break;
			case 2:
				$status = JText::_('COM_BOOKIT_PENDING');
				break;
			case 3:
				$status = JText::_('COM_BOOKIT_CLOSED');
				break;
			default:
				$status = JText::_('COM_BOOKIT_UNKNOWN');
				break;
		}
		return $status;
	}
	function _getCategory ($idcategory)
	{
		$query = "SELECT * FROM ".
				$this->_db->nameQuote('#__bookitcategory')." WHERE ".
				$this->_db->nameQuote('idcategory')." = ".$idcategory;
		$this->_db->setQuery($query);
		return $this->_db->loadResult();
	}

	function _getRuleName($rule)
	{
		$query = "SELECT ".$this->_db->nameQuote('name')." FROM ".
				$this->_db->nameQuote('#__bookitrules')." WHERE ".
				$this->_db->nameQuote('idrule')." = ".$this->_db->quote($rule);
		$this->_db->setQuery($query);
		return $this->_db->loadResult();

	}
	function _getBookingDetails($day, $idcategory=0, $idroom=0)
	{
		$where="";
		$details="";
		if ($idcategory>0 && $idroom>0)
		{
			$where = $this->_db->nameQuote('idcategory')." = ".
					$this->_db->quote($idcategory)." AND ".
					$this->_db->nameQuote('idroom')." = ".$this->_db->quote($idroom);
		}
		else if ($idcategory>0 )
		{
			$where = $this->_db->nameQuote('idcategory')." = ".
					$this->_db->quote($idcategory);
		}
		else if ($idroom>0 )
		{
			$where = $this->_db->nameQuote('idroom')." = ".
					$this->_db->quote($idroom);
		}
		$query = "SELECT * FROM ".
				$this->_db->nameQuote('#__bookitbooking')." WHERE ".$where;
		if ($where!="")$query.=" AND ";
		$query.="(".$this->_db->nameQuote('status')." = ".
				$this->_db->quote('1')." OR ".
				$this->_db->nameQuote('status')." = ".
				$this->_db->quote('2').
				") AND ".$this->_db->quote($day)." >= ".
				$this->_db->nameQuote('valid_from').
				" AND ".$this->_db->quote($day)." < ".
				$this->_db->nameQuote('valid_to');
		$this->_db->setQuery($query);
		$res = $this->_db->loadObjectList();

		if (!isset($res)) return $details;
		$cnt=0;
		$virtual_booking="";
		foreach ($res as $booking)
		{
			if ($booking->idguests<=0)
			{
				$virtual_booking = "<span class='details_row'><a href='#v' class='info'>*<span>".
						JText::_("COM_BOOKIT_VIRTUAL_BOOKINGS_DESC")."</span></a>".
						JText::_("COM_BOOKIT_VIRTUAL_BOOKING")."</span>";
				continue;
			}

			$details .= "<span class='details_row'>";
			$details .= "<span class='details_booking_key'>".
					JText::_("COM_BOOKIT_BOOKING_ID").": </span>";
			$details .= "<span class='details_booking_value'>";
			$url = JURI::root()."administrator/index.php?option=com_blooking&controller=booking&task=edit&cid[]=".$booking->idbook;
			$details.="<a href=".$url.">".$booking->idbook."</a>";
			$details.="</span>";
			$details .= "</span>";

			$details .= "<span class='details_row'>";
			$details .= "<span class='details_booking_key'>".
					JText::_("COM_BOOKIT_BOOKING_PERIOD").":</span>";
			$details .= "<span class='details_booking_value'>"
					.date($this->_getDateFormat(),strtotime($booking->valid_from))." "
							.date($this->_getDateFormat(),strtotime($booking->valid_to));
			$details.="</span>";
			$details .= "</span>";

			$details .= "<span class='details_row'>";
			$details .= "<span class='details_booking_key'>".
					JText::_("COM_BOOKIT_STATUS").":</span>";
			$details .= "<span class='details_booking_value'>".
					$this->_getStatusName($booking->status)."</span>";
			$details .= "</span>";

			$details .= "<span class='details_row'>";
			$details .= "<span class='details_booking_key'>".
					JText::_("COM_BOOKIT_ROOM_CATEGORY").":</span>";
			$details .= "<span class='details_booking_value'>".
					$this->_getCategoryName($booking->idcategory)."</span>";
			$details .= "</span>";

			$details .= "<span class='details_row'>";
			$details .= "<span class='details_booking_key'>".
					JText::_("COM_BOOKIT_ROOM").":</span>";
			$details .= "<span class='details_booking_value'>".
					$this->_getRoomName($booking->idroom)."</span>";
			$details .= "</span>";

			$details .= "<span class='details_row'>";
			$details .= "<span class='details_booking_key'>".
					JText::_("COM_BOOKIT_GUEST").":</span>";
			$details .= "<span class='details_booking_value'>"
					.$this->_getGuestDetails($booking->idguests);
			$details.="</span>";
			$details .= "</span>";

			$details .= "<span class='details_row'>";
			$details .= "<span class='details_booking_key'>".
					JText::_("COM_BOOKIT_AMOUNT_PAID").":</span>";
			$details .= "<span class='details_booking_value'>"
					.$booking->value_paid;
			$details.="</span>";
			$details .= "</span>";

			$details .= "<span class='details_row'>";
			$details .= "<span class='details_booking_key'>".
					JText::_("COM_BOOKIT_AMOUNT_DUE").":</span>";
			$details .= "<span class='details_booking_value'>"
					.$booking->value_pending;
			$details.="</span>";
			$details .= "</span>";

			if (++$cnt >0 && $cnt<count($res))
				$details .= "<span class='details_booking_sep'></span>";
		}
		return $details.$virtual_booking;

	}

	function _getGuestDetails($id)
	{
		$result="";
			
		$query = "SELECT * FROM ".
				$this->_db->nameQuote('#__bookitguests')." WHERE ".
				$this->_db->nameQuote('idguests')." = ".
				$this->_db->quote($id);
		$this->_db->setQuery($query);
		$res = $this->_db->loadObject();

		$url = JURI::root()."administrator/index.php?option=com_blooking&controller=guests&task=edit&cid[]=".$id;
		$result=JText::_("COM_BOOKIT_ID").": <a href=".$url.">".$id."</a>";
		$result.= " ".$res->name." ".$res->surname." ".$res->email." ".$res->phone;
		return $result;
	}
	function _getStatusName($status)
	{
		$res = "";
		switch ($status) {

			case 1:
				$res = JText::_("COM_BOOKIT_CONFIRMED");
				break;
			case 2:
				$res = JText::_("COM_BOOKIT_PENDING");
				break;
			default:
				$res = JText::_("COM_BOOKIT_UNKNOWN");
				break;
		}
		return $res;
	}
	function _getCategoryIdFromRoom ($idroom)
	{
		$query = "SELECT ".$this->_db->nameQuote('idcategory')." FROM ".
				$this->_db->nameQuote('#__bookitroom')." WHERE ".
				$this->_db->nameQuote('idroom')." = ".
				$this->_db->quote($idroom);
		$this->_db->setQuery($query);
		return $this->_db->loadResult();
	}
	function _getOtherRules ($start, $end, $rules)
	{
		$res = new stdClass();
		$check="";
		if ($rules!="")
		{
			$arr = explode(",",$rules);
			foreach ($arr as $key => $link)
			{
				if ($arr[$key] == '')
				{
					unset($arr[$key]);
				}
			}
			if (!empty($arr))
			{
				$check =" AND ".$this->_db->nameQuote('idrule')." NOT IN (".
						implode(",", $arr).")";
			}
		}
		$case1 =  $this->_db->nameQuote('valid_from')." <= ".
				$this->_db->quote($start)." AND ".
				$this->_db->nameQuote('valid_to')." > ".$this->_db->quote($start);

		$case2 = $this->_db->nameQuote('valid_from')." > ".
				$this->_db->quote($start)." AND ".$this->_db->nameQuote('valid_from').
				" < ".$this->_db->quote($end);

		$case3 = $this->_db->nameQuote('valid_to')." < ".
				$this->_db->quote($end)." AND ".$this->_db->nameQuote('valid_to').
				" >= ".$this->_db->quote($start);

		$query = "SELECT name FROM ".
				$this->_db->nameQuote('#__bookitrules').
				" WHERE ( ( ".$case1.") OR (".$case2.") OR (".$case3." ) ) AND ".
				$this->_db->nameQuote('published')." = ".$this->_db->quote('1').$check;
		$this->_db->setQuery($query);
		$res = $this->_db->loadResultArray();

		$result = JText::_("JNONE");
		if (!empty($res))
		{
			$result =  implode(",",$res);
		}
		return $result;
	}
}