<?php
/**
 * BlooKing - The King in Joomla Booking
 * @version 1.0
 * @author BlooKing.org. Based on BooKiTGold code by Costas Kakousis
 * @copyright (C) 2012-2013 by BlooKing.org (http://www.blooking.org)
 * @license GNU/GPL: http://www.gnu.org/copyleft/gpl.html
 *
 * If you fork this to create your own project, please make a reference to
 * BlooKing! someplace in your code and provide a link to
 * http://www.blooking.org
 *
 * This file is part of BlooKing! BlooKing is free software: you can
 * redistribute it and/or modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * BlooKing is distributed in the hope that it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details. You should have received a copy of the GNU General Public License
 * along with BlooKing.  If not, see <http://www.gnu.org/licenses/>.
 *   ______ __                __  __ __
 *	|   __ \  |.-----..-----.|  |/  |__|.-----..-----.
 *	|   __ <  ||  _  ||  _  ||     <|  ||     ||  _  |
 *	|______/__||_____||_____||__|\__|__||__|__||___  |
 *                                             |_____|
 **/
// No direct access
defined( '_JEXEC' ) or die( 'Restricted access' );
jimport('joomla.application.component.model');

class BlookingModelBlooking extends JModel {
	function __construct() {
		parent::__construct();
		$array = JRequest::getVar('cid',  0, '', 'array');
		$this->setId((int)$array[0]);


	}

	function setId($id) {
		$this->_id		= $id;
		$this->_data	= null;
	}

	function getPendingBookingsData() {
		$db =& JFactory::getDBO();
		$sql = "SELECT pending_enabled, pending_time, pending_measure FROM #__bookitutils WHERE id='1';";
		$db->setQuery($sql);
		return $db->loadRow();
	}

	function getCurrentVersion()
	{
		if(version_compare(JVERSION,'1.6.0','ge')) {
			$db =& JFactory::getDBO();
			$sql = "SELECT ".$db->nameQuote('manifest_cache')." FROM ".
					$db->nameQuote('#__extensions')." WHERE ".$db->nameQuote("element").
					" = ".$db->quote("com_blooking");
			$db->setQuery($sql);
			$cache = $db->loadResult();
			$obj = json_decode($cache);
			return $obj->version;

		} else {
			$data = $this->_loadItems();
			if (isset($data['version']))
				return $data['version'];
			else
				return "undefined";
		}
	}
	function _loadItems()
	{
		global $mainframe, $option;

		jimport('joomla.filesystem.folder');
		$data=array();
		/* Get a database connector */
		$db =& JFactory::getDBO();

		$query = 'SELECT * FROM '.$db->nameQuote('#__components')." WHERE ".
				$db->nameQuote('name')." = ".$db->quote('BlooKing');
		$db->setQuery($query);
		$rows = $db->loadObjectList();

		/* Get the component base directory */
		$adminDir = JPATH_ADMINISTRATOR .DS. 'components';
		$siteDir = JPATH_SITE .DS. 'components';

		$numRows = count($rows);
		for($i=0;$i < $numRows; $i++)
		{
			$row =& $rows[$i];


			/* Get the component folder and list of xml files in folder */
			$folder = $adminDir.DS.$row->option;
			if (JFolder::exists($folder)) {
				$xmlFilesInDir = JFolder::files($folder, '.xml$');
			} else {
				$folder = $siteDir.DS.$row->option;
				if (JFolder::exists($folder)) {
					$xmlFilesInDir = JFolder::files($folder, '.xml$');
				} else {
					$xmlFilesInDir = null;
				}
			}

			if (count($xmlFilesInDir))
			{
				foreach ($xmlFilesInDir as $xmlfile)
				{
					if ($data = JApplicationHelper::parseXMLInstallFile($folder.DS.$xmlfile)) {

						foreach($data as $key => $value) {
							$row->$key = $value;
						}
					}
					$row->jname = JString::strtolower(str_replace(" ", "_", $row->name));
				}
			}
		}
		return $data;
	}
}