<?php
/**
 * BlooKing - The King in Joomla Booking
 * @version 1.0
 * @author BlooKing.org. Based on BooKiTGold code by Costas Kakousis
 * @copyright (C) 2012-2013 by BlooKing.org (http://www.blooking.org)
 * @license GNU/GPL: http://www.gnu.org/copyleft/gpl.html
 *
 * If you fork this to create your own project, please make a reference to
 * BlooKing! someplace in your code and provide a link to
 * http://www.blooking.org
 *
 * This file is part of BlooKing! BlooKing is free software: you can
 * redistribute it and/or modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * BlooKing is distributed in the hope that it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details. You should have received a copy of the GNU General Public License
 * along with BlooKing.  If not, see <http://www.gnu.org/licenses/>.
 *   ______ __                __  __ __
 *	|   __ \  |.-----..-----.|  |/  |__|.-----..-----.
 *	|   __ <  ||  _  ||  _  ||     <|  ||     ||  _  |
 *	|______/__||_____||_____||__|\__|__||__|__||___  |
 *                                             |_____|
 **/
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport('joomla.application.component.model');

class BlookingModelBooking extends JModel {
	var $_data = null;
	var $_total = null;
	var $_pagination = null;

	function __construct() {
		parent::__construct();
		$mainframe = JFactory::getApplication();

		$limit = $mainframe->getUserStateFromRequest('global.list.limit', 'limit', $mainframe->getCfg('list_limit'), 'int');
		$limitstart = JRequest::getVar('limitstart', 0, '', 'int');

		$limitstart = ($limit != 0 ? (floor($limitstart / $limit) * $limit) : 0);

		$this->setState('limit', $limit);
		$this->setState('limitstart', $limitstart);
	}

	function _buildQuery() {
		$confirmed = JText::_("COM_BOOKIT_CONFIRMED"); //1
		$pending = JText::_("COM_BOOKIT_PENDING"); //2
		$expired = JText::_("COM_BOOKIT_EXPIRED"); //4
		$cancelled =  JText::_("COM_BOOKIT_CANCELLED"); //5

		$db =& $this->getDBO();
		$query = 'SELECT DISTINCT '.$db->nameQuote('#__bookitbooking').'.*, CASE '.
				$db->nameQuote('#__bookitbooking').'.'.$db->nameQuote('status').
				' WHEN 1 THEN '.$db->quote($confirmed).
				' WHEN 2 THEN '.$db->quote($pending).
				' WHEN 4 THEN '.$db->quote($expired).
				' WHEN 5 THEN '.$db->quote($cancelled).
				' END AS '.$db->nameQuote('statusstr').', '.$db->nameQuote('#__bookitbooking').
				'.'.$db->nameQuote('idbook').'+1000 AS '.$db->nameQuote('refid').','.
				$db->nameQuote('#__bookitguests').'.'.$db->nameQuote('name').' AS '.
				$db->nameQuote('name').', '.$db->nameQuote('#__bookitguests').'.'.
				$db->nameQuote('surname').' AS '.$db->nameQuote('surname').', '.
				$db->nameQuote('#__bookitguests').'.'.$db->nameQuote('email').' AS '.
				$db->nameQuote('email').', '.$db->nameQuote('#__bookitroom').'.'.
				$db->nameQuote('name').' AS '.$db->nameQuote('roomname').
				' FROM '.$db->nameQuote('#__bookitbooking').', '.$db->nameQuote('#__bookitroom').', '.
				$db->nameQuote('#__bookitguests').', '.$db->nameQuote('#__bookitcategory').
				' WHERE '.
				$db->nameQuote('#__bookitguests').'.'.$db->nameQuote('idguests').' = '.
				$db->nameQuote('#__bookitbooking').'.'.$db->nameQuote('idguests').' AND '.
				$db->nameQuote('#__bookitbooking').'.'.$db->nameQuote('idroom').' = '.
				$db->nameQuote('#__bookitroom').'.'.$db->nameQuote('idroom');

		$query .= $this->_buildQueryWhere();
		$query .= $this->_buildContentOrderBy();
		return $query;
	}

	function _buildContentOrderBy() {
		$option = JRequest::getCmd('option');
		$mainframe = JFactory::getApplication();
		$db =& $this->_db;
		$orderby = '';

		$orders = array('idbook', 'refid', 'timestamp', 'valid_from', 'valid_to', 'value_full', 'value_pending',
				'name', 'surname', 'email', 'transaction_id', 'roomname', 'statusstr');
		$filter_order = $mainframe->getUserStateFromRequest($option.'filter_order','filter_order','name');
		$filter_order_Dir = $mainframe->getUserStateFromRequest($option.'filter_order_Dir','filter_order_Dir','ASC');

		if($filter_order_Dir != 'ASC' && $filter_order_Dir != 'DESC') {
			$filter_order_Dir != 'ASC';
		}

		if (!in_array($filter_order, $orders)) {
			$filter_order='valid_from';
		}

		$orderby = ' ORDER BY '.$db->nameQuote($filter_order).' '.$filter_order_Dir;

		if ($filter_order != 'valid_from') {
			$orderby .= ' , '.$db->nameQuote('valid_from');
		}

		return $orderby;
	}

	function _buildQueryWhere() {
		$filter_id = JRequest::getVar('filter_id');
		$filter_name = JRequest::getVar('filter_name');
		$name_id = JRequest::getVar('nameid');
		$filter_email = JRequest::getVar('filter_email');
		$email_id = JRequest::getVar('emailid');
		$filter_category = JRequest::getVar('filter_category');
		$category_id = JRequest::getVar('categoryid');
		$filter_room = JRequest::getVar('filter_room');
		$room_id = JRequest::getVar('roomid');
		$where = "";

		if ($filter_id > 0) {
			$filter_id = trim($filter_id);
			$filter_id = $this->_db->getEscaped($filter_id);
			$where .= ' AND '.$this->_db->nameQuote('#__bookitbooking').'.'.
					$this->_db->nameQuote('idbook').' = '.$this->_db->quote($filter_id);
		}

		if ($filter_name != "") {
			if ($name_id > 0) {
				$where .= ' AND '.$this->_db->nameQuote('#__bookitbooking').'.'.
						$this->_db->nameQuote('idguests').' = '.$this->_db->quote($name_id);
			} else {
				$filter_name = trim($filter_name);
				$filter_name = $this->_db->getEscaped($filter_name);
				$where .= 'AND (LOWER('.$this->_db->nameQuote('#__bookitguests').'.'.
						$this->_db->nameQuote('surname').') LIKE "%'.$filter_name.'%" '.
						'OR LOWER('.$this->_db->nameQuote('#__bookitguests').'.'.
						$this->_db->nameQuote('name').') LIKE "%'.$filter_name.'%")';
			}
		}

		if ($filter_email != "") {
			if ($email_id > 0) {
				$where .= ' AND '.$this->_db->nameQuote('#__bookitbooking').'.'.
						$this->_db->nameQuote('idguests').' = '.$this->_db->quote($email_id);
			} else {
				$filter_email = trim($filter_email);
				$filter_email = $this->_db->getEscaped($filter_email);
				$where .= 'AND LOWER('.$this->_db->nameQuote('#__bookitguests').'.'.
						$this->_db->nameQuote('email').') LIKE '.$this->_db->quote("%".$filter_email."%");
			}
		}

		if ($filter_category != "") {
			if ($category_id > 0) {
				$where .= ' AND '.$this->_db->nameQuote('#__bookitbooking').'.'.
						$this->_db->nameQuote('idcategory').' = '.$this->_db->quote($category_id);
			} else {
				$filter_category = trim($filter_category);
				$filter_category = $this->_db->getEscaped($filter_category);
				$where .= 'AND LOWER('.$this->_db->nameQuote('#__bookitcategory').'.'.
						$this->_db->nameQuote('name').') LIKE "%'.$filter_category.'%"';
			}
		}

		if ($filter_room != "") {
			if ($room_id > 0) {
				$where .= ' AND '.$this->_db->nameQuote('#__bookitbooking').'.'.
						$this->_db->nameQuote('idroom').' = '.$this->_db->quote($room_id);
			} else {
				$filter_room = trim($filter_room);
				$filter_room = $this->_db->getEscaped($filter_room);
				$where .= 'AND LOWER('.$this->_db->nameQuote('#__bookitroom').'.'.
						$this->_db->nameQuote('name').') LIKE "%'.$filter_room.'%"';
			}
		}


		return $where;
	}

	function getData() {


		//$this->_clearMissingGuestsBookings();
		if (empty($this->_data)) {
			$query = $this->_buildQuery();
			$this->_data = $this->_getList($query, $this->getState('limitstart'), $this->getState('limit'));
		}
		//echo $this->_db->getQuery();
		return $this->_data;
	}

	function getTotal() {
		if (empty($this->_total)) {
			$query = $this->_buildQuery();
			$this->_total = $this->_getListCount($query);
		}
		return $this->_total;
	}
	 
	function getPagination() {
		if (empty($this->_pagination)) {
			jimport('joomla.html.pagination');
			$this->_pagination = new JPagination($this->getTotal(), $this->getState('limitstart'), $this->getState('limit') );
		}
		return $this->_pagination;
	}

	function deleteExpired() {
		$db =& JFactory::getDBO();

		$delete_query =  "DELETE FROM ".
				$db->nameQuote('#__bookitbooking')." WHERE ".
				$db->nameQuote('status')."=".$db->quote('4');
		$updateavail = $db->setQuery($delete_query);
		$result = $db->query();
			
		return true;
	}

	function delete() {
		$cids = JRequest::getVar( 'cid', array(0), 'post', 'array' );
		$row =& $this->getTable('bookingedit');
		$db =& JFactory::getDBO();

		foreach($cids as $cid) {
			$query =  "SELECT ".$db->nameQuote("idcoupon")." FROM ".
					$db->nameQuote("#__bookitbooking")." WHERE ".
					$db->nameQuote("idbook")."=".$db->quote($cid);
			$db->setQuery( $query );
			$idcoupon = $db->loadResult();

			if ($idcoupon!=""&&$idcoupon>0) {
				$query = "UPDATE ".$this->_db->nameQuote('#__bookitrules')."
				 	SET ".$this->_db->nameQuote('times_used')." = ".
				 	$this->_db->nameQuote('times_used')." - 1 WHERE ".
				 	$this->_db->nameQuote('idrule')." = ".$idcoupon;
				$this->_db->setQuery( $query );
				$result = $this->_db->query();
			}

			if (!$row->delete( $cid )) {
				$this->setError( $row->getErrorMsg() );
				return false;
			}
		}
		return true;
	}

	function autocomplete($value, $type) {
		$db =& JFactory::getDBO();
		if ($type == 'name') {
			$query = 'SELECT '.$db->nameQuote('idguests').' AS '.$db->nameQuote('id').
			', CONCAT('.$db->nameQuote('name').', " ", '.$db->nameQuote('surname').
			') AS '.$db->nameQuote('value').', '.$db->nameQuote('email').' AS '.
			$db->nameQuote('info')
			.' FROM '.$db->nameQuote('#__bookitguests').' WHERE '.$db->nameQuote('name')
			.' LIKE '.$db->quote("%".$value."%").' OR '.$db->nameQuote('surname').
			' LIKE '.$db->quote("%".$value."%").' ORDER BY '.$db->nameQuote('surname');
		} else if ($type == 'email') {
			$query = 'SELECT '.$db->nameQuote('idguests').' AS '.$db->nameQuote('id').
			', '.$db->nameQuote('email').' AS '.$db->nameQuote('value').
			', CONCAT('.$db->nameQuote('name').', " ", '.$db->nameQuote('surname').
			') AS '.$db->nameQuote('info').' FROM '.$db->nameQuote('#__bookitguests').
			' WHERE '.$db->nameQuote('email').' LIKE '.$db->quote("%".$value."%").
			' ORDER BY '.$db->nameQuote('email').';';
		} else if ($type == 'roomcat') {
			$query = 'SELECT '.$db->nameQuote('idcategory').' AS '.$db->nameQuote('id').
			', '.$db->nameQuote('name').' AS '.$db->nameQuote('value').
			' FROM '.$db->nameQuote('#__bookitcategory').' WHERE '.$db->nameQuote('name').
			' LIKE '.$db->quote("%".$value."%").' ORDER BY '.$db->nameQuote('name').';';
		} else if ($type == 'roomname') {
			$query = 'SELECT '.$db->nameQuote('idroom').' AS '.$db->nameQuote('id').
			', '.$db->nameQuote('name').' AS '.$db->nameQuote('value').
			' FROM '.$db->nameQuote('#__bookitroom').
			' WHERE '.$db->nameQuote('name').' LIKE '.$db->quote("%".$value."%").
			' ORDER BY '.$db->nameQuote('name');
		}

		$db->setQuery( $query );
		return $db->loadObjectList();
	}

	function _clearMissingGuestsBookings()
	{
		$db =& JFactory::getDBO();

		$query =  "SELECT ".$db->nameQuote("idguests")." FROM ".
				$db->nameQuote("#__bookitbooking");
		$db->setQuery( $query );
		$rows = $db->loadObjectList();

		foreach ($rows as $r)
		{
			$query =  "SELECT * FROM ".
					$db->nameQuote("#__bookitguests")." WHERE ".
					$db->nameQuote("idguests")." = ".$db->quote($r->idguests);
			$db->setQuery( $query );
			$res = $db->loadResult();
			if (!$res)
			{
				$query =  "DELETE FROM ".
						$db->nameQuote("#__bookitbooking")." WHERE ".
						$db->nameQuote("idguests")." = ".$db->quote($r->idguests);
				$db->setQuery( $query );
				$db->query();
			}
		}

	}
}