<?php
/**
 * BlooKing - The King in Joomla Booking
 * @version 1.0
 * @author BlooKing.org. Based on BooKiTGold code by Costas Kakousis
 * @copyright (C) 2012-2013 by BlooKing.org (http://www.blooking.org)
 * @license GNU/GPL: http://www.gnu.org/copyleft/gpl.html
 *
 * If you fork this to create your own project, please make a reference to
 * BlooKing! someplace in your code and provide a link to
 * http://www.blooking.org
 *
 * This file is part of BlooKing! BlooKing is free software: you can
 * redistribute it and/or modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * BlooKing is distributed in the hope that it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details. You should have received a copy of the GNU General Public License
 * along with BlooKing.  If not, see <http://www.gnu.org/licenses/>.
 *   ______ __                __  __ __
 *	|   __ \  |.-----..-----.|  |/  |__|.-----..-----.
 *	|   __ <  ||  _  ||  _  ||     <|  ||     ||  _  |
 *	|______/__||_____||_____||__|\__|__||__|__||___  |
 *                                             |_____|
 **/
defined( '_JEXEC' ) or die( 'Restricted access' );
jimport('joomla.application.component.model');

class BlookingModelBookingedit extends JModel
{
	var $_data;
	var $_id;
	var $_db;
	function __construct()
	{
		parent::__construct();

		$array = JRequest::getVar('cid',  0, '', 'array');
		$this->setId((int)$array[0]);
		JLoader::register('BlookingHelper',
		JPATH_COMPONENT.'/helpers/BlookingHelper.php');
	}

	function setId($id)
	{
		// Set id and wipe data
		$this->_id		= $id;
		$this->_data	= null;
	}

	function _buildQuery()
	{
		$cid = JRequest::getVar( 'cid', array(0), 'post', 'array' );
		$id=$cid[0];
		if ($id==0)
		{
			$cid = JRequest::getVar('cid', '', 'get');
			$id = $cid[0];
		}
		$query = ' SELECT * '
				. ' FROM #__bookitbooking WHERE idbook='.$id;
		return $query;
	}


	function &getData()
	{
		// Load the data
		if (empty( $this->_data )) {
			$query = ' SELECT * FROM #__bookitbooking '.
					'  WHERE idbook = '.$this->_id;
			$this->_db->setQuery( $query );
			$this->_data = $this->_db->loadObject();
		}
		if (!$this->_data) {
			$this->_data = new stdClass();
			$this->_data->idbook = 0;
			$this->_data->idcoupon = null;
			$this->_data->idguests = null;
			$this->_data->nguests = null;
			$this->_data->value_paid = null;
			$this->_data->value_pending = null;
			$this->_data->value_full = null;
			$this->_data->valid_from = null;
			$this->_data->valid_to = null;
			$this->_data->today = null;
			$this->_data->extra_ids = null;
			$this->_data->idroom = null;
			$this->_data->idcatgeory = null;
			$this->_data->nchilds = null;
			$this->_data->preferences = null;
			$this->_data->status = null;
			$this->_data->lang = null;
			$this->_data->rule_ids = null;
			$this->_data->timestamp = null;
			$this->_data->staffnotes = null;
		}

		return $this->_data;
	}

	function getAjaxRooms ($idcategory=0)
	{

		if ($idcategory>0)
		{
			$query = ' SELECT * '
					. ' FROM '.$this->_db->nameQuote('#__bookitroom').' WHERE '
							. $this->_db->nameQuote('idcategory'). ' = '
									. $this->_db->quote($idcategory).' ORDER BY '
											. $this->_db->nameQuote('name');
		}
		else
		{
			$query = ' SELECT * '
					. ' FROM '.$this->_db->nameQuote('#__bookitroom').' ORDER BY '
							. $this->_db->nameQuote('name');
		}

		$this->_db->setQuery($query);
		$rooms = $this->_db->loadObjectList();

		$res = array ();
		$res[0] = JText::_("COM_BOOKIT_ANY");
		foreach ($rooms as $room):
		$res[$room->idroom]=$room->name;
		endforeach;

		return $res;
	}
	function store()
	{
		$row =& $this->getTable();
		$data = JRequest::get( 'post' );
		$idbook = JRequest::getVar('idbook');
		$idcoupon = JRequest::getVar('idcoupon');
		$idguests = JRequest::getVar('idguests');
		$nguests = JRequest::getVar('nguests');
		$value_paid = JRequest::getVar('value_paid');
		$value_pending = JRequest::getVar('value_pending');
		$value_full = JRequest::getVar('value_full');
		$valid_from = JRequest::getVar('valid_from');
		$valid_to = JRequest::getVar('valid_to');
		$idroom = JRequest::getVar('idroom');
		$idcategory = JRequest::getVar('idcategory');
		$status = JRequest::getVar('status');
		$lang = JRequest::getVar('lang');
		$staffnotes = JRequest::getVar('staffnotes');

		$data['staffnotes'] = trim($staffnotes);
        $data['value_deposit'] = $value_pending;
		$res['lang'] = $lang;
		$res["id"]=$idbook;
		//set session
		$session =& JFactory::getSession();
		$session->set('booking_old_values', $data, 'bookit');

		if ($idguests==""|| $idguests==0 ||$nguests==0||$value_full==0 )
		{
			$res["code"]=-1;
			return $res;
		}
		else if (!is_numeric($value_full) || !is_numeric($nguests))
		{
			$res["code"]=-1;
			return $res;
		}
		else if ($value_full<0 || $nguests<0)
		{
			$res["code"]=-1;
			return $res;
		}

		$new_valid_from = date("Y-m-d", strtotime($valid_from));
		$new_valid_to = date("Y-m-d", strtotime($valid_to));

		if ($new_valid_to <= $new_valid_from)
		{
			$res["code"]=-1;
			return $res;
		}
		else
		{
			$data['valid_from']  = $new_valid_from;
			$data['valid_to'] = $new_valid_to;
		}

		$data['today'] = date ("Y-m-d");

		$r = $this->availabilityCheck ($data);


		$res['rooms'] = $r->remaining_rooms;
		$res["query"] = $r->query;

		if ($r->remaining_rooms<=0)
			$res['code'] = 0;

		else
			$res['code']=1;


		if ($res['code']<=0)
			return $res;

		//set the room id
		if ($data['idroom']==0)
			$data['idroom'] = $r->idroom;


		if (!$row->bind($data)) {

				
			$this->setError($this->_db->getErrorMsg());
			$res["code"]=-2;
			return $res;
		}
		if (!$row->check()) {
				
			$this->setError($this->_db->getErrorMsg());
			$res["code"]=-2;
			return $res;
		}
		if (!$row->store()) {
				
			$this->setError($this->_db->getErrorMsg());
			$res["code"]=-2;
			return $res;
		}
		$res["id"]=$row->idbook;



		//Manage Coupon Rules
		$coupon_res = $this->_updateCoupons ($idbook, $idcoupon);

		if ($coupon_res < 0 )
			$res['code'] = $coupon_res;




		return $res;

	}

	//Update coupons
	function _updateCoupons ($idbook, $idcoupon)
	{

		$result=1;
		if ($idbook>0)
		{
			$query =  "SELECT ".$this->_db->nameQuote("idcoupon")." FROM ".
					$this->_db->nameQuote("#__bookitbooking")." WHERE ".
					$this->_db->nameQuote("idbook")." = ".$this->_db->quote($idbook);
			$this->_db->setQuery( $query );
			$x_idcoupon = $this->_db->loadResult();
		}
		else
		{
			$x_idcoupon = 0;
		}

		if ($idbook==0)
		{
			if ($idcoupon!=""&&$idcoupon>0)
			{

				$query = "UPDATE ".$this->_db->nameQuote('#__bookitrules')."
						SET ".$this->_db->nameQuote('times_used')." = ".
						$this->_db->nameQuote('times_used')." + 1 WHERE ".
						$this->_db->nameQuote('idrule')." = ".$idcoupon;
				$this->_db->setQuery( $query );
				$result = $this->_db->query();
			}
		}
		//2. Edit booking
		else
		{
			if ($x_idcoupon != $idcoupon)
			{
				//change an existing coupon with another one
				if ($x_idcoupon>0)
				{

					if ($idcoupon>0)
					{
						$query = "UPDATE ".
								$this->_db->nameQuote('#__bookitrules')."
										SET ".$this->_db->nameQuote('times_used')." = ".
										$this->_db->nameQuote('times_used')." + 1 WHERE ".
										$this->_db->nameQuote('idrule')." = ".$idcoupon;
						$this->_db->setQuery( $query );
						$result = $this->_db->query();

						$query = "UPDATE ".
								$this->_db->nameQuote('#__bookitrules')."
										SET ".$this->_db->nameQuote('times_used')." = ".
										$this->_db->nameQuote('times_used')." - 1 WHERE ".
										$this->_db->nameQuote('idrule')." = ".$x_idcoupon;
						$this->_db->setQuery( $query );
						$result = $this->_db->query();
					}
					else if ($idcoupon==0)
					{
						$query = "UPDATE ".
								$this->_db->nameQuote('#__bookitrules')."
										SET ".$this->_db->nameQuote('times_used')." = ".
										$this->_db->nameQuote('times_used')." - 1 WHERE ".
										$this->_db->nameQuote('idrule')." = ".$x_idcoupon;
						$this->_db->setQuery( $query );
						$result = $this->_db->query();
					}
				}
				else if ($x_idcoupon==0) //We ADD a New coupon
				{
					$query = "UPDATE ".$this->_db->nameQuote('#__bookitrules')."
							SET ".$this->_db->nameQuote('times_used')." = ".
							$this->_db->nameQuote('times_used')." + 1 WHERE ".
							$this->_db->nameQuote('idrule')." = ".$idcoupon;
					$this->_db->setQuery( $query );
					$result = $this->_db->query();

				}
			}
		}
		if (!$result) return -2;
		else return 1;
	}

	function availabilityCheck ($data)
	{

		$start= $this->_toMysqlDateFormat ($data['valid_from']);
		$end = $this->_toMysqlDateFormat($data['valid_to']);
		$res = new stdClass();

		$whereStr=" WHERE ";
		if ($data['idroom'] > 0)
		{
			$whereStr.=$this->_db->nameQuote('idroom')." = ".
					$this->_db->quote($data['idroom'])." AND ";
		}

		$whereStr.=$this->_db->nameQuote('idcategory')." = ".
				$this->_db->quote($data['idcategory'])." AND ";


		$case1 =  $this->_db->nameQuote('valid_from')." <= ".
				$this->_db->quote($start)." AND ".
				$this->_db->nameQuote('valid_to')." > ".$this->_db->quote($start);
		$case2 = $this->_db->nameQuote('valid_from')." >= ".
				$this->_db->quote($start)." AND ".$this->_db->nameQuote('valid_from').
				" < ".$this->_db->quote($end);

			
		//------Check if there is availability for the selected options---------
		//Get bookings already found for selected settings
		$query = "SELECT DISTINCT idroom FROM ".
				$this->_db->nameQuote('#__bookitbooking').$whereStr.
				"(".$this->_db->nameQuote('status')." IN(1,2,3)) AND ".
				$this->_db->nameQuote('idbook')." != ".
				$this->_db->quote($data['idbook'])." AND ".
				$this->_db->nameQuote('idroom')." != ".
				$this->_db->quote(0)." AND ( (".$case1.") OR (".$case2."))";
		$this->_db->setQuery($query);
		$rows = $this->_db->loadObjectList();
		$res->query = $query;

		if ($data['idroom'] == 0 ) //no room selected
		{
			$query = "SELECT COUNT(*) FROM ".
					$this->_db->nameQuote('#__bookitroom')." WHERE ".
					$this->_db->nameQuote('idcategory')."=".
					$this->_db->quote($data['idcategory']);
			$this->_db->setQuery($query);
			$rooms_in_selected_category = $this->_db->loadResult();

			if ($rows==null || empty($rows))
				$res->remaining_rooms= $rooms_in_selected_category;
			else
				$res->remaining_rooms = $rooms_in_selected_category -
				count($rows);

			if ($res->remaining_rooms > 0)
				$res->idroom = $this->_getRoom ($rows, $data['idcategory']);


		}
		else  //the room is selected
		{
			if (!empty($rows)) //room is booked
				$res->remaining_rooms=0;
			else
			{
				$res->idroom =  $data['idroom'];
				$res->remaining_rooms=1;
			}
		}

		return $res;
	}
	function _getRoom ($booked_rooms, $idcategory)
	{
		$rooms_array= array();
		$rooms_str="";
		foreach ($booked_rooms as $room)
		{
			array_push($rooms_array, $room->idroom);
		}
		$rooms_str = implode(',', $rooms_array);
		if ($rooms_str!="")
		{
			$query = "SELECT ".$this->_db->nameQuote('idroom')." FROM ".
					$this->_db->nameQuote('#__bookitroom')." WHERE ".
					$this->_db->nameQuote('idroom')." NOT IN (".
					$rooms_str.") AND ".$this->_db->nameQuote('idcategory')." = ".
					$this->_db->quote($idcategory);
		}
		else
		{
			$query = "SELECT ".$this->_db->nameQuote('idroom')." FROM ".
					$this->_db->nameQuote('#__bookitroom')." WHERE ".
					$this->_db->nameQuote('idcategory')." = ".
					$this->_db->quote($idcategory);
		}

		$this->_db->setQuery($query);
		return $this->_db->loadResult();

	}

	function priceCalculation ($data)
	{

		$res = new stdClass();
		$row =& $this->getTable();

		$idcoupon = $data['idcoupon'];
		$extra_ids = $data['extra_ids'];
		$nguests = $data['nguests'];
		$nchild = $data['nchilds'];
		$valid_from = $data['valid_from'];
		$valid_to = $data['valid_to'];
		$idcategory = $data['idcategory'];

		if (!isset($data['lang']))
			$data['lang']='en';
		$price = 0.00;
		$price_deviation = 0.00;

		$daily_rates = array();

		$rule_ids = "";
		$idrules = "";

		if ($idcategory<=0)
		{
			$res->daily_rates = $daily_rates;
			$res->msg = JText::_("COM_BOOKIT_PLEASE_SELECT_ROOM_CATEGORY");
			$res->price = $price;
			$res->rule_ids = $rule_ids;
			$idrules="";
			return $res;
		}


		//Get category details
		$query = "SELECT * FROM ".
				$this->_db->nameQuote('#__bookitcategory')." WHERE ".
				$this->_db->nameQuote('idcategory')." = ".
				$this->_db->quote($idcategory).";";
		$this->_db->setQuery($query);
		$category = $this->_db->loadObject();


		$special_rate_row = $this->_getSpecialRateRule ($valid_from, $valid_to);
		$special_rate_rules = $special_rate_row->rules;

		$dr = $this->_getDailyRates($valid_from, $valid_to,
				null, $category, $nguests, $nchild);
		$daily_rates = $dr->daily_rates;
		//Check for daily rates
		$daily_rate_row = $this->_getPerDayRules( $valid_from, $valid_to);
		if (count($daily_rate_row->rate)>0) //daily rates apply and not special rates
		{
			//v1.5.5
			//$max_daily_rule = $this->_getMaxDailyRule($valid_from,
			//$valid_to, $daily_rate_row->rate);
			foreach ($daily_rate_row->rate as $rule)
			{
				array_push($special_rate_rules, $rule);
			}
			//v1.5.5 end
		}

		if (!empty($special_rate_rules))//special rates apply
		{

			$rules = $this->_filterRuleByCategory ($special_rate_rules,
					$category->idcategory);

			if (!empty($rules))
			{
				$daily_res = $this->_getDailyRates($valid_from, $valid_to,
						$rules, $category, $nguests, $nchild);
				$daily_rates = $daily_res->daily_rates;
				$price = round($this->_getTotalFromDailyRates ($daily_rates));
				foreach ($rules as $rule)
				{
					$rule_name = $this->_translator($data['lang'], 'name',
							'#__bookitrules', 'idrule', $rule->idrule);
					if ($rule_ids!="" && $rule_name!="")
						$rule_ids .= ", ";
					$rule_ids .= $rule_name;
					if ($idrules!="" && $rule->idrule!="")
						$idrules .= ", ";
					$idrules .= $rule->idrule;

				}

			}

		}

		if ($price==0)
		{
			//no daily rate rules and not special rates
			if ($category->price_mode==0)//Charge per room
			{
				$price =$this->_getBasePricePerRoom ($valid_from, $valid_to,
						$category->cost);
			}
			else //charge per guest
			{
				$price =$this->_getBasePricePerGuest ($valid_from, $valid_to,
						$nguests, $nchild, $category->adult_cost,
						$category->child_cost);
			}
			$price_before = $price;

		}

		if (empty($special_rate_rules))//NO special rates apply
		{
			//set daily rates
			$daily_res = $this->_getDailyRates($valid_from, $valid_to, null,
					$category, $nguests, $nchild);
			$daily_rates = $daily_res->daily_rates;
		}

		//SPECIAL OFFERS OR EXTRA CHARGES
		//Check for over x guests rules
		$over_X_guests_offers = $this->_getOverXGuestsOffers ($valid_from,
				$valid_to, $nguests, $nchild);
		//Over X guests rules found
		if ($over_X_guests_offers->rules!=null && sizeof($over_X_guests_offers->rules)>0)
		{
			$over_x_res = $this->_getOverXGuestPriceDeviations($valid_from,
					$valid_to, $over_X_guests_offers->rules, $nguests, $nchild,
					$category, $price, $daily_rates, $idcoupon);
			$price += $over_x_res->deviations;
			$daily_rates =  $over_x_res->daily_rates;
			if ($rule_ids!="" && $over_x_res->rule_ids!="")
				$rule_ids .= ", ";
			$rule_ids.=$over_x_res->rule_ids;
			if ($idrules!=""&&$over_x_res->idrules!="")
				$idrules.=", ";
			$idrules .= $over_x_res->idrules;

		}

		//v.1.5.4.2
		//Check for under x guests rules
		$over_X_guests_offers = $this->_getUnderXGuestsOffers ($valid_from,
				$valid_to, $nguests, $nchild);

		//Over X guests rules found
		if ($over_X_guests_offers->rules!=null && sizeof($over_X_guests_offers->rules)>0)
		{

			$over_x_res = $this->_getOverXGuestPriceDeviations($valid_from,
					$valid_to, $over_X_guests_offers->rules, $nguests, $nchild,
					$category, $price, $daily_rates, $data['lang'], $rooms);

			$price += $over_x_res->deviations;
			$daily_rates =  $over_x_res->daily_rates;
			$rule_ids.=$over_x_res->rule_ids;
			$price_deviation += $over_x_res->deviations;
			$idrules .= $over_x_res->idrules;
		}//v1.5.4.2

		//v.1.5.4.3 add third param
		$over_X_days_offers = $this->_getOverXDaysOffers ($valid_from, $valid_to);
		//Over X day rules found
		if ($over_X_days_offers->rules!=null && sizeof($over_X_days_offers->rules)>0)
		{
			$over_x_res = $this->_getPriceDeviations($valid_from, $valid_to,
					$over_X_days_offers->rules, $nguests, $nchild, $category, $price,
					$daily_rates, $idcoupon);
			$price += $over_x_res->deviations;
			$daily_rates =  $over_x_res->daily_rates;
			if ($rule_ids!="" && $over_x_res->rule_ids!="")
				$rule_ids .= ", ";
			$rule_ids.=$over_x_res->rule_ids;
			if ($idrules!=""&&$over_x_res->idrules!="")
				$idrules.=", ";
			$idrules .= $over_x_res->idrules;
				
			$over_x_res = $this->_getSpecialOffers($valid_from, $valid_to,
					$over_X_days_offers->rules, $nguests, $nchild, $category, $price,
					$daily_rates, $idcoupon);
			$price += $over_x_res->deviations;
			$daily_rates =  $over_x_res->daily_rates;
			if ($rule_ids!="" && $over_x_res->rule_ids!="")
				$rule_ids .= ", ";
			$rule_ids.=$over_x_res->rule_ids;
			if ($idrules!=""&&$over_x_res->idrules!="")
				$idrules.=", ";
			$idrules .= $over_x_res->idrules;
		}

		//v.1.5.4.3
		$under_X_days_offers = $this->_getUnderXDaysOffers ($valid_from, $valid_to);
		//Under X day rules found
		if ($under_X_days_offers->rules!=null && sizeof($under_X_days_offers->rules)>0)
		{
			$over_x_res = $this->_getPriceDeviations($valid_from, $valid_to,
					$under_X_days_offers->rules, $nguests, $nchild, $category, $price,
					$daily_rates, $idcoupon);
			$price += $over_x_res->deviations;
			$daily_rates =  $over_x_res->daily_rates;
			if ($rule_ids!="" && $over_x_res->rule_ids!="")
				$rule_ids .= ", ";
			$rule_ids.=$over_x_res->rule_ids;
			if ($idrules!=""&&$over_x_res->idrules!="")
				$idrules.=", ";
			$idrules .= $over_x_res->idrules;
				
			$over_x_res = $this->_getSpecialOffers($valid_from, $valid_to,
					$under_X_days_offers->rules, $nguests, $nchild, $category, $price,
					$daily_rates, $idcoupon);
			$price += $over_x_res->deviations;
			$daily_rates =  $over_x_res->daily_rates;
			if ($rule_ids!="" && $over_x_res->rule_ids!="")
				$rule_ids .= ", ";
			$rule_ids.=$over_x_res->rule_ids;
			if ($idrules!=""&&$over_x_res->idrules!="")
				$idrules.=", ";
			$idrules .= $over_x_res->idrules;
				
		}





		//EXTRAS
		$nights = $this->_getNights($valid_from, $valid_to);
		$extras_res = $this->_getExtraServicesPriceDeviations ($extra_ids,
				$price, $nights, $nguests, $nchild);
		$price += $extras_res;


		$res->daily_rates = $daily_rates;
		$res->msg = implode(" ", $daily_rates);
		//$res->msg =$over_X_guests_offers->query;
		$res->price = $price;
		//Delete last comma
		if (substr($rule_ids, -2, 1)==",")
			$rule_ids = substr($rule_ids,0,-2);

		$res->rule_ids = $rule_ids;
		$res->idrules = $idrules;

		return $res;


	}

	function _getTotalFromDailyRates($daily_rates)
	{
		$price = 0.00;
		foreach ($daily_rates as $k=>$v)
		{
			$price += $v;
		}
		//return number_format ($price, 2, '.', '');
		return round(number_format($price, 2, '.', ''));
	}

	//-------------------------- Rules Table Queries ---------------------------
	//Get rules of Over X type that apply for the current booking
	// v1.5.4.3 added third param
	function _getOverXDaysOffers ($start, $end)
	{

		$res = new stdClass();
		$nights = $this->_getNights($start, $end);
		$start= $this->_toMysqlDateFormat ($start);
		$end = $this->_toMysqlDateFormat($end);

		$case1 =  $this->_db->nameQuote('valid_from')." <= ".
				$this->_db->quote($start)." AND ".
				$this->_db->nameQuote('valid_to')." >= ".$this->_db->quote($start);

		$case2 = $this->_db->nameQuote('valid_from')." >= ".
				$this->_db->quote($start)." AND ".$this->_db->nameQuote('valid_from').
				" < ".$this->_db->quote($end);

		$query = "SELECT * FROM ".
				$this->_db->nameQuote('#__bookitrules').
				" WHERE ( ( ".$case1.") OR (".$case2.") ) AND ".
				$this->_db->nameQuote('published')." = ".$this->_db->quote('1').
				" AND (".$this->_db->nameQuote('mode')." = ".$this->_db->quote('1').
				" OR ".$this->_db->nameQuote('mode')." = ".$this->_db->quote('2').
				") AND (".$this->_db->nameQuote('type')." = ".$this->_db->quote('2')." AND ".
				$this->_db->nameQuote('xvar')."<".$this->_db->quote($nights)."
						AND datediff(".$this->_db->quote($end).", ".
						$this->_db->nameQuote('valid_from').") > ".
						$this->_db->nameQuote('xvar').")";

		$this->_db->setQuery($query);
		$rules = $this->_db->loadObjectList();
		$res->rules = $rules;
		$res->query = $query;
		return $res;
	}
	function _getUnderXDaysOffers ($start, $end)
	{
		$res = new stdClass();
		$nights = $this->_getNights($start, $end);
		$start= $this->_toMysqlDateFormat ($start);
		$end = $this->_toMysqlDateFormat($end);

		$case1 =  $this->_db->nameQuote('valid_from')." <= ".
				$this->_db->quote($start)." AND ".
				$this->_db->nameQuote('valid_to')." >= ".$this->_db->quote($start);

		$case2 = $this->_db->nameQuote('valid_from')." >= ".
				$this->_db->quote($start)." AND ".$this->_db->nameQuote('valid_from').
				" < ".$this->_db->quote($end);

		$query = "SELECT * FROM ".
				$this->_db->nameQuote('#__bookitrules').
				" WHERE ( ( ".$case1.") OR (".$case2.") ) AND ".
				$this->_db->nameQuote('published')." = ".$this->_db->quote('1').
				" AND (".$this->_db->nameQuote('mode')." = ".$this->_db->quote('1').
				" OR ".$this->_db->nameQuote('mode')." = ".$this->_db->quote('2').
				") AND ( (".$this->_db->nameQuote('type')." = ".$this->_db->quote('6').
				" AND ".$this->_db->nameQuote('xvar').">".$this->_db->quote($nights)."))";

		$this->_db->setQuery($query);
		$rules = $this->_db->loadObjectList();
		$res->rules = $rules;
		$res->query = $query;

		return $res;
	}
	//Get rules of Over X adults/children/guests that apply for the current
	// booking
	function _getOverXGuestsOffers ($start, $end, $nguests, $nchild)
	{
		$res = new stdClass();
		$nights = $this->_getNights($start, $end);
		$start= $this->_toMysqlDateFormat ($start);
		$end = $this->_toMysqlDateFormat($end);

		$case1 =  $this->_db->nameQuote('valid_from')." <= ".
				$this->_db->quote($start)." AND ".
				$this->_db->nameQuote('valid_to')." >= ".$this->_db->quote($start);

		$case2 = $this->_db->nameQuote('valid_from')." >= ".
				$this->_db->quote($start)." AND ".$this->_db->nameQuote('valid_from').
				" < ".$this->_db->quote($end);

		$case4=$this->_db->nameQuote('type')." = ".$this->_db->quote('3').
		" AND ".$this->_db->quote($nguests)." > ".$this->_db->nameQuote('xvar');

		$case5=$this->_db->nameQuote('type')." = ".$this->_db->quote('4').
		" AND ".$this->_db->quote($nchild)." > ".$this->_db->nameQuote('xvar');

		$case6=$this->_db->nameQuote('type')." = ".$this->_db->quote('5').
		" AND ".$this->_db->quote($nchild+$nguests)." > ".
		$this->_db->nameQuote('xvar');

		$query = "SELECT * FROM ".
				$this->_db->nameQuote('#__bookitrules').
				" WHERE ( ( ".$case1.") OR (".$case2.") ) AND ".
				$this->_db->nameQuote('published')." = ".$this->_db->quote('1').
				" AND (".$this->_db->nameQuote('mode')." = ".$this->_db->quote('1').
				" OR ".$this->_db->nameQuote('mode')." = ".$this->_db->quote('2').
				") AND ((".$case4.") OR (".$case5.") OR (".$case6."))";

		$this->_db->setQuery($query);
		$rules = $this->_db->loadObjectList();
		$res->rules = $rules;
		$res->query = $query;

		return $res;
	}
	//Get rules of Daily Rate type that apply for the current booking
	function _getPerDayRules ($start, $end)
	{
		$res = new stdClass();
		$nights = $this->_getNights($start, $end);
		$start= $this->_toMysqlDateFormat ($start);
		$end = $this->_toMysqlDateFormat($end);


		$case1 =  $this->_db->nameQuote('valid_from')." <= ".
				$this->_db->quote($start)." AND ".
				$this->_db->nameQuote('valid_to')." >= ".$this->_db->quote($start);

		$case2 = $this->_db->nameQuote('valid_from')." >= ".
				$this->_db->quote($start)." AND ".$this->_db->nameQuote('valid_from').
				" < ".$this->_db->quote($end);

		$query = "SELECT * FROM ".
				$this->_db->nameQuote('#__bookitrules').
				" WHERE ( ( ".$case1.") OR (".$case2.") ) AND ".
				$this->_db->nameQuote('published')." = ".$this->_db->quote('1')." AND ".
				$this->_db->nameQuote('mode')." = ".$this->_db->quote('0')." AND ".
				$this->_db->nameQuote('type')." = ".$this->_db->quote('1');

		$this->_db->setQuery($query);
		$rate = $this->_db->loadObjectList();
		//get only those rules that the selected days are found in the range

		if ($this->_getNights($start, $end)>6)
		{
			$res->rate = $rate;
			return $res;
		}
		else
		{
			$days = array();
			$start = strtotime($start);
			$end = strtotime($end);
			while ($start < $end) {
				array_push($days, date('w',$start));
				$start = strtotime('+1 day', $start);
			}

			for ($i=0; $i<count($rate); $i++)
			{
				$sd = $rate[$i]->selected_days;
				$sd_arr = explode(",",$sd);
				$found = false;
				foreach ($days as $day)
				{
					if ($sd_arr[$day]=="1")
					{

						$found=true;
						break;
					}
				}
				if (!$found)
				{
					unset($rate[$i]);
				}

			}
		}

		$res->rate = $rate;
		return $res;
	}
	//Get rules of Periodic rate type (weekly, monthly, etc) that apply for the
	// current booking
	function _getSpecialRateRule ($start, $end)
	{
		$res = new stdClass();
		$nights = $this->_getNights($start, $end);
		$start= $this->_toMysqlDateFormat ($start);
		$end = $this->_toMysqlDateFormat($end);

		$case1 =  $this->_db->nameQuote('valid_from')." <= ".
				$this->_db->quote($start)." AND ".
				$this->_db->nameQuote('valid_to')." >= ".$this->_db->quote($start).
				" AND datediff(".$this->_db->quote($end).", ".
				$this->_db->quote($start).") >= ".$this->_db->nameQuote('xvar');

		$case2 = $this->_db->nameQuote('valid_from')." > ".
				$this->_db->quote($start)." AND ".$this->_db->nameQuote('valid_from').
				" < ".$this->_db->quote($end).
				" AND datediff(".$this->_db->quote($end).", ".
				$this->_db->nameQuote('valid_from').") >= ".$this->_db->nameQuote('xvar');

		$case3 = $this->_db->nameQuote('valid_to')." < ".
				$this->_db->quote($end)." AND ".$this->_db->nameQuote('valid_to').
				" >= ".$this->_db->quote($start).
				" AND datediff(".$this->_db->nameQuote('valid_to').", ".
				$this->_db->quote($start).") >= ".$this->_db->nameQuote('xvar');

		$query = "SELECT * FROM ".
				$this->_db->nameQuote('#__bookitrules').
				" WHERE ".
				$this->_db->quote($nights)." >= ".
				$this->_db->nameQuote("xvar")." AND
						( ( ".$case1.") OR (".$case2.") OR (".$case3.") ) AND ".
						$this->_db->nameQuote('published')." = ".$this->_db->quote('1')." AND ".
						$this->_db->nameQuote('mode')." = ".$this->_db->quote('0')." AND ".
						$this->_db->nameQuote('type')." = ".$this->_db->quote('0')." ORDER BY ".
						$this->_db->nameQuote('xvar')." DESC";

		$this->_db->setQuery($query);
		$rate = $this->_db->loadObject();
		$res->rules = $this->_db->loadObjectList();
		$res->rate = $rate;
		$res->query = $query;
		return $res;
	}

	// v.1.5.4.2	7=under_x_adults , 8=under_x_children 9=under_x_guest
	function _getUnderXGuestsOffers ($start, $end, $nguests, $nchild)
	{
		$res = new stdClass();
		$nights = $this->_getNights($start, $end);
		$start= $this->_toMysqlDateFormat ($start);
		$end = $this->_toMysqlDateFormat($end);

		$case1 =  $this->_db->nameQuote('valid_from')." <= ".
				$this->_db->quote($start)." AND ".
				$this->_db->nameQuote('valid_to')." >= ".$this->_db->quote($start);

		$case2 = $this->_db->nameQuote('valid_from')." >= ".
				$this->_db->quote($start)." AND ".$this->_db->nameQuote('valid_from').
				" < ".$this->_db->quote($end);

		$case4=$this->_db->nameQuote('type')." = ".$this->_db->quote('7').
		" AND ".$this->_db->quote($nguests)." < ".$this->_db->nameQuote('xvar');

		$case5=$this->_db->nameQuote('type')." = ".$this->_db->quote('8').
		" AND ".$this->_db->quote($nchild)." < ".$this->_db->nameQuote('xvar');

		$case6=$this->_db->nameQuote('type')." = ".$this->_db->quote('9').
		" AND ".$this->_db->quote($nchild+$nguests)." < ".
		$this->_db->nameQuote('xvar');

		$query = "SELECT * FROM ".
				$this->_db->nameQuote('#__bookitrules').
				" WHERE ( ( ".$case1.") OR (".$case2.") ) AND ".
				$this->_db->nameQuote('published')." = ".$this->_db->quote('1')." AND ".
				$this->_db->nameQuote('coupon')." = ".$this->_db->quote('0').
				" AND (".$this->_db->nameQuote('mode')." = ".$this->_db->quote('1').
				" OR ".$this->_db->nameQuote('mode')." = ".$this->_db->quote('2').
				") AND ((".$case4.") OR (".$case5.") OR (".$case6."))";

		$this->_db->setQuery($query);
		$rules = $this->_db->loadObjectList();
		$res->rules = $rules;
		$res->query = $query;

		return $res;
	}

	function _getSpecialOffers ($valid_from, $valid_to, $rules, $nguests,
			$nchild, $category, $price, $daily_rates, $idcoupon)
	{
		$cost = $category->cost;
		$adult_cost = $category->adult_cost;
		$child_cost = $category->child_cost;
		$res = new stdClass();
		$nights = $this->_getNights($valid_from, $valid_to);

		$price_deviation=0.00;
		$rule_ids="";
		$idrules="";

		foreach ($rules as $rule)
		{
			$rule = $this->_filterRuleByCategory($rule,	$category->idcategory);
			if (!isset($rule)) continue;

			$rule = $this->_filterRuleByCoupon($rule, $idcoupon);
			if (!isset($rule)) continue;

			if ($rule_ids!="" && $rule->name!="")
				$rule_ids .= ", ";
			$rule_ids .= $rule->name;
			if($idrules!=""&&$rule->idrule!="")
				$idrules.=", ";
			$idrules .= $rule->idrule;
			if ($rule->apply_on==0) //Apply the offer/charge on total amount
			{
				if ($rule->price_mode==0)//Charge per room
				{
					if ($rule->value_mode==0) //fixed
					{
						if ($rule->mode==1) //offer
						{
							$price_deviation -= $rule->value;
						}
					}
					else //Percentage
					{
						if ($rule->mode==1) //offer
						{
							$price_deviation -= $price*$rule->value*0.01;
						}
					}
				}
				else //charge per guest
				{
					if ($rule->value_mode==0) //fixed
					{
						if ($rule->mode==1) //offer
						{
							$price_deviation -= $rule->value*$nguests +
							$rule->value_child*$nchild;
						}
					}
					else //Percentage
					{
						if ($rule->mode==1) //offer
						{
							$price_deviation -=
							($price*$rule->value*0.01*$nguests) +
							($price*$rule->value_child*0.01* $nchild);
						}
					}
				}
			}
			else //Apply the offer/charge on daily rate
			{
				$start = strtotime($this->_toMysqlDateFormat ($valid_from));
				$end = strtotime($this->_toMysqlDateFormat ($valid_to));
				$rule_start = strtotime($rule->valid_from);
				$rule_end = strtotime($rule->valid_to);

				$cnt=1;
				do
				{
						
					if ( ($start < $rule_start || $start > $rule_end)||
							($rule->type==2 && $cnt <= $rule->xvar )||
							($rule->type==6 && $cnt >= $rule->xvar )) //v1.5.4.3
					{
						$cnt++;
						$start = strtotime('+1 day',$start);
						continue;
					}
					if ($rule->price_mode==0)//Charge per room
					{
						if ($rule->value_mode==0) //fixed
						{
							if ($rule->mode==1) //offer
							{
								$price_deviation -= $rule->value;
								$daily_rates[$start] -= $rule->value;
							}
						}
						else //Percentage
						{
							if ($rule->mode==1) //offer
							{
								$price_deviation -=
								$daily_rates[$start]*$rule->value*0.01;
								$daily_rates[$start] -=
								$daily_rates[$start]*$rule->value*0.01;
							}
						}
					}
					else //charge per guest
					{
						if ($rule->value_mode==0) //fixed
						{
							if ($rule->mode==1) //offer
							{
								$price_deviation -= $rule->value*$nguests +
								$rule->value_child*$nchild;

								$daily_rates[$start] -= $rule->value*$nguests +
								$rule->value_child*$nchild;
							}
						}
						else //Percentage
						{
							if ($rule->mode==1) //offer
							{
								$price_deviation -=	($rule->value*0.01*
										$daily_rates[$start]*$nguests) +
										($rule->value_child*0.01*$daily_rates[$start]*
												$nchild);

								$daily_rates[$start] -=	($rule->value*0.01*
										$daily_rates[$start]*$nguests) +
										($rule->value_child*0.01*$daily_rates[$start]*
												$nchild);
							}
						}
					}
					$cnt++;
					$start = strtotime('+1 day',$start);
				} while ($start < $end);
			}
		}
		$res->deviations = $price_deviation;
		$res->daily_rates = $daily_rates;
		$res->rule_ids = $rule_ids;
		$res->idrules = $idrules;
		return $res;
	}

	function _getPriceDeviations ($valid_from, $valid_to, $rules, $nguests,
			$nchild, $category, $price, $daily_rates, $idcoupon)
	{
		$cost = $category->cost;
		$adult_cost = $category->adult_cost;
		$child_cost = $category->child_cost;
		$res = new stdClass();
		$nights = $this->_getNights($valid_from, $valid_to);

		$price_deviation=0.00;
		$rule_ids="";
		$idrules="";

		foreach ($rules as $rule)
		{
			$rule = $this->_filterRuleByCategory($rule,	$category->idcategory);
			if (!isset($rule)) continue;

			$rule = $this->_filterRuleByCoupon($rule, $idcoupon);
			if (!isset($rule)) continue;

			if ($rule_ids!="" && $rule->name!="")
				$rule_ids .= ", ";
			$rule_ids .= $rule->name;
			if($idrules!=""&&$rule->idrule!="")
				$idrules.=", ";
			$idrules .= $rule->idrule;
			if ($rule->apply_on==0) //Apply the offer/charge on total amount
			{
				if ($rule->price_mode==0)//Charge per room
				{
					if ($rule->value_mode==0) //fixed
					{
						if ($rule->mode==2) //extra charge
						{
							$price_deviation += $rule->value;
						}
					}
					else //Percentage
					{
						if ($rule->mode==2) //extra charge
						{
							$price_deviation += $price*$rule->value*0.01;
						}
					}
				}
				else //charge per guest
				{
					if ($rule->value_mode==0) //fixed
					{
						if ($rule->mode==2) //extra charge
						{
							$price_deviation += $rule->value*$nguests +
							$rule->value_child*$nchild;
						}
					}
					else //Percentage
					{
						if ($rule->mode==2) //extra charge
						{
							$price_deviation +=
							($price*$rule->value*0.01*$nguests) +
							($price*$rule->value_child*0.01* $nchild);
						}
					}
				}
			}
			else //Apply the offer/charge on daily rate
			{
				$start = strtotime($this->_toMysqlDateFormat ($valid_from));
				$end = strtotime($this->_toMysqlDateFormat ($valid_to));
				$rule_start = strtotime($rule->valid_from);
				$rule_end = strtotime($rule->valid_to);

				$cnt=1;
				do
				{
						
					if ( ($start < $rule_start || $start > $rule_end)||
							($rule->type==2 && $cnt <= $rule->xvar )||
							($rule->type==6 && $cnt >= $rule->xvar )) //v1.5.4.3
					{
						$cnt++;
						$start = strtotime('+1 day',$start);
						continue;
					}
					if ($rule->price_mode==0)//Charge per room
					{
						if ($rule->value_mode==0) //fixed
						{
							if ($rule->mode==2) //extra charge
							{
								$price_deviation += $rule->value;
								$daily_rates[$start] += $rule->value;
							}
						}
						else //Percentage
						{
							if ($rule->mode==2) //extra charge
							{
								$price_deviation +=
								$daily_rates[$start]*$rule->value*0.01;
								$daily_rates[$start] +=
								$daily_rates[$start]*$rule->value*0.01;
							}
						}
					}
					else //charge per guest
					{
						if ($rule->value_mode==0) //fixed
						{
							if ($rule->mode==2) //extra charge
							{
								$price_deviation += $rule->value*$nguests +
								$rule->value_child*$nchild;

								$daily_rates[$start] += $rule->value*$nguests +
								$rule->value_child*$nchild;
							}
						}
						else //Percentage
						{
							if ($rule->mode==2) //extra charge
							{
								$price_deviation += ($rule->value*0.01*
										$daily_rates[$start]*$nguests) +
										($rule->value_child*0.01*$daily_rates[$start]*
												$nchild);

								$daily_rates[$start] +=	($rule->value*0.01*
										$daily_rates[$start]*$nguests) +
										($rule->value_child*0.01*$daily_rates[$start]*
												$nchild);
							}
						}
					}
					$cnt++;
					$start = strtotime('+1 day',$start);
				} while ($start < $end);
			}
		}
		$res->deviations = $price_deviation;
		$res->daily_rates = $daily_rates;
		$res->rule_ids = $rule_ids;
		$res->idrules = $idrules;
		return $res;
	}

	function _getOverXGuestPriceDeviations ($valid_from, $valid_to, $rules,
			$nguests, $nchild, $category, $price, $daily_rates, $idcoupon)
	{
		$cost = $category->cost;
		$adult_cost = $category->adult_cost;
		$child_cost = $category->child_cost;

		$res = new stdClass();
		$nights = $this->_getNights($valid_from, $valid_to);

		$price_deviation=0.00;
		$rule_ids="";
		$idrules="";

		foreach ($rules as $rule)
		{
			$rule = $this->_filterRuleByCategory($rule,	$category->idcategory);
			if (!isset($rule)) continue;

			$rule = $this->_filterRuleByCoupon($rule, $idcoupon);
			if (!isset($rule)) continue;

			if ($rule_ids!="" && $rule->name!="")
				$rule_ids .= ", ";
			$rule_ids .= $rule->name;
			if ($idrules!=""&&$rule->idrule!="")
				$idrules.=", ";
			$idrules .= $rule->idrule;
			switch ($rule->type)
			{
				case 3:
					$new_nguests = abs($nguests-$rule->xvar); //abs added in v.1.5.4.2
					break;
				case 4:
					$new_nchild = abs($nchild-$rule->xvar); //abs added in v.1.5.4.2
					break;
				case 5:
					$new_nguests = abs(($nguests+$nchild-$rule->xvar)); //abs added in v.1.5.4.2
					break;
				default:
					$new_nguests = $nguests;
					$new_nchild = $nchild;
					break;
			}
			if ($rule->apply_on==0) //Apply the offer/charge on total amount
			{
				if ($rule->price_mode==0)//Charge per room
				{
					if ($rule->value_mode==0) //fixed
					{
						if ($rule->mode==1) //offer
						{
							$price_deviation -= $rule->value;
						}
						else if ($rule->mode==2) //extra charge
						{
							$price_deviation += $rule->value;
						}
					}
					else //Percentage
					{
						if ($rule->mode==1) //offer
						{
							$price_deviation -= $price*$rule->value*0.01;
						}
						else if ($rule->mode==2) //extra charge
						{
							$price_deviation += $price*$rule->value*0.01;
						}
					}
				}
				else //charge per guest
				{
					if ($rule->value_mode==0) //fixed
					{
						if ($rule->mode==1) //offer
						{
							if ($rule->type==3 || $rule->type==5 ||
									$rule->type==7 || $rule->type==9)//v1.5.7.1
								$price_deviation -= $rule->value*$new_nguests;
							else if ($rule->type==4 || $rule->type==8)//v1.5.7.1
								$price_deviation -= $rule->value_child*$new_nchild;
						}
						else if ($rule->mode==2) //extra charge
						{
							if ($rule->type==3 || $rule->type==5 ||
									$rule->type==7 || $rule->type==9)//v1.5.7.1
								$price_deviation += $rule->value*$new_nguests;
							else if ($rule->type==4 || $rule->type==8)//v1.5.7.1
								$price_deviation += $rule->value_child*$new_nchild;
						}
					}
					else //Percentage
					{
						if ($rule->mode==1) //offer
						{
							if ($rule->type==3 || $rule->type==5 ||
									$rule->type==7 || $rule->type==9)//v1.5.7.1
								$price_deviation -=
								($price*$rule->value*0.01*$new_nguests);
							else if ($rule->type==4 || $rule->type==8)//v1.5.7.1
								$price_deviation -=
								($price*$rule->value_child*0.01*$new_nchild);
						}
						else if ($rule->mode==2) //extra charge
						{
							if ($rule->type==3 || $rule->type==5 ||
									$rule->type==7 || $rule->type==9)//v1.5.7.1
								$price_deviation +=
								($price*$rule->value*0.01*$new_nguests);
							else if ($rule->type==4 || $rule->type==8)//v1.5.7.1
								$price_deviation +=
								($price*$rule->value_child*0.01*$new_nchild);
						}

					}
				}
			}
			else //Apply the offer/charge on daily rates
			{
				$start = strtotime($this->_toMysqlDateFormat ($valid_from));
				$end = strtotime($this->_toMysqlDateFormat ($valid_to));
				$rule_start = strtotime($rule->valid_from);
				$rule_end = strtotime($rule->valid_to);

				do
				{
					if ( $start < $rule_start || $start > $rule_end)
					{
						$start = strtotime('+1 day',$start);
						continue;
					}
					if ($rule->price_mode==0)//Charge per room
					{
						if ($rule->value_mode==0) //fixed
						{
							if ($rule->mode==1) //offer
							{
								$price_deviation -= $rule->value;
								$daily_rates[$start] -= $rule->value;
							}
							else if ($rule->mode==2) //extra charge
							{
								$price_deviation += $rule->value;
								$daily_rates[$start] += $rule->value;
							}
						}
						else //Percentage
						{
							if ($rule->mode==1) //offer
							{
								$price_deviation -=
								$daily_rates[$start]*$rule->value*0.01;
								$daily_rates[$start] -=
								$daily_rates[$start]*$rule->value*0.01;
							}
							else if ($rule->mode==2) //extra charge
							{
								$price_deviation +=
								$daily_rates[$start]*$rule->value*0.01;
								$daily_rates[$start] +=
								$daily_rates[$start]*$rule->value*0.01;
							}
						}
					}
					else //charge per guest
					{
						if ($rule->value_mode==0) //fixed
						{
							if ($rule->mode==1) //offer
							{
								if ($rule->type==3 || $rule->type==5 ||
										$rule->type==7 || $rule->type==9)//v1.5.7.1
								{
									$price_deviation -=
									$rule->value*$new_nguests;
									$daily_rates[$start] -=
									$rule->value*$new_nguests;
								}
								else if ($rule->type==4 || $rule->type==8)//v1.5.7.1
								{
									$price_deviation -=
									$rule->value_child*$new_nchild;
									$daily_rates[$start] -=
									$rule->value_child*$new_nchild;
								}
							}
							else if ($rule->mode==2) //extra charge
							{
								if ($rule->type==3 || $rule->type==5 ||
										$rule->type==7 || $rule->type==9)//v1.5.7.1
								{
									$price_deviation +=
									$rule->value*$new_nguests;
									$daily_rates[$start] +=
									$rule->value*$new_nguests;
								}
								else if ($rule->type==4 || $rule->type==8)//v1.5.7.1
								{
									$price_deviation +=
									$rule->value_child*$new_nchild;
									$daily_rates[$start] +=
									$rule->value_child*$new_nchild;
								}
							}
						}
						else //Percentage
						{
							if ($rule->mode==1) //offer
							{
								if ($rule->type==3 || $rule->type==5 ||
										$rule->type==7 || $rule->type==9)//v1.5.7.1
								{

									$price_deviation -= $rule->value*0.01*
									($daily_rates[$start]/($nguests+$nchild))*$new_nguests;
									$daily_rates[$start] -=	$rule->value*0.01*
									($daily_rates[$start]/($nguests+$nchild)) *$new_nguests;

								}
								else if ($rule->type==4 || $rule->type==8)//v1.5.7.1
								{
									$price_deviation -=
									$rule->value_child*0.01*
									($daily_rates[$start]/($nguests+$nchild))*$new_nchild;
									$daily_rates[$start] -=
									$rule->value_child*0.01*
									($daily_rates[$start]/($nguests+$nchild))*$new_nchild;
								}

							}
							else if ($rule->mode==2) //extra charge
							{
								if ($rule->type==3 || $rule->type==5 ||
										$rule->type==7 || $rule->type==9)//v1.5.7.1
								{
									$price_deviation += $rule->value*0.01*
									($daily_rates[$start]/($nguests+$nchild))*$new_nguests;
									$daily_rates[$start] +=	$rule->value*0.01*
									($daily_rates[$start]/($nguests+$nchild))*$new_nguests;
								}
								else if ($rule->type==4 || $rule->type==8)//v1.5.7.1
								{
									$price_deviation +=
									$rule->value_child*0.01*
									($daily_rates[$start]/($nguests+$nchild))*$new_nchild;
									$daily_rates[$start] +=
									$rule->value_child*0.01*
									($daily_rates[$start]/($nguests+$nchild))*$new_nchild;
								}
							}
						}
					}
					$start = strtotime('+1 day',$start);
				} while ($start < $end);
			}
		}
		$res->deviations = $price_deviation;
		$res->daily_rates = $daily_rates;
		$res->rule_ids = $rule_ids;
		$res->idrules = $idrules;
		return $res;
	}


	function _getMaxDailyRule ($valid_from, $valid_to, $rules )
	{
		$valid_from = strtotime($this->_toMysqlDateFormat ($valid_from));
		$valid_to = strtotime($this->_toMysqlDateFormat($valid_to));
		$max_period=0;
		$selected_rule = $rules[0];
			
		foreach ($rules as $rule)
		{
			$rule_valid_from = strtotime($rule->valid_from);
			$rule_valid_to = strtotime($rule->valid_to);

			if ($rule_valid_from <= $valid_from &&
					$rule_valid_to >= $valid_to) //case 3
			{
				return $rule;
			}
			else if ($rule_valid_from >= $valid_from &&
					$rule_valid_from >= $valid_to) //case 1
			{
				$period = $valid_to - $rule_valid_from;
				if ($period > $max_period)
				{
					$selected_rule = $rule;
					$max_period = $period;
				}
			}
			else if ($rule_valid_to >= $valid_from &&
					$rule_valid_to <= $valid_to) //case 2
			{
				$period = $rule_valid_to - $valid_from;
				if ($period > $max_period)
				{
					$selected_rule = $rule;
					$max_period = $period;
				}
			}
		}
		return $selected_rule;
	}

	//------------------------ Daily Rates Helper methods ----------------------
	function _getDailyRates ($valid_from, $valid_to, $rules, $category,
			$nguests, $nchild)
	{
		$price_mode = $category->price_mode;
		$cost = $category->cost;
		$adult_cost = $category->adult_cost;
		$child_cost = $category->child_cost;

		$res = new stdClass();
		$daily_rates = array();
		$price=0.00;

		if ($rules==null)
		{
			$start = strtotime($this->_toMysqlDateFormat ($valid_from));
			$end = strtotime($this->_toMysqlDateFormat ($valid_to));
			do
			{
				if ($price_mode==0)//Charge per room
				{
					$daily_rates[$start] = $cost;
				}
				else
				{
					$daily_rates[$start] = ($adult_cost * $nguests) +
					($child_cost * $nchild);
				}

				$start = strtotime('+1 day',$start);
			} while ($start < $end);
		}
		else
		{
			$start = strtotime($this->_toMysqlDateFormat ($valid_from));
			$end = strtotime($this->_toMysqlDateFormat ($valid_to));
			$rule_cnts = array();
			foreach ($rules as $rule)
			{
				$rule_cnts[$rule->name]=1;
			}
			while ($start < $end)
			{

				foreach ($rules as $rule)
				{
					$rule_start = strtotime($rule->valid_from);
					$rule_end = strtotime($rule->valid_to);
					//the rule does not apply go to the next one
					if ($start < $rule_start || $start > $rule_end)
						continue;


					if ($rule->type==1)  //Daily rates
					{

						$days = explode (",",$rule->selected_days);

						//check if rule is active on this day and daily rate applies for
						//this day of the week
						if ($start >= $rule_start && $start <= $rule_end
								&& $days[date("w", $start)]==1)
						{

							if ($price_mode==0)//Charge per room
							{
								$daily_rates[$start] = $rule->value;
								$price += $rule->value;
							}
							else
							{
								$daily_rates[$start] = ($rule->value * $nguests) +
								($rule->value_child * $nchild);
								$price +=  $rule->value * $nguests;
								$price +=  ($rule->value_child * $nchild);
							}
						}
						else //v1.5.5
						{
							if (!isset($daily_rates[$start]))
								$daily_rates[$start]=0;
						}
					}
					else if ($rule->type==0)  //Special rates
					{

						//On this day a special rate applies
						if (( $start >= $rule_start && $start <= $rule_end) &&
								($rule->xvar > 0) )
						{

							if ($rule_cnts[$rule->name] % $rule->xvar == 0)
							{


								if ($price_mode==0)//Charge per room
								{
									$daily_rates[$start] = $rule->value;
									$go_back = $start;
									while ($go_back > strtotime("-".$rule->xvar." day",$start))
									{
										$daily_rates[$go_back] =
										number_format ($rule->value/$rule->xvar,
												2, '.', '');
										$go_back = strtotime("-1 day",$go_back);
									}

								}
								else
								{
									$daily_rates[$start] =  ($rule->value * $nguests) +
									($rule->value_child * $nchild);
									$x =  ($rule->value * $nguests) +
									($rule->value_child * $nchild);
									$go_back = $start;
									while ($go_back > strtotime("-".$rule->xvar." day",$start))
									{
										$daily_rates[$go_back] =
										number_format ( $x/$rule->xvar, 2, '.', '');
										$go_back = strtotime("-1 day",$go_back);
									}

								}

							}
							else
							{
								// apply the standard rate
								if ($price_mode==0)//Charge per room
								{
									$daily_rates[$start] = number_format ($cost, 2, '.', '');
								}
								else
								{
									$daily_rates[$start] =
									number_format (($adult_cost * $nguests) +
											($child_cost * $nchild), 2, '.', '');
								}
							}
							$rule_cnts[$rule->name] += 1;


						}
						else
						{
							// apply the standard rate
							if ($price_mode==0)//Charge per room
							{
								$daily_rates[$start] = number_format ($cost, 2, '.', '');
							}
							else
							{
								$daily_rates[$start] =
								number_format (($adult_cost * $nguests) +
										($child_cost * $nchild), 2, '.', '');
							}
						}

					}
				}
				if (!isset($daily_rates[$start]))
				{
					// apply the standard rate
					if ($price_mode==0)//Charge per room
					{
						$daily_rates[$start] = number_format ($cost, 2, '.', '');
					}
					else
					{
						$daily_rates[$start] =
						number_format (($adult_cost * $nguests) +
								($child_cost * $nchild), 2, '.', '');
					}

				}

				$start = strtotime('+1 day',$start);
			}

		}

		//v1.5.5 fill the gaps
		$start = strtotime($this->_toMysqlDateFormat ($valid_from));
		$end = strtotime($this->_toMysqlDateFormat ($valid_to));
		while ($start < $end)
		{
			if ($daily_rates[$start] > 0)
			{
				$start = strtotime('+1 day',$start);
				continue;
			}
			else
			{
				if ($price_mode==0)//Charge per room
				{
					$daily_rates[$start] = $cost;
					$price += $cost;
				}
				else
				{
					$daily_rates[$start] = ($adult_cost * $nguests) +
					($child_cost * $nchild);
					$price += ($adult_cost * $nguests) +
					($child_cost * $nchild);
				}
			}
			$start = strtotime('+1 day',$start);
		}

		$res->daily_rates = $daily_rates;
		$res->price = number_format ( $price, 2, '.', '');
		return $res;
	}

	function _getPeriodicRate ($valid_from, $valid_to, $rule, $category,
			$nguests, $nchild)
	{
		$price_mode = $category->price_mode;
		$cost =  $category->cost;
		$adult_cost = $category->adult_cost;
		$child_cost = $category->child_cost;

		$price = 0.00;
		$nights = $this->_getNights($valid_from, $valid_to);
		if ($rule->xvar<=0)$rule->xvar=1;
		$times = floor($nights / $rule->xvar);
		if ($times<1) return;

		if ($price_mode==0)//Charge per room
		{
			$price = $rule->value * $times;
		}
		else
		{
			$price = $rule->value * $nguests * $times;
			$price += $rule->value_child * $nchild * $times;
		}
		//Apply the regular rate for remaining nights
		for ($i=0; $i<($nights%$rule->xvar); $i++)
		{
			if ($price_mode==0)//Charge per room
			{
				$price += $cost;
			}
			else
			{
				$price += $adult_cost * $nguests;
				$price += $child_cost * $nchild;
			}
		}
		return number_format ($price, 2, '.', '');
	}

	function _getBasePricePerRoom ($from, $to, $rate)
	{
		$nights = $this->_getNights($from, $to);
		return number_format($nights*$rate, 2, '.', '');
	}

	function _getBasePricePerGuest ($from, $to, $adults, $children,
			$adults_rate, $children_rate)
	{
		$nights = $this->_getNights($from, $to);
		$adults_cost =  $nights*$adults_rate*$adults;
		$children_cost =  $nights*$children_rate*$children;
		return number_format($adults_cost+$children_cost, 2, '.', '');
	}

	//------------------------------Extra ervices-------------------------------
	function _getExtraServicesPriceDeviations ($extra_ids, $price, $nights,
			$nguests, $nchilds)
	{
		if ($extra_ids=="" || $extra_ids<0) return 0.00;

		$res=0.00;
		$qnt=0;
		$extr_id_arr = explode(",", $extra_ids);
		foreach ($extr_id_arr as $extra_id)
		{
			$r = explode("-", $extra_id);
			if (count($r)>1)
			{
				$extra_id=$r['0'];
				$qnt=$r['1'];
			}
			else
				$qnt=0;

			$extra = $this->_getExtraById($extra_id);
			/*
			 * `value_type` '1=booking; 2=night; 3=guest; 4=adult; 5=child;
			* 6=quantity; 7=guest/night; 8=adult/night; 9=child/night;
			* 10=quantity/night; '
			*/
			if ($extra->value_type==1)//Per booking
			{
				if ($extra->value_fix > 0)
					$res += $extra->value_fix;
				else if ($extra->value_percent > 0)
					$res += $extra->value_percent*0.01*$price;
			}
			else if ($extra->value_type==2)//Per Night
			{
				if ($extra->value_fix > 0)
					$res += $extra->value_fix*$nights;
				else if ($extra->value_percent > 0)
					$res += ($extra->value_percent*0.01*$price)*$nights;
			}
			else if ($extra->value_type==3)//Per guest
			{
				if ($extra->value_fix>0)//Fix
				{
					if ($nguests!="" && $nguests>0)
						$res += $extra->value_fix*($nguests+$nchilds);
				}
				else if ($extra->value_percent>0) //Percent
				{
					if ($nguests!="" && $nguests>0)
						$res += ($extra->value_percent*0.01*$price)*
						($nguests+$nchilds);
				}
			}
			else if ($extra->value_type==4)//Per adult
			{
				if ($extra->value_fix>0)
				{
					if ($nguests!=""&&$nguests>0)
						$res += $extra->value_fix*$nguests;
				}
				else if ($extra->value_percent>0)
				{
					if ($nguests!=""&&$nguests>0)
						$res += ($extra->value_percent*0.01*$price)*$nguests;
				}
			}
			else if ($extra->value_type==5)//Per child
			{
				if ($extra->value_fix>0)
				{
					if ($nchilds!="" && $nchilds>0)
						$res += $extra->value_fix*$nchilds;
				}
				else if ($extra->value_percent>0)
				{
					if ($nchilds!="" && $nchilds>0)
						$res += ($extra->value_percent*0.01*$price)*$nchilds;
				}
			}
			else if ($extra->value_type==6)//Per quantity
			{
				if ($extra->value_fix>0)
				{
					if ($qnt>0)
						$res += $extra->value_fix*$qnt;
				}
				else if ($extra->value_percent>0)
				{
					if ($qnt>0)
						$res += ($extra->value_percent*0.01*$price)*$qnt;
				}
			}
			else if ($extra->value_type==7) //Guest/night
			{
				if ($extra->value_fix>0)
				{
					$res += $extra->value_fix*($nguests+$nchilds)*$nights;
				}
				else if ($extra->value_percent>0)
				{
					$res += ($extra->value_percent*0.01*$price)*
					($nguests+$nchilds)*$nights;
				}
			}
			else if ($extra->value_type==8) //Per Adult/Night
			{
				if ($extra->value_fix>0)
				{
					$res += $extra->value_fix*$nguests*$nights;
				}
				else if ($extra->value_percent>0)
				{
					$res += ($extra->value_percent*0.01*$price)*$nguests*$nights;
				}
			}
			else if ($extra->value_type==9) //Per Child/Night
			{
				if ($extra->value_fix>0)
				{
					$res += $extra->value_fix*$nchilds*$nights;
				}
				else if ($extra->value_percent>0)
				{
					$res += ($extra->value_percent*0.01*$price)*$nchilds*$nights;
				}
			}

			else if ($extra->value_type==10) //Quantity/night
			{
				if ($extra->value_fix>0)
				{
					$res += $extra->value_fix*$qnt*$nights;
				}
				else if ($extra->value_percent>0)
				{
					$res += ($extra->value_percent*0.01*$price)*$qnt*$nights;
				}
			}
		}
		return number_format($res, 2, '.', '');
	}
	//----------------------------------Helper methods ------------------------
	function _filterRuleByCategory ($rules, $idcategory)
	{
		if (is_array($rules))
		{
			$filtered_rules = array();
			foreach ($rules as $rule)
			{
				$categories = explode (",",$rule->idcategory);
				if (in_array($idcategory, $categories))
					array_push($filtered_rules, $rule);
			}
			return $filtered_rules;
		}
		else
		{

			if (isset($rules))
			{
				$categories = explode (",",$rules->idcategory);
				if (!in_array($idcategory, $categories))
					return null;
			}
			return $rules;

		}
	}
	function _filterRuleByCoupon ($rule, $idcoupon)
	{
		//If this rule is a coupon then is must match the selected id
		if ($rule->coupon==1 && $rule->idrule!=$idcoupon)
			return null;
		else
			return $rule;
	}
	function _getDateFormat ()
	{
		$params = BlookingHelper::getParams();
		$dateformatcode = $params->dateformat;
		if ($dateformatcode==""||$dateformatcode==3)
			$d1='d-m-Y';
		else if ($dateformatcode==1)
			$d1='Y-m-d';
		else if ($dateformatcode==2)
			$d1='m/d/Y';
		return $d1;
	}

	function _getNights ($from, $to)
	{
		$from_time = strtotime($from);
		$to_time = strtotime($to);
		return (round( ($to_time-$from_time )/86400)) ;
	}

	function _toMysqlDateFormat ($dateString)
	{
		$date_format = $this->_getDateFormat ();
		$originalDate = strtotime($dateString);
		return date("Y-m-d", $originalDate);
	}

	function getCoupons()
	{
		$query = "SELECT idrule, name FROM ".
				$this->_db->nameQuote('#__bookitrules').
				" WHERE ".$this->_db->nameQuote('published')." = ".
				$this->_db->quote('1').
				" AND ".$this->_db->nameQuote('coupon')." = ".$this->_db->quote('1').
				" AND ".$this->_db->nameQuote('quantity')." > ".
				$this->_db->nameQuote('times_used');

		$this->_db->setQuery($query);
		return $this->_db->loadObjectList();
			
	}

	function getGuestDetails() {
		$db =& JFactory::getDBO();
		$sql = "SELECT idguests, email, name, surname FROM #__bookitguests";
		$db->setQuery($sql);
		return $db->loadRowList();
	}

	function getCategories() {
		$db =& JFactory::getDBO();
		$sql = "SELECT idcategory, name FROM #__bookitcategory";
		$db->setQuery($sql);
		return $db->loadObjectList();
	}

	function getRooms() {
		$db =& JFactory::getDBO();
		$sql = "SELECT idroom, name FROM #__bookitroom";
		$db->setQuery($sql);
		return $db->loadObjectList();
	}

	function getExtras () {

		$sql = "SELECT * FROM ".$this->_db->nameQuote("#__bookitextra");
		$this->_db->setQuery($sql);
		return $this->_db->loadObjectList();
	}

	function getBookingExtras($id)
	{
		if ($id==0) return "";

		$sql = 'SELECT '.$this->_db->nameQuote("extra_ids")." FROM ".
				$this->_db->nameQuote("#__bookitbooking")." WHERE ".
				$this->_db->nameQuote("idbook")." = ".$id;
		$this->_db->setQuery($sql);
		return $this->_db->loadResult();
	}

	function getCategoryExtras ($idcategory)
	{
		$sql = "SELECT * FROM ".$this->_db->nameQuote("#__bookitextra");
		$this->_db->setQuery($sql);
		$extras = $this->_db->loadObjectList();



		$result = array();
		foreach ($extras as $extra)
		{

			$categories = explode(",",$extra->idcategories);

			if (in_array($idcategory, $categories))
			{
				array_push($result, $extra->idextra);
			}
		}
		return implode (",",$result);
	}

	function _getExtraById ($extra_id)
	{
		$query =  "SELECT * FROM ".$this->_db->nameQuote("#__bookitextra").
		" WHERE ".$this->_db->nameQuote("idextra")."=".
		$this->_db->quote($extra_id);
		$this->_db->setQuery( $query );
		return $this->_db->loadObject();
	}

	function getSubject($lang, $type='custemail') {
		$db =& JFactory::getDBO();
		if ($lang=='en')
			$subject=$type.'_subject';
		else
			$subject = $type.'_subject_'.$lang;

		$sql = "SELECT ".$this->_db->nameQuote($subject)." FROM ".
				$this->_db->nameQuote('#__bookitutils')." WHERE ".
				$this->_db->nameQuote('id')."=".$this->_db->quote('1');
		$db->setQuery($sql);
		$res = $db->loadResult();

		if (!$res) {
				
				
			$sql = "SELECT ".$this->_db->nameQuote($type.'_subject')." FROM ".
					$this->_db->nameQuote('#__bookitutils')." WHERE ".
					$this->_db->nameQuote('id')."=".$this->_db->quote('1');
			$db->setQuery($sql);
			$res =  $db->loadResult();
		}
		return $res;
	}

	function getBookingDetailsForEmail($bookingid) {
		$db =& JFactory::getDBO();

		$query = "SELECT * FROM ".$db->nameQuote('#__bookitbooking')." WHERE ".
				$db->nameQuote('idbook')." = ".$db->quote($bookingid).";";
		$db->setQuery($query);
		$booking_row = $db->loadObject();

		$lang =& JFactory::getLanguage();
		$lang->setLanguage($booking_row->lang);
		$lang->load();

		$query = "SELECT * FROM ".$db->nameQuote('#__bookitguests')." WHERE ".
				$db->nameQuote('idguests')." = ".$db->quote($booking_row->idguests).";";
		$db->setQuery($query);
		$guest_row = $db->loadObject();

		$query = "SELECT * FROM ".$db->nameQuote('#__bookitutils').";";
		$db->setQuery($query);
		$utils = $db->loadObject();

		$params = BlookingHelper::getParams();
			
		$d1 = $this->_getDateFormat();
		$currency = $params->currency;

		$valid_from = date ($d1, strtotime($booking_row->valid_from));
		$valid_to = date ($d1,strtotime($booking_row->valid_to));

		$valid_from_new = date ("Y-m-d", strtotime($booking_row->valid_from));
		$valid_to_new = date ("Y-m-d",strtotime($booking_row->valid_to));
		$fromDateTS = strtotime($valid_from_new);
		$toDateTS = strtotime($valid_to_new);
		$nights=round( ($toDateTS-$fromDateTS )/86400) ;

		$root = JURI::root();
		$encryptedID = base64_encode($bookingid);
		$cancelbookinglink = '<a href="'.$root.'index.php?option=com_blooking&controller=finalform&task=cancelBooking&idbook='.$encryptedID.'">'.JText::_("COM_BOOKIT_CANCEL_BOOKING").'</a>';
		$paymentlink = '<a href="'.$root.'index.php?option=com_blooking&controller=payment&idbook='.$encryptedID.'">'.JText::_("COM_BOOKIT_MAKE_PAYMENT").'</a>';

		$query = "SELECT name FROM #__bookitcountry WHERE idcountry='".$guest_row->idcountry."'";
		$db->setQuery($query);
		$country_name=$db->loadResult();
		//$refid = $bookingid+1000;

		$ids = array();
		if ($booking_row->coids!="") // Multiroom
		{
			$refid = "";
			$ids = explode (",",$booking_row->coids);
		}
		array_push($ids, $bookingid);
		sort($ids);
		$cat_qnt = array();
		$adults=0;
		$childs=0;
		$guests=0;
		$extra_ids="";
		$extra_table = "";
		$extra_price = "";
		$preferences = "";
		$value_full=0.00;
		$value_paid=0.00;
		foreach ($ids as $id)
		{
				
			$rid = $id+1000;
			if ($refid!="")$refid .= ", ";
			$refid .= $rid;

			$query = "SELECT * FROM ".$db->nameQuote('#__bookitbooking')." WHERE ".
					$db->nameQuote('idbook')." = ".$db->quote($id);
			$db->setQuery($query);
			$booking_row = $db->loadObject();

			$query = "SELECT * FROM ".$db->nameQuote('#__bookitcategory').
			" WHERE ".$db->nameQuote('idcategory')."=".
			$db->quote($booking_row->idcategory);
			$db->setQuery($query);
			$row=$db->loadObject();
			if (isset($row->{"name_".$booking_row->lang}))
				$cat_name = $row->{"name_".$booking_row->lang};
			else
				$cat_name = $row->name;

			if (isset($cat_qnt[$cat_name]))
				$cat_qnt[$cat_name]+=1;
			else
				$cat_qnt[$cat_name]=1;

			$adults += $booking_row->nguests;
			$childs += $booking_row->nchilds;
			$guests += $booking_row->nguests + $booking_row->nchilds;

			$extra_ids=$booking_row->extra_ids;
			if ($booking_row->preferences!="")
			{
				$preferences .= $booking_row->preferences;
				$preferences .= "<br />";
			}
			if ($extra_ids != "")
			{
				$extras = explode (",", $extra_ids);
				foreach ($extras as $extra)
				{
					$nq = explode ("-", $extra);
					$query = "SELECT * FROM ".$db->nameQuote('#__bookitextra').
					" WHERE ".$db->nameQuote('idextra')."=".$nq['0'];
					$db->setQuery($query);
					$row = $db->loadObject();
					if (isset($row->{'name_'.$booking_row->lang}))
						$extra_name=$row->{'name_'.$booking_row->lang};
					else
						$extra_name=$row->name;

					if (isset($booking_row->initial_price))
						$p=$booking_row->initial_price;
					else
						$p=$booking_row->value_full;
					$extra_price .= $this->_getExtraServicesPriceDeviations(
							$extra, $p, $nights, $adults, $childs);
					$extra_price .= "<br />";

					if (count($nq)>1){
						$extra_table .= $extra_name." (x ".$nq['1'].")<br />";
					} else {
						$extra_table .= $extra_name."<br />";
					}
				}
			}
			$value_full += $booking_row->value_full;
			$value_paid = $booking_row->value_paid;
		}

		$cat_name="";
		$i=0;
		foreach ($cat_qnt as $k=>$v )
		{
			if($i==count($cat_qnt)-1){
				$cat_name .= $v." x ".$k;
			}
			else $cat_name .= $v." x ".$k.", ";
			$i++;
		}

		$bookingstatus = $booking_row->status;

		switch ($bookingstatus) {
			case 1:
				$bookingstatus = JText::_('COM_BOOKIT_BOOKED');
				break;
			case 2:
				$bookingstatus = JText::_('COM_BOOKIT_PENDING');
				break;
			case 4:
				$bookingstatus = JText::_('COM_BOOKIT_EXPIRED');
				break;
			case 5:
				$bookingstatus = JText::_('COM_BOOKIT_CANCELLED');
				break;
			case 6:
				$bookingstatus = JText::_('COM_BOOKIT_PROCESSING');
				break;
			default:
				$bookingstatus = JText::_('COM_BOOKIT_PROCESSING');
		}

		$booking_details = array (
				'firstname' => $guest_row->name,
				'surname' => $guest_row->surname,
				'email' => $guest_row->email,
				'phone' => $guest_row->phone,
				'address1' => $guest_row->address1,
				'address2' => $guest_row->address2,
				'address3' => $guest_row->address3,
				'postcode' => $guest_row->postcode,
				'country' => $country_name,
				'bookingid' => $refid,
				'checkin' => $valid_from,
				'checkout' => $valid_to,
				'nights' => $nights,
				'roomtype' => $cat_name,
				'totalprice' => number_format($value_full,2, '.',''),
				'deposit' => number_format($value_paid,2, '.',''),
				'remainingprice' => number_format($value_full-$value_paid,2, '.',''),
				'adults' => $adults,
				'childs' => $childs,
				'guests' => $guests,
				'extras' => $extra_table,
				'extraprices' => $extra_price,
				'requests' => $preferences,
				'terms' => $this->_translator($booking_row->lang,"terms_conditions", "#__bookitutils","id",1),
				'cancellation_policy' => $this->_translator($booking_row->lang,"cancellation_policy", "#__bookitutils","id",1),
				'cancelbookinglink' => $cancelbookinglink,
				'bookingstatus' => $bookingstatus,
				'paymentlink' => $paymentlink ,
				'paymentmethod' => $booking_row->payment_method
		);

		return $booking_details;
	}
	function getUtils()
	{
		$sql="SELECT * FROM ".$this->_db->nameQuote('#__bookitutils');
		$this->_db->setQuery($sql);
		return $this->_db->loadObject();
	}
	function getAdminEmails ()
	{
		$res = new stdClass();
		$params = BlookingHelper::getParams();
		$res->admin1 = $params->admin_email;
		$res->admin2 = $params->admin_email2;
		return $res;
	}
	function _translator ($lang, $column, $table, $idkey, $idvalue)
	{

		$sql = "SELECT * FROM ".$this->_db->nameQuote($table)." WHERE ".
				$this->_db->nameQuote($idkey)."=".$this->_db->quote($idvalue);
		$this->_db->setQuery($sql);
		$obj = $this->_db->loadObject();

		if($lang!='en')
		{
			$new_column=$column.'_'.$lang;
			if(isset($obj->{$new_column}))
				return $obj->{$new_column};
		}
		return $obj->{$column};

	}

	function adminConfirm() {
		$cids = JRequest::getVar( 'cid', array(0), 'post', 'array' );
		$row =& $this->getTable('booking');
		$updaterow =& $this->getTable('booking');
		$db =& JFactory::getDBO();

		foreach($cids as $cid) {
			$row->load($cid);
			if ($row->payment_requested == 0) {
				$this->sendValidationEmail($cid,$row->lang,'custverified');

				//Mark coids as payment requested to prevent duplicate email
				if ($row->coids != "") {
					$coids = explode(",", $row->coids);
						
					foreach ($coids as $coid) {
						$data = array('idbook' => $coid, 'payment_requested' => '1');
						if (!$updaterow->bind($data)) {
							$this->setError( $updaterow->getErrorMsg() );
							return false;
						}
							
						if (!$updaterow->store()) {
							$this->setError( $updaterow->getErrorMsg() );
							return false;
						}
					}
				}
					
				$data = array('idbook' => $cid, 'payment_requested' => '1');
					
				if (!$updaterow->bind($data)) {
					$this->setError( $updaterow->getErrorMsg() );
					return false;
				}
					
				if (!$updaterow->store()) {
					$this->setError( $updaterow->getErrorMsg() );
					return false;
				}
			}
		}
		return true;
	}

	function sendValidationEmail($idbook, $lang, $type) {
		$mailer =& JFactory::getMailer();
		$config =& JFactory::getConfig();
		$params = BlookingHelper::getParams();

		$emails = $this->getAdminEmails();
		$sender = array($emails->admin1, $config->getValue('config.fromname'));
		$mailer->setSender($sender);

		$subject = $this->getSubject($lang, $type);
		//$idbook = JRequest::getVar('idbook');
		$res = $this->getBookingDetailsForEmail($idbook);
		$recipients = $res['email'];
		$mailer->addRecipient($recipients);
		//$mailer->addRecipient($emails->admin1); //To send to admin as well

		$utils = $this->getUtils();
		if ($lang!='en') {
			$type=$type."_".$lang;
		}
		$msg_tmpl = $utils->{$type};

		if ($params->deposit_percent > 0) {
			$deposit = number_format(($res['totalprice'] / 100)*$params->deposit_percent,2, '.','');
		} else {
			$deposit = number_format($params->deposit_fixed,2, '.','');
		}

		$pricelessdeposit = number_format($res['totalprice'] - $deposit,2, '.','');

		$arr_tpl_vars = array('{firstname}','{surname}', '{email}', '{phone}',
				'{address1}', '{address2}', '{address3}', '{postcode}', '{country}',
				'{bookingid}', '{checkin}', '{checkout}', '{nights}', '{roomtype}',
				'{totalprice}', '{deposit}', '{amountreceived}','{remainingprice}',
				'{pricelessdeposit}','{adults}', '{childs}', '{guests}', '{extras}',
				'{extraprices}', '{requests}', '{terms}', '{cancellation}', '{cancelbookinglink}',
				'{bookingstatus}', '{paymentlink}');

		$arr_tpl_data = array($res['firstname'], $res['surname'], $res['email'],
				$res['phone'], $res['address1'], $res['address2'], $res['address3'],
				$res['postcode'], $res['country'], $res['bookingid'], $res['checkin'],
				$res['checkout'], $res['nights'], $res['roomtype'], $res['totalprice'],
				$deposit, $res['deposit'], $res['remainingprice'], $pricelessdeposit,
				$res['adults'], $res['childs'],	$res['guests'], $res['extras'],
				$res['extraprices'], $res['requests'], $res['terms'], $res['cancellation_policy'],
				$res['cancelbookinglink'], $res['bookingstatus'], $res['paymentlink']);

		$msg = str_replace($arr_tpl_vars, $arr_tpl_data, $msg_tmpl);
		$subject = str_replace($arr_tpl_vars, $arr_tpl_data, $subject);

		$mailer->setSubject($subject);
		$mailer->isHTML(true);
		$mailer->setBody($msg);
		$send =& $mailer->Send();

		if ($send==true) {
			$msg=JText::_("COM_BOOKIT_EMAIL_SENT");
		}

		return $msg;
	}



}
