<?php
/**
 * BlooKing - The King in Joomla Booking
 * @version 1.0
 * @author BlooKing.org. Based on BooKiTGold code by Costas Kakousis
 * @copyright (C) 2012-2013 by BlooKing.org (http://www.blooking.org)
 * @license GNU/GPL: http://www.gnu.org/copyleft/gpl.html
 *
 * If you fork this to create your own project, please make a reference to
 * BlooKing! someplace in your code and provide a link to
 * http://www.blooking.org
 *
 * This file is part of BlooKing! BlooKing is free software: you can
 * redistribute it and/or modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * BlooKing is distributed in the hope that it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details. You should have received a copy of the GNU General Public License
 * along with BlooKing.  If not, see <http://www.gnu.org/licenses/>.
 *   ______ __                __  __ __
 *	|   __ \  |.-----..-----.|  |/  |__|.-----..-----.
 *	|   __ <  ||  _  ||  _  ||     <|  ||     ||  _  |
 *	|______/__||_____||_____||__|\__|__||__|__||___  |
 *                                             |_____|
 **/
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport('joomla.application.component.model');

class BlookingModelGatewayseditor extends JModel {
	function _construct() {
		parent::__construct();
	}
	function getPlugins15() {
		$db =& JFactory::getDBO();
		$sql = "SELECT * FROM ".$this->_db->nameQuote('#__plugins')." WHERE ".
				$this->_db->nameQuote('name')." LIKE ".$this->_db->quote('blooking%');
		$db->setQuery($sql);
		return $db->loadObjectList();
	}

	function getPlugins17() {
		$db =& JFactory::getDBO();
		$sql = "SELECT * FROM ".$this->_db->nameQuote('#__extensions')." WHERE ".
				$this->_db->nameQuote('name')." LIKE ".$this->_db->quote('blooking%').
				" AND ".$this->_db->nameQuote('type')."=".$this->_db->quote('plugin');
		$db->setQuery($sql);
		return $db->loadObjectList();
	}

	function store ()
	{
		$posted = JRequest::get('post');

		if(version_compare(JVERSION,'1.6.0','ge'))
		{
			$plugin = JPluginHelper::getPlugin('system', $posted['element']);
			$pluginParams = new JRegistry();
			$pluginParams->loadString($plugin->params);
			$pluginParams =  $pluginParams->toArray();
				
			$params = json_encode(array_merge($pluginParams, $posted['params']));
				
			$sql = "UPDATE ".$this->_db->nameQuote('#__extensions')." SET ".
					$this->_db->nameQuote('enabled')." = ".
					$this->_db->quote($posted['published']).", ".
					$this->_db->nameQuote('params')." = ".
					$this->_db->quote($params)." WHERE ".
					$this->_db->nameQuote('extension_id')."=".
					$this->_db->quote($posted['id']);
			$this->_db->setQuery($sql);
			$this->_db->Query();
		}
		else
		{
			$row  =& JTable::getInstance('plugin');
			$row->id = JRequest::getVar('id');
				
			if (!$row->bind($posted)) {
				JError::raiseError(500, $row->getError() );
			}
			if (!$row->check()) {
				JError::raiseError(500, $row->getError() );
			}
			if (!$row->store()) {
				JError::raiseError(500, $row->getError() );
			}
				

		}
		return true;
	}
}