<?php
/**
 * BlooKing - The King in Joomla Booking
 * @version 1.0
 * @author BlooKing.org. Based on BooKiTGold code by Costas Kakousis
 * @copyright (C) 2012-2013 by BlooKing.org (http://www.blooking.org)
 * @license GNU/GPL: http://www.gnu.org/copyleft/gpl.html
 *
 * If you fork this to create your own project, please make a reference to
 * BlooKing! someplace in your code and provide a link to
 * http://www.blooking.org
 *
 * This file is part of BlooKing! BlooKing is free software: you can
 * redistribute it and/or modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * BlooKing is distributed in the hope that it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details. You should have received a copy of the GNU General Public License
 * along with BlooKing.  If not, see <http://www.gnu.org/licenses/>.
 *   ______ __                __  __ __
 *	|   __ \  |.-----..-----.|  |/  |__|.-----..-----.
 *	|   __ <  ||  _  ||  _  ||     <|  ||     ||  _  |
 *	|______/__||_____||_____||__|\__|__||__|__||___  |
 *                                             |_____|
 **/
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport('joomla.application.component.model');

class BlookingModelGuests extends JModel {
	var $_data = null;
	var $_total = null;
	var $_pagination = null;

	function __construct() {
		parent::__construct();
		$mainframe = JFactory::getApplication();

		$limit = $mainframe->getUserStateFromRequest('global.list.limit', 'limit', $mainframe->getCfg('list_limit'), 'int');
		$limitstart = JRequest::getVar('limitstart', 0, '', 'int');

		$limitstart = ($limit != 0 ? (floor($limitstart / $limit) * $limit) : 0);

		$this->setState('limit', $limit);
		$this->setState('limitstart', $limitstart);
	}

	function _buildQuery() {
		$db =& $this->_db;
		$rtable = $db->nameQuote('#__bookitguests');
		$ctable = $db->nameQuote('#__bookitcountry');
		$query = ' SELECT r.*, cc.name AS cname FROM ' . $rtable.' AS r LEFT JOIN '.$ctable.'
				AS cc ON cc.idcountry=r.idcountry';
		$query .= $this->_buildQueryWhere();
		$query .= $this->_buildContentOrderBy();
		return $query;
	}

	function _buildContentOrderBy() {
		$option = JRequest::getCmd('option');
		$mainframe = JFactory::getApplication();
		$db =& $this->_db;
		$orderby = '';

		$orders = array('idguests', 'name', 'surname', 'email', 'jid', 'cname');
		$filter_order = $mainframe->getUserStateFromRequest($option.'filter_order','filter_order','name');
		$filter_order_Dir = $mainframe->getUserStateFromRequest($option.'filter_order_Dir','filter_order_Dir','ASC');

		if($filter_order_Dir != 'ASC' && $filter_order_Dir != 'DESC') {
			$filter_order_Dir != 'ASC';
		}

		if (!in_array($filter_order, $orders)) {
			$filter_order='name';
		}

		$orderby = ' ORDER BY '.$db->nameQuote($filter_order).' '.$filter_order_Dir;

		if ($filter_order != 'surname') {
			$orderby .= ' , '.$db->nameQuote('surname');
		}

		return $orderby;
	}

	function _buildQueryWhere() {
		$filter_search = JRequest::getVar('filter_search');
		$where = array();

		if ($filter_search = trim($filter_search)) {
			$filter_search = JString::strtolower ($filter_search);
			$filter_search = $this->_db->getEscaped($filter_search);
			$where = ' WHERE (LOWER('.$this->_db->nameQuote('r').'.'.
					$this->_db->nameQuote('name').') LIKE "%'.$filter_search.'%" '.
					'OR LOWER('.$this->_db->nameQuote('r').'.'.
					$this->_db->nameQuote('surname').') LIKE "%'.$filter_search.'%" '.
					'OR LOWER('.$this->_db->nameQuote('cc').'.'.
					$this->_db->nameQuote('name').') LIKE "%'.$filter_search.'%" '.
					'OR LOWER('.$this->_db->nameQuote('r').'.'.
					$this->_db->nameQuote('email').') LIKE "%'.$filter_search.'%")';
		}

		return (count($where)) ? $where : ' ';
	}

	function getData() {
		if (empty($this->_data)) {
			$query = $this->_buildQuery();
			$this->_data = $this->_getList($query, $this->getState('limitstart'), $this->getState('limit'));
		}

		return $this->_data;
	}

	function getTotal() {
		if (empty($this->_total)) {
			$query = $this->_buildQuery();
			$this->_total = $this->_getListCount($query);
		}
		return $this->_total;
	}
	 
	function getPagination() {
		if (empty($this->_pagination)) {
			jimport('joomla.html.pagination');
			$this->_pagination = new JPagination($this->getTotal(), $this->getState('limitstart'), $this->getState('limit') );
		}
		return $this->_pagination;
	}

	function _buildCopyQuery($id) {
		$db =& $this->_db;
		$query = 'SELECT * FROM '.$db->nameQuote('#__bookitguests').' WHERE '.
				$db->nameQuote('idguests').'='.$db->quote($id);
		$db->setQuery($query);
		$row = $db->loadRow();

		$data =new stdClass();
		$data->idguests = null;
		$data->idcountry = $row['1'];
		$data->name = $row['2'];
		$data->surname = $row['3'];
		$data->email = $row['4'];
		$data->address2 = $row['5'];
		$data->address1 = $row['6'];
		$data->phone = $row['7'];
		$data->address3 = $row['8'];
		$data->postcode = $row['9'];
		$data->jid = $row['10'];

		$db->insertObject( '#__bookitguests', $data, 'idguests' );
		return true;
	}

	function delete() {
		$cids = JRequest::getVar( 'cid', array(0), 'post', 'array' );
		$row =& $this->getTable('guestsedit');

		foreach($cids as $cid) {
				
			if (!$this->_canDelete($cid)) return false;
				
			if (!$row->delete( $cid )) {
				$this->setError( $row->getErrorMsg() );
				return false;
			}
		}

		return true;
	}

	function copy () {
		$cids = JRequest::getVar( 'cid', array(0), 'post', 'array' );

		foreach($cids as $cid) {
			if (!$this->_buildCopyQuery($cid)) {
				return false;
			}
		}

		return true;
	}

	function _canDelete($cid)
	{
		$db =& $this->_db;
		$query = 'SELECT * FROM '.$db->nameQuote('#__bookitbooking').' WHERE '.
				$db->nameQuote('idguests').'='.$db->quote($cid);
		$db->setQuery($query);
		$row = $db->loadObjectList();

		if (count($row) > 0) return false;
		else return true;

	}
}