<?php
/**
 * BlooKing - The King in Joomla Booking
 * @version 1.0
 * @author BlooKing.org. Based on BooKiTGold code by Costas Kakousis
 * @copyright (C) 2012-2013 by BlooKing.org (http://www.blooking.org)
 * @license GNU/GPL: http://www.gnu.org/copyleft/gpl.html
 *
 * If you fork this to create your own project, please make a reference to
 * BlooKing! someplace in your code and provide a link to
 * http://www.blooking.org
 *
 * This file is part of BlooKing! BlooKing is free software: you can
 * redistribute it and/or modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * BlooKing is distributed in the hope that it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details. You should have received a copy of the GNU General Public License
 * along with BlooKing.  If not, see <http://www.gnu.org/licenses/>.
 *   ______ __                __  __ __
 *	|   __ \  |.-----..-----.|  |/  |__|.-----..-----.
 *	|   __ <  ||  _  ||  _  ||     <|  ||     ||  _  |
 *	|______/__||_____||_____||__|\__|__||__|__||___  |
 *                                             |_____|
 **/
// No direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport('joomla.application.component.model');

class BlookingModelGuestsedit extends JModel
{
	var $_data;
	var $_id;
	var $_db;

	function __construct()
	{
		parent::__construct();

		$array = JRequest::getVar('cid',  0, '', 'array');
		$this->setId((int)$array[0]);
	}

	function setId($id)
	{
		// Set id and wipe data
		$this->_id		= $id;
		$this->_data	= null;
	}


	/**
	 * Returns the query
	 * @return string The query to be used to retrieve the rows from the database
	 */
	function _buildQuery()
	{

		$cid = JRequest::getVar( 'cid', array(0), 'post', 'array' );
		$id=$cid[0];
		if ($id==0)
		{
			$cid = JRequest::getVar('cid', '', 'get');
			$id = $cid[0];
		}

			
		$query = ' SELECT * '
				. ' FROM #__bookitguests WHERE idguests='.$id;
		return $query;
	}

	/**
	 * Retrieves the bookings
	 * @return array Array of objects containing the data from the database
	 */
	function &getData()
	{
		// Load the data
		if (empty( $this->_data )) {
			$query = ' SELECT * FROM #__bookitguests '.
					'  WHERE idguests = '.$this->_id;
			$this->_db->setQuery( $query );
			$this->_data = $this->_db->loadObject();
		}
		if (!$this->_data) {
			$this->_data = new stdClass();

			$this->_data->idguests = 0;
			$this->_data->idcountry = 0;
			$this->_data->name = null;
			$this->_data->surname = null;
			$this->_data->email = null;
			$this->_data->address2 = null;
			$this->_data->address1 = null;
			$this->_data->phone = null;
			$this->_data->address3 = null;
			$this->_data->postcode = null;
			$this->_data->jid = null;

		}


		return $this->_data;
	}
	/**
	 * Method to store a record
	 */
	function store()
	{
		$row =& $this->getTable();
		$data = JRequest::get( 'post' );
		$name = JRequest::getVar('name');
		$idcountry = JRequest::getVar('idcountry');
		$surname = JRequest::getVar('surname');
		$email = JRequest::getVar('email');
		$address1 = JRequest::getVar('address1');
		$phone = JRequest::getVar('phone');
		$address2 = JRequest::getVar('address2');
		$id = JRequest::getVar('idguests');

		$res["id"]=$id;

		if ($name==""|| $surname==""||$email=="")
		{
			$res["code"]=-1;
			return $res;
		}

		// Bind the form fields to the Bookitbooking table
		if (!$row->bind($data)) {

			$this->setError($this->_db->getErrorMsg());
			$res["code"]=-2;
			return $res;
		}

		// Make sure the record is valid
		if (!$row->check()) {

			$this->setError($this->_db->getErrorMsg());
			$res["code"]=-2;
			return $res;
		}


		// Store to the database
		if (!$row->store()) {

			$this->setError($this->_db->getErrorMsg());
			$res["code"]=-2;
			return $res;
		}

		if ($res["id"]==0)
			$res["id"]=$row->idguests;
		$res["code"]=0;
		return $res;
	}

	function getCountries ()
	{
		//		$sql = "SELECT ".$this->_db->nameQuote('idcountry').", ".
		//				$this->_db->nameQuote('name')." FROM ".
		//				$this->_db->nameQuote('#__bookitcountry');
		//		$this->_db->setQuery($sql);
		//		return  $this->_db->loadObjectList();
		JLoader::register('BlookingHelper',
		JPATH_COMPONENT_ADMINISTRATOR.'/helpers/BlookingHelper.php');
		return BlookingHelper::getCountries();

	}

	function getJUsers ()
	{
		$sql = "SELECT * FROM ".
				$this->_db->nameQuote('#__users');
		$this->_db->setQuery($sql);
		return  $this->_db->loadObjectList();
	}

	function getJUser ()
	{
		$posted_data = JRequest::get();
		$data = array('');
		$data['idcountry']=0;
		$data['name']="";
		$data['surname']="";
		$data['email']="";
		$data['address1']="";
		$data['address2']="";
		$data['address3']="";
		$data['phone']="";
		$data['postcode']="";

		if ($posted_data['jid']>0)
		{
			$sql = "SELECT * FROM ".
					$this->_db->nameQuote('#__bookitguests')." WHERE ".
					$this->_db->nameQuote('jid')."=".
					$this->_db->quote($posted_data['jid']);
			$this->_db->setQuery($sql);
			$buser =  $this->_db->loadObject();
			if (isset($buser))
			{
				$data['idcountry']=$buser->idcountry;
				$data['name']=$buser->name;
				$data['surname']=$buser->surname;
				$data['email']=$buser->email;
				$data['address1']=$buser->address1;
				$data['address2']=$buser->address2;
				$data['address3']=$buser->address3;
				$data['phone']=$buser->phone;
				$data['postcode']=$buser->postcode;
			}
			else
			{
				$sql = "SELECT * FROM ".
						$this->_db->nameQuote('#__users')." WHERE ".
						$this->_db->nameQuote('id')."=".
						$this->_db->quote($posted_data['jid']);
				$this->_db->setQuery($sql);
				$juser = $this->_db->loadObject();
				$fullname = explode(" ",$juser->name );
				$data['name']=$fullname[0];
				if (isset($fullname[1]))
					$data['surname']=$fullname[1];
				$data['email']=$juser->email;
			}
		}
		else
		{
			$sql = "SELECT * FROM ".
					$this->_db->nameQuote('#__bookitguests')." WHERE ".
					$this->_db->nameQuote('idguests')."=".
					$this->_db->quote($posted_data['idguests']);
			$this->_db->setQuery($sql);
			$buser =  $this->_db->loadObject();
			if (isset($buser))
			{
				$data['idcountry']=$buser->idcountry;
				$data['name']=$buser->name;
				$data['surname']=$buser->surname;
				$data['email']=$buser->email;
				$data['address1']=$buser->address1;
				$data['address2']=$buser->address2;
				$data['address3']=$buser->address3;
				$data['phone']=$buser->phone;
				$data['postcode']=$buser->postcode;
			}

		}
		return $data;
			
	}
}