<?php
/**
 * BlooKing - The King in Joomla Booking
 * @version 1.0
 * @author BlooKing.org. Based on BooKiTGold code by Costas Kakousis
 * @copyright (C) 2012-2013 by BlooKing.org (http://www.blooking.org)
 * @license GNU/GPL: http://www.gnu.org/copyleft/gpl.html
 *
 * If you fork this to create your own project, please make a reference to
 * BlooKing! someplace in your code and provide a link to
 * http://www.blooking.org
 *
 * This file is part of BlooKing! BlooKing is free software: you can
 * redistribute it and/or modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * BlooKing is distributed in the hope that it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details. You should have received a copy of the GNU General Public License
 * along with BlooKing.  If not, see <http://www.gnu.org/licenses/>.
 *   ______ __                __  __ __
 *	|   __ \  |.-----..-----.|  |/  |__|.-----..-----.
 *	|   __ <  ||  _  ||  _  ||     <|  ||     ||  _  |
 *	|______/__||_____||_____||__|\__|__||__|__||___  |
 *                                             |_____|
 **/
// No direct access
defined( '_JEXEC' ) or die( 'Restricted access' );
jimport('joomla.application.component.model');

class BlookingModelParams extends JModel {
	var $_data;
	var $_id;
	var $_db;

	function __construct() {
		parent::__construct();
	}

	function getParam($param)
	{
		$db =& JFactory::getDBO();
		$sql = "SELECT ".$this->_db->nameQuote($param)." FROM ".
				$this->_db->nameQuote('#__bookitparams')." WHERE ".
				$this->_db->nameQuote('id')."=".$this->_db->quote('1');
		$db->setQuery($sql);
		return $db->loadResult();
	}

	function store()
	{
		$res = array();
		$res['code']=1;
		$data = JRequest::get( 'post',  JREQUEST_ALLOWHTML );

		if($data['show_address']==0)
		{
			$data['address_req']=0;
			$data['show_postcode']=0;
			$data['show_address3']=0;
		}
		if($data['show_phone']==0)
			$data['phone_req']=0;
		if($data['show_postcode']==0)
			$data['postcode_req']=0;


		if ($data['publickey']!="")
			$data['publickey'] = ($data['publickey']);
		if ($data['privatekey']!="")
			$data['privatekey'] = ($data['privatekey']);
			
		if($data['pending_enabled']==0)
			$data['pending_time']=0;

		if ($data['multiroom']==2) {
			$sql = "TRUNCATE TABLE ".$this->_db->nameQuote('#__bookitroom');
			$this->_db->setQuery($sql);
			$this->_db->query();

			$query = "SELECT * FROM ".$this->_db->nameQuote('#__bookitcategory');
			$this->_db->setQuery($query);
			$row = $this->_db->loadRowList();

			$rooms = array();
			foreach ($row as $key=>$value) {
				$rooms[] = "(".$this->_db->quote($value['0']).",".$this->_db->quote($value['1']).")";
			}

			if (count($rooms != "0")) {
				$sql = "INSERT INTO ".$this->_db->nameQuote('#__bookitroom');
				$sql .= "(".$this->_db->nameQuote('idcategory').",";
				$sql .= $this->_db->nameQuote('name').") VALUES";
				$sql .= implode(",",$rooms);

				$this->_db->setQuery($sql);
				$this->_db->query();
				//die($this->_db->getErrorMsg());
			}
		}

		$sql = "UPDATE ".$this->_db->nameQuote('#__bookitutils').
		" SET ".$this->_db->nameQuote('show_address')."=".
		$this->_db->quote($data['show_address']).", ".
		$this->_db->nameQuote('show_phone')."=".
		$this->_db->quote($data['show_phone']).", ".
		$this->_db->nameQuote('address_req')."=".
		$this->_db->quote($data['address_req']).", ".
		$this->_db->nameQuote('phone_req')."=".
		$this->_db->quote($data['phone_req']).", ".
		$this->_db->nameQuote('show_captcha')."=".
		$this->_db->quote($data['show_captcha']).", ".
		$this->_db->nameQuote('publickey')."=".
		$this->_db->quote($data['publickey']).", ".
		$this->_db->nameQuote('privatekey')."=".
		$this->_db->quote($data['privatekey']).", ".
		$this->_db->nameQuote('captcha_theme')."=".
		$this->_db->quote($data['captcha_theme']).", ".
		$this->_db->nameQuote('pending_enabled')."=".
		$this->_db->quote($data['pending_enabled']).", ".
		$this->_db->nameQuote('pending_time')."=".
		$this->_db->quote($data['pending_time']).", ".
		$this->_db->nameQuote('pending_measure')."=".
		$this->_db->quote($data['pending_measure']).", ".
		$this->_db->nameQuote('show_address3')."=".
		$this->_db->quote($data['show_address3']).", ".
		$this->_db->nameQuote('surname_req')."=".
		$this->_db->quote($data['surname_req']).", ".
		$this->_db->nameQuote('show_postcode')."=".
		$this->_db->quote($data['show_postcode']).", ".
		$this->_db->nameQuote('postcode_req')."=".
		$this->_db->quote($data['postcode_req']).
		" WHERE ".$this->_db->nameQuote('id')." = ".$this->_db->quote('1');
		$this->_db->setQuery($sql);
		if (!$this->_db->query()) $res['code']=-1;

		$sql = "UPDATE ".$this->_db->nameQuote('#__bookitparams').
		" SET ".$this->_db->nameQuote('multiroom')."=".
		$this->_db->quote($data['multiroom']).", ".
		$this->_db->nameQuote('dateformat')."=".
		$this->_db->quote($data['dateformat']).", ".
		$this->_db->nameQuote('currency')."=".
		$this->_db->quote($data['currency']).", ".
		$this->_db->nameQuote('max_booking_period')."=".
		$this->_db->quote($data['max_booking_period']).", ".
		$this->_db->nameQuote('daysForCancellation')."=".
		$this->_db->quote($data['daysForCancellation']).", ".
		$this->_db->nameQuote('available_color')."=".
		$this->_db->quote($data['available_color']).", ".
		$this->_db->nameQuote('booked_color')."=".
		$this->_db->quote($data['booked_color']).", ".
		$this->_db->nameQuote('pending_color')."=".
		$this->_db->quote($data['pending_color']).", ".
		$this->_db->nameQuote('other_color')."=".
		$this->_db->quote($data['other_color']).", ".
		$this->_db->nameQuote('show_available')."=".
		$this->_db->quote($data['show_available']).", ".
		$this->_db->nameQuote('show_booked')."=".
		$this->_db->quote($data['show_booked']).", ".
		$this->_db->nameQuote('show_pending')."=".
		$this->_db->quote($data['show_pending']).", ".
		$this->_db->nameQuote('show_extra')."=".
		$this->_db->quote($data['show_extra']).", ".
		$this->_db->nameQuote('show_coupons')."=".
		$this->_db->quote($data['show_coupons']).", ".
		$this->_db->nameQuote('deposit_percent')."=".
		$this->_db->quote($data['deposit_percent']).", ".
		$this->_db->nameQuote('deposit_fixed')."=".
		$this->_db->quote($data['deposit_fixed']).", ".
		$this->_db->nameQuote('admin_email')."=".
		$this->_db->quote($data['admin_email']).", ".
		$this->_db->nameQuote('admin_email2')."=".
		$this->_db->quote($data['admin_email2']).", ".
		$this->_db->nameQuote('ok_url')."=".
		$this->_db->quote($data['ok_url']).", ".
		$this->_db->nameQuote('failure_url')."=".
		$this->_db->quote($data['failure_url']).", ".
		$this->_db->nameQuote('auto_confirm')."=".
		$this->_db->quote($data['auto_confirm']).", ".
		$this->_db->nameQuote('show_calendar')."=".
		$this->_db->quote($data['show_calendar']).", ".
		$this->_db->nameQuote('start_monday')."=".
		$this->_db->quote($data['start_monday']).", ".
		$this->_db->nameQuote('show_year_calendar')."=".
		$this->_db->quote($data['show_year_calendar']).", ".
		$this->_db->nameQuote('last_date')."=".
		$this->_db->quote(date("Y-m-d", strtotime($data['last_date']))).", ".
		$this->_db->nameQuote('show_daily_rates')."=".
		$this->_db->quote($data['show_daily_rates']).", ".
		$this->_db->nameQuote('normalize')."=".
		$this->_db->quote($data['normalize']).", ".
		$this->_db->nameQuote('show_bar')."=".
		$this->_db->quote($data['show_bar']).", ".
		$this->_db->nameQuote('new_template')."=".
		$this->_db->quote($data['new_template']).", ".
		$this->_db->nameQuote('prebooking_url')."=".
		$this->_db->quote($data['prebooking_url']).", ".
		$this->_db->nameQuote('admin_confirm')."=".
		$this->_db->quote($data['admin_confirm']).", ".
		$this->_db->nameQuote('late_booking')."=".
		$this->_db->quote($data['late_booking']).
		" WHERE ".$this->_db->nameQuote('id')." = ".$this->_db->quote('1');
		$this->_db->setQuery($sql);
		if (!$this->_db->query()) $res['code']=-1;


		return $res;
	}
}