<?php
/**
 * BlooKing - The King in Joomla Booking
 * @version 1.0
 * @author BlooKing.org. Based on BooKiTGold code by Costas Kakousis
 * @copyright (C) 2012-2013 by BlooKing.org (http://www.blooking.org)
 * @license GNU/GPL: http://www.gnu.org/copyleft/gpl.html
 *
 * If you fork this to create your own project, please make a reference to
 * BlooKing! someplace in your code and provide a link to
 * http://www.blooking.org
 *
 * This file is part of BlooKing! BlooKing is free software: you can
 * redistribute it and/or modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * BlooKing is distributed in the hope that it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details. You should have received a copy of the GNU General Public License
 * along with BlooKing.  If not, see <http://www.gnu.org/licenses/>.
 *   ______ __                __  __ __
 *	|   __ \  |.-----..-----.|  |/  |__|.-----..-----.
 *	|   __ <  ||  _  ||  _  ||     <|  ||     ||  _  |
 *	|______/__||_____||_____||__|\__|__||__|__||___  |
 *                                             |_____|
 **/
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport('joomla.application.component.model');

class BlookingModelRoom extends JModel {
	var $_data = null;
	var $_total = null;
	var $_pagination = null;

	function __construct() {
		parent::__construct();
		$mainframe = JFactory::getApplication();

		$limit = $mainframe->getUserStateFromRequest('global.list.limit', 'limit', $mainframe->getCfg('list_limit'), 'int');
		$limitstart = JRequest::getVar('limitstart', 0, '', 'int');

		$limitstart = ($limit != 0 ? (floor($limitstart / $limit) * $limit) : 0);

		$this->setState('limit', $limit);
		$this->setState('limitstart', $limitstart);
	}

	function _buildQuery() {
		$db =& $this->getDBO();

		$query = 'SELECT '.$db->nameQuote('#__bookitroom').'.*, '.
				$db->nameQuote('#__bookitcategory').'.'.$db->nameQuote('name').' AS '.
				$db->nameQuote('categoryname').' FROM '.$db->nameQuote('#__bookitroom').','.
				$db->nameQuote('#__bookitcategory').' WHERE '.$db->nameQuote('#__bookitroom').
				'.'.$db->nameQuote('idcategory').' = '.$db->nameQuote('#__bookitcategory').
				'.'.$db->nameQuote('idcategory');
		$query .= $this->_buildQueryWhere();
		$query .= $this->_buildContentOrderBy();
		return $query;
	}

	function _buildContentOrderBy() {
		$option = JRequest::getCmd('option');
		$mainframe = JFactory::getApplication();
		$db =& $this->_db;
		$orderby = '';

		$orders = array('idroom', 'name', 'categoryname');
		$filter_order = $mainframe->getUserStateFromRequest($option.'filter_order','filter_order','name');
		$filter_order_Dir = $mainframe->getUserStateFromRequest($option.'filter_order_Dir','filter_order_Dir','ASC');

		if($filter_order_Dir != 'ASC' && $filter_order_Dir != 'DESC') {
			$filter_order_Dir != 'ASC';
		}

		if (!in_array($filter_order, $orders)) {
			$filter_order='name';
		}

		$orderby = ' ORDER BY '.$db->nameQuote($filter_order).' '.$filter_order_Dir;

		if ($filter_order != 'name') {
			$orderby .= ' , '.$db->nameQuote('name');
		}

		return $orderby;
	}

	function _buildQueryWhere() {
		$filter_search = JRequest::getVar('filter_search');
		$where = array();

		if ($filter_search = trim($filter_search)) {
			$filter_search = JString::strtolower ($filter_search);
			$filter_search = $this->_db->getEscaped($filter_search);
			$where = 'AND ( LOWER('.$this->_db->nameQuote('#__bookitroom').'.'.
					$this->_db->nameQuote('name').') LIKE "%'.$filter_search.'%" '.
					' OR LOWER('.$this->_db->nameQuote('#__bookitcategory').'.'.
					$this->_db->nameQuote('name').') LIKE "%'.$filter_search.'%")';
		}

		return (count($where)) ? $where : ' ';
	}

	function getData() {
		$db =& $this->_db;
		if (empty($this->_data)) {
			$query = $this->_buildQuery();
			$this->_data = $this->_getList($query, $this->getState('limitstart'), $this->getState('limit'));
		}
		//die($this->_db->getQuery());
		return $this->_data;
	}

	function getTotal() {
		if (empty($this->_total)) {
			$query = $this->_buildQuery();
			$this->_total = $this->_getListCount($query);
		}
		return $this->_total;
	}
	 
	function getPagination() {
		if (empty($this->_pagination)) {
			jimport('joomla.html.pagination');
			$this->_pagination = new JPagination($this->getTotal(), $this->getState('limitstart'), $this->getState('limit') );
		}
		return $this->_pagination;
	}

	function _buildCopyQuery($id) {
		$db =& $this->_db;
		$query = 'SELECT * FROM '.$db->nameQuote('#__bookitroom').'WHERE idroom='.$id;
		$db->setQuery($query);
		$row = $db->loadRow();

		$data =new stdClass();
		$data->idroom = null;
		$data->idcategory = $row['1'];
		$data->name = 'Copy of '.$row['2'];
		$data->description = $row['3'];
		$data->url = $row['4'];

		$db->insertObject( '#__bookitroom', $data, 'idroom' );
		return true;
	}

	function _buildCategoriesQuery() {
		$query = 'SELECT * FROM '.$db->nameQuote('#__bookitcategory');
		return $query;
	}

	function getRoomCategories() {
		if (empty( $this->_categories )) {
			$query = $this->_buildCategoriesQuery();
			$this->_categories = $this->_getList( $query );
		}

		return $this->_categories;
	}

	function delete() {
		$cids = JRequest::getVar( 'cid', array(0), 'post', 'array' );
		$row =& $this->getTable('roomedit');
		$db =& $this->_db;
		foreach($cids as $cid) {
			if ($this->_checkForBookings($cid)>0) return -3;
				
			if (!$row->delete( $cid )) {
				$this->setError( $row->getErrorMsg() );
				return false;
			}

		}
		return 0;
	}

	function copy () {
		$cids = JRequest::getVar( 'cid', array(0), 'post', 'array' );

		if (!$this->_buildCopyQuery($cids['0'])) {
			return false;
		}

		return true;
	}

	function getCategoryName ($id) {
		$db =& $this->_db;
		$query = 'SELECT DISTINCT '.$db->nameQuote('name').' FROM '.
				$db->nameQuote('#__bookitcategory').' WHERE '.$db->nameQuote('idcategory').
				'='.$db->quote($id);
		$db->setQuery($query);
		$res = $db->loadResult();
		return res;
	}

	function _checkForBookings ($id) {
		$query = "SELECT COUNT(*) FROM ".$this->_db->nameQuote('#__bookitbooking').
		" WHERE ".$this->_db->nameQuote('idroom')."=".$this->_db->quote($id).
		" AND ".$this->_db->nameQuote('idguests').">".$this->_db->quote('0');
		$this->_db->setQuery($query);
		return $this->_db->loadResult();
	}
}