<?php
/**
 * BlooKing - The King in Joomla Booking
 * @version 1.0
 * @author BlooKing.org. Based on BooKiTGold code by Costas Kakousis
 * @copyright (C) 2012-2013 by BlooKing.org (http://www.blooking.org)
 * @license GNU/GPL: http://www.gnu.org/copyleft/gpl.html
 *
 * If you fork this to create your own project, please make a reference to
 * BlooKing! someplace in your code and provide a link to
 * http://www.blooking.org
 *
 * This file is part of BlooKing! BlooKing is free software: you can
 * redistribute it and/or modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * BlooKing is distributed in the hope that it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details. You should have received a copy of the GNU General Public License
 * along with BlooKing.  If not, see <http://www.gnu.org/licenses/>.
 *   ______ __                __  __ __
 *	|   __ \  |.-----..-----.|  |/  |__|.-----..-----.
 *	|   __ <  ||  _  ||  _  ||     <|  ||     ||  _  |
 *	|______/__||_____||_____||__|\__|__||__|__||___  |
 *                                             |_____|
 **/
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport('joomla.application.component.model');

class BlookingModelRoomcategory extends JModel
{
	var $_data;
	var $_total = null;
	var $_pagination = null;

	function __construct() {
		parent::__construct();
		$mainframe = JFactory::getApplication();

		$limit = $mainframe->getUserStateFromRequest('global.list.limit', 'limit', $mainframe->getCfg('list_limit'), 'int');
		$limitstart = JRequest::getVar('limitstart', 0, '', 'int');

		$limitstart = ($limit != 0 ? (floor($limitstart / $limit) * $limit) : 0);

		$this->setState('limit', $limit);
		$this->setState('limitstart', $limitstart);
	}

	function _buildQuery() {
		JLoader::register('BlookingHelper',JPATH_COMPONENT.'/helpers/BlookingHelper.php');
		$params = BlookingHelper::getParams();

		if ($params->multiroom != "2") {
			$roomStr = JText::_('COM_BOOKIT_ROOM');
		} else {
			$roomStr = JText::_('COM_BOOKIT_PROPERTY');
		}

		$guestStr = JText::_('COM_BOOKIT_GUEST');

		$query = 'SELECT *, CASE '.$this->_db->nameQuote('price_mode').' WHEN 0 THEN '.
				$this->_db->quote($roomStr).' WHEN 1 THEN '.$this->_db->quote($guestStr).
				' END AS '.$this->_db->nameQuote('chargeper').' FROM '.$this->_db->nameQuote('#__bookitcategory');
		$query .= $this->_buildQueryWhere();
		$query .= $this->_buildContentOrderBy();
		return $query;
	}

	function _buildContentOrderBy() {
		$option = JRequest::getCmd('option');
		$mainframe = JFactory::getApplication();
		$db =& $this->_db;
		$orderby = '';

		$orders = array('idcategory', 'name', 'nguests', 'nchilds', 'cost', 'adult_cost','child_cost', 'chargeper');
		$filter_order = $mainframe->getUserStateFromRequest($option.'filter_order','filter_order','name');
		$filter_order_Dir = $mainframe->getUserStateFromRequest($option.'filter_order_Dir','filter_order_Dir','ASC');

		if($filter_order_Dir != 'ASC' && $filter_order_Dir != 'DESC') {
			$filter_order_Dir != 'ASC';
		}

		if (!in_array($filter_order, $orders)) {
			$filter_order='name';
		}

		$orderby = ' ORDER BY '.$db->nameQuote($filter_order).' '.$filter_order_Dir;

		if ($filter_order != 'name') {
			$orderby .= ' , '.$db->nameQuote('name');
		}

		return $orderby;
	}

	function _buildQueryWhere() {
		$filter_search = JRequest::getVar('filter_search');
		$where = array();

		if ($filter_search = trim($filter_search)) {
			$filter_search = JString::strtolower ($filter_search);
			$filter_search = $this->_db->getEscaped($filter_search);
			$where = 'WHERE LOWER('.$this->_db->nameQuote('name').') LIKE "%'.$filter_search.'%" ';
		}

		return (count($where)) ? $where : ' ';
	}

	function _buildCopyQuery($id) {
		JLoader::register('BlookingHelper',JPATH_COMPONENT.'/helpers/BlookingHelper.php');
		$params = BlookingHelper::getParams();

		$db =& $this->_db;
		$query = ' SELECT * FROM '.$db->nameQuote('#__bookitcategory').' WHERE '.
				$db->nameQuote('idcategory').'='.$db->quote($id);
		$db->setQuery($query);
		$row = $db->loadRow();

		$data =new stdClass();

		$data->idcategory = null;
		$data->name = 'Copy of '.$row['1'];
		$data->nguests = $row['2'];
		$data->nchilds = $row['3'];
		$data->cost = $row['4'];
		$data->facilities = $row['5'];
		$data->description = $row['6'];
		$data->url = $row['7'];

		$data->adult_cost = $row['8'];
		$data->child_cost = $row['9'];
		$data->nguests_min = $row['10'];
		$data->nchilds_min = $row['11'];
		$data->min_stay = $row['12'];
		$data->max_stay = $row['13'];
		$data->price_mode = $row['14'];
		$data->max_in_total = $row['15'];
		$data->min_in_total = $row['16'];
		$data->start_day = $row['17'];
		$data->end_day = $row['18'];

		$db->insertObject( '#__bookitcategory', $data, 'idcategory' );
		$catid = $db->insertid();
		//CREATE ROOM DETAILS IF IN WHOLE PROPERTY MODE
		if ($params->multiroom == "2") {
			$db =& $this->_db;
			$query = ' SELECT * FROM '.$db->nameQuote('#__bookitroom').' WHERE '.
					$db->nameQuote('idcategory').'='.$db->quote($id);

			$db->setQuery($query);
			$roomrow = $db->loadRow();
				
			$roomdata =new stdClass();
				
			$roomdata->idroom = null;
			$roomdata->idcategory = $catid;
			$roomdata->name = "Copy of ".$roomrow['2'];
				
			$db->insertObject( '#__bookitroom', $roomdata, 'idroom' );
		}
		return true;
	}

	function delete() {
		JLoader::register('BlookingHelper',JPATH_COMPONENT.'/helpers/BlookingHelper.php');
		$params = BlookingHelper::getParams();

		$cids = JRequest::getVar( 'cid', array(0), 'post', 'array' );
		$row =& $this->getTable('roomcategoryedit');

		foreach($cids as $cid) {
			if ($params->multiroom != "2") {
				if ($this->_checkForRooms($cid)>0) return -1;
			}
			if ($this->_checkForRules($cid)>0) return -2;
			if ($this->_checkForBookings($cid)>0) return -3;
				
			if (!$row->delete( $cid )) {
				$this->setError( $row->getErrorMsg() );
				return false;
			}
			//DELETE ROOM DETAILS IF IN WHOLE PROPERTY MODE
			if ($params->multiroom == "2") {
				$sql = "DELETE FROM ".$this->_db->nameQuote('#__bookitroom')
				." WHERE ".$this->_db->nameQuote('idcategory')."="
						.$this->_db->quote($cid).";";
				$this->_db->setQuery($sql);

				if (!$this->_db->query()) {
					$this->setError($db->getErrorMsg());
					return false;
				}
			}
		}

		return 0;
	}

	function copy () {
	 $cids = JRequest::getVar( 'cid', array(0), 'post', 'array' );

	 foreach($cids as $cid) {
	 	if (!$this->_buildCopyQuery($cid)) {
	 		return false;
	 	}
	 }

	 return true;
	}

	function getData() {
		if (empty($this->_data)) {
			$query = $this->_buildQuery();
			$this->_data = $this->_getList($query, $this->getState('limitstart'), $this->getState('limit'));
		}

		return $this->_data;
	}

	function getTotal() {
		if (empty($this->_total)) {
			$query = $this->_buildQuery();
			$this->_total = $this->_getListCount($query);
		}
		return $this->_total;
	}
	 
	function getPagination() {
		if (empty($this->_pagination)) {
			jimport('joomla.html.pagination');
			$this->_pagination = new JPagination($this->getTotal(), $this->getState('limitstart'), $this->getState('limit') );
		}
		return $this->_pagination;
	}
		
	function _checkForRooms ($id) {
		$query = "SELECT COUNT(*) FROM ".
				$this->_db->nameQuote('#__bookitroom').
				" WHERE ".$this->_db->nameQuote('idcategory')."=".
				$this->_db->quote($id);
		$this->_db->setQuery($query);
		return $this->_db->loadResult();
	}

	function _checkForRules ($id) {
		$query = "SELECT COUNT(*) FROM ".
				$this->_db->nameQuote('#__bookitrules').
				" WHERE ".$this->_db->nameQuote('idcategory')."=".
				$this->_db->quote($id);
		$this->_db->setQuery($query);
		return $this->_db->loadResult();
	}

	function _checkForBookings ($id) {
		$query = "SELECT COUNT(*) FROM ".
				$this->_db->nameQuote('#__bookitbooking').
				" WHERE ".$this->_db->nameQuote('idcategory')."=".
				$this->_db->quote($id)." AND ".$this->_db->nameQuote('idguests').">".
				$this->_db->quote('0');
		$this->_db->setQuery($query);
		return $this->_db->loadResult();
	}
}