<?php
/**
 * BlooKing - The King in Joomla Booking
 * @version 1.0
 * @author BlooKing.org. Based on BooKiTGold code by Costas Kakousis
 * @copyright (C) 2012-2013 by BlooKing.org (http://www.blooking.org)
 * @license GNU/GPL: http://www.gnu.org/copyleft/gpl.html
 *
 * If you fork this to create your own project, please make a reference to
 * BlooKing! someplace in your code and provide a link to
 * http://www.blooking.org
 *
 * This file is part of BlooKing! BlooKing is free software: you can
 * redistribute it and/or modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * BlooKing is distributed in the hope that it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details. You should have received a copy of the GNU General Public License
 * along with BlooKing.  If not, see <http://www.gnu.org/licenses/>.
 *   ______ __                __  __ __
 *	|   __ \  |.-----..-----.|  |/  |__|.-----..-----.
 *	|   __ <  ||  _  ||  _  ||     <|  ||     ||  _  |
 *	|______/__||_____||_____||__|\__|__||__|__||___  |
 *                                             |_____|
 **/
// No direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport('joomla.application.component.model');

class BlookingModelRoomcategoryedit extends JModel
{
	var $_data;
	var $_id;
	function __construct()
	{
		parent::__construct();

		$array = JRequest::getVar('cid',  0, '', 'array');
		$this->setId((int)$array[0]);
		JLoader::register('BlookingHelper',
		JPATH_COMPONENT.'/helpers/BlookingHelper.php');
	}

	function setId($id)
	{
		// Set id and wipe data
		$this->_id		= $id;
		$this->_data	= null;
	}

	/**
	 * Returns the query
	 * @return string The query to be used to retrieve the rows from the database
	 */
	function _buildQuery()
	{

		$cid = JRequest::getVar( 'cid', array(0), 'post', 'array' );
		$id=$cid[0];
		if ($id==0)
		{
			$cid = JRequest::getVar('cid', '', 'get');

			$id = $cid[0];
		}

		$query = ' SELECT * '
				. ' FROM #__bookitcategory WHERE idcategory='.$id;
		return $query;
	}



	function &getData()
	{
		// Load the data
		if (empty( $this->_data )) {
			$query = ' SELECT * FROM #__bookitcategory '.
					'  WHERE idcategory = '.$this->_id;
			$this->_db->setQuery( $query );
			$this->_data = $this->_db->loadObject();
				
		}
		if (!$this->_data) {
			$this->_data = new stdClass();
			$this->_data->idcategory = 0;
			$this->_data->name = null;
			$this->_data->nguests = null;
			$this->_data->nchilds = null;
			$this->_data->cost = null;
			$this->_data->adult_cost = null;
			$this->_data->child_cost = null;
			$this->_data->facilities = null;
			$this->_data->description = null;
			$this->_data->url = null;
			$this->_data->nguests_min = null;
			$this->_data->nchilds_min = null;
			$this->_data->min_stay = null;
			$this->_data->max_stay = null;
			$this->_data->price_mode = null;
			$this->_data->max_in_total = null;
			$this->_data->min_in_total = null;
			$this->_data->start_day = null;
			$this->_data->end_day = null;

		}

		return $this->_data;
	}


	function store()
	{
		$row =& $this->getTable();

		$data = JRequest::get( 'post' );
		$name = JRequest::getVar('name');
		$nguests = JRequest::getVar('nguests');
		$cost = JRequest::getVar('cost');
		$adult_cost = JRequest::getVar('adult_cost');
		$child_cost = JRequest::getVar('child_cost');
		$id = JRequest::getVar('idcategory');
		$startDays = JRequest::getVar('start_day');
		$endDays = JRequest::getVar('end_day');
		$res["id"]=$id;

		//IMPLODE START DAYS
		$n = count($startDays);
		$strSelectedStartDays = "";

		for($i=0; $i < $n; $i++) {
			$strSelectedStartDays .= $startDays[$i].",";
		}
		 
		$data['start_day'] = $strSelectedStartDays;
		 
		//IMPLODE END DAYS
		$n = count($endDays);
		$strSelectedEndDays = "";

		for($i=0; $i < $n; $i++) {
			$strSelectedEndDays .= $endDays[$i].",";
		}
		 
		$data['end_day'] = $strSelectedEndDays;
		 
		if ($data['price_mode'] == "0") {
			$data['adult_cost'] = null;
			$data['child_cost'] = null;
		} else if($data['price_mode'] == "1") {
			$data['cost'] = null;
		}
		 
		//CHECK IF THE NAME IS UNIQUE
		$query = "SELECT COUNT(*) FROM ".
				$this->_db->nameQuote('#__bookitcategory')." WHERE ".
				$this->_db->nameQuote('name')."=".
				$this->_db->quote($name). " AND ".
				$this->_db->nameQuote('idcategory')."!=".$id;
		$this->_db->setQuery($query);
		$names_found = $this->_db->loadResult();
			
		if ($name==""||$nguests=="0"||!is_numeric($nguests)||
				($cost=="0" && $adult_cost=="0" )|| (!is_numeric($cost) &&
						!is_numeric($adult_cost)))
		{
			$res["code"]=-1;
			return $res;
		}
		else if ($nguests < 0 || $cost < 0)
		{
			$res["code"]=-1;
			return $res;
		}
		else if ($names_found > 0)
		{
			$res["code"]=-3;
			return $res;
		}
		$data['description']=JRequest::getVar( 'description', '', 'post',
				'string', JREQUEST_ALLOWRAW );

		$lang = JRequest::getVar('language','en');
		if($lang!='en')
		{
			$data['description_'.$lang] = $data['description'];
			unset($data['description']);
				
			$data['name_'.$lang] = $data['name'];
				
			if ($this->_alreadySet('#__bookitcategory', 'name', $id))
				unset($data['name']);
				

			//Add the columns if the translations do not exist
			if(!BlookingHelper::columnExists('#__bookitcategory','description_'.$lang))
			{
				$query = "ALTER TABLE ".$this->_db->nameQuote("#__bookitcategory").
				" ADD ".$this->_db->nameQuote('description_'.$lang).
				" TEXT NULL DEFAULT NULL";
				$this->_db->setQuery($query);
				$this->_db->query();
			}
			if(!BlookingHelper::columnExists('#__bookitcategory','name_'.$lang))
			{
				$query = "ALTER TABLE ".$this->_db->nameQuote("#__bookitcategory").
				" ADD ".$this->_db->nameQuote('name_'.$lang).
				" TEXT NULL DEFAULT NULL";
				$this->_db->setQuery($query);
				$this->_db->query();
			}
		}
		$res['lang'] = $lang;


		// Bind the form fields to the Bookitbooking table
		if (!$row->bind($data)) {

			$this->setError($this->_db->getErrorMsg());
			$res["code"]=-2;
			return $res;
		}

		// Make sure the record is valid
		if (!$row->check()) {

			$this->setError($this->_db->getErrorMsg());
			$res["code"]=-2;
			return $res;
		}


		// Store to the database
		if (!$row->store()) {

			$this->setError($this->_db->getErrorMsg());
			$res["code"]=-2;
			return $res;
		}

		if ($res["id"]==0) {
			$res["id"]=$row->idcategory;
			$res["code"]=0;
			//return $res;
		}

		//AUTO INSERT ROOM IF IN WHOLE PROPERTY MODE
		$params = BlookingHelper::getParams();

		if ($params->multiroom=="2") {
			$sql = "SELECT COUNT(*) FROM ".$this->_db->nameQuote('#__bookitroom').
			" WHERE ".$this->_db->nameQuote('idcategory')." = ".
			$this->_db->quote($res['id']).";";
			$this->_db->setQuery($sql);
			$count = $this->_db->loadResult();

			if ($count == "0") {
				$sql = "INSERT INTO ".$this->_db->nameQuote('#__bookitroom');
				$sql .= " (".$this->_db->nameQuote('idcategory').",".$this->_db->nameQuote('name');
				$sql .= ") VALUES (".$this->_db->quote($res['id']).",".$this->_db->quote($name).");";

				$this->_db->setQuery($sql);
				$this->_db->query();
			}
		}
		return $res;
	}
	function _alreadySet($table, $column, $id)
	{
		$query = "SELECT ".$this->_db->nameQuote($column).
		" FROM ".$this->_db->nameQuote($table).
		" WHERE ".$this->_db->nameQuote('idcategory')."=".
		$this->_db->quote($id);
		$this->_db->setQuery($query);
		if($this->_db->loadResult()!="") return true;
		else return false;
	}




}