<?php
/**
 * BlooKing - The King in Joomla Booking
 * @version 1.0
 * @author BlooKing.org. Based on BooKiTGold code by Costas Kakousis
 * @copyright (C) 2012-2013 by BlooKing.org (http://www.blooking.org)
 * @license GNU/GPL: http://www.gnu.org/copyleft/gpl.html
 *
 * If you fork this to create your own project, please make a reference to
 * BlooKing! someplace in your code and provide a link to
 * http://www.blooking.org
 *
 * This file is part of BlooKing! BlooKing is free software: you can
 * redistribute it and/or modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * BlooKing is distributed in the hope that it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details. You should have received a copy of the GNU General Public License
 * along with BlooKing.  If not, see <http://www.gnu.org/licenses/>.
 *   ______ __                __  __ __
 *	|   __ \  |.-----..-----.|  |/  |__|.-----..-----.
 *	|   __ <  ||  _  ||  _  ||     <|  ||     ||  _  |
 *	|______/__||_____||_____||__|\__|__||__|__||___  |
 *                                             |_____|
 **/
// No direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport('joomla.application.component.model');

class BlookingModelRoomedit extends JModel
{
	var $_data;
	var $_categories;
	var $_category;
	var $_extra;

	var $_id;
	function __construct()
	{
		parent::__construct();

		$array = JRequest::getVar('cid',  0, '', 'array');
		$this->setId((int)$array[0]);

	}

	function setId($id)
	{
		// Set id and wipe data
		$this->_id		= $id;
		$this->_data	= null;
	}
	/**
	 * Returns the query
	 * @return string The query to be used to retrieve the rows from the database
	 */
	function _buildQuery()
	{

		$cid = JRequest::getVar( 'cid', array(0), 'post', 'array' );
		$id=$cid[0];
		if ($id==0)
		{
			$cid = JRequest::getVar('cid', '', 'get');
			$id = $cid[0];
		}

			
		$query = ' SELECT * '
				. ' FROM #__bookitroom WHERE idroom='.$id;
		return $query;
	}

	function _buildCategoriesQuery()
	{
		$query = ' SELECT * '
				. ' FROM #__bookitcategory' ;
		return $query;
	}

	function _buildCategoryQuery()
	{

		$cid = JRequest::getVar( 'cid', array(0), 'post', 'array' );
		$id=$cid[0];
		if ($id==0)
		{
			$cid = JRequest::getVar('cid', '', 'get');
			$id = $cid[0];
		}
		$db =& JFactory::getDBO();
		$query = ' SELECT idcategory '
				. ' FROM #__bookitroom WHERE idroom='.$id;
		$db->setQuery($query);
		$categoryid = $db->loadResult();

		$query2 = ' SELECT name '
				. ' FROM #__bookitcategory WHERE idcategory='.$categoryid;
		$db->setQuery($query2);
		$categoryname = $db->loadResult();

		return $categoryname;
	}




	function &getData()
	{
		// Load the data
		if (empty( $this->_data )) {
			$query = ' SELECT * FROM #__bookitroom '.
					'  WHERE idroom = '.$this->_id;
			$this->_db->setQuery( $query );
			$this->_data = $this->_db->loadObject();
		}
		if (!$this->_data) {
			$this->_data = new stdClass();


			$this->_data->idroom = 0;
			$this->_data->idcategory = 0;
			$this->_data->name = null;
			$this->_data->description = null;
			$this->_data->url = null;

		}


		return $this->_data;
	}


	function getRoomCategories()
	{
			
		// Lets load the data if it doesn't already exist
		if (empty( $this->_categories ))
		{

			$query = $this->_buildCategoriesQuery();
			$this->_categories = $this->_getList( $query );
		}

		return $this->_categories;
	}

	function getRoomCategory()
	{
			
		// Lets load the data if it doesn't already exist
		if (empty( $this->_category ))
		{
			$this->_category = $this->_buildCategoryQuery();
		}

		return $this->_category;
	}



	/**
	 * Method to store a record
	 */
	function store()
	{
		$row =& $this->getTable();

		$data = JRequest::get( 'post' );
		$name = JRequest::getVar('name');
		$catid = JRequest::getVar('idcategory');
		$idroom = JRequest::getVar('idroom');
		$quantity = JRequest::getVar('quantity');

		unset($data['quantity']);
		$res['id']=$idroom;


		if ($name==""||$catid==0)
		{
			$res['code']=-1;
			return $res;
		}
		else if (intval($quantity)<=0 )
		{
			$quantity=1;
		}

		for ($i=1; $i<=$quantity; $i++)
		{
			if ($quantity>1)
				$data['name'] = $name."_".$i;
			// Bind the form fields to the Bookitbooking table
			if (!$row->bind($data))
			{
				$this->setError($this->_db->getErrorMsg());
				$res['code']=-2;
				return $res;
			}

			// Make sure the record is valid
			if (!$row->check()) {

				$this->setError($this->_db->getErrorMsg());
				$res['code']=-2;
				return $res;

			}
			// Store to the database
			if (!$row->store()) {

				$this->setError($this->_db->getErrorMsg());
				$res['code']=-2;
				return $res;

			}
		}
		if ($idroom==0)
		{
			$res['id']=$row->idroom;
			$res['code']=0;
			return $res;
		}
		$res['code']=0;
		return $res;
	}

}