<?php
/**
 * BlooKing - The King in Joomla Booking
 * @version 1.0
 * @author BlooKing.org. Based on BooKiTGold code by Costas Kakousis
 * @copyright (C) 2012-2013 by BlooKing.org (http://www.blooking.org)
 * @license GNU/GPL: http://www.gnu.org/copyleft/gpl.html
 *
 * If you fork this to create your own project, please make a reference to
 * BlooKing! someplace in your code and provide a link to
 * http://www.blooking.org
 *
 * This file is part of BlooKing! BlooKing is free software: you can
 * redistribute it and/or modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * BlooKing is distributed in the hope that it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details. You should have received a copy of the GNU General Public License
 * along with BlooKing.  If not, see <http://www.gnu.org/licenses/>.
 *   ______ __                __  __ __
 *	|   __ \  |.-----..-----.|  |/  |__|.-----..-----.
 *	|   __ <  ||  _  ||  _  ||     <|  ||     ||  _  |
 *	|______/__||_____||_____||__|\__|__||__|__||___  |
 *                                             |_____|
 **/
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport('joomla.application.component.model');

class BlookingModelRoomextra extends JModel {
	var $_data;
	var $_total = null;
	var $_pagination = null;

	function __construct() {
		parent::__construct();
		$mainframe = JFactory::getApplication();

		$limit = $mainframe->getUserStateFromRequest('global.list.limit', 'limit', $mainframe->getCfg('list_limit'), 'int');
		$limitstart = JRequest::getVar('limitstart', 0, '', 'int');

		$limitstart = ($limit != 0 ? (floor($limitstart / $limit) * $limit) : 0);

		$this->setState('limit', $limit);
		$this->setState('limitstart', $limitstart);
	}

	function _buildQuery() {
		$bookingStr = JText::_('COM_BOOKIT_BOOKING');
		$nightStr = JText::_('COM_BOOKIT_NIGHT');
		$guestStr = JText::_('COM_BOOKIT_GUEST');
		$adultStr = JText::_('COM_BOOKIT_ADULT');
		$childStr = JText::_('COM_BOOKIT_CHILD');
		$qtyStr = JText::_('COM_BOOKIT_QUANTITY');
		$guestNightStr = JText::_('COM_BOOKIT_GUEST_NIGHT');
		$adultNightStr = JText::_('COM_BOOKIT_ADULT_NIGHT');
		$childNightStr = JText::_('COM_BOOKIT_CHILD_NIGHT');
		$qtyNightStr = JText::_('COM_BOOKIT_QUANTITY_NIGHT');

		$query = ' SELECT *, CASE '.$this->_db->nameQuote('value_type').
		' WHEN 1 THEN '.$this->_db->quote($bookingStr).
		' WHEN 2 THEN '.$this->_db->quote($nightStr).
		' WHEN 3 THEN '.$this->_db->quote($guestStr).
		' WHEN 4 THEN '.$this->_db->quote($adultStr).
		' WHEN 5 THEN '.$this->_db->quote($childStr).
		' WHEN 6 THEN '.$this->_db->quote($qtyStr).
		' WHEN 7 THEN '.$this->_db->quote($guestNightStr).
		' WHEN 8 THEN '.$this->_db->quote($adultNightStr).
		' WHEN 9 THEN '.$this->_db->quote($childNightStr).
		' WHEN 10 THEN '.$this->_db->quote($qtyNightStr).
		' END AS '.$this->_db->quote('valueper').' FROM '.
		$this->_db->nameQuote('#__bookitextra');
		$query .= $this->_buildQueryWhere();
		$query .= $this->_buildContentOrderBy();
		return $query;
	}

	function _buildContentOrderBy() {
		$option = JRequest::getCmd('option');
		$mainframe = JFactory::getApplication();
		$db =& $this->_db;
		$orderby = '';

		$orders = array('idextra', 'name', 'valueper', 'ordering');
		$filter_order = $mainframe->getUserStateFromRequest($option.'filter_order','filter_order','ordering');
		$filter_order_Dir = $mainframe->getUserStateFromRequest($option.'filter_order_Dir','filter_order_Dir','ASC');

		if($filter_order_Dir != 'ASC' && $filter_order_Dir != 'DESC') {
			$filter_order_Dir != 'ASC';
		}

		if (!in_array($filter_order, $orders)) {
			$filter_order='ordering';
		}

		$orderby = ' ORDER BY '.$db->nameQuote($filter_order).' '.$filter_order_Dir;

		if ($filter_order != 'ordering') {
			$orderby .= ' , '.$db->nameQuote('name');
		}

		return $orderby;
	}

	function _buildQueryWhere() {
		$filter_search = JRequest::getVar('filter_search');
		$where = array();

		if ($filter_search = trim($filter_search)) {
			$filter_search = JString::strtolower ($filter_search);
			$filter_search = $this->_db->getEscaped($filter_search);
			$where = 'WHERE LOWER('.$this->_db->nameQuote('#__bookitextra').'.'.
					$this->_db->nameQuote('name').') LIKE "%'.$filter_search.'%" ';
		}

		return (count($where)) ? $where : ' ';
	}

	function _buildCopyQuery($id) {
		$db =& $this->_db;
		$query = ' SELECT * FROM '.$db->nameQuote('#__bookitextra').' WHERE '.
				$db->nameQuote('idextra').'='.$db->quote($id);
		$db->setQuery($query);
		$row = $db->loadRow();

		$data =new stdClass();

		$data->idextra = null;
		$data->name = 'Copy of '.$row['1'];
		$data->extra_type = $row['2'];
		$data->value_fix = $row['3'];
		$data->value_percent = $row['4'];
		$data->value_type = $row['5'];
		$data->description = $row['6'];
		$data->idcategories = $row['7'];
		$db->insertObject( '#__bookitextra', $data, 'idextra' );
		return true;
	}

	function delete() {
		$cids = JRequest::getVar( 'cid', array(0), 'post', 'array' );
		$row =& $this->getTable('roomextraedit');

		foreach($cids as $cid) {
			if (!$row->delete( $cid )) {
				$this->setError( $row->getErrorMsg() );
				return false;
			}
		}

		return true;
	}

	function copy () {
	 $cids = JRequest::getVar( 'cid', array(0), 'post', 'array' );

	 foreach($cids as $cid) {
	 	if (!$this->_buildCopyQuery($cid)) {
	 		return false;
	 	}
	 }

	 return true;
	}

	function getData() {
		if (empty($this->_data)) {
			$query = $this->_buildQuery();
			$this->_data = $this->_getList($query, $this->getState('limitstart'), $this->getState('limit'));
		}

		return $this->_data;
	}

	function publish() {
		$cid = JRequest::getVar( 'cid', array(), '', 'array' );

		if( JRequest::getVar('task') == 'publish') {
			$publish = 1;
		} else {
			$publish = 0;
		}

		$row =& $this->getTable('roomextra');
		$result = $row->publish($cid, $publish);

		return $result;
	}

	function saveorder() {
		$cid	= JRequest::getVar( 'cid', array(), 'post', 'array' );
		$total	= count( $cid );
		$order= JRequest::getVar( 'order', array(0), 'post', 'array' );
		JArrayHelper::toInteger($order, array(0));

		$row = $this->getTable('roomextra');
		// update ordering values
		for( $i=0; $i < $total; $i++ ) {
			$row->load( (int) $cid[$i] );

			if ($row->ordering != $order[$i]) {
				$row->ordering = $order[$i];
				if (!$row->store()) {
					JError::raiseError(500, $db->getErrorMsg() );
				}
			}
		}

		$reorder = $row->reorder();

		return $reorder;
	}

	function reorder($inc) {
		$cid	= JRequest::getVar( 'cid', array(), 'post', 'array' );
		$row = $this->getTable('roomextra');
		$row->load( $cid[0] );
		$result =$row->move($inc);//, 'idextra = '. (int) $row->idextra .' AND published != 0' );

		return $result;
	}


	function getTotal() {
		if (empty($this->_total)) {
			$query = $this->_buildQuery();
			$this->_total = $this->_getListCount($query);
		}
		return $this->_total;
	}
	 
	function getPagination() {
		if (empty($this->_pagination)) {
			jimport('joomla.html.pagination');
			$this->_pagination = new JPagination($this->getTotal(), $this->getState('limitstart'), $this->getState('limit') );
		}
		return $this->_pagination;
	}
}