<?php
/**
 * BlooKing - The King in Joomla Booking
 * @version 1.0
 * @author BlooKing.org. Based on BooKiTGold code by Costas Kakousis
 * @copyright (C) 2012-2013 by BlooKing.org (http://www.blooking.org)
 * @license GNU/GPL: http://www.gnu.org/copyleft/gpl.html
 *
 * If you fork this to create your own project, please make a reference to
 * BlooKing! someplace in your code and provide a link to
 * http://www.blooking.org
 *
 * This file is part of BlooKing! BlooKing is free software: you can
 * redistribute it and/or modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * BlooKing is distributed in the hope that it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details. You should have received a copy of the GNU General Public License
 * along with BlooKing.  If not, see <http://www.gnu.org/licenses/>.
 *   ______ __                __  __ __
 *	|   __ \  |.-----..-----.|  |/  |__|.-----..-----.
 *	|   __ <  ||  _  ||  _  ||     <|  ||     ||  _  |
 *	|______/__||_____||_____||__|\__|__||__|__||___  |
 *                                             |_____|
 **/
// No direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport('joomla.application.component.model');

class BlookingModelRoomextraedit extends JModel
{
	var $_data;
	var $_id;
	function __construct()
	{
		parent::__construct();

		$array = JRequest::getVar('cid',  0, '', 'array');
		$this->setId((int)$array[0]);
		JLoader::register('BlookingHelper',
		JPATH_COMPONENT.'/helpers/BlookingHelper.php');
	}

	function setId($id)
	{
		// Set id and wipe data
		$this->_id		= $id;
		$this->_data	= null;
	}

	/**
	 * Returns the query
	 * @return string The query to be used to retrieve the rows from the database
	 */
	function _buildQuery()
	{

		$cid = JRequest::getVar( 'cid', array(0), 'post', 'array' );
		$id=$cid[0];
		if ($id==0)
		{
			$cid = JRequest::getVar('cid', '', 'get');
			$id = $cid[0];
		}

			
		$query = ' SELECT * '
				. ' FROM #__bookitextra WHERE idextra='.$id;
		return $query;
	}

	/**
	 * Retrieves the bookings
	 * @return array Array of objects containing the data from the database
	 */
	function &getData()
	{
		// Load the data
		if (empty( $this->_data )) {
			$query = ' SELECT * FROM #__bookitextra '.
					'  WHERE idextra = '.$this->_id;
			$this->_db->setQuery( $query );
			$this->_data = $this->_db->loadObject();
		}
		if (!$this->_data) {
			$this->_data = new stdClass();
			$this->_data->idextra = 0;
			$this->_data->name = null;
			$this->_data->extra_type = 0;
			$this->_data->value_fix = 0;
			$this->_data->value_percent = 0;
			$this->_data->value_type = 0;
			$this->_data->description = null;
			// MRS
			$this->_data->idcategories = null;
			// MRE

		}


		return $this->_data;
	}
	/**
	 * Method to store a record
	 */
	function store()
	{
		//CHECK HIGHEST ORDER
		$query = "SELECT MAX(".$this->_db->nameQuote("ordering").") FROM ".
				$this->_db->nameQuote("#__bookitextra");
		$this->_db->setQuery($query);
		$ordering = $this->_db->loadResult();
		//

		$row =& $this->getTable();

		$data = JRequest::get( 'post' );
		$data['ordering'] = $ordering + 1;
		$name = JRequest::getVar('name');
		$extra_type = JRequest::getVar('extra_type');
		$value_fix = JRequest::getVar('value_fix');
		$value_percent = JRequest::getVar('value_percent');
		$value_type = JRequest::getVar('value_type');
		$idcategories = implode(",", JRequest::getVar('idcategories'));

		$id = JRequest::getVar('idextra',0);
		$res["id"]=$id;
		if ($name==""|| $extra_type==""|| ($value_fix==""&&$value_percent=="")
				||$value_type=="")
		{
			$res["code"]=-1;
			return $res;
		}
		else if (!is_numeric($value_fix) && !is_numeric($value_percent))
		{
				
			$res["code"]=-1;
			return $res;

		}
		if ($idcategories!="")
		{

			$categories = explode(",",$idcategories);
				
			if (count($categories)>1 && in_array(-1,$categories))
			{
				$res["code"]=-1;
				return $res;
			}
		}
		else
		{
			$res["code"]=-1;
			return $res;
		}

		$data['description']=JRequest::getVar( 'description', '', 'post',
				'string', JREQUEST_ALLOWHTML );

		$lang = JRequest::getVar('language','en');
		if($lang!='en')
		{
			$data['description_'.$lang] = $data['description'];
			unset($data['description']);
			$data['name_'.$lang] = $data['name'];
			if ($this->_alreadySet('#__bookitextra', 'name', $id))
			{
				unset($data['name']);
			}
				
				
			//Add the columns if the translations do not exist
			if(!BlookingHelper::columnExists('#__bookitextra','description_'.$lang))
			{
				$query = "ALTER TABLE ".$this->_db->nameQuote("#__bookitextra").
				" ADD ".$this->_db->nameQuote('description_'.$lang).
				" TEXT NULL DEFAULT NULL";
				$this->_db->setQuery($query);
				$this->_db->query();
			}
			if(!BlookingHelper::columnExists('#__bookitextra','name_'.$lang))
			{
				$query = "ALTER TABLE ".$this->_db->nameQuote("#__bookitextra").
				" ADD ".$this->_db->nameQuote('name_'.$lang).
				" TEXT NULL DEFAULT NULL";
				$this->_db->setQuery($query);
				$this->_db->query();
			}
		}
		$res["lang"]=$lang;


		$data['idcategories']=$idcategories;


		// Bind the form fields to the Bookitbooking table
		if (!$row->bind($data)) {

			$this->setError($this->_db->getErrorMsg());
			$res["code"]=-2;
			return $res;
		}

		// Make sure the record is valid
		if (!$row->check()) {

			$this->setError($this->_db->getErrorMsg());
			$res["code"]=-2;
			return $res;
		}

		// Store to the database
		if (!$row->store()) {

			$this->setError($this->_db->getErrorMsg());
			$res["code"]=-2;
			return $res;
		}

		if ($res["id"]==0)
			$res["id"]=$row->idextra;
		$res["code"]=0;
		return $res;
	}

	function getRoomCategories () {
		$db =& JFactory::getDBO();
		$sql = "SELECT idcategory, name FROM #__bookitcategory";
		$db->setQuery($sql);
		return $db->loadObjectList();
	}
	function _alreadySet($table, $column, $id)
	{
		$query = "SELECT ".$this->_db->nameQuote($column).
		" FROM ".$this->_db->nameQuote($table).
		" WHERE ".$this->_db->nameQuote('idextra')."=".
		$this->_db->quote($id);
		$this->_db->setQuery($query);
		if($this->_db->loadResult()!="") return true;
		else return false;
	}


}