<?php
/**
 * BlooKing - The King in Joomla Booking
 * @version 1.0
 * @author BlooKing.org. Based on BooKiTGold code by Costas Kakousis
 * @copyright (C) 2012-2013 by BlooKing.org (http://www.blooking.org)
 * @license GNU/GPL: http://www.gnu.org/copyleft/gpl.html
 *
 * If you fork this to create your own project, please make a reference to
 * BlooKing! someplace in your code and provide a link to
 * http://www.blooking.org
 *
 * This file is part of BlooKing! BlooKing is free software: you can
 * redistribute it and/or modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * BlooKing is distributed in the hope that it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details. You should have received a copy of the GNU General Public License
 * along with BlooKing.  If not, see <http://www.gnu.org/licenses/>.
 *   ______ __                __  __ __
 *	|   __ \  |.-----..-----.|  |/  |__|.-----..-----.
 *	|   __ <  ||  _  ||  _  ||     <|  ||     ||  _  |
 *	|______/__||_____||_____||__|\__|__||__|__||___  |
 *                                             |_____|
 **/
// No direct access
defined( '_JEXEC' ) or die( 'Restricted access' );
jimport('joomla.application.component.model');

class BlookingModelRulesedit extends JModel {
	var $_data;
	var $_id;
	function __construct() {
		parent::__construct();
		$array = JRequest::getVar('cid',  0, '', 'array');
		$this->setId((int)$array[0]);
		JLoader::register('BlookingHelper',
		JPATH_COMPONENT.'/helpers/BlookingHelper.php');
	}

	function setId($id) {
		$this->_id		= $id;
		$this->_data	= null;
	}

	function _buildQuery() {
		$cid = JRequest::getVar( 'cid', array(0), 'post', 'array' );
		$id=$cid[0];
		if ($id==0) {
			$cid = JRequest::getVar('cid', '', 'get');
			$id = $cid[0];
		}
		$query = ' SELECT * FROM #__bookitrules WHERE idrule='.$id;
		return $query;
	}

	function &getData() {
		if (empty( $this->_data )) {
			$query = ' SELECT * FROM #__bookitrules'.
					'  WHERE idrule = '.$this->_id;
			$this->_db->setQuery( $query );
			$this->_data = $this->_db->loadObject();
		}
		if (!$this->_data) {
			$this->_data = new stdClass();
			$this->_data->idrule = 0;
			$this->_data->idcategory = null;
			$this->_data->name = null;
			$this->_data->value = null;
			$this->_data->value_child = null;
			$this->_data->value_mode = null;
			$this->_data->mode = null;
			$this->_data->published = null;
			$this->_data->valid_from = null;
			$this->_data->valid_to = null;
			$this->_data->xvar = null;
			$this->_data->type = null;
			$this->_data->selected_days = null;
			$this->_data->apply_on = null;
			$this->_data->price_mode = null;
			$this->_data->coupon=null;
			$this->_data->quantity=null;
			$this->_data->times_used=null;
			$this->_data->code=null;
		}
		return $this->_data;
	}

	function store() {
		$row =& $this->getTable();
		$data = JRequest::get( 'post' );
		$res = new stdClass();
		$res->code=0;
		$res->msg="";
		$name = JRequest::getVar('name');
		$idcategory = implode(",", JRequest::getVar('idcategory'));
		$value_mode = JRequest::getVar('value_mode');
		$value = JRequest::getVar('value');
		$rule_modes = JRequest::getVar('rule_modes');
		$rule_types = JRequest::getVar('type');
		$xvar = JRequest::getVar('xvar');
		$valid_from = JRequest::getVar('valid_from');
		$valid_to = JRequest::getVar('valid_to');
		$selected_days = JRequest::getVar('selected_days');
		$coupon = JRequest::getVar('coupon',0);


		if ($coupon==1)
		{
			$data['apply_on']=0;
		}


		$new_valid_from = date("Y-m-d", strtotime($valid_from));
		$new_valid_to = date("Y-m-d", strtotime($valid_to));

		if ($new_valid_to < $new_valid_from) {
			$res->code=-3;
			return $res;
		} else {
			$data['valid_from']  = $new_valid_from;
			$data['valid_to'] = $new_valid_to;
		}

		if ($idcategory!="")
		{

			$categories = explode(",",$idcategory);
				
			if (count($categories)>1 && in_array(-1,$categories))
			{
				$res->code=-1;
				$res->msg = JText::_("COM_BOOKIT_PLEASE_SELECT_AT_LEAST_ONE_ROOM_CATEGORY");
				return $res;
			}
			else
			{
				$data['idcategory'] = $idcategory;
			}
		}
		else
		{
			$res->code=-1;
			$res->msg = JText::_("COM_BOOKIT_PLEASE_SELECT_AT_LEAST_ONE_ROOM_CATEGORY");
			return $res;
		}

		$n = count($selected_days);
		$strSelectedDays = "";

		for($i=0; $i < $n; $i++) {
			$strSelectedDays .= $selected_days[$i].",";
		}
		 
		$data['selected_days'] = $strSelectedDays;
			

		$lang = JRequest::getVar('language','en');
		if($lang!='en')
		{
			$data['name_'.$lang] = $data['name'];
			if ($this->_alreadySet('#__bookitrules', 'name', JRequest::getVar('idrule',0)))
				unset($data['name']);
				
				
			if(!BlookingHelper::columnExists('#__bookitrules','name_'.$lang))
			{
				$query = "ALTER TABLE ".$this->_db->nameQuote("#__bookitrules").
				" ADD ".$this->_db->nameQuote('name_'.$lang).
				" TEXT NULL DEFAULT NULL";
				$this->_db->setQuery($query);
				$this->_db->query();
			}
		}
		$res->lang=$lang;

		 

		if (!$row->bind($data)) {
			$this->setError($this->_db->getErrorMsg());
			$res->msg=JText::_("COM_BOOKIT_ERROR_SAVING_RULES");
			$res->code=-1;
			return $res;
		}

		if (!$row->check()) {
			$this->setError($this->_db->getErrorMsg());
			$res->msg=JText::_("COM_BOOKIT_ERROR_SAVING_RULES");
			$res->code=-1;
			return $res;
		}

		if (!$row->store()) {
			$this->setError($this->_db->getErrorMsg());
			$res->msg=JText::_("COM_BOOKIT_ERROR_SAVING_RULES");
			$res->code=-1;
			return $res;
		}

		$res->id = $row->idrule;
		$res->code=0;
		$res->msg=JText::_("COM_BOOKIT_RULE_SAVED");
		return $res;
	}

	function getRoomCategories () {
		$db =& JFactory::getDBO();
		$sql = "SELECT idcategory, name FROM #__bookitcategory";
		$db->setQuery($sql);
		return $db->loadObjectList();
	}
	function _alreadySet($table, $column, $id)
	{
		$query = "SELECT ".$this->_db->nameQuote($column).
		" FROM ".$this->_db->nameQuote($table).
		" WHERE ".$this->_db->nameQuote('idrule')."=".
		$this->_db->quote($id);
		$this->_db->setQuery($query);
		if($this->_db->loadResult()!="") return true;
		else return false;
	}
}