<?php
/**
 * BlooKing - The King in Joomla Booking
 * @version 1.0
 * @author BlooKing.org. Based on BooKiTGold code by Costas Kakousis
 * @copyright (C) 2012-2013 by BlooKing.org (http://www.blooking.org)
 * @license GNU/GPL: http://www.gnu.org/copyleft/gpl.html
 *
 * If you fork this to create your own project, please make a reference to
 * BlooKing! someplace in your code and provide a link to
 * http://www.blooking.org
 *
 * This file is part of BlooKing! BlooKing is free software: you can
 * redistribute it and/or modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * BlooKing is distributed in the hope that it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details. You should have received a copy of the GNU General Public License
 * along with BlooKing.  If not, see <http://www.gnu.org/licenses/>.
 *   ______ __                __  __ __
 *	|   __ \  |.-----..-----.|  |/  |__|.-----..-----.
 *	|   __ <  ||  _  ||  _  ||     <|  ||     ||  _  |
 *	|______/__||_____||_____||__|\__|__||__|__||___  |
 *                                             |_____|
 **/

defined( '_JEXEC' ) or die( 'Restricted access' );

jimport('joomla.application.component.model');

class BlookingModelStatistics extends JModel {
	function __construct() {
		parent::__construct();
	}

	function totalRoomsSold() {
		$db =& JFactory::getDBO();
		$sql = "SELECT COUNT(*) FROM ".
				$db->nameQuote('#__bookitbooking')." WHERE ".
				$db->nameQuote('status')."=".$db->quote('1')." AND ".
				$db->nameQuote('idguests').">".$db->quote('0');
		$db->setQuery($sql);
		return $db->loadResult();
	}

	function monthlyRoomsSold($valid_from = null, $valid_to = null) {
		if (($valid_from != null)||($valid_to !=null)) {
			$valid_from = explode("-",$valid_from);
			$valid_to = explode("-",$valid_to);
			$noMonths = ($valid_to['0'] - $valid_from['0'])+
			12*($valid_to['1']-$valid_from['1']);
			$valid_from =
			date("Y-m-d",mktime(0,0,0,$valid_from['0'],1,$valid_from['1']));
			$valid_to =
			date("Y-m-d",mktime(0,0,0,$valid_to['0'],1,$valid_to['1']));
		} else {
			$noMonths = "11";
			$valid_to = date("Y-m-01");
		}
		$graphdata = array();
		for ($i=$noMonths; $i>=0; $i--) {
			$date = date("Y-m-", strtotime( $valid_to." -$i months"));
			$month = date("m", strtotime( $valid_to." -$i months"));
			$year = date("Y", strtotime( $valid_to." -$i months"));
			$month_name = date('M', mktime(0,0,0,$month,1));
			$days_in_month = date('t',mktime(0,0,0,$month,1,$year));
			$db =& JFactory::getDBO();
			$sql = "SELECT COUNT(*) FROM ".
					$db->nameQuote('#__bookitbooking')." WHERE ".
					$db->nameQuote('today')." BETWEEN ".
					$db->quote($date."1")." AND ".$db->quote($date.$days_in_month).
					" AND ".$db->nameQuote('status')."=".$db->quote('1').
					" AND ".$db->nameQuote('idguests').">".$db->quote('0');
			$db->setQuery($sql);
			$booked_rooms = $db->loadResult();
			$graphdata[] = array($booked_rooms, $month_name." ".$year);
		}
		return $graphdata;
	}

	function totalNetIncome() {
		$db =& JFactory::getDBO();
		$sql = "SELECT SUM(".$db->nameQuote('value_paid').") FROM ".
				$db->nameQuote('#__bookitbooking')." WHERE ".
				$db->nameQuote('idguests').">".$db->quote('0');
		$db->setQuery($sql);
		return number_format($db->loadResult(), 2, '.', '');
	}

	function monthlyNetIncome($valid_from = null, $valid_to = null) {
		if (($valid_from != null)||($valid_to !=null)) {
			$valid_from = explode("-",$valid_from);
			$valid_to = explode("-",$valid_to);
			$noMonths =
			($valid_to['0'] - $valid_from['0'])+12*($valid_to['1']-$valid_from['1']);
			$valid_from = date("Y-m-d",mktime(0,0,0,$valid_from['0'],1,$valid_from['1']));
			$valid_to = date("Y-m-d",mktime(0,0,0,$valid_to['0'],1,$valid_to['1']));
		} else {
			$noMonths = "11";
			$valid_to = date("Y-m-01");
		}
		$graphdata = array();
		for ($i=$noMonths; $i>=0; $i--) {
			$date = date("Y-m-", strtotime( $valid_to." -$i months"));
			$month = date("m", strtotime( $valid_to." -$i months"));
			$year = date("Y", strtotime( $valid_to." -$i months"));
			$month_name = date('M', mktime(0,0,0,$month,1));
			$days_in_month = date('t',mktime(0,0,0,$month,1,$year));
			$db =& JFactory::getDBO();
			$sql = "SELECT SUM(".$db->nameQuote('value_paid').") FROM ".
					$db->nameQuote('#__bookitbooking')." WHERE ".
					$db->nameQuote('today')." BETWEEN ".$db->quote($date."1")." AND ".
					$db->quote($date.$days_in_month)." AND ".$db->nameQuote('status').
					"=".$db->quote('1')." AND ".$db->nameQuote('idguests').">".
					$db->quote('0');
			$db->setQuery($sql);
			$booked_rooms = $db->loadResult();
			if (!$booked_rooms) {
				$booked_rooms = "0";
			}
			$graphdata[] = array($booked_rooms, $month_name." ".$year);
		}
		return $graphdata;
	}

	function averageBookingPrice() {
		$db =& JFactory::getDBO();
		$sql = "SELECT AVG(".$db->nameQuote('value_paid').") FROM ".
				$db->nameQuote('#__bookitbooking')." WHERE ".
				$db->nameQuote('idguests').">".$db->quote('0');
		$db->setQuery($sql);
		return number_format($db->loadResult(), 2, '.', '');
	}

	function monthlyOccupancy($valid_from = null, $valid_to = null) {
		if (($valid_from != null)||($valid_to !=null)) {
			$valid_from = explode("-",$valid_from);
			$valid_to = explode("-",$valid_to);
			$noMonths = ($valid_to['0'] - $valid_from['0'])+12*($valid_to['1']-$valid_from['1']);
			$valid_from = date("Y-m-d",mktime(0,0,0,$valid_from['0'],1,$valid_from['1']));
			$valid_to = date("Y-m-d",mktime(0,0,0,$valid_to['0'],1,$valid_to['1']));
		} else {
			$noMonths = "11";
			$valid_to = date("Y-m-01");
		}
		$graphdata = array();
		for ($i=$noMonths; $i>=0; $i--) {
			$date = date("Y-m-", strtotime( $valid_to." -$i months"));
			$month = date("m", strtotime( $valid_to." -$i months"));
			$year = date("Y", strtotime( $valid_to." -$i months"));
			$month_name = date('M', mktime(0,0,0,$month,1));
			$days_in_month = date('t',mktime(0,0,0,$month,1,$year));
				
			$db =& JFactory::getDBO();
			$sql = "SELECT COUNT(*) FROM ".
					$db->nameQuote('#__bookitbooking')." WHERE
							(( ".$db->nameQuote('valid_from')." BETWEEN ".
							$db->quote($date."1")." AND ".$db->quote($date.$days_in_month).")
									OR (".$db->nameQuote('valid_to')." BETWEEN ".
									$db->quote($date."1")." AND ".$db->quote($date.$days_in_month).")
											OR (".$db->nameQuote('valid_to')." > ".
											$db->quote($date."1")." AND ".$db->nameQuote('valid_from')." < ".
											$db->quote($date.$days_in_month)."))
													AND ".$db->nameQuote('status')."=".$db->quote('1')." AND ".
													$db->nameQuote('idguests')." > ".$db->quote('0');
			$db->setQuery($sql);
			$rooms_sold = $db->loadResult();

				
			if (!$rooms_sold) {
				$rooms_sold = "0";
				$daysbooked = "0";
			} else {
				$db =& JFactory::getDBO();
				$sql = "SELECT ".$db->nameQuote('valid_from').", ".
						$db->nameQuote('valid_to')." FROM ".
						$db->nameQuote('#__bookitbooking')." WHERE
								(( ".$db->nameQuote('valid_from')." BETWEEN ".
								$db->quote($date."1")." AND ".
								$db->quote($date.$days_in_month).")
										OR (".$db->nameQuote('valid_to')." BETWEEN ".
										$db->quote($date."1")." AND ".
										$db->quote($date.$days_in_month).")
												OR (".$db->nameQuote('valid_to')." > ".
												$db->quote($date."1")." AND ".
												$db->nameQuote('valid_from')."<".
												$db->quote($date.$days_in_month)."))
														AND ".$db->nameQuote('status')."=".$db->quote('1')." AND ".
														$db->nameQuote('idguests').">".$db->quote('0');
				$db->setQuery($sql);
				$bookingdates = $db->loadRowList();

				$daysbooked = "0";
				foreach ($bookingdates as $dates) {
					$monthend = date('Y-m-d', mktime(0,0,0,$month,$days_in_month,$year));
					$monthstart = date('Y-m-d', mktime(0,0,0,$month,1,$year));
						
					if (($dates[0] <= $monthstart) && ($dates[1] >= $monthend)){
						$daysbooked += $this->_dateDiff($monthstart,$monthend) + 1;
					} elseif ($dates[1] >= $monthend) {
						$daysbooked += $this->_dateDiff($dates[0],$monthend);
					} elseif ($dates[0] <= $monthstart) {
						$daysbooked += $this->_dateDiff($monthstart,$dates[1]);
					} else {
						$daysbooked += $this->_dateDiff($dates[0],$dates[1]);
					}
				}
			}
				
			$db =& JFactory::getDBO();
			$sql = "SELECT COUNT(*) FROM ".
					$db->nameQuote('#__bookitroom');
			$db->setQuery($sql);
			$noRooms = $db->loadResult();
			$noRooms = $noRooms * $days_in_month;
			if ($noRooms > 0)
				$occupancy = number_format(($daysbooked / $noRooms)*100);
			else
				$occupancy=0;
				
			$graphdata[] = array($occupancy, $month_name." ".$year);
		}
		//$graphdata = json_encode($graphdata);
		return $graphdata;
	}

	function _dateDiff($start, $end) {
		$start_ts = strtotime($start);
		$end_ts = strtotime($end);
		$diff = $end_ts - $start_ts;
		return round($diff / 86400);
	}

	function getCategories() {
		$db =& JFactory::getDBO();
		$sql = "SELECT * FROM ".$db->nameQuote('#__bookitcategory');
		$db->setQuery($sql);
		return $db->loadObjectList();
	}

	function getRooms() {
		$db =& JFactory::getDBO();
		$sql = "SELECT * FROM ".$db->nameQuote('#__bookitroom');
		$db->setQuery($sql);
		return $db->loadObjectList();
	}
}