<?php
/**
 * BlooKing - The King in Joomla Booking
 * @version 1.0
 * @author BlooKing.org. Based on BooKiTGold code by Costas Kakousis
 * @copyright (C) 2012-2013 by BlooKing.org (http://www.blooking.org)
 * @license GNU/GPL: http://www.gnu.org/copyleft/gpl.html
 *
 * If you fork this to create your own project, please make a reference to
 * BlooKing! someplace in your code and provide a link to
 * http://www.blooking.org
 *
 * This file is part of BlooKing! BlooKing is free software: you can
 * redistribute it and/or modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * BlooKing is distributed in the hope that it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details. You should have received a copy of the GNU General Public License
 * along with BlooKing.  If not, see <http://www.gnu.org/licenses/>.
 *   ______ __                __  __ __
 *	|   __ \  |.-----..-----.|  |/  |__|.-----..-----.
 *	|   __ <  ||  _  ||  _  ||     <|  ||     ||  _  |
 *	|______/__||_____||_____||__|\__|__||__|__||___  |
 *                                             |_____|
 **/
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.application.component.view' );
class BlookingViewAvailability extends JView {
	function display($tpl = null) {

		JLoader::register('BlookingHelper',
		JPATH_COMPONENT.'/helpers/BlookingHelper.php');

		JToolbarHelper::title( JText::_( 'COM_BOOKIT_AVAILABILITY' ),
		'availability');
		JToolBarHelper::cancel( 'cancel', 'Close' );
		JToolBarHelper::help( 'availability-help/availabilityhelp', true );

			
		$document  = & JFactory::getDocument();
		$document->addStyleSheet(
				JURI::root().'administrator/components/com_blooking/css/icons.css',
				'text/css', null, array() );
		$document->addStyleSheet(
				JURI::root().'administrator/components/com_blooking/css/year_calendar.css',
				'text/css', null, array() );

		$document->addStyleSheet(
				JURI::root().'administrator/components/com_blooking/css/availability.css',
				'text/css', null, array() );

		$document->addScript( JURI::root().
				'/administrator/components/com_blooking/js/availability.js' );




		//SET CATEGORY DROPDOWN
		$model = $this->getModel('availability');
		$defaultCategory = '-1';
		$category[] = JHTML::_('select.option', -1,
				JText::_('COM_BOOKIT_ANY'), 'idcategory', 'name' );
		$category = array_merge( $category, $model->getCategories() );

		$lists['catid']  = JHTML::_('select.genericList', $category,
				'idcategory', 'class="required validate-dropbox inputbox" size="1"',
				'idcategory', 'name', $defaultCategory);

		$lists['set_catid']  = JHTML::_('select.genericList', $category,
				'set_idcategory', 'class="inputbox" size="1"', 'idcategory', 'name',
				$defaultCategory);


		//END CATEGORY

		//SET ROOM DROPDOWN
		$model = $this->getModel('availability');
		$defaultRoom = '-1';
		$room[] = JHTML::_('select.option', -1,
				JText::_('COM_BOOKIT_ANY'), 'idroom', 'name' );
		$room = array_merge( $room, $model->getRooms() );

		$lists['roomid']  = JHTML::_('select.genericList', $room,
				'idroom', 'class="required validate-dropbox inputbox" size="1"',
				'idroom', 'name', $defaultRoom);

		$lists['set_roomid']  = JHTML::_('select.genericList', $room,
				'set_idroom', 'class="inputbox" size="1"',
				'idroom', 'name', $defaultRoom);
		//END ROOM DROPDOWN

		//SET STATUS DROPDOWN
		$defaultStatus = '0';

		$statuses['0'] = JHTML::_('select.option', '0',
				JText::_('COM_BOOKIT_AVAILABLE'), 'status', 'name' );
		$statuses['1'] = JHTML::_('select.option', '2',
				JText::_('COM_BOOKIT_PENDING'), 'status', 'name' );
		$statuses['2'] = JHTML::_('select.option', '3',
				JText::_('COM_BOOKIT_CLOSED'), 'status', 'name' );

		$lists['status']  = JHTML::_('select.genericList', $statuses,
				'status', 'class="inputbox" size="1"', 'status', 'name',
				$defaultStatus);

		$this->assignRef('lists', $lists);
		$this->assignRef('date_code',  BlookingHelper::getDateFormat());

		$categories = $model->getCategories();

		if (count($categories)<=0) {
			$url = JURI::base()."index.php?option=com_blooking&controller=roomcategoryedit&task=edit&prev=availability";
			$msg = JText::_("COM_BOOKIT_PLEASE_CREATE_AT_LEAST_ONE").
			"<a href='".$url."'> ".JText::_("COM_BOOKIT_ROOM_CATEGORY")."</a> ".
			JText::_("COM_BOOKIT_FIRST");
			JError::raiseNotice (500, $msg );
		} else {
			$rooms =& $model->getRooms();
			if (count($rooms)<=0) {
				$url = JURI::base()."index.php?option=com_blooking&controller=room&task=edit&prev=availability";
				$msg = JText::_("COM_BOOKIT_PLEASE_CREATE_AT_LEAST_ONE").
				"<a href='".$url."'> ".JText::_("COM_BOOKIT_ROOM")."</a> ".
				JText::_("COM_BOOKIT_FIRST");
				JError::raiseNotice (500, $msg );
			}
		}

		parent::display($tpl);
	}

}

