<?php
/**
 * BlooKing - The King in Joomla Booking
 * @version 1.0
 * @author BlooKing.org. Based on BooKiTGold code by Costas Kakousis
 * @copyright (C) 2012-2013 by BlooKing.org (http://www.blooking.org)
 * @license GNU/GPL: http://www.gnu.org/copyleft/gpl.html
 *
 * If you fork this to create your own project, please make a reference to
 * BlooKing! someplace in your code and provide a link to
 * http://www.blooking.org
 *
 * This file is part of BlooKing! BlooKing is free software: you can
 * redistribute it and/or modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * BlooKing is distributed in the hope that it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details. You should have received a copy of the GNU General Public License
 * along with BlooKing.  If not, see <http://www.gnu.org/licenses/>.
 *   ______ __                __  __ __
 *	|   __ \  |.-----..-----.|  |/  |__|.-----..-----.
 *	|   __ <  ||  _  ||  _  ||     <|  ||     ||  _  |
 *	|______/__||_____||_____||__|\__|__||__|__||___  |
 *                                             |_____|
 **/
defined( '_JEXEC' ) or die( 'Restricted access' );
jimport( 'joomla.application.component.view' );

class BlookingViewAvailability extends JView {

	function display($tpl = null) {
		JLoader::register('BlookingHelper',
		JPATH_COMPONENT.'/helpers/BlookingHelper.php');

		$model =& $this->getModel( 'availability' );
		$valid_from = JRequest::getVar('valid_from');
		$valid_to = JRequest::getVar('valid_to');
		$idcategory = JRequest::getVar('idcategory',0);
		$idroom = JRequest::getVar('idroom',0);
		$mode = JRequest::getVar('mode','+0 month');

		$date_code = BlookingHelper::getDateFormat();
		$time = date ($date_code->d1, strtotime($valid_from));
		$time = strtotime($time);
		$time = strtotime ($mode, $time);
		$month = date('n', $time);
		$year = date('Y', $time);
		$months_ahead = "6";


		$calendar = $model->displayCalendar($month, $year, $idcategory, $idroom,
				$months_ahead);

		$data['valid_from'] = date ($date_code->d1, $time);

		if ($calendar=="") {
			$data['code']=0;
		} else {
			$data['code']=1;
		}

		$data['calendar'] = $calendar;
		$document =& JFactory::getDocument();
		// Set the MIME type for JSON output.
		$document->setMimeEncoding( 'application/json' );

		echo json_encode( $data );
	}
	function update_rooms() {

		$model =& $this->getModel( 'availability' );
		$idcategory = JRequest::getVar('idcategory',0);
		$data = array();
		$data['rooms'] = $model->getAjaxRooms ($idcategory);
			
		$document =& JFactory::getDocument();
		// Set the MIME type for JSON output.
		$document->setMimeEncoding( 'application/json' );

		echo json_encode( $data );
	}
	function setstatus() {

		$model =& $this->getModel( 'availability' );
		$res = $model->setstatus(JRequest::getVar( 'valid_from'),
				JRequest::getVar( 'valid_to' ),
				JRequest::getVar( 'idcategory', '-1' ),
				JRequest::getVar( 'idroom', '-1' ),
				JRequest::getVar( 'status', '0' ));

		$data = array();
		$data['result'] = $res;
			
		$document =& JFactory::getDocument();
		// Set the MIME type for JSON output.
		$document->setMimeEncoding( 'application/json' );

		echo json_encode( $data );
	}

}