<?php
/**
 * BlooKing - The King in Joomla Booking
 * @version 1.0
 * @author BlooKing.org. Based on BooKiTGold code by Costas Kakousis
 * @copyright (C) 2012-2013 by BlooKing.org (http://www.blooking.org)
 * @license GNU/GPL: http://www.gnu.org/copyleft/gpl.html
 *
 * If you fork this to create your own project, please make a reference to
 * BlooKing! someplace in your code and provide a link to
 * http://www.blooking.org
 *
 * This file is part of BlooKing! BlooKing is free software: you can
 * redistribute it and/or modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * BlooKing is distributed in the hope that it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details. You should have received a copy of the GNU General Public License
 * along with BlooKing.  If not, see <http://www.gnu.org/licenses/>.
 *   ______ __                __  __ __
 *	|   __ \  |.-----..-----.|  |/  |__|.-----..-----.
 *	|   __ <  ||  _  ||  _  ||     <|  ||     ||  _  |
 *	|______/__||_____||_____||__|\__|__||__|__||___  |
 *                                             |_____|
 **/

defined( '_JEXEC' ) or die( 'Restricted access' );
jimport( 'joomla.application.component.view' );

class BlookingViewBlooking extends JView {
	function display($tpl = null) {
		$data =& $this->get('Data');

		JToolbarHelper::title(JText::_('COM_BOOKIT_BOOKIT_HOME'), 'roomcategories');

		$document  = & JFactory::getDocument();
		$document->addStyleSheet(
				JURI::root().'administrator/components/com_blooking/css/icons.css',
				'text/css', null, array() );
			
		if(version_compare(JVERSION,'1.6.0','ge'))
		{
			$document->addStyleSheet(
					JURI::root().'administrator/components/com_blooking/css/blooking.css',
					'text/css', null, array() );
			JToolBarHelper::custom('params', 'options.png', '', 'COM_BOOKIT_PARAMETERS');
		}
		else
		{
			$document->addStyleSheet(
					JURI::root().'administrator/components/com_blooking/css/blooking15.css',
					'text/css', null, array() );
			JToolBarHelper::customX( 'params', 'config.png', 'config.png',
			'COM_BOOKIT_PARAMETERS', false );
		}

		JLoader::register('BlookingHelper',
		JPATH_COMPONENT.'/helpers/BlookingHelper.php');

		$params = BlookingHelper::getParams();

		$model = $this->getModel();

		$this->assignRef('version', $model->getCurrentVersion());
		$this->assignRef('data', $data);
		$this->assignRef('params', $params);

		//CHECK BLOOKING IS UP TO DATE
		$url = 'http://www.blooking.org/version.xml';
		$checkurl = @fopen($url, "r");
		if ($checkurl) {
			$xmlfile = file_get_contents($url);
			$parser = JFactory::getXMLParser('Simple');
			$parserfile = JFactory::getXMLParser('Simple');

			if ($parser->loadString($xmlfile)) {
				if (isset($parser->document)) {
					$latestversion = $parser->document->blooking[0]->data();
					$parserfile->loadFile(JPATH_ADMINISTRATOR.DS.'components'.DS.
							'com_blooking'.DS.'install.xml');
					$label = JText::_('COM_BOOKIT_UPDATE')." v".$latestversion;
					if (version_compare($parserfile->document->version[0]->data(), $latestversion)==-1) {
						JToolBarHelper::CustomX('update', 'outdated.png', 'outdated.png',
						$label, false);
						$changelog = "<font color='red'>PLEASE UPDATE YOUR BLOOKING VERSION</font>";
						$changelog .= "<ul>";

						foreach($parser->document->update as $feature) {
							$changelog .="<li>".$feature->data()."</li>";
						};
						$changelog .="</ul>";
					}
					$this->assignRef('changelog', $changelog);
						
				} else {
					parent::display($tpl);
					return;
				}
			}
		} else {
			parent::display($tpl);
			return;
		}

			
		parent::display($tpl);
	}
}