<?php
/**
 * BlooKing - The King in Joomla Booking
 * @version 1.0
 * @author BlooKing.org. Based on BooKiTGold code by Costas Kakousis
 * @copyright (C) 2012-2013 by BlooKing.org (http://www.blooking.org)
 * @license GNU/GPL: http://www.gnu.org/copyleft/gpl.html
 *
 * If you fork this to create your own project, please make a reference to
 * BlooKing! someplace in your code and provide a link to
 * http://www.blooking.org
 *
 * This file is part of BlooKing! BlooKing is free software: you can
 * redistribute it and/or modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * BlooKing is distributed in the hope that it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details. You should have received a copy of the GNU General Public License
 * along with BlooKing.  If not, see <http://www.gnu.org/licenses/>.
 *   ______ __                __  __ __
 *	|   __ \  |.-----..-----.|  |/  |__|.-----..-----.
 *	|   __ <  ||  _  ||  _  ||     <|  ||     ||  _  |
 *	|______/__||_____||_____||__|\__|__||__|__||___  |
 *                                             |_____|
 **/
defined('_JEXEC') or die('Restricted access');
jimport('joomla.html.pagination');
JHTML::_('behavior.tooltip');

$url = JURI::base()."index.php?option=com_blooking&controller".
		"=booking&task=autocomplete&format=json&";

$js = <<<EOD
window.addEvent( 'domready', function() {
	var searchBar = new Fx.Slide('searchDiv');

	var nameOptions = {
		script: '{$url}', json: true, maxresults: 35, varname: "name",
		callback: function (obj) {
			document.getElementById('nameid').value = obj.id;
			document.getElementById('filter_email').value = obj.info;
			document.adminForm.submit();
		}
	};

	var emailOptions = {
		script: '{$url}', json: true, maxresults: 35, varname: "email",
		callback: function (obj) {
			document.getElementById('emailid').value = obj.id;
			document.getElementById('filter_name').value = obj.info;
			document.adminForm.submit();
		}
	};

	var categoryOptions = {
		script: '{$url}', json: true, maxresults: 35, varname: "category",
		callback: function (obj) {
			document.getElementById('categoryid').value = obj.id;
			document.adminForm.submit();
		}
	};

	var roomOptions = {
		script: '{$url}', json: true, maxresults: 35, varname: "room", cache: false,
		callback: function (obj) {
			document.getElementById('roomid').value = obj.id;
			document.adminForm.submit();
		}
	};

	var filterName = new bsn.AutoSuggest('filter_name', nameOptions);
	var filterEmail = new bsn.AutoSuggest('filter_email', emailOptions);
	var filterCategories = new bsn.AutoSuggest('filter_category', categoryOptions);
	var filterRooms = new bsn.AutoSuggest('filter_room', roomOptions);

	$('searchToggle').addEvent('click', function(event){
    	event.stop();
    	searchBar.toggle();
  	});
  
  	$('filter_id').addEvent('change',function(){
  		document.adminForm.submit();
  	});
  
  	$('submitbutton').addEvent('click',function(){
  		document.adminForm.submit();
  	});
  
  	$('reset').addEvent('click',function(){
  		$('filter_id').value='';
  		$('filter_name').value='';
  		$('filter_email').value='';
  		$('filter_category').value='';
  		$('filter_room').value='';
  		$('nameid').value='';
  		$('emailid').value='';
  		$('categoryid').value='';
  		$('roomid').value='';
  		document.adminForm.submit();
  	});
  
});
EOD;

$doc = & JFactory::getDocument();
$doc->addScriptDeclaration( $js );
?>
<form action="index.php" method="post"
	name="adminForm" id="adminForm">
	<div id="editcell">
		<a id="searchToggle" href="#">Hide/View Search Bar</a>
		<div id="searchDiv">
			<table>
				<tr>
					<td><?php echo JText::_('COM_BOOKIT_ID');?>:</td>
					<td><?php echo JText::_('COM_BOOKIT_NAME');?>:</td>
					<td><?php echo JText::_('COM_BOOKIT_EMAIL');?>:</td>
					<td><?php echo JText::_('COM_BOOKIT_CATEGORY');?>:</td>
					<?php if ($this->multiroom != "2") {?>
					<td><?php echo JText::_('COM_BOOKIT_ROOM_NAME');?>:</td>
					<?php }?>
				</tr>
				<tr>
					<td><input id="filter_id" name="filter_id" type="text"
						class="text_area" value="<?php echo $this->lists['filter_id'];?>" />
					</td>
					<td><input id="filter_name" name="filter_name" type="text"
						class="text_area"
						value="<?php echo $this->lists['filter_name'];?>" /></td>
					<td><input id="filter_email" name="filter_email" type="text"
						class="text_area"
						value="<?php echo $this->lists['filter_email'];?>" /></td>
					<td><input id="filter_category" name="filter_category" type="text"
						class="text_area"
						value="<?php echo $this->lists['filter_category'];?>" /></td>
					<?php if ($this->multiroom != '2') {?>
					<td><input id="filter_room" name="filter_room" type="text"
						class="text_area"
						value="<?php echo $this->lists['filter_room'];?>" /></td>
					<?php }?>
					<td><button id="submitbutton">
							<?php echo JText::_("COM_BOOKIT_GO"); ?>
						</button>
						<button id="reset">
							<?php echo JText::_('COM_BOOKIT_RESET'); ?>
						</button>
					</td>
				</tr>
			</table>
		</div>
		<table class="adminlist">
			<thead>
				<?php $cost_total =JText::_("COM_BOOKIT_COST_TOTAL");
				$cost_due =JText::_("COM_BOOKIT_COST_DUE");
				$guest_name =JText::_("COM_BOOKIT_GUEST_NAME");
				$guest_surname =JText::_("COM_BOOKIT_GUEST_SURNAME");
				$guest_mail =JText::_("COM_BOOKIT_GUEST_MAIL");

				?>
				<tr>
					<th width="2%"><input type="checkbox" name="toggle" value=""
						onclick="checkAll(<?php echo count( $this->booking ); ?>);" /></th>
					<th width="2%"></th>
					<th width="2%"><?php echo JHTML::_( 'grid.sort', 'COM_BOOKIT_ID', 'idbook', $this->lists['order_Dir'], $this->lists['order']); ?>
					</th>
					<th width="5%"><?php echo JHTML::_( 'grid.sort', 'COM_BOOKIT_REFERENCE_ID', 'refid', $this->lists['order_Dir'], $this->lists['order']); ?>
					</th>
					<th width="5%"><?php echo JText::_('COM_BOOKIT_BOOKED_WITH');?></th>
					<th width="10%"><?php echo JHTML::_( 'grid.sort', 'COM_BOOKIT_BOOKED_ON', 'timestamp', $this->lists['order_Dir'], $this->lists['order']); ?>
					</th>
					<th width="10%"><?php echo JHTML::_( 'grid.sort', 'COM_BOOKIT_STATUS', 'statusstr', $this->lists['order_Dir'], $this->lists['order']); ?>
					</th>
					<th width="10%"><?php echo JHTML::_( 'grid.sort', 'COM_BOOKIT_CHECK_IN', 'valid_from', $this->lists['order_Dir'], $this->lists['order']); ?>
					</th>
					<th width="10%"><?php echo JHTML::_( 'grid.sort', 'COM_BOOKIT_CHECK_OUT', 'valid_to', $this->lists['order_Dir'], $this->lists['order']); ?>
					</th>
					<?php if ($this->multiroom != "2") {?>
					<th width="15%"><?php echo JHTML::_( 'grid.sort', 'COM_BOOKIT_ROOM', 'roomname', $this->lists['order_Dir'], $this->lists['order']); ?>
					</th>
					<?php } else {?>
					<th width="10%"><?php echo JHTML::_( 'grid.sort', 'COM_BOOKIT_PROPERTY', 'roomname', $this->lists['order_Dir'], $this->lists['order']); ?>
					</th>
					<?php }?>
					<th width="5%"><?php echo JHTML::_( 'grid.sort', $cost_total, 'value_full', $this->lists['order_Dir'], $this->lists['order']); ?>
					</th>
					<th width="5%"><?php echo JHTML::_( 'grid.sort', $cost_due, 'value_pending', $this->lists['order_Dir'], $this->lists['order']); ?>
					</th>
					<th width="10%"><?php echo JHTML::_( 'grid.sort', $guest_name, 'name', $this->lists['order_Dir'], $this->lists['order']); ?>
					</th>
					<th width="10%"><?php echo JHTML::_( 'grid.sort', $guest_surname, 'surname', $this->lists['order_Dir'], $this->lists['order']); ?>
					</th>
					<th width="15%"><?php echo JHTML::_( 'grid.sort', $guest_mail, 'email', $this->lists['order_Dir'], $this->lists['order']); ?>
					</th>
					<th width="5%"><?php echo JHTML::_( 'grid.sort', 'COM_BOOKIT_TRANSACTION_ID', 'transaction_id', $this->lists['order_Dir'], $this->lists['order']); ?>
					</th>
				</tr>
			</thead>
			<tfoot>
				<tr>
					<td colspan="16"><?php echo $this->pagination->getListFooter(); ?>
					</td>
				</tr>
			</tfoot>
			<?php
			$r =& JTable::getInstance('room', 'Table');

			$k = 0;
			for ($i=0, $n=count( $this->booking ); $i < $n; $i++) {
		$row =& $this->booking[$i];

		if ($row->idroom==0) {
			$room_name= JText::_("COM_BOOKIT_PENDING");
		} else {
			$r->load($row->idroom);
			$room_name = $r->name;
		}

		$checked    = JHTML::_( 'grid.id', $i, $row->idbook );
		$link = JRoute::_( 'index.php?option=com_blooking&controller=booking&task=edit&cid[]='. $row->idbook );
		$coids = explode(",",  $row->coids);

		$colink = "";
		foreach ($coids as $k=>$v)
		{
			$colink .= "<a href='".
					JRoute::_( 'index.php?option=com_blooking&controller=booking&task=edit&cid[]='. $v )."'>";
			$colink .= $v;
			if ($k<count($coids)-1)
				$colink .=", ";
			$colink .=" </a>";
		}
		if ($colink=="" || $coids[0]==0)
			$colink="-";


		JLoader::register('BlookingHelper',
		JPATH_COMPONENT.'/helpers/BlookingHelper.php');
		$params = BlookingHelper::getParams();
		$dateformatcode = $params->dateformat;
		if ($dateformatcode==""||$dateformatcode==3)
		{
			$d1='d-m-Y';
		}
		else if ($dateformatcode==1)
		{
			$d1='Y-m-d';
		}
		else if ($dateformatcode==2)
		{
			$d1='m-d-Y';
		}
	 ?>
			<tr class="<?php echo "row$k"; ?>">
				<td width="2%" align="center"><?php echo $checked; ?></td>
				<td width="2%" align="center"><?php 
				if ($row->staffnotes != "") {
				echo JHTML::tooltip($row->staffnotes, JText::_('COM_BOOKIT_STAFF_NOTES'),
				'tooltip.png', '', '');
			}
			?>
				
				<td width="2%" align="center"><?php echo $row->idbook; ?></td>
				<td width="5%" align="center"><?php echo $row->refid." ";?></td>
				<td width="5%" align="center"><?php echo $colink; ?></td>
				<td width="10%" align="center"><a href="<?php echo $link; ?>"> <?php echo date($d1." H:i:s",strtotime($row->timestamp)); ?>
				</a></td>
				<td width="5%" align="center"><?php if ($this->admin_confirm ==1 && $row->status==2 && $row->payment_requested==1) {?>
					<font color="purple"><?php echo JText::_("COM_BOOKIT_PAYMENT_REQUESTED"); ?>
				</font> <?php } else if ($row->status==2){ ?><font color="orange"> <?php echo JText::_("COM_BOOKIT_PENDING"); ?>
				</font> <?php } else if ($row->status==1) {?> <font color="green"><?php  echo JText::_("COM_BOOKIT_CONFIRMED"); ?>
				</font> <?php } else if ($row->status==4)  { ?> <font color="red"><?php  echo JText::_("COM_BOOKIT_EXPIRED"); ?>
				</font> <?php } else if ($row->status==5)  { ?> <font color="grey"><?php  echo JText::_("COM_BOOKIT_CANCELLED"); ?>
				</font> <?php }?></td>
				<td width="10%" align="center"><?php echo date($d1,strtotime($row->valid_from)); ?>
				</td>
				<td width="10%" align="center"><?php echo date($d1,strtotime($row->valid_to)); ?>
				</td>

				<td width="10%" align="center"><?php echo $row->roomname; ?></td>

				<td width="5%" align="center"><?php echo round($row->value_full,"2"); ?>
				</td>
				<?php if ($row->value_pending==0){?>
				<td width="5%" align="center"><font color="green"> <?php echo round($row->value_pending,"2"); ?>
				</font></td>
				<?php } if ($row->value_pending>0){ ?>
				<td width="5%" align="center"><font color="red"><?php echo round($row->value_pending,"2"); ?>
				</font></td>
				<?php } ?>
				<td width="10%" align="center"><?php echo $row->name; ?></td>
				<td width="10%" align="center"><?php echo $row->surname; ?></td>
				<td width="15%" align="center"><?php echo $row->email; ?></td>
				<td width="5%" align="center"><?php if ($row->transaction_id!="") 
					echo $row->transaction_id; else echo"-";?>
				</td>
			</tr>
			<?php

			$k = 1 - $k;
	}
	?>


		</table>
	</div>


	<?php echo JHTML::_( 'form.token' ); ?>
	<input type="hidden" name="option" value="com_blooking" /> <input
		type="hidden" name="controller" value="booking" /> <input
		type="hidden" name="view" value="booking" /> <input type="hidden"
		name="task" value="listing" /> <input type="hidden" name="boxchecked"
		value="0" />
	<!-- FILTERING -->
	<input type="hidden" name="filter_order"
		value="<?php echo $this->lists['order']; ?>" /> <input type="hidden"
		name="filter_order_Dir" value="<?php $this->lists['order_Dir']; ?>" />
	<input type="hidden" id="nameid" name="nameid"
		value="<?php echo $this->ids['nameid']; ?>" />
	</td> <input type="hidden" id="emailid" name="emailid"
		value="<?php echo $this->ids['emailid']; ?>" />
	</td> <input type="hidden" id="categoryid" name="categoryid"
		value="<?php echo $this->ids['categoryid']; ?>" />
	</td> <input type="hidden" id="roomid" name="roomid"
		value="<?php echo $this->ids['roomid']; ?>" />
	</td>
</form>

