<?php
/**
 * BlooKing - The King in Joomla Booking
 * @version 1.0
 * @author BlooKing.org. Based on BooKiTGold code by Costas Kakousis
 * @copyright (C) 2012-2013 by BlooKing.org (http://www.blooking.org)
 * @license GNU/GPL: http://www.gnu.org/copyleft/gpl.html
 *
 * If you fork this to create your own project, please make a reference to
 * BlooKing! someplace in your code and provide a link to
 * http://www.blooking.org
 *
 * This file is part of BlooKing! BlooKing is free software: you can
 * redistribute it and/or modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * BlooKing is distributed in the hope that it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details. You should have received a copy of the GNU General Public License
 * along with BlooKing.  If not, see <http://www.gnu.org/licenses/>.
 *   ______ __                __  __ __
 *	|   __ \  |.-----..-----.|  |/  |__|.-----..-----.
 *	|   __ <  ||  _  ||  _  ||     <|  ||     ||  _  |
 *	|______/__||_____||_____||__|\__|__||__|__||___  |
 *                                             |_____|
 **/
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.application.component.view' );
class BlookingViewBooking extends JView {
	function display($tpl = null) {
		JLoader::register('BlookingHelper',
		JPATH_COMPONENT.'/helpers/BlookingHelper.php');

		$params = BlookingHelper::getParams();

		JToolbarHelper::title( JText::_( 'COM_BOOKIT_BOOKINGS' ),
		'bookings');
		$document  = & JFactory::getDocument();
		$document->addStyleSheet(
				JURI::root().'administrator/components/com_blooking/css/icons.css',
				'text/css', null, array() );
		$document->addStyleSheet(
				JURI::root().'administrator/components/com_blooking/css/autosuggest.css',
				'text/css', null, array() );
		$document->addScript(
				JURI::root().'administrator/components/com_blooking/js/autocompleter.js');

		if ($params->admin_confirm == 1) {
			JToolBarHelper::customX( 'adminConfirm', 'money','money','COM_BOOKIT_REQUEST_PAYMENT',true);
			JToolBarHelper::divider();
		}
		JToolBarHelper::addNewX();
		JToolBarHelper::divider();
		JToolBarHelper::editListX();
		JToolBarHelper::customX( 'deleteExpired', 'delete.png','delete_f2.png',
		'COM_BOOKIT_DELETE_EXPIRED',false);
		JToolBarHelper::deleteList();
		JToolBarHelper::divider();
		JToolBarHelper::cancel();

		global  $option;
		$mainframe = JFactory::getApplication();
		$state =& $this->get( 'state' );
		$lists = array();
		$ids = array();

		JLoader::register('BlookingHelper',
		JPATH_COMPONENT.'/helpers/BlookingHelper.php');

		$params = BlookingHelper::getParams();

		$filter_order = $mainframe->getUserStateFromRequest
		($option.'filter_order','filter_order','name');

		$filter_order_Dir = $mainframe->getUserStateFromRequest
		($option.'filter_order_Dir','filter_order_Dir','ASC');

		//$filter_search = $mainframe->getUserStateFromRequest
		//($option.'filter_search','filter_search');

		$filter_id = $mainframe->getUserStateFromRequest
		($option.'filter_id', 'filter_id' );

		$filter_name = $mainframe->getUserStateFromRequest
		($option.'filter_name', 'filter_name');

		$filter_email = $mainframe->getUserStateFromRequest
		($option.'filter_email', 'filter_email');

		$filter_category = $mainframe->getUserStateFromRequest
		($option.'filter_category', 'filter_category');

		$filter_room = $mainframe->getUserStateFromRequest
		($option.'filter_room', 'filter_room');

		$emailid = $mainframe->getUserStateFromRequest
		($option.'emailid', 'emailid');

		$nameid = $mainframe->getUserStateFromRequest
		($option.'nameid', 'nameid');

		$categoryid = $mainframe->getUserStateFromRequest
		($option.'categoryid', 'categoryid');

		$roomid = $mainframe->getUserStateFromRequest
		($option.'roomid', 'roomid');

		$lists['order_Dir'] = $filter_order_Dir;
		$lists['order'] = $filter_order;
		$lists['filter_id'] = $filter_id;
		$lists['filter_name'] = $filter_name;
		$lists['filter_email'] = $filter_email;
		$lists['filter_category'] = $filter_category;
		$lists['filter_room'] = $filter_room;
		$ids['nameid'] = $nameid;
		$ids['emailid'] = $emailid;
		$ids['categoryid'] = $categoryid;
		$ids['roomid'] = $roomid;

		$booking =& $this->get('Data');
		$pagination =& $this->get('Pagination');
		$this->assignRef( 'booking', $booking );
		$this->assignRef( 'pagination', $pagination );
		$this->assignRef( 'lists', $lists );
		$this->assignRef( 'ids', $ids );
		$this->assignRef('multiroom',$params->multiroom);
		$this->assignRef('admin_confirm', $params->admin_confirm);

		parent::display($tpl);
	}
}