<?php
/**
 * BlooKing - The King in Joomla Booking
 * @version 1.0
 * @author BlooKing.org. Based on BooKiTGold code by Costas Kakousis
 * @copyright (C) 2012-2013 by BlooKing.org (http://www.blooking.org)
 * @license GNU/GPL: http://www.gnu.org/copyleft/gpl.html
 *
 * If you fork this to create your own project, please make a reference to
 * BlooKing! someplace in your code and provide a link to
 * http://www.blooking.org
 *
 * This file is part of BlooKing! BlooKing is free software: you can
 * redistribute it and/or modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * BlooKing is distributed in the hope that it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details. You should have received a copy of the GNU General Public License
 * along with BlooKing.  If not, see <http://www.gnu.org/licenses/>.
 *   ______ __                __  __ __
 *	|   __ \  |.-----..-----.|  |/  |__|.-----..-----.
 *	|   __ <  ||  _  ||  _  ||     <|  ||     ||  _  |
 *	|______/__||_____||_____||__|\__|__||__|__||___  |
 *                                             |_____|
 **/
defined( '_JEXEC' ) or die( 'Restricted access' );
jimport( 'joomla.application.component.view' );
class BlookingViewBookingedit extends JView {
	function display($tpl = null) {

		JLoader::register('BlookingHelper',
		JPATH_COMPONENT.'/helpers/BlookingHelper.php');

		$booking        =& $this->get('Data');
		//get session
		$session =& JFactory::getSession();
		$cached_booking = $session->get('booking_old_values', array(), 'blooking');
		$session->clear('booking_old_values', 'blooking');

		if (!empty($cached_booking) && $booking->idbook < 1) {
			$booking->valid_from = $cached_booking['valid_from'];
			$booking->valid_to = $cached_booking['valid_to'];
			$booking->idcategory = $cached_booking['idcategory'];
			$booking->idroom = $cached_booking['idroom'];
			$booking->idguests = $cached_booking['idguests'];
			$booking->idcoupon = $cached_booking['idcoupon'];
			$booking->nguests = $cached_booking['nguests'];
			$booking->nchilds = $cached_booking['nchilds'];
			$booking->value_paid = $cached_booking['value_paid'];
			$booking->value_pending = $cached_booking['value_pending'];
			$booking->value_full = $cached_booking['value_full'];
			$booking->status = $cached_booking['status'];
			$booking->lang = $cached_booking['lang'];
			$booking->staffnotes = $cached_booking['staffnotes'];
		}

		$isNew        = ($booking->idbook < 1);
		$text = $isNew ? JText::_( 'COM_BOOKIT_NEW' ) :
		JText::_( 'COM_BOOKIT_EDIT' );

		JToolbarHelper::title( JText::_( 'COM_BOOKIT_BOOKINGS' ).
		': <small>[ ' . $text.' ]</small>', 'bookings');
		$document  = & JFactory::getDocument();
		$document->addStyleSheet(
				JURI::root().'administrator/components/com_blooking/css/icons.css',
				'text/css', null, array() );
		 

		JToolBarHelper::customX( 'sendemail', 'send.png','send_f2.png',
		'COM_BOOKIT_NOTIFY_USER',false);
		JToolBarHelper::divider();
		JToolBarHelper::customX( 'save', 'save.png','save_f2.png',
		'COM_BOOKIT_SAVE_CLOSE',false);
		JToolBarHelper::customX( 'saveNew', 'new.png', 'new_f2.png',
		'COM_BOOKIT_SAVE_NEW', false );
		JToolBarHelper::divider();

		if ($isNew)  {
			JToolBarHelper::cancel();
		} else {
			JToolBarHelper::cancel( 'cancel', 'Close' );
		}
		JToolBarHelper::help( 'bookings-help/bookingshelp', true );

		$stylesheet = 'year_calendar.css';
		$path = 'components/com_blooking/css/';
		JHTML::stylesheet($stylesheet, $path);

		$date_code = BlookingHelper::getDateFormat();
		$lists = array();
		$model =& $this->getModel('bookingedit');

		//SET GUEST DROPDOWN
		$rows = $model->getGuestDetails();
		$results_db = array ();
		$cnt=0;
		foreach ($rows as $row) {
			$o = new stdClass();
			$o->idguests = $row[0];
			$o->email = $row[1]." - ".$row[2]." ".$row[3];
			$results_db [$cnt++] = $o;
		}

		$defaultGuests = isset($booking->idguests)?$booking->idguests:'-1';
		$guests[] = JHTML::_('select.option', -1,
				JText::_('COM_BOOKIT_SELECT_GUEST'), 'idguests', 'email' );
		$guests = array_merge( $guests, $results_db );
		$lists['guests']  = JHTML::_('select.genericList', $guests, 'idguests',
				'class="required validate-dropbox inputbox" size="1"', 'idguests',
				'email', $defaultGuests);
		//GUEST END

		//SET COUPON DROPDOWN
		$defaultCoupon = isset($booking->idcoupon)?$booking->idcoupon:'-1';
		$coupons[] = JHTML::_('select.option', -1, JText::_('COM_BOOKIT_SELECT_COUPON'));
		foreach ($model->getCoupons() as $coupon)
		{
			array_push($coupons, JHTML::_('select.option', $coupon->idrule, $coupon->name ));
		}

		$lists['coupons']  = JHTML::_('select.genericList', $coupons,
				'idcoupon', 'class="inputbox"', 'value', 'text', $defaultCoupon);



		//COUPON END

		//SET CATEGORY DROPDOWN
		$defaultCategory = isset($booking->idcategory)?$booking->idcategory:'-1';
		$category[] = JHTML::_('select.option', -1,
				JText::_('COM_BOOKIT_SELECT_CATEGORY'), 'idcategory', 'name' );
		$category = array_merge( $category, $model->getCategories() );

		$lists['catid']  = JHTML::_('select.genericList', $category,
				'idcategory', 'class="required validate-dropbox inputbox" size="1" ',
				'idcategory', 'name', $defaultCategory);
		//END CATEGORY

		//SET ROOM DROPDOWN
		$defaultRoom = isset($booking->idroom)?$booking->idroom:'-1';
		$rooms[] = JHTML::_('select.option', 0,
				JText::_('COM_BOOKIT_ANY'), 'idroom', 'name' );
		$rooms = array_merge( $rooms, $model->getRooms() );
		$lists['roomid']  = JHTML::_('select.genericList', $rooms, 'idroom',
				'class="inputbox" size="1"', 'idroom', 'name', $defaultRoom);
		//END ROOM

		//SET EXTRAS
		$extras = $model->getExtras();
		$booking_extras= $model->getBookingExtras($booking->idbook);

		if ($booking_extras!="") {
			$extra_selections = explode(",", $booking_extras);
		} else {
			$extra_selections = array();
		}

		$initial_ids="";
		$new_selection=array();
		for ($i=0; $i<count($extra_selections); $i++)
		{
			$pos=strpos($extra_selections[$i],"-");
			if ($pos>0)
			{
				$new_selection[$i] = substr($extra_selections[$i],0,$pos);
				$quantities[substr($extra_selections[$i],0,$pos)]
				= substr($extra_selections[$i],$pos+1);
			}
			else
			{
				$new_selection[$i]=$extra_selections[$i];
			}
		}
		$html="";

		foreach ($extras as $ex)
		{
			$idextra=$ex->idextra;
			$html .= "<tr>";
			if (in_array($ex->idextra,$new_selection))
			{
				$html .= '<td><input type="checkbox" onClick="updateIDs();
						calculatePrice();" name="extra_box"
						id="extra_box_'.$ex->idextra.'" value="'.$ex->idextra.'"
								checked/>'.$ex->name."</td> ";
				if ($initial_ids != "")
					$initial_ids .= ",".$ex->idextra;
				else
					$initial_ids .= $ex->idextra;
			}
			else
				$html .= '<td><input type="checkbox" onClick="updateIDs();
						calculatePrice();" name="extra_box" id="extra_box_'.$ex->idextra.'"
								value="'.$ex->idextra.'" />'
										.$ex->name."</td> ";

			if ($ex->value_type==6 || $ex->value_type==10)
			{
				if(isset($quantities[$ex->idextra]))
				{
					$html .= '<td><input type="text" onChange="calculatePrice();
							updateIDs(); " size="5" name="extra_box"
							value="' .$quantities[$ex->idextra].
							'" id="'.$ex->idextra.'_qnt" /></td></tr>';
					$initial_ids .= "-".$quantities[$ex->idextra];
				}
				else
				{
					$html .= '<td><input type="text" onChange="calculatePrice();
							updateIDs(); " size="5"  id="'.$ex->idextra.'_qnt" /></td>
									</tr>';

				}
			}
			else
				$html .= '</tr>';


		}
		//END EXTRAS
		$params = BlookingHelper::getParams();

		$this->assignRef('multiroom', $params->multiroom);
		$this->assignRef('extras', $html);
		$this->assignRef('initial_ids', $initial_ids);
		$this->assignRef('lists', $lists);
		$this->assignRef('date_code', $date_code);
		$this->assignRef('booking', $booking);


		$guests =& $model->getGuestDetails();
		if (count($guests)<=0) {
			$url = JURI::base()."index.php?option=com_blooking&controller=guests&task=edit&prev=bookingedit";
			$msg = JText::_("COM_BOOKIT_PLEASE_CREATE_AT_LEAST_ONE").
			"<a href='".$url."'> ".JText::_("COM_BOOKIT_GUEST")."</a> ".
			JText::_("COM_BOOKIT_FIRST");
			JError::raiseNotice (500, $msg );
		}
		$categories = $model->getCategories();
		if (count($categories)<=0) {
			$url = JURI::base()."index.php?option=com_blooking&controller=roomcategoryedit&task=edit&prev=bookingedit";
			$msg = JText::_("COM_BOOKIT_PLEASE_CREATE_AT_LEAST_ONE").
			"<a href='".$url."'> ".JText::_("COM_BOOKIT_ROOM_CATEGORY")."</a> ".
			JText::_("COM_BOOKIT_FIRST");
			JError::raiseNotice (500, $msg );
		}
		$rooms =& $model->getRooms();
		if (count($rooms)<=0) {
			$url = JURI::base()."index.php?option=com_blooking&controller=room&task=edit&prev=bookingedit";
			$msg = JText::_("COM_BOOKIT_PLEASE_CREATE_AT_LEAST_ONE").
			"<a href='".$url."'> ".JText::_("COM_BOOKIT_ROOM")."</a> ".
			JText::_("COM_BOOKIT_FIRST");
			JError::raiseNotice (500, $msg );
		}
		parent::display($tpl);

		// Form Validation
		if(version_compare(JVERSION,'1.6.0','ge')) {
			$document = &JFactory::getDocument();
			$document->addScript( JURI::root(true).
					'/administrator/components/com_blooking/js/formValidator16.js' );
		} else {
			$document = &JFactory::getDocument();
			$document->addScript( JURI::root(true).
					'/administrator/components/com_blooking/js/formValidator15.js' );
		}

	}


	function _arrayToObject($array) {
		if(!is_array($array)) {
			return FALSE;
		}

		$object = new stdClass();
		if (is_array($array) && count($array) > 0) {
			foreach ($array as $name=>$value) {
				$name = strtolower(trim($name));
				if (!empty($name)) {
					$object->$name = $this->_arrayToObject($value);
				}
			}
			return $object;
		}
		else {
			return FALSE;
		}
	}
}