<?php
/**
 * BlooKing - The King in Joomla Booking
 * @version 1.0
 * @author BlooKing.org. Based on BooKiTGold code by Costas Kakousis
 * @copyright (C) 2012-2013 by BlooKing.org (http://www.blooking.org)
 * @license GNU/GPL: http://www.gnu.org/copyleft/gpl.html
 *
 * If you fork this to create your own project, please make a reference to
 * BlooKing! someplace in your code and provide a link to
 * http://www.blooking.org
 *
 * This file is part of BlooKing! BlooKing is free software: you can
 * redistribute it and/or modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * BlooKing is distributed in the hope that it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details. You should have received a copy of the GNU General Public License
 * along with BlooKing.  If not, see <http://www.gnu.org/licenses/>.
 *   ______ __                __  __ __
 *	|   __ \  |.-----..-----.|  |/  |__|.-----..-----.
 *	|   __ <  ||  _  ||  _  ||     <|  ||     ||  _  |
 *	|______/__||_____||_____||__|\__|__||__|__||___  |
 *                                             |_____|
 **/
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.application.component.view' );
class BlookingViewFinalform extends JView {
	function display($tpl = null) {

		JToolbarHelper::title( JText::_( 'COM_BOOKIT_EDIT_FINAL_FORM' ),
		'form');
		$document  = & JFactory::getDocument();
		$document->addStyleSheet(
				JURI::root().'administrator/components/com_blooking/css/icons.css',
				'text/css', null, array() );
		$lang = JRequest::getVar('lang','');
		JToolBarHelper::apply();
		JToolBarHelper::customX( 'save', 'save.png','save_f2.png',
		'COM_BOOKIT_SAVE_CLOSE',false);

		$model = $this->getModel();
		$data = $model->getData();

		JToolBarHelper::divider();
		JToolBarHelper::cancel();
		JToolBarHelper::help( 'final_form-help/final_formhelp', true );


		JLoader::register('BlookingHelper',
		JPATH_COMPONENT.'/helpers/BlookingHelper.php');
		$language_options =  BlookingHelper::getLanguages();
		if ($lang=="")
			$default = 'en';
		else
			$default = $lang;
		$lists['language']  = JHTML::_('select.genericList', $language_options,
				'language', 'class="inputbox" size="1"', 'value', 'text', $default);


		$this->assignRef('lists', $lists);
		$this->assignRef('data', $data);
		$this->assignRef('lang', JRequest::getVar('lang','en'));

		parent::display($tpl);
		// Form Validation
		if(version_compare(JVERSION,'1.6.0','ge')) {
			$document = &JFactory::getDocument();
			$document->addScript( JURI::root(true).
					'/administrator/components/com_blooking/js/formValidator16.js' );
		} else {
			$document = &JFactory::getDocument();
			$document->addScript( JURI::root(true).
					'/administrator/components/com_blooking/js/formValidator15.js' );
		}
	}
}