<?php
/**
 * BlooKing - The King in Joomla Booking
 * @version 1.0
 * @author BlooKing.org. Based on BooKiTGold code by Costas Kakousis
 * @copyright (C) 2012-2013 by BlooKing.org (http://www.blooking.org)
 * @license GNU/GPL: http://www.gnu.org/copyleft/gpl.html
 *
 * If you fork this to create your own project, please make a reference to
 * BlooKing! someplace in your code and provide a link to
 * http://www.blooking.org
 *
 * This file is part of BlooKing! BlooKing is free software: you can
 * redistribute it and/or modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * BlooKing is distributed in the hope that it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details. You should have received a copy of the GNU General Public License
 * along with BlooKing.  If not, see <http://www.gnu.org/licenses/>.
 *   ______ __                __  __ __
 *	|   __ \  |.-----..-----.|  |/  |__|.-----..-----.
 *	|   __ <  ||  _  ||  _  ||     <|  ||     ||  _  |
 *	|______/__||_____||_____||__|\__|__||__|__||___  |
 *                                             |_____|
 **/
defined( '_JEXEC' ) or die( 'Restricted access' );
jimport( 'joomla.application.component.view' );
class BlookingViewGatewayseditor extends JView {
	function display($tpl = null) {
		JToolbarHelper::title( JText::_( 'COM_BOOKIT_PAYMENT_GATEWAYS_EDITOR'), 'gateways' );
		$document  = & JFactory::getDocument();
		$document->addStyleSheet(
				JURI::root().'administrator/components/com_blooking/css/icons.css',
				'text/css', null, array() );

		JToolBarHelper::customX( 'save', 'save.png','save_f2.png',
		'COM_BOOKIT_SAVE_CLOSE',false);
		JToolBarHelper::divider();
		JToolBarHelper::cancel();
		JToolBarHelper::help( 'gateways-help/gatewayshelp', true );

		$model = $this->getModel('gatewayseditor');
		$id = JRequest::getInt('id');

		if(version_compare(JVERSION,'1.6.0','ge')) {
			$row =& JTable::getInstance('extension');
			$row->load($id);
			$row->published = $row->enabled;
			$row->id = $row->extension_id;
			$data = JApplicationHelper::parseXMLInstallFile(JPATH_SITE . DS . 'plugins'. DS .$row->folder . DS . $row->element.DS . $row->element .'.xml');


		} else {

			$row =& JTable::getInstance('plugin');
			$row->load($id);
			$data = JApplicationHelper::parseXMLInstallFile(JPATH_SITE . DS . 'plugins'. DS .$row->folder . DS . $row->element .'.xml');

		}
		$params = new JParameter( $row->params, JApplicationHelper::getPath( 'plg_xml', $row->folder.DS.$row->element ), 'plugin' );

		$lists['published'] = JHTML::_('select.booleanlist',  'published',
				'class="inputbox"', $row->published );



		$lang =& JFactory::getLanguage();
		$lang->load( 'plg_' . trim( $row->folder ) . '_' . trim( $row->element ), JPATH_ADMINISTRATOR );

		$row->description = $data['description'];

		$this->assignRef( 'plugins', $row );
		$this->assignRef( 'lists', $lists );
		$this->assignRef('params', $params);

		if(version_compare(JVERSION,'1.6.0','ge')) {
			parent::display($tpl);
		}
		else {
			parent::display('15');

		}
	}
}