<?php
/**
 * BlooKing - The King in Joomla Booking
 * @version 1.0
 * @author BlooKing.org. Based on BooKiTGold code by Costas Kakousis
 * @copyright (C) 2012-2013 by BlooKing.org (http://www.blooking.org)
 * @license GNU/GPL: http://www.gnu.org/copyleft/gpl.html
 *
 * If you fork this to create your own project, please make a reference to
 * BlooKing! someplace in your code and provide a link to
 * http://www.blooking.org
 *
 * This file is part of BlooKing! BlooKing is free software: you can
 * redistribute it and/or modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * BlooKing is distributed in the hope that it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details. You should have received a copy of the GNU General Public License
 * along with BlooKing.  If not, see <http://www.gnu.org/licenses/>.
 *   ______ __                __  __ __
 *	|   __ \  |.-----..-----.|  |/  |__|.-----..-----.
 *	|   __ <  ||  _  ||  _  ||     <|  ||     ||  _  |
 *	|______/__||_____||_____||__|\__|__||__|__||___  |
 *                                             |_____|
 **/

defined( '_JEXEC' ) or die( 'Restricted access' );
jimport( 'joomla.application.component.view' );
class BlookingViewGuestsedit extends JView {
	function display($tpl = null) {
		$guests        =& $this->get('Data');
		$isNew        = ($guests->idguests < 1);

		$text = $isNew ? JText::_( 'COM_BOOKIT_NEW' ) : JText::_( 'COM_BOOKIT_EDIT' );

		JToolbarHelper::title( JText::_( 'COM_BOOKIT_GUESTS' ).
		': <small>[ ' . $text.' ]</small>',
		'guests');
		$document  = & JFactory::getDocument();
		$document->addStyleSheet(
				JURI::root().'administrator/components/com_blooking/css/icons.css',
				'text/css', null, array() );

		$model =& $this->getModel('guestsedit');
		$lists=array();
		$value = isset($guests->idcountry)? $guests->idcountry: '0';
		$results[] = JHTML::_('select.option', 0, JText::_('COM_BOOKIT_SELECT_AN_ITEM'), 'idcountry', 'name' );
		$results = array_merge( $results,$model->getCountries());

		$lists['catid']  = JHTML::_('select.genericList', $results, 'idcountry', 'class="inputbox" size="1"', 'idcountry', 'name', $value);


		$jusers = $model->getJUsers();
		$options = array();
		foreach($jusers as $juser)
		{
			$options[] = JHTML::_('select.option', $juser->id, $juser->id." - ".$juser->email);
		}

		$value = isset($guests->jid)? $guests->jid: '0';
		$arr[] = JHTML::_('select.option', 0, JText::_('COM_BOOKIT_NONE') );
		$arr = array_merge( $arr,$options);
		$lists['jusers']  = JHTML::_('select.genericList', $arr, 'jid', 'class="inputbox" size="1"', 'value', 'text', $value);


		JToolBarHelper::customX( 'save', 'save.png','save_f2.png',
		'COM_BOOKIT_SAVE_CLOSE',false);
		JToolBarHelper::customX( 'saveNew', 'new.png', 'new_f2.png',
		'COM_BOOKIT_SAVE_NEW', false );
		JToolBarHelper::divider();

		if ($isNew)  {
			JToolBarHelper::cancel();
		} else {
			JToolBarHelper::cancel( 'cancel', 'Close' );
		}
		JToolBarHelper::help( 'guests-help/guestshelp', true );

		$previousView = JRequest::getVar('prev');
		$this->assignRef('prev', $previousView);
		$this->assignRef('lists', $lists);
		$this->assignRef('guests', $guests);
		parent::display($tpl);
		// 	Form Validation
		if(version_compare(JVERSION,'1.6.0','ge')) {
			$document = &JFactory::getDocument();
			$document->addScript( JURI::root(true). '/administrator/components/com_blooking/js/formValidator16.js' );
		} else {
			$document = &JFactory::getDocument();
			$document->addScript( JURI::root(true).'/administrator/components/com_blooking/js/formValidator15.js' );
		}
	}
}