<?php
/**
 * BlooKing - The King in Joomla Booking
 * @version 1.0
 * @author BlooKing.org. Based on BooKiTGold code by Costas Kakousis
 * @copyright (C) 2012-2013 by BlooKing.org (http://www.blooking.org)
 * @license GNU/GPL: http://www.gnu.org/copyleft/gpl.html
 *
 * If you fork this to create your own project, please make a reference to
 * BlooKing! someplace in your code and provide a link to
 * http://www.blooking.org
 *
 * This file is part of BlooKing! BlooKing is free software: you can
 * redistribute it and/or modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * BlooKing is distributed in the hope that it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details. You should have received a copy of the GNU General Public License
 * along with BlooKing.  If not, see <http://www.gnu.org/licenses/>.
 *   ______ __                __  __ __
 *	|   __ \  |.-----..-----.|  |/  |__|.-----..-----.
 *	|   __ <  ||  _  ||  _  ||     <|  ||     ||  _  |
 *	|______/__||_____||_____||__|\__|__||__|__||___  |
 *                                             |_____|
 **/
defined('_JEXEC') or die('Restricted access');
jimport('joomla.html.pagination');
JHTML::_('behavior.formvalidation');

$warningtext = JText::_('COM_BOOKIT_MULTIROOM_WARNING');
$js = <<<EOD
window.addEvent( 'domready', function() {
	var multivalue = $('multiroom').value;
	$('multiroom').addEvent('change',function(){
		if ($('multiroom').value=="2") {
			var warning = confirm("{$warningtext}");
			if (warning==true) {
  				multivalue = $('multiroom').value;
  			} else {
  				$('multiroom').value = multivalue;
  			}
		} else {
			multivalue = $('multiroom').value;
		}
	});
});
EOD;

$doc = & JFactory::getDocument();
$doc->addScriptDeclaration( $js );
?>
<form action="index.php" method="post" name="adminForm" id="adminForm">
	<?php
	echo $this->pane->startPane('configuration-pane');
	echo $this->pane->startPanel(JText::_('COM_BOOKIT_GENERAL'), 'general');
	?>
	<div class="col100">
		<fieldset class="adminform">
			<table class="admintable">
				<tr>
					<td width="100" align="right" class="key"><span class="hasTip"
						title="<?php echo JText::_('COM_BOOKIT_MULTI_ROOM_MODE_DESC'); ?>">
							<?php echo JText::_('COM_BOOKIT_BLOOKING_MODE'); ?>
					</span>
					</td>
					<td><?php echo $this->lists['multiroom'];?>
					</td>
				</tr>
				<tr>
					<td width="100" align="right" class="key"><span class="hasTip"
						title="<?php echo JText::_('COM_BOOKIT_DATE_FORMAT_DESC'); ?>"> <?php echo JText::_('COM_BOOKIT_DATE_FORMAT'); ?>
					</span>
					</td>
					<td><?php echo $this->lists['dateformat'];?>
					</td>
				</tr>
				<tr>
					<td width="100" align="right" class="key"><span class="hasTip"
						title="<?php echo JText::_('COM_BOOKIT_CURRENCY_DESC'); ?>"> <?php echo JText::_('COM_BOOKIT_CURRENCY'); ?>
					</span>
					</td>
					<td><?php echo $this->lists['currency'];?>
					</td>
				</tr>
				<tr>
					<td width="100" align="right" class="key"><span class="hasTip"
						title="<?php echo JText::_('COM_BOOKIT_SHOW_PROGRESS_STEPS_DESC'); ?>">
							<?php echo JText::_('COM_BOOKIT_SHOW_PROGRESS_STEPS'); ?>
					</span>
					</td>
					<td><?php echo $this->lists['show_bar'];?>
					</td>
				</tr>
				<tr>
					<td width="100" align="right" class="key"><span class="hasTip"
						title="<?php echo JText::_('COM_BOOKIT_NEW_TEMPLATE_DESC'); ?>"> <?php echo JText::_('COM_BOOKIT_NEW_TEMPLATE'); ?>
					</span>
					</td>
					<td><?php echo $this->lists['new_template'];?>
					</td>
				</tr>
				<tr>
					<td width="100" align="right" class="key"><span class="hasTip"
						title="<?php echo JText::_('COM_BOOKIT_SHOW_DAILY_RATES_DESC'); ?>">
							<?php echo JText::_('COM_BOOKIT_SHOW_DAILY_RATES'); ?>
					</span>
					</td>
					<td><?php echo $this->lists['show_daily_rates'];?>
					</td>
				</tr>

				<tr>
					<td width="100" align="right" class="key"><span class="hasTip"
						title="<?php echo JText::_('COM_BOOKIT_NORMALIZE_DESC'); ?>"> <?php echo JText::_('COM_BOOKIT_NORMALIZE'); ?>
					</span>
					</td>
					<td><?php echo $this->lists['normalize'];?>
					</td>
				</tr>
			</table>
		</fieldset>
	</div>
	<div class="clr"></div>
	<?php
	echo $this->pane->endPanel();

	echo $this->pane->startPanel(JText::_('COM_BOOKIT_BOOKINGS'), 'bookings');
	?>
	<div class="col100">
		<fieldset class="adminform">
			<table class="admintable">
				<tr>
					<td width="100" align="right" class="key"><span class="hasTip"
						title="<?php echo JText::_('COM_BOOKIT_MAX_BOOKING_PERIOD_DESC'); ?>">
							<?php echo JText::_('COM_BOOKIT_MAX_BOOKING_PERIOD'); ?>
					</span>
					</td>
					<td><input class="text_area" type="text" name="max_booking_period"
						id="max_booking_period" size="35"
						value="<?php echo $this->params->max_booking_period; ?>" />
					</td>
				</tr>
				<tr>
					<td width="100" align="right" class="key"><span class="hasTip"
						title="<?php echo JText::_('COM_BOOKIT_DAYS_FOR_CANCELLATION_DESC'); ?>">
							<?php echo JText::_('COM_BOOKIT_DAYS_FOR_CANCELLATION'); ?>
					</span>
					</td>
					<td><input class="text_area" type="text" name="daysForCancellation"
						id="daysForCancellation" size="35"
						value="<?php echo $this->params->daysForCancellation; ?>" />
					</td>
				</tr>
				<tr>
					<td width="100" align="right" class="key"><span class="hasTip"
						title="<?php echo JText::_('COM_BOOKIT_LAST_DATE_DESC'); ?>"> <?php echo JText::_('COM_BOOKIT_LAST_DATE'); ?>
					</span>
					</td>
					<td><?php echo JHTML::_('calendar',date($this->date_code->d1,
							strtotime($this->params->last_date)),'last_date',
							'last_date',$this->date_code->d2); ?></td>
				</tr>

				<tr>
					<td width="100" align="right" class="key"><span class="hasTip"
						title="<?php echo JText::_('COM_BOOKIT_REQUIRED_DEPOSIT_FIXED_DESC'); ?>">
							<?php echo JText::_('COM_BOOKIT_REQUIRED_DEPOSIT_FIXED'); ?>
					</span>
					</td>
					<td><input class="text_area" type="text" name="deposit_fixed"
						id="deposit_fixed" size="35"
						value="<?php echo $this->params->deposit_fixed; ?>" />
					</td>
				</tr>
				<tr>
					<td width="100" align="right" class="key"><span class="hasTip"
						title="<?php echo JText::_('COM_BOOKIT_REQUIRED_DEPOSIT_PER_DESC'); ?>">
							<?php echo JText::_('COM_BOOKIT_REQUIRED_DEPOSIT_PER'); ?>
					</span>
					</td>
					<td><input class="text_area" type="text" name="deposit_percent"
						id="deposit_percent" size="35"
						value="<?php echo $this->params->deposit_percent; ?>" />
					</td>
				</tr>
				<tr>
					<td width="100" align="right" class="key"><span class="hasTip"
						title="<?php echo JText::_('COM_BOOKIT_FULL_DEPOSIT_REQUIRED_DESC'); ?>">
							<?php echo JText::_('COM_BOOKIT_FULL_DEPOSIT_REQUIRED'); ?>
					</span>
					</td>
					<td><input class="text_area" type="text" name="late_booking"
						id="late_booking" size="5"
						value="<?php echo $this->params->late_booking; ?>" />
					</td>
				</tr>
				<tr>
					<td width="100" align="right" class="key"><span class="hasTip"
						title="<?php echo JText::_('COM_BOOKIT_SHOW_COUPONS_DESC'); ?>"> <?php echo JText::_('COM_BOOKIT_SHOW_COUPONS'); ?>
					</span>
					</td>
					<td><?php echo $this->lists['show_coupons'];?>
					</td>
				</tr>
				<tr>
					<td width="100" align="right" class="key"><span class="hasTip"
						title="<?php echo JText::_('COM_BOOKIT_ADMIN_CONFIRM_DESC'); ?>">
							<?php echo JText::_('COM_BOOKIT_ADMIN_CONFIRM'); ?>
					</span>
					</td>
					<td><?php echo $this->lists['admin_confirm'];?>
					</td>
				</tr>
				<tr>
					<td width="100" align="right" class="key"><span class="hasTip"
						title="<?php echo JText::_('COM_BOOKIT_PRE_VALIDATION_RETURN_DESC'); ?>">
							<?php echo JText::_('COM_BOOKIT_PRE_VALIDATION_RETURN'); ?>
					</span>
					</td>
					<td><input class="text_area" type="text" name="prebooking_url"
						id="prebooking_url" size="70"
						value="<?php echo $this->params->prebooking_url; ?>" />
					</td>
				</tr>
				<tr>
					<td width="100" align="right" class="key"><span class="hasTip"
						title="<?php echo JText::_('COM_BOOKIT_AUTO_CONFIRM_BOOKINGS_DESC'); ?>">
							<?php echo JText::_('COM_BOOKIT_AUTO_CONFIRM_BOOKINGS'); ?>
					</span>
					</td>
					<td><?php echo $this->lists['auto_confirm'];?>
					</td>
				</tr>
				<tr>
					<td width="100" align="right" class="key"><span class="hasTip"
						title="<?php echo JText::_('COM_BOOKIT_PENDING_EXPIRE_ENABLED_DESC'); ?>">
							<?php echo JText::_('COM_BOOKIT_PENDING_EXPIRE_ENABLED'); ?>
					</span>
					</td>
					<td><?php echo $this->lists['pending_enabled'];?>
					</td>
				</tr>

				<tr>
					<td width="100" align="right" class="key"><span class="hasTip"
						title="<?php echo JText::_('COM_BOOKIT_PENDING_EXPIRE_INTERVAL_DESC'); ?>">
							<?php echo JText::_('COM_BOOKIT_PENDING_EXPIRE_INTERVAL'); ?>
					</span>
					</td>
					<td><input class="text_area" type="text" name="pending_time"
						id="pending_time" size="35"
						value="<?php echo $this->utils->pending_time; ?>" />
					</td>
				</tr>
				<tr>
					<td width="100" align="right" class="key"><span class="hasTip"
						title="<?php echo JText::_('COM_BOOKIT_PENDING_EXPIRE_MEASURE_DESC'); ?>">
							<?php echo JText::_('COM_BOOKIT_PENDING_EXPIRE_MEASURE'); ?>
					</span>
					</td>
					<td><?php echo $this->lists['pending_measure'];?>
					</td>
				</tr>

				<tr>
					<td width="100" align="right" class="key"><span class="hasTip"
						title="<?php echo JText::_('COM_BOOKIT_SUCCESSFUL_RETURN_URL_DESC'); ?>">
							<?php echo JText::_('COM_BOOKIT_SUCCESSFUL_RETURN_URL'); ?>
					</span>
					</td>
					<td><input class="text_area" type="text" name="ok_url" id="ok_url"
						size="70" value="<?php echo $this->params->ok_url; ?>" />
					</td>
				</tr>
				<tr>
					<td width="100" align="right" class="key"><span class="hasTip"
						title="<?php echo JText::_('COM_BOOKIT_UNSUCCESSFUL_RETURN_URL_DESC'); ?>">
							<?php echo JText::_('COM_BOOKIT_UNSUCCESSFUL_RETURN_URL'); ?>
					</span>
					</td>
					<td><input class="text_area" type="text" name="failure_url"
						id="failure_url" size="70"
						value="<?php echo $this->params->failure_url; ?>" />
					</td>
				</tr>
			</table>
		</fieldset>
	</div>
	<div class="clr"></div>
	<?php
	echo $this->pane->endPanel();

	echo $this->pane->startPanel(JText::_('COM_BOOKIT_CALENDAR'), 'calendar');
	?>

	<div class="col100">
		<fieldset class="adminform">
			<table class="admintable">
				<tr>
					<td width="100" align="right" class="key"><span class="hasTip"
						title="<?php echo JText::_('COM_BOOKIT_SHOW_CALENDAR_DESC'); ?>">
							<?php echo JText::_('COM_BOOKIT_SHOW_CALENDAR'); ?>
					</span>
					</td>
					<td><?php echo $this->lists['show_calendar'];?>
					</td>
				</tr>
				<tr>
					<td width="100" align="right" class="key"><span class="hasTip"
						title="<?php echo JText::_('COM_BOOKIT_SHOW_YEAR_CALENDAR_DESC'); ?>">
							<?php echo JText::_('COM_BOOKIT_SHOW_YEAR_CALENDAR'); ?>
					</span>
					</td>
					<td><?php echo $this->lists['show_year_calendar'];?>
					</td>
				</tr>
				<tr>
					<td width="100" align="right" class="key"><span class="hasTip"
						title="<?php echo JText::_('COM_BOOKIT_START_ON_MONDAY_DESC'); ?>">
							<?php echo JText::_('COM_BOOKIT_START_ON_MONDAY'); ?>
					</span>
					</td>
					<td><?php echo $this->lists['start_monday'];?>
					</td>
				</tr>
				<tr>
					<td width="100" align="right" class="key"><span class="hasTip"
						title="<?php echo JText::_('COM_BOOKIT_AVAILABLE_COLOR_DESC'); ?>">
							<?php echo JText::_('COM_BOOKIT_AVAILABLE_COLOR'); ?>
					</span></td>
					<td><input class="color" type="text" name="available_color"
						id="available_color" size="35"
						value="<?php echo $this->params->available_color; ?>" /></td>
				</tr>
				<tr>
					<td width="100" align="right" class="key"><span class="hasTip"
						title="<?php echo JText::_('COM_BOOKIT_BOOKED_COLOR_DESC'); ?>"> <?php echo JText::_('COM_BOOKIT_BOOKED_COLOR'); ?>
					</span></td>
					<td><input class="color" type="text" name="booked_color"
						id="booked_color" size="35"
						value="<?php echo $this->params->booked_color; ?>" /></td>
				</tr>
				<tr>
					<td width="100" align="right" class="key"><span class="hasTip"
						title="<?php echo JText::_('COM_BOOKIT_PENDING_COLOR_DESC'); ?>">
							<?php echo JText::_('COM_BOOKIT_PENDING_COLOR'); ?>
					</span></td>
					<td><input class="color" type="text" name="pending_color"
						id="pending_color" size="35"
						value="<?php echo $this->params->pending_color; ?>" /></td>
				</tr>
				<tr>
					<td width="100" align="right" class="key"><span class="hasTip"
						title="<?php echo JText::_('COM_BOOKIT_EXTRA_COLOR_DESC'); ?>"> <?php echo JText::_('COM_BOOKIT_EXTRA_COLOR'); ?>
					</span></td>
					<td><input class="color" type="text" name="other_color"
						id="other_color" size="35"
						value="<?php echo $this->params->other_color; ?>" /></td>
				</tr>
				<tr>
					<td width="100" align="right" class="key"><span class="hasTip"
						title="<?php echo JText::_('COM_BOOKIT_SHOW_AVAILABLE_DESC'); ?>">
							<?php echo JText::_('COM_BOOKIT_SHOW_AVAILABLE'); ?>
					</span>
					</td>
					<td><?php echo $this->lists['show_available'];?>
					</td>
				</tr>
				<tr>
					<td width="100" align="right" class="key"><span class="hasTip"
						title="<?php echo JText::_('COM_BOOKIT_SHOW_BOOKED_DESC'); ?>"> <?php echo JText::_('COM_BOOKIT_SHOW_BOOKED'); ?>
					</span>
					</td>
					<td><?php echo $this->lists['show_booked'];?>
					</td>
				</tr>
				<tr>
					<td width="100" align="right" class="key"><span class="hasTip"
						title="<?php echo JText::_('COM_BOOKIT_SHOW_PENDING_DESC'); ?>"> <?php echo JText::_('COM_BOOKIT_SHOW_PENDING'); ?>
					</span>
					</td>
					<td><?php echo $this->lists['show_pending'];?>
					</td>
				</tr>
				<tr>
					<td width="100" align="right" class="key"><span class="hasTip"
						title="<?php echo JText::_('COM_BOOKIT_SHOW_EXTRA_DESC'); ?>"> <?php echo JText::_('COM_BOOKIT_SHOW_EXTRA'); ?>
					</span>
					</td>
					<td><?php echo $this->lists['show_extra'];?>
					</td>
				</tr>


			</table>
		</fieldset>
	</div>
	<div class="clr"></div>
	<?php
	echo $this->pane->endPanel();

	echo $this->pane->startPanel(JText::_('COM_BOOKIT_EMAILS'), 'emails');
	?>
	<div class="col100">
		<fieldset class="adminform">
			<table class="admintable">

				<tr>
					<td width="100" align="right" class="key"><span class="hasTip"
						title="<?php echo JText::_('COM_BOOKIT_ADMIN_EMAIL_DESC'); ?>"> <?php echo JText::_('COM_BOOKIT_ADMIN_EMAIL'); ?>
					</span>
					</td>
					<td><input class="text_area" type="text" name="admin_email"
						id="admin_email" size="35"
						value="<?php echo $this->params->admin_email; ?>" />
					</td>
				</tr>
				<tr>
					<td width="100" align="right" class="key"><span class="hasTip"
						title="<?php echo JText::_('COM_BOOKIT_ADMIN_EMAIL_2_DESC'); ?>">
							<?php echo JText::_('COM_BOOKIT_ADMIN_EMAIL_2'); ?>
					</span>
					</td>
					<td><input class="text_area" type="text" name="admin_email2"
						id="admin_email2" size="35"
						value="<?php echo $this->params->admin_email2; ?>" />
					</td>
				</tr>
			</table>
		</fieldset>
	</div>
	<div class="clr"></div>
	<?php
	echo $this->pane->endPanel();

	echo $this->pane->startPanel(JText::_('COM_BOOKIT_FINAL_FORM'), 'finalform');
	?>

	<div class="col100">
		<fieldset class="adminform">
			<table class="admintable">


				<tr id="surname_req_row">
					<td width="100" align="right" class="key"><span class="hasTip"
						title="<?php echo JText::_('COM_BOOKIT_SURNAME_REQUIRED_DESC'); ?>">
							<?php echo JText::_('COM_BOOKIT_SURNAME_REQUIRED'); ?>
					</span>
					</td>
					<td><?php echo $this->lists['surname_req'];?></td>
				</tr>

				<tr>
					<td width="100" align="right" class="key"><span class="hasTip"
						title="<?php echo JText::_('COM_BOOKIT_SHOW_ADDRESS_DESC'); ?>"> <?php echo JText::_('COM_BOOKIT_SHOW_ADDRESS'); ?>
					</span>
					</td>
					<td><?php echo $this->lists['show_address'];?></td>

				</tr>
				<tr id="address_req_row">
					<td width="100" align="right" class="key"><span class="hasTip"
						title="<?php echo JText::_('COM_BOOKIT_ADDRESS_REQUIRED_DESC'); ?>">
							<?php echo JText::_('COM_BOOKIT_ADDRESS_REQUIRED'); ?>
					</span>
					</td>
					<td><?php echo $this->lists['address_req'];?></td>
				</tr>
				<tr>
					<td width="100" align="right" class="key"><span class="hasTip"
						title="<?php echo JText::_('COM_BOOKIT_SHOW_ADDR3_DESC'); ?>"> <?php echo JText::_('COM_BOOKIT_SHOW_ADDR3'); ?>
					</span>
					</td>
					<td><?php echo $this->lists['show_address3'];?></td>
				</tr>
				<tr>
					<td width="100" align="right" class="key"><span class="hasTip"
						title="<?php echo JText::_('COM_BOOKIT_SHOW_POSTCODE_DESC'); ?>">
							<?php echo JText::_('COM_BOOKIT_SHOW_POSTCODE'); ?>
					</span>
					</td>
					<td><?php echo $this->lists['show_postcode'];?></td>
				</tr>

				<tr id="postcode_req_row">
					<td width="100" align="right" class="key"><span class="hasTip"
						title="<?php echo JText::_('COM_BOOKIT_POSTCODE_REQUIRED_DESC'); ?>">
							<?php echo JText::_('COM_BOOKIT_POSTCODE_REQUIRED'); ?>
					</span>
					</td>
					<td><?php echo $this->lists['postcode_req'];?></td>
				</tr>
				<tr>
					<td width="100" align="right" class="key"><span class="hasTip"
						title="<?php echo JText::_('COM_BOOKIT_SHOW_PHONE_DESC'); ?>"> <?php echo JText::_('COM_BOOKIT_SHOW_PHONE'); ?>
					</span>
					</td>
					<td><?php echo $this->lists['show_phone'];?></td>

				</tr>
				<tr id="phone_req_row">
					<td width="100" align="right" class="key"><span class="hasTip"
						title="<?php echo JText::_('COM_BOOKIT_PHONE_REQUIRED_DESC'); ?>">
							<?php echo JText::_('COM_BOOKIT_PHONE_REQUIRED'); ?>
					</span>
					</td>
					<td><?php echo $this->lists['phone_req'];?></td>
				</tr>

				<tr>
					<td width="100" align="right" class="key"><span class="hasTip"
						title="<?php echo JText::_('COM_BOOKIT_SHOW_CAPTCHA_DESC'); ?>"> <?php echo JText::_('COM_BOOKIT_SHOW_CAPTCHA'); ?>
					</span>
					</td>
					<td><?php echo $this->lists['show_captcha'];?></td>

				</tr>
				<tr>
					<td width="100" align="right" class="key"><span class="hasTip"
						title="<?php echo JText::_( 'COM_BOOKIT_PUBLIC_KEY_DESC' ); ?>"> <?php echo JText::_( 'COM_BOOKIT_PUBLIC_KEY' ); ?>
					</span></td>
					<td><input class="text_area" type="text" name="publickey"
						id="publickey" size="35"
						value="<?php echo $this->utils->publickey; ?>" />
					</td>
				</tr>
				<tr>
					<td width="100" align="right" class="key"><span class="hasTip"
						title="<?php echo JText::_( 'COM_BOOKIT_PRIVATE_KEY_DESC' ); ?>">
							<?php echo JText::_( 'COM_BOOKIT_PRIVATE_KEY' ); ?>
					</span></td>
					<td><input class="text_area" type="text" name="privatekey"
						id="privatekey" size="35"
						value="<?php echo $this->utils->privatekey; ?>" />
					</td>
				</tr>
				<tr>
					<td width="100" align="right" class="key"><span class="hasTip"
						title="<?php echo JText::_('COM_BOOKIT_CAPTCHA_THEME_DESC'); ?>">
							<?php echo JText::_('COM_BOOKIT_CAPTCHA_THEME'); ?>
					</span>
					</td>
					<td><?php echo $this->lists['captcha_theme'];?></td>
				</tr>
			</table>
		</fieldset>
	</div>
	<div class="clr"></div>

	<?php
	echo $this->pane->endPanel();

	?>
	<input type="hidden" name="option" value="com_blooking" /> <input
		type="hidden" name="task" value="display" /> <input type="hidden"
		name="view" value="params" /> <input type="hidden" name="layout"
		value="default" /> <input type="hidden" name="controller"
		value="params" />
</form>
