<?php
/**
 * BlooKing - The King in Joomla Booking
 * @version 1.0
 * @author BlooKing.org. Based on BooKiTGold code by Costas Kakousis
 * @copyright (C) 2012-2013 by BlooKing.org (http://www.blooking.org)
 * @license GNU/GPL: http://www.gnu.org/copyleft/gpl.html
 *
 * If you fork this to create your own project, please make a reference to
 * BlooKing! someplace in your code and provide a link to
 * http://www.blooking.org
 *
 * This file is part of BlooKing! BlooKing is free software: you can
 * redistribute it and/or modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * BlooKing is distributed in the hope that it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details. You should have received a copy of the GNU General Public License
 * along with BlooKing.  If not, see <http://www.gnu.org/licenses/>.
 *   ______ __                __  __ __
 *	|   __ \  |.-----..-----.|  |/  |__|.-----..-----.
 *	|   __ <  ||  _  ||  _  ||     <|  ||     ||  _  |
 *	|______/__||_____||_____||__|\__|__||__|__||___  |
 *                                             |_____|
 **/
defined( '_JEXEC' ) or die( 'Restricted access' );
jimport( 'joomla.application.component.view' );
jimport('joomla.html.pane');

class BlookingViewParams extends JView {
	function display($tpl = null) {
		$task = JRequest::getVar('task');
		$filetype = JRequest::getVar('type');

		JToolbarHelper::title( JText::_( 'COM_BOOKIT_PARAMETERS' ), 'params');
		$document  = & JFactory::getDocument();
		$document->addScript( JURI::root(true).
				'/administrator/components/com_blooking/js/jscolor/jscolor.js' );
		$document->addStyleSheet(
				JURI::root().'administrator/components/com_blooking/css/icons.css',
				'text/css', null, array() );


		JToolBarHelper::apply();
		JToolBarHelper::customX( 'save', 'save.png','save_f2.png',
		'COM_BOOKIT_SAVE',false);

		JToolBarHelper::divider();
		JToolBarHelper::cancel();
		JToolBarHelper::help( 'properties-help/propertieshelp', true );

		JLoader::register('BlookingHelper',
		JPATH_COMPONENT.'/helpers/BlookingHelper.php');

		$binary_options =  array(JHTML::_('select.option', 0, JText::_('JNO')),
				JHTML::_('select.option', 1, JText::_('JYES')));

		$blooking_mode = array(JHTML::_('select.option', 0, JText::_('COM_BOOKIT_SINGLE_ROOM_MODE')),
				JHTML::_('select.option', 1, JText::_('COM_BOOKIT_MULTI_ROOM')),
				JHTML::_('select.option', 2, JText::_('COM_BOOKIT_WHOLE_PROPERTY')));

		$params = BlookingHelper::getParams();
		$lists = array();
		$lists['multiroom'] = JHTML::_('select.genericlist',$blooking_mode,
				'multiroom', 'class="inputbox"', 'value', 'text',
				$params->multiroom);
		$lists['start_monday'] = JHTML::_('select.genericlist',
				$binary_options, 'start_monday', 'class="inputbox"',
				'value', 'text', $params->start_monday);
		$lists['show_available'] = JHTML::_('select.genericlist',
				$binary_options, 'show_available', 'class="inputbox"',
				'value', 'text', $params->show_available);
		$lists['show_booked'] = JHTML::_('select.genericlist', $binary_options,
				'show_booked', 'class="inputbox"', 'value', 'text',
				$params->show_booked);
		$lists['show_pending'] = JHTML::_('select.genericlist', $binary_options,
				'show_pending', 'class="inputbox"', 'value', 'text',
				$params->show_pending);
		$lists['show_extra'] = JHTML::_('select.genericlist', $binary_options,
				'show_extra', 'class="inputbox"', 'value', 'text',
				$params->show_extra);
		$lists['show_coupons'] = JHTML::_('select.genericlist', $binary_options,
				'show_coupons', 'class="inputbox"', 'value', 'text',
				$params->show_coupons);
		$lists['auto_confirm'] = JHTML::_('select.genericlist', $binary_options,
				'auto_confirm', 'class="inputbox"', 'value', 'text',
				$params->auto_confirm);
		$lists['show_calendar'] = JHTML::_('select.genericlist', $binary_options,
				'show_calendar', 'class="inputbox"', 'value', 'text',
				$params->show_calendar);
		$lists['show_year_calendar'] = JHTML::_('select.genericlist', $binary_options,
				'show_year_calendar', 'class="inputbox"', 'value', 'text',
				$params->show_year_calendar);
		$lists['show_daily_rates'] = JHTML::_('select.genericlist', $binary_options,
				'show_daily_rates', 'class="inputbox"', 'value', 'text',
				$params->show_daily_rates);
		$lists['normalize'] = JHTML::_('select.genericlist', $binary_options,
				'normalize', 'class="inputbox"', 'value', 'text',
				$params->normalize);
		$lists['show_bar'] = JHTML::_('select.genericlist', $binary_options,
				'show_bar', 'class="inputbox"', 'value', 'text',
				$params->show_bar);
		$lists['new_template'] = JHTML::_('select.genericlist', $binary_options,
				'new_template', 'class="inputbox"', 'value', 'text',
				$params->new_template);
		$lists['admin_confirm'] = JHTML::_('select.genericlist', $binary_options,
				'admin_confirm', 'class="inputbox"', 'value', 'text',
				$params->admin_confirm);


		$utils = BlookingHelper::getUtils();
		$lists['show_address3'] = JHTML::_('select.genericlist', $binary_options,
				'show_address3', 'class="inputbox"', 'value', 'text',
				$utils->show_address3);
		$lists['surname_req'] = JHTML::_('select.genericlist', $binary_options,
				'surname_req', 'class="inputbox"', 'value', 'text',
				$utils->surname_req);
		$lists['show_postcode'] = JHTML::_('select.genericlist', $binary_options,
				'show_postcode', 'class="inputbox"', 'value', 'text',
				$utils->show_postcode);
		$lists['postcode_req'] = JHTML::_('select.genericlist', $binary_options,
				'postcode_req', 'class="inputbox"', 'value', 'text',
				$utils->postcode_req);
		$lists['show_address'] = JHTML::_('select.genericlist', $binary_options,
				'show_address', 'class="inputbox"', 'value', 'text',
				$utils->show_address);
		$lists['address_req'] = JHTML::_('select.genericlist', $binary_options,
				'address_req', 'class="inputbox"', 'value', 'text',
				$utils->address_req);
		$lists['show_phone'] = JHTML::_('select.genericlist', $binary_options,
				'show_phone', 'class="inputbox"', 'value', 'text',
				$utils->show_phone);
		$lists['phone_req'] = JHTML::_('select.genericlist', $binary_options,
				'phone_req', 'class="inputbox"', 'value', 'text',
				$utils->phone_req);
		$lists['show_captcha'] = JHTML::_('select.genericlist', $binary_options,
				'show_captcha', 'class="inputbox"', 'value', 'text',
				$utils->show_captcha);
		$lists['pending_enabled'] = JHTML::_('select.genericlist', $binary_options,
				'pending_enabled', 'class="inputbox"', 'value', 'text',
				$utils->pending_enabled);


		$captcha_options =  array(
				JHTML::_('select.option', 'red', 'red'),
				JHTML::_('select.option', 'white', 'white'),
				JHTML::_('select.option', 'clean', 'clean'),
				JHTML::_('select.option', 'blackglass', 'blackglass'));

		$lists['captcha_theme']  = JHTML::_('select.genericList',
				$captcha_options, 'captcha_theme',
				'class="inputbox"', 'value', 'text', $utils->captcha_theme);

		$date_options = array(
				JHTML::_('select.option', '1', 'Y-m-d'),
				JHTML::_('select.option', '2', 'm-d-Y'),
				JHTML::_('select.option', '3', 'd-m-Y')
		);
		$lists['dateformat'] = JHTML::_('select.genericlist', $date_options,
				'dateformat', 'class="inputbox"', 'value',
				'text', $params->dateformat);

		$lists['currency'] = JHTML::_('select.genericlist',
				BlookingHelper::getCurrencyOptions(), 'currency',
				'class="inputbox"', 'value', 'text', $params->currency);

		$options['0'] =  JHTML::_('select.option',
				'0', JText::_('COM_BOOKIT_PENDING_EXPIRE_MONTH'));
		$options['1'] =  JHTML::_('select.option',
				'1', JText::_('COM_BOOKIT_PENDING_EXPIRE_WEEK'));
		$options['2'] =  JHTML::_('select.option',
				'2', JText::_('COM_BOOKIT_PENDING_EXPIRE_DAY'));
		$options['3'] =  JHTML::_('select.option',
				'3', JText::_('COM_BOOKIT_PENDING_EXPIRE_HOUR'));
		$options['4'] =  JHTML::_('select.option',
				'4', JText::_('COM_BOOKIT_PENDING_EXPIRE_MINUTE'));

			
		$lists['pending_measure'] = JHTML::_('select.genericlist', $options,
				'pending_measure', 'class="inputbox"', 'value', 'text',
				$utils->pending_measure);



		$pane =& JPane::getInstance('tabs', array('startOffset'=>0));

		$this->assignRef('utils', $utils);
		$this->assignRef('params', $params);
		$this->assignRef('pane', $pane);
		$this->assignRef('lists', $lists);
		$this->assignRef('date_code', BlookingHelper::getDateFormat());



		$model = $this->getModel('params');
		parent::display($tpl);

	}

}