<?php
/**
 * BlooKing - The King in Joomla Booking
 * @version 1.0
 * @author BlooKing.org. Based on BooKiTGold code by Costas Kakousis
 * @copyright (C) 2012-2013 by BlooKing.org (http://www.blooking.org)
 * @license GNU/GPL: http://www.gnu.org/copyleft/gpl.html
 *
 * If you fork this to create your own project, please make a reference to
 * BlooKing! someplace in your code and provide a link to
 * http://www.blooking.org
 *
 * This file is part of BlooKing! BlooKing is free software: you can
 * redistribute it and/or modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * BlooKing is distributed in the hope that it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details. You should have received a copy of the GNU General Public License
 * along with BlooKing.  If not, see <http://www.gnu.org/licenses/>.
 *   ______ __                __  __ __
 *	|   __ \  |.-----..-----.|  |/  |__|.-----..-----.
 *	|   __ <  ||  _  ||  _  ||     <|  ||     ||  _  |
 *	|______/__||_____||_____||__|\__|__||__|__||___  |
 *                                             |_____|
 **/
defined( '_JEXEC' ) or die( 'Restricted access' );
jimport( 'joomla.application.component.view' );

class BlookingViewRoomcategoryedit extends JView {
	function display($tpl = null) {
		$category        =& $this->get('Data');
		$isNew        = ($category->idcategory < 1);

		$text = $isNew ? JText::_( 'COM_BOOKIT_NEW' ) : JText::_( 'COM_BOOKIT_EDIT' );

		JLoader::register('BlookingHelper',JPATH_COMPONENT.'/helpers/BlookingHelper.php');
		$params = BlookingHelper::getParams();

		if ($params->multiroom != "2") {
			JToolbarHelper::title( JText::_( 'COM_BOOKIT_ROOM_CATEGORY' ).
			': <small><small>[ ' . $text.' ]</small></small>' , 'roomcategories');
		} else {
			JToolbarHelper::title( JText::_( 'COM_BOOKIT_PROPERTIES' ).
			': <small><small>[ ' . $text.' ]</small></small>' , 'roomcategories');
		}

		JToolBarHelper::apply();
		JToolBarHelper::customX( 'save', 'save.png','save_f2.png',
		'COM_BOOKIT_SAVE_CLOSE',false);
		JToolBarHelper::customX( 'saveNew', 'new.png', 'new_f2.png',
		'COM_BOOKIT_SAVE_NEW', false );
		JToolBarHelper::divider();

		 
		if ($isNew)  {
			JToolBarHelper::cancel();
		} else {
			JToolBarHelper::cancel( 'cancel', 'Close' );
		}
		JToolBarHelper::help( 'room_categories-help/room_categorieshelp', true );

		$options = $this->_getDayOptions();
			
		$arrSelectedStartDays = explode(",",$category->start_day);
		$arrSelectedEndDays = explode(",",$category->end_day);

		if (count($arrSelectedStartDays)<7)
			$arrSelectedStartDays =  array(0, 0, 0, 0, 0, 0, 0);

		if (count($arrSelectedEndDays)<7)
			$arrSelectedEndDays =  array(0, 0, 0, 0, 0, 0, 0);

		$this->assignRef('startdays', $arrSelectedStartDays);
		$this->assignRef('enddays', $arrSelectedEndDays);

		$language_options =  BlookingHelper::getLanguages();

		$lang = JRequest::getVar('lang','');
		if ($lang=="")
			$default = 'en';
		else
			$default = $lang;
		$lists['language']  = JHTML::_('select.genericList', $language_options,
				'language', 'class="inputbox" size="1"', 'value', 'text', $default);

		$document  = & JFactory::getDocument();
		$document->addStyleSheet(
				JURI::root().'administrator/components/com_blooking/css/icons.css',
				'text/css', null, array() );

		$prevView = JRequest::getVar('prev');
		$this->assignRef('prev', $prevView);
		$this->assignRef('lang', JRequest::getVar('lang','en'));
		$this->assignRef('category', $category);
		$this->assignRef('lists', $lists);
		$this->assignRef('multiroom', $params->multiroom);
		parent::display($tpl);
		// 	Form Validation
		if(version_compare(JVERSION,'1.6.0','ge')) {
			$document = &JFactory::getDocument();
			$document->addScript( JURI::root(true). '/administrator/components/com_blooking/js/formValidator16.js' );
		} else {
			$document = &JFactory::getDocument();
			$document->addScript( JURI::root(true).'/administrator/components/com_blooking/js/formValidator15.js' );
		}
	}

	function _getDayOptions ()
	{
		$options =  array();
		array_push($options, JHTML::_('select.option', -1,
		JText::_('COM_BOOKIT_ANY')));
		array_push($options, JHTML::_('select.option', 0,
		JText::_('SUNDAY')));
		array_push($options, JHTML::_('select.option', 1,
		JText::_('MONDAY')));
		array_push($options, JHTML::_('select.option', 2,
		JText::_('TUESDAY')));
		array_push($options, JHTML::_('select.option', 3,
		JText::_('WEDNESDAY')));
		array_push($options, JHTML::_('select.option', 4,
		JText::_('THURSDAY')));
		array_push($options, JHTML::_('select.option', 5,
		JText::_('FRIDAY')));
		array_push($options, JHTML::_('select.option', 6,
		JText::_('SATURDAY')));
		return $options;
	}


}