<?php
/**
 * BlooKing - The King in Joomla Booking
 * @version 1.0
 * @author BlooKing.org. Based on BooKiTGold code by Costas Kakousis
 * @copyright (C) 2012-2013 by BlooKing.org (http://www.blooking.org)
 * @license GNU/GPL: http://www.gnu.org/copyleft/gpl.html
 *
 * If you fork this to create your own project, please make a reference to
 * BlooKing! someplace in your code and provide a link to
 * http://www.blooking.org
 *
 * This file is part of BlooKing! BlooKing is free software: you can
 * redistribute it and/or modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * BlooKing is distributed in the hope that it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details. You should have received a copy of the GNU General Public License
 * along with BlooKing.  If not, see <http://www.gnu.org/licenses/>.
 *   ______ __                __  __ __
 *	|   __ \  |.-----..-----.|  |/  |__|.-----..-----.
 *	|   __ <  ||  _  ||  _  ||     <|  ||     ||  _  |
 *	|______/__||_____||_____||__|\__|__||__|__||___  |
 *                                             |_____|
 **/
// No direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.application.component.view' );

class BlookingViewRoomedit extends JView {
	function display($tpl = null) {
		$room        =& $this->get('Data');
		$isNew        = ($room->idroom < 1);

		$text = $isNew ? JText::_( 'COM_BOOKIT_NEW' ) :
		JText::_( 'COM_BOOKIT_EDIT' );

		JToolbarHelper::title(JText::_( 'COM_BOOKIT_ROOM' ).':
				<small>[ ' . $text.' ]</small>', 'rooms');

		$document  = & JFactory::getDocument();
		$document->addStyleSheet(
				JURI::root().'administrator/components/com_blooking/css/icons.css',
				'text/css', null, array() );



		JToolBarHelper::customX( 'save', 'save.png','save_f2.png',
		'COM_BOOKIT_SAVE_CLOSE',false);
		JToolBarHelper::customX( 'saveNew', 'new.png', 'new_f2.png',
		'COM_BOOKIT_SAVE_NEW', false );
		JToolBarHelper::divider();

		$roomcategories        =& $this->get('RoomCategories');

		$this->assignRef('roomcategories', $roomcategories );
		if ($isNew)  {
			JToolBarHelper::cancel();
		} else {
			JToolBarHelper::cancel( 'cancel', 'Close' );
			$roomcategory        =& $this->get('RoomCategory');
			$this->assignRef('roomCategory', $roomcategory);
		}
		JToolBarHelper::help( 'rooms-help/roomshelp', true );

		$mainframe = JFactory::getApplication();
		$state =& $this->get( 'state' );

			
		$previousView = JRequest::getVar('prev');
		$this->assignRef('prev', $previousView);
		$this->assignRef('room', $room);

		$model =& $this->getModel('roomedit');
		$categories =& $model->getRoomCategories();
		if (count($categories)<=0) {
			$url = JURI::base()."index.php?option=com_blooking&controller=roomcategory&task=edit&prev=roomedit";
			$msg = JText::_("COM_BOOKIT_PLEASE_CREATE_AT_LEAST_ONE").
			"<a href='".$url."'> ".JText::_("COM_BOOKIT_ROOM_CATEGORY")."</a> ".
			JText::_("COM_BOOKIT_FIRST");
			JError::raiseNotice (500, $msg );
		}

		parent::display($tpl);

		// Form Validation
		if(version_compare(JVERSION,'1.6.0','ge')) {
			$document = &JFactory::getDocument();
			$document->addScript( JURI::root(true). '/administrator/components/com_blooking/js/formValidator16.js' );
		} else {
			$document = &JFactory::getDocument();
			$document->addScript( JURI::root(true).'/administrator/components/com_blooking/js/formValidator15.js' );
		}
	}
}