<?php
/**
 * BlooKing - The King in Joomla Booking
 * @version 1.0
 * @author BlooKing.org. Based on BooKiTGold code by Costas Kakousis
 * @copyright (C) 2012-2013 by BlooKing.org (http://www.blooking.org)
 * @license GNU/GPL: http://www.gnu.org/copyleft/gpl.html
 *
 * If you fork this to create your own project, please make a reference to
 * BlooKing! someplace in your code and provide a link to
 * http://www.blooking.org
 *
 * This file is part of BlooKing! BlooKing is free software: you can
 * redistribute it and/or modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * BlooKing is distributed in the hope that it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details. You should have received a copy of the GNU General Public License
 * along with BlooKing.  If not, see <http://www.gnu.org/licenses/>.
 *   ______ __                __  __ __
 *	|   __ \  |.-----..-----.|  |/  |__|.-----..-----.
 *	|   __ <  ||  _  ||  _  ||     <|  ||     ||  _  |
 *	|______/__||_____||_____||__|\__|__||__|__||___  |
 *                                             |_____|
 **/
defined('_JEXEC') or die('Restricted access');
$editor =& JFactory::getEditor();
JHTML::_('behavior.formvalidation');

$js = <<<EOD
window.addEvent( 'domready', function() {
	$('language').value='{$this->lang}';
	var jsonReq = new Request.JSON({
  		url: 'index.php',
 		method: 'get',
  		data: {json: 'yes' },
	  	onSuccess: function (responseJSON, responseText){

		if (typeof responseJSON != 'undefined' &&  responseJSON != null )
	  	{
	  		translation = responseJSON.description;
	  		if (translation!=null)
			{
	  			if (typeof(WFEditor) != 'undefined' && WFEditor!=null)
				WFEditor.setContent('description',translation);
				else if (typeof(tinyMCE)!='undefined' && tinyMCE!=null &&
				tinyMCE.activeEditor!=null)
				{
					tinyMCE.activeEditor.setContent(translation);
				}
				//Check if JCK editor
				else if (typeof(CKEDITOR) !== 'undefined' && CKEDITOR.instances != null)
				{
					for ( instance in CKEDITOR.instances )
					{
						CKEDITOR.instances[instance].setData( translation );
					}
				}
				else
				{
					document.id('description').value = translation;
				}
			}
	  		name = responseJSON.name;
	  		if (name!=null && name!="")
	  		$('name').value=name;
	  	}
  	}
 });

 		if ({$this->extra->idextra}>0)
		{
			jsonReq.get({'option': 'com_blooking', 'view':'roomextraedit',
			'controller':'roomextraedit', 'format':'json',
			'task':'languageChange', 'language':$('language').value,
			'idextra':'{$this->extra->idextra}',
			'name':$('name').value});
		}
		
	$('language').addEvent('change',function(){
		if ({$this->extra->idextra}>0)
		{
			jsonReq.get({'option': 'com_blooking', 'view':'roomextraedit',
			'controller':'roomextraedit', 'format':'json',
			'task':'languageChange', 'language':$('language').value,
			'idextra':'{$this->extra->idextra}',
			'name':$('name').value});
		}
	});

});
EOD;

$doc = & JFactory::getDocument();
$doc->addScriptDeclaration( $js );
?>
<style type="text/css">
.invalid {
	border: 1px solid red;
}
</style>
<form action="index.php" method="post" name="adminForm" id="adminForm"
	class="form-validate">
	<div class="col100">
		<fieldset class="adminform">
			<legend>
				<?php echo JText::_( 'COM_BOOKIT_EXTRA_BASICS' ); ?>
			</legend>
			<table class="admintable">
				<tr>
					<td width="100" align="right" class="key"><label for="language"> <?php echo JText::_( 'COM_BOOKIT_LANGUAGE' ); ?>:
					</label></td>

					<td><?php echo $this->lists['language']; ?></td>
				</tr>
				<tr>
					<td width="100" align="right" class="key"><label for="name"> <?php echo JText::_( 'COM_BOOKIT_EXTRA_NAME' ); ?>:
					</label>
					</td>
					<td><input class="required text_area" type="text" name="name"
						id="name" size="20" maxlength="250"
						value="<?php echo $this->extra->name;?>" />
					</td>

				</tr>

				<tr>
					<td width="30" align="right" class="key"><label for="cost"> <?php echo JText::_( 'COM_BOOKIT_MANDATORY' ); ?>:
					</label></td>
					<td>
						<table>
							<tr>
								<td><?php echo JText::_('JNO');?></td>
								<td><input type="radio" name="extra_type" id="extra_type"
									value="0"
									<?php if ($this->extra->extra_type==0||$this->extra->extra_type==""){
										echo 'checked="checked"';}?> /></td>

								<td><?php echo JText::_('JYES');?></td>
								<td><input type="radio" name="extra_type" id="extra_type"
									value="1"
									<?php if ($this->extra->extra_type==1){ echo 'checked="checked"';}?> />
								</td>
							</tr>
						</table>
					</td>
				</tr>
				<tr>
					<td width="100" align="right" class="key"><label for="idcategory">
							<?php echo JText::_( 'COM_BOOKIT_CATEGORIES_TO_APPLY' ); ?>:
					</label>
					</td>
					<td><?php echo $this->lists['idcategories'];?></td>
				</tr>
				<tr>
					<td width="100" align="right" class="key"><label for="value"> <?php echo JText::_( 'COM_BOOKIT_VALUE' ); ?>:
					</label> <span style="font-size: 10px; font-style: italic;"><br />
							<?php echo JText::_('COM_BOOKIT_KEEP_THE_VALUE_TO_ZERO');?> <br />
					</span></td>
					<td>
						<table>
							<tr>
								<td><?php echo JText::_('COM_BOOKIT_FIXED').":";?></td>
								<td><input class="text_area" type="text" name="value_fix"
									id="value_fix" size="10" maxlength="10"
									value="<?php echo $this->extra->value_fix;?>" /></td>
								<td><?php echo JText::_('COM_BOOKIT_OR')." ".
										JText::_('COM_BOOKIT_PERCENTAGE').":";?></td>
								<td><input class="text_area" type="text" name="value_percent"
									id="value_percent" size="10" maxlength="10"
									value="<?php echo $this->extra->value_percent;?>"
									title="<?php echo JText::_("COM_BOOKIT_EXTRA_VALUE_IS_COMPUTED_AS_A_PERCENTAGE_OF_BOOKING_COST");?>" />
								</td>
							</tr>
						</table>
					</td>
				</tr>
				<tr>
					<td width="30" align="right" class="key"><label for="cost"> <?php echo JText::_( 'COM_BOOKIT_APPLY_EXTRA_PER' ); ?>:
					</label></td>
					<td><?php echo $this->lists['value_type'];?>
					</td>
				</tr>


				<tr>
					<td width="100" align="right" class="key"><label for="description">
							<?php echo JText::_( 'COM_BOOKIT_DESCRIPTION' ); ?>:
					</label></td>
					<td><?php echo $editor->display( 'description', 
							$this->extra->description , '200', '150', '40', '5' ) ; ?></td>
				</tr>


			</table>
		</fieldset>

	</div>

	<div class="clr"></div>

	<input type="hidden" name="option" value="com_blooking" /> <input
		type="hidden" name="idextra"
		value="<?php echo $this->extra->idextra; ?>" /> <input type="hidden"
		name="task" value="" /> <input type="hidden" name="controller"
		value="roomextraedit" />
</form>


