<?php
/**
 * BlooKing - The King in Joomla Booking
 * @version 1.0
 * @author BlooKing.org. Based on BooKiTGold code by Costas Kakousis
 * @copyright (C) 2012-2013 by BlooKing.org (http://www.blooking.org)
 * @license GNU/GPL: http://www.gnu.org/copyleft/gpl.html
 *
 * If you fork this to create your own project, please make a reference to
 * BlooKing! someplace in your code and provide a link to
 * http://www.blooking.org
 *
 * This file is part of BlooKing! BlooKing is free software: you can
 * redistribute it and/or modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * BlooKing is distributed in the hope that it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details. You should have received a copy of the GNU General Public License
 * along with BlooKing.  If not, see <http://www.gnu.org/licenses/>.
 *   ______ __                __  __ __
 *	|   __ \  |.-----..-----.|  |/  |__|.-----..-----.
 *	|   __ <  ||  _  ||  _  ||     <|  ||     ||  _  |
 *	|______/__||_____||_____||__|\__|__||__|__||___  |
 *                                             |_____|
 **/
// No direct access
defined( '_JEXEC' ) or die( 'Restricted access' );
jimport( 'joomla.application.component.view' );

class BlookingViewRoomextraedit extends JView
{
	function display($tpl = null)
	{
		//get the room category
		$extra        =& $this->get('Data');

		$isNew        = ($extra->idextra < 1);

		$text = $isNew ? JText::_( 'COM_BOOKIT_NEW' ) :
		JText::_( 'COM_BOOKIT_EDIT' );
		JToolbarHelper::title(JText::_( 'COM_BOOKIT_EXTRA_SERVICES' ).
		': <small>[ ' . $text.' ]</small>', 'extras');

		$document  = & JFactory::getDocument();
		$document->addStyleSheet(
				JURI::root().'administrator/components/com_blooking/css/icons.css',
				'text/css', null, array() );

		JToolBarHelper::apply();
		JToolBarHelper::save();


		if ($isNew)  {
			JToolBarHelper::cancel();
		} else {
			// for existing items the button is renamed `close`
			JToolBarHelper::cancel( 'cancel', 'Close' );
		}
		JToolBarHelper::help( 'extra_services-help/extra_serviceshelp', true );

		$model =& $this->getModel('roomextraedit');


		$value="";
		if (isset($extra->idcategories))
			$value = explode(",",$extra->idcategories);
			
		$results[] = JHTML::_('select.option', -1, JText::_('COM_BOOKIT_NONE'),
				'idcategory', 'name' );

		$results = array_merge( $results, $model->getRoomCategories());
		$lists['idcategories']  = JHTML::_('select.genericList', $results,
				'idcategories[]', 'class="inputbox required" multiple="multiple" size="8"',
				'idcategory', 'name', $value);


		$value = isset($extra->value_type) ? $extra->value_type:'0';
		$options[1] = JHTML::_('select.option', 1,
				JText::_('COM_BOOKIT_BOOKING'), 'value_type', 'name' );
		$options[2] = JHTML::_('select.option', 2,
				JText::_('COM_BOOKIT_NIGHT'), 'value_type', 'name' );
		$options[3] = JHTML::_('select.option', 3,
				JText::_('COM_BOOKIT_GUEST'), 'value_type', 'name' );
		$options[4] = JHTML::_('select.option', 4,
				JText::_('COM_BOOKIT_ADULT'), 'value_type', 'name' );
		$options[5] = JHTML::_('select.option', 5,
				JText::_('COM_BOOKIT_CHILD'), 'value_type', 'name' );
		$options[6] = JHTML::_('select.option', 6,
				JText::_('COM_BOOKIT_QUANTITY'), 'value_type', 'name' );
		$options[7] = JHTML::_('select.option', 7,
				JText::_('COM_BOOKIT_GUEST_NIGHT'), 'value_type', 'name' );
		$options[8] = JHTML::_('select.option', 8,
				JText::_('COM_BOOKIT_ADULT_NIGHT'), 'value_type', 'name' );
		$options[9] = JHTML::_('select.option', 9,
				JText::_('COM_BOOKIT_CHILD_NIGHT'), 'value_type', 'name' );
		$options[10] = JHTML::_('select.option', 10,
				JText::_('COM_BOOKIT_QUANTITY_NIGHT'), 'value_type', 'name' );

		$lists['value_type']  = JHTML::_('select.genericList', $options,
				'value_type', 'class="validate-dropbox inputbox" size="1"',
				'value_type', 'name', $value);

		JLoader::register('BlookingHelper',
		JPATH_COMPONENT.'/helpers/BlookingHelper.php');
		$language_options =  BlookingHelper::getLanguages();
		$lang = JRequest::getVar('lang','');
		if ($lang=="")
			$default = 'en';
		else
			$default = $lang;
		$lists['language']  = JHTML::_('select.genericList', $language_options,
				'language', 'class="inputbox" size="1"', 'value', 'text', $default);

		$this->assignRef('lang', JRequest::getVar('lang','en'));
		$this->assignRef('extra', $extra);
		$this->assignRef('lists', $lists);

		parent::display($tpl);

		// Form Validation
		if(version_compare(JVERSION,'1.6.0','ge')) {
			$document = &JFactory::getDocument();
			$document->addScript( JURI::root(true).'/administrator/components/com_blooking/js/formValidator16.js' );
		} else {
			$document = &JFactory::getDocument();
			$document->addScript( JURI::root(true).'/administrator/components/com_blooking/js/formValidator15.js' );
		}


	}



}


