<?php
/**
 * BlooKing - The King in Joomla Booking
 * @version 1.0
 * @author BlooKing.org. Based on BooKiTGold code by Costas Kakousis
 * @copyright (C) 2012-2013 by BlooKing.org (http://www.blooking.org)
 * @license GNU/GPL: http://www.gnu.org/copyleft/gpl.html
 *
 * If you fork this to create your own project, please make a reference to
 * BlooKing! someplace in your code and provide a link to
 * http://www.blooking.org
 *
 * This file is part of BlooKing! BlooKing is free software: you can
 * redistribute it and/or modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * BlooKing is distributed in the hope that it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details. You should have received a copy of the GNU General Public License
 * along with BlooKing.  If not, see <http://www.gnu.org/licenses/>.
 *   ______ __                __  __ __
 *	|   __ \  |.-----..-----.|  |/  |__|.-----..-----.
 *	|   __ <  ||  _  ||  _  ||     <|  ||     ||  _  |
 *	|______/__||_____||_____||__|\__|__||__|__||___  |
 *                                             |_____|
 **/
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.application.component.view' );
class BlookingViewRulesedit extends JView {
	function display($tpl = null) {
		JLoader::register('BlookingHelper',
		JPATH_COMPONENT.'/helpers/BlookingHelper.php');
		$rules        =& $this->get('Data');
		$isNew        = ($rules->idrule < 1);
		$text = $isNew ? JText::_( 'COM_BOOKIT_NEW' ) :
		JText::_( 'COM_BOOKIT_EDIT' );
		JToolbarHelper::title( JText::_( 'COM_BOOKIT_RULES' ).
		': <small>[ ' . $text.' ]</small>',
		'rules');
		$document  = & JFactory::getDocument();
		$document->addStyleSheet(
				JURI::root().'administrator/components/com_blooking/css/icons.css',
				'text/css', null, array() );
		JToolBarHelper::apply();
		JToolBarHelper::customX( 'save', 'save.png','save_f2.png',
		'COM_BOOKIT_SAVE_CLOSE',false);
		JToolBarHelper::customX( 'saveNew', 'new.png', 'new_f2.png',
		'COM_BOOKIT_SAVE_NEW', false );
		JToolBarHelper::divider();
		JToolBarHelper::cancel();
		JToolBarHelper::help( 'price_rules-help/price_ruleshelp', true );

		$model =& $this->getModel('rulesedit');

		$lists=array();
		//------------------SET RULE MODES--------------------------------------
		$modes[0] = JHTML::_('select.option', -1,
				JText::_('COM_BOOKIT_SELECT_RULE_MODE'));
		$rule_modes = $this->_getRuleModes();
		$i=1;
		$defaultMode = isset($rules->mode)?$rules->mode:'-1';

		foreach($rule_modes as $key=>$value) :
		$modes[$i++] = JHTML::_('select.option', $key, $value);
		endforeach;

		$lists['rule_modes'] = JHTML::_('select.genericlist', $modes, 'mode',
				'class="required validate-dropbox inputbox"', 'value', 'text',
				$defaultMode);

		//------------------SET RULE TYPES--------------------------------------
		$results[0] = JHTML::_('select.option', -1,
				JText::_('COM_BOOKIT_SELECT_RULE_TYPE') );
		$rule_types = $this->_getRuleTypes($defaultMode);
		$rules->rule_types = $this->_getRuleTypes(999);
		$rules->rule_type_default = JText::_('COM_BOOKIT_SELECT_RULE_TYPE');
		$i=1;
		$defaultType = isset($rules->type)?$rules->type:'-1';

		foreach($rule_types as $key=>$value) :
		$results[$i++] = JHTML::_('select.option', $key, $value);
		endforeach;

		$lists['rule_types'] = JHTML::_('select.genericlist', $results,
				'type', 'class="required validate-dropbox inputbox"', 'value', 'text',
				$defaultType);


		//--------------------CATEGORY LIST-------------------------------------
		$default="";
		if (isset($rules->idcategory))
			$default = explode(",",$rules->idcategory);
		$categories[] = JHTML::_('select.option', -1,
				JText::_('COM_BOOKIT_NONE'), 'idcategory', 'name' );
			
		$categories = array_merge( $categories, $model->getRoomCategories() );
		$lists['categories']  = JHTML::_('select.genericList', $categories,
				'idcategory[]', 'class="required inputbox" multiple="multiple" size="8"',
				'idcategory', 'name', $default);

		JLoader::register('BlookingHelper',
		JPATH_COMPONENT.'/helpers/BlookingHelper.php');
		$language_options =  BlookingHelper::getLanguages();
		$lang = JRequest::getVar('lang','');
		if ($lang=="")
			$default = 'en';
		else
			$default = $lang;
		$lists['language']  = JHTML::_('select.genericList', $language_options,
				'language', 'class="inputbox" size="1"', 'value', 'text', $default);

		$date_code = BlookingHelper::getDateFormat();
		$rules->d1 = $date_code->d1;
		$rules->d2 = $date_code->d2;

		$this->assignRef('lang', JRequest::getVar('lang','en'));
		$this->assignRef('rules', $rules);
		$this->assignRef('lists', $lists);

		$arrSelectedDays = explode(",",$rules->selected_days);
		if (count($arrSelectedDays)<7)
			$arrSelectedDays =  array(0, 0, 0, 0, 0, 0, 0);

		$this->assignRef('days', $arrSelectedDays);

		parent::display($tpl);
		// Form Validation
		if(version_compare(JVERSION,'1.6.0','ge')) {
			$document = &JFactory::getDocument();
			$document->addScript( JURI::root(true). '/administrator/components/com_blooking/js/formValidator16.js' );
		} else {
			$document = &JFactory::getDocument();
			$document->addScript( JURI::root(true).'/administrator/components/com_blooking/js/formValidator15.js' );
		}
	}

	function _getRuleTypes($mode)
	{
		$types = array ();
		switch ($mode)
		{
			case -1: return $types;
			case 0:
				$types[0] = JText::_("COM_BOOKIT_PER_X_PERIOD_RATE");
				$types[1] = JText::_("COM_BOOKIT_PER_DAY_RATE");
				break;
			case 1:
				$types[2] = JText::_("COM_BOOKIT_AFTER_X_DAYS_RATE");
				$types[3] = JText::_("COM_BOOKIT_OVER_X_ADULTS_RATE");
				$types[4] = JText::_("COM_BOOKIT_OVER_X_CHILDREN_RATE");
				$types[5] = JText::_("COM_BOOKIT_OVER_X_GUEST");
				//v1.5.4.3 6=before_x_days
				$types[6] = JText::_("COM_BOOKIT_UNDER_X_DAYS");
				//v1.5.4.2 7=under_x_adults , 8=under_x_children 9=under_x_guest
				$types[7] = JText::_("COM_BOOKIT_UNDER_X_ADULTS_RATE");
				$types[8] = JText::_("COM_BOOKIT_UNDER_X_CHILDREN_RATE");
				$types[9] = JText::_("COM_BOOKIT_UNDER_X_GUEST");
				break;
			case 2:
				$types[2] = JText::_("COM_BOOKIT_AFTER_X_DAYS_RATE");
				$types[3] = JText::_("COM_BOOKIT_OVER_X_ADULTS_RATE");
				$types[4] = JText::_("COM_BOOKIT_OVER_X_CHILDREN_RATE");
				$types[5] = JText::_("COM_BOOKIT_OVER_X_GUEST");
				//v1.5.4.3 6=before_x_days
				$types[6] = JText::_("COM_BOOKIT_UNDER_X_DAYS");
				//v1.5.4.2 7=under_x_adults , 8=under_x_children 9=under_x_guest
				$types[7] = JText::_("COM_BOOKIT_UNDER_X_ADULTS_RATE");
				$types[8] = JText::_("COM_BOOKIT_UNDER_X_CHILDREN_RATE");
				$types[9] = JText::_("COM_BOOKIT_UNDER_X_GUEST");
				break;
			default:
				$types[0] = JText::_("COM_BOOKIT_PER_X_PERIOD_RATE");
				$types[1] = JText::_("COM_BOOKIT_PER_DAY_RATE");
				$types[2] = JText::_("COM_BOOKIT_AFTER_X_DAYS_RATE");
				$types[3] = JText::_("COM_BOOKIT_OVER_X_ADULTS_RATE");
				$types[4] = JText::_("COM_BOOKIT_OVER_X_CHILDREN_RATE");
				$types[5] = JText::_("COM_BOOKIT_OVER_X_GUEST");
				//v1.5.4.3 6=before_x_days
				$types[6] = JText::_("COM_BOOKIT_UNDER_X_DAYS");
				//v1.5.4.2 7=under_x_adults , 8=under_x_children 9=under_x_guest
				$types[7] = JText::_("COM_BOOKIT_UNDER_X_ADULTS_RATE");
				$types[8] = JText::_("COM_BOOKIT_UNDER_X_CHILDREN_RATE");
				$types[9] = JText::_("COM_BOOKIT_UNDER_X_GUEST");
				break;
				return $types;

		}
		return $types;
	}


	function _getRuleModes()
	{
		$modes = array ();
		$modes[0] = JText::_("COM_BOOKIT_SPECIAL_RATE");
		$modes[1] = JText::_("COM_BOOKIT_SPECIAL_OFFER");
		$modes[2] = JText::_("COM_BOOKIT_EXTRA_CHARGE");
		return $modes;

	}

}