
<?php
/**
 * BlooKing - The King in Joomla Booking
 * @version 1.0
 * @author BlooKing.org. Based on BooKiTGold code by Costas Kakousis
 * @copyright (C) 2012-2013 by BlooKing.org (http://www.blooking.org)
 * @license GNU/GPL: http://www.gnu.org/copyleft/gpl.html
 *
 * If you fork this to create your own project, please make a reference to
 * BlooKing! someplace in your code and provide a link to
 * http://www.blooking.org
 *
 * This file is part of BlooKing! BlooKing is free software: you can
 * redistribute it and/or modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * BlooKing is distributed in the hope that it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details. You should have received a copy of the GNU General Public License
 * along with BlooKing.  If not, see <http://www.gnu.org/licenses/>.
 *   ______ __                __  __ __
 *	|   __ \  |.-----..-----.|  |/  |__|.-----..-----.
 *	|   __ <  ||  _  ||  _  ||     <|  ||     ||  _  |
 *	|______/__||_____||_____||__|\__|__||__|__||___  |
 *                                             |_____|
 **/
defined('_JEXEC') or die('Restricted access');
//JHtml::_('behavior.framework', true);
$model = $this->getModel();

$url = JRoute::_(JURI::base()."index.php?option=com_blooking&controller=statistics&task=getChart&format=raw");
$js = <<<EOD
window.addEvent( 'domready', function() {

	var jsonReq = new Request.JSON({
  		url: '{$url}',
 		method: 'get',
  		data: {json: 'yes' },
	  	onSuccess: function (responseJSON, responseText){

		if (typeof responseJSON != 'undefined' &&
			responseJSON != null) {
	  		var roomsSold = new mooBarGraph({
        		container: $('chart'),
        		data: responseJSON['chart'],
		        width: responseJSON['width'],
        		height: 400,
		        title: responseJSON['title'],
        		colors: ['#4f81bd', '#c0504d', '#9bbb59', '#8064a2', '#4198af', '#db843d'],
        		float: 'left'
    });
    		$('chart').scrollTop = $('chart').offsetTop;
	  	}
  	}
 });

    $('set_button').addEvent('click',function(event){
		if ($('chart_wrapper') != null) {
    		$('chart_wrapper').empty();
			$('chart_wrapper').setAttribute('id','chart');
		}

    	jsonReq.get({
			'valid_from':$('from_month').value+"-"+$('from_year').value,
			'valid_to':$('to_month').value+"-"+$('to_year').value,
			'report_type':$('report_type').value});
	});
})
EOD;

$doc = & JFactory::getDocument();
$doc->addScriptDeclaration( $js );

?>

<form action="index.php" method="post" name="adminForm" id="adminForm">
	<div class="col100">
		<fieldset class="adminform" style="float: left; width: 700px;">
			<legend>
				<?php echo JText::_( 'COM_BOOKIT_STATISTICS' ); ?>
			</legend>

			<table class="admintable" align="center" width="100%" border="0"
				bgcolor="white" style="border-collapse: collapse;">
				<tr>
					<td>
						<div style="overflow: auto">
							<div id="chart">
								<?php echo JText::_("COM_BOOKIT_SELECT_REPORT_TYPE_RIGHT");?>
							</div>
						</div>
					</td>
				</tr>
			</table>
		</fieldset>

		<fieldset class="adminform" style="float: right; width: 200px;">
			<table class="admintable" width="100%">
				<tr>
					<td>
						<fieldset>
							<legend>
								<?php echo JText::_("COM_BOOKIT_ALL_TIME_STATS");?>
							</legend>
							<?php echo JText::_("COM_BOOKIT_ROOMS_SOLD")." ".$model->totalRoomsSold(); ?>
							<br />
							<?php  echo JText::_("COM_BOOKIT_NET_INCOME")." ". $model->totalNetIncome(); ?>
							<br />
							<?php echo JText::_("COM_BOOKIT_AVERAGE_PRICE")." ".$model->averageBookingPrice(); ?>
						</fieldset>
					</td>
				</tr>
				<tr>
					<td>
						<fieldset>
							<legend>
								<?php echo JText::_("COM_BOOKIT_SELECT_REPORT_TYPE");?>
							</legend>
							<table>
								<tr>
									<td width="90px" class="down_align_cell"><label
										for="set_valid_from"> <?php echo JText::_( 'COM_BOOKIT_FROM' ); ?>
									</label></td>

								</tr>
								<tr>
									<td class="up_align_cell"><?php 
									echo $this->lists['from_month'];
									echo $this->lists['from_year'];?></td>

								</tr>
								<tr>
									<td width="90px" class="down_align_cell"><label
										for="set_valid_to"> <?php echo JText::_( 'COM_BOOKIT_TO' ); ?>
									</label></td>
								</tr>
								<tr>
									<td class="up_align_cell"><?php 
									echo $this->lists['to_month'];
									echo $this->lists['to_year'];?>
									</td>
								</tr>
								<tr height="20px">
									<td class="down_align_cell"><label for="report_type"> <?php echo JText::_( 'COM_BOOKIT_REPORT_TYPE' ); ?>
									</label></td>

								</tr>
								<tr>
									<td class="up_align_cell"><?php echo $this->lists['report_type'];?>
									</td>
									<td class="up_align_cell"><input id="set_button" type="button"
										value="<?php echo JText::_('COM_BOOKIT_GO');?>" /></td>
								</tr>
							</table>
						</fieldset>
					</td>
				</tr>
			</table>
		</fieldset>

	</div>

	<div class="clr"></div>

	<input type="hidden" name="option" value="com_blooking" /> <input
		type="hidden" name="task" value="" /> <input type="hidden"
		name="controller" value="statistics" />
</form>
