<?php
/**
 * BlooKing - The King in Joomla Booking
 * @version 1.0
 * @author BlooKing.org. Based on BooKiTGold code by Costas Kakousis
 * @copyright (C) 2012-2013 by BlooKing.org (http://www.blooking.org)
 * @license GNU/GPL: http://www.gnu.org/copyleft/gpl.html
 *
 * If you fork this to create your own project, please make a reference to
 * BlooKing! someplace in your code and provide a link to
 * http://www.blooking.org
 *
 * This file is part of BlooKing! BlooKing is free software: you can
 * redistribute it and/or modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * BlooKing is distributed in the hope that it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details. You should have received a copy of the GNU General Public License
 * along with BlooKing.  If not, see <http://www.gnu.org/licenses/>.
 *   ______ __                __  __ __
 *	|   __ \  |.-----..-----.|  |/  |__|.-----..-----.
 *	|   __ <  ||  _  ||  _  ||     <|  ||     ||  _  |
 *	|______/__||_____||_____||__|\__|__||__|__||___  |
 *                                             |_____|
 **/
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.application.component.view' );
class BlookingViewStatistics extends JView {
	function display($tpl = null){

		JLoader::register('BlookingHelper',
		JPATH_COMPONENT.'/helpers/BlookingHelper.php');

		if(version_compare(JVERSION,'1.6.0','ge')) {
			JHtml::_('behavior.framework', true);
		}

		JToolbarHelper::title( JText::_( 'COM_BOOKIT_STATISTICS' ),
		'statistics');
		$document  = & JFactory::getDocument();
		$document->addStyleSheet(
				JURI::root().'administrator/components/com_blooking/css/icons.css',
				'text/css', null, array() );
		 
		$document->addScript(JURI::root().'administrator/components/com_blooking/js/moobargraph.js');
		JToolBarHelper::cancel();
		JToolBarHelper::help( 'statistics-help/statisticshelp', true );


		//SET MONTH DROPDOWN
		$defaultMonth = date('m');

		for ($i=1;$i<=12;$i++) {
			$months[$i] = JHTML::_('select.option', $i,
					$i, 'to_month', 'name' );
		}

		$lists['to_month']  = JHTML::_('select.genericList', $months,
				'to_month', 'class="inputbox" size="1"', 'to_month', 'name',
				$defaultMonth);
			
		for ($i=1;$i<=12;$i++) {
			$months[$i] = JHTML::_('select.option', $i,
					$i, 'from_month', 'name' );
		}

		$lists['from_month']  = JHTML::_('select.genericList', $months,
				'from_month', 'class="inputbox" size="1"', 'from_month', 'name',
				$defaultMonth);

		//SET YEAR DROPDOWN
		$defaultYear = date('Y');
		$lastYear = date('Y')-1;
		for ($i=$defaultYear;$i>=$defaultYear-2;$i--) {
			$years[$i] = JHTML::_('select.option', $i,
					$i, 'to_year', 'name' );
		}

		$lists['to_year']  = JHTML::_('select.genericList', $years,
				'to_year', 'class="inputbox" size="1"', 'to_year', 'name',
				$defaultYear);

		for ($i=$defaultYear;$i>=$defaultYear-2;$i--) {
			$years[$i] = JHTML::_('select.option', $i,
					$i, 'from_year', 'name' );
		}

		$lists['from_year']  = JHTML::_('select.genericList', $years,
				'from_year', 'class="inputbox" size="1"', 'from_year', 'name',
				$lastYear);

		//SET REPORT TYPE DROPDOWN
		$defaultReportType = '0';

		$report_types['0'] = JHTML::_('select.option', '0',
				JText::_('COM_BOOKIT_MONTHLY_OCCUPANCY'), 'report_type', 'name' );
		$report_types['1'] = JHTML::_('select.option', '1',
				JText::_('COM_BOOKIT_MONTHLY_NET_INCOME'), 'report_type', 'name' );
		$report_types['2'] = JHTML::_('select.option', '2',
				JText::_('COM_BOOKIT_MONTHLY_ROOMS_SOLD'), 'report_type', 'name' );

		$lists['report_type']  = JHTML::_('select.genericList', $report_types,
				'report_type', 'class="inputbox" size="1"', 'report_type', 'name',
				$defaultReportType);


		$this->assignRef('lists', $lists);

		$this->assignRef('date_code',  BlookingHelper::getDateFormat());

		$model = $this->getModel('statistics');
		$categories = $model->getCategories();
		if (count($categories)<=0)
		{

			$url = JURI::base()."index.php?option=com_blooking&controller=roomcategory&task=edit";
			$msg = JText::_("COM_BOOKIT_PLEASE_CREATE_AT_LEAST_ONE").
			"<a href='".$url."'> ".JText::_("COM_BOOKIT_ROOM_CATEGORY")."</a> ".
			JText::_("COM_BOOKIT_FIRST");
			JError::raiseNotice (500, $msg );
		}
		else
		{
			$rooms =& $model->getRooms();
			if (count($rooms)<=0)
			{
				$url = JURI::base()."index.php?option=com_blooking&controller=room&task=edit";
				$msg = JText::_("COM_BOOKIT_PLEASE_CREATE_AT_LEAST_ONE").
				"<a href='".$url."'> ".JText::_("COM_BOOKIT_ROOM")."</a> ".
				JText::_("COM_BOOKIT_FIRST");
				JError::raiseNotice (500, $msg );
			}
		}
		parent::display($tpl);
	}


}

