<?php
/**
 * BlooKing - The King in Joomla Booking
 * @version 1.0
 * @author BlooKing.org. Based on BooKiTGold code by Costas Kakousis
 * @copyright (C) 2012-2013 by BlooKing.org (http://www.blooking.org)
 * @license GNU/GPL: http://www.gnu.org/copyleft/gpl.html
 *
 * If you fork this to create your own project, please make a reference to
 * BlooKing! someplace in your code and provide a link to
 * http://www.blooking.org
 *
 * This file is part of BlooKing! BlooKing is free software: you can
 * redistribute it and/or modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * BlooKing is distributed in the hope that it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details. You should have received a copy of the GNU General Public License
 * along with BlooKing.  If not, see <http://www.gnu.org/licenses/>.
 *   ______ __                __  __ __
 *	|   __ \  |.-----..-----.|  |/  |__|.-----..-----.
 *	|   __ <  ||  _  ||  _  ||     <|  ||     ||  _  |
 *	|______/__||_____||_____||__|\__|__||__|__||___  |
 *                                             |_____|
 **/
defined( '_JEXEC' ) or die( 'Restricted access' );
jimport( 'joomla.application.component.view' );

class BlookingViewStatistics extends JView {
	function display($tpl = null) {
		$model =& $this->getModel( 'statistics' );
		$valid_from = JRequest::getVar('valid_from');
		$valid_to = JRequest::getVar('valid_to');
		$report_type = JRequest::getVar('report_type');
		$title="";

		if ($report_type == 0) {
			$chart = $model->monthlyOccupancy($valid_from,$valid_to);
			$title = "<b>Hotel Occupancy (%) from ".$valid_from." to ".$valid_to."</b>";
		} elseif ($report_type == 1) {
			$chart = $model->monthlyNetIncome($valid_from,$valid_to);
			$title = "<b>Net Monthly Income from ".$valid_from." to ".$valid_to."</b>";
		} elseif ($report_type == 2) {
			$chart = $model->monthlyRoomsSold($valid_from,$valid_to);
			$title = "<b>Rooms sold from ".$valid_from." to ".$valid_to."</b>";
		}

		$nomonths = $this->_getMonths("01-".$valid_from, "01-".$valid_to);

		$chartwidth = "800";


		$data['title'] = $title;
		$data['chart'] = $chart;
		$data['width'] = $chartwidth;

		$document =& JFactory::getDocument();
		// Set the MIME type for JSON output.
		$document->setMimeEncoding( 'application/json' );

		echo json_encode($data);
	}

	function _getMonths($start, $end) {
		$diff = abs(strtotime($start) - strtotime($end));
		$years = floor($diff / (365*60*60*24));
		$months = floor(($diff - $years * 365*60*60*24) / (30*60*60*24));
		return $months;
	}
}