<?php
/**
 * BlooKing - The King in Joomla Booking
 * @version 1.0
 * @author BlooKing.org. Based on BooKiTGold code by Costas Kakousis
 * @copyright (C) 2012-2013 by BlooKing.org (http://www.blooking.org)
 * @license GNU/GPL: http://www.gnu.org/copyleft/gpl.html
 *
 * If you fork this to create your own project, please make a reference to 
 * BlooKing! someplace in your code and provide a link to 
 * http://www.blooking.org
 *
 * This file is part of BlooKing! BlooKing is free software: you can 
 * redistribute it and/or modify it under the terms of the GNU General Public 
 * License as published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * BlooKing is distributed in the hope that it will be useful, but WITHOUT ANY 
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS 
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more 
 * details. You should have received a copy of the GNU General Public License
 * along with BlooKing.  If not, see <http://www.gnu.org/licenses/>.
 *   ______ __                __  __ __               
 *	|   __ \  |.-----..-----.|  |/  |__|.-----..-----.
 *	|   __ <  ||  _  ||  _  ||     <|  ||     ||  _  |
 *	|______/__||_____||_____||__|\__|__||__|__||___  |
 *                                             |_____|
 **/

defined('_JEXEC') or die('Restricted access');

jimport('joomla.plugin.plugin');

class plgSystemBlookingRobokassa extends JPlugin
{

	function plgSystemBlookingRobokassa (&$subject, $config)
	{
		parent::__construct($subject, $config);
		
	}
	
	function onMakeBookingBlookingrobokassa($data)
	{
		$res = new stdClass ();
		$this->loadLanguage('plg_system_blookingrobokassa', JPATH_ADMINISTRATOR);

		if ($data['deposit']<=0)
		{
			$res->msg = "<span class='error'>".JText::_('COM_BOOKIT_WRONG_AMOUNT')."</span>";
			$res->code = -1;
			return $res;
		} 
		
		$mrh_login = $this->params->get('login', "demo");
		$mrh_pass1 = $this->params->get('pass', "password_1");
		$inv_desc = $this->params->get('item_name', "");
		$isSandbox = $this->params->get('sandbox', "");
		
		// номер заказа
		// number of order
		$inv_id = 0;
		
		// сумма заказа
		// sum of order
		$out_summ = $data['deposit'];
		
		// тип товара
		// code of goods
		$shp_item = 1;
		
		// предлагаемая валюта платежа
		// default payment e-currency
		$in_curr = $this->params->get('currency', "BANKOCEANMR");
		
		// язык
		// language
		$culture = $data['lang'];
		
		// кодировка
		// encoding
		$encoding = "utf-8";
		
		// формирование подписи
		// generate signature
		$crc  = md5("$mrh_login:$out_summ:$inv_id:$mrh_pass1:Shp_item=$shp_item");
		
		// HTML-страница с кассой
		// ROBOKASSA HTML-page
// 		$res->msg = "<html><script language=JavaScript ".
// 				"src='https://merchant.roboxchange.com/Handler/MrchSumPreview.ashx?".
// 				"MrchLogin=$mrh_login&OutSum=$out_summ&InvId=$inv_id&IncCurrLabel=$in_curr".
// 				"&Desc=$inv_desc&SignatureValue=$crc&Shp_item=$shp_item".
// 				"&Culture=$culture&Encoding=$encoding'></script></html>";
		

		if ($isSandbox==1)
			$link = "http://test.robokassa.ru/Index.aspx";
		else
			$link = "https://merchant.roboxchange.com/Handler/MrchSumPreview.ashx?";
				
		$res->msg = "<form action='".$link."' method='post' target='_self' id='robokassaForm' name='robokassaForm'><input type='hidden' name='MrchLogin' value='".$mrh_login."'><input type='hidden' name='OutSum' value='".$out_summ."'><input type='hidden' name='InvId' value='".$inv_id."' ><input type='hidden' name='IncCurrLabel' value='".$in_curr."'><input type='hidden' name='Desc' value='".$inv_desc."'><input type='hidden' name='SignatureValue' value='".$crc."'><input type='hidden' name='Shp_item' value='".$shp_item."'><input type='hidden' name='Culture' value='".$culture."'><input type='hidden' name='Encoding' value='".$encoding."'><input type='hidden' name='shpa' id='shpa' value=''></form>";
		$res->code = 1;
		return $res;
	}
	
}