<?php
/**
 * BlooKing - The King in Joomla Booking
 * @version 1.0
 * @author BlooKing.org. Based on BooKiTGold code by Costas Kakousis
 * @copyright (C) 2012-2013 by BlooKing.org (http://www.blooking.org)
 * @license GNU/GPL: http://www.gnu.org/copyleft/gpl.html
 *
 * If you fork this to create your own project, please make a reference to
 * BlooKing! someplace in your code and provide a link to
 * http://www.blooking.org
 *
 * This file is part of BlooKing! BlooKing is free software: you can
 * redistribute it and/or modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * BlooKing is distributed in the hope that it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details. You should have received a copy of the GNU General Public License
 * along with BlooKing.  If not, see <http://www.gnu.org/licenses/>.
 *   ______ __                __  __ __
 *	|   __ \  |.-----..-----.|  |/  |__|.-----..-----.
 *	|   __ <  ||  _  ||  _  ||     <|  ||     ||  _  |
 *	|______/__||_____||_____||__|\__|__||__|__||___  |
 *                                             |_____|
 **/
defined( '_JEXEC' ) or die( 'Restricted access' );

class ModBlookingAvailabilityHelper {


	
	function getCalendar ($idcategory, $months_ahead, $rows, $cols)
	{
		
		require_once(
				JPATH_ADMINISTRATOR.DS."components".DS."com_blooking".DS."models".DS."availability.php");
		$availObj = new BlookingModelAvailability();
		return $availObj->displayCalendar(date('n'), date('Y'), $idcategory, $idroom=-999, $months_ahead,
				$rows, $cols);
	}
	
	function getParams ()
	{
		$db =& JFactory::getDBO();
		$sql = "SELECT * FROM ".$db->nameQuote("#__bookitparams").
		" WHERE ".$db->nameQuote("id")."=".
		$db->quote("1");
		$db->setQuery($sql);
		return $db->loadObject();
	}

	function getDateFormat ($dateformatcode) {
		$res = new stdClass();
		if ($dateformatcode==""||$dateformatcode==3)
		{
			$d1='d-m-Y';
			$d2='%d-%m-%Y';
		}
		else if ($dateformatcode==1)
		{
			$d1='Y-m-d';
			$d2='%Y-%m-%d';
		}
		else if ($dateformatcode==2)
		{
			$d1='m/d/Y';
			$d2='%m/%d/%Y';
		}

		$res->d1 = $d1;
		$res->d2 = $d2;
		return $res;
	}
	function getLang($locale=false)
	{
		$lg = JFactory::getLanguage();
		if(version_compare(JVERSION,'1.6.0','ge'))
		{
			$lang_code = explode('-',$lg->getTag());
			$lang = $lang_code[0];
			if ($locale)
				return $lg->getTag();
		}
		else
		{
			$lang_code = explode('-',$lg->_lang);
			$lang = $lang_code[0];
			if ($locale)
				return $lg->_lang;
		}
		return $lang;
	}
	
}
?>