<?php
/**
 * BlooKing - The King in Joomla Booking
 * @version 1.0
 * @author BlooKing.org. Based on BooKiTGold code by Costas Kakousis
 * @copyright (C) 2012-2013 by BlooKing.org (http://www.blooking.org)
 * @license GNU/GPL: http://www.gnu.org/copyleft/gpl.html
 *
 * If you fork this to create your own project, please make a reference to
 * BlooKing! someplace in your code and provide a link to
 * http://www.blooking.org
 *
 * This file is part of BlooKing! BlooKing is free software: you can
 * redistribute it and/or modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * BlooKing is distributed in the hope that it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details. You should have received a copy of the GNU General Public License
 * along with BlooKing.  If not, see <http://www.gnu.org/licenses/>.
 *   ______ __                __  __ __
 *	|   __ \  |.-----..-----.|  |/  |__|.-----..-----.
 *	|   __ <  ||  _  ||  _  ||     <|  ||     ||  _  |
 *	|______/__||_____||_____||__|\__|__||__|__||___  |
 *                                             |_____|
 **/

$msg = "";
function com_install () {
	$db =& JFactory::getDBO();

	//CHECK IF PREVIOUS VERSION OF BOOKIT INSTALLED
	jimport('joomla.application.component.helper');
	$db->setQuery("SHOW TABLES LIKE '".$db->getPrefix()."bookitbooking'");

	global $msg;
	if ($db->loadResult())
	{
		$msg .= "Previous version found! <br />"; //UPGRADING....
		$installtables = _sqlFile('install');

		//Replace bookit/uninstall.php
		_replaceBookitUninstall ();

		if ($installtables == 'true') {
			$msg .= "Database updated! <br />";
		} else {
			$msg .= "Adding new database tables failed: ".$installtables."<br />";
		}

		$db->setQuery("SHOW TABLES LIKE '".$db->getPrefix()."bookitavailability'");
		if ($db->loadResult())
		{
			$msg .= _convertBookings();
			$msg .= _convertCategories();
			$msg .= _convertCoupons();
			$msg .= _convertGuests();
			$msg .= _convertSpecialOffers();
			$msg .= _convertCountries();
				
			$msg .= _addUtils();
			$msg .= _dropOldTables();
			$msg .= _addParams();
			$msg .=_convertTodayToTimestump();
		}
		else {//New Updates
			$msg .= _adjustCategories(); //For changing start_day + end_day to char(13)
			$msg .= _adjustBookings(); //Add Staff Notes Field
			$msg .= _updateUtils(); //Add columns for show/req surname and postcode
			$msg .= _addParams();
			$msg .= _updateParams();
			$msg .= _extraServicesPublish(); //Add published + ordering fields to extra services

		}
	}
	else
	{

		_sqlFile('install');
		$msg .= _addUtils();
		$msg .= _addParams();
	}
	_languages();
	_convertCountries();

	echo "<table class='adminlist'>
			<thead>
			<tr>
			<th class='title' style='text-align: left'>Installation Notes</th>
			</tr>
			</thead>
			<tbody>
			<tr class='row0'>
			<td class='key'>".$msg."</td>
					</tr>
					</tbody>
					</table>";

	return true;
}

function _addUtils() {

	$msg = "";
	$db =& JFactory::getDBO();
	$query = "SELECT COUNT(*) FROM ".$db->nameQuote('#__bookitutils');
	$db->setQuery($query);
	if ($db->loadResult()<=0)
	{
		$adminemail = _getContentFromFile('adminemail.html');
		$custemail = _getContentFromFile('custemail.html');
		$custverified = _getContentFromFile('custverified.html');
		$custprebooking = _getContentFromFile('custprebooking.html');
		$adminprebooking = _getContentFromFile('adminprebooking.html');

		$msg .= "Setting Hotel Setup Table <br/>";

		$query = "INSERT INTO ".$db->nameQuote('#__bookitutils')."(".
				$db->nameQuote('id').", ".
				$db->nameQuote('custemail_subject').", ".
				$db->nameQuote('adminemail_subject').", ".
				$db->nameQuote('custverified_subject').", ".
				$db->nameQuote('custprebooking_subject').", ".
				$db->nameQuote('adminprebooking_subject').", ".
				$db->nameQuote('show_phone').", ".
				$db->nameQuote('show_address').", ".
				$db->nameQuote('phone_req').", ".
				$db->nameQuote('address_req').", ".
				$db->nameQuote('show_captcha').", ".
				$db->nameQuote('captcha_theme').", ".
				$db->nameQuote('publickey').", ".
				$db->nameQuote('privatekey').", ".
				$db->nameQuote('adminemail').", ".
				$db->nameQuote('custemail').", ".
				$db->nameQuote('custverified').", ".
				$db->nameQuote('custprebooking').", ".
				$db->nameQuote('adminprebooking').", ".
				$db->nameQuote('terms_conditions').", ".
				$db->nameQuote('cancellation_policy').", ".
				$db->nameQuote('form_msg').", ".
				$db->nameQuote('session_cnt').
				") VALUES (".
				$db->quote('1').", ".
				$db->quote('Thank you for booking with us').", ".
				$db->quote('{bookingid} - Booking by {firstname} {surname}').", ".
				$db->quote('Your booking has now been verified').", ".
				$db->quote('Thank you for booking with us').", ".
				$db->quote('{bookingid} - Booking requires verification').", ".
				$db->quote('1').", ".
				$db->quote('1').", ".
				$db->quote('1').", ".
				$db->quote('1').", ".
				$db->quote('0').", ".
				$db->quote('red').", ".
				$db->quote('').", ".
				$db->quote('').", ".
				$db->quote($adminemail).", ".
				$db->quote($custemail).", ".
				$db->quote($custverified).", ".
				$db->quote($custprebooking).", ".
				$db->quote($adminprebooking).", ".
				$db->quote('').", ".
				$db->quote('').", ".
				$db->quote('').", ".
				$db->quote('1').")";
		$db->setQuery($query);

		if ($db->query()) {
			;
		} else {
			$msg .= "Error inserting hotel setup table: ".$db->stderr(true)."<br/>";
		}
	}
	return $msg;

}


function _addParams() {

	$db =& JFactory::getDBO();
	$msg = "";
	$query = "SELECT COUNT(*) FROM ".$db->nameQuote('#__bookitparams');
	$db->setQuery($query);
	if ($db->loadResult()<=0)
	{

		$date = date("Y-m-d");
		$date = strtotime(date("Y-m-d", strtotime($date)) . " +5 year");
		$date = date("Y-m-d",$date);

		$msg .= "Setting Parameters <br />";

		$config =& JFactory::getConfig();
		$admin_email = $config->getValue( 'config.mailfrom' );

		$query = "INSERT INTO ".$db->nameQuote('#__bookitparams')."(".
				$db->nameQuote('id').", ".
				$db->nameQuote('multiroom').", ".
				$db->nameQuote('dateformat').", ".
				$db->nameQuote('currency').", ".
				$db->nameQuote('max_booking_period').", ".
				$db->nameQuote('daysForCancellation').", ".
				$db->nameQuote('available_color').", ".
				$db->nameQuote('booked_color').", ".
				$db->nameQuote('pending_color').", ".
				$db->nameQuote('other_color').", ".
				$db->nameQuote('show_available').", ".
				$db->nameQuote('show_booked').", ".
				$db->nameQuote('show_pending').", ".
				$db->nameQuote('show_extra').", ".
				$db->nameQuote('show_coupons').", ".
				$db->nameQuote('deposit_percent').", ".
				$db->nameQuote('deposit_fixed').", ".
				$db->nameQuote('admin_email').", ".
				$db->nameQuote('admin_email2').", ".
				$db->nameQuote('auto_confirm').", ".
				$db->nameQuote('last_date').", ".
				$db->nameQuote('normalize').", ".
				$db->nameQuote('show_bar').", ".
				$db->nameQuote('new_template').", ".
				$db->nameQuote('admin_confirm').", ".
				$db->nameQuote('late_booking').
				") VALUES (".
				$db->quote('1').", ".
				$db->quote('0').", ".
				$db->quote('1').", ".
				$db->quote('EUR').", ".
				$db->quote('365').", ".
				$db->quote('30').", ".
				$db->quote('F2FCFF').", ".
				$db->quote('FF6666').", ".
				$db->quote('FFCC66').", ".
				$db->quote('CCCCFF').", ".
				$db->quote('1').", ".
				$db->quote('1').", ".
				$db->quote('1').", ".
				$db->quote('1').", ".
				$db->quote('1').", ".
				$db->quote('100').", ".
				$db->quote('0.00').", ".
				$db->quote($admin_email).", ".
				$db->quote('').", ".
				$db->quote('1').", ".
				$db->quote($date).", ".
				$db->quote('0').", ".
				$db->quote('1').", ".
				$db->quote('1').", ".
				$db->quote('0').", ".
				$db->quote('0').")";

		$db->setQuery($query);

		if ($db->query()) {
			;
		} else {
			$msg .= "Error inserting params table: ".$db->stderr(true)."<br/>";
		}
	}
	return $msg;

}

function _adjustBookings() {
	$msg = "";

	$db =& JFactory::getDBO();

	if (!_column_exists('#__bookitbooking', 'staffnotes'))
	{
		$query = "ALTER TABLE ".$db->nameQuote("#__bookitbooking").
		" ADD ".$db->nameQuote('staffnotes')." TEXT NULL DEFAULT NULL;";
		$db->setQuery($query);
		$db->query();
		$msg .= "Adding staff notes field <br />";
	}
	if (!_column_exists('#__bookitbooking', 'lang'))
	{
		$query = "ALTER TABLE ".$db->nameQuote("#__bookitbooking").
		" ADD ".$db->nameQuote('lang')." TEXT NULL DEFAULT NULL;";
		$db->setQuery($query);
		$db->query();
		$msg .= "Adding lang field <br />";
	}
	if (!_column_exists('#__bookitbooking', 'payment_requested'))
	{
		$query = "ALTER TABLE ".$db->nameQuote("#__bookitbooking").
		" ADD ".$db->nameQuote('payment_requested')." TINYINT(1) NOT NULL DEFAULT ".$db->quote('0');
		$db->setQuery($query);
		$db->query();
		$msg .= "Adding payment requested field (Admin confirm bookings) <br />";
	}
	if (!_column_exists('#__bookitbooking', 'value_deposit'))
	{
		$query = "ALTER TABLE ".$db->nameQuote("#__bookitbooking").
		" ADD ".$db->nameQuote('value_deposit')." FLOAT UNSIGNED NULL DEFAULT NULL;";
		$db->setQuery($query);
		$db->query();
		$msg .= "Adding deposit value field (Admin confirm bookings) <br />";
	}
	if (!_column_exists('#__bookitbooking', 'payment_method'))
	{
		$query = "ALTER TABLE ".$db->nameQuote("#__bookitbooking").
		" ADD ".$db->nameQuote('payment_method')." TEXT NULL DEFAULT NULL;";
		$db->setQuery($query);
		$db->query();
		$msg .= "Adding payment method field <br />";
	}
	if (!_column_exists('#__bookitbooking', 'initial_price'))
	{
		$query = "ALTER TABLE ".$db->nameQuote("#__bookitbooking").
		" ADD ".$db->nameQuote('initial_price')." FLOAT UNSIGNED NULL DEFAULT NULL;";
		$db->setQuery($query);
		$db->query();
		$msg .= "Adding initial_price method field <br />";
	}

	return $msg;
}

function _extraServicesPublish() {
	$db =& JFactory::getDBO();
	$msg = "";
	if (!_column_exists('#__bookitextra', 'published'))
	{
		$query = "ALTER TABLE ".$db->nameQuote("#__bookitextra").
		" ADD ".$db->nameQuote('published')." tinyint(1) NOT NULL DEFAULT ".
		$db->quote("1").";";
		$db->setQuery($query);
		$db->query();
		$msg .= "Enable/Disable Extra Services Mod <br />";
	}

	if (!_column_exists('#__bookitextra', 'ordering'))
	{
		$query = "ALTER TABLE ".$db->nameQuote("#__bookitextra").
		" ADD ".$db->nameQuote('ordering')." int(11) NOT NULL DEFAULT ".
		$db->quote("0").";";
		$db->setQuery($query);
		$db->query();

		$query = "UPDATE ".$db->nameQuote("#__bookitextra")." SET "
				.$db->nameQuote("ordering")."=".$db->nameQuote("idextra").";";
		$db->setQuery($query);
		$db->query();

		$msg .= "Ordering for Extra Services <br />";
	}
	return $msg;
}

function _convertBookings() {

	$msg = "";
	$msg .= "Updating Bookings <br />";
	$db =& JFactory::getDBO();

	$query = "ALTER TABLE ".$db->nameQuote("#__bookitbooking").
	" ADD ".$db->nameQuote('rule_ids')." TEXT NULL DEFAULT NULL,".
	" ADD ".$db->nameQuote('coids')." TEXT NULL DEFAULT NULL,".
	" ADD ".$db->nameQuote('transaction_id')." TEXT NULL DEFAULT NULL,".
	" ADD ".$db->nameQuote('staffnotes')." TEXT NULL DEFAULT NULL,".
	" ADD ".$db->nameQuote('payment_requested')." TINYINT(1) NOT NULL DEFAULT ".$db->quote('0').",".
	" ADD ".$db->nameQuote('value_deposit')." FLOAT UNSIGNED NULL DEFAULT NULL ,".
	" ADD ".$db->nameQuote('payment_method')." TEXT NULL DEFAULT NULL,".
	" ADD ".$db->nameQuote('timestamp')." TIMESTAMP NULL DEFAULT CURRENT_TIMESTAMP;";
	$db->setQuery($query);

	if (!$db->query()) {
		$msg .= "Error updating bookings: ".$db->stderr(true)."<br />";
	}
	return $msg;
}

function _convertGuests() {
	$msg = "";
	$msg .= "Updating Guests Table <br />";
	$db =& JFactory::getDBO();

	$query = "ALTER TABLE ".$db->nameQuote("#__bookitguests").
	" CHANGE ".$db->nameQuote('city')." ".$db->nameQuote('address2')." TEXT NULL DEFAULT NULL, ".
	" CHANGE ".$db->nameQuote('addr')." ".$db->nameQuote('address1')." TEXT NULL DEFAULT NULL, ".
	" ADD ".$db->nameQuote('address3')." TEXT NULL DEFAULT NULL,".
	" ADD ".$db->nameQuote('postcode')." TEXT NULL DEFAULT NULL,".
	" ADD ".$db->nameQuote('jid')." INT UNSIGNED NULL DEFAULT NULL";

	$db->setQuery($query);
	if (!$db->query()) {
		$msg .=  "Error updating Guests: ".$db->stderr(true)."<br />";
	}
	return $msg;
}

function _convertCountries() {

	$msg = "";
	$msg .= "Updating Countries Table <br />";
	$db =& JFactory::getDBO();

	$query = "DROP TABLE ".$db->nameQuote("#__bookitcountry");
	$db->setQuery($query);
	$db->query();

	$query = "CREATE TABLE IF NOT EXISTS ".$db->nameQuote("#__bookitcountry").
	" (".$db->nameQuote('idcountry')." INT UNSIGNED NOT NULL AUTO_INCREMENT ,".
	$db->nameQuote("abbv")." TEXT NULL, ".$db->nameQuote("name")." TEXT NULL ,
			PRIMARY KEY (".$db->nameQuote("idcountry")."))";
	$db->setQuery($query);
	$db->query();

	$query = "INSERT INTO ".$db->nameQuote("#__bookitcountry")." (".
			$db->nameQuote("abbv").", ".$db->nameQuote("name").") VALUES
					('AF', 'Afghanistan'),
					('AX', 'Aland Islands'),
					('AL', 'Albania'),
					('DZ', 'Algeria'),
					('AS', 'American Samoa'),
					('A0', 'Angola'),
					('AI', 'Anguilla'),
					('AQ', 'Antarctica'),
					('AG', 'Antigua and Barbuda'),
					('AR', 'Argentina'),
					('AM', 'Armenia'),
					('AW', 'Aruba'),
					('AU', 'Australia'),
					('AT', 'Austria'),
					('AZ', 'Azerbaijan'),
					('BS', 'Bahamas'),
					('BH', 'Bahrain'),
					('BD', 'Bangladesh'),
					('BB', 'Barbados'),
					('BY', 'Belarus'),
					('BE', 'Belgium'),
					('BZ', 'Belize'),
					('BJ', 'Benin'),
					('BM', 'Bermuda'),
					('BT', 'Bhutan'),
					('BO', 'Bolivia'),
					('BA', 'Bosnia and Herzegovina'),
					('BW', 'Botswana'),
					('BV', 'Bouvet Island'),
					('BR', 'Brazil'),
					('BN', 'Brunei Darussalam'),
					('BG', 'Bulgaria'),
					('BF', 'Burkina Faso'),
					('BI', 'Burundi'),
					('KH', 'Cambodia'),
					('CM', 'Cameroon'),
					('CA', 'Canada'),
					('CV', 'Cape Verde'),
					('KY', 'Cayman Islands'),
					('CF', 'Central African Rep'),
					('TD', 'Chad'),
					('CL', 'Chile'),
					('CN', 'China'),
					('CX', 'Christmas Island'),
					('CC', 'Cocos Islands '),
					('CO', 'Colombia'),
					('KM', 'Comoros'),
					('CD', 'Congo'),
					('CK', 'Cook Islands'),
					('CR', 'Costa Rica'),
					('CI', 'Cote d Ivoire'),
					('HR', 'Croatia'),
					('CU', 'Cuba'),
					('CY', 'Cyprus'),
					('CZ', 'Czech Republic'),
					('DK', 'Denmark'),
					('DJ', 'Djibouti'),
					('DM', 'Dominica'),
					('DO', 'Dominican Rep'),
					('EC', 'Ecuador'),
					('EG', 'Egypt'),
					('SV', 'El Salvador'),
					('CG', 'Equatorial Guinea'),
					('ER', 'Eritrea'),
					('EE', 'Estonia'),
					('ET', 'Ethiopia'),
					('FK', 'Falkland Islands'),
					('FO', 'Faroe Islands'),
					('FJ', 'Fiji'),
					('FI', 'Finland'),
					('FR', 'France'),
					('GF', 'French Guiana'),
					('PF', 'French Polynesia'),
					('GA', 'Gabon'),
					('GM', 'Gambia'),
					('GE', 'Georgia'),
					('DE', 'Germany'),
					('GH', 'Ghana'),
					('GI', 'Gibraltar'),
					('GR', 'Greece'),
					('GL', 'Greenland'),
					('GD', 'Grenada'),
					('GP', 'Guadeloupe'),
					('GU', 'Guam'),
					('GT', 'Guatemala'),
					('GG', 'Guernsey'),
					('GN', 'Guinea'),
					('GW', 'Guinea-Bissau'),
					('GY', 'Guyana'),
					('HT', 'Haiti'),
					('VA', 'Holy See'),
					('HN', 'Honduras'),
					('HK', 'Hong Kong'),
					('HU', 'Hungary'),
					('IS', 'Iceland'),
					('IN', 'India'),
					('ID', 'Indonesia'),
					('IR', 'Iran'),
					('IQ', 'Iraq'),
					('IE', 'Ireland'),
					('IM', 'Isle of Man'),
					('IL', 'Israel'),
					('IT', 'Italy'),
					('JM', 'Jamaica'),
					('JP', 'Japan'),
					('JE', 'Jersey'),
					('JO', 'Jordan'),
					('KZ', 'Kazakhstan'),
					('KE', 'Kenya'),
					('KI', 'Kiribati'),
					('PRK', 'Korea PRK'),
					('KOR', 'Korea'),
					('KW', 'Kuwait'),
					('KG', 'Kyrgyzstan'),
					('LA', 'Lao'),
					('LV', 'Latvia'),
					('LB', 'Lebanon'),
					('LS', 'Lesotho'),
					('LY', 'Libya'),
					('LT', 'Liechtenstein'),
					('LU', 'Luxembourg'),
					('MO', 'Macao'),
					('MK','FYROM'),
					('MG','Madagascar'),
					('MW','Malawi'),
					('MY','Malaysia'),
					('MV','Maldives'),
					('ML','Mali'),
					('MT','Malta'),
					('MH','Marshall Islands'),
					('MQ','Martinique'),
					('MR','Mauritania'),
					('MU','Mauritius'),
					('YT','Mayotte'),
					('MX','Mexico'),
					('FM','Micronesia'),
					('MD','Moldova'),
					('MC','Monaco'),
					('MN','Mongolia'),
					('ME','Montenegro'),
					('MS','Montserrat'),
					('MA','Morocco'),
					('MZ','Mozambique'),
					('MM','Myanmar'),
					('NA','Namibia'),
					('NR','Nauru'),
					('NP','Nepal'),
					('NL','Netherlands'),
					('AN','Netherlands Antilles'),
					('NC','New Caledonia'),
					('NZ','New Zealand'),
					('NI','Nicaragua'),
					('NE','Niger'),
					('NG','Nigeria'),
					('NU','Niue'),
					('NF','Norfolk Island'),
					('NO','Norway'),
					('OM','Oman'),
					('PK','Pakistan'),
					('PW','Palau'),
					('PA','Panama'),
					('PG','Papua New Guinea'),
					('PY','Paraguay'),
					('PE','Peru'),
					('PH','Philippines'),
					('PN','Pitcairn'),
					('PL','Poland'),
					('PT','Portugal'),
					('PR','Puerto Rico'),
					('QA','Qatar'),
					('RE','Reunion'),
					('RO','Romania'),
					('RU','Russian Federation'),
					('RW','Rwanda'),
					('BL','Saint Barthélemy'),
					('SH','Saint Helena'),
					('KN','Saint Kitts & Nevis'),
					('LC','Saint Lucia'),
					('MF','Saint Martin'),
					('WS','Samoa'),
					('SM','San Marino'),
					('ST','Sao Tome'),
					('SA','Saudi Arabia'),
					('SN','Senegal'),
					('RS','Serbia'),
					('SC','Seychelles'),
					('SL','Sierra Leone'),
					('SG','Singapore'),
					('SK','Slovakia'),
					('SI','Slovenia'),
					('SB','Solomon Islands'),
					('SO','Somalia'),
					('ZA','South Africa'),
					('ES','Spain'),
					('LK','Sri Lanka'),
					('SD','Sudan'),
					('SR','Suriname'),
					('SZ','Swaziland'),
					('SE','Sweden'),
					('CH','Switzerland'),
					('SY','Syria'),
					('TW','Taiwan'),
					('TJ','Tajikistan'),
					('TZ','Tanzania'),
					('TH','Thailand'),
					('TL','Timor-Leste'),
					('TG','Togo'),
					('TK','Tokelau'),
					('TO','Tonga'),
					('TT','Trinidad & Tobago'),
					('TN','Tunisia'),
					('TR','Turkey'),
					('TM','Turkmenistan'),
					('TV','Tuvalu'),
					('UG','Uganda'),
					('UA','Ukraine'),
					('AE','Arab Emirates'),
					('GB','United Kingdom'),
					('US','United States'),
					('UY','Uruguay'),
					('UZ','Uzbekistan'),
					('VU','Vanuatu'),
					('VE','Venezuela'),
					('VN','Viet Nam'),
					('YE','Yemen'),
					('ZM','Zambia'),
					('ZW','Zimbabwe')";
	$db->setQuery($query);
	$db->query();
	return $msg;
}



function _adjustCategories() {
	$msg = "";
	$msg .= "Adjusting Room Categories <br />";
	$db =& JFactory::getDBO();

	$query = "ALTER TABLE ".$db->nameQuote("#__bookitcategory").
	" CHANGE COLUMN ".$db->nameQuote('start_day')." ".
	$db->nameQuote('start_day')." CHAR(13) NULL, ".
	" CHANGE COLUMN ".$db->nameQuote('end_day')." ".
	$db->nameQuote('end_day')." CHAR(13) NULL ;";

	$db->setQuery($query);

	if (!$db->query()) {
		$msg .= "Error updating Room Categories: ".$db->stderr(true)."<br />";
	}

	//CHANGE START DAYS TO NEW FORMAT
	$query = "UPDATE ".$db->nameQuote("#__bookitcategory").
	"SET ".$db->nameQuote('start_day')."=".$db->Quote('0,0,0,0,0,0,0').
	"WHERE ".$db->nameQuote('start_day')."=".$db->Quote('-1').";";
	$db->setQuery($query);
	$err = $db->query();

	$query = "UPDATE ".$db->nameQuote("#__bookitcategory").
	"SET ".$db->nameQuote('start_day')."=".$db->Quote('0,1,1,1,1,1,1').
	"WHERE ".$db->nameQuote('start_day')."=".$db->Quote('0').";";
	$db->setQuery($query);
	$err .= $db->query();

	$query = "UPDATE ".$db->nameQuote("#__bookitcategory").
	"SET ".$db->nameQuote('start_day')."=".$db->Quote('1,0,1,1,1,1,1').
	"WHERE ".$db->nameQuote('start_day')."=".$db->Quote('1').";";
	$db->setQuery($query);
	$err .= $db->query();

	$query = "UPDATE ".$db->nameQuote("#__bookitcategory").
	"SET ".$db->nameQuote('start_day')."=".$db->Quote('1,1,0,1,1,1,1').
	"WHERE ".$db->nameQuote('start_day')."=".$db->Quote('2').";";
	$db->setQuery($query);
	$err .= $db->query();

	$query = "UPDATE ".$db->nameQuote("#__bookitcategory").
	"SET ".$db->nameQuote('start_day')."=".$db->Quote('1,1,1,0,1,1,1').
	"WHERE ".$db->nameQuote('start_day')."=".$db->Quote('3').";";
	$db->setQuery($query);
	$err .= $db->query();

	$query = "UPDATE ".$db->nameQuote("#__bookitcategory").
	"SET ".$db->nameQuote('start_day')."=".$db->Quote('1,1,1,1,0,1,1').
	"WHERE ".$db->nameQuote('start_day')."=".$db->Quote('4').";";
	$db->setQuery($query);
	$err .= $db->query();

	$query = "UPDATE ".$db->nameQuote("#__bookitcategory").
	"SET ".$db->nameQuote('start_day')."=".$db->Quote('1,1,1,1,1,0,1').
	"WHERE ".$db->nameQuote('start_day')."=".$db->Quote('5').";";
	$db->setQuery($query);
	$err .= $db->query();

	$query = "UPDATE ".$db->nameQuote("#__bookitcategory").
	"SET ".$db->nameQuote('start_day')."=".$db->Quote('1,1,1,1,1,1,0').
	"WHERE ".$db->nameQuote('start_day')."=".$db->Quote('6').";";
	$db->setQuery($query);
	$err .= $db->query();

	$query = "UPDATE ".$db->nameQuote("#__bookitcategory").
	"SET ".$db->nameQuote('start_day')."=".$db->Quote('0,0,0,0,0,0,0').
	"WHERE ".$db->nameQuote('start_day').">=".$db->Quote('7').";";
	$db->setQuery($query);
	$err .= $db->query();

	//CHANGE END DAYS TO NEW FORMAT
	$query = "UPDATE ".$db->nameQuote("#__bookitcategory").
	"SET ".$db->nameQuote('end_day')."=".$db->Quote('0,0,0,0,0,0,0').
	"WHERE ".$db->nameQuote('end_day')."=".$db->Quote('-1').";";
	$db->setQuery($query);
	$err .= $db->query();

	$query = "UPDATE ".$db->nameQuote("#__bookitcategory").
	"SET ".$db->nameQuote('end_day')."=".$db->Quote('0,1,1,1,1,1,1').
	"WHERE ".$db->nameQuote('end_day')."=".$db->Quote('0').";";
	$db->setQuery($query);
	$err .= $db->query();

	$query = "UPDATE ".$db->nameQuote("#__bookitcategory").
	"SET ".$db->nameQuote('end_day')."=".$db->Quote('1,0,1,1,1,1,1').
	"WHERE ".$db->nameQuote('end_day')."=".$db->Quote('1').";";
	$db->setQuery($query);
	$err .= $db->query();

	$query = "UPDATE ".$db->nameQuote("#__bookitcategory").
	"SET ".$db->nameQuote('end_day')."=".$db->Quote('1,1,0,1,1,1,1').
	"WHERE ".$db->nameQuote('end_day')."=".$db->Quote('2').";";
	$db->setQuery($query);
	$err .= $db->query();

	$query = "UPDATE ".$db->nameQuote("#__bookitcategory").
	"SET ".$db->nameQuote('end_day')."=".$db->Quote('1,1,1,0,1,1,1').
	"WHERE ".$db->nameQuote('end_day')."=".$db->Quote('3').";";
	$db->setQuery($query);
	$err .= $db->query();

	$query = "UPDATE ".$db->nameQuote("#__bookitcategory").
	"SET ".$db->nameQuote('end_day')."=".$db->Quote('1,1,1,1,0,1,1').
	"WHERE ".$db->nameQuote('end_day')."=".$db->Quote('4').";";
	$db->setQuery($query);
	$err .= $db->query();

	$query = "UPDATE ".$db->nameQuote("#__bookitcategory").
	"SET ".$db->nameQuote('end_day')."=".$db->Quote('1,1,1,1,1,0,1').
	"WHERE ".$db->nameQuote('end_day')."=".$db->Quote('5').";";
	$db->setQuery($query);
	$err .= $db->query();

	$query = "UPDATE ".$db->nameQuote("#__bookitcategory").
	"SET ".$db->nameQuote('end_day')."=".$db->Quote('1,1,1,1,1,1,0').
	"WHERE ".$db->nameQuote('end_day')."=".$db->Quote('6').";";
	$db->setQuery($query);
	$err .= $db->query();

	$query = "UPDATE ".$db->nameQuote("#__bookitcategory").
	"SET ".$db->nameQuote('end_day')."=".$db->Quote('0,0,0,0,0,0,0').
	"WHERE ".$db->nameQuote('end_day').">=".$db->Quote('7').";";
	$db->setQuery($query);
	$err .= $db->query();
	return $msg;

}
function _convertCategories() {
	$msg = "";
	$msg .= "Updating Room Categories <br />";
	$db =& JFactory::getDBO();

	$query = "ALTER TABLE ".$db->nameQuote("#__bookitcategory").
	" ADD ".$db->nameQuote('price_mode')." tinyint(1) NOT NULL DEFAULT ".$db->quote('0').
	", ADD ".$db->nameQuote('max_in_total')." INT UNSIGNED NULL DEFAULT ".$db->quote('0').",".
	" ADD ".$db->nameQuote('min_in_total')." INT UNSIGNED NULL DEFAULT ".$db->quote('0').",".
	" ADD ".$db->nameQuote('start_day')." CHAR(13) NULL , ".
	" ADD ".$db->nameQuote('end_day')." CHAR(13) NULL ;";

	$db->setQuery($query);
	if (!$db->query()) {
		$msg .= "Error updating Room Categories: ".$db->stderr(true)."<br />";
	}
	return $msg;
}

function _convertCoupons() {
	$msg = "";
	$msg .= "Converting Coupons to Price Rules <br/>";
	$db =& JFactory::getDBO();
	$query = "SELECT * FROM ".$db->nameQuote('#__bookitcoupon');
	$db->setQuery($query);
	$coupons = $db->loadObjectList();

	$query = "SELECT idcategory FROM ".$db->nameQuote('#__bookitcategory');
	$db->setQuery($query);
	$categories = $db->loadResultArray();
	$categories = implode(",",$categories);

	$completed = 0;
	$error = "";

	if (is_array($coupons)) {
		foreach ($coupons as $coupon) {
			if ($coupon->value_fix != "" && $coupon->value_fix >0) {
				$value = $coupon->value_fix;
				$mode = "0";
			} else {
				$value = $coupon->value_percent;
				$mode = "1";
			}

			$query = "INSERT INTO ".$db->nameQuote('#__bookitrules')."(".
					$db->nameQuote('idcategory').",".
					$db->nameQuote('name').",".
					$db->nameQuote('value').",".
					$db->nameQuote('value_child').",".
					$db->nameQuote('value_mode').",".
					$db->nameQuote('mode').",".
					$db->nameQuote('coupon').",".
					$db->nameQuote('type').",".
					$db->nameQuote('xvar').",".
					$db->nameQuote('quantity').",".
					$db->nameQuote('times_used').",".
					$db->nameQuote('valid_from').",".
					$db->nameQuote('valid_to').",".
					$db->nameQuote('code').") VALUES (".
					$db->quote($categories).",".
					$db->quote($coupon->name).",".
					$db->quote($value).",".
					$db->quote($value).",".
					$db->quote($mode).",".
					$db->quote('1').",".
					$db->quote('1').",".
					$db->quote('2').",".
					$db->quote('0').",".
					$db->quote($coupon->usable).",".
					$db->quote($coupon->used).",".
					$db->quote($coupon->valid_from).",".
					$db->quote($coupon->valid_to).",".
					$db->quote($coupon->code).")";

			$db->setQuery($query);
			if ($db->query()) {
				$completed++;
				//UPDATE BOOKINGS TO NEW RULE IDS
				$idcoupon = $db->insertid();
				$query = "UPDATE ".$db->nameQuote('#__bookitbooking')." SET ".
						$db->nameQuote('idcoupon')."=".$db->quote($idcoupon)." WHERE ".
						$db->nameQuote('idcoupon')."=".$db->quote($coupon->idcoupon);
				$db->setQuery($query);
				$db->query();
			} else {
				$error .= $db->stdErr(true)."<br />";
			}
		}
		if (count($coupons)==$completed) {
			$msg .= $completed." coupons converted. <br />";
		} else {
			$msg .= "Error: ".$error." ".$completed."/".count($coupons)." coupons converted. <br />";
		}
	}
	return $msg;
}
function _convertSpecialOffers() {
	$db =& JFactory::getDBO();
	$msg = "";
	$msg .= "Converting Special Offers to Price Rules <br/>";

	$query = "SELECT * FROM ".$db->nameQuote('#__bookitspecialoffer');
	$db->setQuery($query);
	$offers = $db->loadObjectList();

	$query = "SELECT idcategory FROM ".$db->nameQuote('#__bookitcategory');
	$db->setQuery($query);
	$categories = $db->loadResultArray();
	$categories = implode(",",$categories);

	$completed = 0;
	$error = "";

	if (is_array($offers)) {
		foreach ($offers as $offer) {
			if ($offer->value_fix != "" && $offer->value_fix >0) {
				$value = $offer->value_fix;
				$valuemode = "0";
			} else {
				$value = $offer->value_percent;
				$valuemode = "1";
			}

			if ($offer->type == "0") {
				$mode = "1"; //Offer
			} else {
				$mode = "2"; //Extra Charge
			}

			if ($offer->every_x_day != "") $type="2";
			if ($offer->every_x_guest != "") $type="3";
			if ($offer->every_x_child != "") $type="4";

			$query = "INSERT INTO ".$db->nameQuote('#__bookitrules')."(".
					$db->nameQuote('name').
					$db->nameQuote('value').
					$db->nameQuote('value_mode').
					$db->nameQuote('mode').
					$db->nameQuote('type').") VALUES (".
					$db->quote($coupon->name).",".
					$db->quote($value).",".
					$db->quote($valuemode).",".
					$db->quote($mode).",".
					$db->quote($type).");";
			$db->setQuery($query);

			if ($db->query()) {
				$completed++;
			} else {
				$error .= $db->stdErr(true)."<br />";
			}
		}
		if (count($offers)==$completed) {
			$msg .= $completed." offers converted.<br/>";
		} else {
			$msg .= "Error: ".$error." ".$completed."/".count($offers)." coupons converted.<br />";
		}
	}
	return $msg;
}

function _dropOldTables() {

	$msg = "";
	$msg .= "Removing unused tables <br/>";
	$db =& JFactory::getDBO();
	$dropavail = "DROP TABLE ".$db->nameQuote("#__bookitavailability"); //REMOVE AVAIL TABLE
	$db->setQuery($dropavail);

	if (!$db->query()) {
		$msg .= "Error Removing Table 'Availability': ".$db->stdErr(true)."<br />";
	} else {
		$msg .= "Availability Table Removed.<br/>";
	};

	$dropcoupon = "DROP TABLE ".$db->nameQuote("#__bookitcoupon"); //REMOVE COUPON TABLE
	$db->setQuery($dropcoupon);

	if (!$db->query()) {
		$msg .= "Error Removing Table 'Coupons': ".$db->stdErr(true)."<br />";
	} else {
		$msg .= "Coupons Table Removed.<br />";
	};

	$dropspecial = "DROP TABLE ".$db->nameQuote("#__bookitspecialoffer"); //REMOVE SPECIALS TABLE
	$db->setQuery($dropspecial);

	if (!$db->query()) {
		$msg .= "Error Removing Table 'Special Offers': ".$db->stdErr(true)."<br />";
	} else {
		$msg .= "Special Offers Removed.<br />";
	};

	return $msg;
}
function _sqlFile($filename) {
	$db =& JFactory::getDBO();
	$file = dirname(__FILE__).DS.$filename.'.sql';
	if(!file_exists($file)) {
		return false;
	}

	$filecontent = file_get_contents($file);
	$queries = $db->splitSql($filecontent);

	foreach ($queries as $query) {

		if ($query != '' && $query{0} != '#') {
			$db->setQuery($query);
			if (!$db->query()) {
				return $db->stdErr(true);
			}
		}
	}
	return true;
}

function _updateUtils ()
{
	$msg = "";

	$db =& JFactory::getDBO();
	if (!_column_exists('#__bookitutils', 'show_address3'))
	{
		$query = "ALTER TABLE ".$db->nameQuote('#__bookitutils')." ADD ".
				$db->nameQuote("show_address3")." tinyint(1) NOT NULL DEFAULT ".$db->quote('1').
				", ADD ".$db->nameQuote('surname_req')." tinyint(1) NOT NULL DEFAULT ".$db->quote('1').
				", ADD ".$db->nameQuote('show_postcode')." tinyint(1) NOT NULL DEFAULT ".$db->quote('1').
				", ADD ".$db->nameQuote('postcode_req')." tinyint(1) NOT NULL DEFAULT ".$db->quote('1');
		$db->setQuery($query);
		$db->query();
		$msg .= "Updating Utils table <br />";
	}
	if (!_column_exists('#__bookitutils', 'custverified'))
	{
		$custverified = _getContentFromFile('custverified.html');

		$query = "ALTER TABLE ".$db->nameQuote('#__bookitutils')." ADD ".
				$db->nameQuote("custverified")." TEXT NULL, ADD ".
				$db->nameQuote('custverified_subject')." TEXT NULL;";
		$db->setQuery($query);
		$db->query();

		$query = "UPDATE ".$db->nameQuote('#__bookitutils')." SET ".
				$db->nameQuote('custverified')." = ".$db->quote($custverified).
				",".$db->nameQuote('custverified_subject')." = ".
				$db->quote('Your booking has now been verified');
		$db->setQuery($query);
		$db->query();
		$msg .= "Adding 'Booking Verified' Email <br />";
	}
	if (!_column_exists('#__bookitutils', 'custprebooking'))
	{
		$custprebooking = _getContentFromFile('custprebooking.html');

		$query = "ALTER TABLE ".$db->nameQuote('#__bookitutils')." ADD ".
				$db->nameQuote("custprebooking")." TEXT NULL, ADD ".
				$db->nameQuote('custprebooking_subject')." TEXT NULL;";
		$db->setQuery($query);
		$db->query();

		$query = "UPDATE ".$db->nameQuote('#__bookitutils')." SET ".
				$db->nameQuote('custprebooking')." = ".$db->quote($custprebooking).
				",".$db->nameQuote('custprebooking_subject')." = ".
				$db->quote('Thank you for booking with us');
		$db->setQuery($query);
		$db->query();
		$msg .= "Adding 'Pre-Verification' Email <br />";
	}
	if (!_column_exists('#__bookitutils', 'adminprebooking'))
	{
		$adminprebooking = _getContentFromFile('adminprebooking.html');

		$query = "ALTER TABLE ".$db->nameQuote('#__bookitutils')." ADD ".
				$db->nameQuote("adminprebooking")." TEXT NULL, ADD ".
				$db->nameQuote('adminprebooking_subject')." TEXT NULL;";
		$db->setQuery($query);
		$db->query();

		$query = "UPDATE ".$db->nameQuote('#__bookitutils')." SET ".
				$db->nameQuote('adminprebooking')." = ".$db->quote($adminprebooking).
				",".$db->nameQuote('adminprebooking_subject')." = ".
				$db->quote('{bookingid} - New booking requires verification');
		$db->setQuery($query);
		$db->query();
		$msg .= "Adding Admin 'Pre-Verification' Email <br />";
	}
	return $msg;
}
function _updateParams ()
{
	$currentDate = date("Y-m-d");
	$msg = "";

	$db =& JFactory::getDBO();
	if (!_column_exists('#__bookitparams', 'start_monday'))
	{
		$query = "ALTER TABLE ".$db->nameQuote('#__bookitparams')." ADD ".
				$db->nameQuote("start_monday")." tinyint(1) NOT NULL DEFAULT ".$db->quote('0');
		$db->setQuery($query);
		$db->query();
		$msg .= "Adding start_monday in Params table <br />";
	}
	if (!_column_exists('#__bookitparams', 'last_date'))
	{
		$date = date("Y-m-d");
		$date = strtotime(date("Y-m-d", strtotime($date)) . " +5 year");
		$date = date("Y-m-d",$date);
		$query = "ALTER TABLE ".$db->nameQuote('#__bookitparams')." ADD ".
				$db->nameQuote("last_date")." DATE DEFAULT ".$db->quote($date);
		$db->setQuery($query);
		$db->query();
		$msg .= "Adding last_date in Params table <br />";

	}
	if (!_column_exists('#__bookitparams', 'normalize'))
	{

		$query = "ALTER TABLE ".$db->nameQuote('#__bookitparams')." ADD ".
				$db->nameQuote("normalize")." tinyint(1) NOT NULL DEFAULT ".$db->quote('0');
		$db->setQuery($query);
		$db->query();
		$msg .= "Adding normalize in Params table <br />";

	}
	if (!_column_exists('#__bookitparams', 'late_booking'))
	{

		$query = "ALTER TABLE ".$db->nameQuote('#__bookitparams')." ADD ".
				$db->nameQuote("late_booking")." INT UNSIGNED NULL DEFAULT ".$db->quote('0');
		$db->setQuery($query);
		$db->query();
		$msg .= "Adding late booking in Params table <br />";

	}
	if (!_column_exists('#__bookitparams', 'show_bar'))
	{

		$query = "ALTER TABLE ".$db->nameQuote('#__bookitparams')." ADD ".
				$db->nameQuote("show_bar")." INT UNSIGNED NULL DEFAULT ".$db->quote('1');
		$db->setQuery($query);
		$db->query();
		$msg .= "Adding show bar in Params table <br />";

	}
	if (!_column_exists('#__bookitparams', 'new_template'))
	{

		$query = "ALTER TABLE ".$db->nameQuote('#__bookitparams')." ADD ".
				$db->nameQuote("new_template")." INT UNSIGNED NULL DEFAULT ".$db->quote('1');
		$db->setQuery($query);
		$db->query();
		$msg .= "Adding new template in Params table <br />";

	}
	if (!_column_exists('#__bookitparams', 'admin_confirm'))
	{

		$query = "ALTER TABLE ".$db->nameQuote('#__bookitparams')." ADD ".
				$db->nameQuote("admin_confirm")." tinyint(1) NOT NULL DEFAULT ".$db->quote('0');
		$db->setQuery($query);
		$db->query();
		$msg .= "Adding admin confirmation to Params table <br />";

	}
	if (!_column_exists('#__bookitparams', 'prebooking_url'))
	{

		$query = "ALTER TABLE ".$db->nameQuote('#__bookitparams')." ADD ".
				$db->nameQuote("prebooking_url")." TEXT NULL;";
		$db->setQuery($query);
		$db->query();
		$msg .= "Adding pre validation url to Params table <br />";

	}
	return $msg;
}

function _getContentFromFile ($file)
{
	$file = JPATH_ROOT.DS.'components'.DS.'com_blooking'.DS.'tmpl'.DS.$file;
	jimport('joomla.filesystem.file');
	$content = JFile::read($file);
	return $content;
}

function _replaceBookitUninstall ()
{

	$src = JPATH_ROOT.DS.'components'.DS.'com_blooking'.DS.'bookit'.DS.'uninstall.sql';
	$dest = JPATH_ADMINISTRATOR.DS.'components'.DS.'com_bookit'.DS.'uninstall.sql';

	jimport('joomla.filesystem.file');
	if (JFile::exists($dest))
		return JFile::move($src,$dest);

	else
		return false;
}


function _languages() {
	$db =& JFactory::getDBO();
	$query = "SELECT COUNT(*) FROM ".$db->nameQuote("#__bookitcountry");
	$db->setQuery($query);
	$db->query();

	if ($db->loadResult() == 0) {
		$query = "INSERT INTO `#__bookitcountry` (`abbv`, `name`) VALUES
				('AF', 'Afghanistan'),
				('AX', 'Aland Islands'),
				('AL', 'Albania'),
				('DZ', 'Algeria'),
				('AS', 'American Samoa'),
				('A0', 'Angola'),
				('AI', 'Anguilla'),
				('AQ', 'Antarctica'),
				('AG', 'Antigua and Barbuda'),
				('AR', 'Argentina'),
				('AM', 'Armenia'),
				('AW', 'Aruba'),
				('AU', 'Australia'),
				('AT', 'Austria'),
				('AZ', 'Azerbaijan'),
				('BS', 'Bahamas'),
				('BH', 'Bahrain'),
				('BD', 'Bangladesh'),
				('BB', 'Barbados'),
				('BY', 'Belarus'),
				('BE', 'Belgium'),
				('BZ', 'Belize'),
				('BJ', 'Benin'),
				('BM', 'Bermuda'),
				('BT', 'Bhutan'),
				('BO', 'Bolivia'),
				('BA', 'Bosnia and Herzegovina'),
				('BW', 'Botswana'),
				('BV', 'Bouvet Island'),
				('BR', 'Brazil'),
				('BN', 'Brunei Darussalam'),
				('BG', 'Bulgaria'),
				('BF', 'Burkina Faso'),
				('BI', 'Burundi'),
				('KH', 'Cambodia'),
				('CM', 'Cameroon'),
				('CA', 'Canada'),
				('CV', 'Cape Verde'),
				('KY', 'Cayman Islands'),
				('CF', 'Central African Rep'),
				('TD', 'Chad'),
				('CL', 'Chile'),
				('CN', 'China'),
				('CX', 'Christmas Island'),
				('CC', 'Cocos Islands '),
				('CO', 'Colombia'),
				('KM', 'Comoros'),
				('CD', 'Congo'),
				('CK', 'Cook Islands'),
				('CR', 'Costa Rica'),
				('CI', 'Cote d Ivoire'),
				('HR', 'Croatia'),
				('CU', 'Cuba'),
				('CY', 'Cyprus'),
				('CZ', 'Czech Republic'),
				('DK', 'Denmark'),
				('DJ', 'Djibouti'),
				('DM', 'Dominica'),
				('DO', 'Dominican Rep'),
				('EC', 'Ecuador'),
				('EG', 'Egypt'),
				('SV', 'El Salvador'),
				('CG', 'Equatorial Guinea'),
				('ER', 'Eritrea'),
				('EE', 'Estonia'),
				('ET', 'Ethiopia'),
				('FK', 'Falkland Islands'),
				('FO', 'Faroe Islands'),
				('FJ', 'Fiji'),
				('FI', 'Finland'),
				('FR', 'France'),
				('GF', 'French Guiana'),
				('PF', 'French Polynesia'),
				('GA', 'Gabon'),
				('GM', 'Gambia'),
				('GE', 'Georgia'),
				('DE', 'Germany'),
				('GH', 'Ghana'),
				('GI', 'Gibraltar'),
				('GR', 'Greece'),
				('GL', 'Greenland'),
				('GD', 'Grenada'),
				('GP', 'Guadeloupe'),
				('GU', 'Guam'),
				('GT', 'Guatemala'),
				('GG', 'Guernsey'),
				('GN', 'Guinea'),
				('GW', 'Guinea-Bissau'),
				('GY', 'Guyana'),
				('HT', 'Haiti'),
				('VA', 'Holy See'),
				('HN', 'Honduras'),
				('HK', 'Hong Kong'),
				('HU', 'Hungary'),
				('IS', 'Iceland'),
				('IN', 'India'),
				('ID', 'Indonesia'),
				('IR', 'Iran'),
				('IQ', 'Iraq'),
				('IE', 'Ireland'),
				('IM', 'Isle of Man'),
				('IL', 'Israel'),
				('IT', 'Italy'),
				('JM', 'Jamaica'),
				('JP', 'Japan'),
				('JE', 'Jersey'),
				('JO', 'Jordan'),
				('KZ', 'Kazakhstan'),
				('KE', 'Kenya'),
				('KI', 'Kiribati'),
				('PRK', 'Korea PRK'),
				('KOR', 'Korea'),
				('KW', 'Kuwait'),
				('KG', 'Kyrgyzstan'),
				('LA', 'Lao'),
				('LV', 'Latvia'),
				('LB', 'Lebanon'),
				('LS', 'Lesotho'),
				('LY', 'Libya'),
				('LT', 'Liechtenstein'),
				('LU', 'Luxembourg'),
				('MO', 'Macao'),
				('MK','FYROM'),
				('MG','Madagascar'),
				('MW','Malawi'),
				('MY','Malaysia'),
				('MV','Maldives'),
				('ML','Mali'),
				('MT','Malta'),
				('MH','Marshall Islands'),
				('MQ','Martinique'),
				('MR','Mauritania'),
				('MU','Mauritius'),
				('YT','Mayotte'),
				('MX','Mexico'),
				('FM','Micronesia'),
				('MD','Moldova'),
				('MC','Monaco'),
				('MN','Mongolia'),
				('ME','Montenegro'),
				('MS','Montserrat'),
				('MA','Morocco'),
				('MZ','Mozambique'),
				('MM','Myanmar'),
				('NA','Namibia'),
				('NR','Nauru'),
				('NP','Nepal'),
				('NL','Netherlands'),
				('AN','Netherlands Antilles'),
				('NC','New Caledonia'),
				('NZ','New Zealand'),
				('NI','Nicaragua'),
				('NE','Niger'),
				('NG','Nigeria'),
				('NU','Niue'),
				('NF','Norfolk Island'),
				('NO','Norway'),
				('OM','Oman'),
				('PK','Pakistan'),
				('PW','Palau'),
				('PA','Panama'),
				('PG','Papua New Guinea'),
				('PY','Paraguay'),
				('PE','Peru'),
				('PH','Philippines'),
				('PN','Pitcairn'),
				('PL','Poland'),
				('PT','Portugal'),
				('PR','Puerto Rico'),
				('QA','Qatar'),
				('RE','Reunion'),
				('RO','Romania'),
				('RU','Russian Federation'),
				('RW','Rwanda'),
				('BL','Saint Barthélemy'),
				('SH','Saint Helena'),
				('KN','Saint Kitts & Nevis'),
				('LC','Saint Lucia'),
				('MF','Saint Martin'),
				('WS','Samoa'),
				('SM','San Marino'),
				('ST','Sao Tome'),
				('SA','Saudi Arabia'),
				('SN','Senegal'),
				('RS','Serbia'),
				('SC','Seychelles'),
				('SL','Sierra Leone'),
				('SG','Singapore'),
				('SK','Slovakia'),
				('SI','Slovenia'),
				('SB','Solomon Islands'),
				('SO','Somalia'),
				('ZA','South Africa'),
				('ES','Spain'),
				('LK','Sri Lanka'),
				('SD','Sudan'),
				('SR','Suriname'),
				('SZ','Swaziland'),
				('SE','Sweden'),
				('CH','Switzerland'),
				('SY','Syria'),
				('TW','Taiwan'),
				('TJ','Tajikistan'),
				('TZ','Tanzania'),
				('TH','Thailand'),
				('TL','Timor-Leste'),
				('TG','Togo'),
				('TK','Tokelau'),
				('TO','Tonga'),
				('TT','Trinidad & Tobago'),
				('TN','Tunisia'),
				('TR','Turkey'),
				('TM','Turkmenistan'),
				('TV','Tuvalu'),
				('UG','Uganda'),
				('UA','Ukraine'),
				('AE','Arab Emirates'),
				('GB','United Kingdom'),
				('US','United States'),
				('UY','Uruguay'),
				('UZ','Uzbekistan'),
				('VU','Vanuatu'),
				('VE','Venezuela'),
				('VN','Viet Nam'),
				('YE','Yemen'),
				('ZM','Zambia'),
				('ZW','Zimbabwe')";
		$db->setQuery($query);
		$db->query();
	}
}


function _column_exists($table, $column){
	$exists = false;
	$db =& JFactory::getDBO();
	$query = "SHOW COLUMNS FROM ".$db->nameQuote($table)." LIKE ".
			$db->quote($column);
	$db->setQuery($query);
	$res = $db->loadObjectList();
	foreach ($res as $row)
	{
		if ($row->Field==$column)
			return true;
	}

	return false;
}


function _convertTodayToTimestump () {

	$msg="";
	$db =& JFactory::getDBO();
	$query = "UPDATE ".$db->nameQuote("#__bookitbooking")." SET ".
			$db->nameQuote('timestamp')." = ".$db->nameQuote('today');
	$db->setQuery($query);
	if (!$db->query()) {
		$msg .= "Error converting dates ".$db->stderr(true)."<br />";
	}
	return $msg;

}

// Get a new installer
$plg_installer = new JInstaller();
// Install the wire Plugin
$plg_installer->install($this->parent->getPath('source').DS.'plg_blookingwire');
$plg2_installer = new JInstaller();
// Install the paypal Plugin
$plg2_installer->install($this->parent->getPath('source').DS.'plg_blookingpaypal');

$mod_installer = new JInstaller();
$mod_installer->install($this->parent->getPath('source').DS.'module');
/*end of Installation */
?>
<table>
	<tr>
		<td width="1%" style="vertical-align: top"><img
			src="components/com_blooking/images/blooking.png" alt="BlooKing" /></td>
		<td align="left">
			<!--  <div class="blooking_div"><span class='title'></span> <span
			class='subtitle'>New Features</span>
		<ul id="blooking_changelog">
			<li>New look and feel</li>
			<li>Super flexible pricing rules</li>
			<li>Better control on availability</li>
			<li>Native multi-lingual support</li>
			<li>Improved performance</li>
		</ul>
		<a href="http://blooking.org/index.php/changelog" target="_blank">Full
		list</a></div>
		 -->
		</td>
	</tr>
</table>
<table class="adminlist">
	<thead>
		<tr>
			<th class="title" style="text-align: left"><?php echo 'Extension'; ?>
			</th>
			<th width="30%" style="text-align: left"><?php echo 'Status'; ?></th>
		</tr>
	</thead>
	<tbody>
		<tr class="row0">
			<td class="key"><?php echo 'BlooKing '.JText::_('Component'); ?></td>
			<td><?php echo JText::_('Installed'); ?></td>
		</tr>
	</tbody>
</table>

<table class="adminlist">
	<thead>
		<tr>
			<th class="title" style="text-align: left"><?php echo 'Extension'; ?>
			</th>
			<th width="30%" style="text-align: left"><?php echo 'Status'; ?></th>
		</tr>
	</thead>
	<tbody>
		<tr class="row0">
			<td class="key"><?php echo 'BlooKing Side Module'; ?></td>
			<td><?php echo JText::_('Installed'); ?></td>
		</tr>
	</tbody>
</table>

<table class="adminlist">
	<thead>
		<tr>
			<th class="title" style="text-align: left"><?php echo JText::_('Plugin'); ?>
			</th>
			<th width="30%" style="text-align: left"><?php echo JText::_('Group'); ?>
			</th>
			<th width="30%" style="text-align: left"><?php echo 'Status'; ?></th>
		</tr>
	</thead>
	<tbody>
		<tr class="row0">
			<td class="key">BlooKing - Paypal Plugin</td>
			<td class="key">system</td>
			<td><?php echo 'Installed'; ?></td>
		</tr>
		<tr class="row0">
			<td class="key">BlooKing - Wire Transfer Plugin</td>
			<td class="key">system</td>
			<td><?php echo 'Installed'; ?></td>
		</tr>
	</tbody>
</table>




<style>
.title {
	color: #2F6C91;
	display: block;
	font-size: 20px;
}

.subtitle {
	color: #5492BB;
	display: block;
	font-size: 15px;
}

.blooking_div {
	font-size: 15px;
	padding-top: 20px;
}

#blooking_changelog {
	list-style-type: none;
	padding-left: 14px;
}

#blooking_changelog li {
	list-style: circle;
	color: #666;
}

#blooking_links {
	list-style-type: none;
	padding: 0;
}

.blooking_log {
	background-color: #FFFDE0;
	color: #666666;
	font-family: Arial, Helvetica, sans-serif;
	font-size: 12px;
	margin-top: 20px;
	width: 100%;
}

.blooking_log span {
	font-weight: bold;
	display: block;
}
</style>
