<?php
/**
 * BlooKing - The King in Joomla Booking
 * @version 1.0
 * @author BlooKing.org. Based on BooKiTGold code by Costas Kakousis
 * @copyright (C) 2012-2013 by BlooKing.org (http://www.blooking.org)
 * @license GNU/GPL: http://www.gnu.org/copyleft/gpl.html
 *
 * If you fork this to create your own project, please make a reference to
 * BlooKing! someplace in your code and provide a link to
 * http://www.blooking.org
 *
 * This file is part of BlooKing! BlooKing is free software: you can
 * redistribute it and/or modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * BlooKing is distributed in the hope that it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details. You should have received a copy of the GNU General Public License
 * along with BlooKing.  If not, see <http://www.gnu.org/licenses/>.
 *   ______ __                __  __ __
 *	|   __ \  |.-----..-----.|  |/  |__|.-----..-----.
 *	|   __ <  ||  _  ||  _  ||     <|  ||     ||  _  |
 *	|______/__||_____||_____||__|\__|__||__|__||___  |
 *                                             |_____|
 **/
defined( '_JEXEC' ) or die( 'Restricted access' );

class ModBlookingHelper {

	function oncategorychange ($idcategory)
	{
		$options = new stdClass();
		$category = ModBlookingHelper::getCategory($idcategory);

		if ($idcategory<=0)
		{
			$adult_options = array();
			for ($i=1; $i<=4; $i++)
			{
				$adult_options[$i] = $i;
			}
			$options->adults = $adult_options;

			$children_options = array();
			for ($i=0; $i<=3; $i++)
			{
				$children_options[$i] = $i;
			}

			$options->children = $children_options;
		}
		else
		{
			if ($category->nguests > 0)
			{
				$adult_options = array();
				for ($i=1; $i<=$category->nguests; $i++)
				{
					$adult_options[$i] = $i;
				}
				$options->adults = $adult_options;
			}
			else
			{
				$options->adults = "";
			}
			if ($category->nchilds > 0)
			{
				$children_options = array();
				for ($i=$category->nchilds_min; $i<=$category->nchilds; $i++)
				{
					$children_options[$i] = $i;
				}
				$options->children = $children_options;
			}
			else
			{
				$options->children =  array();
			}
		}

		return $options;
	}

	function getCategory($id)
	{
		$db =& JFactory::getDBO();
		$sql = "SELECT * FROM ".$db->nameQuote("#__bookitcategory")." WHERE ".
				$db->nameQuote("idcategory")." = ".$db->quote($id);
		$db->setQuery($sql);
		return $db->loadObject();
	}
	function getCategoryOptions ()
	{
		$db =& JFactory::getDBO();
		$lang = ModBlookingHelper::getLang();
		$options = array();
		$sql = "SELECT * FROM ".$db->nameQuote('#__bookitcategory').
		" ORDER BY ".$db->nameQuote('name');
		$db->setQuery($sql);
		$categories = $db->loadObjectList();

		if (isset($categories))
		{
			foreach ($categories as $category)
			{
				if (isset($category->{"name_".$lang}))
					$name = $category->{"name_".$lang};
				else
					$name=$category->name;
				array_push($options, JHTML::_('select.option', $category->idcategory,
				$name));
			}
		}
		return $options;

	}
	function getParams ()
	{
		$db =& JFactory::getDBO();
		$sql = "SELECT * FROM ".$db->nameQuote("#__bookitparams").
		" WHERE ".$db->nameQuote("id")."=".
		$db->quote("1");
		$db->setQuery($sql);
		return $db->loadObject();
	}

	function getDateFormat ($dateformatcode) {
		$res = new stdClass();
		if ($dateformatcode==""||$dateformatcode==3)
		{
			$d1='d-m-Y';
			$d2='%d-%m-%Y';
		}
		else if ($dateformatcode==1)
		{
			$d1='Y-m-d';
			$d2='%Y-%m-%d';
		}
		else if ($dateformatcode==2)
		{
			$d1='m/d/Y';
			$d2='%m/%d/%Y';
		}

		$res->d1 = $d1;
		$res->d2 = $d2;
		return $res;
	}
	function getLang($locale=false)
	{
		$lg = JFactory::getLanguage();
		if(version_compare(JVERSION,'1.6.0','ge'))
		{
			$lang_code = explode('-',$lg->getTag());
			$lang = $lang_code[0];
			if ($locale)
				return $lg->getTag();
		}
		else
		{
			$lang_code = explode('-',$lg->_lang);
			$lang = $lang_code[0];
			if ($locale)
				return $lg->_lang;
		}
		return $lang;
	}
	function getMaxMinGuests ()
	{
		$db =& JFactory::getDBO();
		$res = new stdClass();
		$res->max_adults=0;
		$res->min_adults=0;
		$res->max_childs=0;
		$res->min_childs=0;
		$query = "SELECT MAX(".$db->nameQuote("nguests").") FROM ".
				$db->nameQuote("#__bookitcategory");
		$db->setQuery($query);
		$res->max_adults = $db->loadResult();
		//--
		$query = "SELECT MIN(".$db->nameQuote("nguests_min").") FROM ".
				$db->nameQuote("#__bookitcategory");
		$db->setQuery($query);
		$res->min_adults = $db->loadResult();
		//--
		$query = "SELECT MAX(".$db->nameQuote("nchilds").") FROM ".
				$db->nameQuote("#__bookitcategory");
		$db->setQuery($query);
		$res->max_childs = $db->loadResult();
		//--
		$query = "SELECT MIN(".$db->nameQuote("nchilds_min").") FROM ".
				$db->nameQuote("#__bookitcategory");
		$db->setQuery($query);
		$res->min_childs = $db->loadResult();

		return $res;
	}

	function setGuestDropDowns ($lists, $res, $booking_session)
	{
		for ($j=1; $j<9; $j++)
		{
			$options = array();
			for ($i=1; $i<=$res->max_adults; $i++)
			{
				array_push($options, JHTML::_('select.option', $i, $i));
			}

			if ($j==1&& $res->max_adults > 0)
				$style = 'class="bookit_search_rooms_dropbox"';
			else
				$style = 'class="bookit_search_rooms_dropbox_hidden"';

			if (isset($booking_session['mod_room'.$j.'_adults']) )
				$default = $booking_session['mod_room'.$j.'_adults'];
			else $default=0;

			$style .= 'onchange=mod_onGuestsChange();';
			$lists['mod_room'.$j.'_adults']  = JHTML::_('select.genericList',
					$options, 'mod_room'.$j.'_adults', $style, 'value', 'text', $default);

			$options = array();
			for ($i=$res->min_childs; $i<=$res->max_childs; $i++)
			{
				array_push($options, JHTML::_('select.option', $i, $i));
			}


			if ($j==1&& $res->max_childs > 0)
				$style = 'class="bookit_search_rooms_dropbox"';
			else
				$style = 'class="bookit_search_rooms_dropbox_hidden"';

			if (isset($booking_session['mod_room'.$j.'_children']) )
				$default = $booking_session['mod_room'.$j.'_children'];
			else $default=0;

			$style .= 'onchange=mod_onGuestsChange();';
			$lists['mod_room'.$j.'_children']  = JHTML::_('select.genericList',
					$options, 'mod_room'.$j.'_children', $style, 'value', 'text',
					$default);

		}
		return $lists;

	}
	function getMinPeriod ()
	{
		$db =& JFactory::getDBO();

		$sql = "SELECT MIN(min_stay) FROM ".
				$db->nameQuote('#__bookitcategory');
		$db->setQuery($sql);
		$min = $db->loadResult();
		if ($min==0) return 1;
		else return $min;
	}
	function getMenuItemID ()
	{
		$db =& JFactory::getDBO();

		$sql = "SELECT ".$db->nameQuote('id')." FROM ".
				$db->nameQuote('#__menu')." WHERE ".$db->nameQuote('link').
				" LIKE ".$db->quote('%view=blooking%');
		$db->setQuery($sql);

		return $db->loadResult();
			
	}
}
?>