<?php
/**
 * BlooKing - The King in Joomla Booking
 * @version 1.0
 * @author BlooKing.org. Based on BooKiTGold code by Costas Kakousis
 * @copyright (C) 2012-2013 by BlooKing.org (http://www.blooking.org)
 * @license GNU/GPL: http://www.gnu.org/copyleft/gpl.html
 *
 * If you fork this to create your own project, please make a reference to
 * BlooKing! someplace in your code and provide a link to
 * http://www.blooking.org
 *
 * This file is part of BlooKing! BlooKing is free software: you can
 * redistribute it and/or modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * BlooKing is distributed in the hope that it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details. You should have received a copy of the GNU General Public License
 * along with BlooKing.  If not, see <http://www.gnu.org/licenses/>.
 *   ______ __                __  __ __
 *	|   __ \  |.-----..-----.|  |/  |__|.-----..-----.
 *	|   __ <  ||  _  ||  _  ||     <|  ||     ||  _  |
 *	|______/__||_____||_____||__|\__|__||__|__||___  |
 *                                             |_____|
 **/
defined( '_JEXEC' ) or die( 'Restricted access' );

require_once JPATH_SITE.DS."modules".DS."mod_blooking".DS."helper.php";
//require_once (JPATH_SITE.DS.'components'.DS.'com_blooking'.DS.'router.php');

$lang =& JFactory::getLanguage();
$extension = 'com_blooking';
$base_dir = JPATH_SITE;
$language_tag = ModBlookingHelper::getLang(true);
$lang->load($extension, $base_dir, $language_tag, true);


$session =& JFactory::getSession();
$booking_session = $session->get('mod_blooking', array());

$itemID = $params->get('itemid', '');
if ($itemID=='')
{
	$itemID =  ModBlookingHelper::getMenuItemID();
}

$template = $params->get('template', '0');
$com_params =  ModBlookingHelper::getParams();
$max_booking_period = $com_params->max_booking_period;
$multiroom = $com_params->multiroom;
$show_categories_list = 1;
$dateformatcode = $com_params->dateformat;

$document = &JFactory::getDocument();
$document->addScript( JURI::root(true).
		'/modules/mod_blooking/js/mod_blooking.js' );
$document->addScript( JURI::root(true).
		'/components/com_blooking/js/json2.js' );
$document->addScript( JURI::root(true).
		'/components/com_blooking/js/json-minified.js' );

//Set css
if ($com_params->new_template == '1') {
	$stylesheet = 'search_form.css';
	$path = 'components/com_blooking/css/thereef/';

} else {
	$stylesheet = 'search_form.css';
	$path = 'components/com_blooking/css/';
}

JHTML::stylesheet($stylesheet, $path);

$date_code = ModBlookingHelper::getDateFormat($dateformatcode);

//-----------RETRIEVE DATA FROM SESSION-------------------------------------
if (empty($booking_session))
{
	$startdate = date ($date_code->d1);
	$enddate = date($date_code->d1,strtotime("+ 1day"));
	$from_day = JText::_(date("l",strtotime("now")));
	$to_day = JText::_(date("l",strtotime("+1 day")));
	if ($multiroom==1 || $multiroom==2)
	{
		$mod_rooms = 0;
	}
	else
	{
		$mod_idcategory = 0;
		$mod_nguests=0;
		$mod_nchilds=0;
	}
}
else
{
	$startdate = $booking_session['mod_valid_from'];
	$enddate = $booking_session['mod_valid_to'];
	$from_day = JText::_(date("l",strtotime($startdate)));
	$to_day = JText::_(date("l",strtotime($enddate)));

	if ($multiroom==1 || $multiroom == 2)
	{
		;
	}
	else
	{

		$mod_idcategory = $booking_session['mod_idcategory'];
		$mod_nguests=$booking_session['mod_nguests'];
		if(isset($booking_session['mod_nchilds']))
			$mod_nchilds=$booking_session['mod_nchilds'];
		else
			$mod_nchilds=0;

	}

}

//-----------SET DATE PICKERS ----------------------------------------------
$min_stay = ModBlookingHelper::getMinPeriod();
$fn="mod_valid_from";
$fn2="mod_valid_to";
$last_date = date($date_code->d1, strtotime($com_params->last_date));

$js = 'onchange="(mod_updateDateField(\''.$fn.'\',\''.$date_code->d1.'\',
		'.$min_stay.',\''.$last_date.'\' ));
				(setDayName(\''.$fn.'\',\''.$date_code->d1.'\'));
						(setDayName(\''.$fn2.'\',\''.$date_code->d1.'\'));"';

$from_datepicker = JHTML::_( 'calendar',$startdate,'mod_valid_from',
		'mod_valid_from',$date_code->d2,'class="bookit_search_inputbox" size="8"
		style="z-index:500" '.$js);

$js2 = 'onchange="(mod_updateDateField(\''.$fn2.'\',\''.$date_code->d1.'\',
		'.$min_stay.',\''.$last_date.'\' ));
				(setDayName(\''.$fn2.'\',\''.$date_code->d1.'\'));
						(setDayName(\''.$fn.'\',\''.$date_code->d1.'\'));"';

$to_datepicker = JHTML::_( 'calendar', $enddate,'mod_valid_to','mod_valid_to',
		$date_code->d2, 'class="bookit_search_inputbox" size="8" '.$js2);

//==============================MULTI ROOM MODE=================================

if ($multiroom==1 || $multiroom == 2)
{

	$lists=array();
	//-----------SET CATEGORY DROP DOWN-----------------------------------------
	$res = ModBlookingHelper::getMaxMinGuests ();
	$min_max=$res;

	$options = array();
	for ($i=1; $i<9; $i++)
	{
		array_push($options, JHTML::_('select.option', $i, $i));
	}
	$js = 'onchange="(mod_updateGuestFields(this.value, '.$res->max_childs.'));"';
	$lists['rooms']  = JHTML::_('select.genericList', $options, 'mod_rooms',
			'class="bookit_search_rooms_dropbox"', 'value', 'text', 0);
	$lists = ModBlookingHelper::setGuestDropDowns ($lists, $res,
			$booking_session);


	//-----------SET ADULTS DROP DOWN-------------------------------------------
	$guests = "";
	for ($i=1; $i<9; $i++)
	{
		if ($i==1)
		{

			$guests .= $lists['mod_room'.$i.'_adults'];
		}
		else
		{

			$guests .= $lists['mod_room'.$i.'_adults'];
		}
	}

	$childs = "";
	for ($i=1; $i<9; $i++)
	{
		$childs .= $lists['mod_room'.$i.'_children'];
	}


	if ($template == '0') {
		require (JModuleHelper::getLayoutPath('mod_blooking','multiroom'));
	} else {
		require (JModuleHelper::getLayoutPath('mod_blooking','horizontal_multiroom'));
	}

}
//==============================SINGLE ROOM MODE================================
else
{

	//-----------RETRIEVE DATA FROM SESSION-------------------------------------
	if (empty($booking_session))
	{
		$startdate = date ($date_code->d1);
		$enddate = date($date_code->d1,strtotime("+ 1day"));
		$mod_idcategory = 0;
		$mod_nguests=0;
		$mod_nchilds=0;
	}
	else
	{
		$startdate = $booking_session['mod_valid_from'];
		$enddate = $booking_session['mod_valid_to'];
		$mod_idcategory = $booking_session['mod_idcategory'];
		$mod_nguests=$booking_session['mod_nguests'];
		if(isset($booking_session['mod_nchilds']))
			$mod_nchilds=$booking_session['mod_nchilds'];
		else
			$mod_nchilds=0;

	}


	$lists=array();
	//-----------SET CATEGORY DROP DOWN-----------------------------------------
	$options = array();
	$options = ModBlookingHelper::getCategoryOptions();

	if (count($options)>1)
	{
		$selectOne = JText::_("COM_BOOKIT_SELECT_ONE");
		$results[] = JHTML::_('select.option', 0, $selectOne);

		$results = array_merge( $results, $options);

		$lists['catid']  = JHTML::_('select.genericList', $results, 'mod_idcategory',
				'class="bookit_search_dropbox mod" size="1" ', 'value', 'text',
				$mod_idcategory);
	}
	else if (count($options)==1)
	{
		$lists['catid']  = JHTML::_('select.genericList', $options, 'mod_idcategory',
				'class="bookit_search_dropbox mod" size="1" ', 'value', 'text',
				$mod_idcategory);
	}
	else
	{
		$options[] = JHTML::_('select.option', 0, JText::_('COM_BOOKIT_NO_CATEGORIES'));
		$lists['catid']  = JHTML::_('select.genericList', $options, 'mod_idcategory',
				'class="bookit_search_dropbox" size="1" ');
	}

	//-----------SET ADULTS DROP DOWN-------------------------------------------
	$js = 'onchange="(mod_onGuestsChange());"';
	$result = ModBlookingHelper::oncategorychange ($mod_idcategory);
	$adult_options = array();
	foreach ($result->adults as $k=>$v)
	{
		array_push ($adult_options, JHTML::_('select.option', $k, $v));
	}

	$lists['nguests']  = JHTML::_('select.genericList', $adult_options, 'mod_nguests',
			'class="bookit_guest_dropbox" '.$js, 'value', 'text', $mod_nguests);
	//-----------SET CHILDREN DROP DOWN-----------------------------------------
	$children_options = array();
	foreach ($result->children as $k=>$v)
	{
		array_push ($children_options, JHTML::_('select.option', $k, $v));
	}
	$lists['nchilds']  = JHTML::_('select.genericList', $children_options, 'mod_nchilds',
			'class="bookit_guest_dropbox" '.$js, 'value', 'text', $mod_nchilds);


	//if ($template == '0') {
	require(JModuleHelper::getLayoutPath('mod_blooking','default'));
	//} else {
	//	require(JModuleHelper::getLayoutPath('mod_blooking','horizontal_single'));
	//}
}

//-----------SET TEMPLATE-------------------------------------------------------



?>