<?php
/**
 * BlooKing - The King in Joomla Booking
 * @version 1.0
 * @author BlooKing.org. Based on BooKiTGold code by Costas Kakousis
 * @copyright (C) 2012-2013 by BlooKing.org (http://www.blooking.org)
 * @license GNU/GPL: http://www.gnu.org/copyleft/gpl.html
 *
 * If you fork this to create your own project, please make a reference to
 * BlooKing! someplace in your code and provide a link to
 * http://www.blooking.org
 *
 * This file is part of BlooKing! BlooKing is free software: you can
 * redistribute it and/or modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * BlooKing is distributed in the hope that it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details. You should have received a copy of the GNU General Public License
 * along with BlooKing.  If not, see <http://www.gnu.org/licenses/>.
 *   ______ __                __  __ __
 *	|   __ \  |.-----..-----.|  |/  |__|.-----..-----.
 *	|   __ <  ||  _  ||  _  ||     <|  ||     ||  _  |
 *	|______/__||_____||_____||__|\__|__||__|__||___  |
 *                                             |_____|
 **/

// No direct access
defined('_JEXEC') or die('Restricted access');
$url = 'index.php';

//PHP STRINGS FOR JS
$monday = JText::_("Monday");
$tuesday = JText::_("Tuesday");
$wednesday = JText::_("Wednesday");
$thursday = JText::_("Thursday");
$friday = JText::_("Friday");
$saturday = JText::_("Saturday");
$sunday = JText::_("Sunday");
$no_category_error_str = JText::_('COM_BOOKIT_PLESE_SELECT_A_ROOM_TYPE');

$js = <<<EOD
window.addEvent('domready',function() {

var Browser = {
  Version: function() {
    var rv = 999;
    if (navigator.appName == 'Microsoft Internet Explorer')
   {
      var ua = navigator.userAgent;
      var re  = new RegExp("MSIE ([0-9]{1,}[\.0-9]{0,})");
      if (re.exec(ua) != null)
         rv = parseFloat( RegExp.$1 );
   }
   return rv;
  }
}

if (Browser.Version() <= 7) {
JSON.decode = function(string, secure){
  	  return jsonParse(string);
	};
}

var phpStrings = {
		Days : {  monday : "{$monday}", tuesday : "{$tuesday}",
			wednesday : "{$wednesday}", thursday : "{$thursday}",
        	friday : "{$friday}", saturday : "{$saturday}",
        	sunday : "{$sunday}" }
	};
new mod_init(phpStrings);

document.id('mod_bookit_search_button').addEvent('click',function(event){
		event.stop();

		if (document.id('mod_idcategory').value == 0)
		{
		 	document.id('mod_category_error_div').set('html','{$no_category_error_str}');
		 	return;
		}
		document.id('modBookingform').submit();
	});


	//-------UPDATE ROOM CATEGORY-----------

	  	var jsonCategReq = new Request.JSON({
		method: 'get',
		url: '',
		data: {},
		onRequest: function() {	},
		onFailure: function(xhr) {;},
		onSuccess: function(r) {

			if (typeof(r)!='undefined' && r!=null)
			{
				var adults_options = r.adults;
				var children_options = r.children;
				/* Remove all options from the select list */
				document.id('mod_nguests').empty();
				document.id('mod_nchilds').empty();
				/* Insert the new ones from the arrays above */
				var i=0;
				if (adults_options != "")
				{
					for (var key in adults_options)
					{ if (i==adults_options.length) break;
					if(i==0) document.id('mod_nguests').value = adults_options[key];
						i++;
						var opt = document.createElement('option');
						opt.text = adults_options[key];
        				opt.value = key;

        				var sel = document.id('mod_nguests');
        				var drop = sel.options;
						drop[drop.length] = new Option(opt.text,opt.value)
        				//document.id('mod_nguests').add(opt, null);

        			}
        			document.id('mod_bookit_adults_div').style.display = '';
      
      
        		}
        		else //Hide adults
        		{
        			document.id('mod_bookit_adults_div').style.display = 'none';
        			document.id('mod_nguests').value=0;
        		}
        		var i=0;
				if (children_options != "")
				{
					for (var key in children_options)
					{ if (i==children_options.length) break;
					if(i==0) document.id('mod_nchilds').value = children_options[key];
						i++;
						var opt = document.createElement('option');
						opt.text = children_options[key];
        				opt.value = key;

        				var sel = document.id('mod_nchilds');
        				var drop = sel.options;
						drop[drop.length] = new Option(opt.text,opt.value)
        				//document.id('mod_nchilds').add(opt, null);
        			}
        			document.id('mod_bookit_children_div').style.display = '';
      
        		}
        		else //Hide children
        		{
        			document.id('mod_bookit_children_div').style.display = 'none';
        			document.id('mod_nchilds').value=0;
        		}
			}
		},
		onError: function(text, error) {
			alert(error);
		}
	});


	document.id('mod_idcategory').addEvent('change',function(event){
		event.stop();
		jsonCategReq.get({'option':'com_blooking', 'task':'oncategorychange',
			'format':'json', 'view':'blooking', 'tmpl':'component',
			'idcategory':document.id('mod_idcategory').value});
	});
	if (document.id('mod_nchilds').length==0)
	{

		document.id('mod_bookit_children_div').style.display = 'none';
        document.id('mod_nchilds').value=0;
    }
    jsonCategReq.get({'option':'com_blooking', 'task':'oncategorychange',
			'format':'json', 'view':'blooking', 'tmpl':'component',
			'idcategory':document.id('mod_idcategory').value});

});
EOD;

$doc = & JFactory::getDocument();
$doc->addScriptDeclaration( $js );
?>

<form id="modBookingform"
	action="<?php echo JRoute::_( 'index.php?option=com_blooking');?>"
	name="modBookingform" method="post">

	<div class='blooking_mod_left'>
		<label for="valid_from" class="bookit_search_label"> <?php echo JText::_("COM_BOOKIT_CHECK_IN");?>
		</label>
	</div>

	<div class='blooking_mod_right'>
		<label for="valid_to" class="bookit_search_label"> <?php echo JText::_("COM_BOOKIT_CHECK_OUT")?>
		</label>
	</div>
	<div class="bookit_search_clear"></div>

	<div class='blooking_mod_left'>
		<?php echo $from_datepicker; ?>
	</div>
	<div class='blooking_mod_right'>
		<?php echo $to_datepicker;?>
	</div>

	<div class="bookit_search_clear"></div>



	<div id="mod_valid_from_day_div" class='blooking_mod_left'>
		<?php echo $from_day;?>
	</div>
	<div id="mod_valid_to_day_div" class='blooking_mod_right'>
		<?php echo $to_day;?>
	</div>
	<div class="bookit_search_clear"></div>

	<div class="bookit_search_clear"></div>
	<div id="mod_valid_to_error_div" class="bookit_search_error"
		style="display: none">
		<?php echo JText::_("COM_BOOKIT_LAST_DATE_ERROR")." ".$last_date;?>
	</div>
	<div class="bookit_search_clear"></div>

	<div id='mod_category_error_div' class='bookit_search_error'></div>
	<div id='blooking_mod_room_type_wrapper'>
		<div id='blooking_mod_room_type'>
			<?php echo JText::_("COM_BOOKIT_ROOM_TYPE"); ?>
		</div>
		<div class="bookit_search_clear"></div>

		<div>
			<?php 
			echo $lists['catid'];
			?>
		</div>
	</div>

	<div id='blooking_mod_guests_wrapper'>
		<div id="mod_bookit_adults_div">
			<div>
				<?php echo JText::_("COM_BOOKIT_ADULTS");?>
			</div>
			<div>
				<?php echo $lists['nguests'];?>
			</div>
		</div>

		<div id="mod_bookit_children_div">
			<div>
				<?php echo JText::_("COM_BOOKIT_CHILDREN");?>
			</div>
			<div>
				<?php echo $lists['nchilds'];?>
			</div>
		</div>
	</div>


	<div class="bookit_search_clear"></div>
	<div>
		<button class="bookit_button" id="mod_bookit_search_button">
			<?php echo JText::_('COM_BOOKIT_SEARCH'); ?>
		</button>

		<div id="mod_bookit_search_loading"></div>
	</div>

	<div class="bookit_search_clear"></div>

	<!-- Hidden helper fields -->
	<input type="hidden" id="mod_start_day" value=""></input> <input
		type="hidden" id="mod_end_day" value=""></input> <input type="hidden"
		name="task" value="displayModule"></input> <input type="hidden"
		name="option" value="com_blooking"></input> <input type="hidden"
		name="view" value="blooking"></input> <input type="hidden"
		name="controller" value="controller"></input> <input type="hidden"
		name="Itemid" value="<?php echo $itemID;?>"></input>
</form>
