<?php
/**
 * BlooKing - The King in Joomla Booking
 * @version 1.0
 * @author BlooKing.org. Based on BooKiTGold code by Costas Kakousis
 * @copyright (C) 2012-2013 by BlooKing.org (http://www.blooking.org)
 * @license GNU/GPL: http://www.gnu.org/copyleft/gpl.html
 *
 * If you fork this to create your own project, please make a reference to 
 * BlooKing! someplace in your code and provide a link to 
 * http://www.blooking.org
 *
 * This file is part of BlooKing! BlooKing is free software: you can 
 * redistribute it and/or modify it under the terms of the GNU General Public 
 * License as published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * BlooKing is distributed in the hope that it will be useful, but WITHOUT ANY 
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS 
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more 
 * details. You should have received a copy of the GNU General Public License
 * along with BlooKing.  If not, see <http://www.gnu.org/licenses/>.
 *   ______ __                __  __ __               
 *	|   __ \  |.-----..-----.|  |/  |__|.-----..-----.
 *	|   __ <  ||  _  ||  _  ||     <|  ||     ||  _  |
 *	|______/__||_____||_____||__|\__|__||__|__||___  |
 *                                             |_____|
 **/

defined('_JEXEC') or die('Restricted access');

jimport('joomla.plugin.plugin');

class plgSystemBlookingAsiapay extends JPlugin
{
	
	function plgSystemBlookingAsiapay (&$subject, $config)
	{
		parent::__construct($subject, $config);
		
	}
	
	function onMakeBookingBlookingasiapay($data)
	{
		$res = new stdClass ();
		$this->loadLanguage('plg_system_blookingasiapay', JPATH_ADMINISTRATOR);

		if ($data['deposit']<=0)
		{
			$res->msg = "<span class='error'>".JText::_('COM_BOOKIT_WRONG_AMOUNT')."</span>";
			$res->code = -1;
			return $res;
		} 
		//Get merchant details from plugin params
		$sandbox = $this->params->get('sandbox', 0);
		$merchantId = $this->params->get('merchantId', "");
		$currCode = $this->params->get('currCode', "978");
		$paymentType = $this->params->get('payType', "N");
		$lang = $this->params->get('lang', "E");
		$payMethod = $this->params->get('payMethod', "ALL");
		$orderRef=date('YmdHis');		
		$secureHashSecret=$this->params->get('hash', "");
		
		$secureHash=$this->generatePaymentSecureHash($merchantId, $orderRef, 
				$currCode, $data['deposit'], $paymentType, $secureHashSecret);
		
		if ($sandbox==1)
		{
			$link = 'https://test.siampay.com/b2c2/eng/payment/payForm.jsp';
		}
		else 
		{
			$link = 'https://www.siampay.com/b2c2/eng/payment/payForm.jsp';
			
		}
		
		$return_link = JURI::base()."index.php?option=com_blooking&lang=".$data['lang']."&controller=finalform&task=asiapaytransactionCompleted";
		
		$html = "<form name='payFormCcard' id='payFormCcard' method='post' action='".$link."'>";
		$html .= "<input type='hidden' name='merchantId' value='".$merchantId."'>";
		$html .= "<input type='hidden' name='amount' value='".$data['deposit']."' >";
		$html .= "<input type='hidden' name='orderRef' value='".$orderRef."'>";
		$html .= "<input type='hidden' name='currCode' value='".$currCode."'>";
		$html .= "<input type='hidden' name='successUrl' value='".$return_link."'>";
		$html .= "<input type='hidden' name='failUrl' value='".$return_link."'>";
		$html .= "<input type='hidden' name='cancelUrl' value='".$return_link."'>";
		$html .= "<input type='hidden' name='payType' value='".$paymentType."'>";
		$html .= "<input type='hidden' name='lang' value='".$lang."'>";
		$html .= "<input type='hidden' name='remark' id='bookingids' value=''>";
		$html .= "<input type='hidden' name='payMethod' value='".$payMethod."'>";
		$html .= "<input type='hidden' name='secureHash' value='".$secureHash."'>";
		$html .= "</form>";
		
				

		$res->msg = $html;
		$res->code = 1;
		
		return $res;
	}
	
	public function generatePaymentSecureHash($merchantId, $merchantReferenceNumber, $currencyCode, $amount, $paymentType, $secureHashSecret) {
	
		$buffer = $merchantId . '|' . $merchantReferenceNumber . '|' . $currencyCode . '|' . $amount . '|' . $paymentType . '|' . $secureHashSecret;
		//echo $buffer;
		return sha1($buffer);
	
	}
	
	public function verifyPaymentDatafeed($src, $prc, $successCode, $merchantReferenceNumber, $paydollarReferenceNumber, $currencyCode, $amount, $payerAuthenticationStatus, $secureHashSecret, $secureHash) {
	
		$buffer = $src . '|' . $prc . '|' . $successCode . '|' . $merchantReferenceNumber . '|' . $paydollarReferenceNumber . '|' . $currencyCode . '|' . $amount . '|' . $payerAuthenticationStatus . '|' . $secureHashSecret;
	
		$verifyData = sha1($buffer);
	
		if ($secureHash == $verifyData) {
			return true;
		}
	
		return false;
	
	}
}