<?php
/**
 * BlooKing - The King in Joomla Booking
 * @version 1.0
 * @author BlooKing.org. Based on BooKiTGold code by Costas Kakousis
 * @copyright (C) 2012-2013 by BlooKing.org (http://www.blooking.org)
 * @license GNU/GPL: http://www.gnu.org/copyleft/gpl.html
 *
 * If you fork this to create your own project, please make a reference to
 * BlooKing! someplace in your code and provide a link to
 * http://www.blooking.org
 *
 * This file is part of BlooKing! BlooKing is free software: you can
 * redistribute it and/or modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * BlooKing is distributed in the hope that it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details. You should have received a copy of the GNU General Public License
 * along with BlooKing.  If not, see <http://www.gnu.org/licenses/>.
 *   ______ __                __  __ __
 *	|   __ \  |.-----..-----.|  |/  |__|.-----..-----.
 *	|   __ <  ||  _  ||  _  ||     <|  ||     ||  _  |
 *	|______/__||_____||_____||__|\__|__||__|__||___  |
 *                                             |_____|
 **/

defined('_JEXEC') or die('Restricted access');

jimport('joomla.plugin.plugin');

class plgSystemBlookingPaypal extends JPlugin
{

	function plgSystemBlookingPaypal(&$subject, $config)
	{
		parent::__construct($subject, $config);

	}

	function onMakeBookingBlookingpaypal($data)
	{
		$res = new stdClass ();
		$this->loadLanguage('plg_system_blookingpaypal', JPATH_ADMINISTRATOR);

		if (floatval($data['deposit'])<=0)
		{
			$res->msg = "<span class='error'>".JText::_('COM_BOOKIT_WRONG_AMOUNT')."</span>";
			$res->code = -1;
			return $res;
		}
		$sandbox = $this->params->get('sandbox', 0);
		if ($sandbox==1)
		{
			$link = 'https://www.sandbox.paypal.com/cgi-bin/webscr';
		}
		else
		{
			$link = 'https://www.paypal.com/cgi-bin/webscr';
		}

		$item_name = $this->params->get('item_name', "");

		$return_link = JRoute::_(JURI::base()."index.php?option=com_blooking&lang=".$data['lang']."&controller=finalform&task=transactionCompleted");
		$html = "<form action='".$link."' method='post' target='_self' id='paypalForm' name='paypalForm'>";
		$html .= "<input type='hidden' name='cmd' value='_xclick'>";
		$html .= "<input type='hidden' name='business' value='".$this->params->get('paypal_mail','')."'>";
		$html .= "<input type='hidden' name='item_name' value='".$item_name."' >";
		$html .= "<input type='hidden' name='amount' value='".$data['deposit']."'>";
		$html .= "<input type='hidden' name='currency_code' value='".$data['currency']."'>";
		$html .= "<input type='hidden' name='button_subtype' value='services'>";
		$html .= "<input type='hidden' name='no_note' value='1'>";
		$html .= "<input type='hidden' name='no_shipping' value='2'>";
		$html .= "<input type='hidden' name='rm' value='1'>";
		$html .= "<input type='hidden' name='custom' id='bookingids' value=''>";
		$html .= "<input type='hidden' name='item_number' id='item_number' value=''>";
		$html .= "<input type='hidden' name='return' value='".$return_link."'>";
		$html .= "<input type='hidden' name='cancel_return' value='".$return_link."'>";
		$html .= "<input type='hidden' name='notify_url' value='".$return_link."'>";
		$html .= "<input type='hidden' name='charset' value='utf-8'>";
		$html .= "<input type='hidden' name='first_name' value='".$data['name']."'>";
		$html .= "<input type='hidden' name='last_name' value='".$data['surname']."'>";
		$html .= "<input type='hidden' name='email' value='".$data['email']."'>";
		$html .= "<input type='hidden' name='address1' value='".$data['address1']."'>";
		$html .= "<input type='hidden' name='address2' value='".$data['address2']."'>";
		$html .= "<input type='hidden' name='city' value='".$data['address3']."'>";
		$html .= "<input type='hidden' name='zip' value='".$data['postcode']."'>";
		//$html .= "<input type='hidden' name='paymentaction' value='authorization'>";
		$html .= "<input type='hidden' name='bn' value='PP-BuyNowBF:btn_paynowCC_LG.gif:NonHosted'>";
		$html .= "</form>";
		$res->msg = $html;
		$res->code = 1;

		return $res;
	}
}