<?php
/**
 * BlooKing - The King in Joomla Booking
 * @version 1.0
 * @author BlooKing.org. Based on BooKiTGold code by Costas Kakousis
 * @copyright (C) 2012-2013 by BlooKing.org (http://www.blooking.org)
 * @license GNU/GPL: http://www.gnu.org/copyleft/gpl.html
 *
 * If you fork this to create your own project, please make a reference to
 * BlooKing! someplace in your code and provide a link to
 * http://www.blooking.org
 *
 * This file is part of BlooKing! BlooKing is free software: you can
 * redistribute it and/or modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * BlooKing is distributed in the hope that it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details. You should have received a copy of the GNU General Public License
 * along with BlooKing.  If not, see <http://www.gnu.org/licenses/>.
 *   ______ __                __  __ __
 *	|   __ \  |.-----..-----.|  |/  |__|.-----..-----.
 *	|   __ <  ||  _  ||  _  ||     <|  ||     ||  _  |
 *	|______/__||_____||_____||__|\__|__||__|__||___  |
 *                                             |_____|
 **/
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport('joomla.application.component.controller');
class BlookingControllerBookingform extends BlookingController
{
	function __construct()
	{
		parent::__construct();
		$this->registerTask( 'bookingdefault'  , 	'bookingdefault' );
		$this->registerTask( 'blookingmod'  , 	'blookingmod' );
		JLoader::register('BlookingHelper',
		JPATH_COMPONENT_ADMINISTRATOR.'/helpers/BlookingHelper.php');
	}

	function bookingdefault()
	{
			
		$params = BlookingHelper::getParams();
		$multiroom = $params->multiroom;
		if (!$this->_checkSession($multiroom))
		{
			if ($multiroom==1 || $multiroom==2)
				$this->setRedirect(JRoute::_('index.php?option=com_blooking&task=expired&view=blooking_multiroom'),'');
			else $this->setRedirect(JRoute::_('index.php?option=com_blooking&task=expired&view=blooking'),'');
		}
		if ($multiroom==1 || $multiroom==2 )
		{
			$view = & $this->getView('bookingform_multiroom', 'html');
			$view->setModel( $this->getModel( 'bookingform' ), true );
			$view->display();
		}
		else
		{

			$view = & $this->getView('bookingform', 'html');
			$view->setModel( $this->getModel( 'bookingform' ), true );
			$view->display();
		}

			
	}

	function blookingmod()
	{
		$view =& $this->getView('blookingmod', 'html');
		$model =& $this->getModel ('blooking');
		$data = JRequest::get('post');
		if (empty($data))
		{

			$this->setRedirect(JRoute::_('index.php?option=com_blooking'),'');
			return;
		}
		$model->setData($data);
		$view->setModel($model,true);
		$view->display();
	}

	function couponvalidation ()
	{
		// Set the view and the model
		$view = JRequest::getVar( 'view', 'bookingform' );
		$format = JRequest::getVar( 'format', 'json' );
		$view =& $this->getView( $view, $format );
		$model =& $this->getModel( 'bookingform' );
		$view->setModel( $model, true );
		$view->display();
	}

	function _checkSession ($mode)
	{
		//Check that necessary data are set and get a session var
		$data =& JRequest::get('post');
		$session =& JFactory::getSession();

		if ($mode==0)//Single room mode
		{
			if (!isset($data['idcategory']) || $data['idcategory']<=0 ||
					!isset($data['nguests']) || $data['nguests']<=0 ||
					!isset($data['price']) || $data['price']<=0 ||
					!isset($data['valid_from']) ||!isset($data['valid_to']))
			{
				if(isset($_COOKIE['jsid'])) //Been here before
				{
					$session_data = $session->get('booking_session_'.$_COOKIE['jsid'],
							array());
					if (empty($session_data))
					{
						return false;
					}
					else
					{
						JRequest::set($session_data, 'post');
						return true;
					}

				}
				else
				{
					return false;
				}
			}

		}
		else if ($mode==1 || $mode==2)
		{
				
			$session =& JFactory::getSession();
			$rooms = $session->get('blooking_rooms', array());
			$data=array_merge($data, $rooms);


			if (!isset($rooms) || $rooms['room'][0]['idcategories']=="" ||
					$rooms['room'][0]['nguests']<=0 || $rooms['room'][0]['price']<=0 ||
					$rooms['room'][0]['rooms']<=0)
			{
				if(isset($_COOKIE['jsid'])) //Been here before
				{
					$session_data = $session->get('booking_session_'.$_COOKIE['jsid'],
							array());
					if (empty($session_data))
					{
						return false;
					}
					else
					{
						JRequest::set($session_data, 'post');
						return true;
					}

				}
				else
				{
					return false;
				}
			}
		}

		//Get session counter
		$cnt = BlookingHelper::getSessionCnt();
		JRequest::setVar('cnt', $cnt, 'get');
		JRequest::setVar('cnt',$cnt, 'post');
		$data['cnt']=$cnt;
		$session->set('booking_session_'.$cnt, $data);
		JRequest::set($data, 'post');
		setcookie('jsid', $cnt, time()+600);

		return true;
	}


}



