<?php
/**
 * BlooKing - The King in Joomla Booking
 * @version 1.0
 * @author BlooKing.org. Based on BooKiTGold code by Costas Kakousis
 * @copyright (C) 2012-2013 by BlooKing.org (http://www.blooking.org)
 * @license GNU/GPL: http://www.gnu.org/copyleft/gpl.html
 *
 * If you fork this to create your own project, please make a reference to
 * BlooKing! someplace in your code and provide a link to
 * http://www.blooking.org
 *
 * This file is part of BlooKing! BlooKing is free software: you can
 * redistribute it and/or modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * BlooKing is distributed in the hope that it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details. You should have received a copy of the GNU General Public License
 * along with BlooKing.  If not, see <http://www.gnu.org/licenses/>.
 *   ______ __                __  __ __
 *	|   __ \  |.-----..-----.|  |/  |__|.-----..-----.
 *	|   __ <  ||  _  ||  _  ||     <|  ||     ||  _  |
 *	|______/__||_____||_____||__|\__|__||__|__||___  |
 *                                             |_____|
 **/
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport('joomla.application.component.controller');
jimport( 'joomla.html.parameter' );

class BlookingControllerFinalform extends BlookingController {
	function __construct() {
		parent::__construct();
		$this->registerTask( 'finaldefault'  , 	'finaldefault' );
		$this->registerTask('cancelBooking', 'cancelBooking');
		$this->registerTask('getPaymentPluginCode', 'getPaymentPluginCode');
		$this->registerTask('transactionCompleted', 'transactionCompleted');
		$this->registerTask('cimbtransactionCompleted', 'cimbtransactionCompleted');
		$this->registerTask('egipsyTransactionCompleted', 'egipsyTransactionCompleted');
		JLoader::register('BlookingHelper',
		JPATH_COMPONENT_ADMINISTRATOR.'/helpers/BlookingHelper.php');

	}

	function finaldefault() {

		//Get payment plugins
		$data = JRequest::get('post');
		$data['payment_plugins'] =  $this->_getPaymentPlugins();
		JRequest::set($data, 'post');


		$params = BlookingHelper::getParams();
		$multiroom = $params->multiroom;
		if (!$this->_checkSession($multiroom))
		{
			if ($multiroom==1 || $multiroom==2)
				$this->setRedirect(JRoute::_('index.php?option=com_blooking&task=expired&view=blooking_multiroom'),'');
			else $this->setRedirect(JRoute::_('index.php?option=com_blooking&task=expired&view=blooking'),'');

		}
		if ($multiroom==1 || $multiroom==2 )
		{
			$view = & $this->getView('finalform_multiroom', 'html');
			$view->setModel( $this->getModel( 'finalform' ), true );
			$view->display();
		}
		else
		{
			$view = & $this->getView('finalform', 'html');
			$view->setModel( $this->getModel( 'finalform' ), true );
			$view->display();
		}

	}

	function _checkSession ($mode)
	{
		return true;
		$cnt = JRequest::getVar('cnt', 0);
		if ($cnt<=0 )
		{
			if (isset($_COOKIE['jsid']))
				$cnt=$_COOKIE['jsid'];
			else
				return false;
		}
		$session =& JFactory::getSession();
		$booking_session = $session->get('booking_session_'.$cnt,
				array());
		if (empty($booking_session)) return false;

		$session->set('booking_session_'.$cnt, array_merge($booking_session,
				JRequest::get('post')));
		JRequest::set(array_merge($booking_session,	JRequest::get('post')),
		'post');

		setcookie('jsid', $cnt, time()+600);
		return true;
	}

	function makeBooking ()
	{
		// Set the view and the model
		$view = JRequest::getVar( 'view', 'finalform' );
		$format = JRequest::getVar( 'format', 'json' );
		$view =& $this->getView( $view, $format );
		$model =& $this->getModel( 'finalform' );
		$view->setModel( $model, true );
			
		$posted_data = JRequest::get('post', JREQUEST_ALLOWHTML);
		$server = JRequest::get('server');
		$addr = $server["REMOTE_ADDR"];

		$captcha_res_code = 1;
		$captcha_msg="";
			
		if($posted_data['show_captcha']==1)
		{
			$captcha_result = $model->captchaValidation ($posted_data, $addr);
			$captcha_res_code = $captcha_result->code;
			$captcha_msg = $captcha_result->msg;
			//Create the booking
			if ($captcha_res_code > 0)
			{
				$booking_res_code = $model->makeBooking($posted_data);
			}
			else
			{
				$booking_res_code = 0;
			}
		}
		else
		{
			$booking_res_code = $model->makeBooking($posted_data);
		}
		$view->display($booking_res_code, $captcha_res_code, $captcha_msg);

	}

	function makeBookings ()
	{
		// Set the view and the model
		$view = JRequest::getVar( 'view', 'finalform_multiroom' );
		$format = JRequest::getVar( 'format', 'json' );
		$view =& $this->getView( $view, $format );
		$model =& $this->getModel( 'finalform' );
		$view->setModel( $model, true );
			
		$posted_data = JRequest::get('post', JREQUEST_ALLOWHTML);
		$server = JRequest::get('server');
		$addr = $server["REMOTE_ADDR"];

		$captcha_res_code = 1;
		$captcha_msg="";
			
		if($posted_data['show_captcha']==1)
		{
			$captcha_result = $model->captchaValidation ($posted_data, $addr);
			$captcha_res_code = $captcha_result->code;
			$captcha_msg = $captcha_result->msg;
			//Create the booking
			if ($captcha_res_code > 0)
			{
				$booking_res_code = $model->makeBookings($posted_data);
			}
			else
			{
				$booking_res_code = 0;
			}
		}
		else
		{
			$booking_res_code = $model->makeBookings($posted_data);
		}
		$view->display($booking_res_code, $captcha_res_code, $captcha_msg);

	}


	function cancelBooking () {
		$encrypted = JRequest::getVar('idbook');
		$cid = base64_decode($encrypted);
		$model = $this->getModel('finalform');
		$res="";

		$booking_ids = explode (",",$cid);

		foreach ($booking_ids as $cid) {
			if (intval ($cid) >0) {
				$result = $model->cancelBooking($cid);
			}

			if ($result == false) { //ADD TO LANG FILE
				echo "<p>".JText::_("COM_BOOKIT_FAILED_TO_CANCEL")."</p>";
				return;
			}
		}
		if ($result == true) {
			$res = JText::_("COM_BOOKIT_THANK_YOU_YOUR_BOOKING_HAS_BEEN_CANCELED");
			echo $res;

			//SEND EMAIL TO ADMIN FOR REFUND
			$mailer =& JFactory::getMailer();
			$config =& JFactory::getConfig();
			$sender = array($config->getValue( 'config.mailfrom' ),
					$config->getValue( 'config.fromname' ) );
			$mailer->addRecipient( $config->getValue( 'config.mailfrom' ));
			$subject = JText::_("COM_BOOKIT_BOOKING_CANCELLATION");
			$mailer->setSubject($subject);

			$body   = JText::_("COM_BOOKIT_BOOKING_REFERENCE").$cid.
			JText::_("COM_BOOKIT_BOOKING_HAS_BEEN CANCELLED")."/n".
			JText::_("COM_BOOKIT_BOOKING_PLEASE_CHECK")."/n /n".
			JText::_("COM_BOOKIT_BOOKING_REFUNDS_MUST_BE_DONE_MANUALLY");

			$mailer->setBody($body);
			$send =& $mailer->Send();
		}
	}
	function _getPaymentPlugins ()
	{
		$data = JRequest::get('post');
		$params = BlookingHelper::getParams();

		if ($params->admin_confirm==1 && $data['controller']=='finalform' ) {
			$plugins=null;
		} else {
			$plugins = array ();
			$wire_plugin =& JPluginHelper::getPlugin('system', 'blookingwire');
			if (!empty($wire_plugin))
				array_push($plugins, 'blookingwire');
			$paypal_plugin =& JPluginHelper::getPlugin('system', 'blookingpaypal');
			if (!empty($paypal_plugin))
				array_push($plugins, 'blookingpaypal');
			$asiapay_plugin =& JPluginHelper::getPlugin('system', 'blookingasiapay');
			if (!empty($asiapay_plugin))
				array_push($plugins, 'blookingasiapay');
			$cimb_plugin =& JPluginHelper::getPlugin('system', 'blookingcimb');
			if (!empty($cimb_plugin))
				array_push($plugins, 'blookingcimb');
			$egipsy_plugin =& JPluginHelper::getPlugin('system', 'blookingegipsy');
			if (!empty($egipsy_plugin))
				array_push($plugins, 'blookingegipsy');
			$ideal_plugin =& JPluginHelper::getPlugin('system', 'blookingideal');
			if (!empty($ideal_plugin))
				array_push($plugins, 'blookingideal');
			$sisow_plugin =& JPluginHelper::getPlugin('system', 'blookingsisow');
			if (!empty($sisow_plugin))
				array_push($plugins, 'blookingsisow');
			$robokassa_plugin =& JPluginHelper::getPlugin('system', 'blookingrobokassa');
			if (!empty($robokassa_plugin))
				array_push($plugins, 'blookingrobokassa');
			$cash_plugin =& JPluginHelper::getPlugin('system', 'blookingcash');
			if (!empty($cash_plugin))
				array_push($plugins, 'blookingcash');

			$plugins = implode(",",$plugins);
		}
		return $plugins;
	}
	function getPaymentPluginCode ()//To be called from default.php
	{
		$data = JRequest::get('post');
		$res = JPluginHelper::importPlugin( 'system' );
		$dispatcher =& JDispatcher::getInstance();

		$results = $dispatcher->trigger( 'onMakeBooking'.$data['type'],
				array($data) );
		$document =& JFactory::getDocument();
		$document->setMimeEncoding( 'application/json' );


		if (!empty($results))
		{
			$data['msg'] =  $results[0]->msg;
			$data['code'] =  $results[0]->code;
		}
		else {
			$data['msg'] = "";
			$data['code'] =  -1;
		}

		echo json_encode($data);

	}


	function bookingCompleted()
	{
		$params = BlookingHelper::getParams();
		$ok_url = $params->ok_url;
		$failure_url = $params->failure_url;
		$prebooking_url = $params->prebooking_url;
		$auto_confirm = $params->auto_confirm;

		if ($ok_url=="")
			$ok_url= JURI::base();
		if ($failure_url=="")
			$failure_url= JURI::base();
		if ($prebooking_url=="")
			$prebooking_url= JURI::base();
			
		$model = $this->getModel('finalform');
		$ids = JRequest::getVar('finalform_bookingids', '');

		$id = explode(",",$ids);
		$paymentRequested = $model->getPaymentRequested($id[0]);

		if ($params->auto_confirm==1)
		{


			if ($model->autoConfirmBookings($ids, 1))
			{
				$this->setRedirect(JRoute::_($ok_url),'');
				return;
			}
			else
			{
				$this->setRedirect(JRoute::_($failure_url),'');
				return;
			}
		}
		else
		{
			$model->autoConfirmBookings($ids, 2);
		}

		if ($params->admin_confirm == "1" && $paymentRequested=="0") {
			$this->setRedirect(JRoute::_($prebooking_url),'');
		} else {
			$this->setRedirect(JRoute::_($ok_url),'');
		}
		return;

	}

	//==================================PAYPAL==================================
	function transactionCompleted()
	{
		$params = BlookingHelper::getParams();
		$ok_url = $params->ok_url;
		$failure_url = $params->failure_url;
		if(version_compare(JVERSION,'1.6.0','ge'))
		{
			$plugin = JPluginHelper::getPlugin('system', 'blookingpaypal');
			$pluginParams = new JRegistry();
			$pluginParams->loadString($plugin->params);

		}
		else
		{
			$plugin = &JPluginHelper::getPlugin('system', 'blookingpaypal');
			$pluginParams = new JParameter($plugin->params);
		}

		$auth_token = $pluginParams->get('pdt_token', '');
		if ($pluginParams->get('sandbox', 0)==1)
		{
			$link ='ssl://www.sandbox.paypal.com';
			$noprefix = "www.sandbox.paypal.com";
		}
		else
		{
			$link ='ssl://www.paypal.com';
			$noprefix = "www.paypal.com";
		}

		if ($ok_url=="")
			$ok_url= JURI::base();
		if ($failure_url=="")
			$failure_url= JURI::base();
			
		$posted_data = JRequest::get('post');
		$get_data = JRequest::get('get');

		if (isset($get_data['tx'])) //pdt
		{

			// read the post from PayPal system and add 'cmd'
			$req = 'cmd=_notify-synch';

			$tx_token = $get_data['tx'];

			if ($auth_token=='')
			{
				JError::raiseWarning(500, 'Failed to complete the transaction: [002]' );
				$this->setRedirect(JRoute::_($failure_url),'');
				return;
			}

			$req .= "&tx=".$tx_token."&at=".$auth_token;

			// post back to PayPal system to validate
			$header = "POST /cgi-bin/webscr HTTP/1.0\r\n";
			$header .= "Content-Type: application/x-www-form-urlencoded\r\n";
			$header .= "Host: ".$noprefix."\r\n";
			$header .= "Content-Length: " . strlen($req) . "\r\n\r\n";
			$fp = fsockopen ($link, 443, $errno, $errstr, 30);

			if (!$fp) {// HTTP ERROR
			}
			else
			{
				fputs ($fp, $header . $req);
				// read the body data
				$res = '';
				$headerdone = false;
				while (!feof($fp))
				{
					$line = fgets ($fp, 1024);
					if (strcmp($line, "\r\n") == 0)
					{
						// read the header
						$headerdone = true;
					}
					else if ($headerdone)
					{
						// header has been read. now read the contents
						$res .= $line;
					}
				}
					
				// parse the data
				$lines = explode("\n", $res);
				$keyarray = array();

				if (strcmp ($lines[0], "SUCCESS") == 0)
				{
					for ($i=1; $i<count($lines)-1;$i++){
						list($key,$val) = explode("=", $lines[$i]);
						$keyarray[urldecode($key)] = urldecode($val);
					}


					$firstname = $keyarray['first_name'];
					$lastname = $keyarray['last_name'];
					$itemname = $keyarray['item_name'];
					$price = $keyarray['mc_gross'];
					if ($price==0)
						$price = $keyarray['payment_gross'];
					$ids = $keyarray['custom'];
					$txn_id = $keyarray['txn_id'];

					$model = $this->getModel('finalform');

					$res =  $model->confirmBookings($ids, $txn_id, $price);
					if($res)
					{
						$this->setRedirect(JRoute::_($ok_url),'');
						return;
					}
					else
					{
						JError::raiseWarning(500, 'Failed to complete the transaction: [003 '.$ids.']' );
						$this->setRedirect(JRoute::_($failure_url),'');
						return;
					}

				}
				else if (strcmp ($lines[0], "FAIL") == 0)
				{
					JError::raiseWarning(500, 'Failed to complete the transaction: [004]' );
					$this->setRedirect(JRoute::_($failure_url),'');
					return;
				}
					
			}
			fclose ($fp);
		}
		else if (isset($posted_data["txn_id"]) && $posted_data["txn_type"]) //IPN
		{
			// STEP 1: Read POST data

			// reading posted data from directly from $_POST causes serialization
			// issues with array data in POST
			// reading raw POST data from input stream instead.
			$raw_post_data = file_get_contents('php://input');
			$raw_post_array = explode('&', $raw_post_data);
			$myPost = array();
			foreach ($raw_post_array as $keyval) {
				$keyval = explode ('=', $keyval);
				if (count($keyval) == 2)
					$myPost[$keyval[0]] = urldecode($keyval[1]);
			}
			// read the post from PayPal system and add 'cmd'
			$req = 'cmd=_notify-validate';
			if(function_exists('get_magic_quotes_gpc')) {
				$get_magic_quotes_exists = true;
			}
			foreach ($myPost as $key => $value) {
				if($get_magic_quotes_exists == true && get_magic_quotes_gpc() == 1) {
					$value = urlencode(stripslashes($value));
				} else {
					$value = urlencode($value);
				}
				$req .= "&$key=$value";
			}



			// STEP 2: Post IPN data back to paypal to validate
			$ch = curl_init('https://www.paypal.com/cgi-bin/webscr');
			curl_setopt($ch, CURLOPT_HTTP_VERSION, CURL_HTTP_VERSION_1_1);
			curl_setopt($ch, CURLOPT_POST, 1);
			curl_setopt($ch, CURLOPT_RETURNTRANSFER,1);
			curl_setopt($ch, CURLOPT_POSTFIELDS, $req);
			curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 1);
			curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, 2);
			curl_setopt($ch, CURLOPT_FORBID_REUSE, 1);
			curl_setopt($ch, CURLOPT_HTTPHEADER, array('Connection: Close'));

			// In wamp like environments that do not come bundled with root authority certificates,
			// please download 'cacert.pem' from "http://curl.haxx.se/docs/caextract.html" and set the directory path
			// of the certificate as shown below.
			// curl_setopt($ch, CURLOPT_CAINFO, dirname(__FILE__) . '/cacert.pem');
			if( !($res = curl_exec($ch)) ) {
				// error_log("Got " . curl_error($ch) . " when processing IPN data");
				JError::raiseWarning(500, 'Failed to complete the transaction: [006]'.curl_error($ch) );
				curl_close($ch);
				exit;
			}
			curl_close($ch);
			if (strcmp ($res, "VERIFIED") == 0) {
				// check whether the payment_status is Completed
				// check that txn_id has not been previously processed
				// check that receiver_email is your Primary PayPal email
				// check that payment_amount/payment_currency are correct
				// process payment
					
				// assign posted variables to local variables
				$data['item_name']			= $posted_data['item_name'];
				$data['item_number'] 		= $posted_data['item_number'];
				$data['payment_status'] 	= $posted_data['payment_status'];
				$data['payment_amount'] 	= $posted_data['mc_gross'];
				$data['payment_currency']	= $posted_data['mc_currency'];
				$data['txn_id']				= $posted_data['txn_id'];
				$data['receiver_email'] 	= $posted_data['receiver_email'];
				$data['payer_email'] 		= $posted_data['payer_email'];
				$data['custom'] 			= $posted_data['custom'];
				$model = $this->getModel('finalform');
				if ($model->confirmBookings($data['custom'], $data['txn_id'],
						$data['payment_amount'])) {
					$this->setRedirect(JRoute::_($ok_url),'');
					return;
				}
					
			} else if (strcmp ($res, "INVALID") == 0) {
				JError::raiseWarning(500, 'Failed to complete the transaction: [006]' );
				$this->setRedirect(JRoute::_($failure_url),'');
				return;
			}


		}

		else
		{
			//JError::raiseWarning(500, 'Failed to complete the transaction: [005]' );
			$this->setRedirect(JRoute::_($failure_url),'');
			return;

		}

	}

	//==================================ASIAPAY=================================
	function asiapaytransactionCompleted()
	{

		$params = BlookingHelper::getParams();
		$ok_url = $params->ok_url;
		$failure_url = $params->failure_url;

		if ($ok_url=="")
			$ok_url= JURI::base();
		if ($failure_url=="")
			$failure_url= JURI::base();
			
		$posted_data = JRequest::get('post');
		$successcode = $posted_data['successcode'];
		$amt = $posted_data['Amt'];
		$ord = $posted_data['Ord'];
		$remark = $posted_data['remark'];

		if ('0'==$successcode) {
			$model = $this->getModel('finalform');
			$res =  $model->confirmBookings($remark, $ord, $amt);
			if($res)
			{
				$this->setRedirect(JRoute::_($ok_url),'');
				return;
			}
			else
			{
				$this->setRedirect(JRoute::_($failure_url),'');
				return;
			}

		} else {
			$this->setRedirect(JRoute::_($failure_url),'');
			return;

		}

	}
	//====================================CIMB==================================
	function cimbtransactionCompleted()
	{
		$params = BlookingHelper::getParams();
		$ok_url = $params->ok_url;
		$failure_url = $params->failure_url;
		$get_data = JRequest::get('get');
		if ( (isset($get_data['tranStatus']) && $get_data['tranStatus']=='S'))
		{
			if (isset($get_data['billReferenceNo3']))
			{
				$model = $this->getModel('finalform');
				$res =  $model->confirmBookings($get_data['billReferenceNo3'],
						$get_data['paymentRefNo'], $get_data['amount']);

				if($res)
				{
					$this->setRedirect(JRoute::_($ok_url),'');
					return;
				}
				else
				{
					$this->setRedirect(JRoute::_($failure_url),'');
					return;
				}
			}
		}
	}
	//===============================ROBOKASSA==================================
	function robokassaResultCheck() {
		$get_data = JRequest::get('post');
		$plugin = JPluginHelper::getPlugin('system', 'blookingrobokassa');
		$pluginParams = new JParameter( $plugin->params );
		$mrh_pass2 = $pluginParams->get('pass2', 'password_2');
		$fail = JRequest::getVar('fail');

		$out_summ = $get_data["OutSum"];
		$inv_id = $get_data["InvId"];
		$crc = $get_data["SignatureValue"];

		$crc = strtoupper($crc);
		$my_crc = strtoupper(md5("$out_summ:$inv_id:$mrh_pass2"));

		if ($my_crc !=$crc || $fail == "true") {
			echo "Signatures do not match or there has been an error.  Booking has not been processed\n";
			exit();
		} else {
			echo "OK".$inv_id;
			exit();
		}
	}

	function robokassaTransactionCompleted() {
		$params = BlookingHelper::getParams();
		$ok_url = $params->ok_url;
		$failure_url = $params->failure_url;
		$get_data = JRequest::get('post');
		$fail = JRequest::getVar('fail');
		$plugin = JPluginHelper::getPlugin('system', 'blookingrobokassa');
		$pluginParams = new JParameter( $plugin->params );
		$mrh_pass1 = $pluginParams->get('pass', 'password_2');

		$out_summ = $get_data["OutSum"];
		$inv_id = $get_data["InvId"];
		$crc = $get_data["SignatureValue"];
		$lang = $get_data["Culture"];

		$crc = strtoupper($crc);
		$my_crc = strtoupper(md5("$out_summ:$inv_id:$mrh_pass1"));

		$orderid = explode(",",$inv_id);

		foreach ($orderid as $i=>$value) {
			$orderid[$i] = $value - 1000;
		}

		$orderid = implode(",",$orderid);

		// Ã�Â¿Ã‘â‚¬Ã�Â¾Ã�Â²Ã�ÂµÃ‘â‚¬Ã�ÂºÃ�Â° Ã�ÂºÃ�Â¾Ã‘â‚¬Ã‘â‚¬Ã�ÂµÃ�ÂºÃ‘â€šÃ�Â½Ã�Â¾Ã‘ï¿½Ã‘â€šÃ�Â¸ Ã�Â¿Ã�Â¾Ã�Â´Ã�Â¿Ã�Â¸Ã‘ï¿½Ã�Â¸
		// check signature
		if ($my_crc !=$crc && $fail == "true") {
			$this->setRedirect(JRoute::_($failure_url."&lang=".$lang),'Signatures do not match.  Booking has not been processed');
			return;
		} else {
			$model = $this->getModel('finalform');
			$res =  $model->confirmBookings($orderid, $inv_id, $out_summ);

			if($res) {
				$this->setRedirect(JRoute::_($ok_url."&lang=".$lang),'');
				return;
			} else {
				$this->setRedirect(JRoute::_($failure_url."&lang=".$lang),'');
				return;
			}
		}
	}
	//====================================eGipsy================================
	function egipsyTransactionCompleted()
	{
		$params = BlookingHelper::getParams();
		$ok_url = $params->ok_url;
		$failure_url = $params->failure_url;

		if ($ok_url=="")
			$ok_url= JURI::base();
		if ($failure_url=="")
			$failure_url= JURI::base();
			
		$data = JRequest::get('get');
		$orderid = $data['ORDER_ID'];
		$transid = $data['TRANSACTION_ID'];
		$price = str_replace(',', '.',$data['IMPORTO']);
		$orderid = explode(",",$orderid);
		foreach ($orderid as $i=>$value) {
			$orderid[$i] = $value - 1000;
		}

		$orderid = implode(",",$orderid);

		if (isset($data['COD_AUT']) && $data['COD_AUT']!="00") {
			$model = $this->getModel('finalform');
			$res =  $model->confirmBookings($orderid, $transid, $price);

			if($res) {
				$this->setRedirect(JRoute::_($ok_url),'');
				return;
			} else {
				$this->setRedirect(JRoute::_($failure_url),'');
				return;
			}
		} else {
			$this->setRedirect(JRoute::_($failure_url),'');
			return;
		}
	}
	//====================================iDeal=================================
	function idealtransactionCompleted()
	{

		$params = BlookingHelper::getParams();
		$ok_url = $params->ok_url;
		$failure_url = $params->failure_url;
		$get_data = JRequest::get('get');


		if (isset($get_data['transaction_id']))
		{
			$model = $this->getModel('finalform');
			$plugin = JPluginHelper::getPlugin('system', 'blookingideal');
			$pluginParams = new JParameter( $plugin->params );
			$partner_id = $pluginParams->get('partner_id', '000000');
			$iDealTest = $pluginParams->get('ideal_test_mode', '0');

			if(version_compare(JVERSION,'1.6.0','ge')) {
				require_once(JPATH_SITE . DS . 'plugins' . DS . 'system' . DS . 'blookingideal' . DS .'ideal.class.php');
			} else {
				require_once(JPATH_SITE . DS . 'plugins' . DS . 'system' . DS . 'ideal.class.php');
			}

			$this->iDEAL = new iDEAL_Payment ($partner_id);
			if ($partner_id == "000000" || $iDealTest == "1" ) {
				$this->iDEAL->setTestMode();
			}

			$payment_details = $this->iDEAL->checkPayment($get_data['transaction_id']);

			if ($payment_details!=false) {

				if ($payment_details->status=="Success" ||
						$payment_details->status=="CheckedBefore") {
					$model->confirmBookings($get_data['idbook'],
							$get_data['transaction_id'],
							$payment_details->amount/100);
					$this->setRedirect(JRoute::_($ok_url),'');
					return;
				}
				else {
						
					$this->setRedirect(JRoute::_($failure_url),'');
					return;
				}
			}
		}

	}

	function sisowtransactionCompleted()
	{
		$params = BlookingHelper::getParams();
		$ok_url = $params->ok_url;
		$failure_url = $params->failure_url;
		$get_data = JRequest::get('get');
		$model = $this->getModel('finalform');

		$plugin = JPluginHelper::getPlugin('system', 'blookingsisow');
		$pluginParams = new JParameter( $plugin->params );
		$partner_id = $pluginParams->get('partner_id', '000000');
		$partner_key = $pluginParams->get('merchant_key', '');
		$iDealTest = $pluginParams->get('ideal_test_mode', '0');

		$bookingids = explode(",",$get_data['idbook']);
		foreach ($bookingids as $i) {
			$ids[] = $i - 1000;
		}
		$bookingids = implode($ids,",");

		if(version_compare(JVERSION,'1.6.0','ge')) {
			require_once(JPATH_SITE . DS . 'plugins' . DS . 'system' . DS . 'blookingsisow' . DS .'sisow.class.php');
		} else {
			require_once(JPATH_SITE . DS . 'plugins' . DS . 'system' . DS . 'sisow.class.php');
		}
			
		$this->iDEAL = new iDEAL_Payment ($partner_id, $partner_key);
		if ($partner_id == "000000" || $iDealTest == "1" ) {
			$this->iDEAL->setTestMode();
		}

		if (isset($get_data['trxid']) && $get_data['trxid']!="") {
			$payment_details = $this->iDEAL->checkPayment($get_data['trxid']);

			if ($payment_details->transaction->status == "Success") {
				$model->confirmBookings($bookingids, $get_data['trxid'], $get_data['amount']);
			} else if ($payment_details->transaction->status == "Cancelled") {
				$model->ipnCancelBookings($bookingids, $get_data['trxid']);
			} else if ($payment_details->transaction->status == "Expired") {
				$model->ipnExpireBookings($bookingids, $get_data['trxid']);
			}
		} else {
			if ($get_data['status'] == "Cancelled") {
				$model->ipnCancelBookings($bookingids, $get_data['trxid']);
			} else if ($get_data['status'] == "Expired") {
				$model->ipnExpireBookings($bookingids, $get_data['trxid']);
			}
		}

		$ids = explode(",", $bookingids);
		if($model->isBookingOk($ids[0])) {
			$this->setRedirect(JRoute::_($ok_url),'');
			return;
		} else {
			$this->setRedirect(JRoute::_($failure_url),'');
			return;
		}
	}

	function gatewayRedirect ()
	{
		$data = JRequest::get('post');
		$res = JPluginHelper::importPlugin( 'system' );
		$dispatcher =& JDispatcher::getInstance();
		$res = $dispatcher->trigger( 'onClickBooking'.$data['type'],
				array($data) );


		$document =& JFactory::getDocument();
		// Set the MIME type for JSON output.
		$document->setMimeEncoding( 'application/json' );

		echo json_encode( $res );

	}

}