﻿<?php
/**
 * BlooKing - The King in Joomla Booking
 * @version 1.0
 * @author BlooKing.org. Based on BooKiTGold code by Costas Kakousis
 * @copyright (C) 2012-2013 by BlooKing.org (http://www.blooking.org)
 * @license GNU/GPL: http://www.gnu.org/copyleft/gpl.html
 *
 * If you fork this to create your own project, please make a reference to
 * BlooKing! someplace in your code and provide a link to
 * http://www.blooking.org
 *
 * This file is part of BlooKing! BlooKing is free software: you can
 * redistribute it and/or modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * BlooKing is distributed in the hope that it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details. You should have received a copy of the GNU General Public License
 * along with BlooKing.  If not, see <http://www.gnu.org/licenses/>.
 *   ______ __                __  __ __
 *	|   __ \  |.-----..-----.|  |/  |__|.-----..-----.
 *	|   __ <  ||  _  ||  _  ||     <|  ||     ||  _  |
 *	|______/__||_____||_____||__|\__|__||__|__||___  |
 *                                             |_____|
 **/
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport('joomla.application.component.controller');
jimport( 'joomla.html.parameter' );

class BlookingControllerPayment extends BlookingController {
	function __construct() {
		parent::__construct();

		JLoader::register('BlookingHelper',
		JPATH_COMPONENT_ADMINISTRATOR.'/helpers/BlookingHelper.php');

	}

	function display(){
		$data = JRequest::get('post');
		$data['payment_plugins'] =  $this->_getPaymentPlugins();
		JRequest::set($data, 'post');

		$view = & $this->getView('payment', 'html');
		$view->setModel( $this->getModel( 'finalform' ), true );
		$view->display();
	}

	function _getPaymentPlugins ()
	{
		$data = JRequest::get('post');
		$params = BlookingHelper::getParams();

		//if ($params->admin_confirm==1 && $data['controller']=='finalform' ) {
		//	$plugins=null;
		//} else {
		$plugins = array ();
		$wire_plugin =& JPluginHelper::getPlugin('system', 'blookingwire');
		if (!empty($wire_plugin))
			array_push($plugins, 'blookingwire');
		$paypal_plugin =& JPluginHelper::getPlugin('system', 'blookingpaypal');
		if (!empty($paypal_plugin))
			array_push($plugins, 'blookingpaypal');
		$asiapay_plugin =& JPluginHelper::getPlugin('system', 'blookingasiapay');
		if (!empty($asiapay_plugin))
			array_push($plugins, 'blookingasiapay');
		$cimb_plugin =& JPluginHelper::getPlugin('system', 'blookingcimb');
		if (!empty($cimb_plugin))
			array_push($plugins, 'blookingcimb');
		$egipsy_plugin =& JPluginHelper::getPlugin('system', 'blookingegipsy');
		if (!empty($egipsy_plugin))
			array_push($plugins, 'blookingegipsy');
		$ideal_plugin =& JPluginHelper::getPlugin('system', 'blookingideal');
		if (!empty($ideal_plugin))
			array_push($plugins, 'blookingideal');
		$sisow_plugin =& JPluginHelper::getPlugin('system', 'blookingsisow');
		if (!empty($sisow_plugin))
			array_push($plugins, 'blookingsisow');
		$robokassa_plugin =& JPluginHelper::getPlugin('system', 'blookingrobokassa');
		if (!empty($robokassa_plugin))
			array_push($plugins, 'blookingrobokassa');
		$cash_plugin =& JPluginHelper::getPlugin('system', 'blookingcash');
		if (!empty($cash_plugin))
			array_push($plugins, 'blookingcash');

		$plugins = implode(",",$plugins);
		//}
		return $plugins;
	}
	function getPaymentPluginCode ()//To be called from default.php
	{

		$data = JRequest::get('post');


		$model = $this->getModel('finalform');
		$booking_details =  $model->getBookingDetails($data['id']);

        $params = BlookingHelper::getParams();
        $db = JFactory::getDbo();
        $query =  "SELECT * FROM ".
            $db->nameQuote("#__bookitbooking")." WHERE ".
            $db->nameQuote("idbook")." = ".$db->quote($data['id']);
        $db->setQuery( $query );
        $bo = $db->loadObject();
        if ($params->deposit_percent > 0) {
            $data['deposit'] = number_format(($bo->value_full / 100)*$params->deposit_percent,2, '.','');
        } else {
            $data['deposit'] = number_format($params->deposit_fixed,2, '.','');
        }

        $data = array_merge($data,$booking_details);
		JRequest::set($data, 'post');

		$res = JPluginHelper::importPlugin( 'system' );
		$dispatcher =& JDispatcher::getInstance();


		$results = $dispatcher->trigger( 'onMakeBooking'.$data['type'],
				array($data) );
				

		$document =& JFactory::getDocument();
		$document->setMimeEncoding( 'application/json' );


		if (!empty($results))
		{
			$data['msg'] =  $results[0]->msg;
			$data['code'] =  $results[0]->code;
		}
		else {
			$data['msg'] = "";
			$data['code'] =  -1;
		}

		echo json_encode($data);

	}

	function adminConfirmBookings() {
		$data = JRequest::get('post');
		$view = JRequest::getVar( 'view', 'payment' );
		$format = JRequest::getVar( 'format', 'json' );
		$view =& $this->getView( $view, $format );
		$model = $this->getModel('finalform');

		$server = JRequest::get('server');
		$addr = $server["REMOTE_ADDR"];

		$model->updatePaymentMethod($data['id'], $data['payment_method']);
		$view->display($data['id'], "1", "");
	}
}