/**
 * BlooKing - The King in Joomla Booking
 * @version 1.0
 * @author BlooKing.org. Based on BooKiTGold code by Costas Kakousis
 * @copyright (C) 2012-2013 by BlooKing.org (http://www.blooking.org)
 * @license GNU/GPL: http://www.gnu.org/copyleft/gpl.html
 *
 * If you fork this to create your own project, please make a reference to 
 * BlooKing! someplace in your code and provide a link to 
 * http://www.blooking.org
 *
 * This file is part of BlooKing! BlooKing is free software: you can 
 * redistribute it and/or modify it under the terms of the GNU General Public 
 * License as published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * BlooKing is distributed in the hope that it will be useful, but WITHOUT ANY 
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS 
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more 
 * details. You should have received a copy of the GNU General Public License
 * along with BlooKing.  If not, see <http://www.gnu.org/licenses/>.
 *   ______ __                __  __ __               
 *	|   __ \  |.-----..-----.|  |/  |__|.-----..-----.
 *	|   __ <  ||  _  ||  _  ||     <|  ||     ||  _  |
 *	|______/__||_____||_____||__|\__|__||__|__||___  |
 *                                             |_____|
 **/
function editTotal (extra, box_id, curr, multi, depo, isFixed)
{
	//multi format: extrabox_idextra_roomno=value and qntbox_idextra_roomno
	//single format:extrabox_idextra=value and qntbox_idextra
	var r = box_id.split("_");
	var qnt_box_id="";
	if (multi==1)
		qnt_box_id = "qntbox_"+r[1]+"_"+r[2];
	else
		qnt_box_id = "qntbox_"+r[1];

	var total=document.id('bookit_booking_total').innerHTML;
	//Remove the commas
	var total=total.replace(/,/g,'');    
	total=parseFloat(total);

	var box_element = document.id(box_id.toString());
	if (!isNaN(total))
	{
		if (box_element.checked)
		{
			if (document.id(qnt_box_id)!=null)
			{

				var v = parseFloat(total+extra*document.id(qnt_box_id).value);
				var x = new Number(v);
				newTotal = x.toFixed(2);
			}
			else
			{
				var v = parseFloat(extra);
				v =v+total;
				var x = new Number(v);
				newTotal = x.toFixed(2);
			}
			document.id('bookit_booking_total').innerHTML=newTotal+" "+curr;
			if (depo>0)
			{
				newTotal=newTotal.replace(/,/g,'');
				newTotal = parseFloat (newTotal);
				if (isFixed==0)
					newDeposit = (newTotal*depo/100).toFixed(2);
				else
					newDeposit = parseFloat(depo).toFixed(2);
				document.id('bookit_booking_deposit').innerHTML=newDeposit+" "+curr;
			}

		}
		else
		{
			if (document.id(qnt_box_id)!=null)
			{
				var v = parseFloat(total-extra*document.id(qnt_box_id).value);
				var x = new Number(v);
				newTotal = x.toFixed(2);
			}
			else
			{
				var v = parseFloat(extra);
				v =total-v;
				var x = new Number(v);
				newTotal = x.toFixed(2);
			}
			document.id('bookit_booking_total').innerHTML=newTotal+" "+curr;
			if (depo>0)
			{
				newTotal=newTotal.replace(/,/g,'');
				newTotal = parseFloat (newTotal);
				if (isFixed==0)
					newDeposit = (newTotal*depo/100).toFixed(2);
				else
					newDeposit = parseFloat(depo).toFixed(2);
				document.id('bookit_booking_deposit').innerHTML=newDeposit+" "+curr;
			}
		}	
	}
}

function applyCoupon (discount, curr, depo, isFixed)
{
	var total=document.id('bookit_booking_total').innerHTML;
	newTotal = parseFloat (total) - parseFloat(discount);
	document.id('bookit_booking_total').innerHTML=newTotal+" "+curr;
	if (depo>0)
	{
		if (isFixed==0)
			newDeposit = (newTotal*depo/100).toFixed(2);
		else
			newDeposit = parseFloat(depo).toFixed(2);
		document.id('bookit_booking_deposit').innerHTML=newDeposit+" "+curr;
	}

}

function checkTerms (multi) 
{

	var price_js = document.getElementById('bookit_booking_total').innerHTML;
	price_js=price_js.replace(/,/g,'');
	price_js = parseFloat (price_js);

	if (document.getElementById('bookit_booking_deposit')!=null)
	{
		var deposit_js = document.getElementById('bookit_booking_deposit').innerHTML;
		deposit_js=deposit_js.replace(/,/g,'');
		deposit_js = parseFloat (deposit_js);
	}
	else
		var deposit_js = 0;
	document.id('price').value=price_js;
	document.id('deposit').value=deposit_js;

	//Create the extra_ids chain
	var elements = document.bookingForm.elements;
	if (multi=="0")
		document.id('extra_ids').value=getExtraIdsSingle ();
	else
		document.id('extra_ids').value=getExtraIds();

	if (document.id('accept_checkbox')!=null)
	{
		document.id('accept_error').style.display="none";
		if (!document.id('accept_checkbox').checked)
		{
			document.id('accept_error').style.display="inline";
			return false;
		}
	}
	
	document.bookingForm.submit();
	return true;	
}


function setQuantityOnly (mode,qnt_box_id ){

	var curVal=parseInt(document.id(qnt_box_id.toString()).value);
	if (mode=="plus")
	{
		document.id(qnt_box_id.toString()).value= curVal+1;
	}
	else if (mode=="minus")
	{
		if (curVal>1)
		{
			document.id(qnt_box_id.toString()).value= curVal-1;
		}
	}
	return false;
}


function setQuantity (extra, mode, qnt_box_id, curr, multi,  depo, isFixed)
{
	var curVal=parseInt(document.id(qnt_box_id.toString()).value);

	var r = qnt_box_id.split("_");
	var box_id="";
	if (multi==1)
		box_id = "extrabox_"+r[1]+"_"+r[2];
	else
		box_id = "extrabox_"+r[1];

	var box_element = document.id(box_id.toString());
	var total=document.id('bookit_booking_total').innerHTML;
	total=total.replace(/,/g,'');  
	total=parseFloat(total);

	if (mode=="plus")
	{
		document.id(qnt_box_id.toString()).value= curVal+1;
		if (box_element.checked)
		{
			var x = new Number(total+extra);
			newTotal = x.toFixed(2);

			document.id('bookit_booking_total').innerHTML=newTotal+" "+curr;
			if (depo>0)
			{
				newTotal=newTotal.replace(/,/g,'');
				newTotal = parseFloat (newTotal);
				if (isFixed==0)
					newDeposit = (newTotal*depo/100).toFixed(2);
				else
					newDeposit = parseFloat(depo).toFixed(2);
				document.id('bookit_booking_deposit').innerHTML=newDeposit+" "+curr;
			}
		}
	}
	else if (mode=="minus")
	{
		if (curVal>1)
		{
			document.id(qnt_box_id.toString()).value= curVal-1;
			if (box_element.checked)
			{
				var x = new Number(total-extra);
				newTotal = x.toFixed(2);
				document.id('bookit_booking_total').innerHTML=newTotal+" "+curr;
				if (depo>0)
				{
					//remove commas
					newTotal=newTotal.replace(/,/g,'');
					newTotal = parseFloat (newTotal);
					if (isFixed==0)
						newDeposit = (newTotal*depo/100).toFixed(2);
					else
						newDeposit = depo.toFixed(2);

					document.id('bookit_booking_deposit').innerHTML=newDeposit+" "+curr;
				}
			}
		}
	}
	return false;
}
function getExtraIdsSingle ()
{
	var elements = document.bookingForm.elements;
	var extras=[];
	var elementid="";
	var r, rr;
	for (i = 0; i < elements.length; i++)
	{
		if ( (elements[i].type=="checkbox" && elements[i].checked  && 
				(elements[i].id.indexOf("prefbox_")!=-1 ||
						elements[i].id.indexOf("extrabox_")!=-1) ) )
		{

			extraObj = new Object;

			r = elements[i].id.split("_");
			extraObj.idextra = r[1].split("=")[0];
			if (r[1].split("=")[1]!=null)
				extraObj.value = r[1].split("=")[1];
			else
				extraObj.value = 0;

			if (r[0]=="extrabox")
			{
				elementid = "qntbox_"+r[1];
				if (document.id(elementid)!=null)	
				{
					extraObj.qnt = document.id(elementid).value;
				}
				else
				{
					extraObj.qnt = 0;
				}
			}
			else //preference
			{
				elementid = "qntprefbox_"+r[1];
				if (document.id(elementid)!=null)	
				{
					extraObj.qnt = document.id(elementid).value;
				}
				else
				{
					extraObj.qnt = 0;
				}
			}
			extras.push(extraObj);
			//alert (JSON.stringify(extras));
		}


	}
	return JSON.stringify(extras);
}
function getExtraIds()
{
	//multi format: extrabox_idextra_roomno=value and qntbox_idextra_roomno
	var elements = document.bookingForm.elements;
	var extras=[];
	var elementid="";
	var r, rr;
	for (var i = 0; i < elements.length; i++)
	{
		if ( (elements[i].type=="checkbox" && elements[i].checked  && 
				(elements[i].id.indexOf("prefbox_")!=-1 ||
						elements[i].id.indexOf("extrabox_")!=-1) ) ||
						(elements[i].type=="textarea" &&  elements[i].value!="" &&
								elements[i].id.indexOf("preferences_")!=-1))
		{
			extraObj = new Object;
			
			if (elements[i].type=="textarea")
			{
				r = elements[i].id.split("_");
				extraObj.idroom = r[1];
				extraObj.preferences = elements[i].value.replace(/\n\r?/g, ' ');
				extraObj.idextra=0;
				extraObj.value=0;
				extraObj.qnt = 0;
				extras.push(extraObj);
			}
			else
			{
				//multi format: extrabox_idextra_roomno=value and qntbox_idextra_roomno
				
				r = elements[i].id.split("_");
				
				extraObj.idroom = r[2].split("=")[0];
				if (r[2].split("=")[1]!=null)
					extraObj.value = r[2].split("=")[1];
				else
					extraObj.value = 0;
				
				extraObj.preferences = "";
				extraObj.idextra = r[1];

				if (r[0]=="extrabox")
				{
					elementid = "qntbox_"+r[1]+"_"+r[2];
					if (document.id(elementid)!=null)	
					{
						extraObj.qnt = document.id(elementid).value;
						
					}
					else
					{
						extraObj.qnt = 0;
					}
				}
				else //preference
				{
					elementid = "qntprefbox_"+r[1]+"_"+r[2];
					if (document.id(elementid)!=null)	
					{
						extraObj.qnt = document.id(elementid).value;
					}
					else
					{
						extraObj.qnt = 0;
					}
				}
				extras.push(extraObj);
				//alert (JSON.stringify(extras));
			}
		}

	}
	return JSON.stringify(extras);
}

/** SQEEZE BOX **/
function showBox()
{		
	
	var boxText = window.tc+"<br/>"+window.cp;
		
	var options = {size: {x: 300, y: 250}};
	SqueezeBox.initialize(options);
	SqueezeBox.setContent('string',boxText);

}
