/**
 * BlooKing - The King in Joomla Booking
 * @version 1.0
 * @author BlooKing.org. Based on BooKiTGold code by Costas Kakousis
 * @copyright (C) 2012-2013 by BlooKing.org (http://www.blooking.org)
 * @license GNU/GPL: http://www.gnu.org/copyleft/gpl.html
 *
 * If you fork this to create your own project, please make a reference to 
 * BlooKing! someplace in your code and provide a link to 
 * http://www.blooking.org
 *
 * This file is part of BlooKing! BlooKing is free software: you can 
 * redistribute it and/or modify it under the terms of the GNU General Public 
 * License as published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * BlooKing is distributed in the hope that it will be useful, but WITHOUT ANY 
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS 
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more 
 * details. You should have received a copy of the GNU General Public License
 * along with BlooKing.  If not, see <http://www.gnu.org/licenses/>.
 *   ______ __                __  __ __               
 *	|   __ \  |.-----..-----.|  |/  |__|.-----..-----.
 *	|   __ <  ||  _  ||  _  ||     <|  ||     ||  _  |
 *	|______/__||_____||_____||__|\__|__||__|__||___  |
 *                                             |_____|
 **/
function formValidation (surname, address, postcode, phone, payment)
{

	var res=true;
	//First Name*
	//Please enter your first name.
	var nameField = document.id('fname');
	var nameErrorDiv = document.id('bookit_final_fname_right_error');
	nameErrorDiv.style.display="none";

	if (surname==1)
	{
		//Last Name*
		//Please enter your last name.
		var surnameField = document.id('surname');
		var surnameErrorDiv = document.id('bookit_final_lname_right_error');
		surnameErrorDiv.style.display="none";
	}

	//Email Address*
	//Please enter your email address.
	var emailField = document.id('bookit_email');
	var emailErrorDiv = document.id('bookit_final_email_right_error');
	var emailInvalidErrorDiv = document.id('bookit_final_email_invalid_right_error');
	emailErrorDiv.style.display="none";
	emailInvalidErrorDiv.style.display="none";

	//Confirm Email Address*
	//Please confirm your email address.
	var cemailField = document.id('cemail');
	var cemailErrorDiv = document.id('bookit_final_cemail_right_error');
	var cemailInvalidErrorDiv = document.id('bookit_final_cemail_invalid_right_error');
	cemailErrorDiv.style.display="none";
	cemailInvalidErrorDiv.style.display="none";

	//Phone*
	//Please enter your phone number.
	if (phone==1)
	{
		var phoneField = document.getElementById('phone');
		var phoneErrorDiv = document.getElementById('bookit_final_phone_right_error');
		var phoneInvalidErrorDiv = document.getElementById('bookit_final_phone_invalid_right_error');
		phoneErrorDiv.style.display="none";
		phoneInvalidErrorDiv.style.display="none";
	}


	//Street Address*
	//Please enter your address.
	if (address==1)
	{
		var addrField1 = document.id('address1');
		var addrField2 = document.id('address2');
		var addrField3 = document.id('address3');

		var addrErrorDiv = document.id('bookit_final_addr_right_error');
		addrErrorDiv.style.display="none";

		//Country*
		//Please select your country.
		var countryField = document.id('idcountry');
		var countryErrorDiv = document.id('bookit_final_country_right_error');
		countryErrorDiv.style.display="none";
	}
	
	if (postcode==1)
	{
		//Postcode*
		//Please select your postcode.
		var postcodeField = document.id('postcode');
		var postcodeErrorDiv = document.id('bookit_final_postcode_right_error');
		postcodeErrorDiv.style.display="none";

	}


	if (nameField.value=="")
	{
		nameErrorDiv.style.display="inline";
		res=false;
	}

	if (surname==1)
	{
		if (surnameField.value=="")
		{	
			surnameErrorDiv.style.display="inline";
			res=false;
		}
	}

	if (emailField.value=="")
	{	
		emailErrorDiv.style.display="inline";
		res=false;
	}
	else if (!isValidEmail())
	{
		emailInvalidErrorDiv.style.display="inline";
		res=false;
	}	
	if (cemailField.value=="")
	{
		cemailErrorDiv.style.display="inline";
		res=false;
	}
	else if (cemailField.value!=emailField.value)
	{	
		cemailInvalidErrorDiv.style.display="inline";
		res=false;
	}

	if (phone==1)
	{
		if (phoneField.value=="")
		{
			phoneErrorDiv.style.display="inline";
			res=false;
		}
		else if (!isValidPhoneNumber())
		{
			phoneInvalidErrorDiv.style.display="inline";
			res=false;
		}
	}

	if (address==1)
	{
		if (addrField1.value=="")
		{
			addrErrorDiv.style.display="inline";
			res=false;
		}
		if (countryField.value=="0")
		{
			countryErrorDiv.style.display="inline";
			res=false;
		}
		
	}
	if (postcode==1)
	{

		//var regex = new RegExp(/^[0-9]{4,4}$/);
		if (postcodeField.value=="" /*|| regex.test(postcodeField.value)==false*/)
		{
			postcodeErrorDiv.style.display="inline";
			res=false;
		}
		
	}

	if (!validatePayment(payment))
		res=false;

	return res;

}

function validatePayment(payment)
{
	var res = true;
	return res;
}



function isValidEmail ()
{
	var address = document.getElementById("bookit_email").value;
	var reg = /^([A-Za-z0-9_\-\.])+\@([A-Za-z0-9_\-\.])+\.([A-Za-z]{2,4})$/;
	if(reg.test(address) == false) 
	{
		return false;
	}
	else
	{
		return true;
	}

}


//Declaring required variables
var digits = "0123456789";
var phoneNumberDelimiters = "()- ";
var validWorldPhoneChars = phoneNumberDelimiters + "+";
//Minimum no of digits in an international phone no.
var minDigitsInIPhoneNumber = 6;

function isInteger(s)
{   var i;
for (i = 0; i < s.length; i++)
{   
	// Check that current character is number.
	var c = s.charAt(i);
	if (((c < "0") || (c > "9"))) return false;
}
// All characters are numbers.
return true;
}
function trim(s)
{   var i;
var returnString = "";
// Search through string's characters one by one.
// If character is not a whitespace, append to returnString.
for (i = 0; i < s.length; i++)
{   
	// Check that current character isn't whitespace.
	var c = s.charAt(i);
	if (c != " ") returnString += c;
}
return returnString;
}
function stripCharsInBag(s, bag)
{   var i;
var returnString = "";
// Search through string's characters one by one.
// If character is not in bag, append to returnString.
for (i = 0; i < s.length; i++)
{   
	// Check that current character isn't whitespace.
	var c = s.charAt(i);
	if (bag.indexOf(c) == -1) returnString += c;
}
return returnString;
}

function checkInternationalPhone(strPhone){
	var bracket=3;
	strPhone=trim(strPhone);
	if(strPhone.indexOf("+")>1) return false;
	if(strPhone.indexOf("-")!=-1)bracket=bracket+1;
	if(strPhone.indexOf("(")!=-1 && strPhone.indexOf("(")>bracket)return false;
	var brchr=strPhone.indexOf("(");
	if(strPhone.indexOf("(")!=-1 && strPhone.charAt(brchr+2)!=")")return false;
	if(strPhone.indexOf("(")==-1 && strPhone.indexOf(")")!=-1)return false;
	s=stripCharsInBag(strPhone,validWorldPhoneChars);
	return (isInteger(s) && s.length >= minDigitsInIPhoneNumber);
}

function isValidPhoneNumber(){
	var Phone=document.getElementById('phone');

	if (checkInternationalPhone(Phone.value)==false){
		return false;
	}
	return true;
}

function getGateway()
{

	//Some kind of gateway is used
	if (typeof(document.getElementsByName("bookit_payment")[0])!='undefined')
	{
		
		var payment_options = document.getElementsByName("bookit_payment");
		for (var i=0; i<payment_options.length; i++)
		{
			
			if (payment_options[i].checked)
			{
							
				//Paypal
				if (payment_options[i].value=='Blookingpaypal')
				{
					
					if (typeof (document.id('paypalForm'))!=undefined)
					{
						return "Blookingpaypal";
					}
					else
					{
						return "paypal_error";
					}
				}
				//AsiaPay
				if (payment_options[i].value=='Blookingasiapay')
				{
					if (typeof (document.id('payFormCcard'))!=undefined)
					{
						return "Blookingasiapay";
					}
					else
					{
						return "asiapay_error";
					}
				}
				//CIMB
				if (payment_options[i].value=='Blookingcimb')
				{
					if (typeof (document.id('cimbForm'))!=undefined)
					{
						return "Blookingcimb";
					}
					else
					{
						return "cimb_error";
					}
				}
				//E-GIPSY
				if (payment_options[i].value=='Blookingegipsy')
				{
					if (typeof (document.id('payEGipsy'))!=undefined)
					{
						return "Blookingegipsy";
					}
					else
					{
						return "GatewayError";
					}
				}
				//iDeal
				if (payment_options[i].value=='Blookingideal')
				{
					if (typeof (document.id('idealForm'))!=undefined)
					{
						return "Blookingideal";
					}
					else
					{
						return "GatewayError";
					}
				}
				//Sisow
				if (payment_options[i].value=='Blookingsisow')
				{
					if (typeof (document.id('idealForm'))!=undefined)
					{
						return "Blookingsisow";
					}
					else
					{
						return "GatewayError";
					}
				}
				//ROBOKASSA
				if (payment_options[i].value=='Blookingrobokassa')
				{
					if (typeof (document.id('robokassaForm'))!=undefined)
					{
						return "Blookingrobokassa";
					}
					else
					{
						return "GatewayError";
					}
				}
				//Wire
				else if (payment_options[i].value=='Blookingwire')
				{
					return "Blookingwire";
				}
				//Cash
				else if (payment_options[i].value=='Blookingcash')
				{
					return "Blookingcash";
				}
			}

		}
	}
	return "";
}

/*
 * If gateways are enabled check that at least one is selected before proceeding
 */
function checkGateways()
{
	//Some kind of gateway is used
	if (typeof(document.getElementsByName("bookit_payment")[0])!='undefined')
	{
		var payment_options = document.getElementsByName("bookit_payment");
		for (var i=0; i<payment_options.length; i++)
		{
			if (payment_options[i].checked)
			{
				if (payment_options[i].value == "Blookingwire") {
					return "Wire Transfer";
				} else if (payment_options[i].value == "Blookingpaypal") {
					return "Paypal";
				} else if (payment_options[i].value == "Blookingasiapay") {
					return "Asia pay";
				} else if (payment_options[i].value == "Blookingcimb") {
					return "Cimb Clicks";
				} else if (payment_options[i].value == "Blookingegipsy") {
					return "E-Gipsy";
				} else if (payment_options[i].value == "Blookingideal") {
					return "iDeal";
				} else if (payment_options[i].value == "Blookingsisow") {
					return "Sisow";
				} else if (payment_options[i].value == "Blookingrobokassa") {
					return "Robokassa";
				} else if (payment_options[i].value == "Blookingcash") {
					return "Cash";
				} else {
					return "Unknown";
				}
				
			}
		}
	}
	else
	{
		return "Unknown";
	}
	return false;
}
