<?php
/**
 * BlooKing - The King in Joomla Booking
 * @version 1.0
 * @author BlooKing.org. Based on BooKiTGold code by Costas Kakousis
 * @copyright (C) 2012-2013 by BlooKing.org (http://www.blooking.org)
 * @license GNU/GPL: http://www.gnu.org/copyleft/gpl.html
 *
 * If you fork this to create your own project, please make a reference to
 * BlooKing! someplace in your code and provide a link to
 * http://www.blooking.org
 *
 * This file is part of BlooKing! BlooKing is free software: you can
 * redistribute it and/or modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * BlooKing is distributed in the hope that it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details. You should have received a copy of the GNU General Public License
 * along with BlooKing.  If not, see <http://www.gnu.org/licenses/>.
 *   ______ __                __  __ __
 *	|   __ \  |.-----..-----.|  |/  |__|.-----..-----.
 *	|   __ <  ||  _  ||  _  ||     <|  ||     ||  _  |
 *	|______/__||_____||_____||__|\__|__||__|__||___  |
 *                                             |_____|
 **/

defined( '_JEXEC' ) or die( 'Restricted access' );
jimport( 'joomla.application.component.model' );

/**
 * the controller will automatically load the model that has the same name as
 * the view and will push it into the view.
 * @author Costas
 *
*/
class BlookingModelBlooking extends JModel
{

	var $_db;
	function __construct()
	{
		parent::__construct();
		JLoader::register('BlookingHelper',
		JPATH_COMPONENT_ADMINISTRATOR.'/helpers/BlookingHelper.php');
	}

	function getCategory($id)
	{
		$db =& JFactory::getDBO();
		if ($id>0)
		{
			$sql = "SELECT * FROM ".$db->nameQuote("#__bookitcategory")." WHERE ".
					$db->nameQuote("idcategory")." = ".$db->quote($id);
			$db->setQuery($sql);
		}
		else {
			$sql = "SELECT * FROM ".$db->nameQuote("#__bookitcategory");
			$db->setQuery($sql);
		}
		return $db->loadObject();
	}
	function getCategoryFromName($name)
	{
		$db =& JFactory::getDBO();
		$sql = "SELECT * FROM ".$db->nameQuote("#__bookitcategory")." WHERE ".
				$db->nameQuote("name")." = ".$db->quote($name);
		$db->setQuery($sql);
		return $db->loadObject();
	}



	function availabilityCheck ($valid_from, $valid_to, $idcategory)
	{
		$res = new stdClass();

		$res->remaining_rooms = 0;
		$res->query="";
		//CHECK FOR AVAILABILITY
		$start= $this->_toMysqlDateFormat ($valid_from);
		$end = $this->_toMysqlDateFormat($valid_to);

		$whereStr=" WHERE ";
		$whereStr.=$this->_db->nameQuote('idcategory')." = ".
				$this->_db->quote($idcategory)." AND ";

		$case1 =  $this->_db->nameQuote('valid_from')." <= ".
				$this->_db->quote($start)." AND ".
				$this->_db->nameQuote('valid_to')." > ".$this->_db->quote($start);
		$case2 = $this->_db->nameQuote('valid_from')." >= ".
				$this->_db->quote($start)." AND ".$this->_db->nameQuote('valid_from').
				" < ".$this->_db->quote($end);
			

		//------Check if there is availability for the selected options---------
		//Get bookings already found for selected settings
		$query = "SELECT DISTINCT ".$this->_db->nameQuote('idroom')." FROM ".
				$this->_db->nameQuote('#__bookitbooking').$whereStr.
				"(".$this->_db->nameQuote('status')." IN(1,2,3) ) AND ( (".
				$case1.") OR (".$case2.") );";
		$this->_db->setQuery($query);
		$rows = $this->_db->loadObjectList();
		$res->query = $query;

		$query = "SELECT COUNT(*) FROM ".
				$this->_db->nameQuote('#__bookitroom')." WHERE ".
				$this->_db->nameQuote('idcategory')."=".
				$this->_db->quote($idcategory);
		$this->_db->setQuery($query);
		$rooms_in_selected_category = $this->_db->loadResult();

		if ($rows==null || empty($rows))
			$res->remaining_rooms= $rooms_in_selected_category;
		else
			$res->remaining_rooms = $rooms_in_selected_category - count($rows);


		if ($res->remaining_rooms > 0)
			$res->idroom = $this->_getRoom ($rows, $idcategory);
		else
			$res->idroom=0;

		return $res;
	}

	function _multiRoomAvailabilityCheck ($valid_from, $valid_to, $idcategories)
	{
		$res = new stdClass();

		$res->remaining_rooms = 0;
		$res->query="";
		//CHECK FOR AVAILABILITY
		$start= $this->_toMysqlDateFormat ($valid_from);
		$end = $this->_toMysqlDateFormat($valid_to);

		$whereStr=" WHERE ";
		$whereStr.=$this->_db->nameQuote('idcategory')." IN (".
				$idcategories.") AND ";

		$case1 =  $this->_db->nameQuote('valid_from')." <= ".
				$this->_db->quote($start)." AND ".
				$this->_db->nameQuote('valid_to')." > ".$this->_db->quote($start);
		$case2 = $this->_db->nameQuote('valid_from')." >= ".
				$this->_db->quote($start)." AND ".$this->_db->nameQuote('valid_from').
				" < ".$this->_db->quote($end);
			
		//------Check if there is availability for the selected options---------
		//Get bookings already found for selected settings
		$query = "SELECT DISTINCT ".$this->_db->nameQuote('idroom')." FROM ".
				$this->_db->nameQuote('#__bookitbooking').$whereStr.
				"(".$this->_db->nameQuote('status')." != ".
				$this->_db->quote('0')." AND ".$this->_db->nameQuote('status')." != ".
				$this->_db->quote('4').
				") AND ( (".$case1.") OR (".$case2.") );";
		$this->_db->setQuery($query);
		$rows = $this->_db->loadObjectList();
		$res->query = $query;

		$query = "SELECT COUNT(*) FROM ".
				$this->_db->nameQuote('#__bookitroom')." WHERE ".
				$this->_db->nameQuote('idcategory')." IN (".
				$idcategories.")";
		$this->_db->setQuery($query);
		$rooms_in_selected_category = $this->_db->loadResult();

		if ($rows==null || empty($rows))
			$res->remaining_rooms= $rooms_in_selected_category;
		else
			$res->remaining_rooms = $rooms_in_selected_category - count($rows);

		return $res;
	}

	function searchResults ($data)
	{

		//Settings vars
		$nguests = $data['nguests'];
		$nchilds = $data['nchilds'];
		$idcategory = $data['idcategory'];
		$valid_from = $data['valid_from'];
		$valid_to = $data['valid_to'];
		$mode = $data['mode'];

		//MENU PARAMS
		$show_daily_rates = $data['show_daily_rates'];
		$show_cal = $data['show_cal'];
		$show_year_calendar = $data['show_year_calendar'];

		//PARAMS
		$params = BlookingHelper::getParams();
		$max_booking_period = $params->max_booking_period;

		//Result object
		$res = new stdClass();
		$res->code ="1";
		$res->remaining_rooms = "0";
		$res->output = "";
		$res->calendar="";
		$res->new_date=$valid_from;
		$res->price=0.00;
		$res->idroom=0;
		$res->idrules="";

		//GET CATEGORY

		$category = $this->getCategory($idcategory);

		$res->min_stay=$category->min_stay;
		$res->max_stay=$category->max_stay;
		$res->start_day=$category->start_day;
		$res->end_day=$category->end_day;

		//CALL THE CALENAR

		$date_code = $this->_getDateFormat();
		$time = date ($date_code, strtotime($valid_from));
		$time = strtotime($time);
		$start_day = date('w', $time);
		$time = strtotime ($mode, $time);
		$month = date('n', $time);
		$year = date('Y', $time);
		$to_time = date ($date_code, strtotime($valid_to));
		$to_time = strtotime($to_time);
		$end_day = date('w', $to_time);
		if ($show_cal==1)
		{
			$months_ahead = "1";
			$res->calendar = $this->displayCalendar($month, $year,
					$category->idcategory,	$months_ahead);
		}


		//CHECK FOR STAYING RESTRICTIONS
		//HOTEL MAX BOOKING PERIOD
		$nights = $this->_getNights($valid_from, $valid_to);
		if ($nights > $max_booking_period)
		{
			$res->code = "-4";
			return $res;
		}
		else if (($nights < $category->min_stay) && ($category->min_stay > 0) ||
				($nights > $category->max_stay) && ($category->max_stay > 0) )
		{
			$res->code = "-3";
			return $res;
		}
		//CATEGORY START/END DAYS

		$restStartDay = explode(",", $category->start_day);
		$restEndDay = explode(",", $category->end_day);

		if (($restStartDay[$start_day] == "1") || ($restEndDay[$end_day] == "1"))
		{
			$res->start_day=$this->getAllowedDays($restStartDay);
			$res->end_day=$this->getAllowedDays($restEndDay);
			$res->code = "-5";
			return $res;
		}

		//Check if MAX guest condition is satisfied
		if (($category->nguests > 0 && $nguests > $category->nguests) ||
				($category->nchilds > 0 && $nchilds > $category->nchilds) ||
				($category->max_in_total > 0 && ($nguests+$nchilds) >
						$category->max_in_total))
		{
			$res->code = "-1";
			return $res;
		}
		//Check if MIN guests condition is satisfied
		else if ($category->nguests_min > 0 &&
				$nguests < $category->nguests_min ||
				$category->nchilds_min > 0 && $nchilds < $category->nchilds_min ||
				$category->min_in_total > 0 && ($nguests+$nchilds)
				< $category->min_in_total)
		{
			$res->code = "-2";
			return $res;
		}


		//CHECK FOR AVAILABILITY
		$availability_check = $this->availabilityCheck($valid_from, $valid_to,
				$idcategory);
		$res->remaining_rooms = $availability_check->remaining_rooms;
		//VACANCIES
		if ($res->remaining_rooms > 0)
		{
			$rates = $this->priceCalculation($category, $data);
			$res->output = $this->_getHTMLOutput ($category, $data, $rates,
					false);
			$res->price = $rates->price;
			$res->idrules = $rates->idrules;
				
			$res->idroom = $availability_check->idroom;
		}
		else //NO VACANCIES
		{
			$res->code = "0";
		}


		return $res;

	}


	//-------------------------- GENERATE OUTPUT -------------------------------
	function _getHTMLOutput ($category, $data, $rates, $multiroom)
	{

		//PARAMS
		$params = BlookingHelper::getParams();
		$img_width = 96;
		$img_height = 96;
		$currency = $params->currency;

		//MENU PARAMS
		$show_daily_rates = $data['show_daily_rates'];

		//VARS
		$nguests = $data['nguests'];
		$nchilds = $data['nchilds'];
		$valid_from =  $data['valid_from'];
		$valid_to =  $data['valid_to'];
		$nights = $this->_getNights($valid_from, $valid_to);
		$res_row="";
		$price_str="";

		//LABELS
		$adult_str = "";
		$child_str = "";
		($nchilds>1 || $nchilds==0) ?
		$child_str=JText::_("COM_BOOKIT_CHILDREN") :
		$child_str=JText::_("COM_BOOKIT_CHILD");
		($nguests>1) ? $adult_str=JText::_("COM_BOOKIT_ADULTS") :
		$adult_str=JText::_("COM_BOOKIT_ADULT");
		($nights>1) ? $night_str=JText::_("COM_BOOKIT_NIGHTS"):
		$night_str=JText::_("COM_BOOKIT_NIGHT");
		$book_now_str = JText::_("COM_BOOKIT_BOOK_NOW");
			

		//THUMBNAIL
		$img_src="";
		$img_width>=$img_height ? $img_ori= 'width' : $img_ori= 'height';
		if ($category->url != "")
		{
			$img_src=JURI::root()."/images/bookit/images/".$category->url;
			$img_str = "<img style='".$img_ori.": 100%;' src='".$img_src."' />";
		}
		else
		{
			$img_src=JURI::root()."/images/bookit/images/sample.png";
			$img_str = "<img style='".$img_ori.": 100%;' src='".$img_src."'
					alt='".JText::_("COM_BOOKIT_PHOTOS_NOT_AVAILABLE")."' />";
		}


		//PRICE
		//CHECK FOR RULES
		if ($rates->price_deviation!=0)
		{
			$price_str .= $this->_getSpecialRatesText($rates, $currency);
		}
		else
		{
			$price_str = $rates->price."<br />".$currency;
			$offer="";
		}
		//COMPOSE OUTPUT
		//LABEL
		$name = $this->_translator ($data['lang'], 'name',
				'#__bookitcategory', 'idcategory', $category->idcategory);

		$res_row = "<div class='bookit_box'>
				<div class='bookit_search_result_header'>
				<div class='bookit_search_result_header_text'>".
				$name."&nbsp;</div>
						<div class='bookit_search_result_header_desc'>";
		if ($nguests>0)
			$res_row .=$nguests." ".$adult_str.", ";
		if ($nchilds>0)
			$res_row .=$nchilds." ".$child_str.", ";
		$res_row .=$nights." ".$night_str."
				</div></div>";
		//THUMBNAIL
		$res_row .="<div class='bookit_search_clear'></div>";
		$res_row .="<div id='single_room_desc'>";
		$res_row .="<a class='p3'>".$img_str.
		"<b><img class='large' src='".$img_src."' alt=''/></b></a>";

		//DESCRIPTION
		//FILTER FROM LOADPOSITIONS
		$load_position_res = $this->loadPositions ($category, $data['lang']);
		$res_row .="<p class='bookit_search_result_desc'>".
				$load_position_res->new_description."</p>";
		$res_row .="</div>";
		//PRICE
		$res_row.="<div class='bookit_search_result_right_15'>
				<div class='bookit_search_result_price'>".$price_str."</div>
						<div class='bookit_search_clear'></div>
						<div class='bookit_search_result_nights'>".$nights." ".$night_str."</div>
								<div class='bookit_search_clear'></div>";

		if (!$multiroom)
		{
			$res_row.="<div id='single_bookit_button_div' class=''>
					<div class='bookit_search_clear'></div>
					<button type='submit' class='bookit_button'>".$book_now_str."</button>
							</div>";
		}
		$res_row.="</div>
				<div class='bookit_search_clear'></div>";

		//LOAD MODULES IF ANY
		$res_row.="<div class='bookit_search_result_below'>";
		$res_row .=$load_position_res->module_text;
		$res_row.="</div><div class='bookit_search_clear'></div>";

		//DAILY RATES
		if ($show_daily_rates==1)
		{
			$res_row.="<div class='bookit_search_result_below'>
					<div class='bookit_search_result_header_rates'>";
			$res_row.="<div class='bookit_search_result_header_text'>".
					JText::_('COM_BOOKIT_DAILY_RATES')."</div></div>
							<div class='bookit_search_result_below_cell_header'>
							".$rates->daily_rates_txt."</div></div>";
		}

		//Close res row
		$res_row .= "</div>";

		return $res_row;
	}

	//----------------PRICE CALCULATIONS START----------------------------------
	function priceCalculation ($category, $data, $rooms=1)
	{

		$res = new stdClass();
		$nguests = $data['nguests'];
		$nchild = $data['nchilds'];
		$valid_from = $data['valid_from'];
		$valid_to = $data['valid_to'];
		$price = 0.00;
		$price_deviation = 0.00;
		$price_before = 0.00;

		$daily_rates = array();
		$rule_ids = "";
		$idrules = "";

		//PARAMS
		$params = BlookingHelper::getParams();
		$currency = $params->currency;
		//Check for special rates
		$special_rate_row = $this->_getSpecialRateRule ($valid_from, $valid_to);
		$special_rate_rules = $special_rate_row->rules;

		//Check for daily rates
		$daily_rate_row = $this->_getPerDayRules( $valid_from, $valid_to);
		if (count($daily_rate_row->rate)>0) //daily rates apply and not special rates
		{
			//v1.5.5
			//$max_daily_rule = $this->_getMaxDailyRule($valid_from,
			//$valid_to, $daily_rate_row->rate);
			foreach ($daily_rate_row->rate as $rule)
			{
				array_push($special_rate_rules, $rule);
			}
			//v1.5.5 end
		}

		if (!empty($special_rate_rules))//special rates apply
		{

			$rules = $this->_filterRuleByCategory ($special_rate_rules,
					$category->idcategory);

			if (!empty($rules))
			{
				$daily_res = $this->_getDailyRates($valid_from, $valid_to,
						$rules, $category, $nguests, $nchild);
				$daily_rates = $daily_res->daily_rates;
				$price = round($this->_getTotalFromDailyRates ($daily_rates)); //v1.5.6
				foreach ($rules as $rule)
				{
					$rule_name = $this->_translator($data['lang'], 'name',
							'#__bookitrules', 'idrule', $rule->idrule);
					$rule_ids .= $rule_name.", ";
					$idrules .= $rule->idrule.", ";
				}
			}
			$price_before = $price;

		}

		//END OF SPECIAL RATE RULES
		if ($price==0)
		{
			//no daily rate rules and no special rates
			if ($category->price_mode==0)//Charge per room
			{
				$price =$this->_getBasePricePerRoom ($valid_from, $valid_to,
						$category->cost);
			}
			else //charge per guest
			{
				$price =$this->_getBasePricePerGuest ($valid_from,
						$valid_to, $nguests, $nchild, $category->adult_cost,
						$category->child_cost);
			}
			$price_before = $price;

		}

		if (empty($rules))//NO special rates apply
		{
			//set daily rates
			$daily_res = $this->_getDailyRates($valid_from, $valid_to, null,
					$category, $nguests, $nchild);
			$daily_rates = $daily_res->daily_rates;
		}

		//SPECIAL OFFERS OR EXTRA CHARGES

		//Check for over x guests rules
		$over_X_guests_offers = $this->_getOverXGuestsOffers ($valid_from,
				$valid_to, $nguests, $nchild);

		//Over X guests rules found
		if ($over_X_guests_offers->rules!=null && sizeof($over_X_guests_offers->rules)>0)
		{

			$over_x_res = $this->_getOverXGuestPriceDeviations($valid_from,
					$valid_to, $over_X_guests_offers->rules, $nguests, $nchild,
					$category, $price, $daily_rates, $data['lang'], $rooms);

			$price += $over_x_res->deviations;
			$daily_rates =  $over_x_res->daily_rates;
			$rule_ids.=$over_x_res->rule_ids;
			$price_deviation += $over_x_res->deviations;
			$idrules .= $over_x_res->idrules;
		}

		//v.1.5.4.2
		//Check for under x guests rules
		$over_X_guests_offers = $this->_getUnderXGuestsOffers ($valid_from,
				$valid_to, $nguests, $nchild);

		//Over X guests rules found
		if ($over_X_guests_offers->rules!=null && sizeof($over_X_guests_offers->rules)>0)
		{

			$over_x_res = $this->_getOverXGuestPriceDeviations($valid_from,
					$valid_to, $over_X_guests_offers->rules, $nguests, $nchild,
					$category, $price, $daily_rates, $data['lang'], $rooms);

			$price += $over_x_res->deviations;
			$daily_rates =  $over_x_res->daily_rates;
			$rule_ids.=$over_x_res->rule_ids;
			$price_deviation += $over_x_res->deviations;
			$idrules .= $over_x_res->idrules;
		}//v1.5.4.2

		//v.1.5.4.3 add third param
		$over_X_days_offers = $this->_getOverXDaysOffers ($valid_from, $valid_to);

		//Over X day rules found
		if ($over_X_days_offers->rules!=null && sizeof($over_X_days_offers->rules)>0)
		{

			$over_x_res = $this->_getPriceDeviations($valid_from, $valid_to,
					$over_X_days_offers->rules, $nguests, $nchild, $category, $price,
					$daily_rates, $data['lang'], $rooms);


			$price += $over_x_res->deviations;
			$daily_rates =  $over_x_res->daily_rates;
			$rule_ids.=$over_x_res->rule_ids;
			$price_deviation += $over_x_res->deviations;
			$idrules .= $over_x_res->idrules;
				
			//AC 1.5.4.5 - SEPARATE EXTRA CHARGE AND SPECIALS
			$over_x_res = $this->_getSpecialOffers($valid_from, $valid_to,
					$over_X_days_offers->rules, $nguests, $nchild, $category, $price,
					$daily_rates, $data['lang'], $rooms);


			$price += $over_x_res->deviations;
			$daily_rates =  $over_x_res->daily_rates;
			$rule_ids.=$over_x_res->rule_ids;
			$price_deviation += $over_x_res->deviations;
			$idrules .= $over_x_res->idrules;
		}


		//v.1.5.4.3
		$under_X_days_offers = $this->_getUnderXDaysOffers ($valid_from, $valid_to);
		//Under X day rules found
		if ($under_X_days_offers->rules!=null && sizeof($under_X_days_offers->rules)>0)
		{
			$over_x_res = $this->_getPriceDeviations($valid_from, $valid_to,
					$under_X_days_offers->rules, $nguests, $nchild, $category, $price,
					$daily_rates, $data['lang'], $rooms);
			$price += $over_x_res->deviations;
			$daily_rates =  $over_x_res->daily_rates;
			if ($rule_ids!="" && $over_x_res->rule_ids!="")
				$rule_ids .= ", ";
			$rule_ids.=$over_x_res->rule_ids;
			if ($idrules!=""&&$over_x_res->idrules!="")
				$idrules.=", ";
			$idrules .= $over_x_res->idrules;
				
			$over_x_res = $this->_getSpecialOffers($valid_from, $valid_to,
					$under_X_days_offers->rules, $nguests, $nchild, $category, $price,
					$daily_rates, $data['lang'], $rooms);
			$price += $over_x_res->deviations;
			$daily_rates =  $over_x_res->daily_rates;
			if ($rule_ids!="" && $over_x_res->rule_ids!="")
				$rule_ids .= ", ";
			$rule_ids.=$over_x_res->rule_ids;
			if ($idrules!=""&&$over_x_res->idrules!="")
				$idrules.=", ";
			$idrules .= $over_x_res->idrules;
		}
			


		//$nights = $this->_getNights($valid_from, $valid_to);
		$daily_rates_txt = "";
		$date_format = $this->_getDateFormat();

		foreach ($daily_rates as $key=>$value)
		{

			$ld = JText::_(BlookingHelper::getLocalizedDate(date('Y-m-d H:i:s',$key)));

			//$format = JText::_('DATE_FORMAT_LC4');
			$format=$this->_getDateFormat();
			$date_str= (JHTML::_('date', $ld, $format));

			$daily_rates_txt .= "<div class='bookit_search_result_below_cell'>".
					$date_str." <br /><div class='bookit_search_result_below_cell_price'>".
					$value." ".$currency."</div></div>";
			$date_str="";
		}

		$res->price_deviation = number_format($price_deviation, 2, '.', '');
		$res->daily_rates_txt = $daily_rates_txt;
		$res->daily_rates = $daily_rates;
		$res->msg = implode(" ", $daily_rates);
		$res->price = number_format($price, 2, '.', '');
		$res->price_before = $price_before;
		//Delete last comma
		if (substr($rule_ids, -2, 1)==",")
			$rule_ids = substr($rule_ids,0,-2);
		$res->rule_ids = $rule_ids;
		if (substr($idrules, -2, 1)==",")
			$idrules = substr($idrules,0,-2);
		$res->idrules = $idrules;

		return $res;
	}

	function _getTotalFromDailyRates ($daily_rates)
	{
		$price=0.00;
		foreach ($daily_rates as $k=>$v)
		{
			$price+=$v;
		}
		return number_format($price, 2, '.', '');
	}


	//Get rules of Periodic rate type (weekly, monthly, etc) that apply for the
	// current booking
	function _getSpecialRateRule ($start, $end)
	{
		$res = new stdClass();
		$nights = $this->_getNights($start, $end);
		$start= $this->_toMysqlDateFormat ($start);
		$end = $this->_toMysqlDateFormat($end);

		$case1 =  $this->_db->nameQuote('valid_from')." <= ".
				$this->_db->quote($start)." AND ".
				$this->_db->nameQuote('valid_to')." >= ".$this->_db->quote($start).
				" AND datediff(".$this->_db->quote($end).", ".
				$this->_db->quote($start).") >= ".$this->_db->nameQuote('xvar');

		$case2 = $this->_db->nameQuote('valid_from')." > ".
				$this->_db->quote($start)." AND ".$this->_db->nameQuote('valid_from').
				" < ".$this->_db->quote($end).
				" AND datediff(".$this->_db->quote($end).", ".
				$this->_db->nameQuote('valid_from').") >= ".$this->_db->nameQuote('xvar');

		$case3 = $this->_db->nameQuote('valid_to')." < ".
				$this->_db->quote($end)." AND ".$this->_db->nameQuote('valid_to').
				" >= ".$this->_db->quote($start).
				" AND datediff(".$this->_db->nameQuote('valid_to').", ".
				$this->_db->quote($start).") >= ".$this->_db->nameQuote('xvar');

		$query = "SELECT * FROM ".
				$this->_db->nameQuote('#__bookitrules').
				" WHERE ".
				$this->_db->quote($nights)." >= ".
				$this->_db->nameQuote("xvar")." AND
						( ( ".$case1.") OR (".$case2.") OR (".$case3.") ) AND ".
						$this->_db->nameQuote('published')." = ".$this->_db->quote('1')." AND ".
						$this->_db->nameQuote('mode')." = ".$this->_db->quote('0')." AND ".
						$this->_db->nameQuote('coupon')." = ".$this->_db->quote('0')." AND ".
						$this->_db->nameQuote('type')." = ".$this->_db->quote('0')." ORDER BY ".
						$this->_db->nameQuote('xvar')." DESC";

		$this->_db->setQuery($query);
		$rate = $this->_db->loadObject();
		$res->rules = $this->_db->loadObjectList();
		$res->query = $query;
		return $res;
	}
	//Get rules of Daily Rate type that apply for the current booking
	function _getPerDayRules ($start, $end)
	{
		$res = new stdClass();
		$nights = $this->_getNights($start, $end);
		$start= $this->_toMysqlDateFormat ($start);
		$end = $this->_toMysqlDateFormat($end);

		$case1 =  $this->_db->nameQuote('valid_from')." <= ".
				$this->_db->quote($start)." AND ".
				$this->_db->nameQuote('valid_to')." >= ".$this->_db->quote($start);

		$case2 = $this->_db->nameQuote('valid_from')." > ".
				$this->_db->quote($start)." AND ".$this->_db->nameQuote('valid_from').
				" < ".$this->_db->quote($end);

		$case3 = $this->_db->nameQuote('valid_to')." < ".
				$this->_db->quote($end)." AND ".$this->_db->nameQuote('valid_to').
				" >= ".$this->_db->quote($start);

		$query = "SELECT * FROM ".
				$this->_db->nameQuote('#__bookitrules').
				" WHERE ( ( ".$case1.") OR (".$case2.") OR (".$case3." ) ) AND ".
				$this->_db->nameQuote('published')." = ".$this->_db->quote('1')." AND ".
				$this->_db->nameQuote('mode')." = ".$this->_db->quote('0')." AND ".
				$this->_db->nameQuote('coupon')." = ".$this->_db->quote('0')." AND ".
				$this->_db->nameQuote('type')." = ".$this->_db->quote('1');

		$this->_db->setQuery($query);
		$rate = $this->_db->loadObjectList();
		$res->rate = $rate;
		$res->query = $query;


		return $res;
	}
	function _getBasePricePerRoom ($from, $to, $rate)
	{
		$nights = $this->_getNights($from, $to);
		return number_format($nights*$rate, 2, '.', '');
	}

	function _getBasePricePerGuest ($from, $to, $adults, $children,
			$adults_rate, $children_rate)
	{
		$nights = $this->_getNights($from, $to);
		$adults_cost =  $nights*$adults_rate*$adults;
		$children_cost =  $nights*$children_rate*$children;
		return number_format($adults_cost+$children_cost, 2, '.', '');
	}

	function _getPeriodicRate ($valid_from, $valid_to, $rule, $category,
			$nguests, $nchild)
	{
		$price_mode = $category->price_mode;
		$cost =  $category->cost;
		$adult_cost = $category->adult_cost;
		$child_cost = $category->child_cost;

		$price = 0.00;
		$nights = $this->_getNights($valid_from, $valid_to);


		$times = floor($nights / $rule->xvar);
		if ($times<1) return;

		if ($price_mode==0)//Charge per room
		{
			$price = $rule->value * $times;
		}
		else
		{
			$price = $rule->value * $nguests * $times;
			$price += $rule->value_child * $nchild * $times;
		}
		//Apply the regular rate for remaining nights
		for ($i=0; $i<($nights%$rule->xvar); $i++)
		{
			if ($price_mode==0)//Charge per room
			{
				$price += $cost;
			}
			else
			{
				$price += $adult_cost * $nguests;
				$price += $child_cost * $nchild;
			}
		}

		return number_format ($price, 2, '.', '');
	}
	function _getDailyRates ($valid_from, $valid_to, $rules, $category, $nguests, $nchild)
	{
		$price_mode = $category->price_mode;
		$cost = $category->cost;
		$adult_cost = $category->adult_cost;
		$child_cost = $category->child_cost;

		$res = new stdClass();
		$daily_rates = array();
		$price=0.00;

		if ($rules==null)
		{
			$start = strtotime($this->_toMysqlDateFormat ($valid_from));
			$end = strtotime($this->_toMysqlDateFormat ($valid_to));
			do
			{
				if ($price_mode==0)//Charge per room
				{
					$daily_rates[$start] = $cost;
				}
				else
				{
					$daily_rates[$start] = ($adult_cost * $nguests) +
					($child_cost * $nchild);
				}

				$start = strtotime('+1 day',$start);
			} while ($start < $end);
		}
		else
		{
			$start = strtotime($this->_toMysqlDateFormat ($valid_from));
			$end = strtotime($this->_toMysqlDateFormat ($valid_to));
			$rule_cnts = array();
			foreach ($rules as $rule)
			{
				$rule_cnts[$rule->name]=1;
			}
			while ($start < $end)
			{

				foreach ($rules as $rule)
				{
					$rule_start = strtotime($rule->valid_from);
					$rule_end = strtotime($rule->valid_to);
					//the rule does not apply go to the next one
					if ($start < $rule_start || $start > $rule_end)
						continue;


					if ($rule->type==1)  //Daily rates
					{

						$days = explode (",",$rule->selected_days);

						//check if rule is active on this day and daily rate applies for
						//this day of the week
						if ($start >= $rule_start && $start <= $rule_end
								&& $days[date("w", $start)]==1 )
						{
							if ($price_mode==0)//Charge per room
							{
								$daily_rates[$start] = $rule->value;
								$price += $rule->value;
							}
							else
							{
								$daily_rates[$start] = ($rule->value * $nguests) +
								($rule->value_child * $nchild);
								$price +=  $rule->value * $nguests;
								$price +=  ($rule->value_child * $nchild);
							}
						}
						else //v1.5.5
						{
							if (!isset($daily_rates[$start]))
								$daily_rates[$start]=0;
						}
							



					}
					else if ($rule->type==0)  //Special rates
					{

						//On this day a special rate applies
						if (( $start >= $rule_start && $start <= $rule_end) &&
								($rule->xvar > 0) )
						{

							if ($rule_cnts[$rule->name] % $rule->xvar == 0)
							{


								if ($price_mode==0)//Charge per room
								{
									$daily_rates[$start] = $rule->value;
									$go_back = $start;
									while ($go_back > strtotime("-".$rule->xvar." day",$start))
									{
										$daily_rates[$go_back] =
										number_format ($rule->value/$rule->xvar,
												2, '.', '');
										$go_back = strtotime("-1 day",$go_back);
									}

								}
								else
								{
									$daily_rates[$start] =  ($rule->value * $nguests) +
									($rule->value_child * $nchild);
									$x =  ($rule->value * $nguests) +
									($rule->value_child * $nchild);
									$go_back = $start;
									while ($go_back > strtotime("-".$rule->xvar." day",$start))
									{
										$daily_rates[$go_back] =
										number_format ( $x/$rule->xvar, 2, '.', '');
										$go_back = strtotime("-1 day",$go_back);
									}

								}

							}
							else
							{
								// apply the standard rate
								if ($price_mode==0)//Charge per room
								{
									$daily_rates[$start] = number_format ($cost, 2, '.', '');
								}
								else
								{
									$daily_rates[$start] =
									number_format (($adult_cost * $nguests) +
											($child_cost * $nchild), 2, '.', '');
								}
							}
							$rule_cnts[$rule->name] += 1;


						}
						else
						{
							// apply the standard rate
							if ($price_mode==0)//Charge per room
							{
								$daily_rates[$start] = number_format ($cost, 2, '.', '');
							}
							else
							{
								$daily_rates[$start] =
								number_format (($adult_cost * $nguests) +
										($child_cost * $nchild), 2, '.', '');
							}
						}

					}
				}
				if (!isset($daily_rates[$start]))
				{
					// apply the standard rate
					if ($price_mode==0)//Charge per room
					{
						$daily_rates[$start] = number_format ($cost, 2, '.', '');
					}
					else
					{
						$daily_rates[$start] =
						number_format (($adult_cost * $nguests) +
								($child_cost * $nchild), 2, '.', '');
					}

				}

				$start = strtotime('+1 day',$start);
			}

		}

		//v1.5.5 fill the gaps
		$start = strtotime($this->_toMysqlDateFormat ($valid_from));
		$end = strtotime($this->_toMysqlDateFormat ($valid_to));
		while ($start < $end)
		{
			if ($daily_rates[$start] > 0)
			{
				$start = strtotime('+1 day',$start);
				continue;
			}
			else
			{
				if ($price_mode==0)//Charge per room
				{
					$daily_rates[$start] = $cost;
					$price += $cost;
				}
				else
				{
					$daily_rates[$start] = ($adult_cost * $nguests) +
					($child_cost * $nchild);
					$price += ($adult_cost * $nguests) +
					($child_cost * $nchild);
				}
			}
			$start = strtotime('+1 day',$start);
		}


		$res->daily_rates = $daily_rates;
		$res->price = number_format ( $price, 2, '.', '');
		return $res;
	}

	function _getMaxDailyRule ($valid_from, $valid_to, $rules )
	{
		$valid_from = strtotime($this->_toMysqlDateFormat ($valid_from));
		$valid_to = strtotime($this->_toMysqlDateFormat($valid_to));
		$max_period=0;
		$selected_rule = $rules[0];

		foreach ($rules as $rule)
		{
			$rule_valid_from = strtotime($rule->valid_from);
			$rule_valid_to = strtotime($rule->valid_to);

			if ($rule_valid_from <= $valid_from &&
					$rule_valid_to >= $valid_to) //case 3
			{
				return $rule;
			}
			else if ($rule_valid_from >= $valid_from &&
					$rule_valid_from >= $valid_to) //case 1
			{
				$period = $valid_to - $rule_valid_from;
				if ($period > $max_period)
				{
					$selected_rule = $rule;
					$max_period = $period;
				}
			}
			else if ($rule_valid_to >= $valid_from &&
					$rule_valid_to <= $valid_to) //case 2
			{
				$period = $rule_valid_to - $valid_from;
				if ($period > $max_period)
				{
					$selected_rule = $rule;
					$max_period = $period;
				}
			}
		}
		return $selected_rule;
	}
	function _filterRuleByCategory ($rules, $idcategory)
	{

		if (is_array($rules))
		{
			$filtered_rules = array();
			foreach ($rules as $rule)
			{
				$categories = explode (",",$rule->idcategory);
				if (in_array($idcategory, $categories))
					array_push($filtered_rules, $rule);
			}
			return $filtered_rules;
		}
		else
		{

			if (isset($rules))
			{
				$categories = explode (",",$rules->idcategory);
				if (!in_array($idcategory, $categories))
					return null;
			}
			return $rules;

		}
	}

	//Get rules of Over X type that apply for the current booking
	// v1.5.4.3 added third param
	function _getOverXDaysOffers ($start, $end)
	{

		$res = new stdClass();
		$nights = $this->_getNights($start, $end);
		$start= $this->_toMysqlDateFormat ($start);
		$end = $this->_toMysqlDateFormat($end);

		$case1 =  $this->_db->nameQuote('valid_from')." <= ".
				$this->_db->quote($start)." AND ".
				$this->_db->nameQuote('valid_to')." >= ".$this->_db->quote($start); //1.5.7.4

		$case2 = $this->_db->nameQuote('valid_from')." >= ".
				$this->_db->quote($start)." AND ".$this->_db->nameQuote('valid_from').
				" < ".$this->_db->quote($end);

		$query = "SELECT * FROM ".
				$this->_db->nameQuote('#__bookitrules').
				" WHERE ( ( ".$case1.") OR (".$case2.") ) AND ".
				$this->_db->nameQuote('published')." = ".$this->_db->quote('1')." AND ".
				$this->_db->nameQuote('coupon')." = ".$this->_db->quote('0').
				" AND (".$this->_db->nameQuote('mode')." = ".$this->_db->quote('1').
				" OR ".$this->_db->nameQuote('mode')." = ".$this->_db->quote('2').
				") AND (".$this->_db->nameQuote('type')." = ".$this->_db->quote('2')." AND ".
				$this->_db->nameQuote('xvar')."<".$this->_db->quote($nights)."
						AND datediff(".$this->_db->quote($end).", ".$this->_db->nameQuote('valid_from').") > ".
						$this->_db->nameQuote('xvar').")";




		$this->_db->setQuery($query);
		$rules = $this->_db->loadObjectList();
		$res->rules = $rules;
		$res->query = $query;

		return $res;
	}
	//Get rules of Over X type that apply for the current booking
	// v1.5.4.3 added third param
	function _getUnderXDaysOffers ($start, $end)
	{

		$res = new stdClass();
		$nights = $this->_getNights($start, $end);
		$start= $this->_toMysqlDateFormat ($start);
		$end = $this->_toMysqlDateFormat($end);

		$case1 =  $this->_db->nameQuote('valid_from')." <= ".
				$this->_db->quote($start)." AND ".
				$this->_db->nameQuote('valid_to')." >= ".$this->_db->quote($start);

		$case2 = $this->_db->nameQuote('valid_from')." >= ".
				$this->_db->quote($start)." AND ".$this->_db->nameQuote('valid_from').
				" < ".$this->_db->quote($end);

		$query = "SELECT * FROM ".
				$this->_db->nameQuote('#__bookitrules').
				" WHERE ( ( ".$case1.") OR (".$case2.") ) AND ".
				$this->_db->nameQuote('published')." = ".$this->_db->quote('1')." AND ".
				$this->_db->nameQuote('coupon')." = ".$this->_db->quote('0').
				" AND (".$this->_db->nameQuote('mode')." = ".$this->_db->quote('1').
				" OR ".$this->_db->nameQuote('mode')." = ".$this->_db->quote('2').
				") AND ( (".$this->_db->nameQuote('type')." = ".$this->_db->quote('6').
				" AND ".$this->_db->nameQuote('xvar').">".$this->_db->quote($nights)."))";

		$this->_db->setQuery($query);
		$rules = $this->_db->loadObjectList();
		$res->rules = $rules;
		$res->query = $query;

		return $res;
	}
	//Get rules of Over X adults/children/guests that apply for the current
	// booking
	function _getOverXGuestsOffers ($start, $end, $nguests, $nchild)
	{
		$res = new stdClass();
		$nights = $this->_getNights($start, $end);
		$start= $this->_toMysqlDateFormat ($start);
		$end = $this->_toMysqlDateFormat($end);

		$case1 =  $this->_db->nameQuote('valid_from')." <= ".
				$this->_db->quote($start)." AND ".
				$this->_db->nameQuote('valid_to')." >= ".$this->_db->quote($start);

		$case2 = $this->_db->nameQuote('valid_from')." >= ".
				$this->_db->quote($start)." AND ".$this->_db->nameQuote('valid_from').
				" < ".$this->_db->quote($end);

		$case4=$this->_db->nameQuote('type')." = ".$this->_db->quote('3').
		" AND ".$this->_db->quote($nguests)." > ".$this->_db->nameQuote('xvar');

		$case5=$this->_db->nameQuote('type')." = ".$this->_db->quote('4').
		" AND ".$this->_db->quote($nchild)." > ".$this->_db->nameQuote('xvar');

		$case6=$this->_db->nameQuote('type')." = ".$this->_db->quote('5').
		" AND ".$this->_db->quote($nchild+$nguests)." > ".
		$this->_db->nameQuote('xvar');

		$query = "SELECT * FROM ".
				$this->_db->nameQuote('#__bookitrules').
				" WHERE ( ( ".$case1.") OR (".$case2.") ) AND ".
				$this->_db->nameQuote('published')." = ".$this->_db->quote('1')." AND ".
				$this->_db->nameQuote('coupon')." = ".$this->_db->quote('0').
				" AND (".$this->_db->nameQuote('mode')." = ".$this->_db->quote('1').
				" OR ".$this->_db->nameQuote('mode')." = ".$this->_db->quote('2').
				") AND ((".$case4.") OR (".$case5.") OR (".$case6."))";

		$this->_db->setQuery($query);
		$rules = $this->_db->loadObjectList();
		$res->rules = $rules;
		$res->query = $query;

		return $res;
	}

	// v.1.5.4.2	7=under_x_adults , 8=under_x_children 9=under_x_guest
	function _getUnderXGuestsOffers ($start, $end, $nguests, $nchild)
	{
		$res = new stdClass();
		$nights = $this->_getNights($start, $end);
		$start= $this->_toMysqlDateFormat ($start);
		$end = $this->_toMysqlDateFormat($end);

		$case1 =  $this->_db->nameQuote('valid_from')." <= ".
				$this->_db->quote($start)." AND ".
				$this->_db->nameQuote('valid_to')." >= ".$this->_db->quote($start);

		$case2 = $this->_db->nameQuote('valid_from')." >= ".
				$this->_db->quote($start)." AND ".$this->_db->nameQuote('valid_from').
				" < ".$this->_db->quote($end);

		$case4=$this->_db->nameQuote('type')." = ".$this->_db->quote('7').
		" AND ".$this->_db->quote($nguests)." < ".$this->_db->nameQuote('xvar');

		$case5=$this->_db->nameQuote('type')." = ".$this->_db->quote('8').
		" AND ".$this->_db->quote($nchild)." < ".$this->_db->nameQuote('xvar');

		$case6=$this->_db->nameQuote('type')." = ".$this->_db->quote('9').
		" AND ".$this->_db->quote($nchild+$nguests)." < ".
		$this->_db->nameQuote('xvar');

		$query = "SELECT * FROM ".
				$this->_db->nameQuote('#__bookitrules').
				" WHERE ( ( ".$case1.") OR (".$case2.") ) AND ".
				$this->_db->nameQuote('published')." = ".$this->_db->quote('1')." AND ".
				$this->_db->nameQuote('coupon')." = ".$this->_db->quote('0').
				" AND (".$this->_db->nameQuote('mode')." = ".$this->_db->quote('1').
				" OR ".$this->_db->nameQuote('mode')." = ".$this->_db->quote('2').
				") AND ((".$case4.") OR (".$case5.") OR (".$case6."))";

		$this->_db->setQuery($query);
		$rules = $this->_db->loadObjectList();
		$res->rules = $rules;
		$res->query = $query;

		return $res;
	}

	function _getSpecialOffers ($valid_from, $valid_to, $rules, $nguests,
			$nchild, $category, $price, $daily_rates, $lang, $rooms=1)
	{
		//AC 1.5.4.5 - FUNCTION ADDED TO SEPARATE EXTRA CHARGE AND SPECIALS
		$cost = $category->cost;
		$adult_cost = $category->adult_cost;
		$child_cost = $category->child_cost;
		$res = new stdClass();
		$nights = $this->_getNights($valid_from, $valid_to);

		$price_deviation=0.00;
		$rule_ids="";
		$idrules="";

		foreach ($rules as $rule)
		{
			$rule = $this->_filterRuleByCategory($rule,	$category->idcategory);
			if (!isset($rule)) continue;

			$rule_name = $this->_translator($lang, 'name',
					'#__bookitrules', 'idrule', $rule->idrule);
			$rule_ids .= $rule_name.", ";
			$idrules .= $rule->idrule.", ";
				
			if ($rule->apply_on==0) //Apply the offer/charge on total amount
			{
				if ($rule->price_mode==0)//Charge per room
				{
					if ($rule->value_mode==0) //fixed
					{
						if ($rule->mode==1) //offer
						{
							$price_deviation -= $rule->value*$rooms;
						}
					}
					else //Percentage
					{
						if ($rule->mode==1) //offer
						{
							$price_deviation -= $price*$rule->value*0.01*$rooms;

						}
					}
				}
				else //charge per guest
				{
					if ($rule->value_mode==0) //fixed
					{
						if ($rule->mode==1) //offer
						{
							$price_deviation -= $rule->value*$nguests +
							$rule->value_child*$nchild;
						}
					}
					else //Percentage
					{
						if ($rule->mode==1) //offer
						{
							$price_deviation -=
							($price*$rule->value*0.01*$nguests) +
							($price*$rule->value_child*0.01* $nchild);
						}
					}
				}

			}
			else //Apply the offer/charge on daily rate
			{
				$start = strtotime($this->_toMysqlDateFormat ($valid_from));
				$end = strtotime($this->_toMysqlDateFormat ($valid_to));
				$rule_start = strtotime($rule->valid_from);
				$rule_end = strtotime($rule->valid_to);

				$cnt=1;
				do
				{
					if ( ($start < $rule_start || $start > $rule_end)||
							($rule->type==2 && $cnt <= $rule->xvar )||
							($rule->type==6 && $cnt >= $rule->xvar )) //v1.5.4.3
					{
						$cnt++;
						$start = strtotime('+1 day',$start);
						continue;
					}
					if ($rule->price_mode==0)//Charge per room
					{
						if ($rule->value_mode==0) //fixed
						{
							if ($rule->mode==1) //offer
							{
								$price_deviation -= $rule->value*$rooms;
								$daily_rates[$start] -= $rule->value*$rooms;
							}
						}
						else //Percentage
						{
							if ($rule->mode==1) //offer
							{
								$price_deviation -=
								$daily_rates[$start]*$rule->value*0.01*$rooms;
								$daily_rates[$start] -=
								$daily_rates[$start]*$rule->value*0.01*$rooms;
							}
						}
					}
					else //charge per guest
					{
						if ($rule->value_mode==0) //fixed
						{
							if ($rule->mode==1) //offer
							{
								$price_deviation -= $rule->value*$nguests +
								$rule->value_child*$nchild;

								$daily_rates[$start] -= $rule->value*$nguests +
								$rule->value_child*$nchild;
							}
						}
						else //Percentage
						{
							if ($rule->mode==1) //offer
							{
								$price_deviation -=	($rule->value*0.01*
										$daily_rates[$start]*$nguests) +
										($rule->value_child*0.01*$daily_rates[$start]*
												$nchild);

								$daily_rates[$start] -=	($rule->value*0.01*
										$daily_rates[$start]*$nguests) +
										($rule->value_child*0.01*$daily_rates[$start]*
												$nchild);
							}
						}
					}
					$cnt++;
					$start = strtotime('+1 day',$start);
				} while ($start < $end);
			}
		}

		//1.5.7.4
		$params = BlookingHelper::getParams();
		$normalize = $params->normalize;

		if ($normalize==1) {
			$start = strtotime($this->_toMysqlDateFormat ($valid_from));
			$end = strtotime($this->_toMysqlDateFormat ($valid_to));
			do
			{
				$daily_rates[$start] = number_format( (($price+$price_deviation)/$nights), 2, '.', '');
				$start = strtotime('+1 day',$start);
			} while ($start < $end);
		}

		$res->deviations = $price_deviation;
		$res->daily_rates = $daily_rates;
		$res->rule_ids = $rule_ids;
		$res->idrules = $idrules;
		return $res;
	}
		
	function _getPriceDeviations ($valid_from, $valid_to, $rules, $nguests,
			$nchild, $category, $price, $daily_rates, $lang, $rooms=1)
	{
		$cost = $category->cost;
		$adult_cost = $category->adult_cost;
		$child_cost = $category->child_cost;
		$res = new stdClass();
		$nights = $this->_getNights($valid_from, $valid_to);

		$price_deviation=0.00;
		$rule_ids="";
		$idrules="";

		foreach ($rules as $rule)
		{
			$rule = $this->_filterRuleByCategory($rule,	$category->idcategory);
			if (!isset($rule)) continue;

			$rule_name = $this->_translator($lang, 'name',
					'#__bookitrules', 'idrule', $rule->idrule);
			$rule_ids .= $rule_name.", ";
			$idrules .= $rule->idrule.", ";

			if ($rule->apply_on==0) //Apply the offer/charge on total amount
			{
				if ($rule->price_mode==0)//Charge per room
				{
					if ($rule->value_mode==0) //fixed
					{
						if ($rule->mode==2) //extra charge
						{
							$price_deviation += $rule->value*$rooms;
						}
					}
					else //Percentage
					{
						if ($rule->mode==2) //extra charge
						{
							$price_deviation += $price*$rule->value*0.01*$rooms;
						}
					}
				}
				else //charge per guest
				{
					if ($rule->value_mode==0) //fixed
					{
						if ($rule->mode==2) //extra charge
						{
							$price_deviation += $rule->value*$nguests +
							$rule->value_child*$nchild;
						}

					}
					else //Percentage
					{
						if ($rule->mode==2) //extra charge
						{
							$price_deviation +=
							($price*$rule->value*0.01*$nguests) +
							($price*$rule->value_child*0.01* $nchild);
						}
					}
				}

			}
			else //Apply the offer/charge on daily rate
			{
				$start = strtotime($this->_toMysqlDateFormat ($valid_from));
				$end = strtotime($this->_toMysqlDateFormat ($valid_to));
				$rule_start = strtotime($rule->valid_from);
				$rule_end = strtotime($rule->valid_to);

				$cnt=1;
				do
				{
					if ( ($start < $rule_start || $start > $rule_end)||
							($rule->type==2 && $cnt <= $rule->xvar )||
							($rule->type==6 && $cnt >= $rule->xvar )) //v1.5.4.3
					{
						$cnt++;
						$start = strtotime('+1 day',$start);
						continue;
					}
					if ($rule->price_mode==0)//Charge per room
					{
						if ($rule->value_mode==0) //fixed
						{
							if ($rule->mode==2) //extra charge
							{
								$price_deviation += $rule->value*$rooms;
								$daily_rates[$start] += $rule->value*$rooms;
							}
						}
						else //Percentage
						{
							if ($rule->mode==2) //extra charge
							{
								$price_deviation +=
								$daily_rates[$start]*$rule->value*0.01*$rooms;
								$daily_rates[$start] +=
								$daily_rates[$start]*$rule->value*0.01*$rooms;
							}
						}
					}
					else //charge per guest
					{
						if ($rule->value_mode==0) //fixed
						{
							if ($rule->mode==2) //extra charge
							{
								$price_deviation += $rule->value*$nguests +
								$rule->value_child*$nchild;

								$daily_rates[$start] += $rule->value*$nguests +
								$rule->value_child*$nchild;
							}
						}
						else //Percentage
						{
							if ($rule->mode==2) //extra charge
							{
								$price_deviation += ($rule->value*0.01*
										$daily_rates[$start]*$nguests) +
										($rule->value_child*0.01*$daily_rates[$start]*
												$nchild);

								$daily_rates[$start] +=	($rule->value*0.01*
										$daily_rates[$start]*$nguests) +
										($rule->value_child*0.01*$daily_rates[$start]*
												$nchild);
							}
						}
					}
					$cnt++;
					$start = strtotime('+1 day',$start);
				} while ($start < $end);
			}
		}

		//1.5.7.4
		$params = BlookingHelper::getParams();
		$normalize = $params->normalize;

		if ($normalize==1) {
			$start = strtotime($this->_toMysqlDateFormat ($valid_from));
			$end = strtotime($this->_toMysqlDateFormat ($valid_to));
			do
			{
				$daily_rates[$start] = number_format( (($price+$price_deviation)/$nights), 2, '.', '');
				$start = strtotime('+1 day',$start);
			} while ($start < $end);
		}

		//NO PRICE NORMALIZATION
		//		$start = strtotime($this->_toMysqlDateFormat ($valid_from));
		//		$end = strtotime($this->_toMysqlDateFormat ($valid_to));
		//		do
			//		{
			//			$daily_rates[$start] = number_format( $daily_rates[$start], 2, '.', '');
			//			$start = strtotime('+1 day',$start);
			//		} while ($start < $end);


		$res->deviations = $price_deviation;
		$res->daily_rates = $daily_rates;
		$res->rule_ids = $rule_ids;
		$res->idrules = $idrules;
		return $res;
	}

	function _getOverXGuestPriceDeviations ($valid_from, $valid_to, $rules,
			$nguests, $nchild, $category, $price, $daily_rates, $lang, $rooms)
	{
		$cost = $category->cost;
		$adult_cost = $category->adult_cost;
		$child_cost = $category->child_cost;

		$res = new stdClass();
		$nights = $this->_getNights($valid_from, $valid_to);

		$price_deviation=0.00;
		$rule_ids="";
		$idrules="";
		foreach ($rules as $rule)
		{

			$rule = $this->_filterRuleByCategory($rule, $category->idcategory);
			if (!isset($rule)) continue;
			$rule_name = $this->_translator($lang, 'name',
					'#__bookitrules', 'idrule', $rule->idrule);
			$rule_ids .= $rule_name.", ";
			$idrules .= $rule->idrule.", ";
			switch ($rule->type)
			{
				case 3:
					$new_nguests = abs($nguests-$rule->xvar); //abs added in v.1.5.4.2
					break;
				case 4:
					$new_nchild = abs($nchild-$rule->xvar); //abs added in v.1.5.4.2
					break;
				case 5:
					$new_nguests = abs(($nguests+$nchild-$rule->xvar)); //abs added in v.1.5.4.2
					break;
				default:
					$new_nguests = $nguests;
					$new_nchild = $nchild;
					break;
			}
			if ($rule->apply_on==0) //Apply the offer/charge on total amount
			{
				if ($rule->price_mode==0)//Charge per room
				{
					if ($rule->value_mode==0) //fixed
					{
						if ($rule->mode==1) //offer
						{
							$price_deviation -= $rule->value*$rooms;
						}
						else if ($rule->mode==2) //extra charge
						{
							$price_deviation += $rule->value*$rooms;
						}
					}
					else //Percentage
					{
						if ($rule->mode==1) //offer
						{
							$price_deviation -= $price*$rule->value*0.01*$rooms;
						}
						else if ($rule->mode==2) //extra charge
						{
							$price_deviation += $price*$rule->value*0.01*$rooms;
						}
					}
				}
				else //charge per guest
				{
					if ($rule->value_mode==0) //fixed
					{
						if ($rule->mode==1) //offer
						{
							if ($rule->type==3 || $rule->type==5 ||
									$rule->type==7 || $rule->type==9)//v1.5.7.1
								$price_deviation -= $rule->value*$new_nguests;
							else if ($rule->type==4 || $rule->type==8)//v1.5.7.1
								$price_deviation -= $rule->value_child*$new_nchild;
						}
						else if ($rule->mode==2) //extra charge
						{
							if ($rule->type==3 || $rule->type==5 ||
									$rule->type==7 || $rule->type==9)
								$price_deviation += $rule->value*$new_nguests;
							else if ($rule->type==4 || $rule->type==8)//v1.5.7.1
								$price_deviation += $rule->value_child*$new_nchild;
						}


							
					}
					else //Percentage
					{
						if ($rule->mode==1) //offer
						{
							if ($rule->type==3 || $rule->type==5 ||
									$rule->type==7 || $rule->type==9)//v1.5.7.1
								$price_deviation -=
								($price*$rule->value*0.01*$new_nguests);
							else if ($rule->type==4 || $rule->type==8)//v1.5.7.1
								$price_deviation -=
								($price*$rule->value_child*0.01*$new_nchild);
						}
						else if ($rule->mode==2) //extra charge
						{
							if ($rule->type==3 || $rule->type==5 ||
									$rule->type==7 || $rule->type==9)//v1.5.7.1
								$price_deviation +=
								($price*$rule->value*0.01*$new_nguests);
							else if ($rule->type==4 || $rule->type==8)//v1.5.7.1
								$price_deviation +=
								($price*$rule->value_child*0.01*$new_nchild);
						}

					}
				}


					
			}
			else //Apply the offer/charge on daily rates
			{


				$start = strtotime($this->_toMysqlDateFormat ($valid_from));
				$end = strtotime($this->_toMysqlDateFormat ($valid_to));
				$rule_start = strtotime($rule->valid_from);
				$rule_end = strtotime($rule->valid_to);

				do
				{
					if ( $start < $rule_start || $start > $rule_end)
					{
						$start = strtotime('+1 day',$start);
						continue;
					}
					if ($rule->price_mode==0)//Charge per room
					{
						if ($rule->value_mode==0) //fixed
						{
							if ($rule->mode==1) //offer
							{
								$price_deviation -= $rule->value*$rooms;
								$daily_rates[$start] -= $rule->value*$rooms;
							}
							else if ($rule->mode==2) //extra charge
							{
								$price_deviation += $rule->value*$rooms;
								$daily_rates[$start] += $rule->value*$rooms;
							}
						}
						else //Percentage
						{
							if ($rule->mode==1) //offer
							{
								$price_deviation -=
								$daily_rates[$start]*$rule->value*0.01*$rooms;
								$daily_rates[$start] -=
								$daily_rates[$start]*$rule->value*0.01*$rooms;
							}
							else if ($rule->mode==2) //extra charge
							{
								$price_deviation +=
								$daily_rates[$start]*$rule->value*0.01*$rooms;
								$daily_rates[$start] +=
								$daily_rates[$start]*$rule->value*0.01*$rooms;
							}
						}
					}
					else //charge per guest
					{
						if ($rule->value_mode==0) //fixed
						{
							if ($rule->mode==1) //offer
							{
								if ($rule->type==3 || $rule->type==5 ||
										$rule->type==7 || $rule->type==9)//v1.5.7.1
								{

									$price_deviation -=
									$rule->value*$new_nguests;
									$daily_rates[$start] -=
									$rule->value*$new_nguests;
								}
								else if ($rule->type==4 || $rule->type==8)//v1.5.7.1
								{
									$price_deviation -=
									$rule->value_child*$new_nchild;
									$daily_rates[$start] -=
									$rule->value_child*$new_nchild;
								}
							}
							else if ($rule->mode==2) //extra charge
							{
								if ($rule->type==3 || $rule->type==5 ||
										$rule->type==7 || $rule->type==9)//v1.5.7.1
								{
									$price_deviation +=
									$rule->value*$new_nguests;
									$daily_rates[$start] +=
									$rule->value*$new_nguests;

								}
								else if ($rule->type==4 || $rule->type==8)//v1.5.7.1
								{
									$price_deviation +=
									$rule->value_child*$new_nchild;
									$daily_rates[$start] +=
									$rule->value_child*$new_nchild;

								}
							}
						}
						else //Percentage
						{
							if ($rule->mode==1) //offer
							{
								if ($rule->type==3 || $rule->type==5 ||
										$rule->type==7 || $rule->type==9)//v1.5.7.1
								{
									$price_deviation -= $rule->value*0.01*
									($daily_rates[$start]/($nguests+$nchild))*$new_nguests;
									$daily_rates[$start] -=	$rule->value*0.01*
									($daily_rates[$start]/($nguests+$nchild)) *$new_nguests;

								}
								else if ($rule->type==4 || $rule->type==8)//v1.5.7.1
								{
									$price_deviation -=
									$rule->value_child*0.01*
									($daily_rates[$start]/($nguests+$nchild))*$new_nchild;

										
									$daily_rates[$start] -=
									$rule->value_child*0.01*
									($daily_rates[$start]/($nguests+$nchild))*$new_nchild;
								}

							}
							else if ($rule->mode==2) //extra charge
							{
								if ($rule->type==3 || $rule->type==5 ||
										$rule->type==7 || $rule->type==9)//v1.5.7.1
								{
									$price_deviation += $rule->value*0.01*
									($daily_rates[$start]/($nguests+$nchild))*$new_nguests;
									$daily_rates[$start] +=	$rule->value*0.01*
									($daily_rates[$start]/($nguests+$nchild))*$new_nguests;
								}
								else if ($rule->type==4 || $rule->type==8)//v1.5.7.1
								{
									$price_deviation +=
									$rule->value_child*0.01*
									($daily_rates[$start]/($nguests+$nchild))*$new_nchild;
									$daily_rates[$start] +=
									$rule->value_child*0.01*
									($daily_rates[$start]/($nguests+$nchild))*$new_nchild;
								}
							}
						}
					}
					$start = strtotime('+1 day',$start);
				} while ($start < $end);
			}
		}

		//1.5.7.4
		$params = BlookingHelper::getParams();
		$normalize = $params->normalize;

		if ($normalize==1) {
			$start = strtotime($this->_toMysqlDateFormat ($valid_from));
			$end = strtotime($this->_toMysqlDateFormat ($valid_to));

			do
			{
				$daily_rates[$start] = number_format( (($price+$price_deviation)/$nights), 2, '.', '');
				$start = strtotime('+1 day',$start);
			} while ($start < $end);
		}

		$res->deviations = $price_deviation;
		$res->daily_rates = $daily_rates;
		$res->rule_ids = $rule_ids;
		$res->idrules = $idrules;
		return $res;
	}

	//----------------PRICE CALCULATIONS END------------------------------------

	//-------------------------- HELPER METHODS --------------------------------
	function _toMysqlDateFormat ($dateString)
	{
		$date_format = $this->_getDateFormat ();
		$originalDate = strtotime($dateString);
		return date("Y-m-d", $originalDate);
	}
	function _getDateFormat ()
	{
		$params = BlookingHelper::getParams();
		$dateformatcode = $params->dateformat;
		if ($dateformatcode==""||$dateformatcode==3)
			$d1='d-m-Y';
		else if ($dateformatcode==1)
			$d1='Y-m-d';
		else if ($dateformatcode==2)
			$d1='m/d/Y';
		return $d1;
	}
	function _getNights ($from, $to)
	{
		$from_time = strtotime($from);
		$to_time = strtotime($to);
		return (round( ($to_time-$from_time )/86400)) ;
	}

	function _getSpecialRatesText ($rate, $currency, $qnt=1)
	{

		$price_str="";
		$img_src=JURI::root(true)."/components/com_blooking/images/info.gif";
		if (is_array($rate))
		{
			foreach ($rate as $r)
			{
				if ($r->price_deviation < 0) //Special Offer
				{
					$price_str .= "<span class='bookit_search_del'>".
							number_format ( $r->price_before*$qnt, 2, '.', '').
							"</span><div class='bookit_search_clear'></div>";
					$new_price += ($r->price)*$qnt;
					$new_price = number_format ( $new_price, 2, '.', '');

					$price_str .= "<span class='bookit_rate'>".$new_price."<br />".
							$currency."</span>";
					$price_str .= "<span class='bookit_text_below_price'>".
							JText::_("COM_BOOKIT_SPECIAL_RATES_APPLY");
					$price_str  .= "<a class='tooltip'>
							<img src='".$img_src."' /><span>".$r->rule_ids.
							"</span></a></span>";
				}
				else //Extra charge
				{
					$price_str .= "<span class='bookit_rate'>".
							number_format ( $r->price*$qnt, 2, '.', '')."<br />".
							$currency."</span>";
					$price_str  .= "<span class='bookit_text_below_price'>".
							JText::_("COM_BOOKIT_SPECIAL_RATES_APPLY");
					$price_str  .= "<a class='tooltip'>
							<img src='".$img_src."' /><span>".$r->rule_ids.
							"</span></a></span>";

				}
			}
		}
		else
		{
			//1.5.7
			$arr = explode(",",  $rate->rule_ids);
			$arr = array_map("trim", $arr);
			$arr = array_unique($arr);
			foreach ($arr as $key => $link)
			{
				if ($arr[$key] == '')
				{
					unset($arr[$key]);
				}
			}
			$rate->rule_ids = implode(",",$arr);
			if ($rate->price_deviation < 0) //Special Offer
			{
				$price_str .= "<span class='bookit_search_del'>".
						number_format ( $rate->price_before*$qnt, 2, '.', '').
						"</span><div class='bookit_search_clear'></div>";
				$new_price = ($rate->price)*$qnt;
				$new_price = number_format ( $new_price, 2, '.', '');
				$price_str .= "<span class='bookit_rate'>".$new_price."<br />".
						$currency."</span>";
				$price_str .= "<span class='bookit_text_below_price'>".
						JText::_("COM_BOOKIT_SPECIAL_RATES_APPLY");
				$price_str  .= "<a class='tooltip'>
						<img src='".$img_src."' /><span>".$rate->rule_ids.
						"</span></a></span>";
			}
			else //Extra charge
			{
				$price_str .= "<span class='bookit_rate'>".
						number_format ( $rate->price*$qnt, 2, '.', '')."<br />".
						$currency."</span>";
				$price_str  .= "<span class='bookit_text_below_price'>".
						JText::_("COM_BOOKIT_SPECIAL_RATES_APPLY");
				$price_str  .= "<a class='tooltip'>
						<img src='".$img_src."' /><span>".$rate->rule_ids.
						"</span></a></span>";

			}
		}
		//$res_row.="<div class='bookit_search_result_offer'>".$offer."</div>";
		return $price_str;
	}



	function loadPositions ($category, $lang)
	{

		$result = new stdClass();
		$result->module_text="";
		$code = $this->_translator ($lang, 'description', '#__bookitcategory',
				'idcategory', $category->idcategory);

		//Fix relative images+SEF problem (alternative change editor plugin to include only absolute paths
		preg_match_all("/<img[^>]+\>/i",  $code, $images);

		foreach ($images[0] as $img)
		{


			if (strpos($img,'http')>0) continue;
			preg_match('/< *img[^>]*src *= *["\']?([^"\']*)/i', $img, $src);

			$code = str_replace($img, JHTML::image(JRoute::_(JURI::root().$src[1]), ""), $code);

		}

		jimport( 'joomla.application.module.helper' );

		preg_match_all('#\{(.*?)\}#', $code, $match);

		if (!empty($match))
		{
			//Clear description from loadpositions
			$new_description = str_replace($match[0], "", $code);
			$loadpositions = $match[1];
			foreach ($loadpositions as $pos)
			{
				$position = explode(" ", $pos);
				$position = $position[1];
				$modules = JModuleHelper::getModules($position);
				foreach ($modules as $module)
				{
					if (!empty($module))
						$result->module_text .=
						JModuleHelper::renderModule($module)." ";
				}
			}
		}

		$result->new_description = $new_description;
		return $result;
	}

	//--------------------------------------------------------------------------

	//--------------------------------CALENDAR----------------------------------
	function displayCalendar($month, $year, $idcategory, $months_ahead,
			$cal_rows=1, $cal_cols=6)
	{

		$imagesRoot = JURI::root()."components/com_blooking/images/";
		$params = BlookingHelper::getParams();

		$available_color = '#'.$params->available_color;
		$booked_color = '#'.$params->booked_color;
		$pending_color = '#'.$params->pending_color;
		$other_color = '#'.$params->other_color;
		$extra_availability = JText::_("COM_BOOKIT_CLOSED");
		$none_color="#FFFFFF";
		$months_count = 0;
		$backcolor="";
		$backimage="";
		$state=0;
		$afternoon_booked=0;
		$morning_booked=0;
		$currentDay= date('Y-m-d');

		$calendar = "<table>";
		for ($i=0; $i<$cal_rows; $i++)
		{
			$calendar .= "<tr>";
			for ($j=0; $j<$cal_cols; $j++)
			{
				$state=0;
				if (++$months_count>$months_ahead)
					break;
				$calendar .="<td style='vertical-align:top;'>";

				$calendar .= '<table cellpadding="0" cellspacing="0" class="ycalendar">';
				$calendar.= '<tr class="ycalendar-row" align="right">
						<td class="table-header" colspan="7">'.
						$month.' / '.$year.'</td></tr>';

				/* table headings */
				if ($params->start_monday==1)
				{
					$headings = array(
							JText::_("COM_BOOKIT_MO"),
							JText::_("COM_BOOKIT_TU"),
							JText::_("COM_BOOKIT_WE"),
							JText::_("COM_BOOKIT_TH"),
							JText::_("COM_BOOKIT_FR"),
							JText::_("COM_BOOKIT_SA"),
							JText::_("COM_BOOKIT_SU")
					);
				}
				else
				{
					//If start on monday
					$headings = array(JText::_("COM_BOOKIT_SU"),
							JText::_("COM_BOOKIT_MO"),
							JText::_("COM_BOOKIT_TU"),
							JText::_("COM_BOOKIT_WE"),
							JText::_("COM_BOOKIT_TH"),
							JText::_("COM_BOOKIT_FR"),
							JText::_("COM_BOOKIT_SA")
					);
				}

				$calendar.= '<tr class="ycalendar-row">
						<td class="ycalendar-day-head">'.
						implode('</td><td class="ycalendar-day-head">',$headings).'</td></tr>';

				/* days and weeks vars now ... */
				if ($params->start_monday==0)
					$running_day = date('w',mktime(0,0,0,$month,1,$year));
				else
					$running_day = date('N',mktime(0,0,0,$month,1,$year))-1;

				$days_in_month = date('t',mktime(0,0,0,$month,1,$year));

				$days_in_this_week = 1;
				$day_counter = 0;
				$dates_array = array();

				/* row for week one */
				$calendar.= '<tr class="ycalendar-row">';

				/* print "blank" days until the first of the current week */
				for($x = 0; $x < $running_day; $x++):
				$calendar.= '<td class="ycalendar-day-np"> </td>';
				$days_in_this_week++;
				endfor;

				/* keep going with days.... */
				for($list_day = 1; $list_day <= $days_in_month; $list_day++):

				$currentDay =  date ("Y-m-d",strtotime($year."-".$month."-".$list_day));



				$check = $this->availabilityCheck($currentDay,
						$currentDay, $idcategory);
				$count_available = $check->remaining_rooms;
				$state = $this->_getAvailabilityState ($currentDay, $idcategory);

				if ($count_available>0)
				{
					//Get the day state (availability)
					if ($state==0 || $state=="" || $state==6)
					{
						if ($params->show_available==1)
						{
							if ($morning_booked>0)
							{
								$backcolor = $available_color;
								$backimage = "" ;
							}
							else
							{
								$backcolor = $available_color;
								$backimage = "";
							}
						}
						else
						{
							$backcolor = $none_color;
							$backimage = "";
						}
					}
					else if ($state==2)
					{
						if ($params->show_pending==1)
						{
							$backcolor = $pending_color;
							$backimage = "";
						}
						else
						{
							$backcolor = $available_color;
							$backimage = "";
						}
					}
					else if ($state==3)
					{
						if ($params->show_extra==1)
						{
							$backcolor = $other_color;
							$backimage = "";
						}
						else
						{
							$backcolor = $available_color;
							$backimage = "";
						}
					}
				}
				else if ($count_available<=0)
				{

					if ($state==3)
					{
						if ($params->show_extra==1)
						{
							$backcolor = $other_color;
							$backimage = "";
						}
						else
						{
							$backcolor = $available_color;
							$backimage = "";
						}
					}
					else
					{
						if ($state==2)
						{
							//To draw a half day tomorrow must be available
							$yesterday = date('Y-m-d', strtotime($currentDay.' -1 day'));
							$check = $this->availabilityCheck($yesterday, $currentDay,
									$idcategory);
							$afternoon_booked = $check->remaining_rooms;

							if ($params->show_pending==1)
							{
								if ($afternoon_booked>0)
								{
									$backcolor = $available_color;
									$backimage = "url(".$imagesRoot."pending_eve_y.gif)" ;
								}
								else
								{
									$backcolor = $pending_color;
									$backimage = "";
								}
							}
							else
							{
								$backcolor = $available_color;
								$backimage = "";
							}
						}
						else
						{
							//To draw a half day tomorrow must be available
							$yesterday = date('Y-m-d', strtotime($currentDay.' -1 day'));
							$check = $this->availabilityCheck($yesterday, $currentDay,
									$idcategory);
							$afternoon_booked = $check->remaining_rooms;

							if ($params->show_booked==1)
							{
								if ($afternoon_booked>0)
								{
									$backcolor = $available_color;
									$backimage = "url(".$imagesRoot."booked_eve_y.gif)" ;
								}
								else
								{
									$backcolor = $booked_color;
									$backimage = "";
								}
							}
							else
							{
								$backcolor = $available_color;
								$backimage = "";
							}
						}
					}

				}
				else
				{
					if ($params->show_available==1)
					{
						$backcolor = $available_color;
						$backimage = "";
					}
					else
					{
						$backcolor = $none_color;
						$backimage = "";
					}
				}



				$calendar.= '<td class="ycalendar-day" style="background:'.
						$backcolor.' '.$backimage.' no-repeat" />';

				$calendar.= '<div class="day-number">'.$list_day.'</div>';
				$calendar.= str_repeat('<p> </p>',2);
				$calendar.= '</td>';

				if($running_day == 6):
				$calendar.= '</tr>';
				if(($day_counter+1) != $days_in_month):
				$calendar.= '<tr class="ycalendar-row">';
				endif;
				$running_day = -1;
				$days_in_this_week = 0;
				endif;
				$days_in_this_week++; $running_day++; $day_counter++;
				endfor;

				/* finish the rest of the days in the week */
				if($days_in_this_week < 8):
				for($x = 1; $x <= (8 - $days_in_this_week); $x++):
				$calendar.= '<td class="ycalendar-day-np"> </td>';
				endfor;
				endif;

				/* final row */
				$calendar.= '</tr>';

				/* end the table */
				$calendar.= '</table>';

				$calendar.='</td>';
				$month++;
				if ($month==13)
				{
					$month=1;
					$year++;
				}
			}

			$calendar.= '</tr>';
			if ($months_count==$months_ahead)
				break;
		}

		$calendar .="</table><table class='calendar-labels'>";
		if ($params->show_available==1)
		{
			$calendar .= "<td style='background-color:".$available_color."'
					class='ycalendar-label-day' >
					</td><td>".
					JText::_( 'COM_BOOKIT_AVAILABLE' )."</td>";
		}
		if ($params->show_booked==1)
		{
			$calendar .= "<td style='background-color:".$booked_color."'
					class='ycalendar-label-day'>
					</td><td>".
					JText::_( 'COM_BOOKIT_BOOKED' )."</td>";
		}
		if ($params->show_pending==1)
		{
			$calendar .= "<td style='background-color:".$pending_color."'
					class='ycalendar-label-day'>
					</td><td>".
					JText::_( 'COM_BOOKIT_PENDING' )."</td>";
		}
		if ($params->show_extra==1)
		{
			$calendar .= "<td style='background-color:".$other_color."'
					class='ycalendar-label-day'>
					</td><td>".
					$extra_availability."</td>";
		}

		$calendar .= "</tr></table>";

		$calendar .="</table>";
		$calendar .="</div>";

		return $calendar;
	}

	function getCalendar ($data, $months_ahead)
	{
		$result = new stdClass();
		//CALL THE CALENAR
		$date_code = $this->_getDateFormat();
		if (isset($data['new_date']) && $data['new_date']!="")
			$data['valid_from'] = $data['new_date'];
		$time = date ($date_code, strtotime($data['valid_from']));
		$time = strtotime($time);
		$time = strtotime ($data['mode'], $time);
		$month = date('n', $time);
		$year = date('Y', $time);
		$calendar = $this->displayCalendar($month, $year, $data['idcategory'],
				$months_ahead);

		$result->calendar = $calendar;
		$result->new_date = date($date_code, $time);
		return $result;

	}

	//-------------ON CATEGORY CHANGE-------------------------------------------
	function oncategorychange ($idcategory)
	{
		$options = new stdClass();
		$category = $this->getCategory($idcategory);

		if ($idcategory<=0)
		{
			$max_min = $this->getMaxMinGuests();
			$adult_options = array();
			for ($i=1; $i<=$max_min->max_adults; $i++)
			{
				$adult_options[$i] = $i;
			}
			$options->adults = $adult_options;

			$children_options = array();
			$options->children = $children_options;
			for ($i=0; $i<=$max_min->max_childs; $i++)
			{
				$children_options[$i] = $i;
			}
			if ($i>1)
				$options->children = $children_options;
		}
		else
		{
			if ($category->nguests > 0)
			{
				$adult_options = array();
				for ($i=1; $i<=$category->nguests; $i++)
				{
					$adult_options[$i] = $i;
				}
				$options->adults = $adult_options;
			}
			else
			{
				$options->adults = "";
			}
			if ($category->nchilds > 0)
			{
				$children_options = array();
				for ($i=$category->nchilds_min; $i<=$category->nchilds; $i++)
				{
					$children_options[$i] = $i;
				}
				$options->children = $children_options;
			}
			else
			{
				$options->children =  array();
			}
		}

		return $options;
	}


	//---------------------------MULTI ROOM ------------------------------------
	//--------------------------------------------------------------------------
	function getMaxMinGuests ()
	{
		$res = new stdClass();
		$res->max_adults=0;
		$res->min_adults=0;
		$res->max_childs=0;
		$res->min_childs=0;
		$query = "SELECT MAX(".$this->_db->nameQuote("nguests").") FROM ".
				$this->_db->nameQuote("#__bookitcategory");
		$this->_db->setQuery($query);
		$res->max_adults = $this->_db->loadResult();
		//--
		$query = "SELECT MIN(".$this->_db->nameQuote("nguests_min").") FROM ".
				$this->_db->nameQuote("#__bookitcategory");
		$this->_db->setQuery($query);
		$res->min_adults = $this->_db->loadResult();
		//--
		$query = "SELECT MAX(".$this->_db->nameQuote("nchilds").") FROM ".
				$this->_db->nameQuote("#__bookitcategory");
		$this->_db->setQuery($query);
		$res->max_childs = $this->_db->loadResult();
		//--
		$query = "SELECT MIN(".$this->_db->nameQuote("nchilds_min").") FROM ".
				$this->_db->nameQuote("#__bookitcategory");
		$this->_db->setQuery($query);
		$res->min_childs = $this->_db->loadResult();

		return $res;
	}



	function getSuitableRoomCategories ($nguests, $nchilds)
	{

		$query = "SELECT * FROM ".
				$this->_db->nameQuote("#__bookitcategory")." ORDER BY CASE ".
				$this->_db->nameQuote('price_mode')." WHEN ".$this->_db->quote ('0').
				" THEN ".$this->_db->nameQuote('cost')." ELSE ".
				$this->_db->nameQuote('adult_cost')." END ASC";
		$this->_db->setQuery($query);

		return $this->_db->loadObjectList();

	}

	function getStayingRestrictions ($category, $nights, $max_booking_period,
			$start_day, $end_day, $nguests, $nchilds)
	{
		$code = 1;
		//CHECK FOR STAYING RESTRICTIONS
        if (empty($nights))
		$nights = $this->_getNights($start_day, $end_day);
		if ($nights > $max_booking_period)
		{
			$code = -4;
			return $code;
		}

		if (($nights < $category->min_stay) && ($category->min_stay > 0) ||
				($nights > $category->max_stay) && ($category->max_stay > 0) )
		{
			$code = -3;
			return $code;
		}
		//CATEGORY START/END DAYS

		$restStartDay = explode(",", $category->start_day);
		$restEndDay = explode(",", $category->end_day);

		if (($restStartDay[$start_day] == "1") || ($restEndDay[$end_day] == "1"))
		{
			$code = -5;
			return $code;
		}

		//Check if MAX guest condition is satisfied
		//		if (($category->nguests > 0 && $nguests > $category->nguests) ||
		//		($nchilds > $category->nchilds) ||
		//		($category->max_in_total > 0 && ($nguests+$nchilds) >
		//		$category->max_in_total))
		//		{
		//			$code = -1;
		//			return $code;
		//		}
		//Check if MIN guests condition is satisfied
		//		else if ($category->nguests_min > 0 &&
		//		$nguests < $category->nguests_min ||
		//		$category->nchilds_min > 0 && $nchilds < $category->nchilds_min ||
		//		$category->min_in_total > 0 && ($nguests+$nchilds)
		//		< $category->min_in_total)
		//		{
		//			$code = -2;
		//			return $code;
		//		}
		return $code;
	}




	function getMultiRoomSpecialRatesText ($rates, $currency)
	{

		$price_str="";
		$price_deviation = 0.00;
		$price=0.00;
		$rule_ids = array();
		$img_src=JURI::root(true)."/components/com_blooking/images/info.gif";
		foreach ($rates as $rate)
		{
			$price_deviation += $rate->price_deviation;
			$price+=$rate->price;
			$arr = explode (",",$rate->rule_ids);
			foreach ($arr as $id)
			{
				if (!in_array($id, $rule_ids))
					array_push($rule_ids, $id);
			}
		}
		$rule_ids = implode (",",$rule_ids);
		if (substr($rule_ids, -1, 1)==",")
			$rule_ids = substr($rule_ids,0,-1);
		$price = number_format ( $price, 2, '.', '');

		if ($price_deviation < 0) //Special Offer
		{
			$price_str .= "<span class='bookit_search_del'>".
					$price."</span><div class='bookit_search_clear'></div>";
			$new_price = $price+$price_deviation;
			$new_price = number_format ( $new_price, 2, '.', '');

			$price_str .= "<span class='bookit_rate'>".$new_price."<br />".
					$currency."</span>";
			$price_str .= "<span class='bookit_text_below_price'>".
					JText::_("COM_BOOKIT_SPECIAL_RATES_APPLY");
			$price_str  .= "<a class='tooltip'>
					<img src='".$img_src."' /><span>".$rule_ids.
					"</span></a></span>";
		}
		else if ($price_deviation > 0)//Extra charge
		{
			$price_str .= "<span class='bookit_rate'>".$price."<br />".
					$currency."</span>";
			$price_str  .= "<span class='bookit_text_below_price'>".
					JText::_("COM_BOOKIT_SPECIAL_RATES_APPLY");
			$price_str  .= "<a class='tooltip'>
					<img src='".$img_src."' /><span>".$rule_ids.
					"</span></a></span>";
		}
		else
		{
			$price_str .= "<span class='bookit_rate'>".$price."<br />".
					$currency."</span>";

		}
		//$res_row.="<div class='bookit_search_result_offer'>".$offer."</div>";
		return $price_str;
	}

	function getAllowedDays ($days)
	{
		$res = "";
		if ($days[0]==0)
			if ($res!="")
			$res .=" or ".JText::_('SUNDAY');
		else
			$res = JText::_('SUNDAY');
		if ($days[1]==0)
			if ($res!="")
			$res .=" or ".JText::_('MONDAY');
		else
			$res =JText::_('MONDAY');
		if ($days[2]==0)
			if ($res!="")
			$res .=" or ".JText::_('TUESDAY');
		else
			$res = JText::_('TUESDAY');
		if ($days[3]==0)
			if ($res!="")
			$res .=" or ".JText::_('WEDNESDAY');
		else
			$res =JText::_('WEDNESDAY');
		if ($days[4]==0)
			if ($res!="")
			$res .=" or ".JText::_('THURSDAY');
		else
			$res =JText::_('THURSDAY');
		if ($days[5]==0)
			if ($res!="")
			$res .=" or ".JText::_('FRIDAY');
		else
			$res =JText::_('FRIDAY');
		if ($days[6]==0)
			if ($res!="")
			$res .=" or ".JText::_('SATURDAY');
		else
			$res =JText::_('SATURDAY');

		return $res;
	}
	function noToDayName ($no)
	{
		$res = "";
		switch ($no)
		{
			case '0':
				$res = JText::_('SUNDAY');
				break;
			case '1':
				$res = JText::_('MONDAY');
				break;
			case '2':
				$res = JText::_('TUESDAY');
				break;
			case '3':
				$res = JText::_('WEDNESDAY');
				break;
			case '4':
				$res = JText::_('THURSDAY');
				break;
			case '5':
				$res = JText::_('FRIDAY');
				break;
			case '6':
				$res = JText::_('SATURDAY');
				break;
			default:
				$res = '';
				break;
		}
		return $res;
	}
	//------------------ GENERATE ROOM DESCRIPTION BOX -------------------------
	function _getMultiHTMLOutput ($category, $data, $rates, $rooms, $room_ids, $lang)
	{

		//PARAMS
		$params = BlookingHelper::getParams();
		$img_width = 96;
		$img_height = 96;
		$currency = $params->currency;

		//MENU PARAMS
		$show_daily_rates = $data['show_daily_rates'];

		//VARS
		$nguests = $data['nguests'];
		$nchilds = $data['nchilds'];
		$valid_from =  $data['valid_from'];
		$valid_to =  $data['valid_to'];
		$nights = $this->_getNights($valid_from, $valid_to);
		$res_row="";
		$price_str="";

		//LABELS
		($nights>1) ? $night_str=JText::_("COM_BOOKIT_NIGHTS"):
		$night_str=JText::_("COM_BOOKIT_NIGHT");
		$book_now_str = JText::_("COM_BOOKIT_BOOK_NOW");

		//FACILITIES TEXT
		$facilities_str="";

		$name_code = $this->_translator ($lang, 'name',
				'#__bookitcategory', 'idcategory', $category->idcategory);

		$facilities = $this->_translator ($lang, 'facilities',
				'#__bookitcategory', 'idcategory', $category->idcategory);


		//		if ($facilities != "")
		//		{
		//			$facilities = preg_split('%[\n,]+%', $facilities);
		//			if (count($facilities)>0)
		//			{
		//				$facilities_str .= "<span class='bookit_amenities_list'>";
		//				foreach ($facilities as $k => $v)
		//				$facilities_str .= $v."<br/>";
		//				$facilities_str .= "</span>";
		//			}
		//
		//		}
		//THUMBNAIL
		$img_src="";
		$img_width>=$img_height ? $img_ori= 'width' : $img_ori= 'height';
		if ($category->url != "")
		{
			$img_src=JURI::root()."/images/bookit/images/".$category->url;
			$img_str = "<img style='".$img_ori.": 100%;' src='".$img_src."' />";
		}
		else
		{
			$img_src=JURI::root()."/images/bookit/images/sample.png";
			$img_str = "<img style='".$img_ori.": 100%;' src='".$img_src."'
					alt='".JText::_("COM_BOOKIT_PHOTOS_NOT_AVAILABLE")."' />";
		}
		//PRICE
		//CHECK FOR RULES
		$price_str .= $this->_getSpecialRatesText($rates, $currency, $rooms);

		//		else
		//		{
		//			$price_str = number_format( $rates->price * $rooms, 2, '.', '').
		//				"<br />".$currency;
		//			$offer="";
		//		}
		//COMPOSE OUTPUT
		//LABEL
		$res_row = "<div class='room_description_row'>
				<div class='room_details_header'>";
		$res_row .= "<div class='room_details_room'>".
				$rooms." x ".$name_code."&nbsp;</div>";
		$res_row .="</div>";//Close room details header

		//THUMBNAIL
		$res_row .="<div class='bookit_search_clear'></div>";
		$res_row .="<div class='room_details_left_column'>";
		$res_row .="<a class='p3' >".$img_str.
		"<b><img class='large' src='".$img_src."' alt=''/></b></a>";
		$res_row .="<div class='bookit_search_clear'></div>";
		//GUEST DETAILS
		$res_row.="<div id='room_details_guest_wrapper_".$category->name."'
				class='room_details_guest_wrapper'>";
		$res_row.="<a class='toggle_guest_details'
				onclick='toggleGuestDetails(\"room_details_guest_".$category->name."\",
						\"toggle_guest_details_".$category->name."_label\")'>";
		$res_row.="<span id='toggle_guest_details_".$category->name."_label'
				class='toggle_label_closed'>";
		$res_row.= JText::_("COM_BOOKIT_GUEST_DETAILS");
		$res_row.="</span></a>";
		$res_row.="<div id='room_details_guest_".$category->name."'
				style='display: none; margin-top:5px'>";


		$arr = explode (",",$room_ids);
		foreach ($arr as $room_id)
		{
			$nguests = $data['room'.$room_id."_adults"];
			$nchilds = $data['room'.$room_id."_children"];
			$adult_str = "";
			$child_str = "";
			($nchilds>1 || $nchilds==0) ?
			$child_str=JText::_("COM_BOOKIT_CHILDREN") :
			$child_str=JText::_("COM_BOOKIT_CHILD");
			($nguests>1) ? $adult_str=JText::_("COM_BOOKIT_ADULTS") :
			$adult_str=JText::_("COM_BOOKIT_ADULT");

			$res_row .= "<div class='guests_per_room'> <p>";
			$res_row .= JText::_("COM_BOOKIT_ROOM")." ".$room_id;
			$res_row .= "</p><span class='room_details_guests'>";

			if ($nguests>0)
			{
				//$res_row .= "<p>";
				$res_row .=$nguests." ".$adult_str;
				//$res_row .= "</p>";
			}
			if ($nchilds>1)
			{
				$res_row .=", ";
				$res_row .= "<p>";
				$res_row .= $nchilds." ".$child_str;
				$res_row .= "</p>";
			}
			else if ($nchilds==1)
			{
				$res_row .= ", ".$nchilds." ".$child_str;
			}

			$res_row .= "</span></div>";

		}
		$res_row .="</div>";
		$res_row .="</div>";
		$res_row .="</div>";

		//DESCRIPTION
		//FILTER FROM LOADPOSITIONS
		$load_position_res = $this->loadPositions ($category, $data['lang']);
		$res_row .="<div id='room_description_inner_div'>";
		$res_row .="<div class='bookit_search_result_desc multi'> <b>".
				JText::_("COM_BOOKIT_DESCRIPTION")."</b> <br/>".
				$load_position_res->new_description."</div>";

		//FACILITIES
		//		if ($facilities_str!="")
		//		{
		//			$amen = JText::_("COM_BOOKIT_AMENITIES");
		//
		//
		//			$res_row .= "<div class='bookit_search_result_fas'> ";
		//			$res_row .= "<div class='bookit_amenities'>".$amen.
		//			"</div>";
		//			$res_row .=$facilities_str."</div>";
		//		}
		//PRICE
		//		$res_row.="<div class='bookit_search_result_right'>
		//		<div class='bookit_search_result_price'>".$price_str."</div>
		//		<div class='bookit_search_clear'></div>
		//		<div class='bookit_search_result_nights'>".$nights." ".$night_str."</div>
		//		<div class='bookit_search_clear'></div>";
		//		$res_row.="</div>";
		//		$res_row.="<div class='bookit_search_clear'></div>";


		//LOAD MODULES IF ANY
		$res_row.="<div class='bookit_room_details_module'>";
		$res_row .=$load_position_res->module_text;
		$res_row.="</div><div class='bookit_search_clear'></div>";



		//DAILY RATES
		if ($show_daily_rates==1)
		{

			$res_row.="<div >";
			$res_row.="<a class='toggle_guest_details'
					onclick='toggleGuestDetails(\"room_details_rates_".
					$category->name."\",
							\"toggle_rate_details_".$category->name."_label\")'>";
			$res_row.="<span id='toggle_rate_details_".$category->name."_label'
					class='toggle_label_closed'>";
			$res_row.= JText::_("COM_BOOKIT_DAILY_RATES");
			$res_row.="</span></a>";
			$res_row.="<div id='room_details_rates_".$category->name."'
					style='display: none; margin-top:10px; margin-left:10px'>";

			$total_daily_rates=array();

			foreach ($rates as $room=>$room_rates)
			{
				$daily_rates = $room_rates->daily_rates;
				foreach ($daily_rates as $time=>$price)
				{
					if (isset($total_daily_rates[$time]))
					{
						$total_daily_rates[$time] += $price;
					}
					else
					{
						$total_daily_rates[$time] = $price;
					}
				}
			}
			foreach ($total_daily_rates as $time=>$price)
			{
				$ld = JText::_(BlookingHelper::getLocalizedDate(date('Y-m-d',$key)));
				$format = JText::_('DATE_FORMAT_LC3');
				$date_str= (JHTML::_('date', $ld, $format));
				$res_row .= "<div class='bookit_search_result_below_cell'>".
						$date_str." <br /><div class='bookit_search_result_below_cell_price'>".
						$price." ".$currency."</div></div>";
			}

			$res_row .="</div>";
			$res_row .="</div>";
			$res_row.="<div class='bookit_search_clear'></div>";

		}

		$res_row.="</div>";//Room description inner div
		$res_row.="<div class='bookit_search_clear'></div>";
		//Close res row
		$res_row .= "</div>";
		$res_row.="<div class='bookit_search_clear'></div>";
		return $res_row;
	}
	function _getBookingSummary ($categ_name_to_categ, $categ_to_qnt,
			$price, $nights, $rates, $rooms_left, $categ_to_adults, $categ_to_children,
			$lang)
	{

		//PARAMS
		$params = BlookingHelper::getParams();
		$currency = $params->currency;
		$price_str="";
		//LABELS
		$adult_str = "";
		$child_str = "";

		($nights>1) ? $night_str=JText::_("COM_BOOKIT_NIGHTS"):
		$night_str=JText::_("COM_BOOKIT_NIGHT");
		$book_now_str = JText::_("COM_BOOKIT_BOOK_NOW");

		$res_row = "<div class='bookit_search_result_row_overall'>";
		$res_row .="<div class='bookit_search_clear'></div>";

		//DESCRIPTION
		$res_row .="<div class='bookit_search_summary_desc'>";
		$res_row .="<span class='summary_block'>";

		$res_row .="<span class='summary_key'>".
				JText::_("COM_BOOKIT_ROOMS_FOUND").": </span>";

		//if($lang=='en')$name_code = 'name'; else $name_code='name_'.$lang;


		foreach ($categ_name_to_categ as $category)
		{
			$name_code = $this->_translator ($lang, 'name',
					'#__bookitcategory', 'idcategory', $category->idcategory);

			$nguests = $categ_to_adults[$category->name];
			$nchilds = $categ_to_children[$category->name];

			($nchilds>1 || $nchilds==0) ?
			$child_str=JText::_("COM_BOOKIT_CHILDREN") :
			$child_str=JText::_("COM_BOOKIT_CHILD");
			($nguests>1) ? $adult_str=JText::_("COM_BOOKIT_ADULTS") :
			$adult_str=JText::_("COM_BOOKIT_ADULT");

			$res_row .="<span class='summary_block'>";

			$res_row .="<span class='summary_value'>".
					$categ_to_qnt[$category->name]." ".$name_code." ".
					JText::_("COM_BOOKIT_FOR")." ".$nguests." ".$adult_str;
			if ($nchilds > 0)
			{
				$res_row .= " ".JText::_("COM_BOOKIT_AND")." ".
						$nchilds." ".$child_str;
			}
			$res_row .="</span>";

			$res_row .="</span>";

		}

		if ($rooms_left > 0)
		{
			$res_row .="<span class='summary_key_error'>".
					JText::_("COM_BOOKIT_NO_MATCH").$rooms_left." ";
			if ($rooms_left=="1")
				$res_row .=JText::_("COM_BOOKIT_ROOM_LC");
			else
				$res_row .=JText::_("COM_BOOKIT_ROOMS_LC");
			$res_row .=" </span>";
		}

		$res_row .="</div>";

		//IMAGE GALLERY
		$res_row .= "<div class='bookit_search_result_gallery'>";
		//THUMBNAIL

		$img_src="";
		$img_ori= 'width';
		foreach ($categ_name_to_categ as $category)
		{
			$name = $this->_translator ($lang, 'name',
					'#__bookitcategory', 'idcategory', $category->idcategory);
			if ($category->url != "")
			{
				$img_src=JURI::root()."/images/bookit/images/".$category->url;
				$img_str = "<img style='".$img_ori.": 100%;' src='".$img_src."'
						alt='".$name."' />";
			}
			else
			{
				$img_src=JURI::root()."/images/bookit/images/sample.png";
				$img_str = "<img style='".$img_ori.": 100%;' src='".$img_src."'
						alt='".JText::_("COM_BOOKIT_PHOTOS_NOT_AVAILABLE")."' />";
			}


			$res_row .= "<div class='gallery_img'>";
			$res_row .= "<div>";
			$res_row .= "<a class='p2' >".$img_str.
			"<b><img class='large' src='".$img_src."' alt=''/></b></a>";
			$res_row .= "</div><div class='bookit_search_clear'></div>";
			$res_row .= "<div class='gallery_img_caption'>
					<p>".$name."</p></div>";
			$res_row .= "</div>";



		}
		$res_row .="</div>";

		$price_str .= $this->getMultiRoomSpecialRatesText($rates, $currency);

		$res_row.="<div class='bookit_search_result_right_15'>
				<div class='bookit_search_result_price'>".$price_str."</div>
						<div class='bookit_search_clear'></div>
						<div class='bookit_search_result_nights'>".$nights." ".$night_str."</div>
								<div class='bookit_search_clear'></div>";

		$res_row.="<div id='bookit_button_div' class='bookit_button'>
				<div class='bookit_search_clear'></div>
				<button type='submit'>".$book_now_str."</button>
						</div>";

		$res_row.="</div>
				<div class='bookit_search_clear'></div>";


		//Close res row
		$res_row .= "</div>";

		return $res_row;

	}


	//-----------------------CALENDAR MULTI-ROOM--------------------------------
	function displayMultiRoomCalendar($month, $year, $idcategories,
			$months_ahead, $cal_rows=1, $cal_cols=6)
	{
		$imagesRoot = JURI::root()."components/com_blooking/images/";
		$params = BlookingHelper::getParams();

		$available_color = '#'.$params->available_color;
		$booked_color = '#'.$params->booked_color;
		$pending_color = '#'.$params->pending_color;
		$other_color = '#'.$params->other_color;
		$extra_availability = JText::_("COM_BOOKIT_CLOSED");
		$none_color="#FFFFFF";
		$months_count = 0;
		$backcolor="";
		$backimage="";
		$state=0;
		$afternoon_booked=0;
		$morning_booked=0;
		$currentDay= date('Y-m-d');

		$calendar = "<table>";
		for ($i=0; $i<$cal_rows; $i++)
		{
			$calendar .= "<tr>";
			for ($j=0; $j<$cal_cols; $j++)
			{
				if (++$months_count>$months_ahead)
					break;
				$calendar .="<td style='vertical-align:top;'>";

				$calendar .= '<table cellpadding="0" cellspacing="0" class="ycalendar">';
				$calendar.= '<tr class="ycalendar-row" align="right" >
						<td class="table-header" colspan="7">'.
						$month.' / '.$year.'</td></tr>';

				/* table headings */
				if ($params->start_monday==0) {
					$headings = array(JText::_("COM_BOOKIT_SU"),
							JText::_("COM_BOOKIT_MO"),
							JText::_("COM_BOOKIT_TU"),
							JText::_("COM_BOOKIT_WE"),
							JText::_("COM_BOOKIT_TH"),
							JText::_("COM_BOOKIT_FR"),
							JText::_("COM_BOOKIT_SA")
					);
				}
				else{
					$headings = array(
							JText::_("COM_BOOKIT_MO"),
							JText::_("COM_BOOKIT_TU"),
							JText::_("COM_BOOKIT_WE"),
							JText::_("COM_BOOKIT_TH"),
							JText::_("COM_BOOKIT_FR"),
							JText::_("COM_BOOKIT_SA"),
							JText::_("COM_BOOKIT_SU")
					);
				}
				$calendar.= '<tr class="ycalendar-row">
						<td class="ycalendar-day-head" >'.
						implode('</td><td class="ycalendar-day-head">',$headings).'</td></tr>';

				/* days and weeks vars now ... */
				if ($params->start_monday==0)
					$running_day = date('w',mktime(0,0,0,$month,1,$year));
				else
					$running_day = date('N',mktime(0,0,0,$month,1,$year))-1;
					
				$days_in_month = date('t',mktime(0,0,0,$month,1,$year));
				$days_in_this_week = 1;
				$day_counter = 0;
				$dates_array = array();

				/* row for week one */
				$calendar.= '<tr class="ycalendar-row">';

				/* print "blank" days until the first of the current week */
				for($x = 0; $x < $running_day; $x++):
				$calendar.= '<td class="ycalendar-day-np"> </td>';
				$days_in_this_week++;
				endfor;

				/* keep going with days.... */
				for($list_day = 1; $list_day <= $days_in_month; $list_day++):

				$currentDay =  date ("Y-m-d",strtotime($year."-".$month."-".$list_day));

				if ($idcategories!=""){

					$check = $this->_multiRoomAvailabilityCheck($currentDay,
							$currentDay, $idcategories);
					$count_available = $check->remaining_rooms;
				}
				else
					return "";

				$state = $this->_getAvailabilityState ($currentDay, 0, $idcategories);
				if ($count_available>0)
				{
					//Get the day state (availability)
					if ($state==0 || $state=="" || $state==6)
					{
						if ($params->show_available==1)
						{
							$backcolor = $available_color;
							$backimage = "";
						}
						else
						{
							$backcolor = $none_color;
							$backimage = "";
						}
					}
					else
					{
						$backcolor = $available_color;
						$backimage = "";
					}

				}
				else if ($count_available<=0)
				{
					if ($state==3)
					{
						if ($params->show_extra==1)
						{
							$backcolor = $other_color;
							$backimage = "";
						}
						else
						{
							$backcolor = $available_color;
							$backimage = "";
						}
					}
					else
					{
						if ($state==2)
						{
							//To draw a half day tomorrow must be available
							$yesterday = date('Y-m-d', strtotime($currentDay.' -1 day'));
							$check = $this->_multiRoomAvailabilityCheck($yesterday,
									$currentDay, $idcategories);
							$afternoon_booked = $check->remaining_rooms;

							if ($params->show_pending==1)
							{
								if ($afternoon_booked>0)
								{
									$backcolor = $available_color;
									$backimage = "url(".$imagesRoot."pending_eve_y.gif)" ;
								}
								else
								{
									$backcolor = $pending_color;
									$backimage = "";
								}
							}
							else
							{
								$backcolor = $available_color;
								$backimage = "";
							}
						}
						else
						{

							//To draw a half day tomorrow must be available
							$yesterday = date('Y-m-d', strtotime($currentDay.' -1 day'));
							$check = $this->_multiRoomAvailabilityCheck($yesterday,
									$currentDay, $idcategories);
							$afternoon_booked = $check->remaining_rooms;

							if ($params->show_booked==1)
							{
								if ($afternoon_booked>0)
								{
									$backcolor = $available_color;
									$backimage = "url(".$imagesRoot."booked_eve_y.gif)" ;
								}
								else
								{
									$backcolor = $booked_color;
									$backimage = "";
								}
							}
							else
							{
								$backcolor = $available_color;
								$backimage = "";
							}
						}
					}
				}
				else
				{
					if ($params->show_available==1)
					{
						$backcolor = $available_color;
						$backimage = "";
					}
					else
					{
						$backcolor = $none_color;
						$backimage = "";
					}
				}



				$calendar.= '<td class="ycalendar-day" style="background:'.
						$backcolor.' '.$backimage.' no-repeat" />';

				$calendar.= '<div class="day-number">'.$list_day.'</div>';
				$calendar.= str_repeat('<p> </p>',2);
				$calendar.= '</td>';

				if($running_day == 6):
				$calendar.= '</tr>';
				if(($day_counter+1) != $days_in_month):
				$calendar.= '<tr class="ycalendar-row">';
				endif;
				$running_day = -1;
				$days_in_this_week = 0;
				endif;
				$days_in_this_week++; $running_day++; $day_counter++;
				endfor;

				/* finish the rest of the days in the week */
				if($days_in_this_week < 8):
				for($x = 1; $x <= (8 - $days_in_this_week); $x++):
				$calendar.= '<td class="ycalendar-day-np"> </td>';
				endfor;
				endif;

				/* final row */
				$calendar.= '</tr>';

				/* end the table */
				$calendar.= '</table>';

				$calendar.='</td>';
				$month++;
				if ($month==13)
				{
					$month=1;
					$year++;
				}
			}

			$calendar.= '</tr>';
			if ($months_count==$months_ahead)
				break;
		}

		$calendar .="</table><table class='calendar-labels'>";
		if ($params->show_available==1)
		{
			$calendar .= "<td style='background-color:".$available_color."'
					class='ycalendar-label-day' >
					</td><td>".
					JText::_( 'COM_BOOKIT_AVAILABLE' )."</td>";
		}
		if ($params->show_booked==1)
		{
			$calendar .= "<td style='background-color:".$booked_color."'
					class='ycalendar-label-day'>
					</td><td>".
					JText::_( 'COM_BOOKIT_BOOKED' )."</td>";
		}
		if ($params->show_pending==1)
		{
			$calendar .= "<td style='background-color:".$pending_color."'
					class='ycalendar-label-day'>
					</td><td>".
					JText::_( 'COM_BOOKIT_PENDING' )."</td>";
		}
		if ($params->show_extra==1)
		{
			$calendar .= "<td style='background-color:".$other_color."'
					class='ycalendar-label-day'>
					</td><td>".
					$extra_availability."</td>";
		}

		$calendar .= "</tr></table>";

		$calendar .="</table>";
		$calendar .="</div>";

		return $calendar;
	}
	function getMultiRoomCalendar ($data, $months_ahead)
	{
		$result = new stdClass();
		//CALL THE CALENAR
		$date_code = $this->_getDateFormat();
		if (isset($data['new_date']) && $data['new_date']!="")
			$data['valid_from'] = $data['new_date'];
		$time = date ($date_code, strtotime($data['valid_from']));
		$time = strtotime($time);
		$time = strtotime ($data['mode'], $time);
		$month = date('n', $time);
		$year = date('Y', $time);
		$calendar = $this->displayMultiRoomCalendar($month, $year,
				$data['idcategories'], $months_ahead);

		$result->calendar = $calendar;
		$result->new_date = date($date_code, $time);
		return $result;

	}
	function _gatTotalRooms ($idcategory, $idcategories="")
	{
		$whereStr="";
		if ($idcategories!="")
		{
			$whereStr .= " WHERE ".$this->_db->nameQuote("idcategory")." IN (".
					$idcategories.")";
		}
		else if ($idcategory>0)
		{
			$whereStr .= " WHERE ".$this->_db->nameQuote("idcategory")."=".
					$this->_db->quote($idcategory);
		}

		$query = "SELECT COUNT(*) FROM ".
				$this->_db->nameQuote("#__bookitroom").$whereStr;
		$this->_db->setQuery($query);
		return $this->_db->loadResult();
	}

	function _getAvailabilityState ($currentDay, $idcategory, $idcategories="")
	{
		$whereStr = "";
		$state = 0;
		$pending_rooms = 0;
		$closed_rooms = 0;
		$booked_rooms = 0;
		$available_rooms = 0;

		if ($idcategory>0)
		{
			$whereStr .= $this->_db->nameQuote("idcategory")."=".
					$this->_db->quote($idcategory);
			$query = "SELECT ".$this->_db->nameQuote("status").
			" FROM ".$this->_db->nameQuote("#__bookitbooking").
			" WHERE ".$whereStr;
			if ($whereStr!="")
				$query .= " AND ";
			$query .= "(";
			$query .= $this->_db->nameQuote("valid_from")." <= ".
					$this->_db->quote($currentDay)." AND ".
					$this->_db->nameQuote("valid_to")." > ".
					$this->_db->quote($currentDay).")";
			$this->_db->setQuery($query);
			$states = $this->_db->loadResultArray();
			$rooms = $this->_gatTotalRooms ($idcategory);
		}
		else if ($idcategories!="")
		{
			$query = "SELECT ".$this->_db->nameQuote("status").
			" FROM ".$this->_db->nameQuote("#__bookitbooking").
			" WHERE ".$this->_db->nameQuote("idcategory")." IN (".
			$idcategories.") AND (".
			$this->_db->nameQuote("valid_from")." <= ".
			$this->_db->quote($currentDay)." AND ".
			$this->_db->nameQuote("valid_to")." >= ".
			$this->_db->quote($currentDay).")";
			$this->_db->setQuery($query);
			$states = $this->_db->loadResultArray();
			$rooms = $this->_gatTotalRooms (0, $idcategories);
		}

		if (!empty($states))
		{
			$pending_rooms = count(array_keys($states, '2'));
			$closed_rooms = count(array_keys($states, '3'));
			$booked_rooms = count(array_keys($states, '1'));
			$processing_rooms = count(array_keys($states, '6'));
			$available_rooms = $rooms -
			($pending_rooms+$closed_rooms+$booked_rooms+$processing_rooms);



			if ($pending_rooms==$rooms) //All rooms are pending
				$state = 2;
			else if ($booked_rooms==$rooms) //All rooms are booked
				$state = 1;
			else if ($closed_rooms==$rooms) //All rooms are closed
				$state = 3;
			else if ($available_rooms>0)
				$state = 0;
			else if ($pending_rooms>0)
				$state = 2;
			else if ($closed_rooms>0)
				$state = 3;
			else if ($booked_rooms>0)
				$state = 1;
			else if ($processing_rooms>0)
				$state = 6;
			else
				$state=0;

		}
		return $state;

	}

	function getPendingBookingsData() {
		$db =& JFactory::getDBO();
		$sql = "SELECT pending_enabled, pending_time, pending_measure FROM #__bookitutils WHERE id='1';";
		$db->setQuery($sql);
		return $db->loadRow();
	}

	function _getRoom ($booked_rooms, $idcategory)
	{
		$rooms_array= array();
		$rooms_str="";
		foreach ($booked_rooms as $room)
		{
			array_push($rooms_array, $room->idroom);
		}
		$rooms_str = implode(',', $rooms_array);
		if ($rooms_str!="")
		{
			$query = "SELECT ".$this->_db->nameQuote('idroom')." FROM ".
					$this->_db->nameQuote('#__bookitroom')." WHERE ".
					$this->_db->nameQuote('idroom')." NOT IN (".
					$rooms_str.") AND ".$this->_db->nameQuote('idcategory')." = ".
					$this->_db->quote($idcategory);
		}
		else
		{
			$query = "SELECT ".$this->_db->nameQuote('idroom')." FROM ".
					$this->_db->nameQuote('#__bookitroom')." WHERE ".
					$this->_db->nameQuote('idcategory')." = ".
					$this->_db->quote($idcategory);
		}

		$this->_db->setQuery($query);
		return $this->_db->loadResult();

	}

	function _translator ($lang, $column, $table, $idkey, $idvalue)
	{

		$sql = "SELECT * FROM ".$this->_db->nameQuote($table)." WHERE ".
				$this->_db->nameQuote($idkey)."=".$this->_db->quote($idvalue);
		$this->_db->setQuery($sql);
		$obj = $this->_db->loadObject();

		if($lang!='en')
		{
			$new_column=$column.'_'.$lang;
			if(isset($obj->{$new_column}))
				return $obj->{$new_column};
		}
		return $obj->{$column};

	}
	function getCategoryOptions ($lang)
	{
		$options = array();
		$sql = "SELECT * FROM ".$this->_db->nameQuote('#__bookitcategory').
		" ORDER BY ".$this->_db->nameQuote('name');
		$this->_db->setQuery($sql);
		$categories = $this->_db->loadObjectList();

		foreach ($categories as $category)
		{
			if (isset($category->{"name_".$lang}))
				$name = $category->{"name_".$lang};
			else
				$name=$category->name;
			array_push($options, JHTML::_('select.option', $category->idcategory,
			$name));
		}
		return $options;

	}
	function getMinPeriod ()
	{
		$sql = "SELECT MIN(min_stay) FROM ".
				$this->_db->nameQuote('#__bookitcategory');
		$this->_db->setQuery($sql);
		$min = $this->_db->loadResult();
		if ($min==0) return 1;
		else return $min;
	}


}