<?php
/**
 * BlooKing - The King in Joomla Booking
 * @version 1.0
 * @author BlooKing.org. Based on BooKiTGold code by Costas Kakousis
 * @copyright (C) 2012-2013 by BlooKing.org (http://www.blooking.org)
 * @license GNU/GPL: http://www.gnu.org/copyleft/gpl.html
 *
 * If you fork this to create your own project, please make a reference to
 * BlooKing! someplace in your code and provide a link to
 * http://www.blooking.org
 *
 * This file is part of BlooKing! BlooKing is free software: you can
 * redistribute it and/or modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * BlooKing is distributed in the hope that it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details. You should have received a copy of the GNU General Public License
 * along with BlooKing.  If not, see <http://www.gnu.org/licenses/>.
 *   ______ __                __  __ __
 *	|   __ \  |.-----..-----.|  |/  |__|.-----..-----.
 *	|   __ <  ||  _  ||  _  ||     <|  ||     ||  _  |
 *	|______/__||_____||_____||__|\__|__||__|__||___  |
 *                                             |_____|
 **/

defined( '_JEXEC' ) or die( 'Restricted access' );
jimport( 'joomla.application.component.model' );

/**
 * the controller will automatically load the model that has the same name as
 * the view and will push it into the view.
 * @author Costas
 *
*/
class BlookingModelbookingForm extends JModel
{
	var $_db;

	function getData()
	{
		$data = new stdClass();
		return $data;
	}

	function getCategoryName ($idcategory, $lang)
	{

		if ($idcategory>0)
		{
			$query =  "SELECT * FROM ".
					$this->_db->nameQuote('#__bookitcategory')." WHERE ".
					$this->_db->nameQuote('idcategory')."=".
					$this->_db->quote($idcategory);
			$this->_db->setQuery( $query );
			$res = $this->_db->loadObject();
			if ($lang!='en')
			{
				if(isset($res->{"name_".$lang}))
					$category_name=$res->{"name_".$lang};
				else
					$category_name = $res->name;
			}
			else
			{
				$category_name = $res->name;
			}
		}
		else
		{
			$category_name="";

		}
		return $category_name;
	}

	function getCategoryNames ($idcategories, $lang)
	{
		$category_names="";
		$ids = explode(",", $idcategories);
		for ($i=0; $i<count($ids); $i++)
		{
			$query =  "SELECT * FROM ".
					$this->_db->nameQuote('#__bookitcategory')." WHERE ".
					$this->_db->nameQuote('idcategory')."=".
					$this->_db->quote($ids[$i]);
			$this->_db->setQuery( $query );
			$res = $this->_db->loadObject();
			if ($lang!='en')
			{
				if(isset($res->{"name_".$lang}))
					$category_name=$res->{"name_".$lang};
				else
					$category_name = $res->name;
			}
			else
			{
				$category_name = $res->name;
			}
			if ($i<count($ids)-1)
				$category_names .= $category_name.", ";
			else
				$category_names .= $category_name;
		}

		return $category_names;
	}


	function getCategoryDetails ($idcategory)
	{
		$query = "SELECT * FROM #__bookitcategory WHERE idcategory =".
				$idcategory.";";
		$this->_db->setQuery($query);
		$re = $this->_db->loadObject();
		return $re;
	}

	function getExtras()
	{
		//neg_xtra
		$sql = "SELECT * FROM ".$this->_db->nameQuote('#__bookitextra').
		" WHERE ".$this->_db->nameQuote('published')."=".$this->_db->quote('1').
		" AND (".$this->_db->nameQuote('value_fix')." != ".
		$this->_db->quote('0')." OR ".
		$this->_db->nameQuote('value_percent')." > ".
		$this->_db->quote('0').") ORDER BY ".$this->_db->nameQuote('ordering')." ASC";
		$this->_db->setQuery($sql);
		return $this->_db->loadObjectList();
	}

	function getPrefArray ()
	{
		$sql = 'SELECT * FROM #__bookitextra WHERE value_fix=\'0\' AND
				value_percent=\'0\' ORDER BY name';
		$this->_db->setQuery($sql);
		return $this->_db->loadObjectList();
	}
	function getNights ($from, $to)
	{
		$from_time = strtotime($from);
		$to_time = strtotime($to);
		return (round( ($to_time-$from_time )/86400)) ;
	}

	function isLateBooking ($from, $days)
	{
		$from_time = strtotime($from);
		$to_time = strtotime(date('Ymd'));
		$days_left =  round( ($from_time - $to_time )/86400);

		return ($days_left > $days) ? false : true;
	}


	function getRoomExtrasTextSingleMode ($price, $idcategory, $nights,
			$nguests, $nchilds, $currency, $deposit, $mode, $lang)
	{
		$extras = $this->getExtras();
		$res = new stdClass;
		$res->text = "";
		$res->total_price=$price;
		$extraRes=0;
		$total_price=$price;
		$box_id="";
		$setTitle=false;



		if (count($extras)<=0) return $res;


		for ($i=0; $i<count($extras); $i++)
		{
			$qnt_div="";
			$qnt_box_id="qntbox_".$extras[$i]->idextra;
			$box_id="extrabox_".$extras[$i]->idextra;

			$categories_extra_applies = explode(",",
					$extras[$i]->idcategories);
			if (!in_array($idcategory, $categories_extra_applies))
				continue;

			if (!$setTitle)
			{
				$res->text = "<div id='bookit_booking_extras' class='bookit_box'>";
				$res->text .= "<div class='options_heading'>".
						JText::_('COM_BOOKIT_TAXES_EXTRA_SERVICES')."</div>";
				$setTitle=true;
			}
			$extraRes=$this->_getTaxPrice($extras[$i],
					$price, $nights, $nguests, $nchilds);
			$extra_price=number_format ( $extraRes, 2, '.', '');
			$extra_price_str=str_replace(",","",$extra_price);
			$box_id.="=".$extra_price_str;
			$qnt_box_id.="=".$extra_price_str;
			if ($extraRes!=0) //neg_xtr
			{
				$extra_name = $this->_translator($lang, 'name',
					 '#__bookitextra', 'idextra', $extras[$i]->idextra);
				if ($extras[$i]->extra_type==1)//Required
				{
						
					$res->text .= "<div class='bookit_booking_taxes_left'>
							<input type='checkbox' name='".$box_id."' id='".$box_id."'
									disabled='disabled' checked>".$extra_name.
									"</div>";
					$res->text .= "<div class='bookit_booking_taxes_right'>".
							$extra_price." ".$currency."</div>";
					$res->text .= "<div class='bookit_booking_clear'></div>";
						
					$desc = $this->_translator ($lang, 'description',
							'#__bookitextra', 'idextra', $extras[$i]->idextra);
					$res->text .= $desc;
						
					$res->text .= "<div class='bookit_booking_clear'></div>";
					$total_price+=$extraRes;
				}
				elseif ($extras[$i]->extra_type==0)//Optional
				{
					$js1='onclick="return (setQuantity('.$extraRes.
					',\'plus\', \''.$qnt_box_id.'\', \''.$currency.
					'\',0,\''.$deposit.'\',\''.$mode.'\'));"';
					$js2='onclick="return (setQuantity('.$extraRes.
					',\'minus\', \''.$qnt_box_id.'\', \''.$currency.
					'\',0,\''.$deposit.'\',\''.$mode.'\'));"';
					$plus_but="<button class='button' ".$js1.">+</button>";
					$minus_but="<button class='button' ".$js2.">-</button>";

					if ($extras[$i]->value_type==6 ||
							$extras[$i]->value_type==10) //Quantity
					{
						$qnt_div="<div class='bookit_booking_taxes_qnt'>
								<input type='text' size='1' maxlength='3' value='1'
								readonly='readonly' name='".$qnt_box_id."' id='".
								$qnt_box_id."'/>".
								$plus_but.$minus_but."</div>";
					}

					$js='onclick="(editTotal('.$extraRes.',\''.$box_id.'\',\''.
							$currency.'\',0,\''.$deposit.'\',\''.$mode.'\'));"';

					$res->text .= "<div class='bookit_booking_taxes_left'>
							<input type='checkbox' name='".$box_id."'
									id='".$box_id."' ".$js.">".$extra_name.$qnt_div.
									"</div>";
					$res->text .= "<div class='bookit_booking_taxes_right'>".
							$extra_price." ".$currency."</div>";
					$res->text .= "<div class='bookit_booking_clear'></div>";
					$desc = $this->_translator ($lang, 'description',
							'#__bookitextra', 'idextra', $extras[$i]->idextra);
					$res->text .= $desc;
					$res->text .= "<div class='bookit_booking_clear'></div>";
				}
			}
			$extraRes=0;
		}

		if($setTitle)
		{
			$res->text .= "<div class='bookit_booking_clear'></div>";
			$res->text .= "</div>";
		}

		$res->total_price=$total_price;

		return $res;
	}
    function getBookingExtrasTextMultiMode ($price, $nights, $currency, $deposit, $mode, $room_no, $lang)
    {
        $extras = $this->getExtras();
        $res = new stdClass;
        $res->text = "";
        $res->total_price=0;
        $extraRes=0;
        $total_price=0;
        $box_id="";
        $setTitle=false;

        if (count($extras)<=0) return $res;



        for ($i=0; $i<count($extras); $i++)
        {

            $qnt_div="";
            $qnt_box_id="qntbox_".$extras[$i]->idextra."_".$room_no;
            $box_id="extrabox_".$extras[$i]->idextra."_".$room_no;


            if (!$setTitle)
            {
                $res->text = "<div id='bookit_booking_extras_".$room_no."' class='extras_box'>";
                $res->text .= "<div class='options_heading'>".
                    JText::_('COM_BOOKIT_TAXES_EXTRA_SERVICES')."</div>";
                $setTitle=true;
            }

            if ($extras[$i]->value_type==1 )
            {
                if ($extras[$i]->value_fix!=0)//neg_xtra
                {
                    $extraRes = $extras[$i]->value_fix;
                }
                else if ($extras[$i]->value_percent>0)
                {

                    $extraRes= $extras[$i]->value_percent/100*$price;
                }

            }
            else
                $extraRes = 0;


            $extra_price=number_format ( $extraRes, 2, '.', '');
            $extra_price_str=str_replace(",","",$extra_price);
            $box_id.="=".$extra_price_str;
            $qnt_box_id.="=".$extra_price_str;
            if ($extraRes!=0)//neg_xtr
            {
                $extra_name = $this->_translator($lang, 'name',
                    '#__bookitextra', 'idextra', $extras[$i]->idextra);

                if ($extras[$i]->extra_type==1)//Required
                {


                    $res->text .= "<div class='bookit_booking_taxes_left'>
							<input type='checkbox' name='".$box_id."' id='".$box_id."'
									disabled='disabled' checked>".$extra_name.
                        "</div>";
                    $res->text .= "<div class='bookit_booking_taxes_right'>".
                        $extra_price." ".$currency."</div>";
                    $res->text .= "<div class='bookit_booking_clear'></div>";

                    $desc = $this->_translator ($lang, 'description',
                        '#__bookitextra', 'idextra', $extras[$i]->idextra);
                    $res->text .= $desc;
                    $res->text .= "<div class='bookit_booking_clear'></div>";
                    $total_price+=$extraRes;
                }
                elseif ($extras[$i]->extra_type==0)//Optional
                {
                    $js1='onclick="return (setQuantity('.$extraRes.
                        ',\'plus\', \''.$qnt_box_id.'\', \''.$currency.
                        '\',1,\''.$deposit.'\',\''.$mode.'\'));"';
                    $js2='onclick="return (setQuantity('.$extraRes.
                        ',\'minus\', \''.$qnt_box_id.'\', \''.$currency.
                        '\',1,\''.$deposit.'\',\''.$mode.'\'));"';
                    $plus_but="<button class='button' ".$js1.">+</button>";
                    $minus_but="<button class='button' ".$js2.">-</button>";

                    if ($extras[$i]->value_type==6 ||
                        $extras[$i]->value_type==10) //Quantity
                    {
                        $qnt_div="<div class='bookit_booking_taxes_qnt'>
								<input type='text' size='1' maxlength='3' value='1'
								readonly='readonly' name='".$qnt_box_id."' id='".
                            $qnt_box_id."'/>".
                            $plus_but.$minus_but."</div>";
                    }

                    $js='onclick="(editTotal('.$extraRes.',\''.$box_id.'\',\''.
                        $currency.'\',1,\''.$deposit.'\',\''.$mode.'\'));"';

                    $res->text .= "<div class='bookit_booking_taxes_left'>
							<input type='checkbox' name='".$box_id."'
									id='".$box_id."' ".$js.">".$extra_name.$qnt_div.
                        "</div>";
                    $res->text .= "<div class='bookit_booking_taxes_right'>".
                        $extra_price." ".$currency."</div>";
                    $res->text .= "<div class='bookit_booking_clear'></div>";

                    $desc = $this->_translator ($lang, 'description',
                        '#__bookitextra', 'idextra', $extras[$i]->idextra);
                    $res->text .= $desc;
                    $res->text .= "<div class='bookit_booking_clear'></div>";
                }
            }

            $extraRes=0;
        }

        if($setTitle)
        {
            $res->text .= "<div class='bookit_booking_clear'></div>";
            $res->text .= "</div>";
        }

        $res->total_price=$total_price;


        return $res;
    }


	function getRoomExtrasTextMultiMode ($price, $idcategory, $nights,
			$nguests, $nchilds, $currency, $deposit, $mode, $room_no, $lang)
	{
		$extras = $this->getExtras();
		$res = new stdClass;
		$res->text = "";
		$res->total_price=0;
		$extraRes=0;
		$total_price=0;
		$box_id="";
		$setTitle=false;


		if (count($extras)<=0) return $res;

		for ($i=0; $i<count($extras); $i++)
		{
            if ($extras[$i]->value_type==1) continue;

            $qnt_div="";
			$qnt_box_id="qntbox_".$extras[$i]->idextra."_".$room_no;
			$box_id="extrabox_".$extras[$i]->idextra."_".$room_no;

			$categories_extra_applies = explode(",",
					$extras[$i]->idcategories);
			if (!in_array($idcategory, $categories_extra_applies))
				continue;

			if (!$setTitle)
			{
				$res->text = "<div id='bookit_booking_extras_".$room_no."' class='extras_box'>";
				$res->text .= "<div class='options_heading'>".
						JText::_('COM_BOOKIT_TAXES_EXTRA_SERVICES')."</div>";
				$setTitle=true;
			}
			$extraRes=$this->_getTaxPrice($extras[$i],
					$price, $nights, $nguests, $nchilds);
			$extra_price=number_format ( $extraRes, 2, '.', '');
			$extra_price_str=str_replace(",","",$extra_price);
			$box_id.="=".$extra_price_str;
			$qnt_box_id.="=".$extra_price_str;
			if ($extraRes!=0)//neg_xtr
			{
				$extra_name = $this->_translator($lang, 'name',
					 '#__bookitextra', 'idextra', $extras[$i]->idextra);

				if ($extras[$i]->extra_type==1)//Required
				{
						
						
					$res->text .= "<div class='bookit_booking_taxes_left'>
							<input type='checkbox' name='".$box_id."' id='".$box_id."'
									disabled='disabled' checked>".$extra_name.
									"</div>";
					$res->text .= "<div class='bookit_booking_taxes_right'>".
							$extra_price." ".$currency."</div>";
					$res->text .= "<div class='bookit_booking_clear'></div>";
						
					$desc = $this->_translator ($lang, 'description',
							'#__bookitextra', 'idextra', $extras[$i]->idextra);
					$res->text .= $desc;
					$res->text .= "<div class='bookit_booking_clear'></div>";
					$total_price+=$extraRes;
				}
				elseif ($extras[$i]->extra_type==0)//Optional
				{
					$js1='onclick="return (setQuantity('.$extraRes.
					',\'plus\', \''.$qnt_box_id.'\', \''.$currency.
					'\',1,\''.$deposit.'\',\''.$mode.'\'));"';
					$js2='onclick="return (setQuantity('.$extraRes.
					',\'minus\', \''.$qnt_box_id.'\', \''.$currency.
					'\',1,\''.$deposit.'\',\''.$mode.'\'));"';
					$plus_but="<button class='button' ".$js1.">+</button>";
					$minus_but="<button class='button' ".$js2.">-</button>";

					if ($extras[$i]->value_type==6 ||
							$extras[$i]->value_type==10) //Quantity
					{
						$qnt_div="<div class='bookit_booking_taxes_qnt'>
								<input type='text' size='1' maxlength='3' value='1'
								readonly='readonly' name='".$qnt_box_id."' id='".
								$qnt_box_id."'/>".
								$plus_but.$minus_but."</div>";
					}

					$js='onclick="(editTotal('.$extraRes.',\''.$box_id.'\',\''.
							$currency.'\',1,\''.$deposit.'\',\''.$mode.'\'));"';

					$res->text .= "<div class='bookit_booking_taxes_left'>
							<input type='checkbox' name='".$box_id."'
									id='".$box_id."' ".$js.">".$extra_name.$qnt_div.
									"</div>";
					$res->text .= "<div class='bookit_booking_taxes_right'>".
							$extra_price." ".$currency."</div>";
					$res->text .= "<div class='bookit_booking_clear'></div>";
						
					$desc = $this->_translator ($lang, 'description',
							'#__bookitextra', 'idextra', $extras[$i]->idextra);
					$res->text .= $desc;
					$res->text .= "<div class='bookit_booking_clear'></div>";
				}
			}

			$extraRes=0;
		}

		if($setTitle)
		{
			$res->text .= "<div class='bookit_booking_clear'></div>";
			$res->text .= "</div>";
		}

		$res->total_price=$total_price;


		return $res;
	}

	function getPreferencesText ($idcategory, $lang)
	{
		$pref_array = $this->getPrefArray();
		$res = new stdClass;
		$res->text = "";
		$res->text = "<div id='bookit_booking_preferences' class='bookit_box'>";
		$setTitle=false;
		if (count($pref_array)>0)
		{
			for ($i=0; $i<count($pref_array); $i++)
			{
				$box_id="prefbox_".$pref_array[$i]->idextra;
				$qnt_box_id="qntprefbox_".$pref_array[$i]->idextra;
				$qnt_div="";
					
				$categories_extra_applies = explode(",",
						$pref_array[$i]->idcategories);
				if (!in_array($idcategory, $categories_extra_applies))
					continue;
					
				if (!$setTitle)
				{
					$res->text .= "<div class='options_heading'>".
							JText::_('COM_BOOKIT_BOOKING_PREFERENCES')."</div>";
					$setTitle=true;
				}

				if ($pref_array[$i]->value_type==6 ||
						$pref_array[$i]->value_type==10) //Quantity
				{
					$js1='onclick="return (setQuantityOnly(\'plus\', \''.
							$qnt_box_id.'\'));"';
					$js2='onclick="return (setQuantityOnly(\'minus\', \''.
							$qnt_box_id.'\'));"';
					$plus_but="<button class='button' ".$js1.">+</button>";
					$minus_but="<button class='button' ".$js2.">-</button>";
					$qnt_div="<div class='bookit_booking_pref_qnt'>
							<input type='text' size='1' maxlength='3' value='1'
							name='".$qnt_box_id."' readonly='readonly'
									id='".$qnt_box_id."'/>".$plus_but.$minus_but."</div>";
				}
				$res->text .= "<span class='bookit_booking_pref_left'>";
				$res->text .= "</span>";

				$pref_name = $this->_translator ($lang, 'name',
						'#__bookitextra', 'idextra', $pref_array[$i]->idextra);
				$res->text .= "<input type='checkbox' name='".$box_id."' id='".$box_id."'/>";
				$res->text .=$pref_name.$qnt_div;
				$res->text .= "<p>";
					
				$desc = $this->_translator ($lang, 'description',
						'#__bookitextra', 'idextra', $pref_array[$i]->idextra);

				$res->text .= $desc;
				$res->text .= "</p>";
					
			}
		}
		$res->text .= "<div id='bookit_booking_pref_requests'>
				<p class='options_heading'>".
				JText::_("COM_BOOKIT_SPECIAL_REQUESTS")."</p>";
		$res->text .= "<textarea rows='2' cols='50' name='preferences'
				id='preferences'></textarea>";
		$res->text .= "</div>";


		$res->text .= "<div class='bookit_booking_clear'></div>";
		$res->text .= "</div>";
		$res->text .= "<div class='bookit_booking_clear'></div>";
		return $res->text;
	}
	function getMultiPreferencesText ($idcategory, $room_no, $lang)
	{

        $pref_array = $this->getPrefArray();
		$res = new stdClass;
		$res->text = "";
		$res->text = "<div id='bookit_booking_preferences_".$room_no."' class='prefs_box'>";
		$setTitle = false;
		if (count($pref_array)>0)
		{

			for ($i=0; $i<count($pref_array); $i++)
			{
				$box_id="prefbox_".$pref_array[$i]->idextra."_".$room_no;
				$qnt_box_id="qntprefbox_".$pref_array[$i]->idextra."_".$room_no;
				$qnt_div="";
					
				$categories_extra_applies = explode(",",
						$pref_array[$i]->idcategories);
				if (!in_array($idcategory, $categories_extra_applies))
					continue;

				if (!$setTitle)
				{
					$res->text .= "<div class='options_heading'>".
							JText::_('COM_BOOKIT_BOOKING_PREFERENCES')."</div>";
					$setTitle=true;
				}
					
				if ($pref_array[$i]->value_type==6 ||
						$pref_array[$i]->value_type==10) //Quantity
				{
					$js1='onclick="return (setQuantityOnly(\'plus\', \''.
							$qnt_box_id.'\'));"';
					$js2='onclick="return (setQuantityOnly(\'minus\', \''.
							$qnt_box_id.'\'));"';
					$plus_but="<button class='button' ".$js1.">+</button>";
					$minus_but="<button class='button' ".$js2.">-</button>";
					$qnt_div="<div class='bookit_booking_pref_qnt'>
							<input type='text' size='1' maxlength='3' value='1'
							name='".$qnt_box_id."' readonly='readonly'
									id='".$qnt_box_id."'/>".$plus_but.$minus_but."</div>";
				}
				$res->text .= "<span class='bookit_booking_pref_left'>";
				$res->text .= "</span>";
				$res->text .= "<input type='checkbox' name='".$box_id."' id='".$box_id."'/>";
				$pref_name = $this->_translator ($lang, 'name',
						'#__bookitextra', 'idextra', $pref_array[$i]->idextra);
				$res->text .=$pref_name.$qnt_div;
				$res->text .= "<p>";

				$desc = $this->_translator ($lang, 'description',
						'#__bookitextra', 'idextra', $pref_array[$i]->idextra);
				$res->text .= $desc;
				$res->text .= "</p>";

					
			}
		}
		$res->text .= "<div id='bookit_booking_pref_requests'>
				<p class='options_heading'>".
				JText::_("COM_BOOKIT_SPECIAL_REQUESTS")."</p>";
		$res->text .= "<textarea rows='2' cols='50' name='preferences'
				id='preferences_".$room_no."_e' value=''></textarea>";
		$res->text .= "</div>";


		$res->text .= "<div class='bookit_booking_clear'></div>";
		$res->text .= "</div>";
		$res->text .= "<div class='bookit_booking_clear'></div>";
		return $res->text;
	}





	function _getTaxPrice($extraRow, $priceReg, $nights, $adults, $childs)
	{

		//1=booking; 2=night; 3=guest; 4=adult; 5=child; 6=quantity;
		//7=guest/night; 8=adult/night; 9=child/night; 10=quantity/night;

		if ($extraRow->value_type==1)//Per booking
		{

            if ($extraRow->value_fix!=0)//neg_xtra
			{
				return $extraRow->value_fix;
			}
			else if ($extraRow->value_percent>0)
			{
					
				return $extraRow->value_percent/100*$priceReg;
			}

		}
		else if ($extraRow->value_type==2)//Per night
		{
			if ($extraRow->value_fix>0)
			{
				return $extraRow->value_fix*$nights;
			}
			else if ($extraRow->value_percent>0)
			{
				return $extraRow->value_percent/100*$priceReg*$nights;
			}
		}
		else if ($extraRow->value_type==3)//Per person
		{
			if ($extraRow->value_fix>0)
			{
				return $extraRow->value_fix*($adults+$childs);
			}
			else if ($extraRow->value_percent>0)
			{
				return $extraRow->value_percent/100*$priceReg*($adults+$childs);
			}
		}
		else if ($extraRow->value_type==4)//Per adult
		{
			if ($extraRow->value_fix>0)
			{
				return $extraRow->value_fix*$adults;
			}
			else if ($extraRow->value_percent>0)
			{
				return $extraRow->value_percent/100*$priceReg*$adults;
			}
		}
		else if ($extraRow->value_type==5)//Per child
		{
			if ($extraRow->value_fix>0)
			{
				return $extraRow->value_fix*$childs;
			}
			else if ($extraRow->value_percent>0)
			{
				return $extraRow->value_percent/100*$priceReg*$childs;
			}
		}
		else if ($extraRow->value_type==6)//Per quantity
		{
			if ($extraRow->value_fix>0)
			{
				return $extraRow->value_fix;
			}
			else if ($extraRow->value_percent>0)
			{
				return $extraRow->value_percent/100*$priceReg;
			}
		}
		else if ($extraRow->value_type==7)//Per guest/night
		{
			if ($extraRow->value_fix>0)
			{
				return $extraRow->value_fix*($adults+$childs)*$nights;
			}
			else if ($extraRow->value_percent>0)
			{
				return $extraRow->value_percent/100*$priceReg*($adults+$childs)*$nights;
			}
		}
		else if ($extraRow->value_type==8)//Per adult/night
		{
			if ($extraRow->value_fix>0)
			{
				return $extraRow->value_fix*$adults*$nights;
			}
			else if ($extraRow->value_percent>0)
			{
				return $extraRow->value_percent/100*$priceReg*$adults*$nights;
			}
		}
		else if ($extraRow->value_type==9)//Per child/night
		{
			if ($extraRow->value_fix>0)
			{
				return $extraRow->value_fix*$childs*$nights;
			}
			else if ($extraRow->value_percent>0)
			{
				return $extraRow->value_percent/100*$priceReg*$childs*$nights;
			}
		}

		else if ($extraRow->value_type==10)//Per quantity/night
		{
			if ($extraRow->value_fix>0)
			{
				return $extraRow->value_fix*$nights;
			}
			else if ($extraRow->value_percent>0)
			{
				return $extraRow->value_percent/100*$priceReg*$nights;
			}
		}


	}

	//-----------------------COUPON VALIDATION---------------------------------
	function couponvalidation($data)
	{
		$res=new stdClass();
		$res->code=0;
		$res->discount=0;

		$start= $this->_toMysqlDateFormat ($data['valid_from']);
		$end = $this->_toMysqlDateFormat($data['valid_to']);

		$nguests = $data['nguests'];
		$nchilds = $data['nchilds'];
		$idcategory = $data['idcategory'];

		$case1 =  $this->_db->nameQuote('valid_from')." <= ".
				$this->_db->quote($start)." AND ".
				$this->_db->nameQuote('valid_to')." > ".$this->_db->quote($start);

		$case2 = $this->_db->nameQuote('valid_from')." >= ".
				$this->_db->quote($start)." AND ".$this->_db->nameQuote('valid_from').
				" < ".$this->_db->quote($end);

		$case4=$this->_db->nameQuote('type')." = ".$this->_db->quote('3').
		" AND ".$this->_db->quote($nguests)." > ".$this->_db->nameQuote('xvar');

		$case5=$this->_db->nameQuote('type')." = ".$this->_db->quote('4').
		" AND ".$this->_db->quote($nchilds)." > ".$this->_db->nameQuote('xvar');

		$case6=$this->_db->nameQuote('type')." = ".$this->_db->quote('5').
		" AND ".$this->_db->quote($nchilds+$nguests)." > ".
		$this->_db->nameQuote('xvar');

		$case7=$this->_db->nameQuote('type')." = ".$this->_db->quote('2').
		" AND ".$this->_db->quote($data['nights'])." > ".$this->_db->nameQuote('xvar');

		$case8=$this->_db->nameQuote('type')." = ".$this->_db->quote('6').
		" AND ".$this->_db->quote($data['nights'])." < ".$this->_db->nameQuote('xvar');



		$query = "SELECT * FROM ".
				$this->_db->nameQuote('#__bookitrules').
				" WHERE ".$this->_db->nameQuote('published')." = ".
				$this->_db->quote('1').
				" AND ".$this->_db->nameQuote('coupon')." = ".$this->_db->quote('1').
				" AND ".$this->_db->nameQuote('quantity')." > ".
				$this->_db->nameQuote('times_used').
				" AND ( (".$case1.") OR (".$case2.")) AND (".
				"(".$case4.") OR (".$case5.")  OR (".$case8.") OR (".$case6.") OR (".$case7.")) AND ".
				$this->_db->nameQuote('code')." = ".
				$this->_db->quote($data['coupon_code']);

		$this->_db->setQuery($query);
		$row = $this->_db->loadObject();

		if (isset($row))
		{
			$coupon = $this->_filterCouponByCategory($row, $data['idcategory']);

			if (isset($coupon->rule))
			{

				$res->code=$coupon->rule->idrule;
				$category = $this->_getCategory($coupon->idcategory);
				$discount = $this->_getPriceDeviations ($data['price'],
						$coupon->rule, $category, $nguests, $nchilds);
				if ($discount==0)
					$discount =
					$this->_getOverXGuestPriceDeviations ($coupon->rule, $category,
							$nguests, $nchilds);
				$res->discount = number_format(abs($discount), 2, '.', '');

				return $res;
			}
		}
		return $res;
	}
	function _getPriceDeviations ($price, $rule, $category, $nguests, $nchild)
	{
		$cost = $category->cost;
		$adult_cost = $category->adult_cost;
		$child_cost = $category->child_cost;
		$price_deviation=0.00;

		if ($rule->apply_on==0) //Apply the offer/charge on total amount
		{
			if ($rule->price_mode==0)//Charge per room
			{
				if ($rule->value_mode==0) //fixed
				{
					if ($rule->mode==1) //offer
					{
						$price_deviation -= $rule->value;
					}
				}
				else //Percentage
				{
					if ($rule->mode==1) //offer
					{
						$price_deviation -= $price*$rule->value*0.01;
					}
				}
			}
			else //charge per guest
			{
				if ($rule->value_mode==0) //fixed
				{
					if ($rule->mode==1) //offer
					{
						$price_deviation -= $rule->value*$nguests +
						$rule->value_child*$nchild;
					}
				}
				else //Percentage
				{
					if ($rule->mode==1) //offer
					{
						$price_deviation -=
						($price*$rule->value*0.01*$nguests) +
						($price*$rule->value_child*0.01* $nchild);
					}
				}
			}
		}
		return $price_deviation;

	}

	function _getOverXGuestPriceDeviations ($rule, $category, $nguests, $nchild)
	{
		$cost = $category->cost;
		$adult_cost = $category->adult_cost;
		$child_cost = $category->child_cost;

		$price_deviation=0.00;

		switch ($rule->type)
		{
			case 3:
				$new_nguests = $nguests-$rule->xvar;
				break;
			case 4:
				$new_nchild = $nchild-$rule->xvar;
				break;
			case 5:
				$new_nguests = ($nguests+$nchild-$rule->xvar);
				break;
			default:
				$new_nguests = $nguests;
				$new_nchild = $nchild;
				break;
		}
		if ($rule->apply_on==0) //Apply the offer/charge on total amount
		{
			if ($rule->price_mode==0)//Charge per room
			{
				if ($rule->value_mode==0) //fixed
				{
					if ($rule->mode==1) //offer
					{
						$price_deviation -= $rule->value;
					}

				}
				else //Percentage
				{
					if ($rule->mode==1) //offer
					{
						$price_deviation -= $price*$rule->value*0.01;
					}

				}
			}
			else //charge per guest
			{
				if ($rule->value_mode==0) //fixed
				{
					if ($rule->mode==1) //offer
					{
						if ($rule->type==3 || $rule->type==5)
							$price_deviation -= $rule->value*$new_nguests;
						else if ($rule->type==4)
							$price_deviation -= $rule->value_child*$new_nchild;
					}

				}
				else //Percentage
				{
					if ($rule->mode==1) //offer
					{
						if ($rule->type==3 || $rule->type==5)
							$price_deviation -=
							($price*$rule->value*0.01*$new_nguests);
						else if ($rule->type==4)
							$price_deviation -=
							($price*$rule->value_child*0.01*$new_nchild);
					}
				}
			}
		}
		return $price_deviation;

	}
	function _filterRuleByCategory ($rule, $idcategory)
	{
		$res = new stdClass();
		$res->rule=null;
		$res->idcategory="";

		if (isset($rule))
		{
			if (strpos($idcategory,",")>0)//multiroom
			{
				$idcategories = explode(",", $idcategory);
				foreach ($idcategories as $idcategory)
				{

					$categories = explode (",",$rule->idcategory);
					if (in_array($idcategory, $categories))
					{
						$res->rule= $rule;
						$res->idcategory = $idcategory;
						return $res;
					}
				}
			}
			else
			{

				$categories = explode (",",$rule->idcategory);
				if (!in_array($idcategory, $categories))
					return $res;
				else
				{
					$res->rule= $rule;
					$res->idcategory = $idcategory;
					return $res;
				}

			}
		}
		return $res;
	}
	function _filterCouponByCategory ($rule, $idcat)
	{
		$res = new stdClass();
		$res->rule=null;
		$res->idcategory="";

		if (isset($rule))
		{
			if (strpos($idcat,",")>0)//multiroom
			{
				$idcategories = explode(",", $idcat);
				foreach ($idcategories as $idcategory)
				{

					$categories = explode (",",$rule->idcategory);
					if (!in_array($idcategory, $categories))
					{
						$res->rule=null;
						$res->idcategory="";
						return $res;
					}
				}
			}
			else
			{

				$categories = explode (",",$rule->idcategory);
				if (!in_array($idcat, $categories))
					return $res;
			}
			$res->rule= $rule;
			$res->idcategory = $idcat;
		}
		return $res;
	}


	function _toMysqlDateFormat ($dateString)
	{
		$date_format = $this->_getDateFormat ();
		$originalDate = strtotime($dateString);
		return date("Y-m-d", $originalDate);
	}
	function _getDateFormat ()
	{
		JLoader::register('BlookingHelper',
		JPATH_COMPONENT_ADMINISTRATOR.'/helpers/BlookingHelper.php');

		$params = BlookingHelper::getParams();
		$dateformatcode = $params->dateformat;
		if ($dateformatcode==""||$dateformatcode==3)
			$d1='d-m-Y';
		else if ($dateformatcode==1)
			$d1='Y-m-d';
		else if ($dateformatcode==2)
			$d1='m/d/Y';
		return $d1;
	}

	function _getCategory($id)
	{

		$sql = "SELECT * FROM ".$this->_db->nameQuote("#__bookitcategory").
		" WHERE ".
		$this->_db->nameQuote("idcategory")." = ".$this->_db->quote($id);
		$this->_db->setQuery($sql);
		return $this->_db->loadObject();
	}

	function getUtil ($name)
	{


		JLoader::register('BlookingHelper',
		JPATH_COMPONENT_ADMINISTRATOR.'/helpers/BlookingHelper.php');
		if(BlookingHelper::columnExists('#__bookitutils', $name))
		{
			$sql = "SELECT ".$this->_db->nameQuote($name)." FROM ".
					$this->_db->nameQuote("#__bookitutils")." WHERE ".
					$this->_db->nameQuote("id")." = ".$this->_db->quote('1');
			$this->_db->setQuery($sql);
			return $this->_db->loadResult();
		}
		return "";
	}

	function _translator ($lang, $column, $table, $idkey, $idvalue)
	{

		$sql = "SELECT * FROM ".$this->_db->nameQuote($table)." WHERE ".
				$this->_db->nameQuote($idkey)."=".$this->_db->quote($idvalue);
		$this->_db->setQuery($sql);
		$obj = $this->_db->loadObject();

		if($lang!='en')
		{
			$new_column=$column.'_'.$lang;
			if(isset($obj->{$new_column}))
				return $obj->{$new_column};
		}
		return $obj->{$column};

	}

}
