<?php
/**
 * BlooKing - The King in Joomla Booking
 * @version 1.0
 * @author BlooKing.org. Based on BooKiTGold code by Costas Kakousis
 * @copyright (C) 2012-2013 by BlooKing.org (http://www.blooking.org)
 * @license GNU/GPL: http://www.gnu.org/copyleft/gpl.html
 *
 * If you fork this to create your own project, please make a reference to
 * BlooKing! someplace in your code and provide a link to
 * http://www.blooking.org
 *
 * This file is part of BlooKing! BlooKing is free software: you can
 * redistribute it and/or modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * BlooKing is distributed in the hope that it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details. You should have received a copy of the GNU General Public License
 * along with BlooKing.  If not, see <http://www.gnu.org/licenses/>.
 *   ______ __                __  __ __
 *	|   __ \  |.-----..-----.|  |/  |__|.-----..-----.
 *	|   __ <  ||  _  ||  _  ||     <|  ||     ||  _  |
 *	|______/__||_____||_____||__|\__|__||__|__||___  |
 *                                             |_____|
 **/

defined( '_JEXEC' ) or die( 'Restricted access' );
jimport( 'joomla.application.component.model' );

class BlookingModelFinalform extends JModel {
	var $_db;
	function __construct()
	{
		parent::__construct();
		JLoader::register('BlookingHelper',
		JPATH_COMPONENT_ADMINISTRATOR.'/helpers/BlookingHelper.php');
	}

	function getUtils() {
		$bookingid = "SELECT * FROM ".$this->_db->nameQuote('#__bookitutils').
		" WHERE ".$this->_db->nameQuote('id').
		"=".$this->_db->quote('1');
		$this->_db->setQuery($bookingid);
		return $this->_db->loadObject();
	}

	function getCountries () {
		//		$sql = "SELECT idcountry, name FROM #__bookitcountry ORDER BY name";
		//		$this->_db->setQuery($sql);
		//		return $this->_db->loadObjectList();

		return BlookingHelper::getCountries();
	}

	function cancelBooking($id) {
		$params = BlookingHelper::getParams();
		$cancvalue = $params->daysForCancellation;

		//Check the booking ID is within the cancellation period
		$bookingid = "SELECT ".$this->_db->nameQuote('idbook')." FROM ".
				$this->_db->nameQuote('#__bookitbooking').
				" WHERE (CURDATE() <= DATE_SUB(".$this->_db->nameQuote('valid_from').
				",INTERVAL ".$cancvalue." day)) AND ".$this->_db->nameQuote('status').
				"=".$this->_db->quote('1')." AND ".$this->_db->nameQuote('idbook').
				"=".$this->_db->quote($id);
		$this->_db->setQuery($bookingid);
		$idBooking = $this->_db->loadResult();

		if ($idBooking > 0) {
			$query =  "UPDATE ".$this->_db->nameQuote('#__bookitbooking')." SET ".
					$this->_db->nameQuote('status')."=".$this->_db->quote('5')." WHERE ".
					$this->_db->nameQuote('idbook')."=".$this->_db->quote($idBooking);
			$this->_db->setQuery( $query );
			$result = $this->_db->query();

			$query2 =  "SELECT ".$this->_db->nameQuote('idcoupon').
			" FROM ".$this->_db->nameQuote('#__bookitbooking').
			" WHERE ".$this->_db->nameQuote('idbook')."=".$this->_db->quote($id);
			$this->_db->setQuery( $query2 );
			$coup = $this->_db->loadResult();

			if ($coup > 0) {
				$query =  "UPDATE ".$this->_db->nameQuote('#__bookitrules').
				" SET ".$this->_db->nameQuote('times_used').
				"=".$this->_db->nameQuote('times_used')."-1 WHERE ".
				$this->_db->nameQuote('idrule')."=".$this->_db->quote($coup);
				$this->_db->setQuery( $query );
				$result = $this->_db->query();
			}
			return true;
		} else {
			return false;
		}
	}

	function getSubject($type, $lang) {
		$db =& JFactory::getDBO();
		$sql = "SELECT * FROM ".
				$this->_db->nameQuote('#__bookitutils')." WHERE ".
				$this->_db->nameQuote('id').'='.$this->_db->quote('1');
		$db->setQuery($sql);
		$obj = $db->loadObject();

		if($lang!='en')
		{
			if(isset($obj->{$type."_".$lang}))
				return $obj->{$type."_".$lang};
		}
		return $obj->{$type};

	}

	function getBookingDetailsForEmail($bookingid) {
		$db =& JFactory::getDBO();
		$query = "SELECT * FROM ".$db->nameQuote('#__bookitbooking')." WHERE ".
				$db->nameQuote('idbook')." = ".$db->quote($bookingid).";";
		$db->setQuery($query);
		$booking_row = $db->loadObject();

		$lang =& JFactory::getLanguage();
		$lang->setLanguage($booking_row->lang);
		$lang->load();

		$query = "SELECT * FROM ".$db->nameQuote('#__bookitguests')." WHERE ".
				$db->nameQuote('idguests')." = ".$db->quote($booking_row->idguests).";";
		$db->setQuery($query);
		$guest_row = $db->loadObject();

		$query = "SELECT * FROM ".$db->nameQuote('#__bookitutils').";";
		$db->setQuery($query);
		$utils = $db->loadObject();

		$params = BlookingHelper::getParams();
			
		$d1 = $this->_getDateFormat();
		$currency = $params->currency;

		$valid_from = date ($d1, strtotime($booking_row->valid_from));
		$valid_to = date ($d1,strtotime($booking_row->valid_to));

		$valid_from_new = date ("Y-m-d", strtotime($booking_row->valid_from));
		$valid_to_new = date ("Y-m-d",strtotime($booking_row->valid_to));
		$fromDateTS = strtotime($valid_from_new);
		$toDateTS = strtotime($valid_to_new);
		$nights=round( ($toDateTS-$fromDateTS )/86400) ;

		$root = JURI::root();
		$encryptedID = base64_encode($bookingid);
		$link = JRoute::_($root.'index.php?option=com_blooking&controller=finalform&task=cancelBooking&idbook='.$encryptedID.'">'.JText::_("COM_BOOKIT_CANCEL_BOOKING"));
		$cancelbookinglink = '<a href="'.$link.'</a>';

		$query = "SELECT name FROM #__bookitcountry WHERE idcountry='".$guest_row->idcountry."'";
		$db->setQuery($query);
		$country_name=$db->loadResult();
		//$refid = $bookingid+1000;
		$refid = "";

		$ids = array();
		if ($booking_row->coids!="") // Multiroom
		{
			$refid="";
			$ids = explode (",",$booking_row->coids);
		}
		array_push($ids, $bookingid);
		sort($ids);
		$cat_qnt = array();
		$adults=0;
		$childs=0;
		$guests=0;
		$extra_ids="";
		$extra_table = "";
		$extra_price = "";
		$preferences = "";
		$value_full=0.00;
		$value_paid=0.00;


		foreach ($ids as $id)
		{
				
			$rid = $id+1000;
			if ($refid!="")$refid .= ", ";
			$refid .= $rid;


				
			$query = "SELECT * FROM ".$db->nameQuote('#__bookitbooking')." WHERE ".
					$db->nameQuote('idbook')." = ".$db->quote($id);
			$db->setQuery($query);
			$booking_row = $db->loadObject();

			$query = "SELECT ".$db->nameQuote('name')." FROM ".
					$db->nameQuote('#__bookitroom')." WHERE ".
					$db->nameQuote('idroom')." = ".$db->quote($booking_row->idroom);
			$db->setQuery($query);
			$room_name = $db->loadResult();
				
				
			$query = "SELECT * FROM ".$db->nameQuote('#__bookitcategory').
			" WHERE ".$db->nameQuote('idcategory')."=".
			$db->quote($booking_row->idcategory);
			$db->setQuery($query);
			$row=$db->loadObject();
			if (isset($row->{"name_".$booking_row->lang}))
				$cat_name = $row->{"name_".$booking_row->lang};
			else
				$cat_name = $row->name;

			if (isset($cat_qnt[$cat_name]))
				$cat_qnt[$cat_name]+=1;
			else
				$cat_qnt[$cat_name]=1;

			$adults += $booking_row->nguests;
			$childs += $booking_row->nchilds;
			$guests += $booking_row->nguests + $booking_row->nchilds;

			$extra_ids=$booking_row->extra_ids;
			if ($booking_row->preferences!="")
			{
				$preferences .= $booking_row->preferences." (".$room_name.")";
				$preferences .= "<br />";
			}
			if ($extra_ids != "")
			{
				$extras = explode (",", $extra_ids);
				foreach ($extras as $extra)
				{
					if ($extra<=0) continue;
					$nq = explode ("-", $extra);
					$query = "SELECT * FROM ".$db->nameQuote('#__bookitextra').
					" WHERE ".$db->nameQuote('idextra')."=".$nq['0'];
					$db->setQuery($query);
					$row = $db->loadObject();
					if (isset($row->{'name_'.$booking_row->lang}))
						$extra_name=$row->{'name_'.$booking_row->lang};
					else
						$extra_name=$row->name;


					if (isset($booking_row->initial_price))
						$p=$booking_row->initial_price;
					else
						$p=$booking_row->value_full;
					$extra_price .= $this->_getExtraServicesPriceDeviations(
							$extra, $p, $nights, $adults, $childs);

					$extra_price .= "<br />";

					if (count($nq)>1){
						//With name
						//$extra_table .= $extra_name." (x ".$nq['1'].") (".$room_name.")<br />";
						$extra_table .= $extra_name." (x ".$nq['1'].") <br />";
					} else {
						//With name
						//$extra_table .= $extra_name." (".$room_name.")<br />";
						$extra_table .= $extra_name." <br />";
					}
				}
			}
			$value_full += $booking_row->value_full;
			$value_paid += $booking_row->value_paid;
		}

		$cat_name="";
		$i=0;
		foreach ($cat_qnt as $k=>$v )
		{
			if($i==count($cat_qnt)-1){
				$cat_name .= $v." x ".$k;
			}
			else $cat_name .= $v." x ".$k.", ";
			$i++;
		}

		$bookingstatus = $booking_row->status;

		switch ($bookingstatus) {
			case 1:
				$bookingstatus = JText::_('COM_BOOKIT_BOOKED');
				break;
			case 2:
				$bookingstatus = JText::_('COM_BOOKIT_PENDING');
				break;
			case 4:
				$bookingstatus = JText::_('COM_BOOKIT_EXPIRED');
				break;
			case 5:
				$bookingstatus = JText::_('COM_BOOKIT_CANCELLED');
				break;
			case 6:
				$bookingstatus = JText::_('COM_BOOKIT_PROCESSING');
				break;
			default:
				$bookingstatus = JText::_('COM_BOOKIT_PROCESSING');
		}

		$booking_details = array (
				'firstname' => $guest_row->name,
				'surname' => $guest_row->surname,
				'email' => $guest_row->email,
				'phone' => $guest_row->phone,
				'address1' => $guest_row->address1,
				'address2' => $guest_row->address2,
				'address3' => $guest_row->address3,
				'postcode' => $guest_row->postcode,
				'country' => $country_name,
				'bookingid' => $refid,
				'checkin' => $valid_from,
				'checkout' => $valid_to,
				'nights' => $nights,
				'roomtype' => $cat_name,
				'totalprice' => number_format($value_full,2, '.',''),
				'deposit' => number_format($value_paid,2, '.',''),
				'remainingprice' => number_format($value_full-$value_paid,2, '.',''),
				'adults' => $adults,
				'childs' => $childs,
				'guests' => $guests,
				'extras' => $extra_table,
				'extraprices' => $extra_price,
				'requests' => $preferences,
				'terms' => $this->_translator($booking_row->lang,"terms_conditions", "#__bookitutils","id",1),
				'cancellation_policy' => $this->_translator($booking_row->lang,"cancellation_policy", "#__bookitutils","id",1),
				'cancelbookinglink' => $cancelbookinglink,
				'bookingstatus' => $bookingstatus,
				'paymentmethod' => $booking_row->payment_method,
				'payment_requested' => $booking_row->payment_requested
		);


		return $booking_details;
	}

	function _translator ($lang, $column, $table, $idkey, $idvalue)
	{

		$sql = "SELECT * FROM ".$this->_db->nameQuote($table)." WHERE ".
				$this->_db->nameQuote($idkey)."=".$this->_db->quote($idvalue);
		$this->_db->setQuery($sql);
		$obj = $this->_db->loadObject();

		if($lang!='en')
		{
			$new_column=$column.'_'.$lang;
			if(isset($obj->{$new_column}))
				return $obj->{$new_column};
		}
		return $obj->{$column};

	}


	function _getDateFormat () {
		$params = BlookingHelper::getParams();
		$dateformatcode = $params->dateformat;
		if ($dateformatcode==""||$dateformatcode==3)
			$d1='d-m-Y';
		else if ($dateformatcode==1)
			$d1='Y-m-d';
		else if ($dateformatcode==2)
			$d1='m/d/Y';
		return $d1;
	}

	function _getExtraById ($extra_id) {
		$query =  "SELECT * FROM ".$this->_db->nameQuote("#__bookitextra").
		" WHERE ".$this->_db->nameQuote("idextra")."=".
		$this->_db->quote($extra_id);
		$this->_db->setQuery( $query );
		return $this->_db->loadObject();
	}

	function _getExtraServicesPriceDeviations ($extra_ids, $price, $nights,
			$nguests, $nchilds) {
		if ($extra_ids=="" || $extra_ids<0) return 0.00;

		$res=0.00;
		$qnt=0;
		$extr_id_arr = explode(",", $extra_ids);
		foreach ($extr_id_arr as $extra_id) {
			$r = explode("-", $extra_id);
			if (count($r)>1) {
				$extra_id=$r['0'];
				$qnt=$r['1'];
			}
			else
				$qnt=0;

			$extra = $this->_getExtraById($extra_id);
			/*
			 * `value_type` '1=booking; 2=night; 3=guest; 4=adult; 5=child;
			* 6=quantity; 7=guest/night; 8=adult/night; 9=child/night;
			* 10=quantity/night; '
			*/
			if ($extra->value_type==1) { //Per booking
				if ($extra->value_fix > 0)
					$res += $extra->value_fix;
				else if ($extra->value_percent > 0)
					$res += $extra->value_percent*0.01*$price;
			} else if ($extra->value_type==2) { //Per Night
				if ($extra->value_fix > 0)
					$res += $extra->value_fix*$nights;
				else if ($extra->value_percent > 0)
					$res += ($extra->value_percent*0.01*$price)*$nights;
			} else if ($extra->value_type==3) { //Per guest
				if ($extra->value_fix>0) { //Fix
					if ($nguests!="" && $nguests>0)
						$res += $extra->value_fix*($nguests+$nchilds);
				} else if ($extra->value_percent>0) { //Percent
					if ($nguests!="" && $nguests>0)
						$res += ($extra->value_percent*0.01*$price)*
						($nguests+$nchilds);
				}
			} else if ($extra->value_type==4) { //Per adult
				if ($extra->value_fix>0) {
					if ($nguests!=""&&$nguests>0)
						$res += $extra->value_fix*$nguests;
				} else if ($extra->value_percent>0) {
					if ($nguests!=""&&$nguests>0)
						$res += ($extra->value_percent*0.01*$price)*$nguests;
				}
			} else if ($extra->value_type==5) { //Per child
				if ($extra->value_fix>0) {
					if ($nchilds!="" && $nchilds>0)
						$res += $extra->value_fix*$nchilds;
				} else if ($extra->value_percent>0) {
					if ($nchilds!="" && $nchilds>0)
						$res += ($extra->value_percent*0.01*$price)*$nchilds;
				}
			} else if ($extra->value_type==6) { //Per quantity
				if ($extra->value_fix>0) {
					if ($qnt>0)
						$res += $extra->value_fix*$qnt;
				} else if ($extra->value_percent>0) {
					if ($qnt>0)
						$res += ($extra->value_percent*0.01*$price)*$qnt;
				}
			} else if ($extra->value_type==7) { //Guest/night
				if ($extra->value_fix>0) {
					$res += $extra->value_fix*($nguests+$nchilds)*$nights;
				} else if ($extra->value_percent>0) {
					$res += ($extra->value_percent*0.01*$price)*
					($nguests+$nchilds)*$nights;
				}
			} else if ($extra->value_type==8) { //Per Adult/Night
				if ($extra->value_fix>0) {
					$res += $extra->value_fix*$nguests*$nights;
				} else if ($extra->value_percent>0) {
					$res += ($extra->value_percent*0.01*$price)*$nguests*$nights;
				}
			} else if ($extra->value_type==9) { //Per Child/Night
				if ($extra->value_fix>0) {
					$res += $extra->value_fix*$nchilds*$nights;
				} else if ($extra->value_percent>0) {
					$res += ($extra->value_percent*0.01*$price)*$nchilds*$nights;
				}
			} else if ($extra->value_type==10) { //Quantity/night
				if ($extra->value_fix>0) {
					$res += $extra->value_fix*$qnt*$nights;
				} else if ($extra->value_percent>0) {
					$res += ($extra->value_percent*0.01*$price)*$qnt*$nights;
				}
			}
		}
		return number_format($res, 2, '.', '');
	}

	function captchaValidation ($posted_data, $addr)
	{
		$res = new stdClass();
		$res->code = 0;
		$res->msg="";
		$utils = $this->getUtils();
		require_once(JPATH_COMPONENT.DS."libs".DS."recaptchalib.php");
		$privatekey = ($utils->privatekey);
		$resp = recaptcha_check_answer ($privatekey,
				$addr,
				$posted_data["recaptcha_challenge_field"],
				$posted_data["recaptcha_response_field"]);

		if (!$resp->is_valid) {
			// What happens when the CAPTCHA was entered incorrectly
			$res->code = 0;
			$res->msg= $resp->error;
		} else {
			// Your code here to handle a successful verification
			$res->code = 1;
			$res->msg="OK";
		}
		return $res;
	}

	function makebookings ($data)
	{

		
		$idbooks = array();

		if(get_magic_quotes_gpc())
		{
			$data['room'] = stripslashes($data['room']);
			$data['extra_ids']= stripslashes($data['extra_ids']);
		}

		$rooms = json_decode($data['room']);
		$data['rooms']=$rooms->room[0]->rooms;
		$qnt_per_category = array();
		for ($i=1; $i<=$rooms->room[0]->rooms; $i++)
		{
			if (array_key_exists($rooms->room[$i]->idcategory, $qnt_per_category))
				$qnt_per_category[$rooms->room[$i]->idcategory] += 1;
			else
				$qnt_per_category[$rooms->room[$i]->idcategory] = 1;
		}

		$data['idguests'] = $this->_createGuest ($data);

		if(is_string($data['extra_ids'])&&substr($data['extra_ids'], 0, 1)=='"' &&
				substr($data['extra_ids'], -1)=='"')
			$data['extra_ids'] = substr($data['extra_ids'], 1, -1);
		$extras  =json_decode($data['extra_ids']);


		$categories_to_idrooms = array();

		foreach ($qnt_per_category as $idcategory=>$qnt)
		{
			$idrooms = $this->_availabilityCheck($data['valid_from'],
					$data['valid_to'], $idcategory, $qnt);
			if (empty($idrooms)) //no more availability
				return -1;
			else //Make bookings
			{
				for ($i=1; $i<=$rooms->room[0]->rooms; $i++)
				{
					if ($rooms->room[$i]->idcategory==$idcategory)
					{
						$idextras = $this->_getMultiRoomExtras ($extras, $i);
						$book_data = array();
						$book_data['idroom'] = array_pop($idrooms);
						$book_data['idcategory'] = $idcategory;
						$book_data['idcoupon'] = $data['idcoupon'];
						$book_data['idguests'] = $data['idguests'];
						$book_data['nguests'] = $rooms->room[$i]->nguests;
						$book_data['nchilds'] = $rooms->room[$i]->nchilds;
						$book_data['initial_price'] = $rooms->room[$i]->price;
						$book_data['valid_from'] = $data['valid_from'];
						$book_data['valid_to'] = $data['valid_to'];
						$book_data['price'] = $this->_getRoomPrice ($rooms->room[$i],
								$extras, $data, $i, $rooms->room[0]->rooms);
						$book_data['extra_ids'] = $idextras;
						$book_data['preferences']=
						$this->_getPreferences ($extras, $i);
						$book_data['idrules'] =$rooms->room[$i]->idrules;
						$book_data['lang'] =$data['lang'];
						$book_data['deposit'] =$data['deposit'];
						$book_data['payment_method']=$data['payment_method'];

						$idbook = $this->_insertBooking ($book_data);
						if ($idbook>0)
						{
							if($data['idcoupon']>0)
								$this->updateCoupons ($data['idcoupon']);
							array_push($idbooks, $idbook);

						}
						else return -1;

					}
					else continue;
				}
					
			}

		}

		if (!empty($idbooks))
			$this->_updateCOIDS($idbooks);
		return $idbooks;
	}
	function makebooking ($data)
	{
			
		if(is_string($data['extra_ids'])&&substr($data['extra_ids'], 0, 1)=='"' &&
				substr($data['extra_ids'], -1)=='"')
			$data['extra_ids'] = substr($data['extra_ids'], 1, -1);

		$pos = strpos($data['extra_ids'], "]");
		$data['extra_ids'] = substr($data['extra_ids'], 0, $pos)."]";

		$xtrs = json_decode($data['extra_ids']);
		$v=0.00;
		foreach ($xtrs as $x)
		{
			$v+=$x->value;
		}

		$data['initial_price'] = $data['price']-$v;
		$data['extra_ids'] = $this->_toCSV(json_decode($data['extra_ids']));
		$bookit_model =&$this->getInstance('blooking', 'BlookingModel');
		$search_results = $bookit_model->availabilityCheck($data['valid_from'],
				$data['valid_to'], $data['idcategory']);

		if ($search_results->idroom<=0) //No rooms available
			return -1;

		$data['idroom'] = $search_results->idroom;
		$data['idguests'] = $this->_createGuest ($data);
		$idbook = $this->_insertBooking ($data);
		if ($idbook>0)
		{
			if($data['idcoupon']>0)
				$this->updateCoupons ($data['idcoupon']);
		}
		return $idbook;
	}
	function getJUser ($id)
	{
		$data = array('');
		$data['idcountry']=0;
		$data['name']="";
		$data['surname']="";
		$data['email']="";
		$data['address1']="";
		$data['address2']="";
		$data['address3']="";
		$data['phone']="";
		$data['postcode']="";
		$data['jid']=$id;

		if ($id<=0) return $data;

		$sql = "SELECT * FROM ".
				$this->_db->nameQuote('#__bookitguests')." WHERE ".
				$this->_db->nameQuote('jid')."=".$this->_db->quote($id);
		$this->_db->setQuery($sql);
		$buser =  $this->_db->loadObject();
		if (isset($buser))
		{
			$data['idcountry']=$buser->idcountry;
			$data['name']=$buser->name;
			$data['surname']=$buser->surname;
			$data['email']=$buser->email;
			$data['address1']=$buser->address1;
			$data['address2']=$buser->address2;
			$data['address3']=$buser->address3;
			$data['phone']=$buser->phone;
			$data['postcode']=$buser->postcode;
			$data['idguests']=$id;
		}
		else
		{
			$sql = "SELECT * FROM ".
					$this->_db->nameQuote('#__users')." WHERE ".
					$this->_db->nameQuote('id')."=".$this->_db->quote($id);
			$this->_db->setQuery($sql);
			$juser = $this->_db->loadObject();
			$fullname = explode(" ",$juser->name );
			$data['name']=$fullname[0];
			if (isset($fullname[1]))
				$data['surname']=$fullname[1];
			$data['email']=$juser->email;
		}
		return $data;
			
	}

	function _createGuest($data)
	{
		if ($data['jid']>0) //Logged in user
		{
			$sql = "SELECT ".$this->_db->nameQuote('idguests')." FROM ".
					$this->_db->nameQuote('#__bookitguests')." WHERE ".
					$this->_db->nameQuote('jid')."=".$this->_db->quote($data['jid']);
			$this->_db->setQuery($sql);
			$bid = $this->_db->loadResult();
		}

		if (isset($bid) && $bid>0) //The user is already a guest, upfate his record
		{
			$sql = "UPDATE ".$this->_db->nameQuote('#__bookitguests')." SET ".
					$this->_db->nameQuote('jid')." = ".
					$this->_db->quote($data['jid']).",".
					$this->_db->nameQuote('idcountry')." = ".
					$this->_db->quote($data['idcountry']).",".
					$this->_db->nameQuote('name')." = ".
					$this->_db->quote($data['name']).",".
					$this->_db->nameQuote('surname')." = ".
					$this->_db->quote($data['surname']).",".
					$this->_db->nameQuote('email')." = ".
					$this->_db->quote($data['email']).",".
					$this->_db->nameQuote('address1')." = ".
					$this->_db->quote($data['address1']).",".
					$this->_db->nameQuote('address2')." = ".
					$this->_db->quote($data['address2']).",".
					$this->_db->nameQuote('address3')." = ".
					$this->_db->quote($data['address3']).",".
					$this->_db->nameQuote('phone')." = ".
					$this->_db->quote($data['phone']).",".
					$this->_db->nameQuote('postcode')." = ".
					$this->_db->quote($data['postcode'])." WHERE ".
					$this->_db->nameQuote('idguests')." = ".$this->_db->quote($bid);
			$this->_db->setQuery($sql);
			$this->_db->query();
			$res = $bid;
		}
		else //New Guest, add him
		{
			$sql = "INSERT INTO ".$this->_db->nameQuote('#__bookitguests').
			" (".$this->_db->nameQuote('jid').",".
			$this->_db->nameQuote('idcountry').",".
			$this->_db->nameQuote('name').",".
			$this->_db->nameQuote('surname').",".
			$this->_db->nameQuote('email').",".
			$this->_db->nameQuote('address1').",".
			$this->_db->nameQuote('address2').",".
			$this->_db->nameQuote('address3').",".
			$this->_db->nameQuote('phone').",".
			$this->_db->nameQuote('postcode').") VALUES(".
			$this->_db->quote($data['jid']).",".
			$this->_db->quote($data['idcountry']).",".
			$this->_db->quote($data['name']).",".
			$this->_db->quote($data['surname']).",".
			$this->_db->quote($data['email']).",".
			$this->_db->quote($data['address1']).",".
			$this->_db->quote($data['address2']).",".
			$this->_db->quote($data['address3']).",".
			$this->_db->quote($data['phone']).", ".
			$this->_db->quote($data['postcode']).")";
			$this->_db->setQuery($sql);
			$this->_db->query();
			$res = $this->_db->insertid();
		}
		return $res;
			
	}
	function _toCSV($extra_ids)
	{
		$res="";
		foreach ($extra_ids as $extra)
		{
			if ($res!="")
				$res.=",";
			$res.=$extra->idextra;
			if($extra->qnt>0)
				$res.="-".$extra->qnt;
		}
		return $res;
	}
	function _getMultiRoomExtras ($extras, $idroom)
	{
		$res="";
		foreach ($extras as $extra)
		{
			if ($extra->idroom!=$idroom) continue;
			if ($res!="")
				$res.=",";
			$res.=$extra->idextra;
			if($extra->qnt>0)
				$res.="-".$extra->qnt;
		}

		return $res;
	}

	function updateCoupons ($idcoupon)
	{

		$query = "UPDATE ".$this->_db->nameQuote('#__bookitrules')."
				SET ".$this->_db->nameQuote('times_used')." = ".
				$this->_db->nameQuote('times_used')." + 1 WHERE ".
				$this->_db->nameQuote('idrule')." = ".$idcoupon;
		$this->_db->setQuery( $query );
		$this->_db->query();
	}

	function sendConfirmationEmail ($idbook, $lang) {

		$cust_mailer =& JFactory::getMailer();
		$admin_mailer =& JFactory::getMailer();
		$config =& JFactory::getConfig();


		$params = BlookingHelper::getParams();
		$sender = array(
				$params->admin_email,
				$config->getValue( 'config.fromname' ) );
		$cust_mailer->setSender($sender);
		$admin_mailer->setSender($sender);

		$res = $this->getBookingDetailsForEmail($idbook);

		if ($params->admin_confirm == 1 && $res['payment_requested'] == "0") {
			$sub1 = 'custprebooking_subject';
			$type1 = 'custprebooking';
			$sub2 = 'adminprebooking_subject';
			$type2 = 'adminprebooking';
		} else {
			$sub1 = 'custemail_subject';
			$type1 = 'custemail';
			$sub2 = 'adminemail_subject';
			$type2 = 'adminemail';
		}

		$cust_subject = $this->getSubject($sub1, $lang);
		$admin_subject = $this->getSubject($sub2, $lang);

		$cust_mailer->addRecipient(array($res['email']));

		$recipients = array($params->admin_email);
		if ($params->admin_email2!="")
			array_push($recipients, $params->admin_email2);
		$admin_mailer->addRecipient($recipients);
		$utils = $this->getUtils();
		if ($lang!='en' && isset($utils->{$type1."_".$lang}))
			$cust_msg_tmpl = $utils->{$type1."_".$lang};
		else
			$cust_msg_tmpl = $utils->{$type1};
		if ($lang!='en' && isset($utils->{$type2."_".$lang}))
			$admin_msg_tmpl = $utils->{$type2."_".$lang};
		else
			$admin_msg_tmpl = $utils->{$type2};
			
		if ($params->deposit_percent > 0) {
			$deposit = number_format(($res['totalprice'] / 100)*$params->deposit_percent,2, '.','');
		} else {
			$deposit = number_format($params->deposit_fixed,2, '.','');
		}
		if ($params->late_booking > 0 && $this->isLateBooking($res['checkin'], $params->late_booking))
		{
			$deposit = number_format(($res['totalprice'] / 100)*100,2, '.','');
		}

		$pricelessdeposit = number_format($res['totalprice'] - $deposit,2, '.','');

		$arr_tpl_vars = array('{firstname}','{surname}', '{email}', '{phone}',
				'{address1}', '{address2}', '{address3}', '{postcode}', '{country}',
				'{bookingid}', '{checkin}', '{checkout}', '{nights}', '{roomtype}',
				'{totalprice}', '{deposit}', '{amountreceived}','{remainingprice}',
				'{pricelessdeposit}','{adults}', '{childs}', '{guests}', '{extras}',
				'{extraprices}', '{requests}', '{terms}', '{cancellation}', '{cancelbookinglink}',
				'{bookingstatus}', '{paymentmethod}');

		$arr_tpl_data = array($res['firstname'], $res['surname'], $res['email'],
				$res['phone'], $res['address1'], $res['address2'], $res['address3'],
				$res['postcode'], $res['country'], $res['bookingid'], $res['checkin'],
				$res['checkout'], $res['nights'], $res['roomtype'], $res['totalprice'],
				$deposit, $res['deposit'], $res['remainingprice'], $pricelessdeposit,
				$res['adults'], $res['childs'],	$res['guests'], $res['extras'],
				$res['extraprices'], $res['requests'], $res['terms'], $res['cancellation_policy'],
				$res['cancelbookinglink'], $res['bookingstatus'], $res['paymentmethod']);

		$cust_msg = str_replace($arr_tpl_vars, $arr_tpl_data, $cust_msg_tmpl);
		$admin_msg = str_replace($arr_tpl_vars, $arr_tpl_data, $admin_msg_tmpl);
		$cust_subject = str_replace($arr_tpl_vars, $arr_tpl_data, $cust_subject);
		$admin_subject = str_replace($arr_tpl_vars, $arr_tpl_data, $admin_subject);

		$cust_mailer->setSubject($cust_subject);
		$cust_mailer->isHTML(true);
		$cust_mailer->setBody($cust_msg);

		$cust_send =& $cust_mailer->Send();
		$admin_mailer->setSubject($admin_subject);
		$admin_mailer->isHTML(true);
		$admin_mailer->setBody($admin_msg);

		$admin_send =& $admin_mailer->Send();

		if (($cust_send==true)&& ($admin_send==true)) { //BETTER ERROR HANDLING REQ
			$msg="E-Mail Sent";
		}
		else {
			//("ERROR SENDING EMAIL");
		}

	}

	function _insertBooking ($data, $mainbooking_id = null)
	{

		$query = "INSERT INTO ".$this->_db->nameQuote("#__bookitbooking").
		" (".
		$this->_db->nameQuote('idcoupon').", ".
		$this->_db->nameQuote('idroom').", ".
		$this->_db->nameQuote('idcategory').", ".
		$this->_db->nameQuote('idguests').", ".
		$this->_db->nameQuote('nguests').", ".
		$this->_db->nameQuote('nchilds').", ".
		$this->_db->nameQuote('valid_from').", ".
		$this->_db->nameQuote('valid_to').", ".
		$this->_db->nameQuote('value_paid').", ".
		$this->_db->nameQuote('value_pending').", ".
		$this->_db->nameQuote('value_full').", ".
		$this->_db->nameQuote('value_deposit').", ".
		$this->_db->nameQuote('today').", ".
		$this->_db->nameQuote('timestamp').", ".
		$this->_db->nameQuote('status').", ".
		$this->_db->nameQuote('extra_ids').", ".
		$this->_db->nameQuote('preferences').", ".
		$this->_db->nameQuote('rule_ids').", ".
		$this->_db->nameQuote('payment_method').", ".
		$this->_db->nameQuote('initial_price').", ".
		$this->_db->nameQuote('lang').
		") VALUES (".
		$this->_db->quote($data['idcoupon']).", ".
		$this->_db->quote($data['idroom']).", ".
		$this->_db->quote($data['idcategory']).", ".
		$this->_db->quote($data['idguests']).", ".
		$this->_db->quote($data['nguests']).", ".
		$this->_db->quote($data['nchilds']).", ".
		$this->_db->quote(date("Y-m-d", strtotime($data['valid_from']))).", ".
		$this->_db->quote(date("Y-m-d", strtotime($data['valid_to']))).", ".
		$this->_db->quote('0').", ".
		$this->_db->quote($data['price']).", ".
		$this->_db->quote($data['price']).", ".
		$this->_db->quote($data['deposit']).", ".
		$this->_db->quote(date ("Y-m-d")).", CURRENT_TIMESTAMP".", ".
		$this->_db->quote('2').", ".
		$this->_db->quote($data['extra_ids']).", ".
		$this->_db->quote(trim($data['preferences'],"\"")).", ".
		$this->_db->quote($data['idrules']).", ".
		$this->_db->quote($data['payment_method']).", ".
		$this->_db->quote($data['initial_price']).", ".
		$this->_db->quote($data['lang']).") ";
		$this->_db->setQuery($query);
		if (!$this->_db->query()) {
			($this->_db->stderr(true));
		}
		$idbook= $this->_db->insertid();


		return $idbook;
	}


	function _availabilityCheck ($valid_from, $valid_to, $idcategory, $qnt)
	{
		$remaining_rooms=0;
		//CHECK FOR AVAILABILITY
		$start= $this->_toMysqlDateFormat ($valid_from);
		$end = $this->_toMysqlDateFormat($valid_to);
		$whereStr=" WHERE ";
		$whereStr.=$this->_db->nameQuote('idcategory')." = ".
				$this->_db->quote($idcategory)." AND ";

		$case1 =  $this->_db->nameQuote('valid_from')." <= ".
				$this->_db->quote($start)." AND ".
				$this->_db->nameQuote('valid_to')." > ".$this->_db->quote($start);
		$case2 = $this->_db->nameQuote('valid_from')." >= ".
				$this->_db->quote($start)." AND ".$this->_db->nameQuote('valid_from').
				" < ".$this->_db->quote($end);
			

		//------Check if there is availability for the selected options---------
		//Get bookings already found for selected settings
		$query = "SELECT DISTINCT ".$this->_db->nameQuote('idroom')." FROM ".
				$this->_db->nameQuote('#__bookitbooking').$whereStr.
				"(".$this->_db->nameQuote('status')." IN(1,2,3) ) AND ( (".
				$case1.") OR (".$case2.") );";
		$this->_db->setQuery($query);
		$booked_rooms = $this->_db->loadObjectList();

		$query = "SELECT COUNT(*) FROM ".
				$this->_db->nameQuote('#__bookitroom')." WHERE ".
				$this->_db->nameQuote('idcategory')."=".
				$this->_db->quote($idcategory);
		$this->_db->setQuery($query);
		$rooms_in_selected_category = $this->_db->loadResult();

		if ($booked_rooms==null || empty($booked_rooms))
			$remaining_rooms= $rooms_in_selected_category;
		else
			$remaining_rooms = $rooms_in_selected_category - count($booked_rooms);

		if ($remaining_rooms < $qnt) //Some rooms are not available anymore
		{
			return array();
		}

		$rooms_array= array();
		$rooms_str="";
		foreach ($booked_rooms as $room)
		{
			array_push($rooms_array, $room->idroom);
		}
		$rooms_str = implode(',', $rooms_array);
		if ($rooms_str!="")
		{
			$query = "SELECT ".$this->_db->nameQuote('idroom')." FROM ".
					$this->_db->nameQuote('#__bookitroom')." WHERE ".
					$this->_db->nameQuote('idroom')." NOT IN (".
					$rooms_str.") AND ".$this->_db->nameQuote('idcategory')." = ".
					$this->_db->quote($idcategory);
		}
		else
		{
			$query = "SELECT ".$this->_db->nameQuote('idroom')." FROM ".
					$this->_db->nameQuote('#__bookitroom')." WHERE ".
					$this->_db->nameQuote('idcategory')." = ".
					$this->_db->quote($idcategory);
		}

		$this->_db->setQuery($query);
		return $this->_db->loadResultArray();

	}
	function _toMysqlDateFormat($date)
	{
		$date_format = $this->_getDateFormat ();
		$originalDate = strtotime($date);
		return date("Y-m-d", $originalDate);
	}

	function _getRoomPrice ($room, $extras, $data, $i, $rooms)
	{
		//Room base price
		$price = $room->price;
		//$price += $room->price_deviation;

		//Add the extras
		foreach ($extras as $extra)
		{
			if ($extra->idroom == $i)
			{
				if ($extra->qnt>0)
					$price += $extra->value * $extra->qnt;
				else
					$price += $extra->value;
			}
		}

		//Sub the coupons
		if ($data['coupon_discount']>0.00)
		{
			$price -= $data['coupon_discount']/$rooms;
		}

		return number_format ( $price, 2, '.', '');
	}
	function _getPreferences ($extras, $i)
	{

		foreach ($extras as $extra)
		{
			if ($extra->idroom == $i && $extra->idextra==0)
			{
				return $extra->preferences;
			}
		}
		return "";
	}
	function _updateCOIDS($idbooks)
	{
		foreach ($idbooks as $id)
		{
			$temp = $idbooks;
			for ($i=0; $i<count($temp); $i++)
			{
				if ($temp[$i]==$id)
					unset($temp[$i]);
			}

			$coids = implode(",",$temp);
			$query =  "UPDATE ".$this->_db->nameQuote('#__bookitbooking')." SET ".
					$this->_db->nameQuote('coids')."=".$this->_db->quote($coids)." WHERE ".
					$this->_db->nameQuote('idbook')."=".$this->_db->quote($id);
			$this->_db->setQuery( $query );
			$result = $this->_db->query();
		}
	}

	function confirmBookings($ids, $txn_id, $price)
	{

		
		if ($txn_id=="" || $price==0) return false;

		if ($ids=="") { //For gateways that do not send $id get the last one only works for single room mode
				
			$sql = "SELECT MAX(".$this->_db->nameQuote('idbook').") FROM ".
					$this->_db->nameQuote('#__bookitbooking');
			$this->_db->setQuery($sql);
			$ids = $this->_db->loadResult();
				
		}
		
		//If the transaction id already exists on the booking table return true
		$sql = "SELECT * FROM ".$this->_db->nameQuote('#__bookitbooking').
		" WHERE ".$this->_db->nameQuote('transaction_id')." = ".
		$this->_db->quote($txn_id)." AND ".$this->_db->nameQuote('status')." = ".
		$this->_db->quote('1');
		$this->_db->setQuery($sql);
		$res = $this->_db->loadObjectList();
		if (count($res)>0) return true;

		$bookings = explode(",",$ids);
		//$costPerRoom = number_format($price / cont($bookings),2);

		$totalcost = 0;
		foreach ($bookings as $id) {
			$sql = "SELECT ".$this->_db->nameQuote('value_pending')." FROM ".
					$this->_db->nameQuote('#__bookitbooking')." WHERE ".
					$this->_db->nameQuote('idbook')."=".$this->_db->quote($id);
			$this->_db->setQuery($sql);
			$totalcost += $this->_db->loadResult();
		}

		foreach ($bookings as $id)
		{
			$sql = "SELECT ".$this->_db->nameQuote('value_pending')." FROM ".
					$this->_db->nameQuote('#__bookitbooking')." WHERE ".
					$this->_db->nameQuote('idbook')."=".$this->_db->quote($id);
			$this->_db->setQuery($sql);
			$valuepending = $this->_db->loadResult();
				
			$valuepaid = number_format(($price / $totalcost) * $valuepending,2);
				
			//$query =  "UPDATE ".$this->_db->nameQuote('#__bookitbooking')." SET ".
			//$this->_db->nameQuote('status')."=".$this->_db->quote('1').", ".
			//$this->_db->nameQuote('value_paid')."=".$this->_db->nameQuote('value_paid').
			//"+".$this->_db->quote($costPerRoom).", ".
			//$this->_db->nameQuote('transaction_id')."=".$this->_db->quote($txn_id).", ".
			//$this->_db->nameQuote('value_pending')."=".$this->_db->nameQuote('value_pending').
			//"-".$this->_db->quote($costPerRoom)." WHERE ".$this->_db->nameQuote('idbook')."=".$this->_db->quote($id);
			//$this->_db->setQuery( $query );
			//if (!$this->_db->query()) return false;
				
			//NEW CALCULATIONS
			$query =  "UPDATE ".$this->_db->nameQuote('#__bookitbooking')." SET ".
					$this->_db->nameQuote('status')."=".$this->_db->quote('1').", ".
					$this->_db->nameQuote('value_paid')."=".$this->_db->nameQuote('value_paid').
					"+".$this->_db->quote($valuepaid).", ".
					$this->_db->nameQuote('transaction_id')."=".$this->_db->quote($txn_id).", ".
					$this->_db->nameQuote('value_pending')."=".$this->_db->nameQuote('value_pending').
					"-".$this->_db->quote($valuepaid)." WHERE ".$this->_db->nameQuote('idbook').
					"=".$this->_db->quote($id);
					$this->_db->setQuery( $query );
						
					if (!$this->_db->query()) return false;
		}
		if ($bookings[0]>0)
		{
			$query =  "SELECT * FROM ".$this->_db->nameQuote('#__bookitbooking').
			" WHERE ".$this->_db->nameQuote('idbook')."=".
			$this->_db->quote($bookings[0]);
			$this->_db->setQuery( $query );
			$res = $this->_db->loadObject();
			$this->sendConfirmationEmail($bookings[0], $res->lang);
		}

		return true;
	}

	function autoConfirmBookings($ids, $status)
	{
		if ($ids=="") return false;

		$bookings = explode(",",$ids);
		$query =  "SELECT * FROM ".$this->_db->nameQuote('#__bookitbooking').
		" WHERE ".$this->_db->nameQuote('idbook')."=".
		$this->_db->quote($bookings[0]);
		$this->_db->setQuery( $query );
		$res = $this->_db->loadObject();
			
		foreach ($bookings as $id)
		{
			$query =  "UPDATE ".$this->_db->nameQuote('#__bookitbooking')." SET ".
					$this->_db->nameQuote('status')."=".$this->_db->quote($status)
					." WHERE ".$this->_db->nameQuote('idbook')."=".$this->_db->quote($id);
			$this->_db->setQuery( $query );
			if (!$this->_db->query()) return false;
		}
		if ($bookings[0]>0)
		{
			$this->sendConfirmationEmail($bookings[0], $res->lang);
		}

		return true;
	}

	function isBookingOk($bookingid) {
		//Function checks that booking is confirmed
		//Used for return url in iDEAL
		$query = "SELECT ".$this->_db->nameQuote('status')." FROM ".$this->_db->nameQuote('#__bookitbooking').
		" WHERE ".$this->_db->nameQuote('idbook')." = ".$this->_db->quote($bookingid);

		$this->_db->setQuery( $query );
		$status = $this->_db->loadResult();

		if ($status == "1") {
			return true;
		} else {
			return false;
		}
	}

	function ipnCancelBookings($ids, $trxid) {
		$idbookings = explode(",",$ids);

		foreach ($idbookings as $idbooking) {
			$query =  "UPDATE ".$this->_db->nameQuote('#__bookitbooking')." SET ".
					$this->_db->nameQuote('status')."=".$this->_db->quote('5').", ".
					$this->_db->nameQuote('transaction_id')."=".$this->_db->quote($trxid).
					"WHERE ".$this->_db->nameQuote('idbook')."=".$this->_db->quote($idbooking);
			$this->_db->setQuery( $query );
			$result = $this->_db->query();

			$query2 =  "SELECT ".$this->_db->nameQuote('idcoupon').
			" FROM ".$this->_db->nameQuote('#__bookitbooking').
			" WHERE ".$this->_db->nameQuote('idbook')."=".$this->_db->quote($idbooking);
			$this->_db->setQuery( $query2 );
			$coup = $this->_db->loadResult();

			if ($coup > 0) {
				$query =  "UPDATE ".$this->_db->nameQuote('#__bookitrules').
				" SET ".$this->_db->nameQuote('times_used').
				"=".$this->_db->nameQuote('times_used')."-1 WHERE ".
				$this->_db->nameQuote('idrule')."=".$this->_db->quote($coup);
				$this->_db->setQuery( $query );
				$result = $this->_db->query();
			}
		}

		return true;
	}

	function ipnExpireBookings($ids, $trxid) {
		$idbookings = explode(",",$ids);

		foreach ($idbookings as $idbooking) {
			$query =  "UPDATE ".$this->_db->nameQuote('#__bookitbooking')." SET ".
					$this->_db->nameQuote('status')."=".$this->_db->quote('4').", ".
					$this->_db->nameQuote('transaction_id')."=".$this->_db->quote($trxid).
					"WHERE ".$this->_db->nameQuote('idbook')."=".$this->_db->quote($idbooking);
			$this->_db->setQuery( $query );
			$result = $this->_db->query();

			$query2 =  "SELECT ".$this->_db->nameQuote('idcoupon').
			" FROM ".$this->_db->nameQuote('#__bookitbooking').
			" WHERE ".$this->_db->nameQuote('idbook')."=".$this->_db->quote($id);
			$this->_db->setQuery( $query2 );
			$coup = $this->_db->loadResult();

			if ($coup > 0) {
				$query =  "UPDATE ".$this->_db->nameQuote('#__bookitrules').
				" SET ".$this->_db->nameQuote('times_used').
				"=".$this->_db->nameQuote('times_used')."-1 WHERE ".
				$this->_db->nameQuote('idrule')."=".$this->_db->quote($coup);
				$this->_db->setQuery( $query );
				$result = $this->_db->query();
			}
		}

		return true;
	}

	function isLateBooking ($from, $days)
	{
		$from_time = strtotime($from);
		$to_time = strtotime(date('Ymd'));
		$days_left =  round( ($from_time - $to_time )/86400);

		return ($days_left > $days) ? false : true;
	}

	function getPaymentRequested($id) {
		$query = "SELECT `payment_requested` FROM ".$this->_db->nameQuote('#__bookitbooking')." WHERE ".
				$this->_db->nameQuote('idbook')." = ".$this->_db->quote($id);
		$this->_db->setQuery($query);

		return ($this->_db->loadResult());
	}

	function getBookingDetails($id) {
		$roomspecifics = array();
		$query = "SELECT `payment_requested`, `coids`, `idguests`, `value_deposit`, `lang`, `valid_from`, `valid_to` FROM ".$this->_db->nameQuote('#__bookitbooking')." WHERE ".
				$this->_db->nameQuote('idbook')." = ".$this->_db->quote($id);
		$this->_db->setQuery($query);

		$details = $this->_db->loadAssoc();


        $details['nights'] = $this->getNights($details['valid_from'], $details['valid_to']);
		if ($details['payment_requested'] != "1") {
			JError::raiseError(500, JText::_('This booking has not been verified' ) );
		}

		if ($details['coids'] != "") {
			$coids = explode(",", $details['coids']);
			array_push($coids,$id);
			sort($coids);
				
			$x = 0;
			$cat_qnt = array();
			$adults=0;
			$childs=0;
			$guests=0;
			$price=0;
				
			foreach ($coids as $coid) {
				$query = "SELECT `idbook`, `idcategory`, `nguests`, `nchilds`, `value_full`, `preferences` ".
						"FROM ".$this->_db->nameQuote('#__bookitbooking')." WHERE ".
						$this->_db->nameQuote('idbook')." = ".$this->_db->quote($coid);
				$this->_db->setQuery($query);
				$roomspecifics['rooms'][] = $this->_db->loadAssoc();

				$query = "SELECT * FROM ".$this->_db->nameQuote('#__bookitcategory').
				" WHERE ".$this->_db->nameQuote('idcategory')."=".
				$this->_db->quote($roomspecifics['rooms'][$x]['idcategory']);
				$this->_db->setQuery($query);
				$row=$this->_db->loadObject();
					
				if (isset($row->{"name_".$details['lang']})) {
					$cat_name = $row->{"name_".$details['lang']};
				} else {
					$cat_name = $row->name;
				}

				if (isset($cat_qnt[$cat_name])) {
					$cat_qnt[$cat_name]+=1;
				} else {
					$cat_qnt[$cat_name]=1;
				}

				$adults += $roomspecifics['rooms'][$x]['nguests'];
				$childs += $roomspecifics['rooms'][$x]['nchilds'];
				$guests += $roomspecifics['rooms'][$x]['nguests'] + $roomspecifics['rooms'][$x]['nchilds'];;
				$price += $roomspecifics['rooms'][$x]['value_full'];
				$x++;
			}
			$details['tadults'] = $adults;
			$details['tchilds'] = $childs;
			$details['tguests'] = $guests;
			$details['cat_qnt'] = $cat_qnt;
			$details['fullprice'] = $price;
		} else { //Single Room
			$query = "SELECT `idbook`, `idcategory`, `nguests`, `nchilds`, `value_full`, `preferences` ".
					"FROM ".$this->_db->nameQuote('#__bookitbooking')." WHERE ".
					$this->_db->nameQuote('idbook')." = ".$this->_db->quote($id);
			$this->_db->setQuery($query);
			$roomspecifics['rooms'][] = $this->_db->loadAssoc();
			$categoryname = $this->getCategoryName($roomspecifics['rooms']['0']['idcategory']);
				
			$details['tadults'] = $roomspecifics['rooms']['0']['nguests'];
			$details['tchilds'] = $roomspecifics['rooms']['0']['nchilds'];
			$details['tguests'] = $roomspecifics['rooms']['0']['nguests'] + $roomspecifics['rooms']['0']['nchilds'];
			$details['cat_qnt'][$categoryname] = 1;
			$details['fullprice'] = $roomspecifics['rooms']['0']['value_full'];

		}

		$query = "SELECT * FROM ".$this->_db->nameQuote('#__bookitguests')." WHERE ".
				$this->_db->nameQuote('idguests')." = ".$this->_db->quote($details['idguests']);
		$this->_db->setQuery($query);
		$guest = $this->_db->loadAssoc();

		if (!is_array($details)) {
			JError::raiseError(500, JText::_('This booking has not been found' ) );
		}

		return array_merge($details, $roomspecifics, $guest);
	}

	function getCategoryName($idcategory, $lang='en')
	{
		$query =  "SELECT * FROM ".
				$this->_db->nameQuote('#__bookitcategory')." WHERE ".
				$this->_db->nameQuote('idcategory')."=".
				$this->_db->quote($idcategory);
		$this->_db->setQuery( $query );
		$res = $this->_db->loadObject();
		if ($lang!='en')
		{
			if(isset($res->{"name_".$lang}))
				$category_name=$res->{"name_".$lang};
			else
				$category_name = $res->name;
		}
		else
		{
			$category_name = $res->name;
		}
		return $category_name;

	}

	function getNights ($from, $to)
	{
		$from_time = strtotime($from);
		$to_time = strtotime($to);
		return (round( ($to_time-$from_time )/86400)) ;
	}

	function updatePaymentMethod($bookingid, $payment_method="Unknown") {

		$bookingids = explode (",", $bookingid);

		foreach($bookingids as $id) {
			$query =  "UPDATE ".$this->_db->nameQuote('#__bookitbooking')." SET ".
					$this->_db->nameQuote('payment_method')."=".$this->_db->quote($payment_method).
					" WHERE ".$this->_db->nameQuote('idbook')."=".$this->_db->quote($id);
			$this->_db->setQuery( $query );
			$result = $this->_db->query();
		}
	}
}