<?php
/**
 * BlooKing - The King in Joomla Booking
 * @version 1.0
 * @author BlooKing.org. Based on BooKiTGold code by Costas Kakousis
 * @copyright (C) 2012-2013 by BlooKing.org (http://www.blooking.org)
 * @license GNU/GPL: http://www.gnu.org/copyleft/gpl.html
 *
 * If you fork this to create your own project, please make a reference to
 * BlooKing! someplace in your code and provide a link to
 * http://www.blooking.org
 *
 * This file is part of BlooKing! BlooKing is free software: you can
 * redistribute it and/or modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * BlooKing is distributed in the hope that it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details. You should have received a copy of the GNU General Public License
 * along with BlooKing.  If not, see <http://www.gnu.org/licenses/>.
 *   ______ __                __  __ __
 *	|   __ \  |.-----..-----.|  |/  |__|.-----..-----.
 *	|   __ <  ||  _  ||  _  ||     <|  ||     ||  _  |
 *	|______/__||_____||_____||__|\__|__||__|__||___  |
 *                                             |_____|
 **/

defined( '_JEXEC' ) or die( 'Restricted access' );
jimport( 'joomla.application.component.model' );

/**
 * the controller will automatically load the model that has the same name as
 * the view and will push it into the view.
 * @author Costas
 *
*/

class BlookingModelMultisearch extends JModel
{
	var $_db;
	var $_model;
	function __construct()
	{
		parent::__construct();
		JLoader::register('BlookingHelper',
		JPATH_COMPONENT_ADMINISTRATOR.'/helpers/BlookingHelper.php');
		$this->_model =& $this->getInstance('blooking', 'BlookingModel');
	}
	function searchMultiResults ()
	{
		$results = new stdClass();
		$results->output="";
		$results->code=1;
		$results->remaining_rooms=0;
		$results->summary="";
		$results->restrictions="";
		$results->calendar="";
		$results->new_date="";
		$results->idcategories="";
		$results->year_calendar="";
		$results->rooms="";

		$posted_data = JRequest::get('get');
		//PARAMS
		$params = BlookingHelper::getParams();
		$max_booking_period = $params->max_booking_period;

		//POSTED VARS
		$valid_from = $posted_data['valid_from'];
		$valid_to = $posted_data['valid_to'];
		$mode = $posted_data['mode'];
		$adults = 1;
		$children = 0;
		$mode = $posted_data['mode'];
		$lang = $posted_data['lang'];

		$show_daily_rates = $posted_data['show_daily_rates'];
		$show_cal = $posted_data['show_cal'];
		$show_year_calendar = $posted_data['show_year_calendar'];

		//SET TIME VARIABLES
		$nights = $this->_getNights($valid_from, $valid_to);
		$date_code = $this->_getDateFormat();
		$time = date ($date_code, strtotime($valid_from));
		$time = strtotime($time);
		$start_day = date('w', $time);
		$time = strtotime ($mode, $time);
		$month = date('n', $time);
		$year = date('Y', $time);
		$to_time = date ($date_code, strtotime($valid_to));
		$to_time = strtotime($to_time);
		$end_day = date('w', $to_time);


		$nights = $this->_getNights($valid_from, $valid_to);
		if ($nights > $max_booking_period)
		{

			$results->output = "";
			$results->restrictions = JText::_("COM_BOOKIT_THE_MAXIMUM_BOOKING_PERIOD_IS")." ".$max_booking_period;
			$results->code =-4;
			$results->remaining_rooms="";
			$results->summary="";

		}
		else
		{

			$categories = $this->_model->getSuitableRoomCategories($adults,
					$children);
			$res = $this->_getAvailableCategories ($categories,
					$max_booking_period, $start_day, $end_day, $adults, $children, $lang,
					$nights, $valid_from, $valid_to, $posted_data);


			$results->output = $res->output;
			$results->restrictions.=$res->restrictions;
			$results->code = $res->code;
			$results->remaining_rooms=$res->remaining_rooms;

			$results->summary=$this->_getBookingSummary (array());

			$idcategories = "";
			foreach ($categories as $cat)
			{
				if ($idcategories=="")
					$idcategories .= $cat->idcategory;
				else
					$idcategories .= ", ".$cat->idcategory;
			}
		}
		//CALL THE CALENAR
		if ($show_cal==1)
		{
			//The ids of categories that match the selected guests
			$months_ahead = "1";
			$results->calendar = $this->_model->displayMultiRoomCalendar($month, $year,
					$idcategories,	$months_ahead);
			$results->idcategories = $idcategories;
		}

		//YEAR CALENDAR
		if ($show_year_calendar==1)
		{
			$month_in_time = strtotime($valid_from);
			$prev_month = date ($this->_getDateFormat(),
					strtotime("-1 month",$month_in_time));
			$data['valid_from'] = $prev_month;
			$data['idcategories'] = $idcategories;
			$data['mode'] = $mode;
			$year_calendar = $this->_model->getMultiRoomCalendar ($data, "3");
			$results->year_calendar = $year_calendar->calendar;
		}
		else
		{
			$results->year_calendar = "";
		}

		return $results;

	}

	function _getAvailableCategories ($categories, $max_booking_period,
			$start_day, $end_day, $adults, $children, $lang, $nights, $valid_from,
			$valid_to, $posted_data)
	{
		$res = new stdClass();
		$res->code=1;
		$res->output="";

		//RESTRICTION STRINGS
		$max_booking_error_str =
		JText::_('COM_BOOKIT_THE_MAXIMUM_BOOKING_PERIOD_IS').
		" ".$max_booking_period." ".JText::_('COM_BOOKIT_NIGHTS');
		$min_guests_error_str =
		JText::_('COM_BOOKIT_HAS_A_MINIMUM_NUMBER_OF_GUESTS');
		$guests_error_str =
		JText::_('COM_BOOKIT_CANNOT_ACCOMMODATE_THE_SELECTED_NUMBER_OF_GUESTS');
		$allowed_staying_str = JText::_("COM_BOOKIT_THE_ALLOWED_STAYING_PERIOD");
		$nights_str = JText::_("COM_BOOKIT_NIGHTS_LC");
		$min_stay_str = JText::_('COM_BOOKIT_MIN_STAY');
		$max_stay_str = JText::_('COM_BOOKIT_MAX_STAY');
		$end_day_error_str = JText::_('COM_BOOKIT_CHECK_OUT_DAY_MUST_BE');
		$start_day_error_str = JText::_('COM_BOOKIT_CHECK_IN_DAY_MUST_BE');


		$restrictions = array();
		$found=false;

		$data = array();
		$data['nguests'] = $adults;
		$data['nchilds'] = $children;
		$data['valid_from'] = $valid_from;
		$data['valid_to'] = $valid_to;
		$data['nights'] = $nights;
		$data['lang'] = $lang;
		$data['show_daily_rates'] = $posted_data['show_daily_rates'];

		$categories_map = new stdClass();
		$adults_left = $adults;
		$children_left = $children;
		$res->remaining_rooms=0;
		foreach ($categories as $category)
		{
			$categories_map->{$category->name} = new stdClass();
			$categories_map->{$category->name}->rooms = 0;

			//CHECK FOR RESTRICTIONS
			$code = $this->_model->getStayingRestrictions($category, $nights,
					$max_booking_period, $start_day, $end_day, $adults, $children);

			if ($code > 0)
			{
				$found = true;
				$res->code = $code;
			}
			else if ($code == -1)
			{
				$restriction = $category->name." ".
						$guests_error_str.".";
				if (!in_array($restriction, $restrictions))
					array_push($restrictions, $restriction);
				if (!$found)
					$res->code = $code;
				continue;
			}
			else if ($code == -2)
			{
				$restriction = $category->name." ".
						$min_guests_error_str.".";
				if (!in_array($restriction, $restrictions))
					array_push($restrictions, $restriction);
				if (!$found)
					$res->code = $code;
				continue;
			}
			else if ($code == -3)
			{
				if ($category->min_stay !="0" &&
						$category->max_stay!="0")
				{
					$restriction = $category->name.": ".$allowed_staying_str." ".
							$category->min_stay." - ".
							$category->max_stay." ".$nights_str.".";
					if (!in_array($restriction, $restrictions))
						array_push($restrictions, $restriction);
				}
				else if ($category->min_stay != "0")
				{
					$restriction = $category->name.": ".$min_stay_str." ".
							$category->min_stay." ".$nights_str.".";
					if (!in_array($restriction, $restrictions))
						array_push($restrictions, $restriction);
				}
				else if ($category->max_stay != "0")
				{
					$restriction =  $category->name.": ".$max_stay_str." ".
							$category->max_stay." ".$nights_str.".";
					if (!in_array($restriction, $restrictions))
						array_push($restrictions, $restriction);
				}
				if (!$found)
					$res->code = $code;
				continue;
			}
			else if ($code == -5)
			{
				$restStartDay = explode(",", $category->start_day);
				$restEndDay = explode(",", $category->end_day);

				if (($restStartDay[$start_day] == "1") && ($restEndDay[$end_day] == "1"))
				{
					$restriction = $category->name.": ".
							$start_day_error_str." ".
							$this->getAllowedDays($restStartDay).
							", ".$end_day_error_str." ".
							$this->getAllowedDays($restEndDay).".";
					if (!in_array($restriction, $restrictions))
						array_push($restrictions, $restriction);
				}
				else if ($restStartDay[$start_day] == "1")
				{
					$restriction = $category->name.": ".
							$start_day_error_str." ".
							$this->getAllowedDays($restStartDay).".";

					if (!in_array($restriction, $restrictions, true))
						array_push($restrictions, $restriction);
				}
				else if ($restEndDay[$end_day] == "1")
				{
					$restriction = $category->name.": ".
							$end_day_error_str." ".
							$this->getAllowedDays($restEndDay).".";
					if (!in_array($restriction, $restrictions))
						array_push($restrictions, $restriction);
				}
				if (!$found)
					$res->code = $code;
				continue;

			}
			//END OF RESTRICTIONS----------------------------------------------
			//CHECK FOR AVAILABILITY
			$availability_check =
			$this->_model->availabilityCheck($valid_from, $valid_to,
					$category->idcategory);

			if ($availability_check->remaining_rooms > 0)
			{
				$res->remaining_rooms+=$availability_check->remaining_rooms;

				//Prepeare the output for category!
				//$rates = $this->_model->priceCalculation($category, $data);

				$res->output.=$this->_getMultiHTMLOutput ($category, $data,
						$availability_check->remaining_rooms);
					
			}
			else //NO VACANCIES
				continue;

		}
		if (sizeof($restrictions)>0)
		{
			$res->restrictions=JText::_("COM_BOOKIT_ACCOMMODATION_RESTRICTIONS_APPLY");
			$res->restrictions .= " ".implode (" ", $restrictions);
		}
		else {
			$res->restrictions ="";
		}
		return $res;
	}

	//------------------ GENERATE ROOM DESCRIPTION BOX -------------------------
	function _getMultiHTMLOutput ($category, $data,  $rooms)
	{

		//PARAMS
		$params = BlookingHelper::getParams();
		$img_width = 96;
		$img_height = 96;
		$currency = $params->currency;
		$multi_mode = $params->multiroom;

		//MENU PARAMS
		$show_daily_rates = $data['show_daily_rates'];

		//VARS
		$nguests = $data['nguests'];
		$nchilds = $data['nchilds'];
		$valid_from =  $data['valid_from'];
		$valid_to =  $data['valid_to'];
		$nights = $data['nights'];
		$res_row="";
		$price_str="";

		//LABELS
		($nights>1) ? $night_str=JText::_("COM_BOOKIT_NIGHTS"):
		$night_str=JText::_("COM_BOOKIT_NIGHT");
		$book_now_str = JText::_("COM_BOOKIT_BOOK_NOW");

		//FACILITIES TEXT
		$facilities_str="";

		$name_code = $this->_translator ($data['lang'], 'name',
				'#__bookitcategory', 'idcategory', $category->idcategory);


		//THUMBNAIL
		$img_src="";
		$img_width>=$img_height ? $img_ori= 'width' : $img_ori= 'height';
		if ($category->url != "")
		{
			$img_src=JURI::root()."/images/bookit/images/".$category->url;
			$img_str = "<img style='".$img_ori.": 100%;' src='".$img_src."' />";
		}
		else
		{
			$img_src=JURI::root()."/images/bookit/images/sample.png";
			$img_str = "<img style='".$img_ori.": 100%;' src='".$img_src."'
					alt='".JText::_("COM_BOOKIT_PHOTOS_NOT_AVAILABLE")."' />";
		}

		//Close res row
		$res_row .= "<div id='result_row'>";
		//LABEL
		$res_row = "<div class='room_description_row inner_description_gradient'>";


		//DESCRIPTION
		//FILTER FROM LOADPOSITIONS
		$load_position_res = $this->_model->loadPositions ($category, $data['lang']);
		$res_row .="<div id='room_description_inner_div'>";
		//Left Column

		$res_row .="<a class='p3' >".$img_str.
		"<b><img class='large' src='".$img_src."' alt=''/></b></a>";
		$res_row .=$load_position_res->new_description;



		$res_row.="</div>";//Room description inner div


		//$res_row .="<div class='bookit_search_clear'></div>";
		//ROOMS & GUEST
		$res_row .="<div class='room_details_guests_column'>";
		$options = array();

		for ($i=0; $i<=$rooms; $i++)
		{
			array_push($options, JHTML::_('select.option', $i, $i));
		}
		$js = 'onchange="(listsUpdate (\''.$category->idcategory.'\',this.value,'.$rooms.',\''.$data['lang'].'\', \'rooms\', this.id));"';

		if ($multi_mode == 1) {
			$res_row .= "<div class='room_details_guests_column_row'>";
			$res_row .= "<label>".JText::_('COM_BOOKIT_NUMBER_OF_ROOMS')."&nbsp;</label>";
			$res_row .= JHTML::_('select.genericList', $options,
					$category->idcategory.'_rooms', 'class="category_rooms_list" '.$js);
			$res_row .= "</div>";
		} else if ($multi_mode == 2) {
			$js = 'onclick="(listsUpdate (\''.$category->idcategory.'\', this.checked,'.$rooms.',\''.$data['lang'].'\', \'rooms\', this.id));"';
			$res_row .= "<div class='checks'><label>";
			$res_row .= "<input type='checkbox' id='".$category->idcategory."_rooms' class='category_rooms_list' $js>";
			$res_row .= " ".JText::_('COM_BOOKIT_ADD_TO_BOOKING')."</label></div>";
		}



		//guests drop-down
		for ($i=1; $i<=$rooms; $i++)
		{

			$res_row .= "<div id='".$category->idcategory."_row_".$i."' class='room_details_guests_column_row displaynone'>";

			if ($multi_mode == 1) {
				$res_row .= "<label class='room_label'>".
						JText::_('COM_BOOKIT_ROOM')."&nbsp;".$i."</label>";
			} else if ($multi_mode == 2) {
				$res_row .= "<label class='room_label'>".
						JText::_('COM_BOOKIT_GUEST').":</label>";
			}

			$options = array();
			$min_adults=0;
			//$min_adults = $category->nguests_min <= 0 ? 1 : $category->nguests_min;
			// 			if ($category->min_in_total > $category->nguests_min && $category->min_in_total>0  )
			// 				$min_adults = $category->min_in_total;
			// 			else
			$min_adults =  $category->nguests_min <= 0 ? 1 : $category->nguests_min;

			for ($j=$min_adults; $j<=$category->nguests; $j++)
			{
				array_push($options, JHTML::_('select.option', $j, $j));

			}

			$children_options = array();
			if ($category->min_in_total > $category->nchilds_min && $category->min_in_total>0 )
				$min = $category->min_in_total;
			else
				$min = $category->nchilds_min;

			$children_options = $this->getInitialChildOptions ($category, $min_adults);

			$res_row .= "<div class='guests_wrapper'>";
			$js = 'onchange="updateGuests (\''.$category->idcategory.'\', \'adults\', this.value, this.id); listsUpdate (\''.$category->idcategory.'\',this.value,'.$rooms.',\''.$data['lang'].'\', \'adults\', this.id);"';
			$res_row .= "<div class='adults_label'>";
			$res_row .="<span>".JText::_('COM_BOOKIT_ADULTS')."&nbsp;</span>";
			$res_row .="<div class='bookit_search_clear'></div>";
			$res_row .= JHTML::_('select.genericList', $options,
					$category->idcategory.'_room_'.$i.'_adults', 'class="category_adults_list" '.$js);
			$res_row .= "</div>";//adults label

			if ($children_options!=null)
			{
				$js = 'onchange="updateGuests (\''.$category->idcategory.'\', \'children\', this.value, this.id); listsUpdate (\''.$category->idcategory.'\',this.value,'.$rooms.',\''.$data['lang'].'\', \'children\', this.id);"';
				$res_row .= "<div class='children_label'>";
				$res_row .="<span>".JText::_('COM_BOOKIT_CHILDREN')."&nbsp;</span>";
				$res_row .= JHTML::_('select.genericList', $children_options,
						$category->idcategory.'_room_'.$i.'_children',
						'class="category_children_list" '.$js);
				$res_row .= "</div>";//childs label
			}





			$res_row .= "</div>";//guests wrapper

			$res_row .="<div class='bookit_search_clear'></div>";
			$res_row .= "</div>";//row

		}

		$res_row .="</div>";//Close Guests and rooms









		$res_row.="<div class='bookit_search_clear'></div>";

		//PRICE
		$price_and_rates =  $this->calculateRowPrice($category, 0, 0, 0,
				$valid_from, $valid_to, $data['lang'], $nights, $night_str,
				$data['show_daily_rates']);

		$res_row .= $price_and_rates->price_str;


		if ($show_daily_rates==1)
		{
			$res_row.="<div class='bookit_search_result_below'>
					<div class='bookit_search_result_header_rates'>";
			$res_row.="<div id='".$category->idcategory."_daily_rates_header'
					class='bookit_search_result_header_text' style='display:none'>".
					JText::_('COM_BOOKIT_DAILY_RATES_PER_ROOM')."</div></div>
							<div id='".$category->idcategory."_daily_rates' class='bookit_search_result_below_cell_header'></div></div>";
		}

		//LOAD MODULES IF ANY
		$res_row.="<div class='bookit_room_details_module'>";
		$res_row .=$load_position_res->module_text;
		$res_row.="</div><div class='bookit_search_clear'></div>";

		$res_row.="<div class='bookit_search_clear'></div>";
		//Close res row
		$res_row .= "</div>";
		$res_row.="<div class='bookit_search_clear'></div>";
		return $res_row;
	}

	function calculateRowPrice ($category, $rooms, $adults, $children,
			$valid_from, $valid_to, $lang, $nights, $night_str, $show_daily_rates)
	{
		//PARAMS
		$params = BlookingHelper::getParams();
		$currency = $params->currency;
		//Prepare data for priceCalculation
		$data = array();
		$data['nguests'] = $adults;
		$data['nchilds'] = $children;
		$data['valid_from'] = $valid_from;
		$data['valid_to'] = $valid_to;
		$data['lang'] = $lang;

		$res = new stdClass();
		$price_res = $this->_model->priceCalculation($category, $data);



		$price_str="";
		$new_price = ($price_res->price)*$rooms;
		$new_price = number_format ( $new_price, 2, '.', '');


		$price_str .= "<span id='".$category->idcategory."_price_before' class='bookit_search_del'></span>";
		$price_str .= "<div class='bookit_search_clear'></div>";
		$price_str .= "<span id='".$category->idcategory."_below' class='bookit_text_below_price'></span>";
		$price_str .= "<span id='".$category->idcategory."_price' class='bookit_rate_box'>".$new_price."</span>";
		$price_str .= "<span class='bookit_currency_box'>".$currency."</span>";



		$right_div  ="<div id='".$category->idcategory."_price_div' class='bookit_search_result_right'>";
		$right_div .="<div class='bookit_search_result_price'>".$price_str."</div>";
		$right_div .="<div class='bookit_search_clear'></div>";
		$right_div .="<div class='bookit_search_result_nights'>".$nights." ".$night_str."</div>";
		$right_div .="<div class='bookit_search_clear'></div>";
		$right_div .="</div>";

		$res->price_str = $right_div;



		return $res;
	}


	function _getBookingSummary ($categ_name_to_categ, $categ_to_qnt=array(),
			$price=0, $nights=0, $categ_to_adults=array(), $categ_to_children=array(),
			$lang='en')
	{
		//PARAMS
		$params = BlookingHelper::getParams();
		$currency = $params->currency;

		if (empty($categ_name_to_categ))
		{
			$res_row = "<div class='bookit_search_result_row_overall'>";
			$res_row .="<div class='bookit_search_clear'></div>";

			//DESCRIPTION
			$res_row .="<div id='blooking_summary_div' class='bookit_search_summary_desc'>";
			$res_row .="<span class='summary_key'>".
					JText::_("COM_BOOKIT_PLEASE_SELECT_YOUR_ROOMS")."</span>";
			$res_row .="</div>";
			$res_row .="</div>";
			return $res_row;
		}
		//PARAMS
		$params = BlookingHelper::getParams();
		$currency = $params->currency;
		$price_str="";
		//LABELS
		$adult_str = "";
		$child_str = "";

		($nights>1) ? $night_str=JText::_("COM_BOOKIT_NIGHTS"):
		$night_str=JText::_("COM_BOOKIT_NIGHT");
		$book_now_str = JText::_("COM_BOOKIT_BOOK_NOW");

		$res_row = "<div class='bookit_search_result_row_overall'>";


		//DESCRIPTION
		$res_row .="<div id='blooking_summary_div' class='bookit_search_summary_desc'>";
		$res_row .="<div class='blooking_summary_header'>";
		$res_row .="<span class='head block'>";
		$res_row .=JText::_("COM_BOOKIT_YOUR_BOOKING");
		$res_row .= "</span>";
		$res_row .="<span class='block'>";
		$res_row .=	JText::_("COM_BOOKIT_ROOMS_SELECTED").":";
		$res_row .= "</span>";
		$res_row .="</div>";

		//if($lang=='en')$name_code = 'name'; else $name_code='name_'.$lang;

		$total_guests = 0;

		foreach ($categ_name_to_categ as $category)
		{
			$name_code = $this->_translator ($lang, 'name',
					'#__bookitcategory', 'idcategory', $category->idcategory);

			$nguests = $categ_to_adults[$category->name];
			if (isset($categ_to_children[$category->name]))
				$nchilds = $categ_to_children[$category->name];
			else
				$nchilds=0;

			($nchilds>1 || $nchilds==0) ?
			$child_str=JText::_("COM_BOOKIT_CHILDREN") :
			$child_str=JText::_("COM_BOOKIT_CHILD");
			($nguests>1) ? $adult_str=JText::_("COM_BOOKIT_ADULTS") :
			$adult_str=JText::_("COM_BOOKIT_ADULT");

			$res_row .="<div class='summary_block'>";


			$res_row .="<div class='summary_row'>";
			$res_row .="<div class='summary_key'>".$name_code."</div>";
			$res_row .="<div class='summary_value'>".$categ_to_qnt[$category->name]."</div>";
			$res_row .="</div>";


			$res_row .="<div class='summary_row'>";
			$res_row .="<span class='summary_key'>".$adult_str."</span>";
			$res_row .="<span class='summary_value'>".$nguests."</span>";
			$res_row .="</div>";


			if ($nchilds > 0)
			{

				$res_row .="<div class='summary_row'>";
				$res_row .="<span class='summary_key'>".$child_str."</span>";
				$res_row .="<span class='summary_value'> ".$nchilds."</span>";
				$res_row .="</div>";
				$total_guests += $nchilds;
			}
			$res_row .="</div>";

			$total_guests+=$nguests;

		}

		$total_rooms = 0;
		foreach ($categ_to_qnt as $key=>$value) $total_rooms +=$value;

		$res_row .="<div class='summary_row bottom'>";
		$res_row .="<span class='summary_key'>".JText::_("COM_BOOKIT_TOTAL_ROOMS")."</span>";
		$res_row .="<span class='summary_value'> ".$total_rooms."</span>";
		$res_row .="</div>";

		$res_row .="<div class='summary_row bottom'>";
		$res_row .="<span class='summary_key'>".JText::_("COM_BOOKIT_TOTAL_GUESTS")."</span>";
		$res_row .="<span class='summary_value'> ".$total_guests."</span>";
		$res_row .="</div>";



		$res_row .="<div class='summary_row bottom total'>";
		$res_row .="<span class='summary_key'>".JText::_("COM_BOOKIT_GRANT_TOTAL")."</span>";
		$res_row .="<span class='summary_value'> ".number_format($price, 2, '.', '')." ".$currency."</span>";
		$res_row .="</div>";


		$res_row.="<div id='bookit_button_div'>";
		$res_row.='<button type="button" id="book_button" class="bookit_button"
				onclick="setsession(\''.$lang.'\');">'.$book_now_str.'</button>';
		$res_row.='</div>';//button


		$res_row.="</div>";//summary
		$res_row .= "</div>";//overall


		return $res_row;

	}


	function updateResults ($posted_data)
	{

		//PARAMS
		$params = BlookingHelper::getParams();
		$show_daily_rates = $params->show_daily_rates;
		$currency = $params->currency;
		$rooms_lists = json_decode($posted_data['rooms_lists']);
		$adults_lists = json_decode($posted_data['adults_lists']);
		$children_lists = json_decode($posted_data['children_lists']);
		$price_lists = json_decode($posted_data['price_lists']);
			
		$updated_id = explode("_",$posted_data['room_list_id']);
		$idcategory= $updated_id[0];

		$category = $this->_model->getCategory($idcategory);

		$adults_array =  get_object_vars($adults_lists);
		$adults=0;
		foreach ($adults_array as $key=>$value)
		{
			$r = explode("_", $key);
			if ($r[0]==$idcategory)
			{
				$adults+=$value;
			}
		}

			

		$children_array =  get_object_vars($children_lists);
		$children=0;
		foreach ($children_array as $key=>$value)
		{
			$r = explode("_", $key);
			if ($r[0]==$idcategory)
			{
				$children+=$value;
			}
		}

		$rooms_array =  get_object_vars($rooms_lists);
		$rooms=0;
		foreach ($rooms_array as $key=>$value)
		{
			$r = explode("_", $key);
			if ($r[0]==$idcategory)
			{
				$rooms=$value;
				break;
			}
		}

		$new_price=0.00;
		$new_price_before=0.00;
		$price_deviation=0.00;
		$res = new stdClass();
		$img_src=JURI::root(true)."/components/com_blooking/images/info.gif";

		$rules_tooltip ="";
		foreach ($adults_array as $key=>$value)
		{
			$r = explode("_", $key);
			if ($r[0]!=$idcategory) continue;
			$children_key = str_replace("_adults", "_children", $key);

			$data['nguests'] = $value;
			if (isset($children_array[$children_key]))
				$data['nchilds'] = $children_array[$children_key];
			else
				$data['nchilds'] = 0;
			$data['valid_from'] = $posted_data['valid_from'];
			$data['valid_to'] = $posted_data['valid_to'];
			$data['lang'] = $posted_data['lang'];

			$price_res = $this->_model->priceCalculation($category, $data);
			$new_price += $price_res->price;
			$new_price_before += $price_res->price_before;
			$price_deviation += $price_res->price_deviation;

			if ($rules_tooltip!="")$rules_tooltip.=",";
			$rules_tooltip.= $price_res->rule_ids;


		}

		$rules_tooltip = explode(",", $rules_tooltip);
		$rules_tooltip=array_map('trim',$rules_tooltip);
		$rules_tooltip = array_unique($rules_tooltip);
		$new_price = number_format ( $new_price, 2, '.', '');
		$res->price_id = $category->idcategory."_price";

		//special rates
		//CHECK FOR RULES
		$res->new_category_price_before ="";
		$res->new_category_price="";
		$res->price_extra_text="";

		$price_str="";
		//1.5.7
		if (isset($price_res->rule_ids)) {
			$arr = explode(",",  $price_res->rule_ids);
			$arr = array_map("trim", $arr);
			$arr = array_unique($arr);
			foreach ($arr as $key => $link)
			{
				if ($arr[$key] == '')
				{
					unset($arr[$key]);
				}
			}
			$price_res->rule_ids = implode(",",$arr);
		}

		if ($price_deviation < 0 && $rooms>0) //Special Offer
		{
			$res->new_category_price_before = number_format ( $new_price_before, 2, '.', '')." ".$currency;
			$res->new_category_price = $new_price;
			$res->price_extra_text = "<span class='bookit_text_below_price'>";
			$res->price_extra_text   .= "<a class='tooltip'>
					<img src='".$img_src."' /><span>".implode(", ", $rules_tooltip).
					"</span></a></span>";
		}
		else if ($price_deviation > 0 && $rooms>0) //Extra charge
		{
			$res->new_category_price = $new_price;
			$res->price_extra_text = "<span class='bookit_text_below_price'><a class='tooltip'>
					<img src='".$img_src."' /><span>".implode(", ", $rules_tooltip).
					"</span></a></span>";

		}
		else
		{
			$res->new_category_price = $new_price;
		}

			

		$res->idcategory = $category->idcategory;

		//Daily Rates
		if ($show_daily_rates==1)
		{
			if ($rooms==0)
				$res->daily_rates ="";
			else
				$res->daily_rates = $price_res->daily_rates_txt;
		}
		else
			$res->daily_rates=null;
		//Update Summary
		$nights = $this->_getNights($posted_data['valid_from'],
				$posted_data['valid_to']);
		$categ_name_to_categ = array();
		$categ_to_qnt = array();

		foreach ($rooms_array as $key=>$value)
		{
			$r = explode("_", $key);
			$idcategory = $r[0];
			$category = $this->_model->getCategory($idcategory);
			$categ_name_to_categ[$category->name] =  $category;
			$categ_to_qnt[$category->name] = $value;

		}

		$categ_to_adults=array();
		foreach ($adults_array as $key=>$value)
		{
			$r = explode("_", $key);
			$idcategory = $r[0];
			$category = $this->_model->getCategory($idcategory);

			if (!isset($categ_to_adults[$category->name]))
				$categ_to_adults[$category->name]=$value;
			else
				$categ_to_adults[$category->name]+=$value;

		}
		$categ_to_children=array();
		foreach ($children_array as $key=>$value)
		{
			$r = explode("_", $key);
			$idcategory = $r[0];
			$category = $this->_model->getCategory($idcategory);
			if (!isset($categ_to_children[$category->name]))
				$categ_to_children[$category->name]=$value;
			else
				$categ_to_children[$category->name]+=$value;

		}
		//Update

		//Total Price
		$total = $new_price;

		$price_array =  get_object_vars($price_lists);
		foreach ($price_array as $price)
		{
			$total += $price;
		}


		$res->summary = $this->_getBookingSummary ($categ_name_to_categ,
				$categ_to_qnt, $total, $nights, $categ_to_adults, $categ_to_children,
				$posted_data['lang']);

		//SET SESSION FOR THE NEXT VIEW---------------------------------

		return $res;
	}

	function updateGuests ($posted_data)
	{
		$category = $this->_model->getCategory($posted_data['idcategory']);
		$res = new stdClass();
		$res->new_options = $this->getGuestOptions(
				$category,
				$posted_data['type'],
				$posted_data['updated_value']);

		//New options for adults or guests in case there is a total max/min
		$type = $posted_data['type'];
		$r = explode ("_", $posted_data['callerid']);
		if ($type=='adults')
			$r[3]='children';
		else if ($type=='children')
			$r[3]='adults';

		$res->id_to_update = implode ("_", $r);
		$res->old_value =$posted_data['updated_value'];
		return $res;
	}

	function getGuestOptions ($category, $changed, $value)
	{

		if ($changed=='adults')
		{
			if ($category->nchilds==0 || ($category->max_in_total==0
					&& $category->min_in_total==0)) return null;

			if ($category->max_in_total>0 && $category->min_in_total>0)
			{
				$start = $category->min_in_total - $value;
				$end = $category->max_in_total - $value;

			}
			else if ($category->max_in_total>0)
			{
				$start = $category->nchilds_min;
				$end = $category->max_in_total - $value;
			}
			else if ($category->min_in_total>0)
			{
				$start = $category->min_in_total - $value;
				$end = $category->nchilds;
			}

			if ($start<$category->nchilds_min){
				$start = $category->nchilds_min;
			}
			if ($end>$category->nchilds){
				$end = $category->nchilds;
			}
		}

		else
			return null;

		$res = array ();
		for ($i=$start; $i<=$end; $i++)
		{
			$res[$i]=$i;
		}




		if (!empty($res))
			return $res;
		else
			return null;
	}



	function setsession ($posted_data)
	{
		$rooms_lists = json_decode($posted_data['rooms_lists']);
		$adults_lists = json_decode($posted_data['adults_lists']);
		$children_lists = json_decode($posted_data['children_lists']);
		$price_lists = json_decode($posted_data['price_lists']);

		$rooms = array();

		$rooms_array =  get_object_vars($rooms_lists);
		$rooms['room'][0]['rooms']=0;
		$rooms['room'][0]['room_types']="";
		$rooms['room'][0]['idcategories'] ="";

		foreach ($rooms_array as $key=>$value)
		{
			$rooms['room'][0]['rooms']+=$value;
			$r = explode("_", $key);
			$idcategory = $r[0];
			$category = $this->_model->getCategory($idcategory);
			$category = $this->_model->getCategoryFromName($category->name);
		}

		$categ_name_to_categ = array();
		$categ_to_qnt = array();

		foreach ($rooms_array as $key=>$value)
		{
			$r = explode("_", $key);
			$idcategory = $r[0];
			$category = $this->_model->getCategory($idcategory);
			$categ_name_to_categ[$category->name] =  $category;
			$categ_to_qnt[$category->idcategory] = $value;

		}
		foreach ($categ_name_to_categ as $key=>$value)
		{
			$category=$value;
			if (isset($rooms['room'][0]['idcategories'])&&$rooms['room'][0]['idcategories']!="")
				$rooms['room'][0]['idcategories'] .= ",".$category->idcategory;
			else
				$rooms['room'][0]['idcategories'] = $category->idcategory;

		}
		foreach ($categ_to_qnt as $key=>$value)
		{
			$category = $this->_model->getCategory($key);
			if (isset($rooms['room'][0]['room_types'])&&$rooms['room'][0]['room_types']!="")
				$rooms['room'][0]['room_types'] .= ", ".$value." ".$category->name;
			else
				$rooms['room'][0]['room_types'] = $value." ".$category->name;
		}

		$children_array =  get_object_vars($children_lists);


		$adults_array =  get_object_vars($adults_lists);
		$rooms['room'][0]['nguests']=0;
		$rooms['room'][0]['idrules'] ="";
		$cnt=1;
		$cat_cnt=1;
		$idcategory=0;

		foreach ($adults_array as $key=>$value)
		{
			$rooms['room'][0]['nguests']+=$value;
			$r = explode("_", $key);
			if ($r[0]!=$idcategory) $cat_cnt=1;
			$idcategory = $r[0];

			$category = $this->_model->getCategory($idcategory);
			$rooms['room'][$cnt]['idcategory']=$category->idcategory;
			$rooms['room'][$cnt]['category_name']=$category->name;
			$rooms['room'][$cnt]['nguests']=$value;
			if(isset($children_array[$category->idcategory."_room_".$cat_cnt."_children"]))
				$rooms['room'][$cnt]['nchilds']=$children_array[$category->idcategory."_room_".$cat_cnt."_children"];
			else
				$rooms['room'][$cnt]['nchilds']=0;

			$data['nguests'] = $value;
			if(isset($children_array[$category->idcategory."_room_".$cat_cnt."_children"]))
				$data['nchilds']=$children_array[$category->idcategory."_room_".$cat_cnt."_children"];
			else
				$data['nchilds']=0;

			$data['valid_from'] = $posted_data['valid_from'];
			$data['valid_to'] = $posted_data['valid_to'];
			$data['lang'] = $posted_data['lang'];

			$price_res = $this->_model->priceCalculation($category, $data);
			$rooms['room'][$cnt]['price']=$price_res->price;
			$rooms['room'][$cnt]['price_deviation'] = $price_res->price_deviation;
			$rooms['room'][$cnt]['idrules'] = $price_res->idrules;


			if ($rooms['room'][0]['idrules']!="")
				$rooms['room'][0]['idrules'] .= ",".$price_res->idrules;
			else
				$rooms['room'][0]['idrules'] .= $price_res->idrules;

			$cat_cnt++;
			$cnt++;
		}

		$array = explode(",",$rooms['room'][0]['idrules']);
		$array = array_unique($array);
		$rooms['room'][0]['idrules']= implode(",",$array);


		$rooms['room'][0]['nchilds']=0;
		foreach ($children_array as $key=>$value)
		{
			$rooms['room'][0]['nchilds']+=$value;
		}
			
			
		$price_array =  get_object_vars($price_lists);
		$rooms['room'][0]['price']=0.00;
		foreach ($price_array as $price)
		{
			$rooms['room'][0]['price']+= $price;
		}
		$rooms['room'][0]['nights'] = $this->_getNights($posted_data['valid_from'],
				$posted_data['valid_to']);

			

		$session = JFactory::getSession();
		$session->set('blooking_rooms', $rooms);

	}



	//-------------------------- HELPER METHODS --------------------------------
	function _toMysqlDateFormat ($dateString)
	{
		$date_format = $this->_getDateFormat ();
		$originalDate = strtotime($dateString);
		return date("Y-m-d", $originalDate);
	}
	function _getDateFormat ()
	{
		$params = BlookingHelper::getParams();
		$dateformatcode = $params->dateformat;
		if ($dateformatcode==""||$dateformatcode==3)
			$d1='d-m-Y';
		else if ($dateformatcode==1)
			$d1='Y-m-d';
		else if ($dateformatcode==2)
			$d1='m/d/Y';
		return $d1;
	}
	function _getNights ($from, $to)
	{
		$from_time = strtotime($from);
		$to_time = strtotime($to);
		return (round( ($to_time-$from_time )/86400)) ;
	}
	function _translator ($lang, $column, $table, $idkey, $idvalue)
	{

		$sql = "SELECT * FROM ".$this->_db->nameQuote($table)." WHERE ".
				$this->_db->nameQuote($idkey)."=".$this->_db->quote($idvalue);
		$this->_db->setQuery($sql);
		$obj = $this->_db->loadObject();

		if($lang!='en')
		{
			$new_column=$column.'_'.$lang;
			if(isset($obj->{$new_column}))
				return $obj->{$new_column};
		}
		return $obj->{$column};

	}
	function getAllowedDays ($days)
	{
		$res = "";
		if ($days[0]==0)
			if ($res!="")
			$res .=" or ".JText::_('SUNDAY');
		else
			$res = JText::_('SUNDAY');
		if ($days[1]==0)
			if ($res!="")
			$res .=" or ".JText::_('MONDAY');
		else
			$res =JText::_('MONDAY');
		if ($days[2]==0)
			if ($res!="")
			$res .=" or ".JText::_('TUESDAY');
		else
			$res = JText::_('TUESDAY');
		if ($days[3]==0)
			if ($res!="")
			$res .=" or ".JText::_('WEDNESDAY');
		else
			$res =JText::_('WEDNESDAY');
		if ($days[4]==0)
			if ($res!="")
			$res .=" or ".JText::_('THURSDAY');
		else
			$res =JText::_('THURSDAY');
		if ($days[5]==0)
			if ($res!="")
			$res .=" or ".JText::_('FRIDAY');
		else
			$res =JText::_('FRIDAY');
		if ($days[6]==0)
			if ($res!="")
			$res .=" or ".JText::_('SATURDAY');
		else
			$res =JText::_('SATURDAY');
			
		return $res;
	}


	function getInitialChildOptions ($category, $v)
	{
		if ($category->nchilds==0 || ($category->max_in_total==0
				&& $category->min_in_total==0)) return null;

		if ($category->max_in_total>0 && $category->min_in_total>0)
		{
			$start = $category->min_in_total - $v;
			$end = $category->max_in_total - $v;
		}
		else if ($category->max_in_total>0)
		{
			$start = $category->nchilds_min;
			$end = $category->max_in_total - $v;
		}
		else if ($category->min_in_total>0)
		{
			$start = $category->min_in_total - $v;
			$end = $category->nchilds;
		}
			
		if ($start<$category->nchilds_min){
			$start = $category->nchilds_min;
		}
		if ($end>$category->nchilds){
			$end = $category->nchilds;
		}

			
		$res = array ();
		for ($i=$start; $i<=$end; $i++)
		{
			array_push($res, JHTML::_('select.option', $i, $i));
		}
			
		if (!empty($res))
			return $res;
		else
			return null;
	}

}