<?php
/**
 * BlooKing - The King in Joomla Booking
 * @version 1.0
 * @author BlooKing.org. Based on BooKiTGold code by Costas Kakousis
 * @copyright (C) 2012-2013 by BlooKing.org (http://www.blooking.org)
 * @license GNU/GPL: http://www.gnu.org/copyleft/gpl.html
 *
 * If you fork this to create your own project, please make a reference to
 * BlooKing! someplace in your code and provide a link to
 * http://www.blooking.org
 *
 * This file is part of BlooKing! BlooKing is free software: you can
 * redistribute it and/or modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * BlooKing is distributed in the hope that it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details. You should have received a copy of the GNU General Public License
 * along with BlooKing.  If not, see <http://www.gnu.org/licenses/>.
 *   ______ __                __  __ __
 *	|   __ \  |.-----..-----.|  |/  |__|.-----..-----.
 *	|   __ <  ||  _  ||  _  ||     <|  ||     ||  _  |
 *	|______/__||_____||_____||__|\__|__||__|__||___  |
 *                                             |_____|
 **/
defined( '_JEXEC' ) or die( 'Restricted access' );
jimport( 'joomla.application.component.view');


class BlookingViewBlooking extends JView
{
	function display($expired, $tpl = null)
	{
		jimport('joomla.language.helper');
		JHTML::_( 'behavior.mootools' );
		$view = new stdClass();
		if ($expired==1)
		{
			JFactory::getApplication()->enqueueMessage(
			JText::_( 'COM_BOOKIT_YOUR_SESSION_HAS_EXPIRED' ), 'notice' );
		}


		$version = 5;
		$view->lang = $this->_getLang();
		$view->origin = 'component';


		$model =& $this->getModel('blooking');


		$document = &JFactory::getDocument();
		$document->addScript( JURI::root(true).
				'/components/com_blooking/js/bookit.js' );

		$document->addScript( JURI::root(true).
				'/components/com_blooking/js/json2.js' );

		$document->addScript( JURI::root(true).
				'/components/com_blooking/js/json-minified.js' );

		JLoader::register('BlookingHelper',
		JPATH_COMPONENT_ADMINISTRATOR.'/helpers/BlookingHelper.php');
		$params =  BlookingHelper::getParams();
		$view->show_cal = $params->show_calendar;
		$view->show_year_calendar = $params->show_year_calendar;
		$view->show_daily_rates = $params->show_daily_rates;

		$view->max_booking_period = $params->max_booking_period;
		$view->multiroom = $params->multiroom;
		$view->show_categories_list = 1;
			
		$dateformatcode = $params->dateformat;
		$date_code = $this->_getDateFormat($dateformatcode);
		$view->d1=$date_code->d1;
		$view->d2=$date_code->d2;

		$view->show_bar = $params->show_bar;

		$path = 'components/com_blooking/css/';
		$stylesheet_year_cal = 'year_calendar.css';
		JHTML::stylesheet($stylesheet_year_cal, $path);

		//Set css
		if ($params->new_template == '1') {
			$stylesheet = 'search_form.css';
			$path = 'components/com_blooking/css/thereef/';
			$tpl = 'thereef';

		} else {
			$stylesheet = 'search_form.css';
			$path = 'components/com_blooking/css/';
		}
		JHTML::stylesheet($stylesheet, $path);

		$view->from_day = JText::_(date("l",strtotime("now")));
		$view->to_day = JText::_(date("l",strtotime("+1 day")));
		$last_date = date($date_code->d1, strtotime($params->last_date));

		//Set the date pickers
		$startdate = date ($date_code->d1);
		$min_stay = $model->getMinPeriod();
		$fn="valid_from";
		$fn2="valid_to";
		$js = 'onchange="(updateDateField(\''.$fn.'\',\''.$date_code->d1.'\',
				'.$min_stay.',\''.$last_date.'\' ));
						(setDayName(\''.$fn.'\',\''.$date_code->d1.'\'));
								(setDayName(\''.$fn2.'\',\''.$date_code->d1.'\'));"';

		$view->from_datepicker = JHTML::_( 'calendar',$startdate,'valid_from',
		 	'valid_from',$date_code->d2,'class="bookit_search_inputbox" size="10"
		 	style="z-index:500" '.$js);
			
		$js2 = 'onchange="(updateDateField(\''.$fn2.'\',\''.$date_code->d1.'\',
				'.$min_stay.',\''.$last_date.'\' ));
						(setDayName(\''.$fn2.'\',\''.$date_code->d1.'\'));
								(setDayName(\''.$fn.'\',\''.$date_code->d1.'\'));"';

		$view->to_datepicker = JHTML::_( 'calendar',
				date($date_code->d1,strtotime("+ ".$min_stay."day")),'valid_to',
				'valid_to',$date_code->d2,
				'class="bookit_search_inputbox" size="10"'.$js2);

		$view->last_date = $last_date;

		//Set the lists with a little help from the model

		$options = array();
		$options = $model->getCategoryOptions($view->lang);
		$lists=array();

		if (count($options)>1)
		{
			$selectOne = JText::_("COM_BOOKIT_SELECT_ONE");
			$results[] = JHTML::_('select.option', 0, $selectOne);

			$results = array_merge( $results, $options);
				
			$lists['catid']  = JHTML::_('select.genericList', $results, 'idcategory',
					'class="bookit_search_dropbox"');
		}
		else if (count($options)==1)
		{
			$lists['catid']  = JHTML::_('select.genericList', $options, 'idcategory',
					'class="bookit_search_dropbox"');
		}
		else
		{

			$options[] = JHTML::_('select.option', 0, JText::_('COM_BOOKIT_NO_CATEGORIES'));
			$lists['catid']  = JHTML::_('select.genericList', $options, 'idcategory',
					'class="bookit_search_dropbox" size="1" ');
		}

		$js = 'onchange="(onGuestsChange());"';

		$adult_options = array();
		for ($i=1; $i<=4; $i++)
		{
			array_push ($adult_options, JHTML::_('select.option', $i, $i));
		}
		$lists['nguests']  = JHTML::_('select.genericList', $adult_options, 'nguests',
				'class="bookit_guest_dropbox" '.$js);


		$children_options = array();
		for ($i=0; $i<=3; $i++)
		{
			array_push ($children_options, JHTML::_('select.option', $i, $i));
		}
		$max_min = $model->getMaxMinGuests();

		if ($max_min->max_childs <= 0)
			$lists['nchilds']  = JHTML::_('select.genericList', $children_options, 'nchilds',
					'class="bookit_guest_dropbox" style="display:none" size="1" '.$js);
		else
			$lists['nchilds']  = JHTML::_('select.genericList', $children_options, 'nchilds',
					'class="bookit_guest_dropbox" size="1" '.$js);
		$view->max_min = $max_min;

		$view->lists = $lists;
		$this->assignRef( 'view', $view );

		$menuitemid = JRequest::getInt( 'Itemid' );
			
		$menu = & JSite::getMenu();
		$item = $menu->getActive();
		$pageSuffix="";
		$showTitle="";
		$class="";
		$pageTitle="";

		if (isset($item))
		{
			$params = $item->params;

			if(version_compare(JVERSION,'1.6.0','ge')) {
				$showTitle = $params->get('show_page_heading');
				$pageSuffix = $params->get('pageclass_sfx');
				$class = "itempage";
				$pageTitle = "<h1>".$this->escape($document->title)."</h1>";
			} else {
				$params = new JParameter( $params );
				$showTitle = $params->get('show_page_title');
				$pageSuffix = $params->get('pageclass_sfx');
				$class = "componentheading";
				$pageTitle = $this->escape($document->title);
			}
		}

		$menuItemHeading = array();

		$menuItemHeading['pagetitle'] = $pageTitle;
		$menuItemHeading['pagesuffix'] = $pageSuffix;
		$menuItemHeading['showtitle'] = $showTitle;
		$menuItemHeading['class'] = $class;

		$this->assignRef( 'itemid', $menuitemid );
		$this->assignRef( 'menuparams', $menuItemHeading );


		parent::display($tpl);

	}

	function _getDateFormat ($dateformatcode)
	{
		$res = new stdClass();
		if ($dateformatcode==""||$dateformatcode==3)
		{
			$d1='d-m-Y';
			$d2='%d-%m-%Y';
		}
		else if ($dateformatcode==1)
		{
			$d1='Y-m-d';
			$d2='%Y-%m-%d';
		}
		else if ($dateformatcode==2)
		{
			$d1='m/d/Y';
			$d2='%m/%d/%Y';
		}

		$res->d1 = $d1;
		$res->d2 = $d2;
		return $res;
	}

	function _getLang()
	{
		$lg = JFactory::getLanguage();
		if(version_compare(JVERSION,'1.6.0','ge'))
		{
			$lang_code = explode('-',$lg->getTag());
			$lang = $lang_code[0];
		}
		else
		{
			$lang_code = explode('-',$lg->_lang);
			$lang = $lang_code[0];
		}
		return $lang;
	}

	function displayModule ()
	{
		$data = JRequest::get('post');

		jimport('joomla.language.helper');
		JHTML::_( 'behavior.mootools' );
		$view = new stdClass();

		$view->lang = $this->_getLang();

		$session =& JFactory::getSession();
		$booking_session = $session->get('mod_blooking', array());
		$data['mod_rooms']=0;

		$session->set('mod_blooking', $data);


		JLoader::register('BlookingHelper',
		JPATH_COMPONENT_ADMINISTRATOR.'/helpers/BlookingHelper.php');
		$com_params =  BlookingHelper::getParams();
		//Set css
		if ($com_params->new_template == '1') {
			$stylesheet = 'search_form.css';
			$path = 'components/com_blooking/css/thereef/';

		} else {
			$stylesheet = 'search_form.css';
			$path = 'components/com_blooking/css/';
		}
		JHTML::stylesheet($stylesheet, $path);

		//Calendar
		$path = 'components/com_blooking/css/';
		$stylesheet_year_cal = 'year_calendar.css';
		JHTML::stylesheet($stylesheet_year_cal, $path);

		$document = &JFactory::getDocument();
		$document->addScript( JURI::root(true).
				'/components/com_blooking/js/bookit.js' );
		$model =& $this->getModel('blooking');
		$min_stay = $model->getMinPeriod();

		JLoader::register('BlookingHelper',
		JPATH_COMPONENT_ADMINISTRATOR.'/helpers/BlookingHelper.php');
		$params =  BlookingHelper::getParams();
		$view->show_cal = $params->show_calendar;
		$view->show_year_calendar = $params->show_year_calendar;
		$view->show_daily_rates = $params->show_daily_rates;
		$view->origin = 'module';
		$view->max_booking_period = $params->max_booking_period;
		//$view->default_category = $params->get('default_category',0);

		$view->show_bar = $params->show_bar;

		$view->multiroom = $params->multiroom;
		$view->show_categories_list = 1;

		$dateformatcode = $params->dateformat;
		$date_code = $this->_getDateFormat($dateformatcode);
		$view->d1=$date_code->d1;
		$view->d2=$date_code->d2;

		//Set css
		if ($params->new_template == '1') {
			$stylesheet = 'search_form.css';
			$path = 'components/com_blooking/css/thereef/';
			$tpl = 'thereef';
		} else {
			$stylesheet = 'search_form.css';
			$path = 'components/com_blooking/css/';
		}



		//Set the date pickers
		$checkin = $data['mod_valid_from'];
		$checkout = $data['mod_valid_to'];
		$last_date = date($date_code->d1, strtotime($params->last_date));

		$fn="valid_from";
		$fn2="valid_to";
		$js = 'onchange="(updateDateField(\''.$fn.'\',\''.$date_code->d1.'\',
				'.$min_stay.',\''.$last_date.'\' ));
						(setDayName(\''.$fn.'\',\''.$date_code->d1.'\'));
								(setDayName(\''.$fn2.'\',\''.$date_code->d1.'\'));"';

		$view->from_datepicker = JHTML::_( 'calendar',$checkin,'valid_from',
				'valid_from',$date_code->d2,'class="bookit_search_inputbox" size="10"
				style="z-index:500" '.$js);

		$js2 = 'onchange="(updateDateField(\''.$fn2.'\',\''.$date_code->d1.'\',
				'.$min_stay.',\''.$last_date.'\' ));
						(setDayName(\''.$fn2.'\',\''.$date_code->d1.'\'));
								(setDayName(\''.$fn.'\',\''.$date_code->d1.'\'));"';

		$view->to_datepicker = JHTML::_( 'calendar', $checkout,'valid_to',
				'valid_to',$date_code->d2,
				'class="bookit_search_inputbox" size="10"'.$js2);

		$view->from_day = JText::_(date("l",strtotime($checkin)));
		$view->to_day = JText::_(date("l",strtotime($checkout)));

		//Set the lists with a little help from the model

		$view->last_date = $last_date;

		$options = array();
		$options = $model->getCategoryOptions($view->lang);
		$lists=array();
		if (count($options)>1)
		{
			$selectOne = JText::_("COM_BOOKIT_SELECT_ONE");
			$results[] = JHTML::_('select.option', 0, $selectOne);

			$results = array_merge( $results, $options);
				
			$lists['catid']  = JHTML::_('select.genericList', $results, 'idcategory',
					'class="bookit_search_dropbox" size="1" '.$js, 'value', 'text',
					$data['mod_idcategory']);
		}
		else if (count($options)==1)
		{
			$lists['catid']  = JHTML::_('select.genericList', $options, 'idcategory',
					'class="bookit_search_dropbox" size="1" ', 'value', 'text',
					$data['mod_idcategory']);
		}
		else
		{
			$options[] = JHTML::_('select.option', 0, JText::_('COM_BOOKIT_NO_CATEGORIES'));
			$lists['catid']  = JHTML::_('select.genericList', $options, 'idcategory',
					'class="bookit_search_dropbox" size="1" ');
		}


		$js = 'onchange="(onGuestsChange());"';
		$result = $model->oncategorychange ( $data['mod_idcategory']);
		$adult_options = array();
		foreach ($result->adults as $k=>$v)
		{
			array_push ($adult_options, JHTML::_('select.option', $k, $v));
		}
		$lists['nguests']  = JHTML::_('select.genericList', $adult_options, 'nguests',
				'class="bookit_guest_dropbox" '.$js, 'value', 'text',
				$data['mod_nguests']);
			

		$children_options = array();
		$mod_nchilds = JRequest::getVar('mod_nchilds', 0);

		foreach ($result->children as $k=>$v)
		{
			array_push ($children_options, JHTML::_('select.option', $k, $v));
		}
		$lists['nchilds']  = JHTML::_('select.genericList', $children_options, 'nchilds',
				'class="bookit_guest_dropbox" '.$js, 'value', 'text',$mod_nchilds);

		$max_min = $model->getMaxMinGuests();
		$view->max_min = $max_min;

		$view->lists = $lists;

		$menuitemid = JRequest::getInt( 'Itemid' );
		$this->assignRef( 'itemid', $menuitemid );
		$this->assignRef( 'view', $view );
		parent::display($tpl);
	}

}