<?php
/**
 * BlooKing - The King in Joomla Booking
 * @version 1.0
 * @author BlooKing.org. Based on BooKiTGold code by Costas Kakousis
 * @copyright (C) 2012-2013 by BlooKing.org (http://www.blooking.org)
 * @license GNU/GPL: http://www.gnu.org/copyleft/gpl.html
 *
 * If you fork this to create your own project, please make a reference to
 * BlooKing! someplace in your code and provide a link to
 * http://www.blooking.org
 *
 * This file is part of BlooKing! BlooKing is free software: you can
 * redistribute it and/or modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * BlooKing is distributed in the hope that it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details. You should have received a copy of the GNU General Public License
 * along with BlooKing.  If not, see <http://www.gnu.org/licenses/>.
 *   ______ __                __  __ __
 *	|   __ \  |.-----..-----.|  |/  |__|.-----..-----.
 *	|   __ <  ||  _  ||  _  ||     <|  ||     ||  _  |
 *	|______/__||_____||_____||__|\__|__||__|__||___  |
 *                                             |_____|
 **/

defined( '_JEXEC' ) or die( 'Restricted access' );
jimport( 'joomla.application.component.view' );

class BlookingViewBlooking extends JView {

	function display($tpl = null) {
		$posted_data = JRequest::get('');
		$model =& $this->getModel( 'blooking' );
		$results = $model->searchResults ($posted_data);

		$start_day = $results->start_day;
		$end_day = $results->end_day;



		$data = array();
		$data['code'] = $results->code;
		$data['remaining_rooms'] = $results->remaining_rooms;
		$data['output'] = $results->output;
		$data['calendar'] =  $results->calendar;
		$data['new_date'] =  $results->new_date;
		$data['max_stay'] =  $results->max_stay;
		$data['min_stay'] =  $results->min_stay;
		$data['start_day'] =  $start_day;
		$data['end_day'] =  $end_day;
		$data['price'] =  $results->price;
		$data['idroom'] =  $results->idroom;
		$data['idrules'] =  $results->idrules;

		//YEAR CALENDAR
		if ($posted_data['show_year_calendar']==1)
		{
			$month_in_time = strtotime($posted_data['valid_from']);
			$prev_month = date ($this->_getDateFormat(),
					strtotime("-1 month",$month_in_time));
			$posted_data['valid_from'] = $prev_month;
			$year_calendar = $model->getCalendar ($posted_data, "3");
			$data['year_calendar'] = $year_calendar->calendar;
		}
		else
		{
			$data['year_calendar'] = "";
		}

		$document =& JFactory::getDocument();
		// Set the MIME type for JSON output.
		$document->setMimeEncoding( 'application/json' );

		echo json_encode( $data );
	}



	function calendar($tpl = null) {
		$posted_data = JRequest::get('');
		$model =& $this->getModel( 'blooking' );
		$result = $model->getCalendar ($posted_data, "1");

		$data = array();
		$data['calendar'] =  $result->calendar;
		$data['new_date'] =  $result->new_date;

		$document =& JFactory::getDocument();
		$document->setMimeEncoding( 'application/json' );

		echo json_encode( $data );
	}
	function oncategorychange()
	{
		$posted_data = JRequest::get('');
		$model =& $this->getModel( 'blooking' );

		$data = array();
		$result = $model->oncategorychange ($posted_data['idcategory']);
		$data['adults'] =  $result->adults;
		$data['children'] =  $result->children;


		$document =& JFactory::getDocument();
		$document->setMimeEncoding( 'application/json' );

		echo json_encode( $data );
	}
	function _getDateFormat ()
	{
		JLoader::register('BlookingHelper',
		JPATH_COMPONENT_ADMINISTRATOR.'/helpers/BlookingHelper.php');
		$params = BlookingHelper::getParams();
		$dateformatcode = $params->dateformat;
		if ($dateformatcode==""||$dateformatcode==3)
			$d1='d-m-Y';
		else if ($dateformatcode==1)
			$d1='Y-m-d';
		else if ($dateformatcode==2)
			$d1='m/d/Y';
		return $d1;
	}

}