<?php
/**
 * BlooKing - The King in Joomla Booking
 * @version 1.0
 * @author BlooKing.org. Based on BooKiTGold code by Costas Kakousis
 * @copyright (C) 2012-2013 by BlooKing.org (http://www.blooking.org)
 * @license GNU/GPL: http://www.gnu.org/copyleft/gpl.html
 *
 * If you fork this to create your own project, please make a reference to
 * BlooKing! someplace in your code and provide a link to
 * http://www.blooking.org
 *
 * This file is part of BlooKing! BlooKing is free software: you can
 * redistribute it and/or modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * BlooKing is distributed in the hope that it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details. You should have received a copy of the GNU General Public License
 * along with BlooKing.  If not, see <http://www.gnu.org/licenses/>.
 *   ______ __                __  __ __
 *	|   __ \  |.-----..-----.|  |/  |__|.-----..-----.
 *	|   __ <  ||  _  ||  _  ||     <|  ||     ||  _  |
 *	|______/__||_____||_____||__|\__|__||__|__||___  |
 *                                             |_____|
 **/

// No direct access
defined('_JEXEC') or die('Restricted access');
$url = 'index.php';

$no_vacancies_error_str = JText::_('COM_BOOKIT_SORRY_NO_VACANCIES').
JText::_('COM_BOOKIT_PLEASE_CHANGE_CRITERIA');
$available_str = JText::_('COM_BOOKIT_ROOMS_ARE_AVAILABLE_FOR_THE_SELECTED_DATES');

//PHP STRINGS FOR JS
$monday = JText::_("Monday");
$tuesday = JText::_("Tuesday");
$wednesday = JText::_("Wednesday");
$thursday = JText::_("Thursday");
$friday = JText::_("Friday");
$saturday = JText::_("Saturday");
$sunday = JText::_("Sunday");

$ajax = <<<EOD
window.addEvent('domready',function() {

var phpStrings = {
		Days : {  monday : "{$monday}", tuesday : "{$tuesday}",
			wednesday : "{$wednesday}", thursday : "{$thursday}",
        	friday : "{$friday}", saturday : "{$saturday}",
        	sunday : "{$sunday}" }
	};
new init(phpStrings);

//updateGuestFields ( '1', '{$this->view->min_max->max_childs}');
var Browser = {
  Version: function() {
    var rv = 999;
    if (navigator.appName == 'Microsoft Internet Explorer')
   {
      var ua = navigator.userAgent;
      var re  = new RegExp("MSIE ([0-9]{1,}[\.0-9]{0,})");
      if (re.exec(ua) != null)
         rv = parseFloat( RegExp.$1 );
   }
   return rv;
  }
}


if (Browser.Version() <= 7) {
JSON.decode = function(string, secure){
return jsonParse(string);
};
}

var req = new Request.JSON({
method: 'get',
url: '',
data: {},
onRequest: function() {
document.id('quick_results_error').set('html', '');
document.id('quick_results').set('html', '');
document.id('quick_results').removeClass('bookit_available');
document.id('quick_results').removeClass('bookit_unavailable');
document.id('bookit_search_loading').addClass('ajax_loading');
},
onFailure: function(xhr) {;},
onSuccess: function(r) {
document.id('bookit_search_loading').removeClass ('ajax_loading');
if (typeof(r)!=undefined && r!=null)
{

if(r.remaining_rooms > 0)
{
//Show results
document.id('quick_results').addClass('bookit_available');
document.id('quick_results').set('html',"{$available_str}");
document.id('bookit_search_results').style.display='';
document.id('bookit_search_summary').set('html',r.summary);
document.id('bookit_search_room_details').set('html',r.output);
document.id('toggle_search_panel_wrapper').style.visibility="visible";

}
else
{
document.id('quick_results').addClass('bookit_unavailable');
//No vacancies
document.id('quick_results').set('html',
"{$no_vacancies_error_str}");

if (r.restrictions!="")
{
document.id('quick_results_error').set('html', r.restrictions);
document.id('quick_results_error').addClass('bookit_restrictions');
//$('calendar_buttons').style.visibility='hidden';
}
}

//ONE MONTH CALENDAR
if (r.calendar != "")
{
document.id('bookit_search_calendar_div').set('html',r.calendar);
document.id('bookit_search_calendar_div').style.display='';
document.id('calendar_buttons').style.visibility='visible';
document.id('new_date').value=r.new_date;
document.id('idcategories').value = r.idcategories;
}
//THREE MONTHS CALENDAR
if (r.year_calendar != "")
{
document.id('bookit_search_results_nov').set('html',r.year_calendar);
document.id('bookit_search_results_nov').style.height='250px';
document.id('bookit_search_results_nov').style.display='';
document.id('availability_fieldset').style.display='';
}
}
},
onError: function(text, error) {
alert(error.message);
}
});


document.id('bookit_search_button').addEvent('click',function(event){
event.stop();
req.get({'option':'com_blooking', 'task':'searchMultiResults',
'format':'json', 'view':'blooking_multiroom',
'valid_from':document.id('valid_from').value, 'valid_to':document.id('valid_to').value,
'idcategory':'0', 'mode':'+0 month','tmpl':'component',
'show_daily_rates': '{$this->view->show_daily_rates }',
'show_cal': '{$this->view->show_cal }',
'show_year_calendar': '{$this->view->show_year_calendar }',
'lang':'{$this->view->lang}'});
});

if ('{$this->view->origin}'=='module')
{
req.get({'option':'com_blooking', 'task':'searchMultiResults',
'format':'json', 'view':'blooking_multiroom',
'valid_from':document.id('valid_from').value, 'valid_to':document.id('valid_to').value,
'idcategory':'0', 'mode':'+0 month','tmpl':'component',
'show_daily_rates': '{$this->view->show_daily_rates }',
'show_cal': '{$this->view->show_cal }',
'show_year_calendar': '{$this->view->show_year_calendar }',
'lang':'{$this->view->lang}'});

}


//-----CALENDAR EVENTS
var jsonCalReq = new Request.JSON({
method: 'get',
url: '',
data: {},
onRequest: function() {
},
onFailure: function(xhr) {;},
onSuccess: function(r) {

if (typeof(r)!=undefined && r!=null)
{
document.id('bookit_search_calendar_div').set('html',r.calendar);
document.id('bookit_search_calendar_div').style.display='';
document.id('calendar_buttons').style.visibility='visible';
document.id('new_date').value=r.new_date;
}
},
onError: function(response) {
alert('error');
}
});


document.id('prev_link').addEvent('click',function(event){
event.stop();
jsonCalReq.get({'option':'com_blooking', 'task':'availabilityCalendar',
'format':'json', 'view':'blooking_multiroom',
'idcategories':document.id('idcategories').value, 'tmpl':'component',
'valid_from':document.id('valid_from').value, 'mode':'-1 month',
'new_date':document.id('new_date').value});
});

document.id('next_link').addEvent('click',function(event){
event.stop();
jsonCalReq.get({'option':'com_blooking', 'task':'availabilityCalendar',
'format':'json', 'view':'blooking_multiroom',
'idcategories':document.id('idcategories').value, 'tmpl':'component',
'valid_from':document.id('valid_from').value, 'mode':'+1 month',
'new_date':document.id('new_date').value});
});

//ROOM DETAILS TOOGLE EFFECT
document.id('toggle_room_details').addEvent('click', function(event){
event.stop();
if(document.id('bookit_search_room_details').style.display!='none')
{
document.id('bookit_search_room_details').style.display='none';
document.id('toggle_label').set('class','toggle_label_closed');
}
else
{
document.id('bookit_search_room_details').style.display='';
document.id('toggle_label').set('class','toggle_label_open');
}
event.stop();
});


document.id('toggle_search_panel').addEvent('click', function(event){
event.stop();
if(document.id('bookit_search_div').style.display!='none')
{
document.id('bookit_search_div').style.display='none';
document.id('search_toggle_label_hide').style.display='none';
document.id('search_toggle_label_show').style.display='';

}
else
{
document.id('bookit_search_div').style.display='';
document.id('search_toggle_label_hide').style.display='';
document.id('search_toggle_label_show').style.display='none';
}
event.stop();
});


});
EOD;

$doc = & JFactory::getDocument();
$doc->addScriptDeclaration( $ajax );
if(JRequest::getCmd('task')!="displayModule") {
	if ($this->menuparams['showtitle'] == '1') {?>
<div
	class="<?php echo $this->menuparams['class'].$this->escape($this->menuparams['pagesuffix']); ?>">
	<?php if (isset($this->menuparams['pagetitle'])) {
		echo $this->menuparams['pagetitle'];
			}?>
</div>
<?php 
	}
}?>

<?php if ($this->view->show_bar==1) {?>
<!-- Progress Bar -->
<ol id="progress">
	<li class="first-step current"><span><?php echo JText::_("COM_BOOKIT_BOOKING_DETAILS");?>
	</span> <?php echo JText::_("COM_BOOKIT_DATES_GUESTS_ROOM_TYPE");?>
	</li>
	<li class="second-step"><span><?php echo JText::_("COM_BOOKIT_REVIEW_BOOKING");?>
	</span> <?php echo JText::_("COM_BOOKIT_EXTRAS_REQUESTS");?>
	</li>
	<li class="payment-step"><span><?php echo JText::_("COM_BOOKIT_PAYMENT");?>
	</span> <?php echo JText::_("COM_BOOKIT_PP_BANK_TRANSFER");?>
	</li>
</ol>
<div class="bookit_search_clear"></div>

<?php }?>
<form
	id="bookingform" action="<?php echo JRoute::_( 'index.php');?>"
	name="searchForm" method="post">
	<fieldset class="bookit_search_fieldset">
		<legend class="bookit_search_legent">
			<?php echo JText::_('COM_BOOKIT_SEARCH_AVAILABILITY');?>
		</legend>

		<div id="bookit_search_div">
			<div id="bookit_panel_wrapper">
				<div id="bookit_search_tdl">
					<p>
						<label for="valid_from" class="bookit_search_label"> <?php echo JText::_("COM_BOOKIT_CHECK_IN");?>
						</label>
					</p>
					<p>
						<?php echo $this->view->from_datepicker; ?>
					</p>

				</div>

				<div class="bookit_search_tdr">
					<p>
						<label for="valid_to" class="bookit_search_label"> <?php echo JText::_("COM_BOOKIT_CHECK_OUT")?>
						</label>
					</p>
					<p>
						<?php echo $this->view->to_datepicker;?>
					</p>
				</div>
				<div class="bookit_search_clear"></div>

				<div id="valid_from_day_div" class="bookit_search_tdl_day">
					<?php echo $this->view->from_day;?>
				</div>
				<div id="valid_to_day_div" class="bookit_search_tdr_day">
					<?php echo $this->view->to_day;?>
				</div>
				<div class="bookit_search_clear"></div>


				<!--<div id="bookit_adults_div" class="bookit_adults_multi">
<p><label for="nguests" class="bookit_adults_multi_label"> 
<?php echo JText::_("COM_BOOKIT_ADULTS");?></label></p>

<?php
echo $this->view->guests;
?></div>


<div id="bookit_children_div" class="bookit_children_multi">
<p><label for="nchilds" class="bookit_search_label"> <?php if ($this->view->min_max->max_childs>0) 
echo JText::_("COM_BOOKIT_CHILDREN");?></label></p>
<?php
echo $this->view->childs;
?></div>
-->

				<div class="bookit_search_clear"></div>
				<div id="valid_to_error_div" class="bookit_search_error"
					style="display: none">
					<?php echo JText::_("COM_BOOKIT_LAST_DATE_ERROR")." ".$this->view->last_date;?>
				</div>
				<div class="bookit_search_clear"></div>
				<div class="bookit_search_tdl_day" id="last_date_error"></div>
				<div class="bookit_search_clear"></div>
				<div class="bookit_search_tdr">

					<p>
						<button class="button" id="bookit_search_button">
							<?php echo JText::_('COM_BOOKIT_SEARCH'); ?>
						</button>
					</p>
					<div id="bookit_search_loading"></div>
				</div>

				<div class="bookit_search_clear"></div>
				<div id="quick_results"></div>
				<div class="bookit_search_clear"></div>
				<div id="quick_results_error"></div>

			</div>
			<!-- Search panel wrapper -->

			<div id="bookit_search_calendar_wrapper">
				<div id="calendar_buttons">
					<a href='#' id='prev_link'> <?php echo "&#060;&#060;";?>
					</a> <a href='#' id='next_link'><?php echo "&#062;&#062;";?> </a>
				</div>
				<div id="bookit_search_calendar_div" style="display: none"></div>
			</div>
			<div class="bookit_search_clear"></div>
		</div>
		<!-- Search div  -->
		<div class="bookit_search_clear"></div>


		<div id="toggle_search_panel_wrapper">
			<a id='toggle_search_panel' href='#'> <span
				id='search_toggle_label_hide' class='toggle_label_up'> <?php echo JText::_("COM_BOOKIT_HIDE") ?>
			</span> <span id='search_toggle_label_show' class='toggle_label_down'
				style="display: none"> <?php echo JText::_("COM_BOOKIT_SHOW") ?>
			</span>
			</a>

		</div>


	</fieldset>

	<!-- Search Results -->
	<div id="bookit_search_results" style="display: none">
		<fieldset class="bookit_search_fieldset">
			<legend class="bookit_search_legent">
				<?php echo JText::_("COM_BOOKIT_SEARCH_RESULTS");?>
			</legend>
			<div id="bookit_search_result_found">
				<div id="bookit_search_room_details_wrapper">
					<a id='toggle_room_details' href='#'> <span id='toggle_label'
						class='toggle_label_open'> <?php echo JText::_("COM_BOOKIT_ROOM_DETAILS") ?>
					</span>
					</a>
					<div id='bookit_search_room_details'></div>
				</div>
				<div id="bookit_search_summary"></div>

			</div>
			<div class="bookit_search_clear"></div>
			<div id="bookit_search_result_other"></div>
			<div class="bookit_search_clear"></div>
		</fieldset>
	</div>
	<fieldset id="availability_fieldset" class="bookit_search_fieldset"
		style="display: none">
		<legend class="bookit_search_legent">
			<?php echo JText::_("COM_BOOKIT_AVAILABILITY");?>
		</legend>
		<div id="bookit_search_results_nov" style="display: none"></div>
	</fieldset>

	<!-- Hidden helper fields -->
	<input type="hidden" id="new_date" value=""></input> <input
		type="hidden" id="start_day" value=""></input> <input type="hidden"
		id="end_day" value=""></input> <input type="hidden" id="idcategories"
		value=""></input> <input type="hidden" id='rooms' name="rooms"
		value="8"></input>

	<!-- AC 1.5.7.4 - SEF Shorter URLS -->
	<input type="hidden" name="option" value="com_blooking" /> <input
		type="hidden" name="controller" value="bookingform" /> <input
		type="hidden" name="task" value="bookingdefault" /> <input
		type="hidden" name="itemid"
		value="<?php if (isset($this->menuid)) { echo $this->menuid; } else if (isset($this->itemid)) { echo $this->itemid; } ?>" />
	<!-- SEF Ends -->

</form>
