<?php
/**
 * BlooKing - The King in Joomla Booking
 * @version 1.0
 * @author BlooKing.org. Based on BooKiTGold code by Costas Kakousis
 * @copyright (C) 2012-2013 by BlooKing.org (http://www.blooking.org)
 * @license GNU/GPL: http://www.gnu.org/copyleft/gpl.html
 *
 * If you fork this to create your own project, please make a reference to
 * BlooKing! someplace in your code and provide a link to
 * http://www.blooking.org
 *
 * This file is part of BlooKing! BlooKing is free software: you can
 * redistribute it and/or modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * BlooKing is distributed in the hope that it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details. You should have received a copy of the GNU General Public License
 * along with BlooKing.  If not, see <http://www.gnu.org/licenses/>.
 *   ______ __                __  __ __
 *	|   __ \  |.-----..-----.|  |/  |__|.-----..-----.
 *	|   __ <  ||  _  ||  _  ||     <|  ||     ||  _  |
 *	|______/__||_____||_____||__|\__|__||__|__||___  |
 *                                             |_____|
 **/
defined( '_JEXEC' ) or die( 'Restricted access' );
jimport( 'joomla.application.component.view');


class BlookingViewBlooking_multiroom extends JView
{
	function display($expired, $tpl = null)
	{

		jimport('joomla.language.helper');
		JHTML::_( 'behavior.mootools' );
		if ($expired==1)
		{
			JFactory::getApplication()->enqueueMessage(
			JText::_( 'COM_BOOKIT_YOUR_SESSION_HAS_EXPIRED' ), 'notice' );
		}
		$version = 5;

		$document = &JFactory::getDocument();

		//Scroller
		$document->addScript( JURI::root(true).
				'/components/com_blooking/js/scrollerspy.js' );

		$document->addScript( JURI::root(true).
				'/components/com_blooking/js/bookit.js' );

		$document->addScript( JURI::root(true).
				'/components/com_blooking/js/json2.js' );

		$document->addScript( JURI::root(true).
				'/components/com_blooking/js/json-minified.js' );






		$view = new stdClass();
		$view->origin = "component";
		JLoader::register('BlookingHelper',
		JPATH_COMPONENT_ADMINISTRATOR.'/helpers/BlookingHelper.php');
		$params =  BlookingHelper::getParams();
		$view->show_cal = $params->show_calendar;
		$view->show_year_calendar = $params->show_year_calendar;
		$view->show_daily_rates = $params->show_daily_rates;

		$view->max_booking_period = $params->max_booking_period;
		//$view->default_category = $params->get('default_category',0);

		$view->show_bar = $params->show_bar;

		//Set css
		if ($params->new_template == '1') {
			$stylesheet = 'search_form.css';
			$path = 'components/com_blooking/css/thereef/';
			$tpl = 'thereef';
		} else {
			$stylesheet = 'search_form.css';
			$path = 'components/com_blooking/css/';
		}

		JHTML::stylesheet($stylesheet, $path);

		$path = 'components/com_blooking/css/';
		$stylesheet_year_cal = 'year_calendar.css';
		JHTML::stylesheet($stylesheet_year_cal, $path);

		$model =& $this->getModel('blooking');
		$min_stay = $model->getMinPeriod();

		$view->multiroom = $params->multiroom;
		$dateformatcode = $params->dateformat;
		$date_code = $this->_getDateFormat($dateformatcode);
		$view->d1=$date_code->d1;
		$view->d2=$date_code->d2;

		//Set the date pickers
		$startdate = date ($date_code->d1);
		$fn="valid_from";
		$fn2="valid_to";

		$last_date = date($date_code->d1, strtotime($params->last_date));
		$js = 'onchange="(updateDateField(\''.$fn.'\',\''.$date_code->d1.'\',
				'.$min_stay.',\''.$last_date.'\' ));
						(setDayName(\''.$fn.'\',\''.$date_code->d1.'\'));
								(setDayName(\''.$fn2.'\',\''.$date_code->d1.'\'));"';

		$view->from_datepicker = JHTML::_( 'calendar',$startdate,'valid_from',
		 	'valid_from',$date_code->d2,'class="bookit_search_inputbox" size="10"
		 	style="z-index:500" '.$js);
			
		$js2 = 'onchange="(updateDateField(\''.$fn2.'\',\''.$date_code->d1.'\',
				'.$min_stay.',\''.$last_date.'\' ));
							
						(setDayName(\''.$fn2.'\',\''.$date_code->d1.'\'));
								(setDayName(\''.$fn.'\',\''.$date_code->d1.'\'));"';

		$view->to_datepicker = JHTML::_( 'calendar',
				date($date_code->d1,strtotime("+ 1day")),'valid_to','valid_to',$date_code->d2,
				'class="bookit_search_inputbox" size="10" '.$js2);

		$view->from_day = JText::_(date("l",strtotime("now")));
		$view->to_day = JText::_(date("l",strtotime("+1 day")));
		$view->last_date = $last_date;


		$res = $model->getMaxMinGuests ();
		$view->min_max=$res;

		$lists=array();
		$options = array();
		for ($i=1; $i<9; $i++)
		{
			array_push($options, JHTML::_('select.option', $i, $i));
		}
		$js = 'onchange="(updateGuestFields(this.value, '.$res->max_childs.'));"';
		$lists['rooms']  = JHTML::_('select.genericList', $options, 'rooms',
				'class="bookit_search_rooms_dropbox"');
		$lists = $this->_setGuestDropDowns ($lists, $model, $res);
		$view->lists = $lists;

		//-----------SET ADULTS/CHILDS DROP DOWN-----------------------------------------------
		$view->guests = "";
		for ($i=1; $i<9; $i++)
		{
			if ($i==1)
			{
				$view->guests .= $view->lists['room'.$i.'_adults'];
			}
			else
			{
				$view->guests .= $view->lists['room'.$i.'_adults'];
			}
		}

		$view->childs = "";
		for ($i=1; $i<9; $i++)
		{
			$view->childs .= $view->lists['room'.$i.'_children'];
		}

		$view->lang=$this->_getLang();
		$this->assignRef( 'view', $view );
			
		$menu = & JSite::getMenu();
		$item = $menu->getActive();

		$pageSuffix="";
		$showTitle="";
		$class="";
		$pageTitle="";

		if (isset($item))
		{
			$params = $item->params;
			$this->assignRef('menuid', $item->id);
				
			if(version_compare(JVERSION,'1.6.0','ge')) {
				$showTitle = $params->get('show_page_heading');
				$pageSuffix = $params->get('pageclass_sfx');
				$class = "itempage";
				$pageTitle = "<h1>".$this->escape($document->title)."</h1>";
			} else {
				$params = new JParameter( $params );
				$showTitle = $params->get('show_page_title');
				$pageSuffix = $params->get('pageclass_sfx');
				$class = "componentheading";
				$pageTitle = $this->escape($document->title);
			}
		}

		$menuItemHeading = array();

		$menuItemHeading['pagetitle'] = $pageTitle;
		$menuItemHeading['pagesuffix'] = $pageSuffix;
		$menuItemHeading['showtitle'] = $showTitle;
		$menuItemHeading['class'] = $class;

		$itemid = JRequest::getVar('Itemid');
		$this->assignRef( 'itemid', $itemid );
		$this->assignRef( 'menuparams', $menuItemHeading );

		parent::display($tpl);
	}

	function _getDateFormat ($dateformatcode)
	{
		$res = new stdClass();
		if ($dateformatcode==""||$dateformatcode==3)
		{
			$d1='d-m-Y';
			$d2='%d-%m-%Y';
		}
		else if ($dateformatcode==1)
		{
			$d1='Y-m-d';
			$d2='%Y-%m-%d';
		}
		else if ($dateformatcode==2)
		{
			$d1='m/d/Y';
			$d2='%m/%d/%Y';
		}

		$res->d1 = $d1;
		$res->d2 = $d2;
		return $res;
	}
	function _setGuestDropDowns ($lists, $model, $res, $pref='', $data=array())
	{
		for ($j=1; $j<9; $j++)
		{

			$options = array();
			for ($i=1; $i<=$res->max_adults; $i++)
			{
				array_push($options, JHTML::_('select.option', $i, $i));
			}

			if ($j==1&& $res->max_adults > 0)
				$style = 'class="bookit_search_rooms_dropbox"';
			else
				$style = 'class="bookit_search_rooms_dropbox_hidden"';

			//if (!empty($data)) $default = $data[$pref.'room'.$j.'_adults'];
			//else	$default = 0;
			$default = 0;
			$style .= 'onchange=onGuestsChange();';
			$lists['room'.$j.'_adults']  = JHTML::_('select.genericList',
					$options, 'room'.$j.'_adults', $style, 'value', 'text', $default);

			$options = array();
			for ($i=$res->min_childs; $i<=$res->max_childs; $i++)
			{
				array_push($options, JHTML::_('select.option', $i, $i));
			}


			if ($j==1&& $res->max_childs > 0)
				$style = 'class="bookit_search_rooms_dropbox"';
			else
				$style = 'class="bookit_search_rooms_dropbox_hidden"';

			$style .= 'onchange=onGuestsChange();';
			if (!empty($data) && isset($data[$pref.'room'.$j.'_children']))
				$default = $data[$pref.'room'.$j.'_children'];
			else	$default = 0;

			$lists['room'.$j.'_children']  = JHTML::_('select.genericList',
					$options, 'room'.$j.'_children', $style, 'value', 'text', $default);

		}

		return $lists;

	}
	function _getLang()
	{
		$lg = JFactory::getLanguage();
		if(version_compare(JVERSION,'1.6.0','ge'))
		{
			$lang_code = explode('-',$lg->getTag());
			$lang = $lang_code[0];
		}
		else
		{
			$lang_code = explode('-',$lg->_lang);
			$lang = $lang_code[0];
		}
		return $lang;
	}

	function displayModule ()
	{
		$data = JRequest::get('post');

		$tpl=null;

		jimport('joomla.language.helper');
		JHTML::_( 'behavior.mootools' );
		$view = new stdClass();

		$view->lang = $this->_getLang();

		$session =& JFactory::getSession();
		$booking_session = $session->get('mod_blooking', array());
		$data['mod_idcategory'] = 0;
		$data['mod_nguests']=0;
		$data['mod_nchilds']=0;
		$session->set('mod_blooking', $data);


		$model =& $this->getModel('blooking');
		$min_stay = $model->getMinPeriod();



		$document = &JFactory::getDocument();
		$document->addScript( JURI::root(true).
				'/components/com_blooking/js/bookit.js' );
		$document->addScript( JURI::root(true).
				'/components/com_blooking/js/json2.js' );
		//Scroller
		$document->addScript( JURI::root(true).
				'/components/com_blooking/js/scrollerspy.js' );

		JLoader::register('BlookingHelper',
		JPATH_COMPONENT_ADMINISTRATOR.'/helpers/BlookingHelper.php');
		$params =  BlookingHelper::getParams();
		$view->show_cal = $params->show_calendar;
		$view->show_year_calendar = $params->show_year_calendar;
		$view->show_daily_rates = $params->show_daily_rates;
		$view->max_booking_period = $params->max_booking_period;
		//$view->default_category = $params->get('default_category',0);

		$view->show_bar = $params->show_bar;

		$view->multiroom = $params->multiroom;
		$view->show_categories_list = 1;
		$view->origin = "module";

		//Set css
		if ($params->new_template == '1') {
			$stylesheet = 'search_form.css';
			$path = 'components/com_blooking/css/thereef/';
			$tpl = 'thereef';
				
		} else {
			$stylesheet = 'search_form.css';
			$path = 'components/com_blooking/css/';
		}
		JHTML::stylesheet($stylesheet, $path);

		$dateformatcode = $params->dateformat;
		$date_code = $this->_getDateFormat($dateformatcode);
		$view->d1=$date_code->d1;
		$view->d2=$date_code->d2;

		$path = 'components/com_blooking/css/';
		$stylesheet_year_cal = 'year_calendar.css';
		JHTML::stylesheet($stylesheet_year_cal, $path);


		//Set the date pickers
		$checkin = $data['mod_valid_from'];
		$checkout = $data['mod_valid_to'];

		$fn="valid_from";
		$fn2="valid_to";
		$last_date = date($date_code->d1, strtotime($params->last_date));

		$js = 'onchange="(updateDateField(\''.$fn.'\',\''.$date_code->d1.'\',
				'.$min_stay.',\''.$last_date.'\' ));
						(setDayName(\''.$fn.'\',\''.$date_code->d1.'\'));
								(setDayName(\''.$fn2.'\',\''.$date_code->d1.'\'));"';

		$view->from_datepicker = JHTML::_( 'calendar',$checkin,'valid_from',
				'valid_from',$date_code->d2,'class="bookit_search_inputbox" size="10"
				style="z-index:500" '.$js);

		$js2 = 'onchange="(updateDateField(\''.$fn2.'\',\''.$date_code->d1.'\',
				'.$min_stay.',\''.$last_date.'\' ));
						(setDayName(\''.$fn2.'\',\''.$date_code->d1.'\'));
								(setDayName(\''.$fn.'\',\''.$date_code->d1.'\'));"';

		$view->to_datepicker = JHTML::_( 'calendar', $checkout,'valid_to',
				'valid_to',$date_code->d2,
				'class="bookit_search_inputbox" size="10" '.$js2);

		$view->from_day = JText::_(date("l",strtotime($checkin)));
		$view->to_day = JText::_(date("l",strtotime($checkout)));
		$view->last_date = $last_date;


		$lists=array();
		//-----------SET CATEGORY DROP DOWN-------------------------------------

		$res = $model->getMaxMinGuests ();
		$view->min_max=$res;

		$options = array();
		for ($i=1; $i<9; $i++)
		{
			array_push($options, JHTML::_('select.option', $i, $i));
		}
		$js = 'onchange="(updateGuestFields(this.value, '.$res->max_childs.'));"';
		$lists['rooms']  = JHTML::_('select.genericList', $options, 'rooms',
				'class="bookit_search_rooms_dropbox"', 'value', 'text',0);
		$lists = $this->_setGuestDropDowns ($lists, $model, $res, 'mod_', $data);


		//-----------SET ADULTS DROP DOWN-------------------------------------------

		$view->guests = "";
		for ($i=1; $i<9; $i++)
		{
			if ($i==1)
			{

				$view->guests .= $lists['room'.$i.'_adults'];
			}
			else
			{

				$view->guests .= $lists['room'.$i.'_adults'];
			}
		}

		$view->childs = "";
		for ($i=1; $i<9; $i++)
		{
			$view->childs .= $lists['room'.$i.'_children'];
		}

		$view->lists = $lists;

		$itemid = JRequest::getVar('Itemid');
		$this->assignRef( 'itemid', $itemid );
		$this->assignRef( 'view', $view );
		parent::display($tpl);
	}
}