<?php
/**
 * BlooKing - The King in Joomla Booking
 * @version 1.0
 * @author BlooKing.org. Based on BooKiTGold code by Costas Kakousis
 * @copyright (C) 2012-2013 by BlooKing.org (http://www.blooking.org)
 * @license GNU/GPL: http://www.gnu.org/copyleft/gpl.html
 *
 * If you fork this to create your own project, please make a reference to
 * BlooKing! someplace in your code and provide a link to
 * http://www.blooking.org
 *
 * This file is part of BlooKing! BlooKing is free software: you can
 * redistribute it and/or modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * BlooKing is distributed in the hope that it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details. You should have received a copy of the GNU General Public License
 * along with BlooKing.  If not, see <http://www.gnu.org/licenses/>.
 *   ______ __                __  __ __
 *	|   __ \  |.-----..-----.|  |/  |__|.-----..-----.
 *	|   __ <  ||  _  ||  _  ||     <|  ||     ||  _  |
 *	|______/__||_____||_____||__|\__|__||__|__||___  |
 *                                             |_____|
 **/
defined( '_JEXEC' ) or die( 'Restricted access' );
jimport( 'joomla.application.component.view' );

class BlookingViewBlooking_multiroom extends JView {

	function multiResults($tpl = null) {

		$posted_data = JRequest::get('');
		$model =& $this->getModel( 'multisearch' );

		$results = $model->searchMultiResults ($posted_data);
		$data = array();
		$data['output'] = $results->output;
		$data['code'] = $results->code;
		$data['remaining_rooms'] = $results->remaining_rooms;
		$data['summary'] = $results->summary;
		$data['restrictions'] = $results->restrictions;
		$data['calendar'] = $results->calendar;
		$data['new_date'] =  $results->new_date;
		$data['idcategories'] = $results->idcategories;
		$data['year_calendar'] = $results->year_calendar;


		$document =& JFactory::getDocument();
		$document->setMimeEncoding( 'application/json' );

		echo json_encode( $data );


	}

	function updateResults($tpl = null) {

		$posted_data = JRequest::get('');
		$model =& $this->getModel( 'multisearch' );
			
		$res = $model->updateResults ($posted_data);
		$data = array();
		$data['new_category_price']=$res->new_category_price;
		$data['new_category_price_before']=$res->new_category_price_before;
		$data['price_extra_text']=$res->price_extra_text;
		$data['price_id']=$res->price_id;
		$data['summary'] = $res->summary;
		//$data['new_options'] = $res->new_options;
		//$data['id_to_update'] =	$res->id_to_update;
		$data['idcategory']=$res->idcategory;
		$data['daily_rates']=$res->daily_rates;
		$document =& JFactory::getDocument();
		$document->setMimeEncoding( 'application/json' );

		echo json_encode( $data );


	}

	function updateGuests($tpl = null) {

		$posted_data = JRequest::get('');
		$model =& $this->getModel( 'multisearch' );
			
		$res = $model->updateGuests ($posted_data);
		$data = array();
		$data['new_options'] = $res->new_options;
		$data['id_to_update'] =	$res->id_to_update;
		$data['old_value'] =	$res->old_value;
		$document =& JFactory::getDocument();
		$document->setMimeEncoding( 'application/json' );

		echo json_encode( $data );


	}

	function setsession($tpl = null)
	{
		$posted_data = JRequest::get('');
		$model =& $this->getModel( 'multisearch' );
		$res = $model->setsession ($posted_data);
		$data = array();
		$document =& JFactory::getDocument();
		$document->setMimeEncoding( 'application/json' );
		echo json_encode( $data );
	}

	function calendar($tpl = null) {
		$posted_data = JRequest::get('');
		$model =& $this->getModel( 'blooking' );
		$result = $model->getMultiRoomCalendar ($posted_data, "1");

		$data = array();
		$data['calendar'] =  $result->calendar;
		$data['new_date'] =  $result->new_date;

		$document =& JFactory::getDocument();
		// Set the MIME type for JSON output.
		$document->setMimeEncoding( 'application/json' );

		echo json_encode( $data );
	}
	function oncategorychange()
	{
		$posted_data = JRequest::get('');
		$model =& $this->getModel( 'blooking' );

		$data = array();
		$result = $model->oncategorychange ($posted_data['idcategory']);
		$data['adults'] =  $result->adults;
		$data['children'] =  $result->children;


		$document =& JFactory::getDocument();
		// Set the MIME type for JSON output.
		$document->setMimeEncoding( 'application/json' );

		echo json_encode( $data );
	}
	function _getDateFormat ()
	{
		JLoader::register('BlookingHelper',
		JPATH_COMPONENT_ADMINISTRATOR.'/helpers/BlookingHelper.php');
		$params = BlookingHelper::getParams();
		$dateformatcode = $params->dateformat;
		if ($dateformatcode==""||$dateformatcode==3)
			$d1='d-m-Y';
		else if ($dateformatcode==1)
			$d1='Y-m-d';
		else if ($dateformatcode==2)
			$d1='m/d/Y';
		return $d1;
	}
	function _noToDayName ($no)
	{
		$res = "";
		switch ($no)
		{
			case '0':
				$res = JText::_('SUNDAY');
				break;
			case '1':
				$res = JText::_('MONDAY');
				break;
			case '2':
				$res = JText::_('TUESDAY');
				break;
			case '3':
				$res = JText::_('WEDNESDAY');
				break;
			case '4':
				$res = JText::_('THURSDAY');
				break;
			case '5':
				$res = JText::_('FRIDAY');
				break;
			case '6':
				$res = JText::_('SATURDAY');
				break;
			default:
				$res = '';
				break;
		}
		return $res;
	}
}