<?php
/**
 * BlooKing - The King in Joomla Booking
 * @version 1.0
 * @author BlooKing.org. Based on BooKiTGold code by Costas Kakousis
 * @copyright (C) 2012-2013 by BlooKing.org (http://www.blooking.org)
 * @license GNU/GPL: http://www.gnu.org/copyleft/gpl.html
 *
 * If you fork this to create your own project, please make a reference to
 * BlooKing! someplace in your code and provide a link to
 * http://www.blooking.org
 *
 * This file is part of BlooKing! BlooKing is free software: you can
 * redistribute it and/or modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * BlooKing is distributed in the hope that it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details. You should have received a copy of the GNU General Public License
 * along with BlooKing.  If not, see <http://www.gnu.org/licenses/>.
 *   ______ __                __  __ __
 *	|   __ \  |.-----..-----.|  |/  |__|.-----..-----.
 *	|   __ <  ||  _  ||  _  ||     <|  ||     ||  _  |
 *	|______/__||_____||_____||__|\__|__||__|__||___  |
 *                                             |_____|
 **/

defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.application.component.view');

class BlookingViewBookingform extends JView
{
	function display($tpl = null)
	{
		$view = new stdClass;
		$idcategory = JRequest::getVar('idcategory');
		$valid_from = JRequest::getVar('valid_from');
		$valid_to = JRequest::getVar('valid_to');
		$nguests = JRequest::getVar('nguests');
		$nchilds = JRequest::getVar('nchilds');
		$price = JRequest::getVar('price');
		$item = JRequest::getVar('Itemid');
		$this->assignRef('menuid', $item);

		$data = JRequest::get('post');

		$lang=$this->_getLang();
		//Get category name from model
		$model =& $this->getModel();
		$view->category_name = $model->getCategoryName($idcategory, $lang);


		//set parmas
		$view = $this->_setParams($view);

		$view->idcategory= $idcategory;
		$view->valid_from= $valid_from;
		$view->valid_to= $valid_to;
		$view->nguests= $nguests;
		$view->nchilds= $nchilds;
		$view->price= $price;
		$view->idrules= $data['idrules'];
		$view->cnt = $data['cnt'];
		$model =& $this->getModel();
		$view->nights = $model->getNights($valid_from, $valid_to);
		$view->preferences_text = $model->getPreferencesText($idcategory,
				$lang);


		if ($lang=='en')
			$view->terms_conditions = $model->getUtil ('terms_conditions');
		else
			$view->terms_conditions = $model->getUtil ('terms_conditions_'.$lang);
		if($lang=='en')
			$view->cancellation_policy = $model->getUtil ('cancellation_policy');
		else
			$view->cancellation_policy = $model->getUtil ('cancellation_policy_'.$lang);


		$deposit=0.0;
		$mode=1;
		if ($view->deposit_fixed>0)
		{
			$deposit = $view->deposit_fixed;
		}
		else if ($view->deposit_percent>0)
		{

			$deposit = $view->deposit_percent;
			$mode=0;
		}

		if ($view->late_booking > 0 && $model->isLateBooking($valid_from, $view->late_booking))
		{
			$deposit = 100;
			$view->deposit_percent = 100;
				
			$mode=0;
		}

		$res = $model->getRoomExtrasTextSingleMode ($price,
				$idcategory, $view->nights, $nguests, $nchilds, $view->currency,
				$deposit, $mode, $this->_getLang());
		$view->extra_text = $res->text;
		$view->total_price = $res->total_price;
		$view->deposit = $deposit;
		$view->deposit_mode = $mode;



		if ($view->terms_conditions!="" && $view->cancellation_policy!="")
		{
			$accept_txt = JText::_("COM_BOOKIT_I_AGREE_TO_THE_FOLLOWING_TERMS_CONDITIONS_CANCELLATION_POLICY");
			$accept_error_txt = JText::_('COM_BOOKIT_PLEASE_INDICATE_THAT_YOU_AGREE_TO_THE_TERMS_CONDITIONS_AND_CANCELLATION_POLICY');
		}
		else if ($view->terms_conditions=="" && $view->cancellation_policy!="")
		{
			$accept_txt = JText::_("COM_BOOKIT_I_AGREE_TO_THE_FOLLOWING_CANCELLATION_POLICY");
			$accept_error_txt = JText::_('COM_BOOKIT_PLEASE_INDICATE_THAT_YOU_AGREE_TO_THE_CANCELLATION_POLICY');
		}
		else if ($view->terms_conditions!="" && $view->cancellation_policy=="")
		{
			$accept_txt = JText::_("COM_BOOKIT_I_AGREE_TO_THE_FOLLOWING_TERMS_CONDITIONS");
			$accept_error_txt =
			JText::_('COM_BOOKIT_PLEASE_INDICATE_THAT_YOU_AGREE_TO_THE_TERMS_CONDITIONS');
		}
		else
		{
			$accept_txt="";
			$accept_error_txt="";
		}
		$view->accept_txt = $accept_txt;
		$view->accept_error_txt = $accept_error_txt;



		//set the stylesheet
		JLoader::register('BlookingHelper', JPATH_COMPONENT_ADMINISTRATOR.'/helpers/BlookingHelper.php');
		$params= BlookingHelper::getParams();

		if ($params->new_template == 1) {
			$stylesheet = 'booking_form.css';
			$path = 'components/com_blooking/css/thereef/';
			$tpl = 'thereef';
		} else {
			$stylesheet = 'booking_form.css';
			$path = 'components/com_blooking/css/';
		}
		JHTML::stylesheet($stylesheet, $path);

		//Add JS code
		$document = &JFactory::getDocument();
		$document->addScript( JURI::root(true).
				'/components/com_blooking/js/bookingform.js' );

		$document->addScript( JURI::root(true).
				'/components/com_blooking/js/json2.js' );

		$document->addScript( JURI::root(true).
				'/components/com_blooking/js/json-minified.js' );

		$this->assignRef( 'view', $view );
		parent::display($tpl);
	}



	function _setParams ($view)
	{
		JLoader::register('BlookingHelper',
		JPATH_COMPONENT_ADMINISTRATOR.'/helpers/BlookingHelper.php');

		$params= BlookingHelper::getParams();
		$view->currency = $params->currency;
		$view->show_coupons = $params->show_coupons;
		$view->dateformat = $params->dateformat;
		$view->deposit_fixed = floatval ($params->deposit_fixed);
		$view->deposit_percent = floatval ($params->deposit_percent);
		$view->late_booking = intval ($params->late_booking);
		$view->show_bar = $params->show_bar;

		return $view;
	}

	function _getLang()
	{
		$lg = JFactory::getLanguage();
		if(version_compare(JVERSION,'1.6.0','ge'))
		{
			$lang_code = explode('-',$lg->getTag());
			$lang = $lang_code[0];
		}
		else
		{
			$lang_code = explode('-',$lg->_lang);
			$lang = $lang_code[0];
		}
		return $lang;
	}

}
