<?php
/**
 * BlooKing - The King in Joomla Booking
 * @version 1.0
 * @author BlooKing.org. Based on BooKiTGold code by Costas Kakousis
 * @copyright (C) 2012-2013 by BlooKing.org (http://www.blooking.org)
 * @license GNU/GPL: http://www.gnu.org/copyleft/gpl.html
 *
 * If you fork this to create your own project, please make a reference to
 * BlooKing! someplace in your code and provide a link to
 * http://www.blooking.org
 *
 * This file is part of BlooKing! BlooKing is free software: you can
 * redistribute it and/or modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * BlooKing is distributed in the hope that it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details. You should have received a copy of the GNU General Public License
 * along with BlooKing.  If not, see <http://www.gnu.org/licenses/>.
 *   ______ __                __  __ __
 *	|   __ \  |.-----..-----.|  |/  |__|.-----..-----.
 *	|   __ <  ||  _  ||  _  ||     <|  ||     ||  _  |
 *	|______/__||_____||_____||__|\__|__||__|__||___  |
 *                                             |_____|
 **/
defined('_JEXEC') or die('Restricted access');
JHTML::_( 'behavior.mootools' );
JHTML::_('behavior.modal');

//---------------------SET VARIABLES START--------------------------------------
$show_coupons = $this->view->show_coupons;
$deposit_fixed = floatval ($this->view->deposit_fixed);
$deposit_percent = floatval ($this->view->deposit_percent);
$deposit_mode = floatval ($this->view->deposit_mode);
$deposit = floatval ($this->view->deposit);
$nights = $this->view->room[0]['nights'];
$nights >1 ? $night=JText::_("COM_BOOKIT_NIGHTS"):
$night=JText::_("COM_BOOKIT_NIGHT");
$nguests= $this->view->room[0]['nguests'];
$nchilds= $this->view->room[0]['nchilds'];
$currency= $this->view->currency;
$valid_from = $this->view->valid_from;
$valid_to = $this->view->valid_to;
$price= $this->view->price;
$terms_conditions = json_encode($this->view->terms_conditions);
$cancellation_policy = json_encode($this->view->cancellation_policy);
$idcategories = $this->view->idcategories;
$extra_text = $this->view->extra_text;

$preferences_text = $this->view->preferences_text;

$invalid_coupon_msg=JText::_("COM_BOOKIT_INVALID_CODE");
$valid_coupon_msg=JText::_("COM_BOOKIT_VALID_CODE");
$you_save=JText::_('COM_BOOKIT_YOU_SAVE');

$room_types = $this->view->room[0]['room_types'];


//---------------------SET VARIABLES END----------------------------------------


$ajax = <<<EOD
window.addEvent('domready',function() {

window.tc = {$terms_conditions};
window.cp = {$cancellation_policy};

var Browser = {
  Version: function() {
    var rv = 999;
    if (navigator.appName == 'Microsoft Internet Explorer')
   {
      var ua = navigator.userAgent;
      var re  = new RegExp("MSIE ([0-9]{1,}[\.0-9]{0,})");
      if (re.exec(ua) != null)
         rv = parseFloat( RegExp.$1 );
   }
   return rv;
  }
}

if (Browser.Version() <= 7) {
JSON.decode = function(string, secure){
  	  return jsonParse(string);
	};
}

if ({$show_coupons}=='0')
document.id('bookit_booking_details').addClass('maximized_details');
	var req = new Request.JSON({
		method: 'get',
		url: '',
		data: {},
		onRequest: function() {
			document.id('bookit_search_loading').addClass ('ajax_loading');
			document.id('bookit_booking_code_msg').removeClass('bookit_invalid_code');
			document.id('bookit_booking_code_msg').removeClass('bookit_valid_code');
			document.id('bookit_booking_code_msg').set('html','');
			document.id('bookit_coupon_discount').set('html','');
			},
		onFailure: function(xhr) {;},
		onSuccess: function(r) {
			document.id('bookit_search_loading').removeClass ('ajax_loading');
			if (typeof(r)!=undefined && r!=null)
			{

				if (r.code <= 0)
				{
					document.id('bookit_booking_code_msg').addClass('bookit_invalid_code');
					document.id('bookit_booking_code_msg').set('html',"{$invalid_coupon_msg}");
					document.id('bookit_coupon_discount').set('html','');
				}
				else
				{
					document.id('bookit_booking_code_msg').addClass('bookit_valid_code');
					document.id('bookit_booking_code_msg').set('html',"{$valid_coupon_msg}");
					document.id('bookit_coupon_discount').set('html',"{$you_save}"+" "+r.discount+" "+"{$currency}"+"!");
					applyCoupon (r.discount, '{$currency}', '{$deposit}', '{$deposit_mode}');
					document.id('coupon_button').disabled=true;
					document.id('idcoupon').value=r.code;
					document.id('coupon_discount').value=r.discount;
			
				}
			}
		},
		onError: function(response) {
			alert('error');
		}
	});
	if (document.id('coupon_button')!=null)
	{
		document.id('coupon_button').addEvent('click',function(event){
		event.stop();
		req.get({'option':'com_blooking', 'controller':'bookingform',
			'task':'couponvalidation', 'format':'json', 'view':'bookingform',
			'idcategory':'{$this->view->room[0]['idcategories']}',
			'coupon_code':document.id('coupon_code').value,
			'valid_from':'{$this->view->valid_from}',
			'valid_to':'{$this->view->valid_to}',
			'price':'{$price}',
			'nguests':'{$nguests}',
			'nchilds':'{$nchilds}','tmpl':'component',
			'nights':'{$nights}' });
		});
	}

	var myVerticalSlide = new Fx.Slide('options_toggle_div');
	document.id('toggle_search_panel').addEvent('click', function(event){
   		event.stop();
    	myVerticalSlide.toggle();
    	if (document.id('search_toggle_label_show').style.display=='')
    	{
	    	document.id('search_toggle_label_show').style.display='none';
	    	document.id('search_toggle_label_hide').style.display='';
    	}
    	else
    	{
    		document.id('search_toggle_label_show').style.display='';
	    	document.id('search_toggle_label_hide').style.display='none';
    	}
 	});

 	var categories = '{$idcategories}'.split(",");

 	for (var i=0; i<categories.length; i++)
 	{
		new Fx.Accordion($$('.extra_room_heading.'+categories[i]+'_e'),
		'.bookit_accordion_'+categories[i]+'_e',
		{
        	onActive: function(toggler) { toggler.addClass('arrow_down'); toggler.removeClass('arrow_right');},
        	onBackground: function(toggler) { toggler.addClass('arrow_right'); toggler.removeClass('arrow_down'); }
    	}
    	);
 	}
});
EOD;

$doc = & JFactory::getDocument();
$doc->addScriptDeclaration( $ajax );
?>

<?php if ($this->view->show_bar==1) {?>
<!-- Progress Bar -->
<ol id="progress">
	<li class="first-step"><span><?php echo JText::_("COM_BOOKIT_BOOKING_DETAILS");?>
	</span> <?php echo JText::_("COM_BOOKIT_DATES_GUESTS_ROOM_TYPE");?>
	</li>
	<li class="second-step current"><span><?php echo JText::_("COM_BOOKIT_REVIEW_BOOKING");?>
	</span> <?php echo JText::_("COM_BOOKIT_EXTRAS_REQUESTS");?>
	</li>
	<li class="payment-step"><span><?php echo JText::_("COM_BOOKIT_PAYMENT");?>
	</span> <?php echo JText::_("COM_BOOKIT_PP_BANK_TRANSFER");?>
	</li>
</ol>
<div class="bookit_search_clear"></div>

<?php }?>
<form action="<?php echo JRoute::_( 'index.php' );?>" name="bookingForm"
	method="post" accept-charset="UTF-8">

	<div id="booking_wrapper"
		class="blooking_panel2 inner_description_gradient">

		<div id="bookit_booking_details" class='bottom_line'>
			<div class='block2 head bottom_line'>
				<?php echo JText::_('COM_BOOKIT_YOUR_BOOKING');?>
			</div>



			<div class="bookit_booking_wrapper">
				<div class="bookit_booking_left_td">
					<?php echo JText::_("COM_BOOKIT_CHECK_IN");?>
				</div>
				<div class="bookit_booking_right_td">
					<span> <?php echo $valid_from;?>
					</span>
				</div>
			</div>

			<div class="bookit_booking_wrapper bottom_line">
				<div class="bookit_booking_left_td">
					<?php echo JText::_("COM_BOOKIT_CHECK_OUT");?>
				</div>
				<div class="bookit_booking_right_td">
					<span> <?php echo $valid_to;?>
					</span>
				</div>
			</div>

			<div class="bookit_booking_wrapper bottom_line">
				<div class="bookit_booking_left_td">
					<?php echo $night;?>
				</div>
				<div class="bookit_booking_right_td">
					<span> <?php echo $nights;?>
					</span>
				</div>
			</div>

			<!-- echo the rooms -->
			<?php 
			$cnt = 1;
			$end = count($this->view->category_name_to_rooms_qnt);
			foreach ($this->view->category_name_to_rooms_qnt as $categ=>$no) {

if ($cnt++>=$end) {?>
			<div class="bookit_booking_wrapper bottom_line">
				<?php } else {?>
				<div class="bookit_booking_wrapper">
					<?php }?>
					<div class="bookit_booking_left_td">
						<?php echo $categ;?>
					</div>
					<div class="bookit_booking_right_td">
						<span> <?php echo $no; ?>
						</span>
					</div>
				</div>

				<input type="hidden" name="cat_qnt[<?php echo $categ;?>]"
					value="<?php echo $no;?>" />

				<?php } ?>

				<div class="bookit_booking_wrapper">
					<div class="bookit_booking_left_td">
						<?php echo JText::_("COM_BOOKIT_TOTAL_ROOMS");?>
					</div>
					<div class="bookit_booking_right_td">
						<span><?php echo $this->view->room[0]['rooms'];?> </span>
					</div>
				</div>


				<?php if ($nguests>0){?>
				<div class="bookit_booking_wrapper">
					<div class="bookit_booking_left_td">
						<?php echo JText::_("COM_BOOKIT_ADULTS");?>
					</div>
					<div class="bookit_booking_right_td">
						<span><?php echo $nguests;?> </span>
					</div>
				</div>

				<?php }?>
				<?php if ($nchilds>0){?>
				<div class="bookit_booking_wrapper">
					<div class="bookit_booking_left_td">
						<?php echo JText::_("COM_BOOKIT_CHILDREN");?>
					</div>
					<div class="bookit_booking_right_td">
						<span> <?php echo $nchilds;?>
						</span>
					</div>
				</div>

				<?php }?>

			</div>

			<?php if ($extra_text!="" || $preferences_text!="") {?>

			<div id="bookit_booking_options" class=''>
				<div class='block2 head'>
					<a id='toggle_search_panel' href='#'> <span
						id='search_toggle_label_hide' class='toggle_label_up'> <?php echo JText::_("COM_BOOKIT_OPTIONS") ?>
					</span> <span id='search_toggle_label_show'
						class='toggle_label_down' style="display: none"> <?php echo JText::_("COM_BOOKIT_OPTIONS") ?>
					</span>
					</a>
				</div>
				<div id='options_toggle_div'>
					<?php echo $extra_text; 
 echo $preferences_text;?>
				</div>

				<?php if ($show_coupons==1){?>

				<div id="bookit_booking_coupon" class='bottom_line'>
					<div class='block2 head '>
						<?php echo JText::_('COM_BOOKIT_PROMOTIONAL_CODE');?>
					</div>

					<div id='bookit_coupon_div'>
						<div class='promo_code_line'>
							<input type="text" name="code" id="coupon_code" />
							<button class="button" id="coupon_button">
								<?php echo JText::_("COM_BOOKIT_APPLY"); ?>
							</button>
						</div>
						<div id='bookit_search_loading'></div>
						<div class="bookit_booking_clear"></div>

						<span class='bookit_coupon_desc'> <?php echo JText::_('COM_BOOKIT_COUPON_INSTRUCTIONS');?>
						</span>

					</div>


					<div class="bookit_booking_clear"></div>
					<div id='bookit_booking_code_msg'></div>
					<div id='bookit_coupon_discount'></div>
					<div class="bookit_booking_clear"></div>
				</div>
				<?php }?>


				<div class="bookit_booking_clear"></div>
				<div class="bookit_booking_review_left"></div>


				<div id="bookit_booking_price" class='bottom_line'>
					<div class='bookit_booking_final_price'>
						<span id='total_label'> <?php echo JText::_('COM_BOOKIT_TOTAL_PRICE');?>
						</span>
						<div id="bookit_booking_total" class='total_value'>
							<?php echo number_format ( $price, 2, '.', '')." ".$currency;?>

						</div>

					</div>
					<div class="bookit_booking_clear"></div>

					<?php if ($deposit_percent>0 || $deposit_fixed>0) {?>
					<div class="bookit_booking_clear"></div>
					<div class='bookit_booking_final_price line'>
						<span id='total_label'> <?php echo JText::_('COM_BOOKIT_DEPOSIT');?>
						</span>
						<div id="bookit_booking_deposit" class='total_value'>
							<?php 
							if ($deposit_percent>0)
								echo number_format ( $price*$deposit_percent/100, 2, '.', '')." ".
								$currency;
							else if ($deposit_fixed>0)
								echo number_format ( $deposit_fixed, 2, '.', '')." ".$currency;
							?>
						</div>
					</div>
					<div class="bookit_booking_clear"></div>
					<?php }?>
				</div>

				<div class="bookit_booking_clear"></div>


				<div id="bookit_booking_continue">
					<?php if ($this->view->accept_txt!=""){ ?>
					<div id="bookit_booking_accept">
						<input type='checkbox' id='accept_checkbox'>

						<?php echo "<a href='#bookit_booking_accept' onclick='showBox(1)' class='modal'>".
	$this->view->accept_txt."</a>" ?>
					</div>

					<div class="bookit_booking_clear"></div>
					<div id="accept_error" style="display: none">
						<?php echo $this->view->accept_error_txt;?>
					</div>
					<div class="bookit_booking_clear"></div>
					<?php } ?>
					<div id="bookit_booking_accept_button" class=''>
						<button type="button" name="continue_button" class='bookit_button'
							id="continue_button" onclick="checkTerms(1)">
							<?php echo JText::_("COM_BOOKIT_CONTINUE")?>
						</button>
					</div>
				</div>

			</div>
			<?php }?>
		</div>

		<!-- AC 1.5.7.4 SEF Shorter URLS -->
		<input type="hidden" name="option" value="com_blooking" /> <input
			type="hidden" name="controller" value="finalform" /> <input
			type="hidden" name="task" value="finaldefault" /> <input
			type="hidden" name="itemid" value="<?php echo $this->menuid ?>" />
		<!-- SEF ENDS -->

		<input type="hidden" name="layout" value="finalform" /> <input
			type="hidden" name="valid_from" id="valid_from"
			value="<?php echo $valid_from;?>" /> <input type="hidden"
			name="valid_to" id="valid_to" value="<?php echo $valid_to;?>" /> <input
			type="hidden" name="nguests" id="nguests"
			value="<?php echo $nguests;?>" /> <input type="hidden" name="nchilds"
			id="nchilds" value="<?php echo $nchilds;?>" /> <input type="hidden"
			name="idcoupon" id="idcoupon" value="0" /> <input type="hidden"
			name="coupon_discount" id="coupon_discount" value="0" /> <input
			type="hidden" name="coupon_code_valid" id="coupon_code_valid" /> <input
			type="hidden" name="price" id="price" /> <input type="hidden"
			name="deposit" id="deposit" /> <input type="hidden" name="extra_ids"
			id="extra_ids" /> <input type="hidden" name="cnt" id="cnt"
			value="<?php echo $this->view->cnt;?>" /> <input type="hidden"
			name="multiroom" id="multiroom" value="0" />

</form>
