<?php
/**
 * BlooKing - The King in Joomla Booking
 * @version 1.0
 * @author BlooKing.org. Based on BooKiTGold code by Costas Kakousis
 * @copyright (C) 2012-2013 by BlooKing.org (http://www.blooking.org)
 * @license GNU/GPL: http://www.gnu.org/copyleft/gpl.html
 *
 * If you fork this to create your own project, please make a reference to
 * BlooKing! someplace in your code and provide a link to
 * http://www.blooking.org
 *
 * This file is part of BlooKing! BlooKing is free software: you can
 * redistribute it and/or modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * BlooKing is distributed in the hope that it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details. You should have received a copy of the GNU General Public License
 * along with BlooKing.  If not, see <http://www.gnu.org/licenses/>.
 *   ______ __                __  __ __
 *	|   __ \  |.-----..-----.|  |/  |__|.-----..-----.
 *	|   __ <  ||  _  ||  _  ||     <|  ||     ||  _  |
 *	|______/__||_____||_____||__|\__|__||__|__||___  |
 *                                             |_____|
 **/
// no direct access

defined( '_JEXEC' ) or die( 'Restricted access' );
jimport( 'joomla.application.component.view');

class BlookingViewBookingform_multiroom extends JView
{
	function display($tpl = null)
	{
		$view = new stdClass;
		$valid_from = JRequest::getVar('valid_from');
		$valid_to = JRequest::getVar('valid_to');
		$item = JRequest::getVar('Itemid');
		$this->assignRef('menuid', $item);

		//Get category name from model
		$model =& $this->getModel();
		$lang=$this->_getLang();

		//set parmas
		$view = $this->_setParams($view);

		$view->room = JRequest::getVar('room');


		$view->idcategories= $view->room[0]['idcategories'];
		$view->valid_from= $valid_from;
		$view->valid_to= $valid_to;
		$view->nguests= $view->room[0]['nguests'];
		$view->nchilds= $view->room[0]['nchilds'];
		$view->price= $view->room[0]['price'];
		$view->idrules= $view->room[0]['idrules'];
		$view->cnt = JRequest::getVar('cnt', 0);
		$view->room[0]['room_types'] =
		$model->getCategoryNames($view->room[0]['idcategories'], $lang);
		$nights = $view->room[0]['nights'];

		//EXTRAS AND PREFERENCES
		$deposit=0.0;
		$mode=1;
		if ($view->deposit_fixed>0)
		{
			$deposit = $view->deposit_fixed;
		}
		else if ($view->deposit_percent>0)
		{

			$deposit = $view->deposit_percent;
			$mode=0;
		}
		if ($view->late_booking > 0 && $model->isLateBooking($valid_from, $view->late_booking))
		{
			$deposit = 100;
			$view->deposit_percent = 100;
			$mode=0;
		}
		$view->deposit = $deposit;
		$view->deposit_mode = $mode;
		$rooms_per_category = array();

		$idcategories = explode(",",$view->room[0]['idcategories']);

		for ($i=1; $i<=$view->room[0]['rooms']; $i++)
		{
			if (!isset($rooms_per_category[$view->room[$i]['idcategory']]))
				$rooms_per_category[$view->room[$i]['idcategory']]=$i;
			else
				$rooms_per_category[$view->room[$i]['idcategory']] .= ",".$i;
		}

		$view->extra_text = "<div id='extras_and_prefs'>";
		$view->preferences_text = "";
		$category_to_rooms_qnt = array();
		foreach ($rooms_per_category as $idcategory=>$rooms)
		{
			//Room category to room number
				
			$categ_name = $model->getCategoryName($idcategory, $lang);

				
			$rooms_array = explode(",",$rooms);
			$category_to_rooms_qnt [$categ_name] = count($rooms_array);
				
			$view->extra_text .= "<div id='extra_for_category_".$idcategory."'
					class='extra_category_wrapper'>";
			$view->extra_text .= "<div class='extra_options_heading'>".
					$categ_name." ".
					JText::_('COM_BOOKIT_ROOMS')."</div>";
				
			$cnt=0;
			foreach ($rooms_array as $i)
			{
				$view->extra_text .= "<div id='extra_for_room_".$i."'
						class='extra_room_wrapper'>";

				$view->extra_text .= "<div class='extra_room_heading ".
						$idcategory."_e'>".JText::_('COM_BOOKIT_ROOM')." ".$i." (".
						$view->room[$i]['nguests']." ";
				if ($view->room[$i]['nguests']>1)
					$view->extra_text .=JText::_('COM_BOOKIT_ADULTS');
				else
					$view->extra_text .=JText::_('COM_BOOKIT_ADULT');
				if ($view->room[$i]['nchilds']>0)
				{
					if ($view->room[$i]['nchilds']>1)
						$child_str = JText::_('COM_BOOKIT_CHILDREN');
					else
						$child_str = JText::_('COM_BOOKIT_CHILD');

					$view->extra_text .=", ".$view->room[$i]['nchilds']." ".$child_str;
				}
				$view->extra_text .=")";
				$view->extra_text .="</div>";
				$view->extra_text .= "</div>";
					
				$idcategory = $view->room[$i]['idcategory'];
				$nguests =  $view->room[$i]['nguests'];
				$nchilds =  $view->room[$i]['nchilds'];

				$room_prefs = $model->getMultiPreferencesText($idcategory, $i,  $this->_getLang());
				$res = $model->getRoomExtrasTextMultiMode ($view->price, $idcategory,
						$nights, $nguests, $nchilds, $view->currency, $deposit,
						$mode, $i, $this->_getLang());

				$view->extra_text .= "<div class='bookit_accordion_".$idcategory."_e'>";
				$view->extra_text .= $res->text;
				$view->extra_text .= $room_prefs;
				$view->extra_text .= "</div>";

				$view->price += $res->total_price;

			}
			$view->extra_text .= "</div>"; //wrapper

		}
		$view->extra_text .= "</div>"; //extra_and_prefs
        $res2 = $model->getBookingExtrasTextMultiMode ($view->room[0]['price'], $nights, $view->currency, $deposit,
            $mode, $i, $this->_getLang());
        $view->price += $res2->total_price;
        $view->extra_text .= "<div>".$res2->text."</div>"; //wrapper


        $view->category_name_to_rooms_qnt= $category_to_rooms_qnt;



		if ($lang=='en' || $lang=='nb')
			$view->terms_conditions = $model->getUtil ('terms_conditions');
		else
			$view->terms_conditions = $model->getUtil ('terms_conditions_'.$lang);
		if($lang=='en')
			$view->cancellation_policy = $model->getUtil ('cancellation_policy');
		else
			$view->cancellation_policy = $model->getUtil ('cancellation_policy_'.$lang);


		if ($view->terms_conditions!="" && $view->cancellation_policy!="")
		{
			$accept_txt = JText::_("COM_BOOKIT_I_AGREE_TO_THE_FOLLOWING_TERMS_CONDITIONS_CANCELLATION_POLICY");
			$accept_error_txt = JText::_('COM_BOOKIT_PLEASE_INDICATE_THAT_YOU_AGREE_TO_THE_TERMS_CONDITIONS_AND_CANCELLATION_POLICY');
		}
		else if ($view->terms_conditions=="" && $view->cancellation_policy!="")
		{
			$accept_txt = JText::_("COM_BOOKIT_I_AGREE_TO_THE_FOLLOWING_CANCELLATION_POLICY");
			$accept_error_txt = JText::_('COM_BOOKIT_PLEASE_INDICATE_THAT_YOU_AGREE_TO_THE_CANCELLATION_POLICY');
		}
		else if ($view->terms_conditions!="" && $view->cancellation_policy=="")
		{
			$accept_txt = JText::_("COM_BOOKIT_I_AGREE_TO_THE_FOLLOWING_TERMS_CONDITIONS");
			$accept_error_txt =
			JText::_('COM_BOOKIT_PLEASE_INDICATE_THAT_YOU_AGREE_TO_THE_TERMS_CONDITIONS');
		}
		else
		{
			$accept_txt="";
			$accept_error_txt="";
		}
		$view->accept_txt = $accept_txt;
		$view->accept_error_txt = $accept_error_txt;

		//set the stylesheet
		JLoader::register('BlookingHelper', JPATH_COMPONENT_ADMINISTRATOR.'/helpers/BlookingHelper.php');
		$params= BlookingHelper::getParams();

		if ($params->new_template == 1) {
			$stylesheet = 'booking_form.css';
			$path = 'components/com_blooking/css/thereef/';
			$tpl = 'thereef';
		} else {
			$stylesheet = 'booking_form.css';
			$path = 'components/com_blooking/css/';
		}
		JHTML::stylesheet($stylesheet, $path);

		//Add JS code
		$document = &JFactory::getDocument();
		$document->addScript( JURI::root(true).
				'/components/com_blooking/js/bookingform.js' );

		$document->addScript( JURI::root(true).
				'/components/com_blooking/js/json2.js' );

		$document->addScript( JURI::root(true).
				'/components/com_blooking/js/json-minified.js' );

		$this->assignRef( 'view', $view );
		parent::display($tpl);
	}



	function _setParams ($view)
	{
		JLoader::register('BlookingHelper',
		JPATH_COMPONENT_ADMINISTRATOR.'/helpers/BlookingHelper.php');

		$params= BlookingHelper::getParams();
		$view->currency = $params->currency;
		$view->show_coupons = $params->show_coupons;
		$view->dateformat = $params->dateformat;
		$view->deposit_fixed = floatval ($params->deposit_fixed);
		$view->deposit_percent = floatval ($params->deposit_percent);
		$view->late_booking = intval($params->late_booking);
		$view->show_bar = $params->show_bar;

		return $view;
	}
	function _getLang()
	{
		$lg = JFactory::getLanguage();
		if(version_compare(JVERSION,'1.6.0','ge'))
		{
			$lang_code = explode('-',$lg->getTag());
			$lang = $lang_code[0];
		}
		else
		{
			$lang_code = explode('-',$lg->_lang);
			$lang = $lang_code[0];
		}
		return $lang;
	}



}
