<?php
/**
 * BlooKing - The King in Joomla Booking
 * @version 1.0
 * @author BlooKing.org. Based on BooKiTGold code by Costas Kakousis
 * @copyright (C) 2012-2013 by BlooKing.org (http://www.blooking.org)
 * @license GNU/GPL: http://www.gnu.org/copyleft/gpl.html
 *
 * If you fork this to create your own project, please make a reference to
 * BlooKing! someplace in your code and provide a link to
 * http://www.blooking.org
 *
 * This file is part of BlooKing! BlooKing is free software: you can
 * redistribute it and/or modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * BlooKing is distributed in the hope that it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details. You should have received a copy of the GNU General Public License
 * along with BlooKing.  If not, see <http://www.gnu.org/licenses/>.
 *   ______ __                __  __ __
 *	|   __ \  |.-----..-----.|  |/  |__|.-----..-----.
 *	|   __ <  ||  _  ||  _  ||     <|  ||     ||  _  |
 *	|______/__||_____||_____||__|\__|__||__|__||___  |
 *                                             |_____|
 **/

defined( '_JEXEC' ) or die( 'Restricted access' );
jimport( 'joomla.application.component.view');

class BlookingViewFinalform extends JView
{
	function display($tpl = null)
	{
		JLoader::register('BlookingHelper',
		JPATH_COMPONENT_ADMINISTRATOR.'/helpers/BlookingHelper.php');
		$params =  BlookingHelper::getParams();
		$model =& $this->getModel();

		$utils = $model->getUtils();
		if ($utils->show_captcha==1)
		{
			if ($utils->privatekey=="" || $utils->publickey=="")
			{
				JError::raiseNotice(100, JText::_('COM_BOOKIT_NO_KEYS'));
			}
		}
		$view = new stdClass;
		$data = JRequest::get( 'post' );
		$lists = array();


		//Set the stylesheet
		if ($params->new_template == 1) {
			$stylesheet = 'final_form.css';
			$path = 'components/com_blooking/css/thereef/';
			$tpl = 'thereef';
		} else {
			$stylesheet = 'final_form.css';
			$path = 'components/com_blooking/css/';
		}

		JHTML::stylesheet($stylesheet, $path);

		$document = &JFactory::getDocument();
		$document->addScript( JURI::root(true).
				'/components/com_blooking/js/finalform.js' );

		$document->addScript( JURI::root(true).
				'/components/com_blooking/js/json2.js' );

		$document->addScript( JURI::root(true).
				'/components/com_blooking/js/json-minified.js' );

		$view->utils = $utils;
		$view->lang = $this->_getLang();

		$view->currency = $params->currency;
		$view->show_bar = $params->show_bar;
		$view->admin_confirm = $params->admin_confirm;
		$view->paypal_mail = '';
		$view->payment_return = '';
		$view->payment_cancel = '';
		$view->mail_request = '';

		$pos = strpos($data['extra_ids'], "]");
		$data['extra_ids'] = substr($data['extra_ids'], 0, $pos)."]";

		$view->category_name= $model->getCategoryName($data['idcategory'], $view->lang);
		$view->idcategory= $data['idcategory'];
		$view->valid_from= $data['valid_from'];
		$view->valid_to= $data['valid_to'];
		$view->nguests= $data['nguests'];
		$view->nchilds= $data['nchilds'];
		$view->price= $data['price'];
		$view->deposit= $data['deposit'];
		$view->extra_ids= $data['extra_ids'];
		$view->idrules= $data['idrules'];
		$view->idcoupon= $data['idcoupon'];
		$view->payment_plugins= JRequest::getVar('payment_plugins');
		$view->coupon_discount= $data['coupon_discount'];
		$view->nights = $model->getNights($data['valid_from'], $data['valid_to']);


		$options = array();
		$plugins = explode(",",$view->payment_plugins);
		foreach ($plugins as $plg)
		{
			if ($plg=='blookingwire')
				array_push($options, JHTML::_('select.option',
						'Blookingwire', JText::_('COM_BOOKIT_WIRE')));
			else if ($plg=='blookingpaypal')
				array_push($options, JHTML::_('select.option',
						'Blookingpaypal', "<!-- PayPal Logo -->
						<img  src='".JURI::root()."components/com_blooking/images/paypal.gif'
						border='0' alt='Paypal'>"));
			else if ($plg=='blookingasiapay')
			{
				array_push($options, JHTML::_('select.option',
				'Blookingasiapay',
				"<img src='".JURI::root()."components/com_blooking/images/asiapay.png'
						border='0' alt='AsiaPay'>"));
			}
			else if ($plg=='blookingcimb')
			{
				array_push($options, JHTML::_('select.option',
				'Blookingcimb',
				"<img src='".JURI::root()."components/com_blooking/images/cimb.png'
						border='0' alt='CIMB'> CIMB"));
			}
			else if ($plg=='blookingegipsy')
			{
				array_push($options, JHTML::_('select.option',
				'Blookingegipsy',
				"<img src='".JURI::root()."components/com_blooking/images/cc.gif'
						border='0' alt='E-Gipsy'>"));
			}
			else if ($plg=='blookingideal')
			{
				array_push($options, JHTML::_('select.option',
				'Blookingideal',
				"<img src='".JURI::root()."components/com_blooking/images/ideal.png'
						border='0' alt='iDeal'>"));
			}
			else if ($plg=='blookingsisow')
			{
				array_push($options, JHTML::_('select.option',
				'Blookingsisow',
				"<img src='".JURI::root()."components/com_blooking/images/ideal.png'
						border='0' alt='iDeal'>"));
			}
			else if ($plg=='blookingrobokassa')
			{
				array_push($options, JHTML::_('select.option',
				'Blookingrobokassa',
				"<img src='".JURI::root()."components/com_blooking/images/robokassa.jpg'
						border='0' alt='robokassa'>"));
			}
			else if ($plg=='blookingcash')
				array_push($options, JHTML::_('select.option',
						'Blookingcash', JText::_('COM_BOOKIT_CASH')));

		}
		$lists['payment'] = JHTML::_('select.radiolist', $options,
				'bookit_payment', 'class="inputbox"', 'value', 'text', '');


		$view->preferences= json_encode($data['preferences']);
		$view->user = $this->_getUserDetails ($data);

		$results[] = JHTML::_('select.option', 0,
				JText::_("COM_BOOKIT_SELECT_COUNTRY"), 'idcountry', 'name' );
		$results = array_merge( $results, $model->getCountries() );
		$lists['country']  = JHTML::_('select.genericList', $results, 'idcountry',
				'class="bookit_final_input" size="1"', 'idcountry', 'name',
				$view->user['idcountry']);
		$view->lists = $lists;

		$item = JRequest::getVar('Itemid');
		$this->assignRef('menuid', $item);
		$this->assignRef( 'view', $view );
		parent::display($tpl);
	}

	function _getUserDetails ()
	{
		//Get category name from model
		$model =& $this->getModel();
		$user =& JFactory::getUser();
		$jid = $user->id;
		return $model->getJUser($jid);
	}


	function _setExtraFields ($data, $model)
	{
		$res = new stdClass;
		$res->text="";
		$category_names_for_pp="";
		$idcategories_arr=array();

		if (isset($data['idcategories']))
			$idcategories = $data['idcategories'];
		else
			$idcategories="";

		if ($idcategories!="")
		{
			$res->text .= "<input type='hidden'
					name='idcategories' id='idcategories'
					value='".$idcategories."' />";
			$idcategories_arr = explode("-",$idcategories);

		}
		$booksigh=0;
		//Iterate room categories
		foreach($idcategories_arr as $i=>$t)
		{

			if (isset($data['booksight'.$t]))
				$booksigh=$data['booksight'.$t];
			else
				$booksigh="";

			if ($booksigh!= "")
			{
				$n = intval ($booksigh);
				$cat_name = $model->getCategoryName($t);
				$category_names_for_pp.=$n." ".$cat_name." ";

				$res->text .= "<input type='hidden'
						name='booksight".$t."' id='booksight".$t."'
								value='".$booksigh."' />";

				$res->text .= "<input type='hidden'
						name='price".$t."' id='price".$t."'
								value='".$data['price'.$t]."' />";

				$res->text .= "<input type='hidden'
						name='pricereg".$t."' id='pricereg".$t."'
								value='".$data['pricereg'.$t]."' />";

				$res->text .= "<input type='hidden'
						name='nchilds".$t."' id='nchilds".$t."'
								value='".$data['nchilds'.$t]."' />";

				$res->text .= "<input type='hidden'
						name='nguests".$t."' id='nguests".$t."'
								value='".$data['nguests'.$t]."' />";

				//Iterate rooms
				for($j=1; $j<$n+1;$j++)
				{
					$res->text .= "<input type='hidden'
							name='bookadults-".$t."-".$j."' id='bookadults-".$t."-".$j."'
									value='".$data['bookadults-'.$t.'-'.$j]."' />";

					$res->text .= "<input type='hidden'
							name='bookchilds-".$t."-".$j."' id='bookchilds-".$t."-".$j."'
									value='".$data['bookchilds-'.$t.'-'.$j]."' />";

					if (isset($data['preferences_'.$t.':'.$j]))
					{
						$res->text .= "<input type='hidden'
								name='preferences_".$t.":".$j."'
										id='preferences_".$t.":".$j."'
												value='".$data['preferences_'.$t.':'.$j]."' />";
					}
					else
					{
						$res->text .=
						"<input type='hidden' name='preferences_".$t.":".$j."'
								id='preferences_".$t.":".$j."'
										value='' />";
					}
				}
			}
		}
		$res->category_names_for_pp = $category_names_for_pp;
		return $res;
	}

	function _getLang()
	{
		$lg = JFactory::getLanguage();
		if(version_compare(JVERSION,'1.6.0','ge'))
		{
			$lang_code = explode('-',$lg->getTag());
			$lang = $lang_code[0];
		}
		else
		{
			$lang_code = explode('-',$lg->_lang);
			$lang = $lang_code[0];
		}
		return $lang;
	}


}
