<?php
/**
 * BlooKing - The King in Joomla Booking
 * @version 1.0
 * @author BlooKing.org. Based on BooKiTGold code by Costas Kakousis
 * @copyright (C) 2012-2013 by BlooKing.org (http://www.blooking.org)
 * @license GNU/GPL: http://www.gnu.org/copyleft/gpl.html
 *
 * If you fork this to create your own project, please make a reference to
 * BlooKing! someplace in your code and provide a link to
 * http://www.blooking.org
 *
 * This file is part of BlooKing! BlooKing is free software: you can
 * redistribute it and/or modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * BlooKing is distributed in the hope that it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details. You should have received a copy of the GNU General Public License
 * along with BlooKing.  If not, see <http://www.gnu.org/licenses/>.
 *   ______ __                __  __ __
 *	|   __ \  |.-----..-----.|  |/  |__|.-----..-----.
 *	|   __ <  ||  _  ||  _  ||     <|  ||     ||  _  |
 *	|______/__||_____||_____||__|\__|__||__|__||___  |
 *                                             |_____|
 **/
defined('_JEXEC') or die('Restricted access');
JHTML::_( 'behavior.mootools' );

$session = JFactory::getSession();
$this->view->rooms = $session->get('blooking_rooms');
$this->view->rooms_encoded = json_encode($this->view->rooms);
$nights = $this->view->rooms['room'][0]['nights'];
$rooms = $this->view->rooms['room'][0]['rooms'];

//---------------------SET VARIABLES START--------------------------------------
$country_list= $this->view->lists['country'];
if ($this->view->lang=='en') $code='form_msg';
else $code="form_msg_".$this->view->lang;

if (isset($this->view->utils->{$code}))
	$form_msg= $this->view->utils->{$code};
else
	$form_msg='';
$guest_name= $this->view->user['name'];
$surname= $this->view->user['surname'];
$email= $this->view->user['email'];
$phone= $this->view->user['phone'];
$addr1= $this->view->user['address1'];
$addr2= $this->view->user['address2'];
$addr3= $this->view->user['address3'];
$postcode= $this->view->user['postcode'];

$mail_request= $this->view->mail_request;
$paypal_mail= $this->view->paypal_mail;
$deposit= $this->view->deposit;
$currency= $this->view->currency;

$captcha_error_msg = JText::_('COM_BOOKIT_INVALID_CAPTCHA');
$captcha_valid_msg  = JText::_('COM_BOOKIT_VALID_CAPTCHA');
$payment_plugins = $this->view->payment_plugins;


$payment_error_msg = JText::_('COM_BOOKIT_YOUR_BOOKING_CANNOT_BE_PROCESSED_DUE_TO_A_PAYMENT_FAILURE');
$no_gateway_selected = JText::_('COM_BOOKIT_PLEASE_SELECT_A_PAYMENT_OPTION');

$bandk_err  = JText::_('COM_BOOKIT_PLEASE_SELECT_BANK');

$nights >1 ? $night=JText::_("COM_BOOKIT_NIGHTS"):
$night=JText::_("COM_BOOKIT_NIGHT");


//---------------------SET VARIABLES END----------------------------------------


$ajax = <<<EOD
window.addEvent('domready',function() {

var Browser = {
  Version: function() {
    var rv = 999;
    if (navigator.appName == 'Microsoft Internet Explorer')
   {
      var ua = navigator.userAgent;
      var re  = new RegExp("MSIE ([0-9]{1,}[\.0-9]{0,})");
      if (re.exec(ua) != null)
         rv = parseFloat( RegExp.$1 );
   }
   return rv;
  }
}


if (Browser.Version() <= 7) {
JSON.decode = function(string, secure){
  	  return jsonParse(string);
	};
}

	var req = new Request.JSON({
		method: 'post',
		url: 'index.php',
		data: {},
		onRequest: function() {
			document.id('payment_error').set('html','');
			document.id('payment_error').style.display='none';
		},
		onFailure: function(xhr) {;},

		onSuccess: function(r) {

			if (typeof(r)!=undefined && r!=null)
			{

				if ('{$this->view->utils->show_captcha}'=='1')
				{
					if (r.code <= 0)
					{
						document.id('payment_error').set('html',"<span id='invalid_captcha'>{$captcha_error_msg}</span>");
						document.id('payment_error').style.display='';
						return;
					}
					else
					{
						document.id('payment_error').set('html',"<span id='valid_captcha'>{$captcha_valid_msg}</span>");
						document.id('payment_error').style.display='';
					}
				}
				if (r.booking_res_code=='-1')
				{
					//no room availables anymore!
					document.id('bookit_warning').style.display='';
					document.id('send_button').disabled=true;
				}
				else
				{
					var gateway = getGateway();
		
					if (gateway=='Blookingpaypal')
					{
						document.id('bookingids').value = r.booking_res_code;
						document.id('paypalForm').submit();
						document.id('bookit_ajax_loader').style.display='';

					}
					else if (gateway=='Blookingasiapay')
					{
						document.id('bookingids').value = r.booking_res_code;
						document.id('payFormCcard').submit();
						document.id('bookit_ajax_loader').style.display='';
					}
					else if (gateway=='Blookingcimb')
					{
		
						document.id('bookingids').value = r.booking_res_code;
						document.id('cimbForm').submit();
						document.id('bookit_ajax_loader').style.display='';
					}
					else if (gateway=='Blookingrobokassa')
					{
						document.id('robokassaForm').submit();
						document.id('bookit_ajax_loader').style.display='';
					}
					else if (gateway=='Blookingegipsy')
					{
						document.id('payEGipsy').submit();
						document.id('bookit_ajax_loader').style.display='';
					}
					else if (gateway=='Blookingideal')
					{
						var bankObj = document.id('bank_id');
						var bankVal = bankObj.options[bankObj.selectedIndex].value;

						if (bankVal==''){
							alert('{$bandk_err}');
							return;
						}
						gatewayRedirectReq.post({'option':'com_blooking',
						'controller':'finalform', 'task':'gatewayRedirect',
						'format':'json', 'view':'finalform',
						'price':'{$this->view->price}','tmpl':'component',
						'amount':'{$this->view->deposit}',
						'lang':'{$this->view->lang}',
						'currency':'{$currency}', 'rooms':'{$this->view->rooms_number}',
						'bank_id':bankVal,
						'type':'Blookingideal'});

					}
					else if (gateway=='Blookingsisow')
					{
						document.id('paySisow').submit();
						document.id('bookit_ajax_loader').style.display='';
					}
					else if (gateway=='paypal_error' || gateway=='asiapay_error'
					|| gateway=='cimb_error' || gateway=='gatewayError')
					{
						document.id('payment_error').set('html',"{$payment_error_msg}");
						document.id('payment_error').style.display='';
						return;
					}
					else
					{
						document.id('finalform_bookingids').value = r.booking_res_code;
						document.id('finalForm').submit();
						document.id('bookit_ajax_loader').style.display='';

					}
				}
			}
		},
		onError: function(response) {
			alert('error');
		}
	});

	document.id('send_button').addEvent('click',function(e) {
		e.stop();
		var payment_method = checkGateways();
		if (payment_method == false)
		{
			document.id('payment_error').set('html',"{$no_gateway_selected}");
			document.id('payment_error').style.display='';
			return;
		}
		if (formValidation ('{$this->view->utils->surname_req}',
			'{$this->view->utils->address_req}',
			'{$this->view->utils->postcode_req}',
			'{$this->view->utils->phone_req}',
			'{$this->view->payment_plugins}'))
		{
			if (document.id('address1')!=null) address1_js = document.id('address1').value;
			else  address1_js = '';
			if (document.id('address2')!=null) address2_js = document.id('address2').value;
			else  address2_js = '';
			if (document.id('address3')!=null) address3_js = document.id('address3').value;
			else  address3_js = '';
			if (document.id('postcode')!=null) postcode_js = document.id('postcode').value;
			else  postcode_js = '';
			if (document.id('idcountry')!=null) idcountry_js = document.id('idcountry').value;
			else  idcountry_js = '0';
			if (document.id('phone')!=null) phone_js = document.id('phone').value;
			else  phone_js = '0';

			if ('{$this->view->utils->show_captcha}'=='1')
			{
			if (document.id('recaptcha_challenge_field')==null)
				{
				 alert("Please set your re-Captcha keys");
				 return;
				 }
				else
				{
				recaptcha_challenge_field_js = document.id('recaptcha_challenge_field').value;
				recaptcha_response_field_js = document.id('recaptcha_response_field').value;
				show_captcha_js = '1';
				}
			}
			else
			{
				recaptcha_challenge_field_js = '';
				recaptcha_response_field_js = '';
				show_captcha_js = '0';
			}

			req.post({'option':'com_blooking', 'controller':'finalform',
				'task':'makeBookings', 'format':'json', 'view':'finalform',
				'recaptcha_challenge_field':recaptcha_challenge_field_js,
				'recaptcha_response_field':recaptcha_response_field_js,
				'show_captcha':show_captcha_js,
				'payment_method':payment_method,
				'name':document.id('fname').value, 'surname':document.id('surname').value,
				'email':document.id('bookit_email').value,
				'address1':address1_js,'address2':address2_js,
				'address3':address3_js,'postcode':postcode_js,
				'idcountry':idcountry_js, 'phone':phone_js,
				'valid_from':'{$this->view->valid_from}',
				'valid_to':'{$this->view->valid_to}',
				'nguests':'{$this->view->nguests}',
				'nchilds':'{$this->view->nchilds}',
				'price':'{$this->view->price}','tmpl':'component',
				'deposit':'{$this->view->deposit}',
				'extra_ids':'{$this->view->extra_ids}',
				'idcoupon':'{$this->view->idcoupon}',
				'coupon_discount':'{$this->view->coupon_discount}',
				'jid':'{$this->view->user['jid']}',
				'lang':'{$this->view->lang}',
				'room':'{$this->view->rooms_encoded}'});
		}
	});

	var gatewayReq = new Request.JSON({
		method: 'post',
		url: 'index.php',
		data: {},
		onRequest: function() {
		document.id('bookit_payment_div').set('html','');
		if (document.id('bookit_warning').style.display=='none')
		document.id('send_button').disabled=false;
		},
		onFailure: function(xhr) {;},

		onSuccess: function(r) {
			if (typeof(r)!=undefined && r!=null)
			{
				if (r.type=='Blookingwire' || r.type=='Blookingideal' || r.type=='Blookingsisow')
				document.id('wire_transfer_div').set('html', r.msg);
				else
				{
					document.id('bookit_payment_div').set('html',r.msg);
					document.id('wire_transfer_div').set('html', '');
				}
				if (r.code <= 0)
					document.id('send_button').disabled=true;

			}
		},
		onError: function(response) {
			alert('error');
		}
	});

	if (typeof(document.getElementsByName("bookit_payment")[0])!='undefined')
	{
		if (document.id('address1')!=null) address1_js = document.id('address1').value;
			else  address1_js = '';
			if (document.id('address2')!=null) address2_js = document.id('address2').value;
			else  address2_js = '';
			if (document.id('address3')!=null) address3_js = document.id('address3').value;
			else  address3_js = '';
			if (document.id('postcode')!=null) postcode_js = document.id('postcode').value;
			else  postcode_js = '';
			if (document.id('idcountry')!=null) idcountry_js = document.id('idcountry').value;
			else  idcountry_js = '0';
			if (document.id('phone')!=null) phone_js = document.id('phone').value;
			else  phone_js = '0';

		var payment_options = document.getElementsByName("bookit_payment");
		for (var i=0; i<payment_options.length; i++)
		{

			el = document.id(payment_options[i].id);
			//el.addEvent('change',function(e) { //IE8 FIX
			el.addEvent('click',function(e) {
			gatewayReq.post({'option':'com_blooking', 'controller':'finalform',
				'task':'getPaymentPluginCode', 'format':'json', 'view':'finalform',
				'name':document.id('fname').value, 'surname':document.id('surname').value,
				'email':document.id('bookit_email').value,
				'address1':address1_js,'address2':address2_js,
				'address3':address3_js,'postcode':postcode_js,
				'idcountry':idcountry_js, 'phone':phone_js,
				'valid_from':'{$this->view->valid_from}',
				'valid_to':'{$this->view->valid_to}',
				'nguests':'{$this->view->nguests}',
				'nchilds':'{$this->view->nchilds}',
				'price':'{$this->view->price}','tmpl':'component',
				'deposit':'{$this->view->deposit}',
				'currency':'{$currency}','lang':'{$this->view->lang}',
				'rooms':'{$this->view->rooms_number}',
				'type':this.value});
			});
		}
	}

	var gatewayRedirectReq = new Request.JSON({
		method: 'post',
		url: 'index.php',
		data: {},
		onRequest: function() {
		document.id('bookit_ajax_loader').style.display='';
		},
		onFailure: function(xhr) {;},

		onSuccess: function(r) {
			document.id('bookit_ajax_loader').style.display='none';
			if (r[0].msg=='OK')
			location.href =r[0].url;
		},
		onError: function(response) {
			alert('error');
		}
	});

});
EOD;
$doc = & JFactory::getDocument();
$doc->addScriptDeclaration( $ajax );

?>

<script type="text/javascript">
var RecaptchaOptions = {
   theme : '<?php echo $this->view->utils->captcha_theme;?>'
};
</script>

<?php if ($this->view->show_bar==1) {?>
<!-- Progress Bar -->
<ol id="progress">
	<li class="first-step"><span><?php echo JText::_("COM_BOOKIT_BOOKING_DETAILS");?>
	</span> <?php echo JText::_("COM_BOOKIT_DATES_GUESTS_ROOM_TYPE");?>
	</li>
	<li class="second-step after"><span><?php echo JText::_("COM_BOOKIT_REVIEW_BOOKING");?>
	</span> <?php echo JText::_("COM_BOOKIT_EXTRAS_REQUESTS");?>
	</li>
	<li class="payment-step current"><span><?php echo JText::_("COM_BOOKIT_PAYMENT");?>
	</span> <?php echo JText::_("COM_BOOKIT_PP_BANK_TRANSFER");?>
	</li>
</ol>
<div class="bookit_search_clear"></div>

<?php }?>


<form action="<?php echo JRoute::_('index.php');?>" name="finalForm"
	id="finalForm" method="get">

	<div id="final_form_div_wrapper"
		class="blooking_panel2 inner_description_gradient">
		<?php 
		$star = "<span class='bookit_star'>*</span>";
		if ($form_msg!="")
		{
			echo "<div class='bookit_box msg'>";
			echo "<div id='form_msg'>".$form_msg;
			echo "</div>";
			echo "</div>";

		}

		?>


		<div id="final_form_overview" class="">
			<div id="bookit_booking_details" class='bottom_line'>
				<div class='block2 head bottom_line'>
					<?php echo JText::_('COM_BOOKIT_YOUR_BOOKING');?>
				</div>

				<div class="bookit_booking_wrapper">
					<div class="bookit_booking_left_td">
						<?php echo JText::_("COM_BOOKIT_CHECK_IN");?>
					</div>
					<div class="bookit_booking_right_td">
						<span> <?php echo $this->view->valid_from;?>
						</span>
					</div>
				</div>

				<div class="bookit_booking_wrapper bottom_line">
					<div class="bookit_booking_left_td">
						<?php echo JText::_("COM_BOOKIT_CHECK_OUT");?>
					</div>
					<div class="bookit_booking_right_td">
						<span> <?php echo $this->view->valid_to;?>
						</span>
					</div>
				</div>

				<div class="bookit_booking_wrapper bottom_line">
					<div class="bookit_booking_left_td">
						<?php echo $night;?>
					</div>
					<div class="bookit_booking_right_td">
						<span> <?php echo $nights;?>
						</span>
					</div>
				</div>

				<!-- echo the rooms -->
				<?php 
				$cnt = 1;
				$end = count($this->view->cat_qnt);
				foreach ($this->view->cat_qnt as $categ=>$no) {

if ($cnt++>=$end) {?>
				<div class="bookit_booking_wrapper bottom_line">
					<?php } else {?>
					<div class="bookit_booking_wrapper">
						<?php }?>
						<div class="bookit_booking_left_td">
							<?php echo $categ;?>
						</div>
						<div class="bookit_booking_right_td">
							<span> <?php echo $no; ?>
							</span>
						</div>
					</div>
					<?php } ?>

					<div class="bookit_booking_wrapper">
						<div class="bookit_booking_left_td">
							<?php echo JText::_("COM_BOOKIT_TOTAL_ROOMS");?>
						</div>
						<div class="bookit_booking_right_td">
							<span><?php echo $rooms;?> </span>
						</div>
					</div>


					<?php if ($this->view->nguests>0){?>
					<div class="bookit_booking_wrapper">
						<div class="bookit_booking_left_td">
							<?php echo JText::_("COM_BOOKIT_ADULTS");?>
						</div>
						<div class="bookit_booking_right_td">
							<span><?php echo $this->view->nguests;?> </span>
						</div>
					</div>

					<?php }?>
					<?php if ($this->view->nchilds>0){?>
					<div class="bookit_booking_wrapper">
						<div class="bookit_booking_left_td">
							<?php echo JText::_("COM_BOOKIT_CHILDREN");?>
						</div>
						<div class="bookit_booking_right_td">
							<span> <?php echo $this->view->nchilds;?>
							</span>
						</div>
					</div>

					<?php }?>

					<!-- PRICE -->

					<div class="bookit_booking_wrapper">
						<div class="bookit_booking_left_td">
							<?php echo JText::_("COM_BOOKIT_TOTAL_PRICE");?>
						</div>
						<div class="bookit_booking_right_td">
							<span> 
							
								<?php echo number_format($this->view->price,2, '.','')." ".$this->view->currency;?>
							</span>
						</div>
					</div>

					<?php 
					if ($this->view->deposit>0) {
?>
					<div class="bookit_booking_wrapper">
						<div class="bookit_booking_left_td">
							<?php echo JText::_("COM_BOOKIT_DEPOSIT");?>
						</div>
						<div class="bookit_booking_right_td">
							<span> <?php echo number_format($this->view->deposit,2, '.','')." ".$this->view->currency;?>
							</span>
						</div>
					</div>
					<?php }?>

				</div>
				<!-- booking_details -->
			</div>

			<div id="bookit_final_form" class="">
				<div class="block2 head bottom_line">
					<?php echo JText::_("COM_BOOKIT_GUEST_DETAILS")?>
				</div>


				<div id="bookit_final_fname_left" class="bookit_final_left">
					<div class="bookit_finalform_key">
						<?php echo JText::_("COM_BOOKIT_FIRST_NAME").$star;?>
					</div>
					<input type="text" name="fname" id="fname"
						class="bookit_final_input"
						value="<?php //gatewayplugin
echo $guest_name;?>" />
					<div id="bookit_final_fname_right_error" class="bookit_final_error"
						style="display: none;">
						<?php echo JText::_("COM_BOOKIT_PLEASE_ENTER_YOUR_FIRST_NAME");?>
					</div>
				</div>
				<!-- first name -->

				<div id="bookit_final_lname_left" class="bookit_final_right">
					<div class="bookit_finalform_key">
						<?php echo JText::_("COM_BOOKIT_LAST_NAME");
						if ($this->view->utils->surname_req==1)
							echo $star;?>
					</div>
					<input type="text" name="surname" id="surname"
						class="bookit_final_input" value="<?php echo $surname; ?>" />
					<div class="bookit_final_clear"></div>
					<div id="bookit_final_lname_right_error" class="bookit_final_error"
						style="display: none;">
						<?php echo JText::_("COM_BOOKIT_PLEASE_ENTER_YOUR_LAST_NAME");?>
					</div>
				</div>
				<!-- last name -->
				<div class="bookit_final_clear"></div>

				<div id="bookit_final_email_left" class="bookit_final_left">
					<div class="bookit_finalform_key">
						<?php echo JText::_("COM_BOOKIT_EMAIL_ADDRESS").$star;?>
					</div>
					<input type="text" name="bookit_email" id="bookit_email"
						class="bookit_final_input" value="<?php echo $email;?>" />
					<div id="bookit_final_email_right_error" class="bookit_final_error"
						style="display: none;">
						<?php echo JText::_("COM_BOOKIT_PLEASE_ENTER_YOUR_EMAIL_ADDRESS");?>
					</div>
					<div id="bookit_final_email_invalid_right_error"
						class="bookit_final_error" style="display: none;">
						<?php echo JText::_("COM_BOOKIT_PLEASE_ENTER_A_VALID_EMAIL_ADDRESS");?>
					</div>
				</div>
				<!-- email -->


				<div id="bookit_final_cemail_left" class="bookit_final_right">
					<div class="bookit_finalform_key">
						<?php echo JText::_("COM_BOOKIT_CONFIRM_EMAIL_ADDRESS").$star;?>
					</div>

					<input type="text" name="cemail" id="cemail"
						class="bookit_final_input" value="<?php echo $email;?>" />
					<div id="bookit_final_cemail_right_error"
						class="bookit_final_error" style="display: none;">
						<?php echo JText::_("COM_BOOKIT_PLEASE_CONFIRM_YOUR_EMAIL_ADDRESS");?>
					</div>
					<div id="bookit_final_cemail_invalid_right_error"
						class="bookit_final_error" style="display: none;">
						<?php echo JText::_("COM_BOOKIT_PLEASE_MAKE_SURE_THAT_THE_TWO_EMAIL_ADDRESSES_YOU_HAVE_ENTERED_ARE_IDENTICAL_AND_CORRECT");?>
					</div>
				</div>
				<!-- confirm email -->
				<div class="bookit_final_clear"></div>

				<?php if ($this->view->utils->show_address==1) {?>
				<div class="bookit_final_left">
					<div class="">
						<div class="bookit_finalform_key">
							<?php echo JText::_("COM_BOOKIT_STREET_ADDRESS");
							if ($this->view->utils->address_req==1) echo $star;
							?>
						</div>
						<input type="text" name="address1" id="address1"
							class="bookit_final_input" value="<?php echo $addr1;?>" />


						<div class="bookit_final_clear"></div>
					</div>

					<div class="">
						<div class="bookit_finalform_key">
							<?php echo JText::_("COM_BOOKIT_ADDRESS_LINE_2");?>
						</div>
						<input type="text" name="address2" id="address2"
							class="bookit_final_input" value="<?php echo $addr2;?>" />
						<div class="bookit_final_clear"></div>
					</div>


					<div class="">
						<?php if ($this->view->utils->show_address3==1) {?>
						<div class="bookit_finalform_key">
							<?php echo JText::_("COM_BOOKIT_ADDRESS_LINE_3");?>
						</div>
						<input type="text" name="address3" id="address3"
							class="bookit_final_input" value="<?php echo $addr3;?>" />
						<?php } ?>
						<div id="bookit_final_addr_right_error" class="bookit_final_error"
							style="display: none;">
							<?php echo JText::_("COM_BOOKIT_PLEASE_ENTER_YOUR_ADDRESS");?>
						</div>
						<div class="bookit_final_clear"></div>
					</div>

					<?php if ($this->view->utils->show_postcode==1) {?>
					<div class="">
						<div class="bookit_finalform_key">
							<?php echo JText::_("COM_BOOKIT_POST_CODE");
							if ($this->view->utils->postcode_req==1) echo $star;
							?>
						</div>
						<input type="text" name="postcode" id="postcode"
							class="bookit_final_input" value="<?php echo $postcode;?>" />
						<div class="bookit_final_clear"></div>
						<div id="bookit_final_postcode_right_error"
							class="bookit_final_error" style="display: none;">
							<?php echo JText::_("COM_BOOKIT_PLEASE_ENTER_YOUR_POSTCODE");?>
						</div>

						<div class="bookit_final_clear"></div>
					</div>
					<?php }?>



					<div class="">
						<div class="bookit_finalform_key">
							<span><?php echo JText::_("COM_BOOKIT_COUNTRY");
							if ($this->view->utils->address_req==1) echo $star;
							?> </span>
						</div>
						<?php echo $country_list;?>
						<div class="bookit_final_clear"></div>
						<div id="bookit_final_country_right_error"
							class="bookit_final_error" style="display: none;">
							<?php echo JText::_("COM_BOOKIT_PLEASE_SELECT_YOUR_COUNTRY");?>
						</div>
					</div>
				</div>
				<?php }?>

				<?php if ($this->view->utils->show_phone==1) {?>
				<div id="bookit_final_phone_right" class="bookit_final_right">
					<div class="bookit_finalform_key">
						<?php echo JText::_("COM_BOOKIT_PHONE");
						if ($this->view->utils->phone_req==1) echo $star;?>
					</div>
					<input type="text" name="phone" id="phone"
						class="bookit_final_input" value="<?php echo $phone;?>" />

					<div id="bookit_final_phone_right_error" class="bookit_final_error"
						style="display: none;">
						<?php echo JText::_("COM_BOOKIT_PLEASE_ENTER_YOUR_PHONE_NUMBER");?>
					</div>
					<div id="bookit_final_phone_invalid_right_error"
						class="bookit_final_error"
						style="display: none; margin-bottom: 10px">
						<?php echo JText::_("COM_BOOKIT_PLEASE_ENTER_A_VALID_PHONE_NUMBER");?>
					</div>
					<div class="bookit_final_clear"></div>
				</div>
				<?php }?>

				<div class="bookit_final_clear"></div>


				<!-- CAPTCHA -->
				<?php 
				if ($this->view->utils->show_captcha==1 &&
$this->view->utils->privatekey!="" && $this->view->utils->publickey!="" )
{
	?>
				<div class="bookit_final_clear"></div>
				<div id="bookit_final_form_captcha" class="bookit_box">
					<div class="block2 head bottom_line">
						<?php echo JText::_("COM_BOOKIT_HUMAN_VERIFICATION")?>
					</div>
					<div class="bookit_final_left">
						<?php 
						require_once(JPATH_COMPONENT.DS."libs".DS."recaptchalib.php");
						$publickey = ($this->view->utils->publickey);
						echo recaptcha_get_html($publickey);
						?>
					</div>

					<div class="bookit_final_clear"></div>
				</div>

				<?php 
}
?>
				<div class="bookit_final_clear"></div>
				<div id='payment_error' class='bookit_box error'
					style="display: none;"></div>
				<div class="bookit_final_clear"></div>
				<?php 
				if (isset($payment_plugins) && $payment_plugins!="")
				{
					?>
				<div class="bookit_final_clear"></div>
				<div id="bookit_final_form_payment" class="bookit_box">
					<div class="block2 head bottom_line">
						<?php echo JText::_("COM_BOOKIT_PAYMENT")?>
					</div>
					<div class="">
						<?php 
						echo $this->view->lists['payment'];
						?>
					</div>
					<div class="bookit_final_clear"></div>
					<div id="wire_transfer_div"></div>

					<div class="bookit_final_clear"></div>
				</div>

				<?php 
				}
				?>
				<div class="bookit_final_spacer"></div>


				<div id="bookit_ajax_loader" style="display: none;">
					<?php echo JText::_('COM_BOOKIT_WAIT_WHILE_YOU_ARE_BEING_REDIRECTED'); ?>
				</div>
				<div id="bookit_final_send_button" class=''>

					<button type="button" name="send_button" class="bookit_button"
						id="send_button">
						<?php echo JText::_("COM_BOOKIT_BOOK_NOW")?>
					</button>

				</div>
				<div id="bookit_warning" style="display: none;">
					<?php echo JText::_('COM_BOOKIT_SELECTED_ROOMS_ARE_NO_LONGER_AVAILABLE'); ?>
				</div>
			</div>
			<!-- finalform -->

			<div class="bookit_final_clear"></div>

			<input type="hidden" name="option" value="com_blooking" /> <input
				type="hidden" id="controller" name="controller" value="finalform" />
			<input type="hidden" id="task" name="task" value="bookingCompleted" />
			<input type="hidden" id="finalform_bookingids"
				name="finalform_bookingids" value="" /> <input type="hidden"
				name="itemid" value="<?php echo $this->menuid ?>" />
		</div>
		<!-- wrapper -->

</form>


<div id="bookit_payment_div"></div>
