<?php
/**
 * BlooKing - The King in Joomla Booking
 * @version 1.0
 * @author BlooKing.org. Based on BooKiTGold code by Costas Kakousis
 * @copyright (C) 2012-2013 by BlooKing.org (http://www.blooking.org)
 * @license GNU/GPL: http://www.gnu.org/copyleft/gpl.html
 *
 * If you fork this to create your own project, please make a reference to
 * BlooKing! someplace in your code and provide a link to
 * http://www.blooking.org
 *
 * This file is part of BlooKing! BlooKing is free software: you can
 * redistribute it and/or modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * BlooKing is distributed in the hope that it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details. You should have received a copy of the GNU General Public License
 * along with BlooKing.  If not, see <http://www.gnu.org/licenses/>.
 *   ______ __                __  __ __
 *	|   __ \  |.-----..-----.|  |/  |__|.-----..-----.
 *	|   __ <  ||  _  ||  _  ||     <|  ||     ||  _  |
 *	|______/__||_____||_____||__|\__|__||__|__||___  |
 *                                             |_____|
 **/
defined('_JEXEC') or die('Restricted access');
JHTML::_( 'behavior.mootools' );

//---------------------SET VARIABLES START--------------------------------------
$guest_name= $this->booking_details['name'];
$surname= $this->booking_details['surname'];
$email= $this->booking_details['email'];
$phone= $this->booking_details['phone'];
$addr1= $this->booking_details['address1'];
$addr2= $this->booking_details['address2'];
$addr3= $this->booking_details['address3'];
$postcode= $this->booking_details['postcode'];
$countryid = $this->booking_details['idcountry'];
$bookingid = $this->booking_details['refid'];

$mail_request= $this->view->mail_request;
$paypal_mail= $this->view->paypal_mail;
$deposit= $this->booking_details['value_deposit'];
$currency= $this->view->currency;
$payment_plugins = $this->view->payment_plugins;

$payment_error_msg = JText::_('COM_BOOKIT_YOUR_BOOKING_CANNOT_BE_PROCESSED_DUE_TO_A_PAYMENT_FAILURE');
$no_gateway_selected = JText::_('COM_BOOKIT_PLEASE_SELECT_A_PAYMENT_OPTION');

$bandk_err  = JText::_('COM_BOOKIT_PLEASE_SELECT_BANK');
$params = BlookingHelper::getParams();
$db = JFactory::getDbo();
$query =  "SELECT * FROM ".
    $db->nameQuote("#__bookitbooking")." WHERE ".
    $db->nameQuote("idbook")." = ".$db->quote($this->booking_details['refid']);
$db->setQuery( $query );
$bo = $db->loadObject();
if ($params->deposit_percent > 0) {
    $deposit = number_format(($bo->value_full / 100)*$params->deposit_percent,2, '.','');
} else {
    $deposit = number_format($params->deposit_fixed,2, '.','');
}

//---------------------SET VARIABLES END----------------------------------------


$ajax = <<<EOD
window.addEvent('domready',function() {

var Browser = {
  Version: function() {
    var rv = 999;
    if (navigator.appName == 'Microsoft Internet Explorer')
   {
      var ua = navigator.userAgent;
      var re  = new RegExp("MSIE ([0-9]{1,}[\.0-9]{0,})");
      if (re.exec(ua) != null)
         rv = parseFloat( RegExp.$1 );
   }
   return rv;
  }
}


if (Browser.Version() <= 7) {
JSON.decode = function(string, secure){
  	  return jsonParse(string);
	};
}

	var req = new Request.JSON({
		method: 'post',
		url: 'index.php',
		data: {},
		onRequest: function() {
			document.id('payment_error').set('html','');
			document.id('payment_error').style.display='none';
		},
		onFailure: function(xhr) {;},

		onSuccess: function(r) {

			if (typeof(r)!=undefined && r!=null)
			{
				if (r.booking_res_code=='-1')
				{
					//no room availables anymore!
					document.id('bookit_warning').style.display='';
					document.id('send_button').disabled=true;
				}
				else
				{
					var gateway = getGateway();
			
					if (gateway=='Blookingpaypal')
					{
						document.id('bookingids').value = r.booking_res_code;
						document.id('paypalForm').submit();
						document.id('bookit_ajax_loader').style.display='';

					}
					else if (gateway=='Blookingasiapay')
					{
						document.id('bookingids').value = r.booking_res_code;
						document.id('payFormCcard').submit();
						document.id('bookit_ajax_loader').style.display='';
					}
					else if (gateway=='Blookingcimb')
					{
			
						//document.id('bookingids').value = r.booking_res_code;
						document.id('bookingids').value = r.booking_res_code;
						document.id('cimbForm').submit();
						document.id('bookit_ajax_loader').style.display='';
					}
					else if (gateway=='Blookingrobokassa')
					{
						document.id('robokassaForm').submit();
						document.id('bookit_ajax_loader').style.display='';
					}
					else if (gateway=='Blookingegipsy')
					{
						document.id('payEGipsy').submit();
						document.id('bookit_ajax_loader').style.display='';
					}
					else if (gateway=='Blookingideal')
					{
						var bankObj = document.id('bank_id');
						var bankVal = bankObj.options[bankObj.selectedIndex].value;

						if (bankVal==''){
							alert('{$bandk_err}');
							return;
						}
						gatewayRedirectReq.post({'option':'com_blooking',
						'controller':'finalform', 'task':'gatewayRedirect',
						'format':'json', 'view':'finalform',
						'price':'{$this->booking_details['value_full']}','tmpl':'component',
						'amount':'{$deposit}',
						'lang':'{$this->booking_details['lang']}',
						'currency':'{$currency}',
						'bank_id':bankVal,
						'type':'Blookingideal'});

					}
					else if (gateway=='Blookingsisow')
					{
						document.id('paySisow').submit();
						document.id('bookit_ajax_loader').style.display='';
					}
					else if (gateway=='paypal_error' || gateway=='asiapay_error'
					|| gateway=='cimb_error' || gateway=='gatewayError')
					{
						document.id('payment_error').set('html',"{$payment_error_msg}");
						document.id('payment_error').style.display='';
						return;
					}
					else
					{
						document.id('finalform_bookingids').value = r.booking_res_code;
						document.id('finalForm').submit();
						document.id('bookit_ajax_loader').style.display='';

					}
				}
			}
		},
		onError: function(response) {
			alert('error');
		}
	});

	document.id('send_button').addEvent('click',function(e) {
		e.stop();
		var payment_method = checkGateways();
		if (payment_method == false)
		{
			document.id('payment_error').set('html',"{$no_gateway_selected}");
			document.id('payment_error').style.display='';
			return;
		}

			req.post({'option':'com_blooking', 'controller':'payment',
				'task':'adminConfirmBookings', 'format':'json', 'view':'payment',
				'payment_method':payment_method,
				'id':'{$bookingid}'});

	});

	var gatewayReq = new Request.JSON({
		method: 'post',
		url: 'index.php',
		data: {},
		onRequest: function() {
		document.id('bookit_payment_div').set('html','');
		if (document.id('bookit_warning').style.display=='none')
		document.id('send_button').disabled=false;
		},
		onFailure: function(xhr) {;},

		onSuccess: function(r) {
			if (typeof(r)!=undefined && r!=null)
			{
				if (r.type=='Blookingwire' || r.type=='Blookingideal' || r.type=='Blookingsisow')
				document.id('wire_transfer_div').set('html', r.msg);
				else
				{
					document.id('bookit_payment_div').set('html',r.msg);
					document.id('wire_transfer_div').set('html', '');
				}
				if (r.code <= 0)
					document.id('send_button').disabled=true;

			}
		},
		onError: function(response) {
			alert('error');
		}
	});

	if (typeof(document.getElementsByName("bookit_payment")[0])!='undefined')
	{
		var payment_options = document.getElementsByName("bookit_payment");
		for (var i=0; i<payment_options.length; i++)
		{

			el = document.id(payment_options[i].id);
			//el.addEvent('change',function(e) { //IE8 FIX
			el.addEvent('click',function(e) {
			gatewayReq.post({'option':'com_blooking', 'controller':'payment',
				'task':'getPaymentPluginCode', 'format':'json', 'view':'payment',
				'id':'{$bookingid}', 'currency':'{$currency}',
				'type':this.value});
			});
		}
	}

	var gatewayRedirectReq = new Request.JSON({
		method: 'post',
		url: 'index.php',
		data: {},
		onRequest: function() {
		document.id('bookit_ajax_loader').style.display='';
		},
		onFailure: function(xhr) {;},

		onSuccess: function(r) {
			document.id('bookit_ajax_loader').style.display='none';
			if (r[0].msg=='OK')
			location.href =r[0].url;
		},
		onError: function(response) {
			alert('error');
		}
	});

});
EOD;
$doc = & JFactory::getDocument();
$doc->addScriptDeclaration( $ajax );
?>
<div id="final_form_div_wrapper"
	class="blooking_panel2 inner_description_gradient">

	<div id="final_form_overview" class="">
		<div id="bookit_booking_details" class='bottom_line'>
			<div class='block2 head bottom_line'>
				<?php echo JText::_( 'COM_BOOKIT_HELLO_AGAIN' ); ?>
				,
				<?php echo $this->booking_details['name']?>
			</div>

			<div class="bookit_booking_wrapper">
				<div class="bookit_booking_left_td">
					<?php echo JText::_( 'COM_BOOKIT_CHECK_IN' ); ?>
				</div>
				<div class="bookit_booking_right_td">
					<span> <?php echo $this->booking_details['valid_from'];?>
					</span>
				</div>
			</div>

			<div class="bookit_booking_wrapper bottom_line">
				<div class="bookit_booking_left_td">
					<?php echo JText::_( 'COM_BOOKIT_CHECK_OUT' ); ?>
				</div>
				<div class="bookit_booking_right_td">
					<span> <?php echo $this->booking_details['valid_to'];?>
					</span>
				</div>
			</div>

			<div class="bookit_booking_wrapper bottom_line">
				<div class="bookit_booking_left_td">
					<?php echo JText::_( 'COM_BOOKIT_NIGHTS' ); ?>
				</div>
				<div class="bookit_booking_right_td">
					<span> <?php echo $this->booking_details['nights'];?>
					</span>
				</div>
			</div>

			<!-- echo the rooms -->
			<?php 
			$cnt = 1;
			$end = count($this->booking_details['cat_qnt']);
			foreach ($this->booking_details['cat_qnt'] as $categ=>$no) {

if ($cnt++>=$end) {?>
			<div class="bookit_booking_wrapper bottom_line">
				<?php } else {?>
				<div class="bookit_booking_wrapper">
					<?php }?>
					<div class="bookit_booking_left_td">
						<?php echo $categ;?>
					</div>
					<div class="bookit_booking_right_td">
						<span> <?php echo $no; ?>
						</span>
					</div>
				</div>
				<?php } ?>

				<div class="bookit_booking_wrapper">
					<div class="bookit_booking_left_td">
						<?php echo JText::_("COM_BOOKIT_TOTAL_ROOMS");?>
					</div>
					<div class="bookit_booking_right_td">
						<span><?php echo count($this->booking_details['rooms']);?> </span>
					</div>
				</div>


				<?php if ($this->booking_details['tguests']>0){?>
				<div class="bookit_booking_wrapper">
					<div class="bookit_booking_left_td">
						<?php echo JText::_("COM_BOOKIT_ADULTS");?>
					</div>
					<div class="bookit_booking_right_td">
						<span><?php echo $this->booking_details['tadults']?> </span>
					</div>
				</div>

				<?php }?>
				<?php if ($this->booking_details['tchilds']>0){?>
				<div class="bookit_booking_wrapper">
					<div class="bookit_booking_left_td">
						<?php echo JText::_("COM_BOOKIT_CHILDREN");?>
					</div>
					<div class="bookit_booking_right_td">
						<span> <?php echo $this->booking_details['tchilds'];?>
						</span>
					</div>
				</div>

				<?php }?>

				<!-- PRICE -->

				<div class="bookit_booking_wrapper">
					<div class="bookit_booking_left_td">
						<?php echo JText::_("COM_BOOKIT_TOTAL_PRICE");?>
					</div>
					<div class="bookit_booking_right_td">
						<span> <?php echo $this->booking_details['fullprice']." ".$currency;?>
						</span>
					</div>
				</div>

				<?php 
				if ($deposit>0) {
?>
				<div class="bookit_booking_wrapper">
					<div class="bookit_booking_left_td">
						<?php echo JText::_("COM_BOOKIT_DEPOSIT");?>
					</div>
					<div class="bookit_booking_right_td">
						<span> <?php echo $deposit." ".$currency;?>
						</span>
					</div>
				</div>
				<?php }?>

			</div>
			<!-- booking_details -->
		</div>

		<div id="bookit_final_form" class="">
			<div class="block2 head">
				<?php echo JText::_("COM_BOOKIT_PAYMENT_MSG")?>
				<br /> <br />
				<?php echo JText::_("COM_BOOKIT_THANK_YOU")?>
			</div>

			<div class="bookit_final_clear"></div>

			<div id='payment_error' class='bookit_box error'
				style="display: none;"></div>
			<div class="bookit_final_clear"></div>
			<?php 
			if (isset($payment_plugins) && $payment_plugins!="")
			{
				?>
			<div class="bookit_final_clear"></div>
			<div id="bookit_final_form_payment" class="bookit_box info">
				<div class="bookit_box_heading">
					<?php echo JText::_("COM_BOOKIT_PAYMENT")?>
				</div>
				<div class="">
					<?php 
					echo $this->view->lists['payment'];
					?>
				</div>
				<div class="bookit_final_clear"></div>
				<div id="wire_transfer_div"></div>

				<div class="bookit_final_clear"></div>
			</div>

			<?php 
			}
			?>
			<div class="bookit_final_spacer"></div>


			<div id="bookit_ajax_loader" style="display: none;">
				<?php echo JText::_('COM_BOOKIT_WAIT_WHILE_YOU_ARE_BEING_REDIRECTED'); ?>
			</div>
			<div id="bookit_final_send_button" class='bookit_button'>

				<button type="button" name="send_button" id="send_button">
					<?php echo JText::_("COM_BOOKIT_BOOK_NOW")?>
				</button>

			</div>
			<div id="bookit_warning" style="display: none;">
				<?php echo JText::_('COM_BOOKIT_SELECTED_ROOMS_ARE_NO_LONGER_AVAILABLE'); ?>
			</div>
			<div class="bookit_final_clear"></div>

			<form action="<?php echo JRoute::_('index.php');?>" name="finalForm"
				id="finalForm" method="get">

				<input type="hidden" name="option" value="com_blooking" /> <input
					type="hidden" id="controller" name="controller" value="finalform" />
				<input type="hidden" id="task" name="task" value="bookingCompleted" />
				<input type="hidden" id="finalform_bookingids"
					name="finalform_bookingids" value="<?php echo $bookingid; ?>" /> <input
					type="hidden" name="itemid" value="<?php echo $this->menuid ?>" />
			</form>

			<div id="bookit_payment_div"></div>