<?php
/**
 * BlooKing - The King in Joomla Booking
 * @version 1.0
 * @author BlooKing.org. Based on BooKiTGold code by Costas Kakousis
 * @copyright (C) 2012-2013 by BlooKing.org (http://www.blooking.org)
 * @license GNU/GPL: http://www.gnu.org/copyleft/gpl.html
 *
 * If you fork this to create your own project, please make a reference to
 * BlooKing! someplace in your code and provide a link to
 * http://www.blooking.org
 *
 * This file is part of BlooKing! BlooKing is free software: you can
 * redistribute it and/or modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * BlooKing is distributed in the hope that it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details. You should have received a copy of the GNU General Public License
 * along with BlooKing.  If not, see <http://www.gnu.org/licenses/>.
 *   ______ __                __  __ __
 *	|   __ \  |.-----..-----.|  |/  |__|.-----..-----.
 *	|   __ <  ||  _  ||  _  ||     <|  ||     ||  _  |
 *	|______/__||_____||_____||__|\__|__||__|__||___  |
 *                                             |_____|
 **/

defined( '_JEXEC' ) or die( 'Restricted access' );
jimport( 'joomla.application.component.view');

class BlookingViewPayment extends JView
{
	function display($tpl = null)
	{
		JLoader::register('BlookingHelper',
		JPATH_COMPONENT_ADMINISTRATOR.'/helpers/BlookingHelper.php');
		$params =  BlookingHelper::getParams();
		$model =& $this->getModel('finalform');

		$view = new stdClass;
		$view->payment_plugins= JRequest::getVar('payment_plugins');

		$data = JRequest::get( 'get' );
		$lists = array();

		$stylesheet = 'final_form.css';
		$path = 'components/com_blooking/css/thereef/';

		JHTML::stylesheet($stylesheet, $path);
		$document = &JFactory::getDocument();
		JHTML::stylesheet($stylesheet, $path);
		$document = &JFactory::getDocument();
		$document->addScript( JURI::root(true).
				'/components/com_blooking/js/finalform.js' );

		$document->addScript( JURI::root(true).
				'/components/com_blooking/js/json2.js' );

		$document->addScript( JURI::root(true).
				'/components/com_blooking/js/json-minified.js' );

		$id = base64_decode($data['idbook']);
		$booking_details = $model->getBookingDetails($id);

		if ($params->multiroom != "0") { //Multiroom
			$refid[] = $id;
			$ids = explode(",",$booking_details['coids']);
				
			foreach ($ids as $id) {
				if ($id != "") {
					$refid[] = $id;// + 1000;
				}
			}
				
			sort($refid);
			$refid = implode(", ", $refid);
			$booking_details['refid'] = $refid;
		} else { //Single Room
			$booking_details['refid'] = $id;
		}
		$value_full = "";

		foreach ($booking_details['rooms'] as $room => $v) {
			$category_name = $model->getCategoryName($v['idcategory']);
			$booking_details['rooms'][$room]['category_name'] = $category_name;
			$value_full += $v['value_full'];
		}

		$booking_details['value_full'] = $value_full;

		$options = array();
		$plugins = explode(",",$view->payment_plugins);

		foreach ($plugins as $plg)
		{
			if ($plg=='blookingwire')
				array_push($options, JHTML::_('select.option',
					 'Blookingwire', JText::_('COM_BOOKIT_WIRE')));
			else if ($plg=='blookingpaypal')
			{
				array_push($options, JHTML::_('select.option',
				'Blookingpaypal', "<!-- PayPal Logo -->
						<img  src='".JURI::root()."components/com_blooking/images/paypal.gif'
								border='0' alt='Paypal'>"));
			}
			else if ($plg=='blookingasiapay')
			{
				array_push($options, JHTML::_('select.option',
				'Blookingasiapay',
				"<img src='".JURI::root()."components/com_blooking/images/asiapay.png'
						border='0' alt='AsiaPay'>"));
			}
			else if ($plg=='blookingcimb')
			{
				array_push($options, JHTML::_('select.option',
				'Blookingcimb',
				"<img src='".JURI::root()."components/com_blooking/images/cimb.png'
						border='0' alt='CIMB'> CIMB"));
			}
			else if ($plg=='blookingegipsy')
			{
				array_push($options, JHTML::_('select.option',
				'Blookingegipsy',
				"<img src='".JURI::root()."components/com_blooking/images/cc.gif'
						border='0' alt='E-Gipsy'>"));
			}
			else if ($plg=='blookingideal')
			{
				array_push($options, JHTML::_('select.option',
				'Blookingideal',
				"<img src='".JURI::root()."components/com_blooking/images/ideal.png'
						border='0' alt='iDeal'>"));
			}
			else if ($plg=='blookingsisow')
			{
				array_push($options, JHTML::_('select.option',
				'Blookingsisow',
				"<img src='".JURI::root()."components/com_blooking/images/ideal.png'
						border='0' alt='iDeal'>"));
			}
			else if ($plg=='blookingrobokassa')
			{
				array_push($options, JHTML::_('select.option',
				'Blookingrobokassa',
				"<img src='".JURI::root()."components/com_blooking/images/robokassa.jpg'
						border='0' alt='robokassa'>"));
			}
			else if ($plg=='blookingcash')
				array_push($options, JHTML::_('select.option',
						'Blookingcash', JText::_('COM_BOOKIT_CASH')));
				
		}
		$lists['payment'] = JHTML::_('select.radiolist', $options,
				'bookit_payment', 'class="inputbox"', 'value', 'text', '');

		$view->lists = $lists;
		$view->lang = $this->_getLang();

		$view->currency = $params->currency;
		$view->show_bar = $params->show_bar;
		$view->admin_confirm = $params->admin_confirm;
		$view->paypal_mail = '';
		$view->payment_return = '';
		$view->payment_cancel = '';
		$view->mail_request = '';

		$item = JRequest::getVar('Itemid');
		$this->assignRef('menuid', $item);
		$this->assignRef( 'view', $view );
		$this->assignRef( 'booking_details', $booking_details );
		parent::display($tpl);
	}

	function _getLang()
	{
		$lg = JFactory::getLanguage();
		if(version_compare(JVERSION,'1.6.0','ge'))
		{
			$lang_code = explode('-',$lg->getTag());
			$lang = $lang_code[0];
		}
		else
		{
			$lang_code = explode('-',$lg->_lang);
			$lang = $lang_code[0];
		}
		return $lang;
	}
}